// file: tc_classes.h

#ifndef tc_classes_h
#define tc_classes_h

#include "nios.h"

class Hardware
{
public:	
	static void Init(void);	
    										// Init the WatchDog
	static void Reset_the_Watchdog(void);							// Resets the WatchDog
//	static void Restart_Record(void);							    // Restart Recording
	static void Start_Record(void);                                 // Restart Recording	
	static void Stop_Record(void);				                    // Stop Recording	
	static void Read_Version(void);                                 // Read out the hardware version
	static void Setup_Vars(void);									// Setup Variables with standart Values
	static void Setup_Hardware(void);								// Setup the Hardware
	static void Setup_Interrupts(void);                             // Setup the Interrupts
	static void Set_Vars_Default(void);                             // Set Vars to default values
	static char SearchZero(char channel, char level, int *DAC_Offset, int *ZeroSign);
    static char SearchZeros(void);                                // Search Signals for correct difference
//	static void GenerateFLASH(void);								// Generate FLASH content
	
	static void DoEnableKeyInterrupt(void);							// Declare Enable PIO ISR
	static void DoDisableKeyInterrupt(void);						// Declare Disable PIO ISR
	static void ISR_KEY(int context);								// Declare Button Interrupt subroutine
	static void Buttonhandler(int MenuKey, char Pushedlong);		// Button Handler

	static char MenuButtonCheck(char BtnNr);						// Check the Menu Buttons (pushed) returns 1 if found one
	static void MenuPopupStep(int MenuPopupNr, short *MenuStatusNr, short *MenuStatusNr2, short *MenuStatusNr3, int DrawMenuNr, int start, char dir); //Updates Menupopup
	static void UpdateChannel(int channel, char active);			// Update all channel depended vars
	static void UpdateTrigger(char nr);								// Update the trigger modus
	
	static void Set_LED(int LED);									// Set LED On
	static void Reset_LED(int LED);									// Set LED Off
	static void Clear_LED(void);									// Clear all LEDs
	static void Send_LED(void);										// Send Shift Value for LEDs to Keyboard

	static void DoEnableRotInterrupt(void);							// Declare Enable PIO ISR
	static void DoDisableRotInterrupt(void);						// Declare Disable PIO ISR
	static void ISR_ROT(int context);								// Declare Button Interrupt subroutine
	static void Rotary_Interface(void);                             // Handle the Rotary Interupt
	static void ON_Rotary_Position(void);                           // Handle the Position Wheel
	static void ON_Trigger_Level(void);                             // Handle Trigger Level
	static void ON_Main_Wheel(void);                                // Handle
	static void ON_Timebase(void);                                  // Handle
	static void Recalc_Vars(void);                                  // Recalc ZFT...
	static void Recalc_Trigger(void);                               // Recalc pre_reg and Trigger Pos on Display
   	static void ON_Voltage_Channel_1(void);                         // Handle	
	static void ON_Zero_Channel_1(void);                            // Handle
	static void ON_Voltage_Channel_2(void);                         // Handle
	static void ON_Zero_Channel_2(void);                            // Handle
	static void ON_Voltage_Channel_3(void);                         // Handle
	static void ON_Zero_Channel_3(void);                            // Handle
	static void ON_Voltage_Channel_4(void);                         // Handle
	static void ON_Zero_Channel_4(void);                            // Handle
	static void Voltage_Zoom(unsigned char *OrgData, unsigned char *ZoomData, int NewVoltage, int OldVoltage, int ZeroLevel);

	static void Keyboard_Interface(void);                           // Handle the Keyboard Interupt
                    	
	static void HandleMainWheel(char Direction);			        // Main Wheel Handler
	static void DoEnableRotReadyInterrupt(void);					// Declare Enable PIO ISR
	static void DoDisableRotReadyInterrupt(void);					// Declare Disable PIO ISR
	static void ISR_ROTREADY(int context);							// Declare Button Interrupt subroutine

	static void DoEnableUARTInterrupt(void);						// Declare Enable UART2 ISR
	static void DoDisableUARTInterrupt(void);						// Declare Disable UART2 ISR
	static void ISR_UART(int context);								// Declare UART2 Interrupt subroutine
	
//**** Noch zu verbessern
	static void DoEnableUART2Interrupt(void);						// Declare Enable UART2 ISR
	static void DoDisableUART2Interrupt(void);						// Declare Disable UART2 ISR
	static void ISR_UART2(int context);								// Declare UART2 Interrupt subroutine
	static void InterpretUART(volatile unsigned char data[37]);		// Interpret the UART receiving
	static void SendData(volatile unsigned char Bytes[40]);			// Sends 37 Bytes to UART2	
	static void SendShot(void);					                    // Sends Screen Shot to PC	
	static void SendSWShot(void);					                    // Sends Screen Shot to PC		
	static void SendLayer(unsigned char LayerNr);					// Send a Layer through USB
	static void SendCtrlBlock(void);                                // Send the ctrl block through USB
	static void SendCtrlBlock2(void);                                // Send the ctrl block 2 through USB	
	static void SendCtrlBlock3(void);                                // Send the ctrl block 3 through USB		
//****
	static void DoEnableTimerInterrupt(void);						// Enable service routine
	static void DoDisableTimerInterrupt(void);						// Disable service routine
	static void Start_Timer1(void);						            // Start Timer1
	static void Stop_Timer1(void);						            // Stop Timer1
	static void ISR_TIMER(int context);								// Timer1 ISR for menu popups
	static void ResetTimer(void);									// Reset Timer

	static void DoEnableTimer2Interrupt(void);						// Enable service routine Timer2
	static void DoDisableTimer2Interrupt(void);						// Disable service routine Timer2
	static void ISR_TIMER2(int context);							// Timer2 ISR for menu popups
    static void Copy_in_asm(int cnt, unsigned char *DataArray_in, unsigned char *DataArray_out); // Copy the Roll Mode array 1 position
	static void DoEnableTimer3Interrupt(void);						// Enable service routine Timer3
	static void DoDisableTimer3Interrupt(void);						// Disable service routine Timer3
	static void ISR_TIMER3(int context);							// Timer3 ISR for menu popups

	static void SetSwitches(char channel, int voltage);				// Send Switches to ADCs
//**** Noch zu verbessern
	static void SetDacOffset(char channel);							// Set the DAC Offset of a Channel
	static void SetCHDacOffset(char channel);							// Set the DAC Offset of a Channel	
	static void SetupADC(void);										// Send Config Data to the ADCs
//****	
	static void WRITEADC(unsigned char which, unsigned long value);	// Write Value to ADC (which)
	static unsigned long READADC(unsigned char which);				// Read Value from ADC (which)
	
	static void PREPARE_READADC(unsigned char correct1, unsigned char correct2, unsigned char correct3, unsigned char correct4, unsigned int count); //Prepare registers for read_all
	static void READADC_ALL(unsigned char which, unsigned char *DataArray1, unsigned char inverse, unsigned int zero, unsigned char averageval, unsigned char highspeed);
	static void READADC_ALL2(unsigned char which, unsigned long *DataArray1, unsigned int count);
	//static void READADC3_Average(unsigned char which, unsigned char *DataArray1, int AverageMax);
	static unsigned char EXTRACTADCVAL(unsigned char which, unsigned long value); 

	static void DoEnableADCInterrupt(void);							// Declare Enable ADC ISR
	static void DoDisableADCInterrupt(void);						// Declare Disable ADC ISR
	static void ISR_ADC_INT(int context);							// Declare ADC Interrupt subroutine
	static int Read_IRQ(void);                                      // red the status of the irq
	static void Handle_ADC(void);							        // Declare ADC Interrupt subroutine	
	static void ReadOut_Signal(char channel, unsigned long adr_read, unsigned long adr_written);
	static void Do_FFT(void);
	static void Do_Gen_Signal(void);	
	static void Do_Gen_Signal2(void);	

    static int FindTrigger(unsigned char channel, unsigned char negativ, int TriggerPos);      // Search the Trigger
	static int AutoScale(void);                                       // Make Autoscale
	static int FindTimebase(char channel);                                       // Make Autoscale
	static int FindVoltage(char channel);                                       // Make Autoscale
	static void FindSlope(void);                                       // Make Autoscale	
	
	static void DoEnableReadVSyncInterrupt(void);					// Declare Enable ReadVSync ISR
	static void DoDisableReadVSyncInterrupt(void);					// Declare Disable ReadVSync ISR
	static void ISR_ReadVSync_INT(int context);						// Declare ReadVSync Interrupt subroutine

    static void TransferPlanes(void);                               // Transfer Backbuffer to Planes
    static void ClearPlanes(void);                               // Clears and Transfer Backbuffer to Planes
    static void TransferDataPlane_asm_persistant(unsigned long Buffer_Adr1, unsigned long Plane_Adr1);
    static void TransferPlane_Set_Buffer_Adr(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2);
    static void TransferPlanes_asm(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count);
    static void TransferPlanes_asm_persistant(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count);
    static void TransferPlanes_clear_asm(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count);
    static void Planes_clear_asm(unsigned long Buffer_Adr1);
	static void Planes_clear_asm_all(unsigned char count, unsigned long Buffer_Adr1, unsigned long Buffer_Adr2, unsigned long Buffer_Adr3, unsigned long Buffer_Adr4, unsigned long Buffer_Adr5);
    static void DoEnableLogicAnalyserInterrupt(void);	            // Declare Enable LogicAnalyser ISR
	static void DoDisableLogicAnalyserInterrupt(void);	            // Declare Disable LogicAnalyser ISR
	static void ISR_LogicAnalyser(int context);	                    // Declare LogicAnalyser Interrupt subroutine
	static int TestFir(void);
	
};


class Display
{
public:	
	static void Init(void);
    static void DRAW_SPLASH(unsigned char remove);								// Draws the splash screen - If remove then it will be removed
    static void REMOVE_SPLASH(void);								// remove the splash screen
	static void DrawStartScreen(void);											// Draws the first screen
	
	static void DRAWP(int x, int y, int dx, int dy, char set, unsigned long *planeaddress);
	static void PIXELP(int x, int y, char set, unsigned long *planeaddress);
	static void DRAWLINEP(int x1, int y1, int x2, int y2, char set, unsigned long *plane);
	static void DRAWZEROLINE(int y, char set, unsigned long *plane);	
	static void TEXTOUTvbig(char *String, int x, int y, char set, unsigned long *layer);		// Draw Text at Pos X / Y with Color and BackColor (FF = Transparent)
	static void TEXTOUTxvbig(char *String, int x, int y, char set, unsigned long *layer);		// Draw Text at Pos X / Y with Color and BackColor (FF = Transparent)
	static void BITBITMAP(unsigned char *pointer, int x, int y, unsigned char set, unsigned long *layer);	// Draw two color bitmap

	static void GRID(unsigned long x, unsigned long y, unsigned long *layer); 	// Draw Grid subroutine
	static void GRIDDELAYED(unsigned long x, unsigned long y, unsigned long *layer); 	// Draw Grid subroutine
	static void GRIDXY(unsigned long x, unsigned long y, unsigned long *layer); 	// Draw Grid subroutine
	
	static void StatusUpdate(void);												// Updates the Status and the Popups
	static void DRAWSTATUS(int Which, int isChanging);							// Draw Status of Channels & Timebase 0 = TB , 1 - 4 = Channels , 5 = Clock
	static void RemoveStatusBtn(void);											// Remove Status Button
	
	static void UpdateMenu(void);
	static void ClearMenuAsm(long start, long count);                                          // Clear Menu Area
	static void ClearMenuItemAsm(long which, long start, long count);                                          // Clear Menu Area	
	static void ClearMenuItemTextAsm(long which, long start, long count);                                          // Clear Menu Area		
	static void DrawMenuItemButton(int ItemNr, unsigned char active, unsigned char pushed);
    static void DrawMenuItem(int MenuNr,int ItemNr, unsigned char active, unsigned char pushed);	// Draw Menu Items
	static void ClearMenuItem(int ItemNr);										// Clear a Menuitem
	
	static void DRAWMENUPOPUP(int PopupNr);										// Popup the Menu Popup
	static void DRAWMENUPOPDOWN(void);											// Popdown the Menu Popup
	static void DRAWMENUBUTTONSELECT(int buttonnr);								// Draws Button Selector over menu	
	
	static void DRAWROUNDBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove);	// Draw a Round Button	
	static void DRAWSQUAREBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove);	// Draw a Square Button
		
	static void DrawMenuCheckBox(int posx, int posy, char checked, char active);// Draw Checkbox in Menu
	static void DrawMenuArrow(int posx, int updn, int active);					// Draw Big Arrow
	static void DrawMenuArrowCycle(int posx, int active);						// Draw Arrow Cycle
	static void DrawMenuArrowCycle2(int posx, int active);						// Draw Arrow Cycle
	static void DrawMenuBiggerArrowCycle(int posx, int active);					// Draw the knob turn cycle
	static void DrawSubMenuArrow(int posx, int active);							// Draw the sub menu arrow

    static void DRAW_ALL_CURSOR(void);											// Draw the all Cursos at once
    static void DRAWMEMORY(char remove, char firstdraw, char redraw);
    
	static void DRAWCURSORDATA(char dir);							            // Draw Cursor Data
	static void DRAWQMDATA(char dir);											// Draw Quick Measurment Data

	static void CALCCURSORDATA(void);											// Calculate Cursor Data
	static void CALCQMDATA(void);										        // Calculate Quick Measurment Data	
	static float Measure(char nr, char channel, char type, char *pretext, char *unittext, char *returntext, char *qm_vertical_active, char *qm_horizontal_active);// make a measurement
    static float MEASUREVOLTAGE(char channel, int points);	// Calculate the Voltage String
    static float MEASURETIME(char sec_hz, int points);	    // Calculate the Time String sec_hz 1 = seconds, sec_hz = 2 = Hz
    //static float MEASUREVOLTAGE(char channel, int points, char *UnitString);	// Calculate the Voltage String
    //static float MEASURETIME(char sec_hz, int points, char *UnitString);	    // Calculate the Time String sec_hz 1 = seconds, sec_hz = 2 = Hz

	static void CALCTRIGGER(void);												// Calculate Trigger Data
	static void CALCPRETRIGGER(void);												// Calclulate Timebase Data
	static void CALCTIMEBASE(void);												// Calclulate Timebase Data
	static void CALCVOLTAGE(char channel, char *String);						// Calculate the Voltage String
	
//	static void DRAWZERO(int inr, char changed);								// Draw one ZeroLine , would be removed if chaSnged
	static void DRAWSIGNS(void);
    	
	static void RemoveZeroSign(long addressold);
	static void DrawZeroSign(unsigned char *sign, long addressnew);
	static void DrawZeroSignXY(int position, char set);
	static void OverDrawZeroSign(unsigned char *sign, long addressnew);
	static void RemoveZeroSignBack(long addressold);
	static void DrawZeroSignBack(unsigned char *sign, long addressnew);

    static void CLEAR2BYTE(long addressold);            	
    static void WRITE2BYTE(unsigned char byte1, unsigned char byte2, long addressnew);
    static void OVERWRITE2BYTE(unsigned char byte1, unsigned char byte2, long addressnew);
    
    static void WRITE2BYTEBACK(unsigned char byte1, unsigned char byte2, long addressnew);
    static void CLEAR2BYTEBACK(long addressold);
      	
	static void DRAWZEROPOPUP(int channel);										// Draws a popup with the Zerolevel
	static void DRAWZEROPOPDOWN(void);											// Popdown the Zerolevel Popup
	
    static void PreInterpolate(int timebase, int fir_start, unsigned char *InterpolateBuff, unsigned char *SignalData, unsigned char *InterpolateResult);	
	static void Interpolate(unsigned char *RawData, int start, int stop, unsigned char *DisplayData);		// Interpolate with FIRCoef
	//static void Interpolate(char *RawData, int start, int stop, char *DisplayData, short *FirCoef);		// Interpolate with FIRCoef
	
	static void DRAWSIGNALS(unsigned char on);
	static void Clear_Flips(void);
//	static void CopySignal(unsigned long *Buffer_Adr1, unsigned long *Plane_Adr1, unsigned long *Buffer_Adr2, unsigned long *Plane_Adr2, unsigned long *Buffer_Adr3, unsigned long *Plane_Adr3, unsigned char count);
	static void CopySignal(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count);
	static void DRAWSIG(unsigned int inr, unsigned char windows, short offset, unsigned char *DisplayData, unsigned char on);	// Draw Signal
	static void DRAWSIG2(unsigned int inr, unsigned char windows, short factor, short offset, unsigned char *DisplayData, unsigned char on);	// Draw Signal
	static void DRAWSIG_vector(unsigned int inr, unsigned char windows, short offset, unsigned char *DisplayData, unsigned char on);	// Draw Signal
	static void DRAWSIG2_vector(unsigned int inr, unsigned char windows, short factor, short offset, unsigned char *DisplayData, unsigned char on);	// Draw Signal
	static void DRAWXY(int channel, unsigned char on);
    static void Connect_Pixels(int x, short y, short y2, int dir, unsigned long *planeaddress, unsigned char on);
    static void Test_Pixels(int x, int y, int y2, int dir, unsigned long *planeaddress);
	static void CALCSIG(void);
	
	static void DrawColorDemoBox(int posx, int posy, int sizex, int sizey, unsigned long *planeaddress);
	static void	ColorDemo(void);
	static void	ColorDemo2(void);
	static void	ColorDemo3(void);
	static void	ColorDemo5(void);
	static void	ColorDemo6(void);
};

class FloatStr
{
protected:
	float Value;
	float Stored_Value;
	float Min_Value;
	float Max_Value;
	float StepSize;
	
	int AfterDot;
	int MaxLength;
	
	char Text[30];
	char PreText[15];
	char Unit[5];
	char DimensionUnit[3];
public:
	void Init(float In_Value, float In_Min_Value, float In_Max_Value, float In_StepSize, int In_AfterDot, int In_MaxLength, char In_Text[20], char In_PreText[10], char In_Unit[5]);
	float Read_Value(void);
	void Write_Value(float In_Value);
	float Read_Stored_Value(void);
	void Write_Stored_Value(float In_Stored_Value);
	float Read_Min_Value(void);
	void Write_Min_Value(float In_Min_Value);
	float Read_Max_Value(void);
	void Write_Max_Value(float In_Max_Value);
	float Read_StepSize(void);
	void Write_StepSize(float In_StepSize);
		
	int Read_AfterDot(void);
	void Write_AfterDot(int In_AfterDot);
	int Read_MaxLength(void);
	void Write_MaxLength(int In_MaxLength);			
		
	char* Read_Text(void);
	char* Read_PreText(void);
	void Write_PreText(char In_PreText[10]);
	char* Read_Unit(void);
	void Write_Unit(char In_Unit[5]);

	void RenderText(void);
	void DoStep(char Direction);	
};

class AMDFlash
{
public:
	static void Init(void);
	static int await_erase_complete(int entire_chip, volatile unsigned char *addr);			// Wait for the given address to contain 0xFF. Return value: 1 on success, 0 on timeout failure.
	static void wait_at_least_1_us(void);													// This routine actually takes about 3 us on a 33.333MHz Nios32.
	static void unlock_bypass_mode(volatile unsigned char *flash_base);						// Unlock bypass mode, enabling fast writes.
	static void reset_bypass_mode(volatile unsigned char *flash_base);						// Turn bypass mode off, disabling fast writes and enabling normal function.
	static int await_write_complete(volatile unsigned char *addr, const unsigned char correct_value);	// Read the given address until two successive reads yield the same value. Return value: 0 on success, -1 on timeout failure.
	static int nr_flash_write_bypass(volatile unsigned char *flash_base, volatile unsigned char *addr, unsigned char val);	// Write val to the given flash address, in bypass mode (assumes that bypass mode has been enabled already). Return value: 0 on success, -1 on failure.

	static int nr_flash_erase_sector(unsigned long *flash_base, unsigned long *sector_address);	// Erase the flash sector at sector_address. Return value: 0 on success, -1 on failure.
	static int nr_flash_write_buffer(unsigned long *flash_base, unsigned long *start_address, unsigned long *buffer, int size);	// Write a buffer of data to the flash, using bypass mode. Return value: 1 on success, 0 on failure. Note: the integer "size" is given as a number of half-words to write.   How convenient.  We write this 8-bit-wide flash one byte at a time (of course).
    static int amd29lv065d_flash_write_byte(unsigned char *flash_base, unsigned char *addr, unsigned char val); // Writes one byte to Flash
    static int nr_flash_write(unsigned long *flash_base, unsigned long *addr, unsigned long val); // Writes one Value to Flash
    
	static void Clear_Data_FLASH(void);														// Clear the Data Flash;
    static int copy_signal_to_flash(unsigned long *flash_address);
    static void load_signal_from_flash(unsigned long *flash_address);
    
	static void copy_flash_to_planes(void);													// Copy the flash memory to the planes	
	static void copy_flash_to_plane(unsigned long *flash_address, unsigned long *plane);	// Copy one flash to plane
	
	static void Write_Config_Flash(void);													// Write Config to Flash
	static void Read_Config_Flash(void);													// Read Config from Flash
	
	static void Write_TestData_Flash(void);													// Write TestData to Flash
	static void Read_TestData_Flash(void);	                                                // Read TestData from Flash

    static int EraseSector_Flash(unsigned long *flash_address);                                   // Erase a sector on givven address
    static int WriteData_Byte_Flash(unsigned long *flash_address, unsigned char add, unsigned char data);   // Writes a Datablock at given address
    static void ReadData_Prepare_Flash(unsigned long *flash_address);
    static unsigned char ReadData_Byte_Flash(unsigned int add);
    
	static void Write_Protected_Flash(void);													// Write Protected to Flash
	static void Read_Protected_Flash(void);	                                                // Read Protected from Flash

};

#endif //tc_classes_h
