// file: tc_classes.cpp
/*
Developed by Oliver Gorzellik at Wittig Technologies AG (c) 2005-2007
Review partial by Thomas M. Wittig (TMW) from June 2008
TMW: "Some bugs found, not easy to understand software structure"
TMW: "All to be improved!!!"
*/
#include "nios.h"	/* Descriptions of standard peripherals */
#include <stdio.h>
#include "math.h"
//#include "assert.h"
//#include "malloc.h"

#include "tc_classes.h"
#include "tc_vars.h"

//#define _Debug_
//#define _Debug_IRQ_
//#define _Debug_QM_
//#define _Debug_FindZero_
//#define _Debug_AutoScale_
//#define _Debug_FindVoltage_
//#define _Debug_FindTimebase_
//#define _Debug_ZeroLevel_
//#define _Debug_Cursor_
//#define _Debug_Roll_Mode_
//#define _Debug_Memory_
//#define _Debug_USB_
//#define _Debug_FFT_

// Class Hardware
void Hardware::Init(void)											// Hardware Init Routine
{
	int x;
	unsigned long ChannelSign = 0;

	data_adr->np_piodata = 0x01;
	
	mode->np_piodata = 0x01;			//reset CH3 & CH4
	mode->np_piodata = 0x00;
		
	data_adr->np_piodata = 0x01;		// delay
	
	ChannelSign = READADC(3);
	
	if ((ChannelSign & 0xFFFF0000) == 0x12480000)
	{
#ifdef _Debug_	
		printf("4-Channels found Signatur : %x\n", ChannelSign);
#endif			
		NumberOfChannels = 4;
	}
	else
	{
#ifdef _Debug_	
		printf("2-Channels found Signatur : %x\n", ChannelSign);
#endif			
		NumberOfChannels = 2;
	}
	
	data_adr->np_piodata = 0x00;

    Setup_Hardware();	
	Setup_Vars();
	Set_Vars_Default();
	
	AMDFlash::Init();
	AMDFlash::Read_Config_Flash();
	AMDFlash::Read_Protected_Flash();
	
    out_test->np_piodata = test_port_reg;		
	
	Recalc_Vars();
	
	if (ROLLMODE_TB < 3) ROLLMODE_TB = 3;   	
	
	if (MenuStatus[1][3] < 104) MenuStatus[1][3] = 104;
	if (MenuStatus[2][3] < 104) MenuStatus[2][3] = 104;
	if (MenuStatus[3][3] < 104) MenuStatus[3][3] = 104;
	if (MenuStatus[4][3] < 104) MenuStatus[4][3] = 104;
	if (MenuStatus[12][4] < 104) MenuStatus[12][4] = 104;
	
	// Coupling channel popup
    if (MenuStatus[1][0] == 7)
    {
        MenuPopupStatus[13][0] = 2;                                     // Popup Coupling = AC
        MenuPopupStatus[13][1] = 3;
        MenuPopupStatus[13][2] = 2;
    }
    else if (MenuStatus[1][0] == 8)
    {
        MenuPopupStatus[13][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[13][1] = 2;
        MenuPopupStatus[13][2] = 3;
    }
    else
    {
        MenuPopupStatus[13][0] = 3;                                     // Popup Coupling = GND
        MenuPopupStatus[13][1] = 2;
        MenuPopupStatus[13][2] = 2;
    }	

    if (MenuStatus[2][0] == 7)
    {
        MenuPopupStatus[14][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[14][1] = 3;
        MenuPopupStatus[14][2] = 2;
    }
    else if (MenuStatus[2][0] == 8)
    {
        MenuPopupStatus[14][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[14][1] = 2;
        MenuPopupStatus[14][2] = 3;
    }
    else
    {
        MenuPopupStatus[14][0] = 3;                                     // Popup Coupling = DC
        MenuPopupStatus[14][1] = 2;
        MenuPopupStatus[14][2] = 2;
    }	

    if (MenuStatus[3][0] == 7)
    {
        MenuPopupStatus[15][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[15][1] = 3;
        MenuPopupStatus[15][2] = 2;
    }
    else if (MenuStatus[3][0] == 8)
    {
        MenuPopupStatus[15][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[15][1] = 2;
        MenuPopupStatus[15][2] = 3;
    }
    else
    {
        MenuPopupStatus[15][0] = 3;                                     // Popup Coupling = DC
        MenuPopupStatus[15][1] = 2;
        MenuPopupStatus[15][2] = 2;
    }	

    if (MenuStatus[4][0] == 7)
    {
        MenuPopupStatus[16][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[16][1] = 3;
        MenuPopupStatus[16][2] = 2;
    }
    else if (MenuStatus[4][0] == 8)
    {
        MenuPopupStatus[16][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[16][1] = 2;
        MenuPopupStatus[16][2] = 3;
    }
    else
    {
        MenuPopupStatus[16][0] = 3;                                     // Popup Coupling = DC
        MenuPopupStatus[16][1] = 2;
        MenuPopupStatus[16][2] = 2;
    }	

	
//    Debug_Mode = true;	
//    ADC_Debug_Mode = true;	
   	
	Read_Version();	
#ifdef _Debug_	
	printf("HW Version : %x  Ch : %d\n", tc_hw_version, NumberOfChannels);
#endif	
    dmode_factor = Timebase_Delayed_Factor_Matrix[Selected_Timebase][SIGNALFaktor_idx] / Timebase_Delayed_Factor_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx];

    Cursor_Delayed_1 = (300 - (int) (((float) 600 / dmode_factor) / 2)) + dmode_Window_Offset_Pos;
    Cursor_Delayed_2 = Cursor_Delayed_1 + (int) ((float) 600 / dmode_factor);
    Cursor_Delayed_Size = Cursor_Delayed_2 - Cursor_Delayed_1;
		
	if (NumberOfChannels == 2)
	{
		Channel_3_Active = 0;
		Channel_4_Active = 0;
		
		LED_ON[2] = 0;
		LED_ON[3] = 0;
		
		sprintf(&MenuData[29][0], "Math");
		sprintf(&MenuData[140][0], "External");	
		
		MenuDataDef[29] = 33;
		MenuDataDef[140] = 21;
		
		sprintf(&MenuPopupText[1][3][0], "Math");
		sprintf(&MenuPopupText[3][3][0], "Math");
		sprintf(&MenuPopupText[5][3][0], "Math");
		sprintf(&MenuPopupText[6][3][0], "Math");
		sprintf(&MenuPopupText[7][3][0], "External");		
		sprintf(&MenuPopupText[24][3][0], "Math");
		sprintf(&MenuPopupText[25][3][0], "Math");
		sprintf(&MenuPopupText[26][3][0], "Math");

		
		MenuPopupDef[1][1] = 2;//3
		MenuPopupDef[3][1] = 2;//3
		MenuPopupDef[5][1] = 3;
		MenuPopupDef[6][1] = 3;
		MenuPopupDef[7][1] = 3;	
		MenuPopupDef[24][1] = 3;
		MenuPopupDef[25][1] = 3;
		MenuPopupDef[26][1] = 3;
		MenuPopupDef[28][1] = 2;
		MenuPopupDef[29][1] = 2;

		MenuPopupStatus[1][2] = 0;//1;
		MenuPopupStatus[1][3] = 0;
		//MenuPopupStatus[1][4] = 0;
		MenuPopupStatus[3][2] = 0;//1
		MenuPopupStatus[3][3] = 0;
//		MenuPopupStatus[3][4] = 0;    //kein math mehr
		MenuPopupStatus[5][2] = 1;
		MenuPopupStatus[5][3] = 0;
		MenuPopupStatus[5][4] = 0;
		MenuPopupStatus[6][2] = 1;
		MenuPopupStatus[6][3] = 0;
		MenuPopupStatus[6][4] = 0;
		MenuPopupStatus[7][3] = 0;
		MenuPopupStatus[7][4] = 0;
		MenuPopupStatus[24][2] = 1;
		MenuPopupStatus[24][3] = 0;
		MenuPopupStatus[24][4] = 0;
		MenuPopupStatus[25][2] = 1;
		MenuPopupStatus[25][3] = 0;
		MenuPopupStatus[25][4] = 0;
		MenuPopupStatus[26][2] = 1;
		MenuPopupStatus[26][3] = 0;
		MenuPopupStatus[26][4] = 0;        		
		MenuPopupStatus[28][2] = 0;
		MenuPopupStatus[28][3] = 0;		
		MenuPopupStatus[29][2] = 0;
		MenuPopupStatus[29][3] = 0;
	}

	key_reset->np_piodata = 0;
	nr_delay(1);
	key_reset->np_piodata = 1;	

	key_int->np_pioedgecapture = 0;									// clear IRQ conditions		
		       		
//	FindSlope();
	
#ifdef _Debug_		       		
	if (Debug_Mode) printf("Init Hardware Ready \n");
#endif

	if (Selected_Timebase > 18)
    {
        Selected_Timebase = 18;
        timebase_reg = tb_value[Selected_Timebase];
        Display_Timebase = Selected_Timebase + SIGNALFaktor_idx;
    }
}

void Hardware::Reset_the_Watchdog(void)								//Resets the WatchDog
{
	reset_watchdog->np_piodata = 0x00;								// Reset WatchDog
	reset_watchdog->np_piodata = 0x01;	
}

void Hardware::Start_Record(void)						
{
    if (Test_Mode) return;

    la_pulse->np_piodata = 0x01;				//stop record Port On
    la_pulse->np_piodata = 0x00;				//stop record Port Off	

    READADC(1);

    adc_started = true;
    start_acq->np_piodata = 0x01;				//start record Port On
    start_acq->np_piodata = 0x00;				//start record Port Off	
#ifdef _Debug_
    if (Debug_Mode) printf("Start Record\n");
#endif
}

void Hardware::Stop_Record(void)							
{
    adc_started = false;
    la_pulse->np_piodata = 0x01;				//stop record Port On
    la_pulse->np_piodata = 0x00;				//stop record Port Off	

//    READADC(1);
#ifdef _Debug_
    if (Debug_Mode) printf("Stop Record\n");
#endif
}

void Hardware::Read_Version(void)								//Read the hardware version
{
    la_gate->np_piodata = 0x01;

    tc_hw_version = (unsigned long) la_data->np_piodata;

    la_gate->np_piodata = 0x00;
}

void Hardware::Setup_Vars(void)												// Set standart values for variables
{
	short ix, ix2, ix3;
    int cnt;
	
	for (ix = 0;ix < 480;ix++)
	{
	    Display_Line_Adresses[ix] = ix * 20;
	}

	for (ix = 0;ix < 480;ix++)
	{
	    Display_Line_Adresses2[ix] = ix * 80;
	}

	for (ix = 0;ix <= 16383;ix++)
	{
		SIGNAL1[ix] = 0;	
		SIGNAL2[ix] = 0;
		SIGNAL3[ix] = 0;
		SIGNAL4[ix] = 0;
	}	
	
	for (ix = 0; ix <= 255; ix++)
	{
        for (ix2 = 0; ix2 < 6; ix2++)
        {	
            for (ix3 = 0; ix3 < 9; ix3++)
            {
                FIR_Tab_big[ix][ix2][ix3] = (short) FIR_Tabel[ix2][ix3] * ix;
            }
        }	
	}
    
	for (ix = 0;ix < 32;ix++)
	{
		LogicData[ix] = ix;
	}
	
	// kann wahrscheinlich auf 600 reduziert werden
	//for (ix = 0;ix <= 16385;ix++)
	for (ix = 0;ix <= 600;ix++)
	{	
	    SIGNAL1_SUM_MIN[ix] = 255;
	    SIGNAL1_SUM_MAX[ix] = 0;
	}
	   /*
    for(ix = 0; ix <= fft_length; ix++)
    {
        fft_window[0][ix] = 1.0;
        //fft_window[1][ix] = (0.25 + ((0.5 * cos(2*PI*(float)ix/(float)fft_length)) * (-0.5 * cos(2*PI*(float)ix/(float)fft_length)))) * 4;
        //fft_window[1][ix] = 0.5 * (1 - cos(2*PI*(float)ix/(float)fft_length));
        //fft_window[2][ix] = 0.281 * cos(2*PI*(float)ix/(float)fft_length) - 0.521 * cos(2*PI*(float)ix/(float)fft_length) + 0.198 * cos(2*PI*(float)ix/(float)fft_length);
        
        fft_window[1][ix] = 0.25 - (0.4825 * (1 - cos(2*PI*(float)ix/(float)fft_length))) + (0.3225 * (1 - cos(2*PI*(float)ix/(float)fft_length))) - (0.097 * (1 - cos(2*PI*(float)ix/(float)fft_length))) + (0.008 * (1 - cos(2*PI*(float)ix/(float)fft_length)));
    }*/	
    
/*    printf("fw1 : %f\n", fft_window[0][1]);
    printf("fw2 : %f\n", fft_window[0][2]);
    printf("fw3 : %f\n", fft_window[0][3]);
    
    printf("fw1 : %f\n", fft_window[1][1]);
    printf("fw2 : %f\n", fft_window[1][2]);
    printf("fw3 : %f\n", fft_window[1][3]);
*/	
	led_status = 0x01;
	
	MenuStored = 0;
	MenuActive = 0;
	MenuChanged = 0;
		
	IsPopuped = 0;
	
	Selected_ADCs_CH1 = 0;
	Selected_ADCs_CH2 = 0;
	Selected_ADCs_CH3 = 0;
	Selected_ADCs_CH4 = 0;
	
	SelectedChannel = 1;
	SelectedChannelOld = 1;
		
	Channel_1_Active = 1;	
	Channel_2_Active = 1;
	Channel_3_Active = 1;
	Channel_4_Active = 1;			
	Channel_Math_Active = 0;
	
	Channel_1_Active_Old = 0;	
	Channel_2_Active_Old = 0;
	Channel_3_Active_Old = 0;
	Channel_4_Active_Old = 0;			
	Channel_Math_Active_Old = 0;
	
	// Channel 1-4 on + Math off
	LED_ON[0] = 1;				
	LED_ON[1] = 1;
	LED_ON[2] = 1;
	LED_ON[3] = 1;	
	LED_ON[4] = 0;
	
	// General Wheel LED off
	LED_ON[5] = 0;	
	
	// Run Green LED On
	LED_ON[12] = 1;
	
	// Trigger edge On
	LED_ON[8] = 1;		
	
	Virtual_ZeroLevelCH1 = -120;
	Virtual_ZeroLevelCH2 = -50;
	Virtual_ZeroLevelCH3 = 50;	
	Virtual_ZeroLevelCH4 = 120;
	
	Virtual_ZeroLevelXYCH1 = 0;
	Virtual_ZeroLevelXYCH2 = 0;
	Virtual_ZeroLevelXYCH3 = 0;	
	Virtual_ZeroLevelXYCH4 = 0;	
	
	ZeroLevelCH1 = 98;
	ZeroLevelCH2 = 340;
	ZeroLevelCH3 = 278;	
	ZeroLevelCH4 = 170;
		
	ZeroLevelCH1_Old = 98;
	ZeroLevelCH2_Old = 340;
	ZeroLevelCH3_Old = 278;
	ZeroLevelCH4_Old = 170;	
		
    Cursor_Enabled = false;
	
	Cursor_Both_Selected_Old = 0;	
    Cursor_Both_Selected = 0;	
	
	SelectedCursor = 0;
	SelectedCursorOld = 0;	
	
	CursorChanged = 0;
	
	Cursor_Horizontal_Active = 0;
	Cursor_Horizontal_Active_Old = 0; 	

	Cursor_Horizontal_Position_Real1 = 103;
	Cursor_Horizontal_Position_Real2 = 203;	

	Cursor_Horizontal_Position1_Old = 103;
	Cursor_Horizontal_Position2_Old = 203;	

	Cursor_Vertical_Active = 0;
	Cursor_Vertical_Active_Old = 0;	

	Cursor_Vertical_Position_Real1 = 103;
	Cursor_Vertical_Position_Real2 = 203;	

	Cursor_Vertical_Position1_Old = 103;
	Cursor_Vertical_Position2_Old = 203;	

	Cursor_Vertical_Position_Real_XY_1 = 103;
	Cursor_Vertical_Position_Real_XY_2 = 203;	

	Cursor_Vertical_Position_XY_1_Old = 103;
	Cursor_Vertical_Position_XY_2_Old = 203;
	
    QM_Enabled = false;
	QM_Changed[0] = 0;
	QM_Changed[1] = 0;
	QM_Changed[2] = 0;
	
	QM_Type[0] = 0;
	QM_Type[1] = 0;
	QM_Type[2] = 0;

	QM_Type_Old[0] = 0;
	QM_Type_Old[1] = 0;
	QM_Type_Old[2] = 0;
	
	QM_Channel[0] = 1;
	QM_Channel[1] = 1;
	QM_Channel[2] = 1;	
    	
	QM_Horizontal_Active = 3;
	QM_Horizontal_Active_Old = 3; 	

	QM_Horizontal_Position_Real1 = 103;
	QM_Horizontal_Position_Real2 = 203;	

	QM_Horizontal_Position1_Old = 103;
	QM_Horizontal_Position2_Old = 203;	

	QM_Vertical_Active = 3;
	QM_Vertical_Active_Old = 3;	

	QM_Vertical_Position_Real1 = 103;
	QM_Vertical_Position_Real2 = 203;	

	QM_Vertical_Position1_Old = 103;
	QM_Vertical_Position2_Old = 203;		

    Quick_Measure_Threshold_btn_select = 1;

	SelectedEdgeExtern = 0;

	Memory_Position = 0;	
	
	Selected_Trigger_Source = 0;
	Selected_Trigger_Source_Old = 5;
	
	Selected_Timebase = 4;
	Display_Timebase = 4;       // Mu vielleicht ins Flash
	Selected_Expand_Timebase = 0;
	
	dmode_Selected_Timebase = 4;
	dmode_Window_Offset_Pos = 0;
	
	TriggerWay = 1;
	
	Trigger_Pos_CH1 = 50;
	Trigger_Pos_CH2 = 100;
	Trigger_Pos_CH3 = 150;
	Trigger_Pos_CH4 = 200;
	Trigger_Pos_CHE = 15;
	
	Trigger_Pos_CH1_Old = 50;
	Trigger_Pos_CH2_Old = 100;
	Trigger_Pos_CH3_Old = 150;
	Trigger_Pos_CH4_Old = 200;
	Trigger_Pos_CHE_Old = 15;	
	
	Timebase_Offset_Pos = 0;
	Timebase_Offset_Pos_Old = 0;

	Trigger_Offset_Pos = 8192;
	Trigger_Offset_Pos_Old = 8192;
    	
	Selected_Voltage_CH1 = 9;
	Selected_Voltage_CH2 = 9;
	Selected_Voltage_CH3 = 9;
	Selected_Voltage_CH4 = 9;
	Selected_TB = 0;	
	
	SwitchesCH1 = 0x00D5;
	SwitchesCH2 = 0x00D5;
	SwitchesCH3 = 0x00D5;
	SwitchesCH4 = 0x00D5;	
	SwitchesTB = 0x0000;		

	SwitchesCH1Old = 0x0000;
	SwitchesCH2Old = 0x0000;
	SwitchesCH3Old = 0x0000;
	SwitchesCH4Old = 0x0000;		
	SwitchesTBOld = 0x0001;
	
	ScreenShotActive = 0;	
	
	USB_Data_Trans = 0;
	USB_SendAllData = 0;
	USB_OnlyTrigger = 0;
	Continius = 1;													// Constant Recodinng
	SingleMode = 0;	
	
    GridColorArrayPos = 3;
    GridColor_Val = 0x3F;
    GridColorArrayPos_Delayed = 2;
    GridColor_Val_Delayed = 0x15;	
	
    ADC_Debug_Mode = false;
    Debug_Mode = false;
    Command_Mode = false;
    Calc_Mode = false;
    ExtraTrg_Mode = false;
    Search_Mode = false;
    Search_Auto = false;

    adc_started = false;
    Connect_Vals = true;

    ctrl_reg = 0x00A3;
    adc_ctrl_reg = 0x01C0;

    adc_del_reg = 0;
    pre_reg = 0x0000;
    //trg_val_reg = 0x00A0;
    //trg_hyst_reg = 0x0090;
    ext_trg_val_reg = 0x80;
    triggering = 0x00;
    channel_Adr_add = 0x0000;
    trig_range_reg = 0;
    trig_width_reg = 0x0001;

    trg_val_CHI_reg = 0x00A0;
    trg_val_CHII_reg = 0x00A0;
    trg_val_CHIII_reg = 0x00A0;
    trg_val_CHIV_reg = 0x00A0;

    trig_holdoff_reg = 0x00000000;
    adc_change12_reg = 0x00000000;
    adc_change34_reg = 0x00000000;
    adc_ctr12_reg = 0x00000000;
    adc_ctr34_reg = 0x00000000;

    timebase_reg = 0xFFFFFFFF;
    ram_adress_reg = 0;
    test_port_reg = 0;

    CH1_DAC_Offset = 8192;
    CH1_Zero_Offset = 0;
    CH1_DAC_1 = 0;
    CH1_DAC_2 = 0;
    CH1_DAC_3 = 0;
    CH1_DAC_4 = 0;

    CH2_DAC_Offset = 8192;
    CH2_Zero_Offset = 0;
    CH2_DAC_1 = 0;
    CH2_DAC_2 = 0;
    CH2_DAC_3 = 0;
    CH2_DAC_4 = 0;

    CH3_DAC_Offset = 8192;
    CH3_Zero_Offset = 0;
    CH3_DAC_1 = 0;
    CH3_DAC_2 = 0;
    CH3_DAC_3 = 0;
    CH3_DAC_4 = 0;

    CH4_DAC_Offset = 8192;
    CH4_Zero_Offset = 0;
    CH4_DAC_1 = 0;
    CH4_DAC_2 = 0;
    CH4_DAC_3 = 0;
    CH4_DAC_4 = 0;

    Channel1_1_ADC_Correction = 0;
    Channel1_2_ADC_Correction = 0;
    Channel1_3_ADC_Correction = 0;//256;
    Channel1_4_ADC_Correction = 0;

    Channel2_1_ADC_Correction = 0;
    Channel2_2_ADC_Correction = 0;
    Channel2_3_ADC_Correction = 0;//256;
    Channel2_4_ADC_Correction = 0;

    Channel3_1_ADC_Correction = 0;
    Channel3_2_ADC_Correction = 0;
    Channel3_3_ADC_Correction = 0;//256;
    Channel3_4_ADC_Correction = 0;

    Channel4_1_ADC_Correction = 0;
    Channel4_2_ADC_Correction = 0;
    Channel4_3_ADC_Correction = 0;//256;
    Channel4_4_ADC_Correction = 0;

    CH1_X_Offset_1 = 0;
    CH1_X_Offset_2 = 0;
    CH1_X_Offset_3 = 0;
    CH1_X_Offset_4 = 0;

    CH2_X_Offset_1 = 0;
    CH2_X_Offset_2 = 0;
    CH2_X_Offset_3 = 0;
    CH2_X_Offset_4 = 0;

    CH3_X_Offset_1 = 0;
    CH3_X_Offset_2 = 0;
    CH3_X_Offset_3 = 0;
    CH3_X_Offset_4 = 0;

    CH4_X_Offset_1 = 0;
    CH4_X_Offset_2 = 0;
    CH4_X_Offset_3 = 0;
    CH4_X_Offset_4 = 0;

    Channel1_Zero_Sign_Offset_1 = 100;
    Channel1_Zero_Sign_Offset_2 = 130;
    Channel1_Zero_Sign_Offset_3 = 100;
    Channel2_Zero_Sign_Offset_1 = 100;
    Channel2_Zero_Sign_Offset_2 = 130;
    Channel2_Zero_Sign_Offset_3 = 100;
    Channel3_Zero_Sign_Offset_1 = 100;
    Channel3_Zero_Sign_Offset_2 = 130;
    Channel3_Zero_Sign_Offset_3 = 100;
    Channel4_Zero_Sign_Offset_1 = 100;
    Channel4_Zero_Sign_Offset_2 = 130;
    Channel4_Zero_Sign_Offset_3 = 100;

    VSync_Needed = 0;
    DrawSignals_Needed = 0;

    ClearPlane = 0x00;
    DrawPlane = 0x00;
    RemovePlane = 0x00;
    ClearPhase = true;

    Rotary_Direction = 0;
    Rotary_Direction_mem = 0;
    Rotary_Direction_mem_pulse = 1;
    Rotary_Switch = 0;
    Rotary_Steps = 1;
    Rotary_Changed = 0;

    Keyboard_mem = 0;
    Keyboard_Changed = 0;

    ADC_Data_Available = 0;

	SwitchesCH1 = 0x00D5;
	SwitchesCH2 = 0x00D5;
	SwitchesCH3 = 0x00D5;
	SwitchesCH4 = 0x00D5;	
	SwitchesTB = 0x0000;		

	SwitchesCH1Old = 0x0000;
	SwitchesCH2Old = 0x0000;
	SwitchesCH3Old = 0x0000;
	SwitchesCH4Old = 0x0000;		
	SwitchesTBOld = 0x0001;
	
    SIGNAL_StartFr_idx = 0;
    SIGNAL_OFFSET = 0;
    SIGNALFaktor_idx = 0;	

    FirEnabledCH1 = 0;
    FirEnabledCH2 = 0;
    FirEnabledCH3 = 0;
    FirEnabledCH4 = 0;

    FirStartCH = 5;
    FirStartCH_delayed = 5;

    SmoothEnabledCH1 = 0;
    SmoothEnabledCH2 = 0;
    SmoothEnabledCH3 = 0;
    SmoothEnabledCH4 = 0;

    USB_Data_Trans = false;
    USB_SendAllData = false;
    USB_OnlyTrigger = false;

    Continius = true;

    SingleMode = false;
    Single_Restart = false;

    ButtonChanged = false;
    RoteryChanged = false;

    DoDraw = false;

    PopUpPosition = 0;
    IsPopuped = false;
    PopupTimeCounter = 0;

    TriggerLevelChanged = 1;								// Was Triggerlevel changed
    TriggerModeChanged = 1;								    // Was Triggermode changed
    TriggerWayChanged = 1;									// Was Triggerway changed
    TimebaseChanged = 1;									// Was Timebase changed
    TimeOffsetChanged = 1;									// Was Time_Offset changed
    SIGNALFaktorChanged = 1;								// Was SIGNALFaktor changed

    TriggerLevelActive = 0;								    // Is Triggerlevel selected ?
    TimeOffsetActive = 0;									// Is Time_Offset selected ?

    StatusbarChanged = 0;									// When 1 then is changed
    ZeroPopupChanged = 0;									// When 1 then is changed
    MenuPopupChanged = 0;									// When 1 then is changed
    MenuPopupActive = -1;									// Stores the actual Menupopup
    VoltageChangedCh1 = 1;									// Was Voltage changed
    VoltageChangedCh2 = 1;									// Was Voltage changed
    VoltageChangedCh3 = 1;									// Was Voltage changed
    VoltageChangedCh4 = 1;									// Was Voltage changed
    MenuPopupChanged2 = 0;									// Was MenuPopup changed
    MenuOnlyChanged = 0;									// When 1 then is changed

    MenuItemChanged[0] = 0;
    MenuItemChanged[1] = 0;
    MenuItemChanged[2] = 0;
    MenuItemChanged[3] = 0;
    MenuItemChanged[4] = 0;
    MenuItemChanged[5] = 0;

    MenuItemPushed[0] = 0;				                    // When Menuitem is pushed drawed
    MenuItemPushed[1] = 0;				                    // When Menuitem is pushed drawed
    MenuItemPushed[2] = 0;				                    // When Menuitem is pushed drawed
    MenuItemPushed[3] = 0;				                    // When Menuitem is pushed drawed
    MenuItemPushed[4] = 0;				                    // When Menuitem is pushed drawed
    MenuItemPushed[5] = 0;				                    // When Menuitem is pushed drawed

    MenuStatusChanged = 0;									// When switching on/off a menu holds menunr

    VS_ZeroChangedCh1 = 1;									// Was Zero changed
    VS_ZeroChangedCh2 = 1;									// Was Zero changed
    VS_ZeroChangedCh3 = 1;									// Was Zero changed
    VS_ZeroChangedCh4 = 1;									// Was Zero changed
    VS_TrigLevelChanged = 1;								// Was Triggerlevel changed

    MenuPopupX = 0;
    MenuPopupY = 0;
    MenuPopupSizeX = 0;
    MenuPopupSizeY = 0;

    MenuStored = 0;
    MenuActive = 18;
    MenuActiveOld = 0;
    MenuChanged = true;
    MenuTimeCounter = 0;										// Counter for Menu Pulldown

    MenuItemCount = 0;											// Store the count of the Menuitems
    MenuOldItemCount = 0;										// Store the count of the old Menuitems

    New_Menu = -1;
    Active_Menu = -1;
    Menu_Changed = -1;

    Btns_Status[0] = 0;
    Btns_Status[1] = 0;
    Btns_Status[2] = 0;
    Btns_Status[3] = 0;
    Btns_Status[4] = 0;
    Btns_Status[5] = 0;

    wheelchanged = 0;
    Rot_Summary = 0;

    Memory_Position = 0;

    for (cnt = 0; cnt < 32; cnt++)
    {
        LogicData[cnt] = 0;
    }

    for (cnt = 0; cnt < 301; cnt++)
    {
        SIGNAL_IntBuf[cnt] = 0;
    }

    for (cnt = 0; cnt < 256; cnt++)
    {
        SIGNAL1_Histo[cnt] = 0;
        SIGNAL2_Histo[cnt] = 0;
        SIGNAL3_Histo[cnt] = 0;
        SIGNAL4_Histo[cnt] = 0;
    }
    // kann wahrscheinlich auf 600 reduziert werden
    for (cnt = 0; cnt < 16386; cnt++)
    {
        SIGNAL1[cnt] = 0;
        SIGNAL2[cnt] = 0;
        SIGNAL3[cnt] = 0;
        SIGNAL4[cnt] = 0;
    }	
}

void Hardware::Setup_Hardware(void)												// Setup the Hardware
{
	dma->np_piointerruptmask = 0x00;								// disable all IRQs
	dma->np_piodirection = 0x01;									// set all bits to output
	dma->np_piodata = 0x00;											// Set to 0

	serstartled->np_piointerruptmask = 0x00;						// disable all IRQs
	serstartled->np_piodirection = 0x01;							// set all bits to output
	serstartled->np_piodata = 0x00;									// Set to 0

	serstartsw->np_piointerruptmask = 0x00;							// disable all IRQs
	serstartsw->np_piodirection = 0x01;								// set all bits to output
	serstartsw->np_piodata = 0x00;									// Set to 0

	serstartdac->np_piointerruptmask = 0x00;						// disable all IRQs
	serstartdac->np_piodirection = 0x01;							// set all bits to output
	serstartdac->np_piodata = 0x00;									// Set to 0

	serdata->np_piointerruptmask = 0x00;							// disable all IRQs
	serdata->np_piodirection = 0xFF;								// set all bits to output
	serdata->np_piodata = 0x00;										// Set to 0

	key_reset->np_piointerruptmask = 0x00;							// disable all IRQs
	key_reset->np_piodirection = 0x01;								// set all bits to output
	key_reset->np_piodata = 0x01;									// Set to 1

	key_int->np_piointerruptmask = 0x00;							// disable all IRQs
	key_int->np_piodirection = 0x00;								// set all bits to input
	key_int->np_piodata = 0x00;										// Set to 0

	key->np_piointerruptmask = 0x00;								// disable all IRQs
	key->np_piodirection = 0x00;									// set all bits to input
	key->np_piodata = 0x00;											// Set to 0

	rot_speed_read->np_piointerruptmask = 0x00;						// disable all IRQs
	rot_speed_read->np_piodirection = 0x01;							// set all bits to output
	rot_speed_read->np_piodata = 0x00;								// Set to 0

	data_adr->np_piointerruptmask = 0x00;							// disable all IRQs
	data_adr->np_piodirection = 0x01;								// set all bits to output
	data_adr->np_piodata = 0x00;									// Set to 0
	
	mode->np_piointerruptmask = 0x00;								// disable all IRQs
	mode->np_piodirection = 0x01;									// set all bits to output
	mode->np_piodata = 0x00;										// Set to 0
	
	start_acq->np_piointerruptmask = 0x00;							// disable all IRQs
	start_acq->np_piodirection = 0x01;								// set all bits to output
	start_acq->np_piodata = 0x00;									// Set to 0

	acq_ready->np_piointerruptmask = 0x00;							// disable all IRQs
	acq_ready->np_piodirection = 0x00;								// set all bits to input
	acq_ready->np_piodata = 0x00;									// Set to 0

	reset_watchdog->np_piointerruptmask = 0x00;						// disable all IRQs
	reset_watchdog->np_piodirection = 0x01;							// set all bits to output
	reset_watchdog->np_piodata = 0x00;								// Set to 0

	la_data->np_piointerruptmask = 0x00;							// disable all IRQs
	la_data->np_piodirection = 0x00;								// set all bits to input
	la_data->np_piodata = 0x00;										// Set to 0

	la_interrupt->np_piointerruptmask = 0x00;						// disable all IRQs
	la_interrupt->np_piodirection = 0x00;							// set all bits to input
	la_interrupt->np_piodata = 0x00;								// Set to 0

	la_gate->np_piointerruptmask = 0x00;							// disable all IRQs
	la_gate->np_piodirection = 0x01;								// set all bits to output
	la_gate->np_piodata = 0x00;										// Set to 0

	la_pulse->np_piointerruptmask = 0x00;							// disable all IRQs
	la_pulse->np_piodirection = 0x01;								// set all bits to output
	la_pulse->np_piodata = 0x00;									// Set to 0

	out_test->np_pioedgecapture = 0x00; 							// clear all existing IRQ conditions
	out_test->np_piodirection = 0x01;								// set all bits to output
	out_test->np_piodata = 0x08;

	boot_reset_key->np_piointerruptmask = 0x00;						// disable all IRQs
	boot_reset_key->np_piodirection = 0x00;							// set all bits to input
	boot_reset_key->np_piodata = 0x00;								// Set to 0

	power_on_boot_key->np_piointerruptmask = 0x00;					// disable all IRQs
	power_on_boot_key->np_piodirection = 0x00;						// set all bits to input
	power_on_boot_key->np_piodata = 0x00;							// Set to 0
	
	key_test->np_piointerruptmask = 0x00;							// disable all IRQs
	key_test->np_piodirection = 0x00;								// set all bits to input
	key_test->np_piodata = 0x00;			

    if ((boot_reset_key->np_piodata == 0x00) && (power_on_boot_key->np_piodata == 0x00))
    {
#ifdef _Debug_
        printf("No Keyboard selected\n");
#endif
        keyboard_found = 1;
    }
    else if ((boot_reset_key->np_piodata == 0x01) && (power_on_boot_key->np_piodata == 0x00))
    {
#ifdef _Debug_
        printf("Power on Boot Pressed\n");
#endif
        keyboard_found = 2;
    }
    else if ((boot_reset_key->np_piodata == 0x00) && (power_on_boot_key->np_piodata == 0x01))
    {
#ifdef _Debug_
        printf("Reset on Boot Pressed\n");
#endif
        keyboard_found = 3;
    }
    else
    {
#ifdef _Debug_
        printf("Keyboard found\n");
#endif
        keyboard_found = 4;
    }

	triggering = 0;
}

void Hardware::Setup_Interrupts(void)								// Setup the Interrupts
{
    if (keyboard_found == 4)
    {
        DoEnableKeyInterrupt();
        DoEnableRotInterrupt();
    }

    DoEnableUARTInterrupt();
    DoEnableUART2Interrupt();
	DoEnableTimerInterrupt();
	DoEnableADCInterrupt();	
	DoEnableReadVSyncInterrupt();
//    DoEnableLogicAnalyserInterrupt();
    DoEnableTimer3Interrupt();	
}

void Hardware::Set_Vars_Default(void)								//Resets all vars to standart values
{
    int cnt;

    // Main/Delayed - Timebase
    MenuStatus[10][0] = 1;                                          // Main
    MenuStatus[10][1] = 0;                                          // Delayed
    MenuStatus[10][2] = 0;                                          // XY-Mode (Roll)
//    MenuStatus[10][3] = 0;                                          // XY-Mode
//    MenuStatus[10][4] = 33;                                         // TimeRef Center
    MenuStatus[5][2] = 136;                                         // Display - Grid - 100%
    Display_Mode = 0;                                               // Normal Mode - No XY-Mode

    MenuStatus[23][1] = 240;                                          // Autoscale - Search Slow TBs

    Selected_Timebase = 4;                                          // 50 ns
    SIGNALFaktor_idx = 0;                                           // non zoom
    SIGNAL_StartFr_idx = 0;                                         // running. so 0
    SIGNAL_OFFSET = 0;                                              // signal offset

	Timebase_Offset_Pos = -300;//-298;                                     // Timebase Offset
	Memory_Position = 0;                                            // Memory Position
    	
	Trig_Pos_Mem = 300;
    Trig_Mem_Pos = 0;   	
    dmode_Window_Offset_Pos = 0;
    	
    SwitchesTB = 0;                                                 // timebase switches

    timebase_reg = 0xFFFFFFFF;                                      // fastest timebase
    Display_Timebase = 4;                                           // Displayed timebase is 50 ns

    dmode_Selected_Timebase = 3;                                    // delayed timebase is 20 ns
    dmode_SIGNALFaktor_idx = 0;                                     // non zoom for delayed windows
    dmode_factor = 0;                                               // factor for delayed windows cursor calculation
    dmode_SIGNAL_StartFr_idx = 0;                                   // running. so 0
    dmode_SIGNAL_OFFSET = 0;                                        // signal offset

    Cursor_Delayed_1 = 180;                                         // Delayed windows cursor position 1
    Cursor_Delayed_2 = 420;                                         // Delayed windows cursor position 2
    Cursor_Delayed_Size = 240;                                      // Delayed windows size

    ROLLMODE_TB = 3;                                                // Roll-Mode timebase is 500 ms
    ROLLMODE_OFFSET = 600;                                          // start from the right side

    // Nicht sicher ob diese bentigt werden
    ROLLMODE_STARTED = false;                                       // Is Roll- Mode started
    ROLLMODE_Value_rec = false;                                     // was a Roll value samples

    // Trigger
    // Trigger Mode
    MenuStatus[12][0] = 93;                                         // Triggering - Auto
    MenuStatus[12][1] = 95;                                         // Triggering - Coupling DC
    MenuStatus[12][2] = 97;                                        // Triggering - LF Reject
    MenuStatus[12][4] = 104;                                        // Triggering - External Probe 1:1

    MenuPopupStatus[9][0] = 3;
    MenuPopupStatus[9][1] = 2;
            
    EdgeToggle = 1;                                                 // Holdoff deaktive

    // Trigger Edge
    MenuStatus[14][0] = 2;                                          // Triggering - positive edge
    MenuStatus[14][1] = 138;                                        // Triggering - Source = channel 1
    MenuStatus[14][2] = 0;                                          // Triggering - no externel triggering
    MenuStatus[14][3] = 0;                                          // Triggering - no externel TV triggering

    MenuPopupStatus[28][0] = 3;
    MenuPopupStatus[28][1] = 2;


    // Trigger Pulse
    MenuStatus[15][0] = 138;                                        // Triggering - Source Channel 1
    //MenuStatus[15][1] = 2;                                          // Triggering - Negative Pulse
    MenuStatus[15][2] = 3;                                          // Triggering - bigger - smaller - then

    // Quick Print
//    MenuStatus[17][0] = 241;                                        // quick Print - USB
//    MenuStatus[17][1] = 240;                                        // quick Print - RS-232

    Selected_Trigger_Source = 1;                                    // Selected Trigger Source is Channel 1
    SelectedEdgeExtern = 0;                                         // Trigger Edge by extern triggering



    if (NumberOfChannels < 4)
    {
        Trigger_Pos_CH1 = 96;                                           // Trigger Level Channel 1
        Trigger_Pos_CH2 = 288;                                          // Trigger Level Channel 2
    }
    else
    {
        Trigger_Pos_CH1 = 42;                                           // Trigger Level Channel 1
        Trigger_Pos_CH2 = 140;                                          // Trigger Level Channel 2
        Trigger_Pos_CH3 = 238;                                          // Trigger Level Channel 3
        Trigger_Pos_CH4 = 336;                                          // Trigger Level Channel 4
    }
    Trigger_Pos_CHE = 15;

    //trg_val_reg = 0xB1;                                             // Trigger Value
    //trg_hyst_reg = 0xA9;                                            // Trigger Hysterese

    trg_val_CHI_reg = 0x00A0;
    trg_val_CHII_reg = 0x00A0;
    trg_val_CHIII_reg = 0x00A0;
    trg_val_CHIV_reg = 0x00A0;

    ext_trg_val_reg = 0x80;                                         // Trigger Extern Value

    trig_range_reg = 0;                                             // Trigger Range
    trig_holdoff_reg = 0;                                           // Trigger Holdoff
    trig_width_reg = 0;                                             // Trigger Width
    ctrl_reg = 0x0007;                                              // Control register
    //adc_ctrl_reg = 0x01C0;                                          // ADC Control register
    adc_ctrl_reg = 0x81C0;                                          // ADC Control register - Auto Slope detect off

    pre_reg = 0x6C;                                                 // PreTrigger Value
//    channel_Adr_add = 0;                                            // Channel Add Value
//    adc_change12_reg &= 0x0000FF00;                                   // ADC Change  - let ADC Shift Bits set
//    adc_change34_reg &= 0x0000FF00;                                   // ADC Change  - let ADC Shift Bits set

//    adc_ctr12_reg &= 0x000000FF;
//    adc_ctr34_reg &= 0x000000FF;

    triggering = 1;                                                 // Triggering - Free Run
    TriggerWay = 1;                                                 // Edge
    Continius = 1;                                                  // Continius Running

    Trigger_Offset_Pos = 353;//(pre_reg << 2);

    HoldOff_Value = 0;
    HoldOff_Expo = 1;   //ns
    HoldOff_Steps = 40;

    Pulse11_Value = 16;
    Pulse11_Expo = 1;   //ns
    Pulse11_Steps = 8;

    Pulse12_Value = 8;
    Pulse12_Expo = 1;   //ns
    Pulse12_Steps = 8;

    Pulse21_Value = 16;
    Pulse21_Expo = 1;   //ns
    Pulse21_Steps = 8;

    Pulse22_Value = 16;
    Pulse22_Expo = 1;   //ns
    Pulse22_Steps = 8;

    Math_Off_Mul_Value = 1;
    Math_Off_Mul_Value_int = 1;
    Math_Off_Mul_Expo = 0;   //V
    Math_Off_Mul_Steps = 1;

    Math_Off_Sub_Value = 1;
    Math_Off_Sub_Value_int = 1;
    Math_Off_Sub_Expo = 0;   //mV
    Math_Off_Sub_Steps = 1;

    Math_Off_Add_Value = 1;
    Math_Off_Add_Value_int = 1;
    Math_Off_Add_Expo = 0;   //mV
    Math_Off_Add_Steps = 1;

	Math_Offset_mul.Init(0.000001, 0.000001, 1000, 0.000001, 2, 3, "", "", "V");
	Math_Offset_mul.RenderText();
	Math_Offset_add.Init(0.001, 0.001, 1000, 0.001, 2, 3, "", "", "V");
	Math_Offset_add.RenderText();
	Math_Offset_sub.Init(0.001, 0.001, 1000, 0.001, 2, 3, "", "", "V");
	Math_Offset_sub.RenderText();

    // Channel 1
    Channel_1_Active = 1;                                           // Channel 1 active
    Channel_1_Active_Old = 0;                                       // Channel 1 old must be 0
    MenuStatus[1][0] = 8;                                           // Channel 1 - Coupling AC
    MenuStatus[1][1] = 240;                                         // Channel 1 - BW Linit off
    MenuStatus[1][2] = 240;                                         // Channel 1 - Invert off
    MenuStatus[1][3] = 104;                                         // Channel 1 - Probe 1.0 : 1

    MenuPopupStatus[13][0] = 2;                                     // Popup Coupling = DC
    MenuPopupStatus[13][1] = 2;
    MenuPopupStatus[13][2] = 3;

    SwitchesCH1 = 0x0F1A;                                           // Switches for Channel 1 and for the other the AC bit
    Selected_Voltage_CH1 = 11;                                      // Voltage 5V

//    Channel1_Zero_Sign_Offset_1 = 100;                              // Search Zeors offset
//    Channel1_Zero_Sign_Offset_2 = 130;                              // Search Zeors offset
//    Channel1_Zero_Sign_Offset_3 = 100;                              // Search Zeors offset

    CH1_DAC_1 = 0;                                                  // channel 1 dac 1 offset
    CH1_DAC_2 = 0;                                                  // channel 1 dac 2 offset
    CH1_DAC_3 = 0;                                                  // channel 1 dac 3 offset
    CH1_DAC_4 = 0;                                                  // channel 1 dac 4 offset

    signal_zoomed1 = false;                                         // signal not zoomed

    if (NumberOfChannels == 2)
    {
        //CH1_DAC_Offset = 8192;                                    // Channel DAC was set while executing config functions
        //ZeroLevelCH1 = 0;                                         // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH1 = -96;                                 // Virtual ZeroLevel
        CH1_Zero_Offset = 0;                                        // Shift offset when stopped
    }
    else
    {
        //CH1_DAC_Offset = 8192;                                    // Channel DAC was set while executing config functions
        //ZeroLevelCH1 = 0;                                         // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH1 = -120;                                // Virtual ZeroLevel
        CH1_Zero_Offset = 0;                                        // Shift offset when stopped
    }

    // Channel2
    Channel_2_Active = 1;                                           // Channel 2 active
    Channel_2_Active_Old = 0;                                       // Channel 2 old must be 0
    MenuStatus[2][0] = 8;                                           // Channel 2 - Coupling AC
    MenuStatus[2][1] = 240;                                         // Channel 2 - BW Linit off
    MenuStatus[2][2] = 240;                                         // Channel 2 - Invert off
    MenuStatus[2][3] = 104;                                         // Channel 2 - Probe 1.0 : 1

    MenuPopupStatus[14][0] = 2;                                     // Popup Coupling = DC
    MenuPopupStatus[14][1] = 2;
    MenuPopupStatus[14][2] = 3;

    SwitchesCH2 = 0x001A;                                           // Switches for Channel 2
    Selected_Voltage_CH2 = 11;                                      // Voltage 5V

//    Channel2_Zero_Sign_Offset_1 = 100;                              // Search Zeors offset
//    Channel2_Zero_Sign_Offset_2 = 130;                              // Search Zeors offset
//    Channel2_Zero_Sign_Offset_3 = 100;                              // Search Zeors offset

    CH2_DAC_1 = 0;                                                  // channel 2 dac 1 offset
    CH2_DAC_2 = 0;                                                  // channel 2 dac 2 offset
    CH2_DAC_3 = 0;                                                  // channel 2 dac 3 offset
    CH2_DAC_4 = 0;                                                  // channel 2 dac 4 offset

    signal_zoomed2 = false;                                         // signal not zoomed

    if (NumberOfChannels == 2)
    {
        //CH2_DAC_Offset = 8192;                                    // Channel DAC was set while executing config functions
        //ZeroLevelCH2 = 0;                                         // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH2 = 96;                                  // Virtual ZeroLevel
        CH2_Zero_Offset = 0;                                        // Shift offset when stopped
    }
    else
    {
        //CH2_DAC_Offset = 8192;                                    // Channel DAC was set while executing config functions
        //ZeroLevelCH2 = 0;                                         // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH2 = -24;                                // Virtual ZeroLevel
        CH2_Zero_Offset = 0;                                        // Shift offset when stopped
    }

    if (NumberOfChannels == 4)
    {
        // Channel 3
        Channel_3_Active = 1;                                           // Channel 3 active
        Channel_3_Active_Old = 0;                                       // Channel 3 old must be 0
        MenuStatus[3][0] = 8;                                           // Channel 3 - Coupling AC
        MenuStatus[3][1] = 240;                                         // Channel 3 - BW Linit off
        MenuStatus[3][2] = 240;                                         // Channel 3 - Invert off
        MenuStatus[3][3] = 104;                                         // Channel 3 - Probe 1.0 : 1

        MenuPopupStatus[15][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[15][1] = 2;
        MenuPopupStatus[15][2] = 3;

        SwitchesCH3 = 0x001A;                                           // Switches for Channel 3
        Selected_Voltage_CH3 = 11;                                      // Voltage 5V

//        Channel3_Zero_Sign_Offset_1 = 100;                              // Search Zeors offset
//        Channel3_Zero_Sign_Offset_2 = 130;                              // Search Zeors offset
//        Channel3_Zero_Sign_Offset_3 = 100;                              // Search Zeors offset

        CH3_DAC_1 = 0;                                                  // channel 3 dac 1 offset
        CH3_DAC_2 = 0;                                                  // channel 3 dac 2 offset
        CH3_DAC_3 = 0;                                                  // channel 3 dac 3 offset
        CH3_DAC_4 = 0;                                                  // channel 3 dac 4 offset

        signal_zoomed3 = false;                                         // signal not zoomed

        //CH3_DAC_Offset = 8192;                                        // Channel DAC was set while executing config functions
        //ZeroLevelCH3 = 0;                                             // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH3 = 72;                                      // Virtual ZeroLevel
        CH3_Zero_Offset = 0;                                            // Shift offset when stopped

        // Channel 4
        Channel_4_Active = 1;                                           // Channel 4 active
        Channel_4_Active_Old = 0;                                       // Channel 4 old must be 0
        MenuStatus[4][0] = 8;                                           // Channel 4 - Coupling AC
        MenuStatus[4][1] = 240;                                         // Channel 4 - BW Linit off
        MenuStatus[4][2] = 240;                                         // Channel 4 - Invert off
        MenuStatus[4][3] = 104;                                         // Channel 4 - Probe 1.0 : 1

        MenuPopupStatus[16][0] = 2;                                     // Popup Coupling = DC
        MenuPopupStatus[16][1] = 2;
        MenuPopupStatus[16][2] = 3;

        SwitchesCH4 = 0x001A;                                           // Switches for Channel 4
        Selected_Voltage_CH4 = 11;                                      // Voltage 5V

//        Channel4_Zero_Sign_Offset_1 = 100;                              // Search Zeors offset
//        Channel4_Zero_Sign_Offset_2 = 130;                              // Search Zeors offset
//        Channel4_Zero_Sign_Offset_3 = 100;                              // Search Zeors offset

        CH4_DAC_1 = 0;                                                  // channel 4 dac 1 offset
        CH4_DAC_2 = 0;                                                  // channel 4 dac 2 offset
        CH4_DAC_3 = 0;                                                  // channel 4 dac 3 offset
        CH4_DAC_4 = 0;                                                  // channel 4 dac 4 offset

        signal_zoomed4 = false;                                         // signal not zoomed

        //CH4_DAC_Offset = 8192;                                        // Channel DAC was set while executing config functions
        //ZeroLevelCH4 = 0;                                             // ZeroLevel was set while executing config functions
        Virtual_ZeroLevelCH4 = 168;                                     // Virtual ZeroLevel
        CH4_Zero_Offset = 0;                                            // Shift offset when stopped
    }

    Channel_Math_Active = 0;                                        // Math channel off
    MenuStatus[26][1] = 0;                                          // standart math fft on
    MenuStatus[26][2] = 0;                                          // standart math 1*2 off
    MenuStatus[26][3] = 1;                                          // standart math 1-2 on
    MenuStatus[26][4] = 0;                                          // standart math 1+2 off

    math_mul_scale = 177;//166;
    math_sub_scale = 161;//153;
    math_add_scale = 161;//153;

    // deactivate Trigger TV
    //MenuStatus[14][3] = 246;                                          // Trigger TV deactive

    // deactive LF Reject and Holdoff
    //MenuStatus[12][2] = 246;                                          // Reject deactive
    //MenuStatus[12][3] = 246;                                          // Holdoff deactive

    MenuPopupStatus[8][0] = 3;
    MenuPopupStatus[8][1] = 2;
    MenuPopupStatus[8][2] = 2;
    
    
//    Recalc_Trigger();

    if (Selected_Timebase > 7) adc_change12_reg |= 0x01000000;
    else adc_change12_reg &= 0xFEFFFFFF;

    adc_change12_reg |= 0x02000000; //filter
    
   	Recalc_Vars();

    // Cursors
    MenuStatus[16][0] = 27;                                         // Cursor soruce = channel 1

    Cursor_Enabled = false;
    Cursor_Both_Selected = 0;	
	SelectedCursor = 0;
	Cursor_Horizontal_Active = 0;
	Cursor_Horizontal_Position_Real1 = 103;
	Cursor_Horizontal_Position_Real2 = 203;	
	Cursor_Vertical_Active = 0;
	Cursor_Vertical_Position_Real1 = 103;
	Cursor_Vertical_Position_Real2 = 203;	
	Cursor_Vertical_Position_Real_XY_1 = 103;
	Cursor_Vertical_Position_Real_XY_2 = 203;	
	

    // Quick Measure
    QM_Enabled = false;
	
	QM_Type[0] = 5;
	QM_Type[1] = 8;
	QM_Type[2] = 0;
	
	QM_Channel[0] = 1;
	QM_Channel[1] = 1;
	QM_Channel[2] = 1;	
    	
	QM_Horizontal_Active = 0;
	QM_Horizontal_Position_Real1 = 103;
	QM_Horizontal_Position_Real2 = 203;	

	QM_Vertical_Active = 0;
	QM_Vertical_Position_Real1 = 103;
	QM_Vertical_Position_Real2 = 203;	

    Quick_Measure_Threshold_btn_select = 1;

    // Display settings
    GridColorArrayPos = 1;                                          // Normal Grid 33 %
    GridColor_Val = GridColorArray[GridColorArrayPos];              // GridColor White
    GridColorArrayPos_Delayed = 1;                                  // Delayed Grid 33 %
    GridColor_Val_Delayed = 0x15;                                   // GridColore Gray

 /* TMW changed  (removed the below due to reload of old grid when default setup)

	for (cnt = 380; cnt < 8120; cnt++) //400
    {
        Grid_Plane[cnt] = *(Grid_Plane_Flash + cnt);

        if (tc_hw_version < 0x4c7) {if ((cnt % 20) == 0) Grid_Plane[cnt] = Grid_Plane[cnt] << 2;} // Gap
    }
	TMW change ends
*/

    MenuStatus[5][0] = 240;                                         // Display - Persist off
    MenuStatus[5][2] = GridColorArrayPos + 133;                     // Display - Grid 33%
    MenuStatus[5][3] = 241;                                         // Display - Verctors on
    MenuStatus[5][4] = 240;                                         // Display - Browse off

    // Aquire
    MenuStatus[0][0] = 1;                                           // Aquire - Normal on
    MenuStatus[0][1] = 0;                                           // Aquire - Averaging

    // LEDs
    LED_ON[0] = 1;			                                        // Select Channel 1
    LED_ON[1] = 1;			                                        // Select Channel 2
    LED_ON[2] = 1;			                                        // Select Channel 3
    LED_ON[3] = 1;			                                        // Select Channel 4
    LED_ON[4] = 0;			                                        // Select Channel Math
    LED_ON[5] = 1;			                                        // General
    LED_ON[6] = 0;			                                        // Cursor
    LED_ON[7] = 0;			                                        // Quick Measure
    LED_ON[8] = 1;			                                        // Edge
    LED_ON[9] = 0;			                                        // Pattern - Not Used
    LED_ON[10] = 0;			                                        // Pulse Width
    LED_ON[11] = 0;			                                        // More - Not Used
    LED_ON[12] = 1;			                                        // Run/Stop Green
    LED_ON[13] = 0;			                                        // Run/Stop Red
    LED_ON[14] = 0;			                                        // Single Red
    LED_ON[15] = 0;			                                        // Single Green

    MenuItemChanged[0] = true;
    MenuItemChanged[1] = true;
    MenuItemChanged[2] = true;
    MenuItemChanged[3] = true;
    MenuItemChanged[4] = true;
    MenuItemChanged[5] = true;

    RemovePlane |= 0x1F;
    ClearPlanes();

//    config_changed = true;
#ifdef _Debug_
    printf("Vars set\n");
#endif
}


char Hardware::SearchZero(char channel, char level, int *DAC_Offset, int *ZeroSign)
{
    int lcnt = 0;
	int lcnt2 = 0;
    unsigned long buflong = 0, buflong1 = 0, buflong2 = 0;
    char is_running = 1;

#ifdef _Debug_FindZero_
    printf("Start searching zero %d\n", channel);
    
    printf("ZeroSign %8x %d\n", ZeroSign[0], ZeroSign[0]);
#endif
     
    lcnt = 0;
    DAC_Offset[0] = 0x2000;
    is_running = 1;

    SetDacOffset(channel);
    SetSwitches(channel, level);

    triggering = 0;								
    ctrl_reg = 0x0083;							                    // Trigger_Master / Trigger_INT / Free Run  / Zero Line search bit
    if (NumberOfChannels == 2) adc_ctrl_reg = 0x00C0;				// Disable Trigger sources and remove the master bits
    else  adc_ctrl_reg = 0x0000;						            // Remove the master bits

    switch (channel)
    {
        case 1 : adc_ctrl_reg |= 0x0100; break;                     // Set channel 1 Master bit
        case 2 : adc_ctrl_reg |= 0x0200; break;                     // Set channel 2 Master bit
        case 3 : adc_ctrl_reg |= 0x0400; break;                     // Set channel 3 Master bit
        case 4 : adc_ctrl_reg |= 0x0800; break;                     // Set channel 4 Master bit
    }

    SetupADC();
    
    nr_delay(100);
    
    ctrl_reg = 0x0183;                                               // Add zero_line_adj
    
    SetupADC();



    buflong = 0x00000000;
	if (channel < 3)					// Channel 1 & 2
	{
		
	    while (1 == 1)
	    {
	        data_adr->np_piodata = 0x01;
	        
			buflong = READADC(1);
	        
	        if ((buflong & 0x00008000) == 0x00008000)
	        {
		
				buflong1 = READADC(1) & 0x3FFF;
	            
	            ZeroSign[0] = (int) (buflong1 - 8192);		// Wertbergabe an NIOS
	            
	  //          printf("buflong_ch1 %8x %d\n", buflong, buflong);
	  //          printf("buflong1_ch1 %8x %d\n", buflong1, buflong1);
printf("ZeroSign %d\n", ZeroSign[0]);	            
	            break;
	        }
	        
	        data_adr->np_piodata = 0x00;
	        lcnt++;
	        
	        if (lcnt == 50000) break;
		}
	}
	else
	{
		lcnt = 0;
		while (1 == 1)		// Channel 3 & 4
		{
			data_adr->np_piodata = 0x01;

			buflong = READADC(3);

			lcnt2 = 0;

			while (key_test->np_piodata == 0)
			{
		
				lcnt2++;
				if (lcnt2 == 50000)
				{
				 break;
				}
			}

			lcnt2 = 0;
			
			buflong = READADC(1);			//neu eingebaut
			
			if ((buflong & 0x00008000) == 0x00008000)
			{
				
				buflong1 = READADC(1) & 0x3FFF;
				
				ZeroSign[0] = (int) (buflong1 - 8192);	// x-value to NIOS	
				
	//			printf("buflong_ch3 %8x %d\n", buflong, buflong);
	//			printf("buflong1_ch3 %8x %d\n", buflong1, buflong1);
printf("ZeroSign %d\n", ZeroSign[0]);				
				data_adr->np_piodata = 0x00;

				
				break;
			}
			
			lcnt++;
			if (lcnt == 50000) break;
		}
	}
//	printf("lcnt %d\n", lcnt);
//	printf("lcnt2 %d\n", lcnt2);
	printf("Master %x\n", adc_ctrl_reg);
	lcnt = 0;
	lcnt2 = 0;
	data_adr->np_piodata = 0x00;


	buflong2 = READADC(channel);
	    
#ifdef _Debug_FindZero_
    printf("buflong %8x %d\n", buflong, buflong);
    printf("buflong1 %8x %d\n", buflong1, buflong1);
    printf("buflong2 %8x %d\n", buflong2, buflong2);
    printf("ZeroSign %8x %d\n", ZeroSign[0], ZeroSign[0]);
  //  printf("%i %i : dir : %i lcnt : %i  BB : %i  BT : %i CZSO : %i \n", channel, level, dir, lcnt, bottom_val, top_val, ZeroSign[0]);
#endif

    ctrl_reg = 0x0083;	// Trigger_Master / Trigger_INT / FreeRun bit  /
    SetupADC();

    return 0;
}

char Hardware::SearchZeros(void)
{
    char IsSearching = true;
    int searchcnt = 0;

    if ((Search_Mode == false) && (Search_Auto == false)) return 0;

    Stop_Record();
    AutoTimerOff = true;

    //reset_watchdog->np_piodata = 0x00;						// Disable WatchDog
#ifdef _Debug_FindZero_
    printf("We start searching\n");
#endif
	printf("We start searching\n");
	
    DoDisableUARTInterrupt();
    DoDisableADCInterrupt();

//    if (Search_Auto == false)
//    {
        Display::DRAWROUNDBUTTON(230, 180, 180, 80, 0, 0);
        Display::TEXTOUTxvbig("Searching zero lines.", 247, 192, 1, UI_Plane2);
        Display::TEXTOUTxvbig("Remove all input lines.", 247, 212, 1, UI_Plane2);
        Display::TEXTOUTxvbig("Can take up to 1 min.", 247, 232, 1, UI_Plane2);
//    }

    // Backup old vars
    Channel_1_Active_bak = Channel_1_Active;
    Channel_2_Active_bak = Channel_2_Active;
    Channel_3_Active_bak = Channel_3_Active;
    Channel_4_Active_bak = Channel_4_Active;

    Selected_Timebase_bak = Selected_Timebase;
    SIGNALFaktor_idx_bak = SIGNALFaktor_idx;
    SIGNAL_StartFr_idx_bak = SIGNAL_StartFr_idx;
    timebase_reg_bak = timebase_reg;
    Display_Timebase_bak = Display_Timebase;
    Continius_bak = Continius;
    SingleMode_bak = SingleMode;

    triggering_bak = triggering;
    ctrl_reg_bak = ctrl_reg;
    adc_ctrl_reg_bak = adc_ctrl_reg;

    // Data for undo
    CH1_DAC_Offset_bak = CH1_DAC_Offset;
    CH2_DAC_Offset_bak = CH2_DAC_Offset;
    CH3_DAC_Offset_bak = CH3_DAC_Offset;
    CH4_DAC_Offset_bak = CH4_DAC_Offset;
    
    CH1_DAC_Offset = 0x2000;
    CH2_DAC_Offset = 0x2000;
    CH3_DAC_Offset = 0x2000;
    CH4_DAC_Offset = 0x2000;
    
    /*

    Channel1_Zero_Sign_Offset_1_bak = Channel1_Zero_Sign_Offset_1;
    Channel1_Zero_Sign_Offset_2_bak = Channel1_Zero_Sign_Offset_2;
    Channel1_Zero_Sign_Offset_3_bak = Channel1_Zero_Sign_Offset_3;

    Channel2_Zero_Sign_Offset_1_bak = Channel2_Zero_Sign_Offset_1;
    Channel2_Zero_Sign_Offset_2_bak = Channel2_Zero_Sign_Offset_2;
    Channel2_Zero_Sign_Offset_3_bak = Channel2_Zero_Sign_Offset_3;

    Channel3_Zero_Sign_Offset_1_bak = Channel3_Zero_Sign_Offset_1;
    Channel3_Zero_Sign_Offset_2_bak = Channel3_Zero_Sign_Offset_2;
    Channel3_Zero_Sign_Offset_3_bak = Channel3_Zero_Sign_Offset_3;

    Channel4_Zero_Sign_Offset_1_bak = Channel4_Zero_Sign_Offset_1;
    Channel4_Zero_Sign_Offset_2_bak = Channel4_Zero_Sign_Offset_2;
    Channel4_Zero_Sign_Offset_3_bak = Channel4_Zero_Sign_Offset_3;
      */

    Channel_1_Active = true;
    Channel_2_Active = true;

    if (NumberOfChannels > 2)
    {
        Channel_3_Active = true;
        Channel_4_Active = true;
    }

    Continius = 0;
 //   SingleMode = 1;

    if (adc_started)
    {
        while (acq_ready->np_piodata == 0x01) {}
        adc_started = false;
    }

    Selected_Timebase = 4;                                          // 50 nS
    SIGNALFaktor_idx = 0;                                           // zoom factor 0
    SIGNAL_StartFr_idx = 0;                                         // running. so 0

    timebase_reg = 0xFFFFFFFF;                                      // real timebase
    Display_Timebase = 4;                                           // Displayed timebase is 50ns
    
  /*
    Selected_Timebase = 8;                                          // 10 S // 500 nS
    SIGNALFaktor_idx = 4;                                           // zoom factor 1 = 10 S
    SIGNAL_StartFr_idx = 0;                                         // running. so 0

    timebase_reg = 0xFFFFFFFB;                                      // real timebase
    Display_Timebase = 12;                                          // Displayed timebase is 10 s
    */
    // start condition made -> start searching

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;

        IsSearching = SearchZero(1, 9, &CH1_DAC_Offset, &Channel1_Zero_Sign_Offset_1);
    }

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;
        IsSearching = SearchZero(1, 10, &CH1_DAC_Offset, &Channel1_Zero_Sign_Offset_2);
    }

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;
        IsSearching = SearchZero(1, 11, &CH1_DAC_Offset, &Channel1_Zero_Sign_Offset_3);
    }

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;
        IsSearching = SearchZero(2, 9, &CH2_DAC_Offset, &Channel2_Zero_Sign_Offset_1);
    }

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;
        IsSearching = SearchZero(2, 10, &CH2_DAC_Offset, &Channel2_Zero_Sign_Offset_2);
    }

    searchcnt = 0;
    IsSearching = true;
    while (IsSearching)
    {
        searchcnt++;
        if (searchcnt == 3) break;
        IsSearching = SearchZero(2, 11, &CH2_DAC_Offset, &Channel2_Zero_Sign_Offset_3);
    }

    if (NumberOfChannels > 2)
    {
        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(3, 9, &CH3_DAC_Offset, &Channel3_Zero_Sign_Offset_1);
        }

        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(3, 10, &CH3_DAC_Offset, &Channel3_Zero_Sign_Offset_2);
        }

        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(3, 11, &CH3_DAC_Offset, &Channel3_Zero_Sign_Offset_3);
        }
        
        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(4, 9, &CH4_DAC_Offset, &Channel4_Zero_Sign_Offset_1);
        }

        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(4, 10, &CH4_DAC_Offset, &Channel4_Zero_Sign_Offset_2);
        }

        searchcnt = 0;
        IsSearching = true;
        while (IsSearching)
        {
            searchcnt++;
            if (searchcnt == 3) break;
            IsSearching = SearchZero(4, 11, &CH4_DAC_Offset, &Channel4_Zero_Sign_Offset_3);
        }
    }
        

    Channel_1_Active = Channel_1_Active_bak;
    Channel_2_Active = Channel_2_Active_bak;
    Channel_3_Active = Channel_3_Active_bak;
    Channel_4_Active = Channel_4_Active_bak;

    Selected_Timebase = Selected_Timebase_bak;
    SIGNALFaktor_idx = SIGNALFaktor_idx_bak;
    SIGNAL_StartFr_idx = SIGNAL_StartFr_idx_bak;
    timebase_reg = timebase_reg_bak;
    Display_Timebase = Display_Timebase_bak;
    Continius = Continius_bak;
    SingleMode = SingleMode_bak;

    triggering = triggering_bak;
    ctrl_reg = ctrl_reg_bak;
    adc_ctrl_reg = adc_ctrl_reg_bak;
    
    CH1_DAC_Offset = CH1_DAC_Offset_bak;
    CH2_DAC_Offset = CH2_DAC_Offset_bak;
    CH3_DAC_Offset = CH3_DAC_Offset_bak;
    CH4_DAC_Offset = CH4_DAC_Offset_bak;


    Rotary_Steps = 0;
    ON_Zero_Channel_1();
    Rotary_Steps = 0;
    ON_Zero_Channel_2();


    SetSwitches(1, Selected_Voltage_CH1);
    SetSwitches(2, Selected_Voltage_CH2);

    if (NumberOfChannels > 2)
    {
        Rotary_Steps = 0;
        ON_Zero_Channel_3();
        Rotary_Steps = 0;
        ON_Zero_Channel_4();

        SetSwitches(3, Selected_Voltage_CH3);
        SetSwitches(4, Selected_Voltage_CH4);
    }
    
    SetDacOffset(1);
    SetDacOffset(2);
    
    if (NumberOfChannels > 2)
    {
        SetDacOffset(3);
        SetDacOffset(4);
    }

    SetupADC();

    SingleMode = 0;
    Continius = 1;

    Search_Mode = 0;
    Search_Auto = 0;

   /*
//    if (USB_Data_Trans == 1)
    {
        send_buffer[0] = (unsigned char) 13;
        send_buffer[1] = (unsigned char) (CH1_DAC_Offset & 0xFF);
        send_buffer[2] = (unsigned char) ((CH1_DAC_Offset & 0xFF00) >> 8);
        send_buffer[3] = (unsigned char) (Channel1_Zero_Sign_Offset_1 & 0xFF);
        send_buffer[4] = (unsigned char) ((Channel1_Zero_Sign_Offset_1 & 0xFF00) >> 8);
        send_buffer[5] = (unsigned char) (Channel1_Zero_Sign_Offset_2 & 0xFF);
        send_buffer[6] = (unsigned char) ((Channel1_Zero_Sign_Offset_2 & 0xFF00) >> 8);
        send_buffer[7] = (unsigned char) (Channel1_Zero_Sign_Offset_3 & 0xFF);
        send_buffer[8] = (unsigned char) ((Channel1_Zero_Sign_Offset_3 & 0xFF00) >> 8);
        send_buffer[9] = (unsigned char) (CH2_DAC_Offset & 0xFF);
        send_buffer[10] = (unsigned char) ((CH2_DAC_Offset & 0xFF00) >> 8);
        send_buffer[11] = (unsigned char) (Channel2_Zero_Sign_Offset_1 & 0xFF);
        send_buffer[12] = (unsigned char) ((Channel2_Zero_Sign_Offset_1 & 0xFF00) >> 8);
        send_buffer[13] = (unsigned char) (Channel2_Zero_Sign_Offset_2 & 0xFF);
        send_buffer[14] = (unsigned char) ((Channel2_Zero_Sign_Offset_2 & 0xFF00) >> 8);
        send_buffer[15] = (unsigned char) (Channel2_Zero_Sign_Offset_3 & 0xFF);
        send_buffer[16] = (unsigned char) ((Channel2_Zero_Sign_Offset_3 & 0xFF00) >> 8);
        send_buffer[17] = (unsigned char) (CH3_DAC_Offset & 0xFF);
        send_buffer[18] = (unsigned char) ((CH3_DAC_Offset & 0xFF00) >> 8);
        send_buffer[19] = (unsigned char) (Channel3_Zero_Sign_Offset_1 & 0xFF);
        send_buffer[20] = (unsigned char) ((Channel3_Zero_Sign_Offset_1 & 0xFF00) >> 8);
        send_buffer[21] = (unsigned char) (Channel3_Zero_Sign_Offset_2 & 0xFF);
        send_buffer[22] = (unsigned char) ((Channel3_Zero_Sign_Offset_2 & 0xFF00) >> 8);
        send_buffer[23] = (unsigned char) (Channel3_Zero_Sign_Offset_3 & 0xFF);
        send_buffer[24] = (unsigned char) ((Channel3_Zero_Sign_Offset_3 & 0xFF00) >> 8);
        send_buffer[25] = (unsigned char) (CH4_DAC_Offset & 0xFF);
        send_buffer[26] = (unsigned char) ((CH4_DAC_Offset & 0xFF00) >> 8);
        send_buffer[27] = (unsigned char) (Channel4_Zero_Sign_Offset_1 & 0xFF);
        send_buffer[28] = (unsigned char) ((Channel4_Zero_Sign_Offset_1 & 0xFF00) >> 8);
        send_buffer[29] = (unsigned char) (Channel4_Zero_Sign_Offset_2 & 0xFF);
        send_buffer[30] = (unsigned char) ((Channel4_Zero_Sign_Offset_2 & 0xFF00) >> 8);
        send_buffer[31] = (unsigned char) (Channel4_Zero_Sign_Offset_3 & 0xFF);
        send_buffer[32] = (unsigned char) ((Channel4_Zero_Sign_Offset_3 & 0xFF00) >> 8);
        send_buffer[33] = (unsigned char) NumberOfChannels;

        SendData(send_buffer);
    }
    */
#ifdef _Debug_FindZero_
    printf("DAC1 : %i DAC2 : %i DAC3 : %i DAC4 : %i\n", CH1_DAC_Offset, CH2_DAC_Offset, CH3_DAC_Offset, CH4_DAC_Offset);

    printf("CH1_1 :%3d CH1_2 :%3d CH1_3 :%3d CH2_1 :%3d CH2_2 :%3d CH2_3 :%3d \n", Channel1_Zero_Sign_Offset_1, Channel1_Zero_Sign_Offset_2, Channel1_Zero_Sign_Offset_3, Channel2_Zero_Sign_Offset_1, Channel2_Zero_Sign_Offset_2, Channel2_Zero_Sign_Offset_3);
    printf("CH3_1 :%3d CH3_2 :%3d CH3_3 :%3d CH4_1 :%3d CH4_2 :%3d CH4_3 :%3d \n", Channel3_Zero_Sign_Offset_1, Channel3_Zero_Sign_Offset_2, Channel3_Zero_Sign_Offset_3, Channel4_Zero_Sign_Offset_1, Channel4_Zero_Sign_Offset_2, Channel4_Zero_Sign_Offset_3);
#endif

 //   config_changed = true;
 //   AMDFlash::Write_Config_Flash();
   
    if (Search_Auto == false)
    {
        Display::DRAWROUNDBUTTON(230, 180, 180, 80, 0, 1);
        Display::TEXTOUTxvbig("Searching zero lines.", 247, 192, 0, UI_Plane2);
        Display::TEXTOUTxvbig("Remove all input lines.", 247, 212, 0, UI_Plane2);
        Display::TEXTOUTxvbig("Can take up to 1 min.", 247, 232, 0, UI_Plane2);
    }


    AutoTimerOff = false;

    DoEnableADCInterrupt();
    DoEnableUARTInterrupt();

    acq_ready->np_pioedgecapture = 0;
    Start_Record();

    //reset_watchdog->np_piodata = 0x01;						// Enable WatchDog

    return 0;
}


void Hardware::DoEnableKeyInterrupt(void)							// Enable Keyboard service routine
{
	key_int->np_pioedgecapture = 0x00; 								// clear all existing IRQ conditions
	key_int->np_piodirection = 0x00;								// set all bits to input
	key_int->np_piointerruptmask = 0x01;							// enable Keyboard IRQ

	key_reset->np_piodata = 0;										// Reset Keyboard
	nr_delay(1);
	key_reset->np_piodata = 1;
	
	key_int->np_pioedgecapture = 0x00; 								// clear all existing IRQ conditions	

	nr_installuserisr(na_key_interrupt_irq,ISR_KEY,(int)key_int);	// Install ISR for Keyboard
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nKEY interrupt enabled.\n"); 							// print on console
#endif
}
	
void Hardware::DoDisableKeyInterrupt(void)							// Disable Keyboard I/O service routine
{
	nr_installuserisr(na_key_interrupt_irq,0,0); 					// Install empty routine for Keyboard irq
	key_int->np_piointerruptmask = 0x00;							// disable all IRQs
}

void Hardware::ISR_KEY(int context)									// Keyboard Interrupt subroutine
{
    int KeyData = key->np_piodata;									// Get interrupt Keyboad data

	//if (init_done) Reset_the_Watchdog();
	//if (adc_started)
	
	tc_test_var2++;

    /*
    if (MenuStatus[10][2] == 1)
    {
        DoDisableTimer2Interrupt();
        Continius = 0;
        //UserIface_active = 0;
        TriggerModeChanged = 1;
        Display::StatusUpdate();
    }
    */

    //Stop_Record();

    ADC_Data_Available_cnt = 2;

    //acq_ready->np_piointerruptmask = 0x00;							// disable adc irq
 	
	key_reset->np_piodata = 0;										// Reset Keyboard
	nr_delay(1);
	key_reset->np_piodata = 1;
	key_int->np_pioedgecapture = 0;									// clear IRQ conditions	

    Keyboard_mem = KeyData;
    Keyboard_Changed = 1;
	//UserIface_active = 1;
	UserIface_active_2 = 1;

    if (SingleMode == 1)
    {
        SingleMode = 0;

        LED_ON[14] = 0;
        LED_ON[15] = 0;
    }
    /*
    LED_ON[12] = 0;
    LED_ON[13] = 1;
    Send_LED();  */

#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nKEY interrupt occured.\n"); 							// print on console
#endif
}

void Hardware::Keyboard_Interface(void)
{
	int cnt;
	
	if (Keyboard_Changed == 0) return;
	Keyboard_Changed = 0;
	
	ButtonChanged = 1;												// Set Button Changed True	
	  /*
	if (MenuStatus[10][2] == 1)
	{
        ClearPlanes();
        ROLLMODE_OFFSET = 601;	
        ROLLMODE_POS = 0;
    }
    */
    	
#ifdef _Debug_						
    printf("MPA0 %d SEE %d MPS[8][0] %d MPS[8][1] %d MPS[8][2] %d\n", MenuPopupActive, SelectedEdgeExtern, MenuPopupStatus[8][0], MenuPopupStatus[8][1], MenuPopupStatus[8][2]);
#endif	    	
    	
	//if ((Keyboard_mem & 0x00000004) != 0x00) ResetTimer();
#ifdef _Debug_	
    if (Debug_Mode) printf("kd : %x \n", Keyboard_mem);									// print Keyboard Data to console
#endif
			
	if      ((Keyboard_mem & 0x00080000) == 0x00) {ResetTimer(); Buttonhandler(30, 0);}	// Function Button 1
	else if ((Keyboard_mem & 0x00040000) == 0x00) {ResetTimer(); Buttonhandler(31, 0);}	// Function Button 2
	else if ((Keyboard_mem & 0x00020000) == 0x00) {ResetTimer(); Buttonhandler(32, 0);}	// Function Button 3
	else if ((Keyboard_mem & 0x00010000) == 0x00) {ResetTimer(); Buttonhandler(33, 0);}	// Function Button 4
	else if ((Keyboard_mem & 0x00400000) == 0x00) {ResetTimer(); Buttonhandler(34, 0);}	// Function Button 5
	else if ((Keyboard_mem & 0x00100000) == 0x00) {ResetTimer(); Buttonhandler(35, 0);}	// Function Button 6
	
	else if ((Keyboard_mem & 0x00200000) == 0x00) Buttonhandler( 1, 0);	// Channel 1 Button
	else if ((Keyboard_mem & 0x00800000) == 0x00) Buttonhandler( 2, 0);	// Channel 2 Button
	else if ((Keyboard_mem & 0x01000000) == 0x00) Buttonhandler( 3, 0);	// Channel 3 Button !!!
	else if ((Keyboard_mem & 0x02000000) == 0x00) Buttonhandler( 4, 0);	// Channel 4 Button
	else if ((Keyboard_mem & 0x04000000) == 0x00) Buttonhandler(26, 0);	// Channel Math Button
	
	else if ((Keyboard_mem & 0x00008000) == 0x00) Buttonhandler(23, 0);	// Auto Scale
	else if ((Keyboard_mem & 0x00000100) == 0x00) Buttonhandler( 8, 0);	// Save/Recall
	else if ((Keyboard_mem & 0x00000800) == 0x00) Buttonhandler(17, 0);	// Quick Print
	else if ((Keyboard_mem & 0x00002000) == 0x00) Buttonhandler( 6, 0);	// Utility
	else if ((Keyboard_mem & 0x00000001) == 0x00) Buttonhandler(15, 0);	// Pulse Width
	
//	else if ((Keyboard_mem & 0x00000020) == 0x00) Buttonhandler(-1, 0);	// Not used
//	else if ((Keyboard_mem & 0x00000002) == 0x00) Buttonhandler(-1, 0);	// Not used
	else if ((Keyboard_mem & 0x00004000) == 0x00) Buttonhandler(16, 0);	// Cursor
	else if ((Keyboard_mem & 0x00000200) == 0x00) Buttonhandler(19, 0);	// Quick Messurement 	// Kurz geschlossen
	else if ((Keyboard_mem & 0x00000400) == 0x00) Buttonhandler( 0, 0);	// Acquire				//
	else if ((Keyboard_mem & 0x00001000) == 0x00) Buttonhandler( 5, 0);	// Display
	else if ((Keyboard_mem & 0x00000010) == 0x00) Buttonhandler(14, 0);	// Edge
	else if ((Keyboard_mem & 0x00000040) == 0x00) Buttonhandler(12, 0);	// Trigger Mode /Coupling
	
	else if ((Keyboard_mem & 0x00000080) == 0x00) Buttonhandler(10, 0);	// Mode Button
	else if ((Keyboard_mem & 0x00000004) == 0x00) Buttonhandler(37, 0);	// Run / Stop Button
	else if ((Keyboard_mem & 0x00000008) == 0x00) Buttonhandler(38, 0);	// Single Button
	
	
	if (USB_Data_Trans == 1)
	{
		//reset_watchdog->np_piodata = 0x00;						// Disable WatchDog
		
		for (cnt = 0; cnt < 32; cnt++)
		{
			send_buffer[0] = 7;
			send_buffer[1] = cnt;
			send_buffer[2] = 1;
			send_buffer[3] = MenuActive;			
			
			send_buffer[4] = (unsigned char) MenuStatus[cnt][0];
			send_buffer[5] = (unsigned char) MenuStatus[cnt][1];
			send_buffer[6] = (unsigned char) MenuStatus[cnt][2];
			send_buffer[7] = (unsigned char) MenuStatus[cnt][3];
			send_buffer[8] = (unsigned char) MenuStatus[cnt][4];
			send_buffer[9] = (unsigned char) MenuStatus[cnt][5];			
		
			SendData(send_buffer);
		}	
		
		//reset_watchdog->np_piodata = 0x01;						// Enable WatchDog
	}
}

void Hardware::Buttonhandler(int MenuKey, char Pushedlong)			// Button Handler
{
	volatile int pm, xm,ym;
	volatile int res_xm;

	volatile long lpm, lxm,lym;
	volatile long lres_xm;
    	
	short x, pos = 0;
	int ix, ix2, xa, Ct, result;
	unsigned long buffer_long;
	unsigned long *flash_address = 0;

    float buf_float;
    int buf_int;

	long timerVal;
	long timerPeriod;
#ifdef _Debug_        	
	if (Debug_Mode) printf("BH %i MA %i\n", MenuKey, MenuActive);
#endif
	//if (ButtonChanged == 0) return;									// If No Button Pressed return.
	//ButtonChanged = 0;

    if (Splash_drawed)
    {
        Display::REMOVE_SPLASH();
        Display::DrawStartScreen();
        Splash_drawed = false;

        Continius = true;

        TimebaseChanged = 1;
        TimeOffsetChanged = 1;
        TriggerLevelChanged = 1;
        TriggerModeChanged = 1;
        TriggerWayChanged = 1;
        VoltageChangedCh1 = 1;									// Was Voltage changed
        VoltageChangedCh2 = 1;									// Was Voltage changed
        VoltageChangedCh3 = 1;									// Was Voltage changed
        VoltageChangedCh4 = 1;									// Was Voltage changed          		
		
        Display::StatusUpdate();
	
        CursorChanged = 3;
        Cursor_Data_First_Draw = 1;
        Display::DRAWCURSORDATA(0);

        Quick_Measure_First_Draw = 1;
        Display::DRAWQMDATA(0); 	

        Display::DRAW_ALL_CURSOR();
        if (Continius) Start_Record();

        return;
    }
	if (StatusbarChanged) Display::RemoveStatusBtn();
//	if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
	
	MenuAktive = 1;
	
	switch(MenuKey)
	{			
		// Acquire Button pressed	
		case 0:
		{		
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
						
			New_Menu = 0;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}	
		// Channel 1 Button pressed	
		case 1:
		{	
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
										
			if (Active_Menu == 1)
			{
                if ((Channel_2_Active == 0) && (Channel_3_Active == 0) && (Channel_4_Active == 0)) break;

				if (Channel_1_Active == 0) UpdateChannel(1, 1);
				else UpdateChannel(1, 0);
				
				VoltageChangedCh1 = 1;
			}
			else UpdateChannel(1, 1);
			
			if (Channel_1_Active == 0)
            {
                if (MenuStatus[10][2] == 1)
                {
                    MenuStatus[10][0] = 1;
                    MenuStatus[10][2] = 246;
                    Display_Mode = 0;
                }
                RemovePlane |= 0x01;
                ClearPlanes();
            }
            
            if ((Channel_1_Active == 1) && (Channel_2_Active == 1)) MenuStatus[10][2] = 0;
			
			DrawSignals_Needed = true;
			UserIface_active = false;
			
			MenuStatusChanged = 1;
			if (Cursor_Enabled) Display::CALCCURSORDATA();
			
			Display::StatusUpdate();
            		
			New_Menu = 1;
			Menu_Changed = 1;
			
			if (Channel_1_Active == 1)
            {
                Set_LED(5);
                MenuAktive = 1;
            }
			else
            {
                Reset_LED(5);
                MenuAktive = 0;
            }
			
			break;	
		}
		// Channel 2 Button pressed	
		case 2:
		{	
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
	
			MenuButtonCheck(-1);
					
			if (Active_Menu == 2)
			{
                if ((Channel_1_Active == 0) && (Channel_3_Active == 0) && (Channel_4_Active == 0)) break;

				if (Channel_2_Active == 0) UpdateChannel(2, 1);
				else UpdateChannel(2, 0);
				
				VoltageChangedCh2 = 1;
			}
			else UpdateChannel(2, 1);
			
			if (Channel_2_Active == 0)
            {
                if (MenuStatus[10][2] == 1)
                {
                    MenuStatus[10][0] = 1;
                    MenuStatus[10][2] = 0;
                    Display_Mode = 0;
                }
                
                RemovePlane |= 0x02;
                ClearPlanes();
            }
            
            if ((Channel_1_Active == 1) && (Channel_2_Active == 1)) MenuStatus[10][2] = 0;
			
			DrawSignals_Needed = true;
			UserIface_active = false;
			
			MenuStatusChanged = 2;
			if (Cursor_Enabled) Display::CALCCURSORDATA();
							
			Display::StatusUpdate();				
			
            New_Menu = 2;
			Menu_Changed = 1;
			
			if (Channel_2_Active == 1)
            {
                Set_LED(5);
                MenuAktive = 1;
            }
			else
            {
                Reset_LED(5);
                MenuAktive = 0;
            }
						
			break;	
		}
		// Channel 3 Button pressed	
		case 3:
		{
			if (NumberOfChannels == 2) return;
			
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
	
			MenuButtonCheck(-1);			
			
			if (Active_Menu == 3)
			{
                if ((Channel_1_Active == 0) && (Channel_2_Active == 0) && (Channel_4_Active == 0)) break;

				if (Channel_3_Active == 0) UpdateChannel(3, 1);
				else UpdateChannel(3, 0);

				VoltageChangedCh3 = 1;
			}
			else UpdateChannel(3, 1);
			
			if (Channel_3_Active == 0)
            {
                RemovePlane |= 0x04;
                ClearPlanes();
            }
			
			DrawSignals_Needed = true;
			UserIface_active = false;
			
			MenuStatusChanged = 3;	
			if (Cursor_Enabled) Display::CALCCURSORDATA();
				
			Display::StatusUpdate();
			
            New_Menu = 3;
			Menu_Changed = 1;
			
			if (Channel_3_Active == 1)
            {
                Set_LED(5);
                MenuAktive = 1;
            }
			else
            {
                Reset_LED(5);
                MenuAktive = 0;
            }
			
			break;	
		}
		// Channel 4 Button pressed	
		case 4:
		{
			if (NumberOfChannels == 2) return;
			
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
						
			if (Active_Menu == 4)
			{
                if ((Channel_1_Active == 0) && (Channel_2_Active == 0) && (Channel_3_Active == 0)) break;

				if (Channel_4_Active == 0) UpdateChannel(4, 1);
				else UpdateChannel(4, 0);
				
				VoltageChangedCh4 = 1;
			}
			else UpdateChannel(4, 1);
			
			if (Channel_4_Active == 0)
            {
                RemovePlane |= 0x08;
                ClearPlanes();
            }
			
			DrawSignals_Needed = true;
			UserIface_active = false;
			
			MenuStatusChanged = 4;
			if (Cursor_Enabled) Display::CALCCURSORDATA();
			
			Display::StatusUpdate();
			
            New_Menu = 4;
			Menu_Changed = 1;
			
			if (Channel_4_Active == 1)
            {
                Set_LED(5);
                MenuAktive = 1;
            }
			else
            {
                Reset_LED(5);
                MenuAktive = 0;
            }
			
			break;	
		}
		// Display Button pressed	
		case 5:
		{		
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
						
			New_Menu = 5;
			Menu_Changed = 1;
			
			Set_LED(5);
			
			break;	
		}
		// Utility Button pressed	
		case 6:
		{	
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
							
			New_Menu = 6;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}
		// Service Button pressed	// Ist im menu Utility versteckt. Mu noch gemacht werden
		case 7:
		{	
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
							
			New_Menu = 7;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}
		// Save / Recall Button pressed	
		case 8:
		{		
			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
			
			New_Menu = 8;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}
		// Print Menu Button pressed	
		case 9:
		{		
			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
			
			New_Menu = 9;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}
		// Main/Delay Button pressed	
		case 10:
		{		


			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
			
			New_Menu = 10;
			Menu_Changed = 1;
			
			Reset_LED(5);
			
			break;	
		}		
		
		case 12: // Mode / Coupling
		{ 	
            /* Toggle deactive		
			if (Active_Menu == 12)
			{
                if (MenuStatus[12][0] == 93) MenuStatus[12][0] = 94;
                else MenuStatus[12][0] = 93;

                MenuItemChanged[0] = 1;						
            }
            */			

			New_Menu = 12;
			Menu_Changed = 1;
			TriggerLevelChanged = 1;
			TriggerModeChanged = 1;
			
			UpdateTrigger(1);
						
			Display::StatusUpdate();			
			
			Set_LED(5);
			
			break;
		}		
				
		// Edge Trigger Menu Button pressed	
		case 14:
		{		
			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
			TriggerWay = 1;
			
			New_Menu = 14;
			Menu_Changed = 1;
			
            TriggerWayChanged = 1;

            Display::StatusUpdate();				
			
			LED_ON[5] = 1;
			LED_ON[8] = 1;
			LED_ON[10] = 0;

			Send_LED();
			
			UpdateTrigger(2);
			
			break;	
		}
		// Pulse Width Trigger Menu Button pressed	
		case 15:
		{		
			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }		
		
            New_Menu = 15;
			Menu_Changed = 1;


			TriggerWay = 2;			
			
            TriggerWayChanged = 1;

            Display::StatusUpdate();			
			
			LED_ON[5] = 1;
			LED_ON[8] = 0;
			LED_ON[10] = 1;	
            Send_LED();	

            UpdateTrigger(3);	



			break;	
		}		
		// Cursor Menu Button pressed	
		case 16:
		{		
			MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
			
			//CursorChanged = 7; 			
			if ((Cursor_Enabled) && (Active_Menu == 16))
			{
                Cursor_Enabled_Old = Cursor_Enabled;
                Cursor_Enabled = false;
				Cursor_Data_First_Draw = 0;
				//Quick_Measure_First_Draw = 0;
				MenuStatusChanged = 1;

                // remove the cursor data
				for (ix = 408 * 20; ix < 430 * 20; ix++)
                {
                    *(UI_Plane1 + ix) = 0;	// delete
                    *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                    *(UI_Plane4 + ix) = 0;	// delete
                    *(UI_Plane5 + ix) = 0;	// delete
                }

                LED_ON[5] = 0;
                LED_ON[6] = 0;

                Send_LED();			
				
                New_Menu = 16;
			    Menu_Changed = 1;
			    MenuAktive = 0;
				
                Display::DRAW_ALL_CURSOR();
			}
			else
			{
                LED_ON[5] = 1;
                LED_ON[6] = 1;
                			
                if (QM_Enabled)
                {
                    QM_Enabled_Old = QM_Enabled;
                    QM_Enabled = false;
                    Quick_Measure_First_Draw = 0;
                    MenuStatusChanged = 1;

                    // remove the cursor data
                    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }

                    LED_ON[7] = 0;
				
                    //New_Menu = 19;
                    Menu_Changed = 1;
                    //MenuAktive = 0;
				
                    Display::CALCQMDATA();
                }	

                Cursor_Vertical_Active = 1;
                Cursor_Horizontal_Active = 3;

                Send_LED();	

                Cursor_Enabled_Old = Cursor_Enabled;
                Cursor_Enabled = true;
				
				Cursor_Data_First_Draw = 1;		
				MenuStatusChanged = 1;
				
				//SelectedChannel = 0;
				
				CursorChanged = 1;
				CursorChanged = 4;
                //CursorChanged = 3;							
				
				Display::CALCCURSORDATA();
				//Display::DRAWCURSORDATA(0);
				Display::DRAW_ALL_CURSOR();		        			

				
                New_Menu = 16;
			    Menu_Changed = 1;
			    MenuAktive = 1;
			}
#ifdef _Debug_Cursor_			
			if (Debug_Mode) printf("CE : %d CB : %d CVA : %d CHA : %d \n", Cursor_Enabled, Cursor_Both_Selected, Cursor_Vertical_Active, Cursor_Horizontal_Active);
#endif			
			UpdateMenuTextPlane = true;
            	
			break;	
		}

		case 17: // Quick Print
		{
            if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
            {
                send_buffer[0] = 151;						// Check USB Connection
                send_buffer[1] = 0;                         //
                send_buffer[2] = 0;
					
                SendData(send_buffer);					
            }
                            	
			New_Menu = 17;
			Menu_Changed = 1;
			USB_Connected = false;
			
			//if (USB_Connected) USB_Connected = false;
			//else USB_Connected = true;
			
			Reset_LED(5);
			
			break;
		}        	
		
		case 19: // quick measure
		{ 	
           // if ((MenuStatus[10][2] == 1) || (Display_Mode == 1)) return;
            if (Display_Mode == 1) return;


            MenuButtonCheck(-1);
			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
			
			
			
			if ((QM_Enabled) && (Active_Menu == 19))
			{
                if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				
	
                QM_Type_Old[0] = QM_Type[0];
                QM_Type_Old[1] = QM_Type[1];
                QM_Type_Old[2] = QM_Type[2];				
				
                QM_Type[0] = 0;
                QM_Type[1] = 0;
                QM_Type[2] = 0;

                QM_Channel[0] = MenuStatus[19][0] - 26;
                QM_Channel[1] = MenuStatus[19][0] - 26;
                QM_Channel[2] = MenuStatus[19][0] - 26;

                QM_Changed[0] = 0;
                QM_Changed[1] = 0;
                QM_Changed[2] = 0;

                Quick_Measure_First_Draw = 1;

                LED_ON[5] = 0;
                LED_ON[7] = 0;

                New_Menu = 19;
                Menu_Changed = 1;

                QM_Enabled_Old = QM_Enabled;
                QM_Enabled = false;

                QM_Vertical_Active = 0;
                QM_Horizontal_Active = 0;

                Display::CALCQMDATA();
			}
			else
			{ 	
                LED_ON[5] = 1;
                LED_ON[7] = 1;
                	
                QM_Enabled_Old = QM_Enabled;
                QM_Enabled = true;

                QM_Vertical_Active = 3;
                QM_Horizontal_Active = 3;
                			
				Quick_Measure_First_Draw = 1;		
				MenuStatusChanged = 1;
				
				if (QM_Type[0] == 0)
				{
                    if (QM_Type_Old[0] == 0)
                    {
                        QM_Type_Old[0] = 5;             // Freqency
				        QM_Type_Old[1] = 8;            // Peak-Peak
				        QM_Type_Old[2] = 0;
                    }
                    	
                    QM_Type[0] = QM_Type_Old[0];
                    QM_Type[1] = QM_Type_Old[1];
                    QM_Type[2] = QM_Type_Old[2];                         			
			
				    QM_Channel[0] = MenuStatus[19][0] - 26;
				    QM_Channel[1] = MenuStatus[19][0] - 26;
				    QM_Channel[2] = MenuStatus[19][0] - 26;
                }
				

				
				if (QM_Type[0] > 0) QM_Changed[0] = 1;
				if (QM_Type[1] > 0) QM_Changed[1] = 1;
				if (QM_Type[2] > 0) QM_Changed[2] = 1;
                			
                if (Cursor_Enabled)
                {
                    Cursor_Enabled_Old = Cursor_Enabled;
                    Cursor_Enabled = false;
                    Cursor_Data_First_Draw = 0;

                    //MenuStatusChanged = 1;

                    // remove the cursor data
                    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }

                    LED_ON[6] = 0;
				
                    //New_Menu = 16;
                    Menu_Changed = 1;
                    //MenuAktive = 0;
				
                    Display::DRAW_ALL_CURSOR();
                }
                				
				Display::CALCQMDATA();
				
                New_Menu = 19;
			    Menu_Changed = 1;
			    MenuAktive = 1;
			    UpdateMenuTextPlane = true;
			}
			
			Send_LED();	
			
			break;
		}
		
		// Autoscale
		case 23:
		{	
            if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

            SingleMode = 0;
            Continius = 1;
		
			New_Menu = 23;
			Menu_Changed = 1;
			
            AutoScale();                          			
			
			break;
        }		

		// Math
		case 26:
		{		
            //if (MenuStatus[10][2] == 1) break;
            if (Display_Mode == 1) break;

			if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

			MenuButtonCheck(-1);
			
/*	TMW changed; disable FFT when only one channel active 		
			if (Channel_Math_Active == 0)
			{
                if ((Channel_1_Active == false) || (Channel_2_Active == false))    // if only onr channel active then FFT
                {
                    MenuStatus[26][1] = 1;
                    MenuStatus[26][2] = 0;
                    MenuStatus[26][3] = 0;
                    MenuStatus[26][4] = 0;
                    
                    TransferPlanes_clear_asm(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
                    
                    for (ix = 0; ix < 600; ix++)
                    {
                        SIGNALM[ix] = FFTOffsetY;
                    }
                }
			}TMW change ends */
			
			if ((Active_Menu == 26) && (Channel_Math_Active == 1))
			{							
                if (Channel_Math_Active) Channel_Math_Active = 0;
                else Channel_Math_Active = 1;
            }
            else Channel_Math_Active = 1;
            
            New_Menu = 26;
			Menu_Changed = 1;
			
			if (Channel_Math_Active == 1)
            {
                Set_LED(4);
                MenuAktive = 1;

                if (NumberOfChannels == 2)
                {
                    //if (MenuPopupStatus[1][2] == 1) MenuPopupStatus[1][2] = 2;
                    //if (MenuPopupStatus[3][2] == 1) MenuPopupStatus[3][2] = 2;
                }
                else
                {
                    //if (MenuPopupStatus[1][4] == 1) MenuPopupStatus[1][4] = 2;
                    //if (MenuPopupStatus[3][4] == 1) MenuPopupStatus[3][4] = 2;
                }
            }
			else
            {
                Reset_LED(4);
                MenuAktive = 0;

                if (NumberOfChannels == 2)
                {
                    //if (MenuPopupStatus[1][2] != 1) MenuPopupStatus[1][2] = 1;
                    //if (MenuPopupStatus[3][2] != 1) MenuPopupStatus[3][2] = 1;
                }
                else
                {
                    //if (MenuPopupStatus[1][4] != 1) MenuPopupStatus[1][4] = 1;
                    //if (MenuPopupStatus[3][4] != 1) MenuPopupStatus[3][4] = 1;
                }

                RemovePlane |= 0x10;
                ClearPlanes();
            }
            
            // Wenn FFT dann voresrt Cursor off
                if ((Cursor_Enabled) && (MenuStatus[26][1] == 1))
                {
                    Cursor_Enabled_Old = Cursor_Enabled;
                    Cursor_Enabled = false;
                    Cursor_Data_First_Draw = 0;

                    //MenuStatusChanged = 1;

                    // remove the cursor data
                    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }

                    LED_ON[6] = 0;
				
                    //New_Menu = 16;
                    Menu_Changed = 1;
                    //MenuAktive = 0;
				
                    Display::DRAW_ALL_CURSOR();
                }

			break;	
		}        					
		
		// Function Button 1
		case 30 :
		{
#ifdef _Debug_		
            printf("F1 Btn start\n");
#endif
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();

            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;

            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird

			MenuButtonCheck(0);
			
			switch(Active_Menu)
			{
				// Acquire -> Normal
				case 0 :
				{			
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[0][0] == 0)
					{
						MenuStatus[0][1] = 0;
						MenuItemChanged[1] = 1;
																
						MenuStatus[0][0] = 1;
						MenuItemChanged[0] = 1;

						New_Menu = 0;
			            Menu_Changed = 1;
						
						if (MenuStatus[0][1] == 1) Set_LED(5);
						else Reset_LED(5);						
					}
						
					break;	
				}				
		
				// Channel 1 -> Coupling
				case 1 :
				{
		
					if (Channel_1_Active == 0) break;

					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 13)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 13)
					{
						pos = -1;
						MenuPopupStep(13, &MenuStatus[1][0], &pos, &pos, 1, 6, 2);
					}

					New_Menu = 1;
			        Menu_Changed = 1;

					Display::DRAWMENUPOPUP(13);
					
					SetSwitches(1, -1);
	
	                //S Display::Update_Channel_Data(1);
				
					break;
				}
		
				// Channel 2 -> Coupling
				case 2 :
				{
					if (Channel_2_Active == 0) break;
					
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 14)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 14)
					{
						pos = -1;
						MenuPopupStep(14, &MenuStatus[2][0], &pos, &pos, 2, 6, 2);

					}				

					New_Menu = 2;
			        Menu_Changed = 1;
										
					Display::DRAWMENUPOPUP(14);
					
					SetSwitches(1, -1);

	                //S Display::Update_Channel_Data(2);
			
					break;
				}
		
				// Channel 3 -> Coupling
				case 3 :
				{
					if (Channel_3_Active == 0) break;
					
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 15)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 15)
					{
						pos = -1;
						MenuPopupStep(15, &MenuStatus[3][0], &pos, &pos, 3, 6, 2);
					}				

					New_Menu = 3;
			        Menu_Changed = 1;
									
					Display::DRAWMENUPOPUP(15);
					
					SetSwitches(1, -1);

	                //S Display::Update_Channel_Data(3);

					break;
				}
		
				// Channel 4 -> Coupling
				case 4 :
				{
					if (Channel_4_Active == 0) break;
					
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 16)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 16)
					{
						pos = -1;
						MenuPopupStep(16, &MenuStatus[4][0], &pos, &pos, 4, 6, 2);
					}				

					New_Menu = 4;
			        Menu_Changed = 1;
						
					Display::DRAWMENUPOPUP(16);
					
					SetSwitches(1, -1);
					
	                //S Display::Update_Channel_Data(4);

					break;
				}						
		
				// Display -> Persist
				case 5 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[5][0] == 240) MenuStatus[5][0] = 241;
					else MenuStatus[5][0] = 240;
					
                    New_Menu = 5;
			        Menu_Changed = 1;
			
					break;
				}		

				// Utility -> Calibrate Zero Lines
				case 6 :
				{
				    UserIface_active = 0;

                    Search_Step = 0;           		
                    Search_Mode = true;
#ifdef _Debug_
                    if (Debug_Mode)
                    {
                        if (Search_Mode) printf("Search Mode enabled\n");
                        else printf("Search Mode disabled\n");
                    }

                    //printf("SearchResult : %i\n", );
#endif
                    Hardware::SearchZeros();

                    if (Continius)
                    {
                        LED_ON[12] = 1;
                        LED_ON[13] = 0;
                        Send_LED();
                    }

					break;		
				}					             	
				
				// Timebase -> Main
				case 10 :
				{			
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[10][0] == 0)
					{
                        //dmode_Window_Offset_Pos++; // for removing the cursor from delayed mode
                        
			            Display_Mode = 0; // Set first XY off, needed in On_Zero
			            
                        if (MenuStatus[10][1] == 1)
                        {			
                            for (ix = 380; ix < 8120; ix++) //400
                            {
                                Grid_Plane[ix] = *(Grid_Plane_Flash + ix);

                                if (tc_hw_version < 0x4c7) {if ((ix % 20) == 0) Grid_Plane[ix] = Grid_Plane[ix] << 2;} // Gap
                            }
                            
							MenuItemChanged[1] = 1;
							MenuStatus[10][1] = 0;
							
                            GridColor_Val = GridColorArray[GridColorArrayPos];
                            SetupADC();
						
                            MenuStatus[5][2] = GridColorArrayPos + 133;							
							
                            					
                        }
						else if (MenuStatus[10][2] == 1)
						{
                            ZeroLevelCH1 = ZeroLevelCH1_XY_bak;
                            Virtual_ZeroLevelCH1 = VZeroLevelCH1_XY_bak;
                            ZeroLevelCH2 = ZeroLevelCH2_XY_bak;
                            Virtual_ZeroLevelCH2 = VZeroLevelCH2_XY_bak;
                            
                            ON_Zero_Channel_1();
                            ON_Zero_Channel_2();
                            						
							MenuItemChanged[2] = 1;
							MenuStatus[10][2] = 0;
						}

                        /* with rollmode
						else if (MenuStatus[10][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[10][2] = 0;
							DoDisableTimer2Interrupt();
						}
						else if (MenuStatus[10][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[10][3] = 0;

						}*/						
							
                        Display::GRID(20, 20, Grid_Plane);
                        									
						MenuStatus[10][0] = 1;
						
						ROLLMODE_STARTED = false;
						
						TimebaseChanged = 1;
                        TriggerWayChanged = 1;
                        TriggerModeChanged = 1;
                        TriggerLevelChanged = 1;

                        Display::StatusUpdate();						

						New_Menu = 10;
			            Menu_Changed = 1;
                        ClearPlanes();			
					}
					
					Display::DRAW_ALL_CURSOR();	
					
					UpdateTrigger(20);
						
					break;		
				}
		
				// Trigger Mode -> Mode
				case 12 :
				{
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 9)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 9)
					{
						pos = -1;
						MenuPopupStep(9, &MenuStatus[12][0], &pos, &pos, 12, 93, 2);						
						
						New_Menu = 12;
			            Menu_Changed = 1;
			            TriggerLevelChanged = 1;
			            TriggerModeChanged = 1;
				
						UpdateTrigger(4);
						
						Display::StatusUpdate();						
					}				
					
					Display::DRAWMENUPOPUP(9);
					break;
				}			
		
				// Edge -> Rising/Falling
				case 14 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[14][0] == 2) MenuStatus[14][0] = 3;
					else MenuStatus[14][0] = 2;
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;
					
					UpdateTrigger(5);					
					
					New_Menu = 14;
                    Menu_Changed = 1;

					Display::StatusUpdate();
										
					break;	
				
				}		
		
				// Pulse Width -> Source
				case 15 :
				{		
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 7)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 7)
					{
						pos = -1;
						MenuPopupStep(7, &MenuStatus[15][0], &pos, &pos, 15, 138, 2);
						
                        New_Menu = 15;
			            Menu_Changed = 1;
                        TriggerWayChanged = 1;
					}				
					
					Display::StatusUpdate();		
					Display::DRAWMENUPOPUP(7);
					
					UpdateTrigger(6);
					
					break;			
				}				
			
				// Cursor -> Source
				case 16 :
				{
                    if (Cursor_Enabled == 0) break;

					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 1)) Display::DRAWMENUPOPDOWN();
					if (MenuPopupActive == 1)
					{
						pos = -1;
						MenuPopupStep(1, &MenuStatus[16][0], &pos, &pos, 16, 27, 2);
						MenuItemChanged[3] = 1;
						MenuItemChanged[4] = 1;
						Display::CALCCURSORDATA();
						
						CursorChanged = 3;
                        New_Menu = 16;
			            Menu_Changed = 1;
					}
					else if (MenuPopupActive == -1)
					{
                        New_Menu = 16;
			            Menu_Changed = 1;
					}
					Display::DRAWMENUPOPUP(1);

					break;
				}
				
				// Quick Print -> Print to Printer
				case 17 :
				{		
				    if (USB_Connected == false) break;
				
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    //if (MenuStatus[17][2] == 143) MenuStatus[17][2] = 144;
                    //else MenuStatus[17][2] = 143;

                    MenuItemChanged[0] = 1;
									
					New_Menu = 17;
                    Menu_Changed = 1;

	
                    if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
                    {					
                        send_buffer[0] = 150;						// Command Quick Print requested
                        send_buffer[1] = 0;                         // Printer ??
                        send_buffer[2] = 0;
					
                        SendData(send_buffer);					
                    }
									
					break;					
				}
		
				// Getting Started
				case 18 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
		//P			Display::PopUp(1);
					break;
				}		
		
				// Quick Measurement -> Source
				case 19 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
				
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 3)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 3)
					{
						pos = -1;
						MenuPopupStep(3, &MenuStatus[19][0], &pos, &pos, 19, 27, 2);
						
                        New_Menu = 19;
			            Menu_Changed = 1;
					}				
				
					Display::DRAWMENUPOPUP(3);
					break;
				}	
		
				// Quick Measurement Delay Settings
				case 20 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
	
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 5)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 5)
					{
						pos = -1;
						MenuPopupStep(5, &MenuStatus[20][0], &pos, &pos, 20, 27, 2);
						
						New_Menu = 20;
			            Menu_Changed = 1;
					}				
				
					Display::DRAWMENUPOPUP(5);
					break;
				}	

				// Quick Measurement Phase Settings
				case 21 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if ((MenuPopupActive > -1) && (MenuPopupActive != 24)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 24)
					{
						pos = -1;
						MenuPopupStep(24, &MenuStatus[21][0], &pos, &pos, 21, 27, 2);
						
						New_Menu = 21;
			            Menu_Changed = 1;
					}				
				
					Display::DRAWMENUPOPUP(24);
					break;
				}                	
		
				// Quick Measurement Thresholds
				case 22 :
				{	
                    //if (MenuStatus[10][2] == 1) break;
                    	
				    if (QM_Enabled == 0) break;
					if ((MenuPopupActive > -1) && (MenuPopupActive != 26)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 26)
					{
						pos = -1;
						MenuPopupStep(26, &MenuStatus[22][0], &pos, &pos, 22, 27, 2);
					}

					New_Menu = 22;
			        Menu_Changed = 1;

					Display::DRAWMENUPOPUP(26);					
					
					
					break;
				}	

				// AutoScale -> Undo
				case 23 :
				{
                    Selected_Timebase = Selected_Timebase_bak;
                    SIGNALFaktor_idx = SIGNALFaktor_idx_bak;
                    SIGNAL_StartFr_idx = SIGNAL_StartFr_idx_bak;
                    timebase_reg = timebase_reg_bak;
                    Display_Timebase = Display_Timebase_bak;

                    Selected_Voltage_CH1 = Selected_Voltage_CH1_bak;
                    Selected_Voltage_CH2 = Selected_Voltage_CH2_bak;
                    Selected_Voltage_CH3 = Selected_Voltage_CH3_bak;
                    Selected_Voltage_CH4 = Selected_Voltage_CH4_bak;

                    ZeroLevelCH1 = ZeroLevelCH1_bak;            	
                    ZeroLevelCH2 = ZeroLevelCH2_bak;
                    ZeroLevelCH3 = ZeroLevelCH3_bak;
                    ZeroLevelCH4 = ZeroLevelCH4_bak;

                    Virtual_ZeroLevelCH1 = Virtual_ZeroLevelCH1_bak;            	
                    Virtual_ZeroLevelCH2 = Virtual_ZeroLevelCH2_bak;
                    Virtual_ZeroLevelCH3 = Virtual_ZeroLevelCH3_bak;
                    Virtual_ZeroLevelCH4 = Virtual_ZeroLevelCH4_bak;

                    Trigger_Pos_CH1 = Trigger_Pos_CH1_bak;
                    Trigger_Pos_CH2 = Trigger_Pos_CH2_bak;
                    Trigger_Pos_CH3 = Trigger_Pos_CH3_bak;
                    Trigger_Pos_CH4 = Trigger_Pos_CH4_bak;

                    Timebase_Offset_Pos = Timebase_Offset_Pos_bak;
                    Trigger_Offset_Pos = Trigger_Offset_Pos_bak;

                    MenuStatus[1][0] = AC_CH1_bak;
                    MenuStatus[2][0] = AC_CH2_bak;
                    MenuStatus[3][0] = AC_CH3_bak;
                    MenuStatus[4][0] = AC_CH4_bak;
                    
                    MenuStatus[1][2] = Invert_CH1_bak;
                    MenuStatus[2][2] = Invert_CH2_bak;
                    MenuStatus[3][2] = Invert_CH3_bak;
                    MenuStatus[4][2] = Invert_CH4_bak;

                    MenuStatus[10][0] = MAINMODE_bak;
                    //MenuStatus[10][2] = ROLLMODE_bak;
                    ROLLMODE_STARTED = ROLLMODESTARTED_bak;

                    MenuStatus[0][0] = Acquire_bak_0;
                    MenuStatus[0][1] = Acquire_bak_1;		

                    MenuStatus[12][0] = AUTOMODE_bak;

                    if (MenuStatus[12][0] == 93)
                    {
                        MenuPopupStatus[9][0] = 3;
                        MenuPopupStatus[9][1] = 2;
                    }
                    else
                    {
                        MenuPopupStatus[9][0] = 2;
                        MenuPopupStatus[9][1] = 3;
                    }                    	

                    if (Channel_1_Active)
                    {
                        SetDacOffset(1);
                        SetCHDacOffset(1);
                        SetSwitches(1, Selected_Voltage_CH1);
                    }

                    if (Channel_2_Active)
                    {
                        SetDacOffset(2);
                        SetCHDacOffset(2);
                        SetSwitches(2, Selected_Voltage_CH2);
                    }

                    if (NumberOfChannels > 2)
                    {
                        if (Channel_3_Active)
                        {
                            SetDacOffset(3);
                            SetCHDacOffset(3);
                            SetSwitches(3, Selected_Voltage_CH3);
                        }

                        if (Channel_4_Active)
                        {
                            SetDacOffset(4);
                            SetCHDacOffset(4);
                            SetSwitches(4, Selected_Voltage_CH4);
                        }
                    }

                    timebase_reg = tb_value[Selected_Timebase];

                    UpdateTrigger(31);

                    if (Cursor_Enabled)
                    {
                        Display::CALCCURSORDATA();
                        Menu_Changed = 1;
                        CursorChanged = 4;
                    }

                    if (QM_Enabled)
                    {
                        Display::CALCQMDATA();
                        Menu_Changed = 1;
                    }
	
                    VoltageChangedCh1 = 1;
                    Display::DRAWSTATUS(1, 0);
                    Rotary_Steps = 0;
                    ON_Zero_Channel_1();

                    VoltageChangedCh2 = 1;
                    Display::DRAWSTATUS(2, 0);
                    Rotary_Steps = 0;
                    ON_Zero_Channel_2();

                    if (NumberOfChannels > 2)
                    {
                        VoltageChangedCh3 = 1;
                        Display::DRAWSTATUS(3, 0);
                        Rotary_Steps = 0;
                        ON_Zero_Channel_3();

                        VoltageChangedCh4 = 1;
                        Display::DRAWSTATUS(4, 0);
                        Rotary_Steps = 0;
                        ON_Zero_Channel_4();
                    }
                    Display::DRAWSTATUS(6, 0);


					break;
				}
                		
				// Trigger Mode TV
				case 24 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					break;
				}
			
				// Math - Settings
				case 26 :
				{			
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					MenuItemChanged[2] = 1;
					MenuItemChanged[3] = 1;
					MenuItemChanged[4] = 1;
			
					if (MenuStatus[26][1] == 1)	New_Menu = 27;			// FFT Settings Menu
					else if (MenuStatus[26][2] == 1) New_Menu = 29;		// Math Settings Menu
					else if (MenuStatus[26][3] == 1) New_Menu = 29;		// Math Settings Menu
					else if (MenuStatus[26][4] == 1) New_Menu = 29;		// Math Settings Menu						

			        Menu_Changed = 1;
			        
			        //printf("We are here and NewMenu is %d Active_Menu is %d MenuAktive is %d\n", New_Menu, Active_Menu, MenuAktive);
					
					break;
				}
				
				// FFT - Settings - Channel
				case 27 :
				{	
                    //if (MenuStatus[10][2] == 1) break;
                    	
					if ((MenuPopupActive > -1) && (MenuPopupActive != 29)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 29)
					{
						pos = -1;
						MenuPopupStep(29, &MenuStatus[27][0], &pos, &pos, 27, 138, 2);
					}

					New_Menu = 27;
			        Menu_Changed = 1;

					Display::DRAWMENUPOPUP(29);					
					
					
					break;
				}					
				               
				// Math Settings Scale
				case 29 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					MathToggle = 0;
					
					Menu_Changed = 1;
					MenuItemChanged[0] = 1;
					MenuItemChanged[1] = 1;
					
					break;
				}				
			}					
#ifdef _Debug_			
			if (Debug_Mode) printf("Function Button 1\n");		
#endif
			break;
		}	

		
		// Function Button 2
		case 31 :
		{
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();

            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            //if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;

            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird
			
			MenuButtonCheck(1);
			
			switch(Active_Menu)
			{
				// Acquire -> Averaging
				case 0 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[0][1] == 0)
					{
						MenuItemChanged[0] = 1;
						MenuStatus[0][0] = 0;
				
						MenuItemChanged[1] = 1;
						MenuStatus[0][1] = 1;

						New_Menu = 0;
                        Menu_Changed = 1;
					}
						
					break;							
				}
		
				// Channel 1 -> BW Linit
				case 1 :
				{
					if (Channel_1_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[1][1] == 240) MenuStatus[1][1] = 241;
					else MenuStatus[1][1] = 240;					
					
	                SetSwitches(1, -1);

					New_Menu = 1;
			        Menu_Changed = 1;
					
					break;
				}
		
				// Channel 2 -> BW Linit
				case 2 :
				{
					if (Channel_2_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[2][1] == 240) MenuStatus[2][1] = 241;
					else MenuStatus[2][1] = 240;
					
	                SetSwitches(2, -1);

					New_Menu = 2;
			        Menu_Changed = 1;
					
					break;
				}
		
				// Channel 3 -> BW Linit
				case 3 :
				{
					if (Channel_3_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[3][1] == 240) MenuStatus[3][1] = 241;
					else MenuStatus[3][1] = 240;
					
	                SetSwitches(3, -1);

					New_Menu = 3;
			        Menu_Changed = 1;
					
					break;
				}
		
				// Channel 4 -> BW Linit
				case 4 :
				{
					if (Channel_4_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[4][1] == 240) MenuStatus[4][1] = 241;
					else MenuStatus[4][1] = 240;
					
	                SetSwitches(4, -1);

					New_Menu = 4;
			        Menu_Changed = 1;
					
					break;
				}		

				// Display -> Clear Display
				case 5 :
				{		
					if ((Continius == false) || (MenuStatus[5][0] == 241)) ClearPlanes();
					break;
				}
				
				// Utility
				case 6 :
				{		
                    Continius = false;
                    ClearPlanes();
                    Display::DRAW_SPLASH(false);
					break;
				}				
                				
				// Service
				case 7 :
				{		
					//
					break;
				}

				// Save / Recall  - > Save
				case 8 :
				{	
                    timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_stop_mask);// & ~np_timercontrol_cont_mask;	// Stop Timer
                    timer_rotary_busy->np_timerstatus = 0;

                    Display::DRAWROUNDBUTTON(250, 200, 140, 40, 0, 0);
                    Display::TEXTOUTxvbig("Saving Signals", 260, 212, 1, UI_Plane2);                    					
#ifdef _Debug_
                    printf("Lets save a signal %d\n", SavePointer);
#endif
                    switch(SavePointer)
                    {
                        case 1 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A01); break;
                        case 2 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A02); break;
                        case 3 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A03); break;
                        case 4 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A04); break;
                        case 5 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A05); break;
                        case 6 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A06); break;
                        case 7 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A07); break;
                        case 8 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A08); break;
                        case 9 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A09); break;
                        case 10 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A10); break;
                        case 11 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A11); break;
                        case 12 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A12); break;
                        case 13 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A13); break;
                        case 14 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A14); break;
                        case 15 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A15); break;
                        case 16 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_A16); break;

                        case 17 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B01); break;
                        case 18 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B02); break;
                        case 19 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B03); break;
                        case 20 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B04); break;
                        case 21 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B05); break;
                        case 22 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B06); break;
                        case 23 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B07); break;
                        case 24 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B08); break;
                        case 25 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B09); break;
                        case 26 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B10); break;
                        case 27 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B11); break;
                        case 28 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B12); break;
                        case 29 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B13); break;
                        case 30 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B14); break;
                        case 31 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B15); break;
                        case 32 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_B16); break;

                        case 33 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C01); break;
                        case 34 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C02); break;
                        case 35 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C03); break;
                        case 36 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C04); break;
                        case 37 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C05); break;
                        case 38 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C06); break;
                        case 39 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C07); break;
                        case 40 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C08); break;
                        case 41 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C09); break;
                        case 42 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C10); break;
                        case 43 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C11); break;
                        case 44 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C12); break;
                        case 45 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C13); break;
                        case 46 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C14); break;
                        case 47 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C15); break;
                        case 48 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_C16); break;

                        case 49 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D01); break;
                        case 50 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D02); break;
                        case 51 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D03); break;
                        case 52 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D04); break;
                        case 53 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D05); break;
                        case 54 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D06); break;
                        case 55 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D07); break;
                        case 56 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D08); break;
                        case 57 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D09); break;
                        case 58 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D10); break;
                        case 59 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D11); break;
                        case 60 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D12); break;
                        case 61 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D13); break;
                        case 62 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D14); break;
                        case 63 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D15); break;
                        case 64 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_D16); break;

                        case 65 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E01); break;
                        case 66 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E02); break;
                        case 67 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E03); break;
                        case 68 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E04); break;
                        case 69 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E05); break;
                        case 70 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E06); break;
                        case 71 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E07); break;
                        case 72 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E08); break;
                        case 73 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E09); break;
                        case 74 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E10); break;
                        case 75 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E11); break;
                        case 76 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E12); break;
                        case 77 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E13); break;
                        case 78 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E14); break;
                        case 79 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E15); break;
                        case 80 :	result = AMDFlash::copy_signal_to_flash(SAVE_SIGNAL_NR_E16); break;

                    }

                    Display::DRAWROUNDBUTTON(250, 200, 140, 40, 0, 1);
                    Display::TEXTOUTxvbig("Saving Signals", 260, 212, 0, UI_Plane2);                    					

					break;
				}                				
				
				// Timebase -> Delayed Mode
				case 10 :
				{			
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[10][1] == 0)
					{
						if (MenuStatus[10][0] == 1)
						{
							MenuItemChanged[0] = 1;
							MenuStatus[10][0] = 0;
						}			
						else if (MenuStatus[10][2] == 1)
						{
                            ZeroLevelCH1 = ZeroLevelCH1_XY_bak;
                            Virtual_ZeroLevelCH1 = VZeroLevelCH1_XY_bak;
                            ZeroLevelCH2 = ZeroLevelCH2_XY_bak;
                            Virtual_ZeroLevelCH2 = VZeroLevelCH2_XY_bak;
                            						
                            ON_Zero_Channel_1();
                            ON_Zero_Channel_2();
                                                    						
							MenuItemChanged[2] = 1;
							MenuStatus[10][2] = 0;						
						}
                        		
						/*
						else if (MenuStatus[10][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[10][2] = 0;
							DoDisableTimer2Interrupt();
						}
						else if (MenuStatus[10][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[10][3] = 0;
						}
                        */					
																
						MenuStatus[10][1] = 1;

						New_Menu = 10;
			            Menu_Changed = 1;
			
                        GridColor_Val = GridColorArray[GridColorArrayPos_Delayed];
                        SetupADC();
						
                        MenuStatus[5][2] = GridColorArrayPos_Delayed + 133;
					}
					
					for (ix = 380; ix < 8120; ix++) //400
                    {
                        Grid_Plane[ix] = *(Grid_Delayed_Plane_Flash + ix);

                        if (tc_hw_version < 0x4c7) {if ((ix % 20) == 0) Grid_Plane[ix] = Grid_Plane[ix] << 2;} // Gap
                    }

                    dmode_SIGNAL_StartFr_idx = SIGNAL_StartFr_idx;

                    dmode_Selected_Timebase = Selected_Timebase;
                    dmode_SIGNALFaktor_idx = SIGNALFaktor_idx;

                    if (dmode_SIGNALFaktor_idx == 0) dmode_Selected_Timebase--;
                    else dmode_SIGNALFaktor_idx--;

                    dmode_factor = Timebase_Delayed_Factor_Matrix[Selected_Timebase][SIGNALFaktor_idx] / Timebase_Delayed_Factor_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx];

                    Cursor_Delayed_1 = (300 - (int) (((float) 600 / dmode_factor) / 2)) + dmode_Window_Offset_Pos;
                    Cursor_Delayed_2 = Cursor_Delayed_1 + (int) ((float) 600 / dmode_factor);
                    Cursor_Delayed_Size = Cursor_Delayed_2 - Cursor_Delayed_1;

                    Recalc_Vars();
                    
                    Display::DRAW_ALL_CURSOR();
                    ClearPlanes();

                    TimebaseChanged = 1;
                    SIGNALFaktorChanged = 1;
                    Display_Mode = 0;

                    Display::DRAWSTATUS(0, 1);
						
					break;							
				}
			
				// Trigger Mode -> Coupling
				case 12 :
				{
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 10)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 10)
					{
						pos = -1;
						MenuPopupStep(10, &MenuStatus[12][1], &pos, &pos, 12, 95, 2);
						
                        New_Menu = 12;
			            Menu_Changed = 1;
					}				
					
					UpdateTrigger(23);	
					
					Display::DRAWMENUPOPUP(10);
					break;
				}					
			
				// Edge -> source
				case 14 :
				{	
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 28)) { Display::DRAWMENUPOPDOWN(); }

                    if ((MenuPopupStatus[28][0] != 3) && (MenuPopupStatus[28][1] != 3) && (MenuPopupStatus[28][2] != 3) && (MenuPopupStatus[28][3] != 3))
                    {
                        if (Channel_1_Active) MenuPopupStatus[28][0] = 3;
                        else if (Channel_2_Active) MenuPopupStatus[28][1] = 3;
                        else if (Channel_3_Active) MenuPopupStatus[28][2] = 3;
                        else if (Channel_4_Active) MenuPopupStatus[28][3] = 3;
                    }

					if (MenuPopupActive == 28)
					{
						pos = -1;
						MenuPopupStep(28, &MenuStatus[14][1], &pos, &pos, 28, 138, 2);
						
                        New_Menu = 14;
			            Menu_Changed = 1;
					}                   			

                    if (MenuPopupStatus[28][0] == 3) MenuStatus[14][1] = 138;
                    else if (MenuPopupStatus[28][1] == 3) MenuStatus[14][1] = 139;
                    else if (MenuPopupStatus[28][2] == 3) MenuStatus[14][1] = 140;
                    else if (MenuPopupStatus[28][3] == 3) MenuStatus[14][1] = 141;

                    MenuItemChanged[1] = 1;	
                        			
                    MenuStatus[14][2] = 0;
                    MenuItemChanged[2] = 1;	
                    		
                    MenuStatus[14][3] = 0;
                    MenuItemChanged[3] = 1;	                        				

					Display::DRAWMENUPOPUP(28);
					
					Selected_Trigger_Source = MenuStatus[14][1] - 137;
					SelectedEdgeExtern = 0;               // No External
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;		
						
					Display::StatusUpdate();
						
					UpdateTrigger(7);					
					
					break;
				}				
				
				// Pulse Width -> Pulse
				case 15 :
				{
				    break;
				    /*
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[15][1] == 2) MenuStatus[15][1] = 3;
					else MenuStatus[15][1] = 2;
		
					New_Menu = 15;
                    Menu_Changed = 1;
                    TriggerWayChanged = 1;

					Display::StatusUpdate();
					
					UpdateTrigger(8);
					
					break;	
					*/
				}
			
				// Cursor -> X1
				case 16 :
				{	
                    if (Cursor_Enabled == 0) break;	

				    {
                        if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
                        if (Cursor_Vertical_Active_Old == 2) MenuItemChanged[2] = 1;
                        else if (Cursor_Vertical_Active_Old == 4) MenuItemChanged[5] = 1;
                        else if (Cursor_Horizontal_Active_Old == 1) MenuItemChanged[3] = 1;
                        else if (Cursor_Horizontal_Active_Old == 2) MenuItemChanged[4] = 1;
                        else if (Cursor_Horizontal_Active_Old == 4) MenuItemChanged[5] = 1;
					
                        Cursor_Vertical_Active = 1;
                        Cursor_Horizontal_Active = 3;

                        Display::CALCCURSORDATA();
						
                        New_Menu = 16;
                        Menu_Changed = 1;

                        Display::DRAW_ALL_CURSOR();
                    }
					break;				
				}
				
				// Quick Print -> Save to BMP
				case 17 :
				{		
				    if (USB_Connected == false) break;
				
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    //if (MenuStatus[17][2] == 143) MenuStatus[17][2] = 144;
                    //else MenuStatus[17][2] = 143;

                    MenuItemChanged[1] = 1;
									
					New_Menu = 17;
                    Menu_Changed = 1;

	
                    if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
                    {					
                        send_buffer[0] = 150;						// Command Quick Print requested
                        send_buffer[1] = 1;                         // BMP
                        send_buffer[2] = 0;
					
                        SendData(send_buffer);					
                    }
									
					break;					
				}				
			
				// Start screen - disabled
				case 18 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
                    //
					break;
				}	
			
				// Quick Measurement -> Select
				case 19 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;

					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 4)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 4)
					{
						MenuPopupStep(4, &MenuStatus[19][1], &MenuStatus[19][2], &MenuStatus[20][4], 19, 52, 2);
                        MenuStatus[21][4] = MenuStatus[20][4];

                        if (((MenuStatus[19][1] - 52) == 4) || ((MenuStatus[19][1] - 52) == 13))
                        {
                            if (MenuStatus[19][4] == 244) MenuItemChanged[4] = 1;
                            MenuStatus[19][4] = 242;
                        }
                        else
                        {
                            if (MenuStatus[19][4] == 242) MenuItemChanged[4] = 1;
                            MenuStatus[19][4] = 244;
                        }

                        MenuItemChanged[1] = 1;
                        MenuItemChanged[2] = 1;		
					
                        New_Menu = 19;
                        Menu_Changed = 1;
					}				
					
					Display::DRAWMENUPOPUP(4);
					
					ResetTimer();
					
					break;
				}	
			
				// Quick Measurement Settings
				case 20 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[20][1] == 2) MenuStatus[20][1] = 3;
					else MenuStatus[20][1] = 2;
				
					New_Menu = 20;
                    Menu_Changed = 1;

					break;
				}
			
				// Quick Measurement Thresholds
				case 22 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if ((MenuPopupActive > -1) && (MenuPopupActive != 27)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 27)
					{
						pos = -1;
						MenuPopupStep(27, &MenuStatus[22][1], &pos, &pos, 22, 49, 2);

                        New_Menu = 22;
			            Menu_Changed = 1;
					}				
				
					Display::DRAWMENUPOPUP(27);
					break;
				}


				// Autoscale -> Slow TB
				case 23 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					if (MenuStatus[23][1] == 240) MenuStatus[23][1] = 241;
					else MenuStatus[23][1] = 240;
					
					MenuItemChanged[1] = 1;
					New_Menu = 23;
                    Menu_Changed = 1;
					
					break;
				}
                	
			
				// Trigger Mode TV
				case 24 :
				{
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[24][1] == 2) MenuStatus[24][1] = 3;
					else MenuStatus[24][1] = 2;		
				
					New_Menu = 24;
                    Menu_Changed = 1;

					break;	
				}	
			
				// Math - FFT
				case 26 :
				{		
					break;		// TMW broke here to disable FFT
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[26][1] == 0)
					{
						if (MenuStatus[26][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[26][2] = 0;
						}
						
						else if (MenuStatus[26][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[26][3] = 0;
						}
						
						else if (MenuStatus[26][4] == 1)
						{
							MenuItemChanged[4] = 1;
							MenuStatus[26][4] = 0;
						}
																
						MenuStatus[26][1] = 1;

						New_Menu = 26;
                        Menu_Changed = 1;
					}
						
					break;				
                }
                
				// FFT - Settings - Window
				case 27 :
				{
					if ((MenuPopupActive > -1) && (MenuPopupActive != 30)) { Display::DRAWMENUPOPDOWN(); }
					
					if (MenuPopupActive == 30)
					{
						pos = -1;
						MenuPopupStep(30, &MenuStatus[27][1], &pos, &pos, 27, 182, 2);
						
                        New_Menu = 27;
                        Menu_Changed = 1; 	
					}                                     			
					
					Display::DRAWMENUPOPUP(30);	
					
					break;
				}
				
				/*
				// FFT - Settings - Scale
				case 27 :
				{	
                    if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
                    				
				    FFTToggle = 0;
				    
					MenuItemChanged[1] = 1;
					MenuItemChanged[2] = 1;					

                    New_Menu = 27;
                    Menu_Changed = 1;                    	

					break;
				}*/				
				
				// Math Settings Offset
				case 29 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					MathToggle = 1;
					
					Menu_Changed = 1;
					MenuItemChanged[0] = 1;
					MenuItemChanged[1] = 1;
					
					break;
				}				
			}					
#ifdef _Debug_			
			if (Debug_Mode) printf("Function Button 2\n");		
#endif
			break;
		}
			
		// Function Button 3
		case 32 :
		{
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();

            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            //if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;

            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird
			
			MenuButtonCheck(2);

			switch(Active_Menu)
			{	
				// Channel 1 -> Invert
				case 1 :
				{
					if (Channel_1_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[1][2] == 240) MenuStatus[1][2] = 241;
					else MenuStatus[1][2] = 240;

					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;
					
					UpdateTrigger(55);						
					Display::StatusUpdate();

					New_Menu = 1;
                    Menu_Changed = 1;
					
					break;
				}
			
				// Channel 2 -> Invert
				case 2 :
				{
					if (Channel_2_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[2][2] == 240) MenuStatus[2][2] = 241;
					else MenuStatus[2][2] = 240;
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;
					
					UpdateTrigger(56);						
					Display::StatusUpdate();

					New_Menu = 2;
                    Menu_Changed = 1;
					
					break;
				}
			
				// Channel 3 -> Invert
				case 3 :
				{
					if (Channel_3_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[3][2] == 240) MenuStatus[3][2] = 241;
					else MenuStatus[3][2] = 240;
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;
					
					UpdateTrigger(57);						
					Display::StatusUpdate();

					New_Menu = 3;
                    Menu_Changed = 1;
					
					break;
				}
			
				// Channel 4 -> Invert
				case 4 :
				{
					if (Channel_4_Active == 0) break;
					
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[4][2] == 240) MenuStatus[4][2] = 241;
					else MenuStatus[4][2] = 240;
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;
					
					UpdateTrigger(58);
					Display::StatusUpdate();

					New_Menu = 4;
                    Menu_Changed = 1;
					
					break;
				}		
					
				// Utility
				case 6 :
				{		
					FindSlope();
					break;
				}
                					
				// Service
				case 7 :
				{		
					//
					break;
				}

				// Save / Recall  - > Recall Signal
				case 8 :
				{	
                    //if (MenuStatus[10][2] == 1) DoDisableTimer2Interrupt();
                    
                    switch(SavePointer)
                    {
                        case 1 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A01); break;
                        case 2 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A02); break;
                        case 3 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A03); break;
                        case 4 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A04); break;
                        case 5 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A05); break;
                        case 6 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A06); break;
                        case 7 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A07); break;
                        case 8 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A08); break;
                        case 9 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A09); break;
                        case 10 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A10); break;
                        case 11 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A11); break;
                        case 12 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A12); break;
                        case 13 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A13); break;
                        case 14 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A14); break;
                        case 15 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A15); break;
                        case 16 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_A16); break;

                        case 17 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B01); break;
                        case 18 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B02); break;
                        case 19 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B03); break;
                        case 20 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B04); break;
                        case 21 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B05); break;
                        case 22 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B06); break;
                        case 23 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B07); break;
                        case 24 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B08); break;
                        case 25 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B09); break;
                        case 26 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B10); break;
                        case 27 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B11); break;
                        case 28 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B12); break;
                        case 29 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B13); break;
                        case 30 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B14); break;
                        case 31 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B15); break;
                        case 32 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_B16); break;

                        case 33 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C01); break;
                        case 34 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C02); break;
                        case 35 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C03); break;
                        case 36 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C04); break;
                        case 37 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C05); break;
                        case 38 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C06); break;
                        case 39 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C07); break;
                        case 40 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C08); break;
                        case 41 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C09); break;
                        case 42 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C10); break;
                        case 43 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C11); break;
                        case 44 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C12); break;
                        case 45 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C13); break;
                        case 46 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C14); break;
                        case 47 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C15); break;
                        case 48 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_C16); break;

                        case 49 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D01); break;
                        case 50 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D02); break;
                        case 51 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D03); break;
                        case 52 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D04); break;
                        case 53 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D05); break;
                        case 54 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D06); break;
                        case 55 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D07); break;
                        case 56 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D08); break;
                        case 57 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D09); break;
                        case 58 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D10); break;
                        case 59 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D11); break;
                        case 60 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D12); break;
                        case 61 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D13); break;
                        case 62 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D14); break;
                        case 63 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D15); break;
                        case 64 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_D16); break;

                        case 65 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E01); break;
                        case 66 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E02); break;
                        case 67 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E03); break;
                        case 68 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E04); break;
                        case 69 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E05); break;
                        case 70 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E06); break;
                        case 71 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E07); break;
                        case 72 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E08); break;
                        case 73 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E09); break;
                        case 74 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E10); break;
                        case 75 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E11); break;
                        case 76 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E12); break;
                        case 77 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E13); break;
                        case 78 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E14); break;
                        case 79 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E15); break;
                        case 80 :	AMDFlash::load_signal_from_flash(SAVE_SIGNAL_NR_E16); break;
                    }
                    
					break;
				}

				// Print
				case 9 :
				{		
                    //
					break;
				}

                // Timebase-> X-Y Mode
				case 10 :
				{		
				    if ((Channel_1_Active == false) || (Channel_2_Active == false)) break;
				    
				    printf("MA : %d L4 : %d \n", Channel_Math_Active, LED_ON[4]);
				    
                    ZeroLevelCH1_XY_bak = ZeroLevelCH1;
                    VZeroLevelCH1_XY_bak = Virtual_ZeroLevelCH1;
                    ZeroLevelCH2_XY_bak = ZeroLevelCH2;
                    VZeroLevelCH2_XY_bak = Virtual_ZeroLevelCH2;
				
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[10][2] == 0)
					{
						if (MenuStatus[10][0] == 1)
						{
							MenuItemChanged[0] = 1;
							MenuStatus[10][0] = 0;
						}
                        else if (MenuStatus[10][1] == 1)
                        {				
                            for (ix = 380; ix < 8120; ix++) //400
                            {
                                Grid_Plane[ix] = *(Grid_Plane_Flash + ix);

                                if (tc_hw_version < 0x4c7) {if ((ix % 20) == 0) Grid_Plane[ix] = Grid_Plane[ix] << 2;} // Gap
                            }
							MenuItemChanged[1] = 1;
							MenuStatus[10][1] = 0;
							
                            GridColor_Val = GridColorArray[GridColorArrayPos];
                            SetupADC();
						
                            MenuStatus[5][2] = GridColorArrayPos + 133;									
                        }
						
                        if (QM_Enabled)
                        {
                            QM_Enabled_Old = QM_Enabled;
                            QM_Enabled = false;
                            Quick_Measure_First_Draw = 0;
                            MenuStatusChanged = 1;

                            // remove the cursor data
                            for (ix = 408 * 20; ix < 430 * 20; ix++)
                            {
                                *(UI_Plane1 + ix) = 0;	// delete
                                *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                                *(UI_Plane4 + ix) = 0;	// delete
                                *(UI_Plane5 + ix) = 0;	// delete
                            }

                            LED_ON[7] = 0;
				
                            //New_Menu = 19;
                            Menu_Changed = 1;
                            //MenuAktive = 0;
				
                            Display::CALCQMDATA();
                        }
                        
                        if (Channel_Math_Active)
                        {
                            LED_ON[4] = 0;
                            Channel_Math_Active = 0;
                        }

                        Send_LED();
                        
						Virtual_ZeroLevelCH1 = 0;
						ON_Zero_Channel_1();
						Virtual_ZeroLevelCH2 = 0;
						ON_Zero_Channel_2();
                        						
						Display::GRIDXY(80, 20, Grid_Plane);

						MenuStatus[10][2] = 1;
						
						New_Menu = 10;
                        Menu_Changed = 1;
                        Display_Mode = 1;
                        Display::DRAWSTATUS(0, 1);
                        ClearPlanes();
					}
					
                    Display::DRAW_ALL_CURSOR();

                    printf("MA2 : %d L4 : %d \n", Channel_Math_Active, LED_ON[4]);
                    						
					break;							
				}                                   		
					     /*
				// Timebase-> Roll Mode
				case 10 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[10][2] == 0)
					{
						if (MenuStatus[10][0] == 1)
						{
							MenuItemChanged[0] = 1;
							MenuStatus[10][0] = 0;
						}
                        else if (MenuStatus[10][1] == 1)
                        {				
                            for (ix = 380; ix < 8120; ix++) //400
                            {
                                Grid_Plane[ix] = *(Grid_Plane_Flash + ix);

                                if (tc_hw_version < 0x4c7) {if ((ix % 20) == 0) Grid_Plane[ix] = Grid_Plane[ix] << 2;} // Gap
                            }
							MenuItemChanged[1] = 1;
							MenuStatus[10][1] = 0;
							
                            GridColor_Val = GridColorArray[GridColorArrayPos];
                            SetupADC();
						
                            MenuStatus[5][2] = GridColorArrayPos + 133;														
											
                        }						
						else if (MenuStatus[10][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[10][3] = 0;
						}						
						
						MenuStatus[10][2] = 1;
						
						TimebaseChanged = 1;
                        TriggerWayChanged = 1;
                        TriggerModeChanged = 1;
                        TriggerLevelChanged = 1;

                        QM_Type_Old[0] = QM_Type[0];
                        QM_Type_Old[1] = QM_Type[1];
                        QM_Type_Old[2] = QM_Type[2];				
				
                        QM_Type[0] = 0;
                        QM_Type[1] = 0;
                        QM_Type[2] = 0;

                        QM_Channel[0] = MenuStatus[19][0] - 26;
                        QM_Channel[1] = MenuStatus[19][0] - 26;
                        QM_Channel[2] = MenuStatus[19][0] - 26;

                        QM_Changed[0] = 0;
                        QM_Changed[1] = 0;
                        QM_Changed[2] = 0;

                        Quick_Measure_First_Draw = 1;

                        LED_ON[5] = 0;
                        LED_ON[7] = 0;

                        QM_Enabled_Old = QM_Enabled;
                        QM_Enabled = false;

                        QM_Vertical_Active = 0;
                        QM_Horizontal_Active = 0;

                        Display::CALCQMDATA();

                        Display::StatusUpdate();

						New_Menu = 10;
                        Menu_Changed = 1;
                        Display_Mode = 0;
                        ROLLMODE_Value_rec = false;

                        ClearPlanes();
                        ROLLMODE_OFFSET = 601;
                        SetSwitches(1, -1);
					}
					
                    Display::DRAW_ALL_CURSOR();	
                        					
					UpdateTrigger(21);
						
					break;							
				}   */
			
				// Trigger Mode -> Reject
				case 12 :
				{
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

				    if ((MenuPopupActive > -1) && (MenuPopupActive != 12)) { Display::DRAWMENUPOPDOWN(); }
				
				    if (MenuPopupActive == 12)
					{
                       	if (MenuPopupStatus[12][0] == 3)	
						{
							MenuPopupStatus[12][0] = 2;
							MenuPopupStatus[12][1] = 3;
                            MenuStatus[12][2] = 98;
						}
                       	else if (MenuPopupStatus[12][1] == 3)	
						{
							MenuPopupStatus[12][0] = 3;
							MenuPopupStatus[12][1] = 2;
							MenuStatus[12][2] = 97;
						}

						New_Menu = 12;
                        Menu_Changed = 1;
                        MenuItemChanged[2] = 1;

                        //UpdateTrigger();    						
                    }

                    Display::DRAWMENUPOPUP(12);
					break;
				}

                // Edge -> External
				case 14 :
				{				
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 8)) { Display::DRAWMENUPOPDOWN(); }			

#ifdef _Debug_						
						printf("MPA1 %d SEE %d MPS[8][0] %d MPS[8][1] %d MPS[8][2] %d\n", MenuPopupActive, SelectedEdgeExtern, MenuPopupStatus[8][0], MenuPopupStatus[8][1], MenuPopupStatus[8][2]);
#endif	
					if (MenuStatus[14][2] == 0)
					{				
						MenuItemChanged[1] = 1;
						MenuStatus[14][1] = 0;
								
                        MenuItemChanged[2] = 1;								
						MenuStatus[14][2] = 1;
						
						MenuItemChanged[3] = 1;
						MenuStatus[14][3] = 0;						

						TriggerLevelChanged = 1;
						TriggerWayChanged = 1;	

                        if (MenuPopupStatus[8][0] == 3)
                        {					
                            Selected_Trigger_Source = 5;						
                            SelectedEdgeExtern = 0;             // External
                        }
                        else if (MenuPopupStatus[8][1] == 3)
                        {					
                            Selected_Trigger_Source = 5;						
                            SelectedEdgeExtern = 0;             // External
                        }
                        else if (MenuPopupStatus[8][1] == 3)
                        {					
                            Selected_Trigger_Source = 6;						
                            SelectedEdgeExtern = 1;             // External
                        }

						New_Menu = 14;
                        Menu_Changed = 1;

                        UpdateTrigger(9);

						Display::StatusUpdate();
						Display::DRAWMENUPOPUP(8);												
					}
					else
					{				
						if ((MenuPopupActive > -1) && (MenuPopupActive != 8)) { Display::DRAWMENUPOPDOWN(); }
						if (MenuPopupActive == 8)
						{
                        	if (MenuPopupStatus[8][0] == 3)	
							{
								SelectedEdgeExtern = 0;             // External LF
								Selected_Trigger_Source = 5;
								MenuPopupStatus[8][0] = 2;
								MenuPopupStatus[8][1] = 3;
								MenuPopupStatus[8][2] = 2;
							}
                        	else if (MenuPopupStatus[8][1] == 3)	
							{
								SelectedEdgeExtern = 1;             // External HF
								Selected_Trigger_Source = 6;
								MenuPopupStatus[8][0] = 2;
								MenuPopupStatus[8][1] = 2;
								MenuPopupStatus[8][2] = 3;
							}
                       	    else if (MenuPopupStatus[8][2] == 3)	
							{
								SelectedEdgeExtern = 0;             // Line
								Selected_Trigger_Source = 5;
								MenuPopupStatus[8][0] = 3;
								MenuPopupStatus[8][1] = 2;
								MenuPopupStatus[8][2] = 2;
							} 			
						}	
#ifdef _Debug_						
						printf("MPA2 %d SEE %d MPS[8][0] %d MPS[8][1] %d MPS[8][2] %d\n", MenuPopupActive, SelectedEdgeExtern, MenuPopupStatus[8][0], MenuPopupStatus[8][1], MenuPopupStatus[8][2]);
#endif															
						TriggerLevelChanged = 1;
						TriggerWayChanged = 1;					
						
						New_Menu = 14;
                        Menu_Changed = 1;

                        UpdateTrigger(10);

						Display::StatusUpdate();
						Display::DRAWMENUPOPUP(8);
					}
					break;
				}
			
				// Pulse Width -> Dir
				case 15 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					if (MenuStatus[15][2] == 2)
					{
						MenuStatus[15][2] = 1;
                        PulseToggle = 2;					
					}
					else if (MenuStatus[15][2] == 1)
					{
						MenuStatus[15][2] = 3;
                        PulseToggle = 1;			
					}
					else
					{
						MenuStatus[15][2] = 2;
						PulseToggle = 1;
					}
#ifdef _Debug_					
					printf("PW MS[15/2] %d PT %d\n", MenuStatus[15][2], PulseToggle);
#endif					
					MenuItemChanged[3] = 1;
					MenuItemChanged[4] = 1;
					MenuItemChanged[5] = 1;					
					MenuStatusChanged = 1;
					TriggerWayChanged = 1;
				
					New_Menu = 15;
                    Menu_Changed = 1;

					Display::StatusUpdate();
					UpdateTrigger(11);

					break;	
				}		
			
				// Cursor -> X2		
				case 16 :
				{
				    if (Cursor_Enabled == 0) break;
				
				    {
                        if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                        if (Cursor_Vertical_Active_Old == 1) MenuItemChanged[1] = 1;
                        else if (Cursor_Vertical_Active_Old == 4) MenuItemChanged[5] = 1;
                        else if (Cursor_Horizontal_Active_Old == 1) MenuItemChanged[3] = 1;
                        else if (Cursor_Horizontal_Active_Old == 2) MenuItemChanged[4] = 1;
                        else if (Cursor_Horizontal_Active_Old == 4) MenuItemChanged[5] = 1;

                        Cursor_Vertical_Active = 2;
                        Cursor_Horizontal_Active = 3;

                        Display::CALCCURSORDATA();
						
                        New_Menu = 16;
                        Menu_Changed = 1;

                        Display::DRAW_ALL_CURSOR();
                    }
					break;		
				}
				
				// Quick Print -> Save to JPEG
				case 17 :
				{	
                    if (USB_Connected == false) break;
                    	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    //if (MenuStatus[17][2] == 143) MenuStatus[17][2] = 144;
                    //else MenuStatus[17][2] = 143;

                    MenuItemChanged[2] = 1;
									
					New_Menu = 17;
                    Menu_Changed = 1;

	
                    if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
                    {					
                        send_buffer[0] = 150;						// Command Quick Print requested
                        send_buffer[1] = 2;                         // JPEG
                        send_buffer[2] = 0;
					
                        SendData(send_buffer);					
                    }
									
					break;					
				}					
			
				// About Oscilloscope
				case 18 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
	//P				Display::PopUp(3);
					break;
				}	

				// Quick Measurement -> Add Measurement
				case 19 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				
					
                    QM_Type_Old[0] = QM_Type[0];
                    QM_Type_Old[1] = QM_Type[1];
                    QM_Type_Old[2] = QM_Type[2];

                    if (QM_Type[0] == 0)
                    {
                        QM_Type[0] = MenuStatus[19][1] - 51;
                        QM_Changed[0] = 1;
                        QM_Channel[0] = MenuStatus[19][0] - 26;
                    }
                    else if (QM_Type[1] == 0)
                    {
                        if ((QM_Type[0] != (MenuStatus[19][1] - 51)) || (QM_Channel[0] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[1] = MenuStatus[19][1] - 51;
                            QM_Changed[1] = 1;
                            QM_Channel[1] = MenuStatus[19][0] - 26;
                        }
                    }
                    else if (QM_Type[2] == 0)
                    {
                        if ((QM_Type[1] != (MenuStatus[19][1] - 51)) || (QM_Channel[1] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[2] = MenuStatus[19][1] - 51;
                            QM_Changed[2] = 1;
                            QM_Channel[2] = MenuStatus[19][0] - 26;
                        }
                    }
                    else
                    {
                        if ((QM_Type[2] != (MenuStatus[19][1] - 51)) || (QM_Channel[2] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[0] = QM_Type[1];
                            QM_Type[1] = QM_Type[2];
                            QM_Type[2] = MenuStatus[19][1] - 51;

                            QM_Channel[0] = QM_Channel[1];
                            QM_Channel[1] = QM_Channel[2];
                            QM_Channel[2] = MenuStatus[19][0] - 26;

                            QM_Changed[0] = 1;
                            QM_Changed[1] = 1;
                            QM_Changed[2] = 1;
                        }
                    }

                    if (NumberOfChannels == 2)
                    {
                        if (QM_Channel[0] == 3) QM_Channel[0] = 5;
                        if (QM_Channel[1] == 3) QM_Channel[1] = 5;
                        if (QM_Channel[2] == 3) QM_Channel[2] = 5;
                    }

                    Quick_Measure_First_Draw = 1;

					New_Menu = 19;
                    Menu_Changed = 1;
#ifdef _Debug_
                    if (Debug_Mode) printf("QT1 : %d QT2 : %d QT3 : %d MS19,1 : %d\n", QM_Type[0], QM_Type[1], QM_Type[2], MenuStatus[19][1]);
#endif
                    //QM_Vertical_Active = 0;
                    //QM_Horizontal_Active = 0;

                    Display::CALCQMDATA();

					break;
                }
                					
				// Quick Measurement Delay Settings
				case 20 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if ((MenuPopupActive > -1) && (MenuPopupActive != 6)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 6)
					{
						pos = -1;
						MenuPopupStep(6, &MenuStatus[20][2], &pos, &pos, 20, 27, 2);
						
                        New_Menu = 20;
                        Menu_Changed = 1;
					}				
						
					Display::DRAWMENUPOPUP(6);
					break;
				}	
				
				// Quick Measurement Phase Settings
				case 21 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if ((MenuPopupActive > -1) && (MenuPopupActive != 25)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 25)
					{
						pos = -1;
						MenuPopupStep(25, &MenuStatus[21][2], &pos, &pos, 21, 27, 2);
						
                        New_Menu = 21;
                        Menu_Changed = 1;
					}				
						
					Display::DRAWMENUPOPUP(25);
					break;
				}

				// Quick Measurement Threshold -> Lower
				case 22 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    if (Quick_Measure_Threshold_btn_select == 2) MenuItemChanged[3] = 1;
                    else if (Quick_Measure_Threshold_btn_select == 3) MenuItemChanged[4] = 1;

					Quick_Measure_Threshold_btn_select = 1;

                    New_Menu = 22;
                    Menu_Changed = 1;

					break;
				}                	                			

				// Trigger Mode TV
				case 24 :
				{
					if ((MenuPopupActive > -1) && (MenuPopupActive != 21)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 21)
					{
						pos = -1;
						MenuPopupStep(21, &MenuStatus[24][2], &pos, &pos, 24, 114, 2);
						
						New_Menu = 24;
                        Menu_Changed = 1;
					}				
					
					Display::DRAWMENUPOPUP(21);	
					break;
				}

				// Math - 1 * 2
				case 26 :
				{	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[26][2] == 0)
					{
						if (MenuStatus[26][1] == 1)
						{
							MenuItemChanged[1] = 1;
							MenuStatus[26][1] = 0;
						}
						
						else if (MenuStatus[26][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[26][3] = 0;
						}
						
						else if (MenuStatus[26][4] == 1)
						{
							MenuItemChanged[4] = 1;
							MenuStatus[26][4] = 0;
						}
																
						MenuStatus[26][2] = 1;

						New_Menu = 26;
                        Menu_Changed = 1;
					}
						
					break;
				}
				
				/*
				// FFT - Settings - Offset
				case 27 :
				{					
                    if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
                    				
				    FFTToggle = 1;
				
					MenuItemChanged[1] = 1;
					MenuItemChanged[2] = 1;					

                    New_Menu = 27;
                    Menu_Changed = 1;                    	

					break;
				}  */

            }
#ifdef _Debug_						
			if (Debug_Mode) printf("Function Button 3\n");
#endif
			break;
		}
		
		// Function Button 4
		case 33 :
		{
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();
			
            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            //if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;
            			
            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird
            			
			MenuButtonCheck(3);
			
			switch(Active_Menu)
			{				
				// Display -> Grid
				case 5 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[5][3] == 240) MenuStatus[5][3] = 241;
					else MenuStatus[5][3] = 240;
					
					if (Continius == false)
                    {
                        DrawSignals_Needed = 1;
                        UserIface_active = 0;
                    }
					
					New_Menu = 5;
                    Menu_Changed = 1;
					break;
				}	
			
				// Service - RS-232 Setup
				case 7 :
				{	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }	
					
                    New_Menu = 21;
                    Menu_Changed = 1;

					break;
				}	

                // Save / Recall
				case 8 :
				{
				    Set_Vars_Default();    			
				
				    UpdateChannel(1, 1);
				    UpdateChannel(2, 1);
				
				    VoltageChangedCh1 = 1;
				    VoltageChangedCh2 = 1;				
				
				    LED_ON[0] = 1;
				    LED_ON[1] = 1; 				
                    LED_ON[5] = 1;
                    LED_ON[6] = 0;

                    Rotary_Steps = 0;
                    ON_Zero_Channel_1();
                    Rotary_Steps = 0;
                    ON_Zero_Channel_2();

                    SetSwitches(1, Selected_Voltage_CH1);
                    SetSwitches(2, Selected_Voltage_CH2);

                    if (NumberOfChannels > 2)
                    {
                        UpdateChannel(3, 1);
                        UpdateChannel(4, 1);

				        VoltageChangedCh3 = 1;
				        VoltageChangedCh4 = 1;
				
				        LED_ON[2] = 1;
				        LED_ON[3] = 1;
				
				        Rotary_Steps = 0;
                        ON_Zero_Channel_3();
                        Rotary_Steps = 0;
                        ON_Zero_Channel_4();

                        SetSwitches(3, Selected_Voltage_CH3);
                        SetSwitches(4, Selected_Voltage_CH4);

                    }
                    else
                    {
                        UpdateChannel(3, 0);
                        UpdateChannel(4, 0);
                    }                 					

                    TriggerLevelChanged = 1;
                    TriggerModeChanged = 1;	
                    TriggerWayChanged = 1;
                    TimebaseChanged = 1;
                    TimeOffsetChanged = 1;
                    MenuStatusChanged = 1;
                    MenuAktive = 1;

				    Cursor_Data_First_Draw = 0;
				    Quick_Measure_First_Draw = 0;   				    	

				    UpdateTrigger(12);
				    Display::CALCPRETRIGGER();
				    Display::DRAW_ALL_CURSOR();
				
                    // remove the cursor data
				    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }				

                    Display::DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnDraw);							// Button
                    Display::TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text

                    Display::DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnDraw);						// Button
                    Display::TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);									// Draw Voltage Text

				    Display::StatusUpdate();

                    if (NumberOfChannels > 2)
                    {
                        Display::DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button
                        Display::TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);								// Draw Voltage Text

                        Display::DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button		
                        Display::TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);								// Draw Voltage Text
                    }
                    				
				    Display::DRAWSTATUS(6, 0);
				
				    Send_LED();
			    	config_changed = true;  		// TMW changed (added save paramter on default)
					AMDFlash::Write_Config_Flash();	// TMW changed (added save paramter on default)
			    			
					break;
				}	
			
			/* is moved up
				// Timebase-> X-Y Mode
				case 10 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[10][3] == 0)
					{
						if (MenuStatus[10][0] == 1)
						{
							MenuItemChanged[0] = 1;
							MenuStatus[10][0] = 0;
						}
                        else if (MenuStatus[10][1] == 1)
                        {				
                            for (ix = 380; ix < 8120; ix++) //400
                            {
                                Grid_Plane[ix] = *(Grid_Plane_Flash + ix);

                                if (tc_hw_version < 0x4c7) {if ((ix % 20) == 0) Grid_Plane[ix] = Grid_Plane[ix] << 2;} // Gap
                            }
							MenuItemChanged[1] = 1;
							MenuStatus[10][1] = 0;
							
                            GridColor_Val = GridColorArray[GridColorArrayPos];
                            SetupADC();
						
                            MenuStatus[5][2] = GridColorArrayPos + 133;									
                        }
						else if (MenuStatus[10][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[10][2] = 0;
						}
						
                        if (QM_Enabled)
                        {
                            QM_Enabled_Old = QM_Enabled;
                            QM_Enabled = false;
                            Quick_Measure_First_Draw = 0;
                            MenuStatusChanged = 1;

                            // remove the cursor data
                            for (ix = 408 * 20; ix < 430 * 20; ix++)
                            {
                                *(UI_Plane1 + ix) = 0;	// delete
                                *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                                *(UI_Plane4 + ix) = 0;	// delete
                                *(UI_Plane5 + ix) = 0;	// delete
                            }

                            LED_ON[7] = 0;
				
                            //New_Menu = 19;
                            Menu_Changed = 1;
                            //MenuAktive = 0;
				
                            Display::CALCQMDATA();
                        }

						Virtual_ZeroLevelCH1 = 0;
						ON_Zero_Channel_1();
						Virtual_ZeroLevelCH2 = 0;
						ON_Zero_Channel_2();
                        						
						Display::GRIDXY(80, 20, Grid_Plane);

						MenuStatus[10][3] = 1;

						New_Menu = 10;
                        Menu_Changed = 1;
                        Display_Mode = 1;
                        Display::DRAWSTATUS(0, 1);
                        ClearPlanes();
					}
                    Display::DRAW_ALL_CURSOR();
                        						
					break;							
				}*/		
					
				// Trigger Mode  -> Holdoff
				case 12 :
				{
				    if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }	
				
					if (EdgeToggle == 0)
					{		
                        buf_int = (int) (HoldOff.Read_Value() * 100000000);	

                        printf("HF bi : %d\n", buf_int);
				
                        if (Rotary_Direction_mem_pulse == 1)
                        {	
                            if (buf_int == 0)
                            {
                                HoldOff.Write_Value(0.000000040);

                                HoldOff_Value = 120;
                                HoldOff_Steps = 40;
                                HoldOff_Expo = 1;
                            }
                            else if ((buf_int >= 1) && (buf_int < 100))
                            {
                                HoldOff.Write_Value(0.000001);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }
                            else if ((buf_int >= 100) && (buf_int < 1000))
                            {
                                HoldOff.Write_Value(0.00001);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }
                            else if ((buf_int >= 1000) && (buf_int < 10000))
                            {
                                HoldOff.Write_Value(0.0001);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }
                            else if ((buf_int >= 10000) && (buf_int < 100000))
                            {
                                HoldOff.Write_Value(0.001);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int >= 100000) && (buf_int < 1000000))
                            {
                                HoldOff.Write_Value(0.01);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int >= 1000000) && (buf_int < 10000000))
                            {
                                HoldOff.Write_Value(0.1);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int >= 10000000) && (buf_int < 100000000))
                            {
                                HoldOff.Write_Value(1);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else if ((buf_int >= 100000000) && (buf_int < 1000000000))
                            {
                                HoldOff.Write_Value(10);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else if ((((int) (HoldOff.Read_Value() * 1000000)) >= 10000000) && (((int) (HoldOff.Read_Value() * 1000000)) < 100000000))
                            {
                                HoldOff.Write_Value(100);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else
                            {
                                HoldOff.Write_Value(0);

                                HoldOff_Value = 0;
                                HoldOff_Steps = 40;
                                HoldOff_Expo = 1;
                            }
                        }
                        else 	                 		
                        {
                            if (buf_int == 0)
                            {
                                HoldOff.Write_Value(100);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else if (buf_int == 4)
                            {
                                HoldOff.Write_Value(0);

                                HoldOff_Value = 0;
                                HoldOff_Steps = 40;
                                HoldOff_Expo = 1;
                            }
                            else if (buf_int == 12)
                            {
                                HoldOff.Write_Value(0.000000040);

                                HoldOff_Value = 40;
                                HoldOff_Steps = 40;
                                HoldOff_Expo = 1;
                            }
                            else if ((buf_int > 10) && (buf_int <= 100))
                            {
                                HoldOff.Write_Value(0.000000120);

                                HoldOff_Value = 120;
                                HoldOff_Steps = 40;
                                HoldOff_Expo = 1;
                            }
                            else if ((buf_int > 100) && (buf_int <= 1000))
                            {
                                HoldOff.Write_Value(0.000001);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }
                            else if ((buf_int > 1000) && (buf_int <= 10000))
                            {
                                HoldOff.Write_Value(0.00001);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }
                            else if ((buf_int > 10000) && (buf_int <= 100000))
                            {
                                HoldOff.Write_Value(0.0001);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 2;
                            }

                            else if ((buf_int > 100000) && (buf_int <= 1000000))
                            {
                                HoldOff.Write_Value(0.001);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int > 1000000) && (buf_int <= 10000000))
                            {
                                HoldOff.Write_Value(0.01);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int > 10000000) && (buf_int <= 100000000))
                            {
                                HoldOff.Write_Value(0.1);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                            else if ((buf_int > 100000000) && (buf_int <= 1000000000))
                            {
                                HoldOff.Write_Value(1);

                                HoldOff_Value = 1;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else if ((((int) (HoldOff.Read_Value() * 1000000)) > 10000000) && (((int) (HoldOff.Read_Value() * 1000000)) <= 100000000))
                            {
                                HoldOff.Write_Value(10);

                                HoldOff_Value = 10;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 4;
                            }
                            else
                            {
                                HoldOff.Write_Value(0.1);

                                HoldOff_Value = 100;
                                HoldOff_Steps = 1;
                                HoldOff_Expo = 3;
                            }
                        }

                            /*




				        buf_int = (int) (HoldOff.Read_Value() * 10000000);			

				        if ((HoldOff.Read_Value() * 100000000) == 0)
                        {
                            HoldOff.Write_Value(0.00000004);

                            HoldOff_Value = 40;
                            HoldOff_Steps = 40;
                            HoldOff_Expo = 1;
                        }				
				        else if ((HoldOff.Read_Value() * 100000000) < 10)//if ((buf_int > 0) && (buf_int < 1))
                        {
                            HoldOff.Write_Value(0.0000001);
                            //HoldOff.Write_StepSize(0.000000001);

                            HoldOff_Value = 100;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 1;
                        }
				        else if ((buf_int >= 1) && (buf_int < 10))
                        {
                            HoldOff.Write_Value(0.000001);
                            //HoldOff.Write_StepSize(0.00000001);

                            HoldOff_Value = 1;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 2;
                        }
				        else if ((buf_int >= 10) && (buf_int < 100))
                        {
                            HoldOff.Write_Value(0.00001);
                            //HoldOff.Write_StepSize(0.0000001);

                            HoldOff_Value = 10;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 2;
                        }
				        else if ((buf_int >= 100) && (buf_int < 1000))
                        {
                            HoldOff.Write_Value(0.0001);
                            //HoldOff.Write_StepSize(0.000001);

                            HoldOff_Value = 100;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 2;
                        }
				        else if ((buf_int >= 1000) && (buf_int < 10000))
                        {
                            HoldOff.Write_Value(0.001);
                            //HoldOff.Write_StepSize(0.00001);

                            HoldOff_Value = 1;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 3;
                        }
				        else if ((buf_int >= 10000) && (buf_int < 100000))
                        {
                            HoldOff.Write_Value(0.01);
                            //HoldOff.Write_StepSize(0.0001);

                            HoldOff_Value = 10;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 3;
                        }
				        else if ((buf_int >= 100000) && (buf_int < 1000000))
                        {
                            HoldOff.Write_Value(0.1);
                            //HoldOff.Write_StepSize(0.001);

                            HoldOff_Value = 100;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 3;
                        }
				        else if ((buf_int >= 1000000) && (buf_int < 10000000))
                        {
                            HoldOff.Write_Value(1);
                            //HoldOff.Write_StepSize(0.01);

                            HoldOff_Value = 1;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 4;
                        }
				        else if ((buf_int >= 10000000) && (buf_int < 100000000))
                        {
                            HoldOff.Write_Value(10);
                            //HoldOff.Write_StepSize(0.1);

                            HoldOff_Value = 10;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 4;
                        }
				        else if ((buf_int >= 100000000) && (buf_int < 300000000))
                        {
                            HoldOff.Write_Value(100);
                            //HoldOff.Write_StepSize(1);

                            HoldOff_Value = 100;
                            HoldOff_Steps = 1;
                            HoldOff_Expo = 4;
                        }
				        else
                        {
                            HoldOff.Write_Value(0.000000000);
                            //HoldOff.Write_StepSize(0.00000004);

                            HoldOff_Value = 0;
                            HoldOff_Steps = 40;
                            HoldOff_Expo = 1;
                        } 	*/		
				
				        HoldOff.RenderText();				
                    }
				
					EdgeToggle = 0;
                    New_Menu = 12;
                    Menu_Changed = 1;
                    MenuItemChanged[3] = 1;
                    MenuItemChanged[4] = 1;

                    UpdateTrigger(13);


					break;
				}	

                // Edge -> TV
				case 14 :
				{	
					Menu_Popup_visible =1; // TMW added to repair multiple records after menu popup

					if ((MenuPopupActive > -1) && (MenuPopupActive != 11)) { Display::DRAWMENUPOPDOWN(); }			

					if (MenuStatus[14][3] == 0)
					{				
						MenuItemChanged[1] = 1;
						MenuStatus[14][1] = 0;
								
                        MenuItemChanged[2] = 1;								
						MenuStatus[14][2] = 0;
						
						MenuItemChanged[3] = 1;
						MenuStatus[14][3] = 1;						
						
						New_Menu = 14;
                        Menu_Changed = 1;

											
					}
					else
					{
						if (MenuPopupActive == 11)
						{
                            if (MenuPopupStatus[11][0] == 3)	
                            {
                                MenuPopupStatus[11][0] = 2;
                                MenuPopupStatus[11][1] = 3;
                            }
                            else
                            {
                                MenuPopupStatus[11][0] = 3;
                                MenuPopupStatus[11][1] = 2;
                            }
                        }
					}
					
					TriggerLevelChanged = 1;
					TriggerWayChanged = 1;						
					Selected_Trigger_Source = 6;
					SelectedEdgeExtern = 2;               // TV CH 1					

                    Display::StatusUpdate();
						
                    UpdateTrigger(14);                      					
					
					Display::DRAWMENUPOPUP(11);

                    break;
                }                	
			
				// Pulse Width
				case 15 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    if (MenuStatus[15][2] == 1) break;

					if (MenuStatus[15][2] == 3)
					{					
                        if (PulseToggle == 1)
                        {					
                            buf_int = (int) (Pulse11.Read_Value() * 100000000);	
				
                            if (Rotary_Direction_mem_pulse == 1)
                            {				
				                if ((buf_int >= 1) && (buf_int < 10))
                                {
                                    Pulse11.Write_Value(0.000000104);

                                    Pulse11_Value = 104;
                                    Pulse11_Steps = 8;
                                    Pulse11_Expo = 1;
                                }
    				            else if ((buf_int >= 10) && (buf_int < 100))
                                {
                                    Pulse11.Write_Value(0.000001);

                                    Pulse11_Value = 1;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }
				                else if ((buf_int >= 100) && (buf_int < 1000))
                                {
                                    Pulse11.Write_Value(0.00001);

                                    Pulse11_Value = 10;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }
				                else if ((buf_int >= 1000) && (buf_int < 10000))
                                {
                                    Pulse11.Write_Value(0.0001);

                                    Pulse11_Value = 100;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }

    				            else if ((buf_int >= 10000) && (buf_int < 100000))
                                {
                                    Pulse11.Write_Value(0.001);

                                    Pulse11_Value = 1;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else if ((buf_int >= 100000) && (buf_int < 1000000))
                                {
                                    Pulse11.Write_Value(0.01);

                                    Pulse11_Value = 10;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else if ((buf_int >= 1000000) && (buf_int < 10000000))
                                {
                                    Pulse11.Write_Value(0.1);

                                    Pulse11_Value = 100;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else
                                {
                                    Pulse11.Write_Value(0.000000016);

                                    Pulse11_Value = 16;
                                    Pulse11_Steps = 8;
                                    Pulse11_Expo = 1;
                                }
                            }
                            else 	                 		
                            {
				                if (buf_int == 1)
                                {
                                    Pulse11.Write_Value(0.1);

                                    Pulse11_Value = 100;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else if (buf_int == 10)
                                {
                                    Pulse11.Write_Value(0.000000016);

                                    Pulse11_Value = 16;
                                    Pulse11_Steps = 8;
                                    Pulse11_Expo = 1;
                                }
				                else if ((buf_int > 10) && (buf_int <= 100))
                                {
                                    Pulse11.Write_Value(0.000000104);

                                    Pulse11_Value = 104;
                                    Pulse11_Steps = 8;
                                    Pulse11_Expo = 1;
                                }
    				            else if ((buf_int > 100) && (buf_int <= 1000))
                                {
                                    Pulse11.Write_Value(0.000001);

                                    Pulse11_Value = 1;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }
				                else if ((buf_int > 1000) && (buf_int <= 10000))
                                {
                                    Pulse11.Write_Value(0.00001);

                                    Pulse11_Value = 10;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }
				                else if ((buf_int > 10000) && (buf_int <= 100000))
                                {
                                    Pulse11.Write_Value(0.0001);

                                    Pulse11_Value = 100;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 2;
                                }

    				            else if ((buf_int > 100000) && (buf_int <= 1000000))
                                {
                                    Pulse11.Write_Value(0.001);

                                    Pulse11_Value = 1;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else if ((buf_int > 1000000) && (buf_int <= 10000000))
                                {
                                    Pulse11.Write_Value(0.01);

                                    Pulse11_Value = 10;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
				                else
                                {
                                    Pulse11.Write_Value(0.1);

                                    Pulse11_Value = 100;
                                    Pulse11_Steps = 1;
                                    Pulse11_Expo = 3;
                                }
                            }					
				
    				        Pulse11.RenderText();
    				        trig_width_reg = (unsigned int) (Pulse11.Read_Value() / (float) 0.000000008);
                        }
                        else PulseToggle = 1;
                    }
                    else
                    {
                        if (PulseToggle == 1)
                        {					
                            buf_int = (int) (Pulse21.Read_Value() * 100000000);	
				
                            if (Rotary_Direction_mem_pulse == 1)
                            {				
				                if ((buf_int >= 1) && (buf_int < 10))
                                {
                                    Pulse21.Write_Value(0.000000104);

                                    Pulse21_Value = 104;
                                    Pulse21_Steps = 8;
                                    Pulse21_Expo = 1;
                                }
    				            else if ((buf_int >= 10) && (buf_int < 100))
                                {
                                    Pulse21.Write_Value(0.000001);

                                    Pulse21_Value = 1;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }
				                else if ((buf_int >= 100) && (buf_int < 1000))
                                {
                                    Pulse21.Write_Value(0.00001);

                                    Pulse21_Value = 10;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }
				                else if ((buf_int >= 1000) && (buf_int < 10000))
                                {
                                    Pulse21.Write_Value(0.0001);

                                    Pulse21_Value = 100;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }

    				            else if ((buf_int >= 10000) && (buf_int < 100000))
                                {
                                    Pulse21.Write_Value(0.001);

                                    Pulse21_Value = 1;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else if ((buf_int >= 100000) && (buf_int < 1000000))
                                {
                                    Pulse21.Write_Value(0.01);

                                    Pulse21_Value = 10;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else if ((buf_int >= 1000000) && (buf_int < 10000000))
                                {
                                    Pulse21.Write_Value(0.1);

                                    Pulse21_Value = 100;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else
                                {
                                    Pulse21.Write_Value(0.000000016);

                                    Pulse21_Value = 16;
                                    Pulse21_Steps = 8;
                                    Pulse21_Expo = 1;
                                }
                            }
                            else 	                 		
                            {
				                if (buf_int == 1)
                                {
                                    Pulse21.Write_Value(0.1);

                                    Pulse21_Value = 100;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else if (buf_int == 10)
                                {
                                    Pulse21.Write_Value(0.000000016);

                                    Pulse21_Value = 16;
                                    Pulse21_Steps = 8;
                                    Pulse21_Expo = 1;
                                }
				                else if ((buf_int > 10) && (buf_int <= 100))
                                {
                                    Pulse21.Write_Value(0.000000104);

                                    Pulse21_Value = 104;
                                    Pulse21_Steps = 8;
                                    Pulse21_Expo = 1;
                                }
    				            else if ((buf_int > 100) && (buf_int <= 1000))
                                {
                                    Pulse21.Write_Value(0.000001);

                                    Pulse21_Value = 1;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }
				                else if ((buf_int > 1000) && (buf_int <= 10000))
                                {
                                    Pulse21.Write_Value(0.00001);

                                    Pulse21_Value = 10;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }
				                else if ((buf_int > 10000) && (buf_int <= 100000))
                                {
                                    Pulse21.Write_Value(0.0001);

                                    Pulse21_Value = 100;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 2;
                                }

    				            else if ((buf_int > 100000) && (buf_int <= 1000000))
                                {
                                    Pulse21.Write_Value(0.001);

                                    Pulse21_Value = 1;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else if ((buf_int > 1000000) && (buf_int <= 10000000))
                                {
                                    Pulse21.Write_Value(0.01);

                                    Pulse21_Value = 10;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
				                else
                                {
                                    Pulse21.Write_Value(0.1);

                                    Pulse21_Value = 100;
                                    Pulse21_Steps = 1;
                                    Pulse21_Expo = 3;
                                }
                            }			
				
    				        Pulse21.RenderText();
    				        trig_width_reg = (unsigned int) ((Pulse21.Read_Value() / (float) 0.000000008));
                        }
                        else PulseToggle = 1;
                    }

					
                    MenuItemChanged[3] = 1;
                    MenuItemChanged[4] = 1;
                					
                    New_Menu = 15;
                    Menu_Changed = 1;
                    TriggerWayChanged = 1;
                    UpdateTrigger(27);

					Display::StatusUpdate();

					break;	
				}
		
				// Cursor -> Y1
				case 16 :
				{	
				    if (Cursor_Enabled == 0) break;
				    {
                        if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }		

                        if (Cursor_Vertical_Active_Old == 1) MenuItemChanged[1] = 1;
                        else if (Cursor_Vertical_Active_Old == 4) MenuItemChanged[5] = 1;
                        else if (Cursor_Vertical_Active_Old == 2) MenuItemChanged[2] = 1;
                        else if (Cursor_Horizontal_Active_Old == 2) MenuItemChanged[4] = 1;
                        else if (Cursor_Horizontal_Active_Old == 4) MenuItemChanged[5] = 1;

                        Cursor_Vertical_Active = 3;
                        Cursor_Horizontal_Active = 1; 			

                        Display::CALCCURSORDATA();
							
                        New_Menu = 16;
                        Menu_Changed = 1;

                        Display::DRAW_ALL_CURSOR();
                    }
					break;						
				}
				
				// Quick Print -> Save to XLS
				case 17 :
				{	
                    if (USB_Connected == false) break;
                    	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    //if (MenuStatus[17][2] == 143) MenuStatus[17][2] = 144;
                    //else MenuStatus[17][2] = 143;

                    MenuItemChanged[3] = 1;
									
					New_Menu = 17;
                    Menu_Changed = 1;

	
                    if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
                    {					
                        send_buffer[0] = 150;						// Command Quick Print requested
                        send_buffer[1] = 3;                         // XLS
                        send_buffer[2] = 0;
					
                        SendData(send_buffer);					
                    }
									
					break;					
				}				

				// Quick Measurement -> Clear
				case 19 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				
				
                    QM_Type_Old[0] = QM_Type[0];
                    QM_Type_Old[1] = QM_Type[1];
                    QM_Type_Old[2] = QM_Type[2];				
				
                    QM_Type[0] = 0;
                    QM_Type[1] = 0;
                    QM_Type[2] = 0;

                    QM_Channel[0] = MenuStatus[19][0] - 26;
                    QM_Channel[1] = MenuStatus[19][0] - 26;
                    QM_Channel[2] = MenuStatus[19][0] - 26;

                    QM_Changed[0] = 0;
                    QM_Changed[1] = 0;
                    QM_Changed[2] = 0;

                    Quick_Measure_First_Draw = 1;

					New_Menu = 19;
                    Menu_Changed = 1;

                    QM_Vertical_Active = 0;
                    QM_Horizontal_Active = 0;

                    Display::CALCQMDATA();

					break;
				}
                			
				// Quick Measurement Settings
				case 20 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				
					if (MenuStatus[20][3] == 2) MenuStatus[20][3] = 3;
					else MenuStatus[20][3] = 2;
				
					New_Menu = 20;
                    Menu_Changed = 1;

					break;
				}	

				// Quick Measurement Threshold -> Middle
				case 22 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
                    if (Quick_Measure_Threshold_btn_select == 1) MenuItemChanged[2] = 1;
                    else if (Quick_Measure_Threshold_btn_select == 3) MenuItemChanged[4] = 1;
                    					
					Quick_Measure_Threshold_btn_select = 2;
					
                    New_Menu = 22;
                    Menu_Changed = 1;

					break;
				}      				
			
				// Trigger Mode TV
				case 24 :
				{
					if ((MenuPopupActive > -1) && (MenuPopupActive != 22)) { Display::DRAWMENUPOPDOWN(); }
					if (MenuPopupActive == 22)
					{
						pos = -1;
						MenuPopupStep(22, &MenuStatus[24][3], &pos, &pos, 24, 119, 2);
						
                        New_Menu = 24;
                        Menu_Changed = 1;
					}				
					
					Display::DRAWMENUPOPUP(22);	
					break;
				}		

				// Math
				case 26 :
				{	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[26][3] == 0)
					{
						if (MenuStatus[26][1] == 1)
						{
							MenuItemChanged[1] = 1;
							MenuStatus[26][1] = 0;
						}
						
						else if (MenuStatus[26][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[26][2] = 0;
						}
						
						else if (MenuStatus[26][4] == 1)
						{
							MenuItemChanged[4] = 1;
							MenuStatus[26][4] = 0;
						}
																
						MenuStatus[26][3] = 1;

						New_Menu = 26;
                        Menu_Changed = 1;
					}
						
					break;
				}	
				
			}	
#ifdef _Debug_		
			if (Debug_Mode) printf("Function Button 4\n");		
#endif
			break;
		}
		
		// Function Button 5
		case 34 :
		{
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();
			
            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            //if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;
            			
            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird
            			
			MenuButtonCheck(4);
			
			switch(Active_Menu)
			{
                // Display / Browse
				case 5 :
				{
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    if (MenuStatus[5][4] == 241) MenuStatus[5][4] = 240;
                    else MenuStatus[5][4] = 241;

                    if (MenuStatus[5][4] == 241) Display::DRAWMEMORY(0, 1, 1);
                    else
                    {
                        Display::DRAWMEMORY(1, 0, 0);			
                        Display::DRAW_ALL_CURSOR();
                    }

					New_Menu = 5;
                    Menu_Changed = 1;				

					break;
				}			
			
				//  Save / Recall - > Clear Display
				case 8 :
				{		
                    if ((Continius == false) || (MenuStatus[5][0] == 241)) ClearPlanes();	
                    break;	
                }				


				case 10 :
				{

					break;
				}
				
				// Trigger Mode  -> Probe
				case 12 :
				{
					EdgeToggle = 1;
                    New_Menu = 12;
                    Menu_Changed = 1;
                    MenuItemChanged[3] = 1;
                    MenuItemChanged[4] = 1;

					break;
				}	
				
			
				// Pulse Width
				case 15 :
				{	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    if (MenuStatus[15][2] == 2) break;

					if (MenuStatus[15][2] == 3)
					{					
                        if (PulseToggle == 2)
                        {					
                            buf_int = (int) (Pulse12.Read_Value() * 100000000);	
				
                            if (Rotary_Direction_mem_pulse == 1)
                            {				
				                if ((buf_int >= 1) && (buf_int < 10))
                                {
                                    Pulse12.Write_Value(0.000000104);

                                    Pulse12_Value = 104;
                                    Pulse12_Steps = 8;
                                    Pulse12_Expo = 1;
                                }
    				            else if ((buf_int >= 10) && (buf_int < 100))
                                {
                                    Pulse12.Write_Value(0.000001);

                                    Pulse12_Value = 1;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }
				                else if ((buf_int >= 100) && (buf_int < 1000))
                                {
                                    Pulse12.Write_Value(0.00001);

                                    Pulse12_Value = 10;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }
				                else if ((buf_int >= 1000) && (buf_int < 10000))
                                {
                                    Pulse12.Write_Value(0.0001);

                                    Pulse12_Value = 100;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }

    				            else if ((buf_int >= 10000) && (buf_int < 100000))
                                {
                                    Pulse12.Write_Value(0.001);

                                    Pulse12_Value = 1;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else if ((buf_int >= 100000) && (buf_int < 1000000))
                                {
                                    Pulse12.Write_Value(0.01);

                                    Pulse12_Value = 10;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else if ((buf_int >= 1000000) && (buf_int < 10000000))
                                {
                                    Pulse12.Write_Value(0.1);

                                    Pulse12_Value = 100;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else
                                {
                                    Pulse12.Write_Value(0.000000016);

                                    Pulse12_Value = 16;
                                    Pulse12_Steps = 8;
                                    Pulse12_Expo = 1;
                                }
                            }
                            else 	                 		
                            {
				                if (buf_int == 1)
                                {
                                    Pulse12.Write_Value(0.1);

                                    Pulse12_Value = 100;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else if (buf_int == 10)
                                {
                                    Pulse12.Write_Value(0.000000016);

                                    Pulse12_Value = 16;
                                    Pulse12_Steps = 8;
                                    Pulse12_Expo = 1;
                                }
				                else if ((buf_int > 10) && (buf_int <= 100))
                                {
                                    Pulse12.Write_Value(0.000000104);

                                    Pulse12_Value = 104;
                                    Pulse12_Steps = 8;
                                    Pulse12_Expo = 1;
                                }
    				            else if ((buf_int > 100) && (buf_int <= 1000))
                                {
                                    Pulse12.Write_Value(0.000001);

                                    Pulse12_Value = 1;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }
				                else if ((buf_int > 1000) && (buf_int <= 10000))
                                {
                                    Pulse12.Write_Value(0.00001);

                                    Pulse12_Value = 10;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }
				                else if ((buf_int > 10000) && (buf_int <= 100000))
                                {
                                    Pulse12.Write_Value(0.0001);

                                    Pulse12_Value = 100;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 2;
                                }

    				            else if ((buf_int > 100000) && (buf_int <= 1000000))
                                {
                                    Pulse12.Write_Value(0.001);

                                    Pulse12_Value = 1;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else if ((buf_int > 1000000) && (buf_int <= 10000000))
                                {
                                    Pulse12.Write_Value(0.01);

                                    Pulse12_Value = 10;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
				                else
                                {
                                    Pulse12.Write_Value(0.1);

                                    Pulse12_Value = 100;
                                    Pulse12_Steps = 1;
                                    Pulse12_Expo = 3;
                                }
                            }

    				        Pulse12.RenderText();
    				        trig_range_reg = (unsigned int) (Pulse12.Read_Value() / (float) 0.000000008);
                        }
                        else PulseToggle = 2;
                    }
                    else
                    {
                        if (PulseToggle == 2)
                        {					
                            buf_int = (int) (Pulse22.Read_Value() * 100000000);	
				
                            if (Rotary_Direction_mem_pulse == 1)
                            {				
				                if ((buf_int >= 1) && (buf_int < 10))
                                {
                                    Pulse22.Write_Value(0.000000104);

                                    Pulse22_Value = 104;
                                    Pulse22_Steps = 8;
                                    Pulse22_Expo = 1;
                                }
    				            else if ((buf_int >= 10) && (buf_int < 100))
                                {
                                    Pulse22.Write_Value(0.000001);

                                    Pulse22_Value = 1;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }
				                else if ((buf_int >= 100) && (buf_int < 1000))
                                {
                                    Pulse22.Write_Value(0.00001);

                                    Pulse22_Value = 10;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }
				                else if ((buf_int >= 1000) && (buf_int < 10000))
                                {
                                    Pulse22.Write_Value(0.0001);

                                    Pulse22_Value = 100;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }

    				            else if ((buf_int >= 10000) && (buf_int < 100000))
                                {
                                    Pulse22.Write_Value(0.001);

                                    Pulse22_Value = 1;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else if ((buf_int >= 100000) && (buf_int < 1000000))
                                {
                                    Pulse22.Write_Value(0.01);

                                    Pulse22_Value = 10;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else if ((buf_int >= 1000000) && (buf_int < 10000000))
                                {
                                    Pulse22.Write_Value(0.1);

                                    Pulse22_Value = 100;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else
                                {
                                    Pulse22.Write_Value(0.000000016);

                                    Pulse22_Value = 16;
                                    Pulse22_Steps = 8;
                                    Pulse22_Expo = 1;
                                }
                            }
                            else 	                 		
                            {
				                if (buf_int == 1)
                                {
                                    Pulse22.Write_Value(0.1);

                                    Pulse22_Value = 100;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else if (buf_int == 10)
                                {
                                    Pulse22.Write_Value(0.000000016);

                                    Pulse22_Value = 16;
                                    Pulse22_Steps = 8;
                                    Pulse22_Expo = 1;
                                }
				                else if ((buf_int > 10) && (buf_int <= 100))
                                {
                                    Pulse22.Write_Value(0.000000104);

                                    Pulse22_Value = 104;
                                    Pulse22_Steps = 8;
                                    Pulse22_Expo = 1;
                                }
    				            else if ((buf_int > 100) && (buf_int <= 1000))
                                {
                                    Pulse22.Write_Value(0.000001);

                                    Pulse22_Value = 1;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }
				                else if ((buf_int > 1000) && (buf_int <= 10000))
                                {
                                    Pulse22.Write_Value(0.00001);

                                    Pulse22_Value = 10;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }
				                else if ((buf_int > 10000) && (buf_int <= 100000))
                                {
                                    Pulse22.Write_Value(0.0001);

                                    Pulse22_Value = 100;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 2;
                                }

    				            else if ((buf_int > 100000) && (buf_int <= 1000000))
                                {
                                    Pulse22.Write_Value(0.001);

                                    Pulse22_Value = 1;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else if ((buf_int > 1000000) && (buf_int <= 10000000))
                                {
                                    Pulse22.Write_Value(0.01);

                                    Pulse22_Value = 10;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
				                else
                                {
                                    Pulse22.Write_Value(0.1);

                                    Pulse22_Value = 100;
                                    Pulse22_Steps = 1;
                                    Pulse22_Expo = 3;
                                }
                            }		
				
    				        Pulse22.RenderText();
    				        trig_width_reg = (unsigned int) ((Pulse22.Read_Value() / (float) 0.000000008));
                        }
                        else PulseToggle = 2;
                    }

					
                    MenuItemChanged[3] = 1;
                    MenuItemChanged[4] = 1;
                					
                    New_Menu = 15;
                    Menu_Changed = 1;
                    TriggerWayChanged = 1;

                    UpdateTrigger(31);

					Display::StatusUpdate();

					break;	
				}	
			
				// Cursor -> Y2
				case 16 :
				{		
				    if (Cursor_Enabled == 0) break;
				    {
                        if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                        if (Cursor_Vertical_Active_Old == 1) MenuItemChanged[1] = 1;
                        else if (Cursor_Vertical_Active_Old == 2) MenuItemChanged[2] = 1;					
                        else if (Cursor_Vertical_Active_Old == 4) MenuItemChanged[5] = 1;
                        else if (Cursor_Horizontal_Active_Old == 1) MenuItemChanged[3] = 1;
                        else if (Cursor_Horizontal_Active_Old == 4) MenuItemChanged[5] = 1;

                        Cursor_Vertical_Active = 3;
                        Cursor_Horizontal_Active = 2;
				
                        Display::CALCCURSORDATA();
							
                        New_Menu = 16;
                        Menu_Changed = 1;

                        Display::DRAW_ALL_CURSOR();
                    }
					break;			
				}
				
				// Quick Print -> Print start XLS
				case 17 :
				{		/*
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                    //if (MenuStatus[17][2] == 143) MenuStatus[17][2] = 144;
                    //else MenuStatus[17][2] = 143;

                    //MenuItemChanged[4] = 1;
									
					New_Menu = 17;
                    Menu_Changed = 1;

	
                    if ((USB_Data_Requested == false) && (USB_Data_Trans == false))
                    {					
                        send_buffer[0] = 150;						// Command Quick Print requested
                        send_buffer[1] = 4;                         //
                        send_buffer[2] = 0;
					
                        SendData(send_buffer);					
                    }  */
									
					break;					
				}				
			
				// Quick Measurement -> Settings
				case 19 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
                    if ((MenuStatus[19][1] - 52) == 4)
                    {
                        New_Menu = 20;
                        Menu_Changed = 1;
                    }
                    if ((MenuStatus[19][1] - 52) == 13)
                    {
                        New_Menu = 21;
                        Menu_Changed = 1;
                    }

					break;
				}
				
				// Quick Measurement -> Add Measurement
				case 20 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				

                    QM_Type_Old[0] = QM_Type[0];
                    QM_Type_Old[1] = QM_Type[1];
                    QM_Type_Old[2] = QM_Type[2];

                    if (QM_Type[0] == 0)
                    {
                        QM_Type[0] = MenuStatus[19][1] - 51;
                        QM_Changed[0] = 1;
                        QM_Channel[0] = MenuStatus[19][0] - 26;
                    }
                    else if (QM_Type[1] == 0)
                    {
                        if ((QM_Type[0] != (MenuStatus[19][1] - 51)) || (QM_Channel[0] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[1] = MenuStatus[19][1] - 51;
                            QM_Changed[1] = 1;
                            QM_Channel[1] = MenuStatus[19][0] - 26;
                        }
                    }
                    else if (QM_Type[2] == 0)
                    {
                        if ((QM_Type[1] != (MenuStatus[19][1] - 51)) || (QM_Channel[1] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[2] = MenuStatus[19][1] - 51;
                            QM_Changed[2] = 1;
                            QM_Channel[2] = MenuStatus[19][0] - 26;
                        }
                    }
                    else
                    {
                        if ((QM_Type[2] != (MenuStatus[19][1] - 51)) || (QM_Channel[2] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[0] = QM_Type[1];
                            QM_Type[1] = QM_Type[2];
                            QM_Type[2] = MenuStatus[19][1] - 51;

                            QM_Channel[0] = QM_Channel[1];
                            QM_Channel[1] = QM_Channel[2];
                            QM_Channel[2] = MenuStatus[19][0] - 26;

                            QM_Changed[0] = 1;
                            QM_Changed[1] = 1;
                            QM_Changed[2] = 1;
                        }
                    }

                    Quick_Measure_First_Draw = 1;

					New_Menu = 20;
                    Menu_Changed = 1;

                    //QM_Vertical_Active = 0;
                    //QM_Horizontal_Active = 0;

                    Display::CALCQMDATA();

					break;
                }

				// Quick Measurement -> Add Measurement
				case 21 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }				

                    QM_Type_Old[0] = QM_Type[0];
                    QM_Type_Old[1] = QM_Type[1];
                    QM_Type_Old[2] = QM_Type[2];

                    if (QM_Type[0] == 0)
                    {
                        QM_Type[0] = MenuStatus[19][1] - 51;
                        QM_Changed[0] = 1;
                        QM_Channel[0] = MenuStatus[19][0] - 26;
                    }
                    else if (QM_Type[1] == 0)
                    {
                        if ((QM_Type[0] != (MenuStatus[19][1] - 51)) || (QM_Channel[0] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[1] = MenuStatus[19][1] - 51;
                            QM_Changed[1] = 1;
                            QM_Channel[1] = MenuStatus[19][0] - 26;
                        }
                    }
                    else if (QM_Type[2] == 0)
                    {
                        if ((QM_Type[1] != (MenuStatus[19][1] - 51)) || (QM_Channel[1] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[2] = MenuStatus[19][1] - 51;
                            QM_Changed[2] = 1;
                            QM_Channel[2] = MenuStatus[19][0] - 26;
                        }
                    }
                    else
                    {
                        if ((QM_Type[2] != (MenuStatus[19][1] - 51)) || (QM_Channel[2] != (MenuStatus[19][0] - 26)))
                        {
                            QM_Type[0] = QM_Type[1];
                            QM_Type[1] = QM_Type[2];
                            QM_Type[2] = MenuStatus[19][1] - 51;

                            QM_Channel[0] = QM_Channel[1];
                            QM_Channel[1] = QM_Channel[2];
                            QM_Channel[2] = MenuStatus[19][0] - 26;

                            QM_Changed[0] = 1;
                            QM_Changed[1] = 1;
                            QM_Changed[2] = 1;
                        }
                    }

                    Quick_Measure_First_Draw = 1;

					New_Menu = 21;
                    Menu_Changed = 1;

                    //QM_Vertical_Active = 0;
                    //QM_Horizontal_Active = 0;

                    Display::CALCQMDATA();

					break;
                }

				// Quick Measurement Threshold -> Upper
				case 22 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
                    if (Quick_Measure_Threshold_btn_select == 1) MenuItemChanged[2] = 1;
                    else if (Quick_Measure_Threshold_btn_select == 2) MenuItemChanged[3] = 1;

					Quick_Measure_Threshold_btn_select = 3;
                    New_Menu = 22;
                    Menu_Changed = 1;

					break;
				}                                 				
			
				// Math
				case 26 :
				{	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					if (MenuStatus[26][4] == 0)
					{
						if (MenuStatus[26][1] == 1)
						{
							MenuItemChanged[1] = 1;
							MenuStatus[26][1] = 0;
						}
						
						else if (MenuStatus[26][2] == 1)
						{
							MenuItemChanged[2] = 1;
							MenuStatus[26][2] = 0;
						}
						
						else if (MenuStatus[26][3] == 1)
						{
							MenuItemChanged[3] = 1;
							MenuStatus[26][3] = 0;
						}
																
						MenuStatus[26][4] = 1;

						New_Menu = 26;
                        Menu_Changed = 1;
					}
						
					break;
				}	
			
				// FFT Settings
				case 27 :
				{				
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					New_Menu = 28;
                    Menu_Changed = 1;

					break;
				}
			}
#ifdef _Debug_		
			if (Debug_Mode) printf("Function Button 5\n");		
#endif			
			break;
		}
		
		// Function Button 6
		case 35 :
		{		
			if (MenuPopupActive > 0) ResetTimer();
//			if (ZeroPopupChanged > 0) ResetTimer();
						
            if ((Active_Menu == 1) && (Channel_1_Active == false)) break;
            if ((Active_Menu == 2) && (Channel_2_Active == false)) break;
            if ((Active_Menu == 3) && (Channel_3_Active == false)) break;
            if ((Active_Menu == 4) && (Channel_4_Active == false)) break;
            //if ((Active_Menu == 26) && (Channel_Math_Active == false)) break;
            						
            if ((Active_Menu == 16) && (Cursor_Enabled == false)) break;
            if ((Active_Menu == 19) && (QM_Enabled == false)) break;
            if ((Active_Menu == 20) && (QM_Enabled == false)) break;
            if ((Active_Menu == 21) && (QM_Enabled == false)) break;
            if ((Active_Menu == 22) && (QM_Enabled == false)) break;

            // Oberes kann raus wenn die folgende zeile in die einzelnen menus gesetz wird
            						
			MenuButtonCheck(5);
			
			switch(Active_Menu)
			{		              		
				// Cursor -> X1X2/Y1Y2
				case 16 :
				{		
				    if (Cursor_Enabled == 0) break;
				
				    {
                        if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }

                        if (Cursor_Vertical_Active_Old == 1) MenuItemChanged[1] = 1;
                        else if (Cursor_Vertical_Active_Old == 2) MenuItemChanged[2] = 1;
                        else if (Cursor_Horizontal_Active_Old == 1) MenuItemChanged[3] = 1;
                        else if (Cursor_Horizontal_Active_Old == 2) MenuItemChanged[4] = 1;

                        Cursor_Both_Selected_Old = Cursor_Both_Selected;

                        if ((Cursor_Vertical_Active == 4) || (Cursor_Horizontal_Active == 4))
                        {
                            if (Cursor_Both_Selected == 0)
                            {
                                Cursor_Both_Selected = 1;
                                Cursor_Vertical_Active = 3;
                                Cursor_Horizontal_Active = 4;
                            }
                            else
                            {
                                Cursor_Both_Selected = 0;
                                Cursor_Vertical_Active = 4;
                                Cursor_Horizontal_Active = 3;
                            }
                        }
                        else
                        {
                            if (Cursor_Both_Selected == 0)
                            {
                                Cursor_Vertical_Active = 4;
                                Cursor_Horizontal_Active = 3;
                            }
                            else
                            {
                                Cursor_Vertical_Active = 3;
                                Cursor_Horizontal_Active = 4;
                            }
                        }
				
                        Display::CALCCURSORDATA();
							
                        New_Menu = 16;
                        Menu_Changed = 1;

                        Display::DRAW_ALL_CURSOR();
					}
					break;			
				}                	
								
				// Quick Measurement -> Thresholds
				case 19 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }	
					
					New_Menu = 22;
                    Menu_Changed = 1;
					break;		
				}				
					
				// Quick Measurement Delay Settings
				case 20 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }	
					
					New_Menu = 19;
                    Menu_Changed = 1;
					break;		
				}
				
				// Quick Measurement Phase Settings
				case 21 :
				{	
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }	
					
					New_Menu = 19;
                    Menu_Changed = 1;
					break;		
				}				
				
				// Quick Measurement Thresholds
				case 22 :
				{		
				    //if (MenuStatus[10][2] == 1) break;
				
				    if (QM_Enabled == 0) break;
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					New_Menu = 19;
                    Menu_Changed = 1;
					break;
				}	
			
				// FFT settings
				case 27 :
				{	
                    //if (MenuStatus[10][2] == 1) break;
                    	
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					New_Menu = 26;
                    Menu_Changed = 1;
					break;	
				}		

				// More FFT settings
				case 28 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					New_Menu = 27;
                    Menu_Changed = 1;
					break;		
				}	
							
				// Math settings
				case 29 :
				{		
					if (MenuPopupActive > -1) { Display::DRAWMENUPOPDOWN(); }
					
					New_Menu = 26;
                    Menu_Changed = 1;
					break;		
				}		
						
				// TMW changed; added Setup Default Button in Edge Menu
				// Edge -> Default Setup
				case 14 :
				{
				    Set_Vars_Default();    			
				
				    UpdateChannel(1, 1);
				    UpdateChannel(2, 1);
				
				    VoltageChangedCh1 = 1;
				    VoltageChangedCh2 = 1;				
				
				    LED_ON[0] = 1;
				    LED_ON[1] = 1; 				
                    LED_ON[5] = 1;
                    LED_ON[6] = 0;

                    Rotary_Steps = 0;
                    ON_Zero_Channel_1();
                    Rotary_Steps = 0;
                    ON_Zero_Channel_2();

                    SetSwitches(1, Selected_Voltage_CH1);
                    SetSwitches(2, Selected_Voltage_CH2);

                    if (NumberOfChannels > 2)
                    {
                        UpdateChannel(3, 1);
                        UpdateChannel(4, 1);

				        VoltageChangedCh3 = 1;
				        VoltageChangedCh4 = 1;
				
				        LED_ON[2] = 1;
				        LED_ON[3] = 1;
				
				        Rotary_Steps = 0;
                        ON_Zero_Channel_3();
                        Rotary_Steps = 0;
                        ON_Zero_Channel_4();

                        SetSwitches(3, Selected_Voltage_CH3);
                        SetSwitches(4, Selected_Voltage_CH4);

                    }
                    else
                    {
                        UpdateChannel(3, 0);
                        UpdateChannel(4, 0);
                    }                 					

                    TriggerLevelChanged = 1;
                    TriggerModeChanged = 1;	
                    TriggerWayChanged = 1;
                    TimebaseChanged = 1;
                    TimeOffsetChanged = 1;
                    MenuStatusChanged = 1;
                    MenuAktive = 1;

				    Cursor_Data_First_Draw = 0;
				    Quick_Measure_First_Draw = 0;   				    	

				    UpdateTrigger(12);
				    Display::CALCPRETRIGGER();
				    Display::DRAW_ALL_CURSOR();
				
                    // remove the cursor data
				    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }				

                    Display::DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnDraw);							// Button
                    Display::TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text

                    Display::DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnDraw);						// Button
                    Display::TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);									// Draw Voltage Text

				    Display::StatusUpdate();

                    if (NumberOfChannels > 2)
                    {
                        Display::DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button
                        Display::TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);								// Draw Voltage Text

                        Display::DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button		
                        Display::TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);								// Draw Voltage Text
                    }
                    				
				    Display::DRAWSTATUS(6, 0);
				
				    Send_LED();
			    	config_changed = true;  		// TMW changed (added save paramter on default)
					AMDFlash::Write_Config_Flash();	// TMW changed (added save paramter on default)
		
					break;
				} // TMW change ends
			}			
#ifdef _Debug_		
			if (Debug_Mode) printf("Function Button 6\n");
#endif			
			break;
		}

        // Run / Stop Button
		case 37 :
		{	
            if (Continius == 1)
            {
                Continius = 0;
                UserIface_active = 0;

                // Run/Stop to red
                LED_ON[12] = 0;
                LED_ON[13] = 1;

                LED_ON[14] = 0;
                LED_ON[15] = 0;


                SIGNAL_StartFr_idx = SIGNALFaktor_idx;
                Selected_Voltage_CH1_Old = Selected_Voltage_CH1;
                Selected_Voltage_CH2_Old = Selected_Voltage_CH2;
                Selected_Voltage_CH3_Old = Selected_Voltage_CH3;
                Selected_Voltage_CH4_Old = Selected_Voltage_CH4;

/*
                printf("SVC1_Old %d SVC1 %d\n", Selected_Voltage_CH1_Old, Selected_Voltage_CH1);
                printf("SVC2_Old %d SVC2 %d\n", Selected_Voltage_CH2_Old, Selected_Voltage_CH2);
                printf("SVC3_Old %d SVC3 %d\n", Selected_Voltage_CH3_Old, Selected_Voltage_CH3);
                printf("SVC4_Old %d SVC4 %d\n", Selected_Voltage_CH4_Old, Selected_Voltage_CH4);
*/
                //if (MenuStatus[10][2] == 1) DoDisableTimer2Interrupt();

                AUTOMODE_bak = MenuStatus[12][0];
            }
            else
            {
               /* TMW if (Memory_Window_visible)
                {
                    Display::DRAWMEMORY(0, 0, 1);
                }*/

                Display::DRAW_ALL_CURSOR();

                Continius = 1;
                Signal_Loaded = 0;
                //UserIface_active = 0;

                SingleMode = 0;

                LED_ON[12] = 1;
                LED_ON[13] = 0;

                LED_ON[14] = 0;
                LED_ON[15] = 0;


                MenuStatus[12][0] = AUTOMODE_bak;
                
                if (MenuStatus[12][0] == 93)
                {
                    MenuPopupStatus[9][0] = 3;
                    MenuPopupStatus[9][1] = 2;
                }
                else
                {
                    MenuPopupStatus[9][0] = 2;
                    MenuPopupStatus[9][1] = 3;
                }
                
                
                MenuItemChanged[0] = 1;						
                Menu_Changed = 1;
                TriggerLevelChanged = 1;
                TriggerModeChanged = 1;

                UpdateTrigger(55);			
                Display::StatusUpdate();
                  /*
                if (MenuStatus[10][2] == 1)
                {
                    ClearPlanes();
                    ROLLMODE_OFFSET = 601;	
                    ROLLMODE_POS = 0;
                    ROLLMODE_STARTED = false;

                    //DoEnableTimer2Interrupt();
                    //Start_Record();
                }
                */

                //if (adc_started == false) Start_Record();
                //ResetTimer();

                Start_Record();
            }

            Send_LED();

            TriggerModeChanged = 1;
            Display::StatusUpdate();
#ifdef _Debug_
            if (Debug_Mode)
            {
                printf("Run / Stop Button \n");
                if (Continius) printf("Continius Mode enabled\n");
                else printf("Continius Mode disabled\n");
            }	
#endif	
		
			break;
        }

        // Single Button
		case 38 :
		{	
            //if (MenuStatus[10][2] == 1) break;

            if (SingleMode == 1)
            {
                // Run / Stop out
                LED_ON[12] = 0;
                LED_ON[13] = 0;

                // Single orange
                LED_ON[14] = 1;
                LED_ON[15] = 1;
                Send_LED();	

                UserIface_active = 0;

                //Single_Restart = 1;
            }
            else
            {		
		        SingleMode = 1;
		        Continius = 0;
		        UserIface_active = 0;

                // Run / Stop out
                LED_ON[12] = 0;
                LED_ON[13] = 0;

                // Single orange
                LED_ON[14] = 1;
                LED_ON[15] = 1;

                AUTOMODE_bak = MenuStatus[12][0];
            }

            MenuStatus[12][0] = 94;
            MenuPopupStatus[9][0] = 2;
            MenuPopupStatus[9][1] = 3;
            MenuItemChanged[0] = 1;						
            Menu_Changed = 1;
            TriggerLevelChanged = 1;
            TriggerModeChanged = 1;

            //timebase_reg = tb_value[Selected_Timebase];     // Switch to old timebase

			UpdateTrigger(15);			
            Display::StatusUpdate();

            Send_LED();	

            if (adc_started == false) Start_Record();
#ifdef _Debug_
			if (Debug_Mode) printf("Single Button sm : %i  c : %i\n", SingleMode, Continius);
#endif			
			break;
        }
		
		// Test Funktion 0 Q
		case 40 :
		{	
            if (ADC_Debug_Mode) ADC_Debug_Mode = false;
            else ADC_Debug_Mode = true;

            if (Debug_Mode)
            {
                if (ADC_Debug_Mode) printf("ADC Debug Mode enabled\n");
                else printf("ADC Debug Mode disabled\n");
            }

            config_changed = true;
			break;
		}
		// Test Funktion 1 W
		case 41 :
		{	

			for (ix = 0x0000; ix < 0x0400; ix+=4)
            {
                printf("S1_%d : %3d %3d %3d %3d\n", ix, SIGNAL1[ix], SIGNAL1[ix + 1], SIGNAL1[ix + 2], SIGNAL1[ix + 3]);
                nr_delay(10);
            }

            printf("CH1VZL %d\n", Virtual_ZeroLevelCH1);
            printf("CH1ZL %d\n", ZeroLevelCH1);
            printf("CH1RK %d\n", (ZeroLevelCH1 + 64) >> 1);

            printf("CH1ZSO1 %d\n", Channel1_Zero_Sign_Offset_1);
            printf("CH1ZSO2 %d\n", Channel1_Zero_Sign_Offset_2);
            printf("CH1ZSO3 %d\n", Channel1_Zero_Sign_Offset_3);
            printf("CH1ZO %d\n", CH1_Zero_Offset);

            printf("Signal Buf_Adr %d Buf_wit %d  pre_reg %d\n", buffer_addi, buffer_long1, pre_reg);

            printf("STB %d STB_idx %d\n", Selected_Timebase, SIGNALFaktor_idx);

			
			break;
		}
		// Test Funktion 2 E
		case 42 :
		{	

			for (ix = 0x3C00; ix < 0x4000; ix+=4)
            {
                printf("S1_%d : %3d %3d %3d %3d\n", ix, SIGNAL1[ix], SIGNAL1[ix + 1], SIGNAL1[ix + 2], SIGNAL1[ix + 3]);
                nr_delay(10);
            }

            printf("CH1VZL %d\n", Virtual_ZeroLevelCH1);
            printf("CH1ZL %d\n", ZeroLevelCH1);
            printf("CH1RK %d\n", (ZeroLevelCH1 + 64) >> 1);

            printf("CH1ZSO1 %d\n", Channel1_Zero_Sign_Offset_1);
            printf("CH1ZSO2 %d\n", Channel1_Zero_Sign_Offset_2);
            printf("CH1ZSO3 %d\n", Channel1_Zero_Sign_Offset_3);
            printf("CH1ZO %d\n", CH1_Zero_Offset);

            printf("Signal Buf_Adr %d Buf_wit %d  pre_reg %d\n", buffer_addi, buffer_long1, pre_reg);
	
			break;
		}
		// Test Funktion 3 R
		case 43 :
		{	/*
			for (ix = 0x0000; ix < 0x0250; ix+=4)
            {
                printf("S1_Min_%d : %3d %3d %3d %3d\n", ix, SIGNAL1_SUM_MIN[ix], SIGNAL1_SUM_MIN[ix + 1], SIGNAL1_SUM_MIN[ix + 2], SIGNAL1_SUM_MIN[ix + 3]);
                nr_delay(10);
            } */
			Do_Gen_Signal();
            VSync_Needed = 1;
            UserIface_active = 0;
            DrawSignals_Needed = 1;

            Display::DRAWSIGNALS(1);		
            TransferPlanes();			
			printf("Generate Signal  ready\n");

			break;
		}
		// Test Funktion 4 T
		case 44 :
		{		
			Do_Gen_Signal2();
            VSync_Needed = 1;
            UserIface_active = 0;
            DrawSignals_Needed = 1;

            Display::DRAWSIGNALS(1);		
            TransferPlanes();			
			printf("Generate Signal ready\n");
			break;
		}
		// Test Funktion 5 Z
		case 45 :
		{	
            Channel_Math_Active = 1;
            MenuStatus[26][1] = 1;
            MenuStatus[26][2] = 0;
            MenuStatus[26][3] = 0;
            MenuStatus[26][4] = 0;
		
            VSync_Needed = 1;
            UserIface_active = 0;
            DrawSignals_Needed = 1;

            Do_FFT();
            Display::DRAWSIGNALS(1);		
            TransferPlanes();

            printf("FFT  ready\n");            	

			break;
		}		
		// Test Funktion 6 U
		case 46 :
		{		
            if (Test_Mode) Test_Mode = false;
            else Test_Mode = true;

            if (Test_Mode) printf("Test Mode enabled\n");
            else printf("Test Mode disabled\n");
            		
			break;
		}
		// Test Funktion 7 I
		case 47 :
		{		
            if (FirEnabledCH1 == 0x00) FirEnabledCH1 = 0x01;
            else FirEnabledCH1 = 0x00;

            if (FirEnabledCH1) printf("FIR CH 1 enabled\n");

			break;
		}
		// Test Funktion 8 O
		case 48 :
		{		
            Test_Slip = Test_Slip - 0.1;

            printf("Slip = %f \n", Test_Slip);

			break;
		}
		// Test Funktion 9 P
		case 49 :
		{

            Test_Slip = Test_Slip + 0.1;

            printf("Slip = %f \n", Test_Slip);

			break;
		}
		
		// Test Funktion 10 A
		case 50 :
		{	
            Test_Range--;
            //Test_Slip = Test_Slip - 1.0;

            //printf("Slip = %f \n", Test_Slip);
            printf("Range = %d \n", Test_Range);

            break;
		}
		// Test Funktion 11 S
		case 51 :
		{	
	
            Test_Range++;
            //Test_Slip = Test_Slip + 1.0;

            //printf("Slip = %f \n", Test_Slip);
            printf("Range = %d \n", Test_Range);


			break;
		}
		// Test Funktion 12 D
		case 52 :
		{	
            if (Debug_Mode) Debug_Mode = false;
            else Debug_Mode = true;

            if (Debug_Mode) printf("Debug Mode enabled\n");
            else printf("Debug Mode disabled\n");

            config_changed = true;
			break;
		}
		// Test Funktion 13 F
		case 53 :
		{	
			//reset_watchdog->np_piodata = 0x00;						// Disable WatchDog
			
			AMDFlash::Clear_Data_FLASH();

			printf("Flash formated\n");

			//reset_watchdog->np_piodata = 0x01;						// Enable WatchDog
			
			//Reset_the_Watchdog();

			printf("Reset Hardware\n");

		    nr_delay(3000);						

			break;
		}
		// Test Funktion 14 G
		case 54 :
		{	
            if (Continius)
            {
                Continius = 0;
                SIGNAL_StartFr_idx = SIGNALFaktor_idx;
            }
            else Continius = 1;

            if (Debug_Mode)
            {
                if (Continius) printf("Continius Mode enabled\n");
                else printf("Continius Mode disabled\n");
            }

			break;
		}
		// Test Funktion 15 H
		case 55 :
		{	
	
            printf("\n");
            printf("***************************************************************************\n");
            printf("* Keyboard Commands : Menus                                               *\n");
            printf("***************************************************************************\n");
            printf("* Channel 1     : i  *  Mode / Timebase : b * Display      : d * File : f *\n");
            printf("* Channel 2     : j  *  Cursor          : c * Trigger Edge : e *          *\n");
            printf("* Channel 3     : k  *  Quick Meas      : q * Mode / Coup  : t *          *\n");
            printf("* Channel 4     : l  *  Quick Meas Sett : w * Pulse Width  : p *          *\n");
            printf("* Channel Math  : o  *  Acquire         : a * Utility      : u *          *\n");
            printf("***************************************************************************\n");
            printf("* Extended Commands : Help Keys                                           *\n");
            printf("***************************************************************************\n");
            printf("* This Help Screen  : h / Shift + H * Write Config to Flash  : Shift + Y  *\n");
            printf("* Enable Debug Mode :     Shift + D * Read Config from Flash : Shift + X  *\n");
            printf("* Clear Data Flash  :     Shift + F * Write Logo 1 to Flash  : Shift + W  *\n");
            printf("* Shoot Signal      :     Shift + S * Write Logo 2 to Flash  : Shift + E  *\n");
            printf("* Reset Hardware    :     Shift + R * Print Config in Flash  : Shift + P  *\n");
            printf("* Enable Debug Sig  :     Shift + Q * Interpolate CH1        : Shift + I  *\n");
            printf("* Continius Rec     :     Shift + G * Show Trigger Vals      : Shift + J  *\n");
            printf("* Smooth CH I       :     Shift + K * Smooth CH II           : Shift + L  *\n");
            printf("* Enable Extra Trg  :     Shift + T * Rot Timer Status       : Shift + A  *\n");
            printf("* Colordemo         :     Shift + C * Enable Command Debug   : Shift + B  *\n");
            printf("* Connect_Vals      :     Shift + V * Search Mode            : Shift + M  *\n");
            printf("* Show Variables    :     ,         * DRAW GRIDXY            : Shift + 6  *\n");
            printf("* Multiplier On/Off :     Shift + 1 * Test Multiplier        : -          *\n");
            printf("* M-Factor CHI + 10 :     Shift + 2 * M-Factor CHI - 10      : Shift + 3  *\n");
//            printf("*                   :     Shift + V *                        : Shift + B  *\n");
//            printf("*                   :     Shift + _ *                                     *\n");
//            printf("* Timebase manipulation : Press ShiftKey +                                *\n");
//            printf("*      1       2       3     4    5    6    7      8      9         0     *\n");
//            printf("* -0x10000 -0x1000 -0x100 -0x10 -0x1 +0x1 +0x10 +0x100 +0x1000 +0x100000  *\n");
            printf("***************************************************************************\n");
            printf("\n");

			break;
		}		
		// Test Funktion 16 J
		case 56 :
		{		
            printf("ctr %x actr %x tb %x pr %x tvr1 %x tvr2 %x trr %x trw %x tp1 %i adc_ch %x \n", ctrl_reg, adc_ctrl_reg, timebase_reg, pre_reg, trg_val_CHI_reg, trg_val_CHII_reg, trig_range_reg, trig_width_reg, Trigger_Pos_CH1, adc_change12_reg);

			break;
		}
		// Test Funktion 17 K
		case 57 :
		{		
            if (SmoothEnabledCH1) SmoothEnabledCH1 = 0;
            else SmoothEnabledCH1 = 1;

            if (Debug_Mode)
            {
                if (SmoothEnabledCH1) printf("Smooth CH I enabled\n");
                else printf("Smooth CH I disabled\n");
            }

			break;
		}
		// Test Funktion 18 L
		case 58 :
		{		
            if (SmoothEnabledCH2) SmoothEnabledCH2 = 0;
            else SmoothEnabledCH2 = 1;

            if (Debug_Mode)
            {
                if (SmoothEnabledCH2) printf("Smooth CH II enabled\n");
                else printf("Smooth CH II disabled\n");
            }

			break;
		}
		// Test Funktion 19 
		case 59 :
		{		
	
            TestFir();

			break;
		}
		
		// Test Funktion 20 Y
		case 60 :
		{	
			
			Display::ColorDemo5();
            			
			
			break;
		}	
		// Test Funktion 21 X
		case 61 :
		{
			Display::ColorDemo6();
			break;					
		}		
		// Test Funktion 22 C
		case 62 :
		{		
			Display::ColorDemo();

			break;
		}	
		// Test Funktion 23 V
		case 63 :
		{	
            if (Connect_Vals) Connect_Vals = false;
            else Connect_Vals = true;

            if (Debug_Mode)
            {
                if (Connect_Vals) printf("Connect_Vals enabled\n");
                else printf("Connect_Vals disabled\n");
            }

            config_changed = true;		

			break;
		}		
		// Test Funktion 24 B
		case 64 :
		{		
            if (Command_Mode) Command_Mode = false;
            else Command_Mode = true;

            if (Debug_Mode)
            {
                if (Command_Mode) printf("Command Mode enabled\n");
                else printf("Command Mode disabled\n");
            }

            config_changed = true;
			break;
		}        	
		// Test Funktion 25 N
		case 65 :
		{	
		    //Display::GRIDXY(80, 20, Grid_Plane);

            //printf("Add  : %d\n", nm_math_pfx(0x040A, 0x00643040, 0x00C8FFB0));
            //printf("Sub  : %d\n", nm_math_pfx(0x000A, 0x00643040, 0x00C8FFB0));
            //printf("Mult : %d\n", nm_math_pfx(0x0212, 0x00643040, 0x00C8FFB0));

            // Multiplikation
            /*
		    xm = 0x00010101;
		    ym = 0x00010101;
		    res_xm = nm_math_pfx(0x0201, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult1 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

		    xm = 0x00010502;
		    ym = 0x00010502;
		    res_xm = nm_math_pfx(0x0201, xm, ym);

            printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult2 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

            xm = 0x01F47E92;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0203, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult3 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

            xm = 0x01F47E6A;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0203, xm, ym);

            printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult4 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

            xm = 0x01F47E90;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0203, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult5 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

            xm = 0x01F47E65;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0203, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult6 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));

            xm = 0x01F47E99;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0203, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d mult7 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            */

            // Addition
		    xm = 0x00010101;
		    ym = 0x00010101;
		    res_xm = nm_math_pfx(0x0401, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad1 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad1 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

		    xm = 0x00010502;
		    ym = 0x00010502;
		    res_xm = nm_math_pfx(0x0401, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad2 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad2 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

		    xm = 0x01F47E92;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad3 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad3 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

            xm = 0x01F47E6A;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad4 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad4 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

            xm = 0x01F47E92;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad5 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad5 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

            xm = 0x01F47E6A;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad6 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad6 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

            xm = 0x01F47E99;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad7 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad7 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));

            xm = 0x01F47EA0;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0403, xm, ym);

            printf("mth op1: %d z1: %d op2: %d z2: %d delA: %d delB: %d\n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, ((xm & 0xFF00) >> 8) - xm & 0xFF, ((ym & 0xFF00) >> 8) - ym & 0xFF);
            //printf("mth ad8 = %x  res: %d  b1: %d b2: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            printf("mth ad8 = %x  res: %d  tst : %d \n\n", res_xm, (res_xm & 0xFF), ((res_xm & 0x00000F00) >> 8));



            // Subtraction
            /*		
		    xm = 0x00010101;//0x00643040;
		    ym = 0x00010101;//0x00C8FFB0;
		    res_xm = nm_math_pfx(0x0001, xm, ym);

            printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub1 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
		
		    xm = 0x00010502;//0x00643040;
		    ym = 0x00010502;//0x00C8FFB0;
		    res_xm = nm_math_pfx(0x0001, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub2 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
		
		    xm = 0x01F47E92;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0003, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub3 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
		
            xm = 0x01F47E6A;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0003, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub4 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            			
            xm = 0x01F47E90;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0003, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub5 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
		
            xm = 0x01F47E65;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0003, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub6 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", xm & 0xFF, (xm & 0xFF00) >> 8, ym & 0xFF, (ym & 0xFF00) >> 8, res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));	
		
            xm = 0x01F47E99;
		    ym = 0x01F47E7D;
		    res_xm = nm_math_pfx(0x0003, xm, ym);

		    printf("math op1 : %d z1 : %d op2 : %d z2 : %d sub7 = %d  res : %d  b1 : %d b2 : %d  test : %d \n", res_xm, (res_xm & 0xFF), (res_xm & 0x100) >> 8, (res_xm & 0x200) >> 9, 255 - ((res_xm & 0x3FC00) >> 10));
            */           	
			break;
		}		
		// Test Funktion 26 M
		case 66 :
		{	
            // Clear All Planes
            //for (ix = 0; ix < 153600; ix++) Planes[ix] = 0;	

            Display::GRID(20, 20, Grid_Plane);		
            /*	
		    Search_Step = 0;
            		
            if (Search_Mode) Search_Mode = false;
            else Search_Mode = true;

            if (Debug_Mode)
            {
                if (Search_Mode) printf("Search Mode enabled\n");
                else printf("Search Mode disabled\n");
            }

            printf("SearchResult : %i\n", Hardware::SearchZeros());
            */
			break;
		}
		// Test Funktion 27 ;
		case 67 :
		{	
            for (ix = 0; ix < 3; ix++)
            {
                printf("QMT %2i = %2i QMC = %2i QMCC = %2i QMSC = %2i QMEI = %2i QMEII = %2i\n", ix, QM_Type[ix], QM_Channel[ix], QM_Changed[ix], QM_Second_Channel[ix], QM_CHI_Edge[ix], QM_CHII_Edge[ix]);
            }
  	
			break;
		}		
		// Test Funktion 28 :
		case 68 :
		{	
		
            for (ix = 0; ix < 32; ix++)
            {
                printf("M %2i =", ix);

                for (ix2 = 0; ix2 < 6; ix2++)
                {
                    printf("  I %i : %3i", ix2, MenuStatus[ix][ix2]);

                }
                printf("\n");
            }

			break;
		}
		// Test Funktion 69 ,
		case 69 :
		{	
            printf("\n");
            printf("*****************************************************************************\n");
            printf("* Variables                           *                                     *\n");
            printf("*****************************************************************************\n");
            printf("* Selected_Timebase       : %5d     * Debug Mode               : %5d    *\n", Selected_Timebase, Debug_Mode);
            printf("* SIGNALFaktor_idx        : %5d     * ADC Debug Mode           : %5d    *\n", SIGNALFaktor_idx, ADC_Debug_Mode);
            printf("* Timebase_Offset_Pos     : %5d     * Command Debug Mode       : %5d    *\n", Timebase_Offset_Pos, Command_Mode);
            printf("* SIGNAL_OFFSET           : %5d     * Calc Mode                : %5d    *\n", SIGNAL_OFFSET, Calc_Mode);
            printf("* correction              : %5d     * ExtraTrg Mode            : %5d    *\n", correction, ExtraTrg_Mode);
            printf("* Signal Start            : %5d     * Search Mode              : %5d    *\n", SIG_Start_Stop[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]][0], Search_Mode);
            printf("* Signal Stop             : %5d     * Search Auto              : %5d    *\n", SIG_Start_Stop[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]][1], Search_Auto);
            printf("* Signal Start Calc       : %5d     * Connect Vals             : %5d    *\n", SIG_Start_Stop[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]][0] + (int)((float) Timebase_Offset_Pos * Offset_Faktor_Table[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]]), Connect_Vals);
            printf("* Signal Stop Calc        : %5d     * Continius                : %5d    *\n", SIG_Start_Stop[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]][1] + (int)((float) Timebase_Offset_Pos * Offset_Faktor_Table[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]]), Continius);
            printf("* Zoom Faktor             : %3.3f     * SingleMode               : %5d    *\n", Zoom_Faktor_Table[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]], SingleMode);
            printf("* Offset Faktor           : %3.3f    * Single Restart           : %5d    *\n", Offset_Faktor_Table[Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx]], Single_Restart);
            printf("* Multiplier Enabled      : %5d     * adc started              : %5d    *\n", multi_active, adc_started);
            printf("* ADC_Data_Available      : %5d     * VSync Needed             : %5d    *\n", ADC_Data_Available, VSync_Needed);
            printf("* Keyboard_Changed        : %5d     * ZFT_float                : %5f    *\n", Keyboard_Changed, ZFT_float);
            printf("* Triggering              : %5d     * DrawSignals Needed       : %5d    *\n", triggering, DrawSignals_Needed);
            printf("* SelectedTriggerSource   : %5d     * SelectedTriggerSourceOld : %5d    *\n", Selected_Trigger_Source, Selected_Trigger_Source_Old);
            printf("* UserIface_active        : %5d     * OneShotRestart           : %5d    *\n", UserIface_active, OneShotRestart);
            printf("* ctrl_reg                :  %4x     * adc_ctrl_reg             :  %4x    *\n", ctrl_reg, adc_ctrl_reg);
            printf("* pre_reg                 :  %4x     * channel_Adr_add          :  %4x    *\n", pre_reg, channel_Adr_add);
            printf("* trg_val_CHI_reg         :  %4x     * trg_val_CHII_reg         :  %4x    *\n", trg_val_CHI_reg, trg_val_CHII_reg);
            printf("* trg_val_CHIII_reg       :  %4x     * trg_val_CHIV_reg         :  %4x    *\n", trg_val_CHIII_reg, trg_val_CHIV_reg);
            printf("* trig_range_reg          :  %4x     * trig_holdoff_reg         :  %4x    *\n", trig_range_reg, trig_holdoff_reg);
            printf("* trig_width_reg          :  %4x     *                                     *\n", trig_width_reg);
            printf("* adc_change12_reg        :  %8x * adc_change34_reg         : %8x *\n", adc_change12_reg, adc_change34_reg);
            printf("* adc_ctr12_reg           :  %8x * adc_ctr34_reg            : %8x *\n", adc_ctr12_reg, adc_ctr34_reg);

            printf("* Selected_Timebase       : %5d     * SIGNALFaktor_idx         : %5d    *\n", Selected_Timebase, SIGNALFaktor_idx);
            printf("* SIGNAL_StartFr_idx      : %5d     * timebase_reg             : %8x *\n", SIGNAL_StartFr_idx, timebase_reg);
            printf("* Display_Timebase        : %5d     * dmode_Selected_Timebase  : %5d    *\n", Display_Timebase, dmode_Selected_Timebase);
            printf("* dmode_SIGNALFaktor_idx  : %5d     * dmode_factor             : %5d    *\n", dmode_SIGNALFaktor_idx, dmode_factor);
            printf("* dmode_SIGNAL_StartFr_idx: %5d     * Cursor_Delayed_1         : %5d    *\n", dmode_SIGNAL_StartFr_idx, Cursor_Delayed_1);
            printf("* Cursor_Delayed_2        : %5d     * Cursor_Delayed_Size      : %5d    *\n", Cursor_Delayed_2, Cursor_Delayed_Size);
            printf("* ROLLMODE_TB             : %5d     * ROLLMODE_OFFSET          : %5d    *\n", ROLLMODE_TB, ROLLMODE_OFFSET);
            printf("* dmode_Window_Offset_Pos : %5d     *                                     *\n", dmode_Window_Offset_Pos);

            printf("* SelectedEdgeExtern      : %5d     * TriggerWay               : %5d    *\n", SelectedEdgeExtern, TriggerWay );
            printf("* Trigger_Pos_CH1         : %5d     * Trigger_Pos_CH2          : %5d    *\n", Trigger_Pos_CH1, Trigger_Pos_CH2);
            printf("* Trigger_Pos_CH3         : %5d     * Trigger_Pos_CH4          : %5d    *\n", Trigger_Pos_CH3, Trigger_Pos_CH4);
            printf("* Trigger_Pos_CHE         : %5d     * FirStartCH_delayed       : %5d    *\n", Trigger_Pos_CHE, FirStartCH_delayed);
            printf("* Selected_Voltage_CH1    : %5d     * CH1_DAC_Offset           : %5d    *\n", Selected_Voltage_CH1, CH1_DAC_Offset);
            printf("* Selected_Voltage_CH2    : %5d     * CH2_DAC_Offset           : %5d    *\n", Selected_Voltage_CH2, CH2_DAC_Offset);
            printf("* Selected_Voltage_CH3    : %5d     * CH3_DAC_Offset           : %5d    *\n", Selected_Voltage_CH3, CH3_DAC_Offset);
            printf("* Selected_Voltage_CH4    : %5d     * CH4_DAC_Offset           : %5d    *\n", Selected_Voltage_CH4, CH4_DAC_Offset);
            printf("* Virtual_ZeroLevelCH1    : %5d     * ZeroLevelCH1             : %5d    *\n", Virtual_ZeroLevelCH1, ZeroLevelCH1);
            printf("* Virtual_ZeroLevelCH2    : %5d     * ZeroLevelCH2             : %5d    *\n", Virtual_ZeroLevelCH2, ZeroLevelCH2);
            printf("* Virtual_ZeroLevelCH3    : %5d     * ZeroLevelCH3             : %5d    *\n", Virtual_ZeroLevelCH3, ZeroLevelCH3);
            printf("* Virtual_ZeroLevelCH4    : %5d     * ZeroLevelCH4             : %5d    *\n", Virtual_ZeroLevelCH4, ZeroLevelCH4);
            printf("* CH1_Zero_Offset         : %5d     * signal_zoomed1           : %5d    *\n", CH1_Zero_Offset, signal_zoomed1);
            printf("* Ch1_Zero_Sign_Offset_1  : %5d     * Ch1_Zero_Sign_Offset_2   : %5d    *\n", Channel1_Zero_Sign_Offset_1, Channel1_Zero_Sign_Offset_2);
            printf("* Ch1_Zero_Sign_Offset_3  : %5d     * FirStartCH               : %5d    *\n", Channel1_Zero_Sign_Offset_3, FirStartCH);
            printf("* CH1_DAC_1               : %5d     * CH1_DAC_2                : %5d    *\n", CH1_DAC_1, CH1_DAC_2);
            printf("* CH1_DAC_3               : %5d     * CH1_DAC_4                : %5d    *\n", CH1_DAC_3, CH1_DAC_4);

            printf("* SwitchesCH1             : %5d     * SwitchesCH2              : %5d    *\n", SwitchesCH1, SwitchesCH2);
            printf("* SwitchesCH3             : %5d     * SwitchesCH4              : %5d    *\n", SwitchesCH3, SwitchesCH4);

            printf("* SwitchesTB              : %5d     * Trigger_Offset_Pos       : %5d    *\n", SwitchesTB, Trigger_Offset_Pos);
            printf("* HoldOff_Value           : %5d     * trig_holdoff_reg         : %8x *\n", HoldOff_Value, trig_holdoff_reg);
            printf("* CVP_Real1               : %5d     *  CVP_Real2               : %5d    *\n", Cursor_Vertical_Position_Real1, Cursor_Vertical_Position_Real2);
            printf("* CVP_RealXY1             : %5d     *  CVP_RealXY2             : %5d    *\n", Cursor_Vertical_Position_Real_XY_1, Cursor_Vertical_Position_Real_XY_2);
            printf("* CHP_Real1               : %5d     *  CHP_Real1               : %5d    *\n", Cursor_Horizontal_Position_Real1, Cursor_Horizontal_Position_Real2);
            printf("* m2k_filter_Mode         :  %4x     *  kill_adc                :  %4x    *\n", m2k_filter_Mode, kill_adc);
            printf("* zeros_filter_Mode       :  %4x     *  tc_hw_version           : %8x *\n", zeros_filter_Mode, tc_hw_version);

            printf("* draw_dm_ixstart         : %5d     * draw_dm_ixstop           : %5d    *\n", draw_dm_ixstart, draw_dm_ixstop);
            printf("* draw_dm_ixfactor        : %5d     * draw_dm_ixoffset         : %5d    *\n", draw_dm_ixfactor, draw_dm_ixoffset);
            printf("* dmode_Window_Offset_Pos : %5d     * dmode_Zoom_Index_Table   : %5d    *\n", dmode_Window_Offset_Pos, Zoom_Index_Table[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx]);
            printf("* dmode_SIG_Start_Stop    : %5d     * dmode_Offset_Faktor_Tab  : %5f *\n", SIG_Start_Stop[Zoom_Index_Table[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx]][0], Offset_Faktor_Table[Zoom_Index_Table[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx]]);


            printf("* ZFT_float               : %3.3f     * ZFT_float_dmode          : %3.3f    *\n", ZFT_float, ZFT_float_dmode);
            printf("* ZIT_short               : %5d     * ZIT_short_dmode          : %5d    *\n", ZIT_short, ZIT_short_dmode);
            printf("* Trig_Pos_Mem            : %5d     * Trig_Pos_Display         : %5d    *\n", Trig_Pos_Mem, Trig_Pos_Display);
            printf("* Trig_Pos_Zoom           : %3.3f     * Trig_Mem_Pos             : %5d    *\n", Trig_Pos_Zoom, Trig_Mem_Pos);
            printf("* Trig_Pos_Mem_old        : %5d     * Trig_Pos_Display_old     : %5d    *\n", Trig_Pos_Mem_old, Trig_Pos_Display_old);
            printf("* Trig_Pos_Zoom_old       : %3.3f     * Trig_Mem_Pos_old         : %5d    *\n", Trig_Pos_Zoom_old, Trig_Mem_Pos_old);
            printf("* OFT_float               : %3.3f     * OFT_float_old            : %3.3f  *\n", OFT_float, OFT_float_old);
            
//            printf("*                                    *                                    *\n");
            printf("*****************************************************************************\n");
            printf("\n");

			break;
		}
		// Test Funktion 70 .
		case 70 :
		{		

            printf("\n");
            printf("*****************************************************************************\n");
            printf("* Interrupts                          *                                     *\n");
            printf("*****************************************************************************\n");		
            printf("* ADC Interrupt Edge      : %5d     * Keyboard IRQ Edge        : %5d    *\n", acq_ready->np_pioedgecapture, key_int->np_pioedgecapture);
            printf("* ADC Interrupt           : %5d     * Keyboard IRQ             : %5d    *\n", acq_ready->np_piodata, acq_ready->np_piodata);
//            printf("*                                    *                                    *\n");
            printf("*****************************************************************************\n");
            printf("\n");
		
			break;
		}        		
		// Test Funktion 71 -
		case 71 :
		{		
		    xm = 100;
		    ym = 20;
		    res_xm = nm_mult(xm, ym);

		    printf("mult 100 x 20 = %d\n", res_xm);

		    xm = -100;
		    ym = 20;
		    res_xm = nm_mult(xm, ym);

		    printf("mult -100 x 20 = %d\n", res_xm);		

		    xm = 54;
		    ym = 55;
		    res_xm = nm_mult(xm, ym);

		    printf("mult 74 x 55 = %d\n", res_xm);
		
		    xm = -74;
		    ym = 55;
		    res_xm = nm_mult(xm, ym);

		    printf("mult -54 x 55 = %d\n", res_xm);		

			break;
		}

		// Test Funktion 31 !
		case 80 :
		{		
            if (multi_active)
            {
                multi_active = false;
                SwitchesCH1 &= 0x7FFF;					
				SetSwitches(1, -1);
            }
            else
            {
                multi_active = true;
                SwitchesCH1 |= 0x8000;					
				SetSwitches(1, -1);
            }


            printf("CH I Multiplier Active : %d\n", multi_active);

			break;
		}
		// Test Funktion 31 "
		case 81 :
		{		
            pre_reg--;

            SetupADC();	
            
            printf("pre_reg : %i\n", pre_reg);

			break;
		}
		// Test Funktion 32 
		case 82 :
		{		
            pre_reg++;

            SetupADC();	
            
            printf("pre_reg : %i\n", pre_reg);

			break;
		}
		// Test Funktion 33 $
		case 83 :
		{	

            pre_reg -= 10;

            SetupADC();	

            printf("pre_reg : %i\n", pre_reg);

			break;
		}
		// Test Funktion 34 %
		case 84 :
		{		
            pre_reg += 10;

            SetupADC();	

            printf("pre_reg : %i\n", pre_reg);

			break;
		}
		// Test Funktion 35 &
		case 85 :
		{		
            if (Display_Mode) Display_Mode = 0;
            else Display_Mode = 1;
  		
            if (Continius == 0) DrawSignals_Needed = 1;

            printf("Display Mode %d\n", Display_Mode);

			break;
		}
		// Test Funktion 36 /
		case 86 :
		{		
            if (SIGNALFaktor_idx == 0) pre_reg = pre_reg - 6;
            else if (SIGNALFaktor_idx == 1) pre_reg = pre_reg - 10;
            else if (SIGNALFaktor_idx == 2) pre_reg = pre_reg - 18;
            else if (SIGNALFaktor_idx == 3) pre_reg = pre_reg - 55;
            else if (SIGNALFaktor_idx == 4) pre_reg = pre_reg - 90;

            SetupADC();


            printf("Test Pre Reg manupulatioin\n");

			break;
		}
		// Test Funktion 37 (
		case 87 :
		{	
            printf("MenuPopupStatus\n");
            for (ix2 = 0; ix2 < 30; ix2++)
            {
                printf("MPS[%2d] : ", ix2);
                
                for (ix = 0; ix < 21; ix++)
                {
                    printf("%2d ", MenuPopupStatus[ix2][ix]);
                }
                printf("\n");
            }



			break;
		}
		// Test Funktion 38 )
		case 88 :
		{		
            ix = (int) (Pulse11.Read_Value() * 100000000);			
            printf("PV 11 RV : % d Va : %d St : %d Ex : %d\n", ix, Pulse11_Value, Pulse11_Steps, Pulse11_Expo);
            ix = (int) (Pulse12.Read_Value() * 100000000);			
            printf("PV 12 RV : % d Va : %d St : %d Ex : %d\n", ix, Pulse12_Value, Pulse12_Steps, Pulse12_Expo);

            ix = (int) (Pulse21.Read_Value() * 100000000);			
            printf("PV 21 RV : % d Va : %d St : %d Ex : %d\n", ix, Pulse21_Value, Pulse21_Steps, Pulse21_Expo);
            ix = (int) (Pulse22.Read_Value() * 100000000);			
            printf("PV 22 RV : % d Va : %d St : %d Ex : %d\n", ix, Pulse22_Value, Pulse22_Steps, Pulse22_Expo);

			break;
		}
		// Test Funktion 39 =
		case 89 :
		{		

            printf("\n");
            printf("*****************************************************************************\n");
            printf("* Channel corrections                                                       *\n");
            printf("*****************************************************************************\n");		
            printf("* CH 1 V  0 : %3d    CH 2 V  0 : %3d    CH 3 V  0 : %3d    CH 4 V  0 : %3d  *\n", Voltage_Correction[0][0], Voltage_Correction[1][0], Voltage_Correction[2][0], Voltage_Correction[3][0]);
            printf("* CH 1 V  1 : %3d    CH 2 V  1 : %3d    CH 3 V  1 : %3d    CH 4 V  1 : %3d  *\n", Voltage_Correction[0][1], Voltage_Correction[1][1], Voltage_Correction[2][1], Voltage_Correction[3][1]);
            printf("* CH 1 V  2 : %3d    CH 2 V  2 : %3d    CH 3 V  2 : %3d    CH 4 V  2 : %3d  *\n", Voltage_Correction[0][2], Voltage_Correction[1][2], Voltage_Correction[2][2], Voltage_Correction[3][2]);
            printf("* CH 1 V  3 : %3d    CH 2 V  3 : %3d    CH 3 V  3 : %3d    CH 4 V  3 : %3d  *\n", Voltage_Correction[0][3], Voltage_Correction[1][3], Voltage_Correction[2][3], Voltage_Correction[3][3]);
            printf("* CH 1 V  4 : %3d    CH 2 V  4 : %3d    CH 3 V  4 : %3d    CH 4 V  4 : %3d  *\n", Voltage_Correction[0][4], Voltage_Correction[1][4], Voltage_Correction[2][4], Voltage_Correction[3][4]);
            printf("* CH 1 V  5 : %3d    CH 2 V  5 : %3d    CH 3 V  5 : %3d    CH 4 V  5 : %3d  *\n", Voltage_Correction[0][5], Voltage_Correction[1][5], Voltage_Correction[2][5], Voltage_Correction[3][5]);
            printf("* CH 1 V  6 : %3d    CH 2 V  6 : %3d    CH 3 V  6 : %3d    CH 4 V  6 : %3d  *\n", Voltage_Correction[0][6], Voltage_Correction[1][6], Voltage_Correction[2][6], Voltage_Correction[3][6]);
            printf("* CH 1 V  7 : %3d    CH 2 V  7 : %3d    CH 3 V  7 : %3d    CH 4 V  7 : %3d  *\n", Voltage_Correction[0][7], Voltage_Correction[1][7], Voltage_Correction[2][7], Voltage_Correction[3][7]);
            printf("* CH 1 V  8 : %3d    CH 2 V  8 : %3d    CH 3 V  8 : %3d    CH 4 V  8 : %3d  *\n", Voltage_Correction[0][8], Voltage_Correction[1][8], Voltage_Correction[2][8], Voltage_Correction[3][8]);
            printf("* CH 1 V  9 : %3d    CH 2 V  9 : %3d    CH 3 V  9 : %3d    CH 4 V  9 : %3d  *\n", Voltage_Correction[0][9], Voltage_Correction[1][9], Voltage_Correction[2][9], Voltage_Correction[3][9]);
            printf("* CH 1 V 10 : %3d    CH 2 V 10 : %3d    CH 3 V 10 : %3d    CH 4 V 10 : %3d  *\n", Voltage_Correction[0][10], Voltage_Correction[1][10], Voltage_Correction[2][10], Voltage_Correction[3][10]);
            printf("* CH 1 V 11 : %3d    CH 2 V 11 : %3d    CH 3 V 11 : %3d    CH 4 V 11 : %3d  *\n", Voltage_Correction[0][11], Voltage_Correction[1][11], Voltage_Correction[2][11], Voltage_Correction[3][11]);
            printf("* Channel corrections Float                                                 *\n");
            printf("*****************************************************************************\n");		
            printf("* CH 1 V  0 : %3f    CH 2 V  0 : %3f    CH 3 V  0 : %3f    CH 4 V  0 : %3f  *\n", Volt_Correct_float[0][0], Volt_Correct_float[1][0], Volt_Correct_float[2][0], Volt_Correct_float[3][0]);
            printf("* CH 1 V  1 : %3f    CH 2 V  1 : %3f    CH 3 V  1 : %3f    CH 4 V  1 : %3f  *\n", Volt_Correct_float[0][1], Volt_Correct_float[1][1], Volt_Correct_float[2][1], Volt_Correct_float[3][1]);
            printf("* CH 1 V  2 : %3f    CH 2 V  2 : %3f    CH 3 V  2 : %3f    CH 4 V  2 : %3f  *\n", Volt_Correct_float[0][2], Volt_Correct_float[1][2], Volt_Correct_float[2][2], Volt_Correct_float[3][2]);
            printf("* CH 1 V  3 : %3f    CH 2 V  3 : %3f    CH 3 V  3 : %3f    CH 4 V  3 : %3f  *\n", Volt_Correct_float[0][3], Volt_Correct_float[1][3], Volt_Correct_float[2][3], Volt_Correct_float[3][3]);
            printf("* CH 1 V  4 : %3f    CH 2 V  4 : %3f    CH 3 V  4 : %3f    CH 4 V  4 : %3f  *\n", Volt_Correct_float[0][4], Volt_Correct_float[1][4], Volt_Correct_float[2][4], Volt_Correct_float[3][4]);
            printf("* CH 1 V  5 : %3f    CH 2 V  5 : %3f    CH 3 V  5 : %3f    CH 4 V  5 : %3f  *\n", Volt_Correct_float[0][5], Volt_Correct_float[1][5], Volt_Correct_float[2][5], Volt_Correct_float[3][5]);
            printf("* CH 1 V  6 : %3f    CH 2 V  6 : %3f    CH 3 V  6 : %3f    CH 4 V  6 : %3f  *\n", Volt_Correct_float[0][6], Volt_Correct_float[1][6], Volt_Correct_float[2][6], Volt_Correct_float[3][6]);
            printf("* CH 1 V  7 : %3f    CH 2 V  7 : %3f    CH 3 V  7 : %3f    CH 4 V  7 : %3f  *\n", Volt_Correct_float[0][7], Volt_Correct_float[1][7], Volt_Correct_float[2][7], Volt_Correct_float[3][7]);
            printf("* CH 1 V  8 : %3f    CH 2 V  8 : %3f    CH 3 V  8 : %3f    CH 4 V  8 : %3f  *\n", Volt_Correct_float[0][8], Volt_Correct_float[1][8], Volt_Correct_float[2][8], Volt_Correct_float[3][8]);
            printf("* CH 1 V  9 : %3f    CH 2 V  9 : %3f    CH 3 V  9 : %3f    CH 4 V  9 : %3f  *\n", Volt_Correct_float[0][9], Volt_Correct_float[1][9], Volt_Correct_float[2][9], Volt_Correct_float[3][9]);
            printf("* CH 1 V 10 : %3f    CH 2 V 10 : %3f    CH 3 V 10 : %3f    CH 4 V 10 : %3f  *\n", Volt_Correct_float[0][10], Volt_Correct_float[1][10], Volt_Correct_float[2][10], Volt_Correct_float[3][10]);
            printf("* CH 1 V 11 : %3f    CH 2 V 11 : %3f    CH 3 V 11 : %3f    CH 4 V 11 : %3f  *\n", Volt_Correct_float[0][11], Volt_Correct_float[1][11], Volt_Correct_float[2][11], Volt_Correct_float[3][11]);
//            printf("*                                    *                                    *\n");
            printf("*****************************************************************************\n");
            printf("* CH 1 V  0 : %3d    CH 2 V  0 : %3d    CH 3 V  0 : %3d    CH 4 V  0 : %3d  *\n", Voltage_Offset[0][0], Voltage_Offset[1][0], Voltage_Offset[2][0], Voltage_Offset[3][0]);
            printf("* CH 1 V  1 : %3d    CH 2 V  1 : %3d    CH 3 V  1 : %3d    CH 4 V  1 : %3d  *\n", Voltage_Offset[0][1], Voltage_Offset[1][1], Voltage_Offset[2][1], Voltage_Offset[3][1]);
            printf("* CH 1 V  2 : %3d    CH 2 V  2 : %3d    CH 3 V  2 : %3d    CH 4 V  2 : %3d  *\n", Voltage_Offset[0][2], Voltage_Offset[1][2], Voltage_Offset[2][2], Voltage_Offset[3][2]);
            printf("* CH 1 V  3 : %3d    CH 2 V  3 : %3d    CH 3 V  3 : %3d    CH 4 V  3 : %3d  *\n", Voltage_Offset[0][3], Voltage_Offset[1][3], Voltage_Offset[2][3], Voltage_Offset[3][3]);

            printf("*****************************************************************************\n");
            printf("\n");

			break;
		}        		
	}
	if (Splash_drawed == false) UpdateMenuTextPlane = true;
}	

char Hardware::MenuButtonCheck(char BtnNr)
{
	char ct, found = 0;
	
	for (ct = 0; ct < 6; ct++)
	{
		if (MenuItemPushed[ct] == 1) { found = 1; MenuItemPushed[ct] = 0; MenuItemPushed_old[ct] = 1; MenuItemChanged[ct] = 1;}
	}
	
	if (found) ResetTimer();

	if (BtnNr > -1)
	{
		MenuItemChanged[BtnNr] = 1;
		MenuItemPushed[BtnNr] = 1;	
	}
	return found;
}

void Hardware::MenuPopupStep(int MenuPopupNr, short *MenuStatusNr, short *MenuStatusNr2, short *MenuStatusNr3, int DrawMenuNr, int start, char dir)
{
	int x, pos = 0;
	int newpos = 0;
	
	unsigned short count = 0;
	
	count = MenuPopupDef[MenuPopupActive][1];
	
	for (x = 0; x < count; x++)
	{
		if (MenuPopupStatus[MenuPopupNr][x] == 3) pos = x;
	}
	
	
	if (dir == 2)
	{
        newpos = -1;
        for (x = pos; x < count; x++)
        {
            if (MenuPopupStatus[MenuPopupNr][x] == 2)
            {
                newpos = x;
                break;
            }
        }	
	
        if (newpos == -1)
        {
            for (x = 0; x < pos; x++)
            {
                if (MenuPopupStatus[MenuPopupNr][x] == 2)
                {
                    newpos = x;
                    break;
                }
            }
        }
    }
    else
	{
        newpos = -1;
        for (x = pos; x >= 0; x--)
        {
            printf("DoStep (%d) down to %d = %d\n", MenuPopupNr, x, MenuPopupStatus[MenuPopupNr][x]);
            if (MenuPopupStatus[MenuPopupNr][x] == 2)
            {
                newpos = x;
                break;
            }
        }	
	
        if (newpos == -1)
        {
            printf("Nothing found\n");
            for (x = count; x > pos; x--)
            {
                if (MenuPopupStatus[MenuPopupNr][x] == 2)
                {
                    newpos = x;
                    break;
                }
            }
        }
    }    	
    
    printf("Pos : %2d NewPos : %2d dir : %2d\n", pos, newpos, dir);
	
    if (newpos == -1) return;	
	
	MenuPopupStatus[MenuPopupNr][pos] = 2;
	MenuPopupStatus[MenuPopupNr][newpos] = 3;
	
	MenuStatusNr[0] = start + newpos;
    if (MenuStatusNr2[0] > -1) { MenuStatusNr2[0] = start + newpos; }
    if (MenuStatusNr3[0] > -1) { MenuStatusNr3[0] = start + newpos; }	
}		

void Hardware::UpdateChannel(int channel, char active)
{
	char *iipos = 0;
	char *iiipos = 0;	
	int x= 0;
	int pos = 0;
	int bufchannel = channel;
	char lednr = 0;
	
	switch(channel)
	{
		case 1:
		{
			iipos = &Channel_1_Active;
			iiipos = &Channel_1_Active_Old;
			lednr = 0;
			break;
		}	
		case 2:
		{
			iipos = &Channel_2_Active;
			iiipos = &Channel_2_Active_Old;
			lednr = 1;
			break;
		}
		case 3:
		{
			iipos = &Channel_3_Active;
			iiipos = &Channel_3_Active_Old;
			lednr = 2;
			break;
		}
		case 4:
		{
			iipos = &Channel_4_Active;
			iiipos = &Channel_4_Active_Old;
			lednr = 3;
			break;
		}
		case 5:
		{
			iipos = &Channel_Math_Active;
			iiipos = &Channel_Math_Active_Old;
			lednr = 4;
			
			if (NumberOfChannels == 2) bufchannel = 3;
			break;
		}		
	}
						
	if (active == 1)
	{
		*iiipos = *iipos;
		*iipos = 1;
		
		// FFT Source
		if (MenuPopupStatus[29][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[27][0] == 91)
			{
				MenuPopupStatus[29][0 + (bufchannel - 1)] = 3;
				MenuStatus[27][0] = 138 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[29][0 + (bufchannel - 1)] = 2;			
		} 		
		
		// Edge Source
		if (MenuPopupStatus[28][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[14][1] == 91)
			{
				MenuPopupStatus[28][0 + (bufchannel - 1)] = 3;
				MenuStatus[14][1] = 138 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[28][0 + (bufchannel - 1)] = 2;			
		} 		
		
		// Cursor Source
		if (MenuPopupStatus[1][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[16][0] == 91)
			{
				MenuPopupStatus[1][0 + (bufchannel - 1)] = 3;
				MenuStatus[16][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[1][0 + (bufchannel - 1)] = 2;			
		}
		
		// Quick Measurement Source
		if (MenuPopupStatus[3][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[19][0] == 91)
			{
				MenuPopupStatus[3][0 + (bufchannel - 1)] = 3;
				MenuStatus[19][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[3][0 + (bufchannel - 1)] = 2;			
		}		
		
		// Quick Measurement Delay Settings Source1
		if (MenuPopupStatus[5][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[20][0] == 91)
			{
				MenuPopupStatus[5][0 + (bufchannel - 1)] = 3;
				MenuStatus[20][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[5][0 + (bufchannel - 1)] = 2;			
		}	
		
		// Quick Measurement Delay Settings Source2
		if (MenuPopupStatus[6][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[20][2] == 91)
			{
				MenuPopupStatus[6][0 + (bufchannel - 1)] = 3;
				MenuStatus[20][2] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[6][0 + (bufchannel - 1)] = 2;			
		}	
		
		// Quick Measurement Phase Settings Source1
		if (MenuPopupStatus[24][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[21][0] == 91)
			{
				MenuPopupStatus[24][0 + (bufchannel - 1)] = 3;
				MenuStatus[21][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[24][0 + (bufchannel - 1)] = 2;			
		}	
		
		// Quick Measurement Phase Settings Source2
		if (MenuPopupStatus[25][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[21][2] == 91)
			{
				MenuPopupStatus[25][0 + (bufchannel - 1)] = 3;
				MenuStatus[21][2] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[25][0 + (bufchannel - 1)] = 2;			
		}		
		
		// Quick Measurement Thresholds Source
		if (MenuPopupStatus[26][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[22][0] == 91)
			{
				MenuPopupStatus[26][0 + (bufchannel - 1)] = 3;
				MenuStatus[22][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[26][0 + (bufchannel - 1)] = 2;			
		}			
		
		// Pulse Width Source
		if (MenuPopupStatus[7][0 + (bufchannel - 1)] == 1)
		{
			if (MenuStatus[15][0] == 91)
			{
				MenuPopupStatus[7][0 + (bufchannel - 1)] = 3;
				MenuStatus[15][0] = 27 + (bufchannel - 1);		
			}			
			else MenuPopupStatus[7][0 + (bufchannel - 1)] = 2;			
		}
		Set_LED(lednr);
	}
	else
	{
		*iiipos = *iipos;
		*iipos = 0;      		
		
		if ((Channel_Math_Active) && ((bufchannel == 1) || (bufchannel == 2)) && (MenuStatus[26][1] == 0))
		{
            Channel_Math_Active = 0;
            RemovePlane |= 0x10;
            ClearPlanes();	
            Reset_LED(4);		
		}
		
		// xy
		if ((Display_Mode == 1) && ((bufchannel == 1) || (bufchannel == 2)))
		{
		    MenuStatus[10][0] = 1;
            MenuStatus[10][2] = 246;
            Display_Mode = 0;

            for (x = 380; x < 8120; x++) //400
            {
                Grid_Plane[x] = *(Grid_Plane_Flash + x);
            }
						
            GridColor_Val = GridColorArray[GridColorArrayPos];
            SetupADC();
						
            MenuStatus[5][2] = GridColorArrayPos + 133;							
		}
		
		// FFT Source
		if (MenuPopupStatus[29][0 + (bufchannel - 1)] == 3)
		{	
			MenuPopupStatus[29][0 + (bufchannel - 1)] = 1;
				
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[29][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[29][pos] = 3;
				MenuStatus[27][0] = 138 + pos;
			}
			else
			{
				MenuStatus[27][0] = 91;						//None
			}
		}
		else MenuPopupStatus[29][0 + (bufchannel - 1)] = 1;		
		
		// Edge Source
		if (MenuPopupStatus[28][0 + (bufchannel - 1)] == 3)
		{	
			MenuPopupStatus[28][0 + (bufchannel - 1)] = 1;
				
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[28][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[28][pos] = 3;
				MenuStatus[14][1] = 138 + pos;
			}
			else
			{
				MenuStatus[14][1] = 91;						//None
			}
		}
		else MenuPopupStatus[28][0 + (bufchannel - 1)] = 1;

        Selected_Trigger_Source	= MenuStatus[14][1] - 137;
        TriggerWayChanged = true;	
        TriggerLevelChanged = 1;

        Display::StatusUpdate();
        UpdateTrigger(45);
		
		// Cursor Source
		if (MenuPopupStatus[1][0 + (bufchannel - 1)] == 3)
		{	
			MenuPopupStatus[1][0 + (bufchannel - 1)] = 1;
				
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[1][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[1][pos] = 3;
				MenuStatus[16][0] = 27 + pos;
			}
			else
			{
				MenuStatus[16][0] = 91;						//None
			}
		}
		else MenuPopupStatus[1][0 + (bufchannel - 1)] = 1;
		
		// Quick Measurement Source
		if (MenuPopupStatus[3][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[3][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 4;x++)
			{
				if (MenuPopupStatus[3][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[3][pos] = 3;
				MenuStatus[19][0] = 27 + pos;
			}
			else
			{
				MenuStatus[19][0] = 91;						//None
			}
		}
		else MenuPopupStatus[3][0 + (bufchannel - 1)] = 1;
		
		// Quick Measurement Delay Settings Source1
		if (MenuPopupStatus[5][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[5][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[5][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[5][pos] = 3;
				MenuStatus[20][0] = 27 + pos;
			}
			else
			{
				MenuStatus[20][0] = 91;						//None
			}
		}
		else MenuPopupStatus[5][0 + (bufchannel - 1)] = 1;
		
		// Quick Measurement Delay Settings Source2
		if (MenuPopupStatus[6][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[6][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[6][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[6][pos] = 3;
				MenuStatus[20][2] = 27 + pos;
			}
			else
			{
				MenuStatus[20][2] = 91;						//None
			}
		}
		else MenuPopupStatus[6][0 + (bufchannel - 1)] = 1;
		
        // Quick Measurement Phase Settings Source1
		if (MenuPopupStatus[24][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[24][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[24][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[24][pos] = 3;
				MenuStatus[21][0] = 27 + pos;
			}
			else
			{
				MenuStatus[21][0] = 91;						//None
			}
		}
		else MenuPopupStatus[24][0 + (bufchannel - 1)] = 1;
		
		// Quick Measurement Phase Settings Source2
		if (MenuPopupStatus[25][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[25][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[25][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[25][pos] = 3;
				MenuStatus[21][2] = 27 + pos;
			}
			else
			{
				MenuStatus[21][2] = 91;						//None
			}
		}
		else MenuPopupStatus[25][0 + (bufchannel - 1)] = 1;		
		
        // Quick Measurement Thresholds Source
		if (MenuPopupStatus[26][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[26][0 + (bufchannel - 1)] = 1;
			
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[26][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[26][pos] = 3;
				MenuStatus[22][0] = 27 + pos;
			}
			else
			{
				MenuStatus[22][0] = 91;						//None
			}
		}
		else MenuPopupStatus[26][0 + (bufchannel - 1)] = 1;
		
		// Pulse Width Source
		if (MenuPopupStatus[7][0 + (bufchannel - 1)] == 3)
		{		
			MenuPopupStatus[7][0 + (bufchannel - 1)] = 1;		
		
			pos = -1;
			for (x = 0;x < 5;x++)
			{
				if (MenuPopupStatus[7][x] == 2)
				{
					pos = x;
					break;	
				}
			}
			if (pos > -1)
			{
				MenuPopupStatus[7][pos] = 3;
				MenuStatus[15][0] = 27 + pos;
			}
			else
			{
				MenuStatus[15][0] = 91;						//None
			}
		}	
		else MenuPopupStatus[7][0 + (bufchannel - 1)] = 1;
		
		Reset_LED(lednr);
	}	
	
	MenuPopupStatus[28][0] = 2;
	MenuPopupStatus[28][1] = 2;
	
	if (NumberOfChannels > 2)
	{
        MenuPopupStatus[28][2] = 2;
        MenuPopupStatus[28][3] = 2;
    }
	
	if (MenuStatus[14][1] == 138) MenuPopupStatus[28][0] = 3;
	else if (MenuStatus[14][1] == 139) MenuPopupStatus[28][1] = 3;
	else if (MenuStatus[14][1] == 140) MenuPopupStatus[28][2] = 3;
	else if (MenuStatus[14][1] == 141) MenuPopupStatus[28][3] = 3;
	
    if (Cursor_Enabled)
    {
        CursorChanged = 3;
        Cursor_Data_First_Draw = 1;
        Display::CALCCURSORDATA();
        Display::DRAWCURSORDATA(0);
    }

    // Check Measurements

    QM_Type_Old[0] = QM_Type[0];
    QM_Type_Old[1] = QM_Type[1];
    QM_Type_Old[2] = QM_Type[2];

    pos = -1;
    for (x = 0; x < 3; x++)
    {
        if (QM_Type[x] > 0)
        {
            if ((QM_Channel[x] == 1) && (Channel_1_Active == 0)) { QM_Type[x] = 0; pos = 1; }
            if ((QM_Channel[x] == 2) && (Channel_2_Active == 0)) { QM_Type[x] = 0; pos = 1; }
            if ((QM_Channel[x] == 3) && (Channel_3_Active == 0)) { QM_Type[x] = 0; pos = 1; }
            if ((QM_Channel[x] == 4) && (Channel_4_Active == 0)) { QM_Type[x] = 0; pos = 1; }
            if ((QM_Channel[x] == 5) && (Channel_Math_Active == 0)) { QM_Type[x] = 0; pos = 1; }
        }
    }

    if (pos == 1)
    {
        QM_Channel[0] = MenuStatus[19][0] - 26;
        QM_Channel[1] = MenuStatus[19][0] - 26;
        QM_Channel[2] = MenuStatus[19][0] - 26;

        QM_Changed[0] = 0;
        QM_Changed[1] = 0;
        QM_Changed[2] = 0;

        Quick_Measure_First_Draw = 1;

        New_Menu = 19;
        Menu_Changed = 1;
    }

    printf("********  Update channel %d done  ***********\n", bufchannel);
}

void Hardware::UpdateTrigger(char nr)
{
    int trg_buf, p_mul_value;
    //if (AutoTimerOff) return;

	Selected_Trigger_Source_Old = Selected_Trigger_Source;
	
	adc_ctrl_reg &= 0xFFF0;
    //ctrl_reg &= 0xC17F;  // remove holdoff and pulse bits
    ctrl_reg &= 0xC17D;  // remove holdoff and pulse bits and internel bit
    	
    if (HoldOff_Value)
    {
        trig_holdoff_reg = (unsigned long) (HoldOff.Read_Value() / (float) 0.000000008);
        ctrl_reg |= 0x2000;
    }
    else trig_holdoff_reg = 0x00000000;
                    	
  //  if (TriggerWay == 1)
    {
        if (MenuStatus[14][1] == 138)
        {
            triggering = 1;
            ctrl_reg |= 0x0002;
            adc_ctrl_reg |= 0x0001;
			
            trg_buf = (128 - ((Trigger_Pos_CH1 + 64) >> 1)) >> 1;

            if (multi_active)
            {
                if (Voltage_Correction[0][Selected_Voltage_CH1] == 0) trg_buf = 0;
                else trg_buf = int (float (trg_buf) / Volt_Correct_float[0][Selected_Voltage_CH1]);
            }

            trg_val_CHI_reg	= ((Trigger_Pos_CH1 + 64) >> 1) + trg_buf;

            trg_val_CHI_reg	= 255 - trg_val_CHI_reg;

		
            if (MenuStatus[14][0] == 2)
            {
                ctrl_reg |= 0x0004;
            }
            else if (MenuStatus[14][0] == 3)
            {
                ctrl_reg &= 0xFFFB;
            }
        }
        else if (MenuStatus[14][1] == 139)
        {
            triggering = 2;
            ctrl_reg |= 0x0002;
            adc_ctrl_reg |= 0x0002;
				
            trg_buf = (128 - ((Trigger_Pos_CH2 + 64) >> 1)) >> 1;

            if (multi_active)
            {
                if (Voltage_Correction[1][Selected_Voltage_CH2] == 0) trg_buf = 0;
                else trg_buf = int (float (trg_buf) / Volt_Correct_float[1][Selected_Voltage_CH2]);
            }

            trg_val_CHII_reg	= ((Trigger_Pos_CH2 + 64) >> 1) + trg_buf;

            trg_val_CHII_reg	= 255 - trg_val_CHII_reg;
            				
			
            //trg_val_reg	= 255 - ((Trigger_Pos_CH2 + 64) >> 1);
				
            if (MenuStatus[14][0] == 2)
            {
                ctrl_reg |= 0x0004;
            }
            else if (MenuStatus[14][0] == 3)
            {
                ctrl_reg &= 0xFFFB;
            }
        }
        else if (MenuStatus[14][1] == 140)
        {
            triggering = 3;
            ctrl_reg |= 0x0002;
            adc_ctrl_reg |= 0x0004;
			
            trg_buf = (128 - ((Trigger_Pos_CH3 + 64) >> 1)) >> 1;

            if (multi_active)
            {
                if (Voltage_Correction[2][Selected_Voltage_CH3] == 0) trg_buf = 0;
                else trg_buf = int (float (trg_buf) / Volt_Correct_float[2][Selected_Voltage_CH3]);
            }

            trg_val_CHIII_reg	= ((Trigger_Pos_CH3 + 64) >> 1) + trg_buf;

            trg_val_CHIII_reg	= 255 - trg_val_CHIII_reg;
                        	
            //trg_val_reg	= 255 - ((Trigger_Pos_CH3 + 64) >> 1);
				
            if (MenuStatus[14][0] == 2)
            {
                ctrl_reg |= 0x0004;
            }
            else if (MenuStatus[14][0] == 3)
            {
                ctrl_reg &= 0xFFFB;
            }
        }
        else if (MenuStatus[14][1] == 141)
        {
            triggering = 4;
            ctrl_reg |= 0x0002;
            adc_ctrl_reg |= 0x0008;
			
            trg_buf = (128 - ((Trigger_Pos_CH4 + 64) >> 1)) >> 1;

            if (multi_active)
            {
                if (Voltage_Correction[3][Selected_Voltage_CH4] == 0) trg_buf = 0;
                else trg_buf = int (float (trg_buf) / Volt_Correct_float[3][Selected_Voltage_CH4]);
            }

            trg_val_CHIV_reg	= ((Trigger_Pos_CH4 + 64) >> 1) + trg_buf;

            trg_val_CHIV_reg	= 255 - trg_val_CHIV_reg;
                        	
            //trg_val_reg	= 255 - ((Trigger_Pos_CH4 + 64) >> 1);
				
            if (MenuStatus[14][0] == 2)
            {
                ctrl_reg |= 0x0004;
            }
            else if (MenuStatus[14][0] == 3)
            {
                ctrl_reg &= 0xFFFB;
            }
        }

        if (MenuStatus[14][2] == 1)
        {
            triggering = 5;
				
            ctrl_reg &= 0xFFFD;
            adc_ctrl_reg &= 0xFFF0;

            if (MenuStatus[14][0] == 2) ctrl_reg |= 0x0004;
            else if (MenuStatus[14][0] == 3) ctrl_reg &= 0xFFFB;

            SwitchesTB = 0x00;
            
            if (MenuPopupStatus[8][0] == 3) SwitchesTB = 0x40;
            else if (MenuPopupStatus[8][1] == 3) SwitchesTB = 0xC0;
            else if (MenuPopupStatus[8][2] == 3) SwitchesTB = 0x80;

            if (MenuStatus[12][1] == 95) SwitchesTB |= 0x04;
            else SwitchesTB &= 0xFB;
        							
            SetSwitches(5, SwitchesTB);
#ifdef _Debug_
            printf("TE %d\n", Trigger_Pos_CHE);
#endif
            ext_trg_val_reg = Extern_Trigger_Values[Trigger_Pos_CHE];
            
            printf("extern level %d \n", ext_trg_val_reg);

            serdata->np_piodata = ext_trg_val_reg;
            serstartpwm->np_piodata = 1;
            serstartpwm->np_piodata = 0;
        }
        
        if (MenuStatus[14][3] == 1)
        {
            triggering = 5;
				
            ctrl_reg &= 0xFFFD;
            adc_ctrl_reg &= 0xFFF0;

            if (MenuStatus[14][0] == 2) ctrl_reg |= 0x0004;
            else if (MenuStatus[14][0] == 3) ctrl_reg &= 0xFFFB;

            SwitchesTB = 0x00;
            
            if (MenuPopupStatus[11][0] == 3) SwitchesTB = 0x01;
            else if (MenuPopupStatus[11][1] == 3) SwitchesTB = 0x02;

            if (MenuStatus[12][1] == 95) SwitchesTB |= 0x04;
            else SwitchesTB &= 0xFB;
        							
            SetSwitches(5, SwitchesTB);
#ifdef _Debug_
            printf("TE %d\n", Trigger_Pos_CHE);
#endif
            ext_trg_val_reg = Extern_Trigger_Values[Trigger_Pos_CHE];

            serdata->np_piodata = ext_trg_val_reg;
            serstartpwm->np_piodata = 1;
            serstartpwm->np_piodata = 0;
        }
    }

    if (TriggerWay == 2)
    {
        if (MenuStatus[15][2] == 1) ctrl_reg |= 0x1200;
        else if (MenuStatus[15][2] == 2) ctrl_reg |= 0x1400;
        else if (MenuStatus[15][2] == 3) ctrl_reg |= 0x1800;
    }

    // Autotrigger
    if ((MenuStatus[12][0] == 93) && (TriggerWay == 1)) ctrl_reg |= 0x0040;
    else ctrl_reg &= 0xFFBF;
    	
    Selected_Trigger_Source = triggering;
			
	MenuPopupStatus[28][0] = 2;
	MenuPopupStatus[28][1] = 2;
	
	if (NumberOfChannels > 2)
	{
        MenuPopupStatus[28][2] = 2;
        MenuPopupStatus[28][3] = 2;
    }
	
	if (MenuStatus[14][1] == 138) MenuPopupStatus[28][0] = 3;
	else if (MenuStatus[14][1] == 139) MenuPopupStatus[28][1] = 3;
	else if (MenuStatus[14][1] == 140) MenuPopupStatus[28][2] = 3;
	else if (MenuStatus[14][1] == 141) MenuPopupStatus[28][3] = 3;			
			
         /*
    // Rollmode
    if (MenuStatus[10][2] == 1)
    {
        adc_ctrl_reg &= 0xFFF0;
        ctrl_reg |= 0x0087;
        triggering = 0;
    }  */
        	
#ifdef _Debug_	
	if (Debug_Mode) printf("Trigger Updated Nr : %d MS12 %i MS14 %i actrl %x ctrl %x trv1 %x trv2 %x\n", nr, MenuStatus[12][0], MenuStatus[14][1], adc_ctrl_reg, ctrl_reg, trg_val_CHI_reg, trg_val_CHII_reg);
#endif	
	SetupADC();
}

void Hardware::Set_LED(int LED)
{
	LED_ON[LED] = 1;
	Send_LED();
}

void Hardware::Reset_LED(int LED)
{
	LED_ON[LED] = 0;
	Send_LED();
}

void Hardware::Clear_LED(void)
{
	int ct;
	
	for (ct = 0; ct < 13;ct++) LED_ON[ct] = 0;
}

void Hardware::Send_LED(void)
{
	int led_value = 0xFFFF;
	
	if (LED_ON[0] == 1) led_value = led_value & 0xBFFF;			// Select Channel 1
	if (LED_ON[1] == 1) led_value = led_value & 0xEFFF;			// Select Channel 2
	
	if (NumberOfChannels > 2)
	{
	   if (LED_ON[2] == 1) led_value = led_value & 0xFEFF;			// Select Channel 3
	   if (LED_ON[3] == 1) led_value = led_value & 0x7FFF;			// Select Channel 4
    }
	if (LED_ON[4] == 1) led_value = led_value & 0xDFFF;			// Select Channel Math
	if (LED_ON[5] == 1) led_value = led_value & 0xFDFF;			// General
	if (LED_ON[6] == 1) led_value = led_value & 0xFBFF;			// Cursor						
	if (LED_ON[7] == 1) led_value = led_value & 0xF7FF;			// Quick Measure
	if (LED_ON[8] == 1) led_value = led_value & 0xFFBF;			// Edge
	if (LED_ON[9] == 1) led_value = led_value & 0xFFFD;			// Pattern - Not Used
	if (LED_ON[10] == 1) led_value = led_value & 0xFF7F;		// Pulse Width
	if (LED_ON[11] == 1) led_value = led_value & 0xFFFE;		// More - Not Used
	if (LED_ON[12] == 1) led_value = led_value & 0xFFDF;		// Run/Stop Green
	if (LED_ON[13] == 1) led_value = led_value & 0xFFEF;		// Run/Stop Red
	if (LED_ON[14] == 1) led_value = led_value & 0xFFF7;		// Single Red					
	if (LED_ON[15] == 1) led_value = led_value & 0xFFFB;		// Single Green
	
	serdata->np_piodata = led_value;
	serstartled->np_piodata = 0x01;
	serstartled->np_piodata = 0x00;	
#ifdef _Debug_	
	if (Debug_Mode) printf("LED VAL : %x \n", led_value);
#endif
}

void Hardware::DoEnableRotInterrupt(void)						// Enable service routine
{
	rot_int->np_pioedgecapture = 0x00; 							// clear all existing IRQ conditions
	rot_int->np_piodirection = 0x00;							// set all bits to input
	rot_int->np_piointerruptmask = 0x01;						// enable Button IRQs

	key_reset->np_piodata = 0;
	nr_delay(1);
	key_reset->np_piodata = 1;

	rot_int->np_pioedgecapture = 0x00; 							// clear all existing IRQ conditions
	
	nr_installuserisr(na_rot_interrupt_irq,ISR_ROT,(int)rot_int);	// Install ISR for parallel I/Os
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nRot interrupt enabled.\n");  						// print on console
#endif	
}
	
void Hardware::DoDisableRotInterrupt(void)						// Disable parallel I/O service routine
{
	nr_installuserisr(na_rot_interrupt_irq,0,0); 				// Install empty routine for pio irq
	rot_int->np_piointerruptmask = 0x00;						// disable all IRQs
}

void Hardware::ISR_ROT(int context)								// Parallel I/O Interrupt subroutine
{
    int ct;
	int KeyData = key->np_piodata;								// Get interrupt data to asign respective ISR
	int Rot_Dir = KeyData & 0x000FFF;							// Get interrupt data to asign respective ISR
	
	     /*
    if (MenuStatus[10][2] == 1)
    {
        DoDisableTimer2Interrupt();
        Continius = 0;
        UserIface_active = 0;
        TriggerModeChanged = 1;
        Display::StatusUpdate();
    }	   */

    ADC_Data_Available_cnt = 2;
	
	Rotary_Switch = (KeyData & 0xFFF000) >> 12;

	for (ct = 0; ct < 100; ct++){};
	
	rot_speed_read->np_piodata = 1;
	Rotary_Steps = key->np_piodata & 0x000FFF;							// Get interrupt data to asign respective ISR

	
	//printf("\nkeydata : %3x RotSW %3x RotDir %i RotaryDirec %i RotDirMem %i RotSpe : %i \n\n", key->np_piodata, Rotary_Switch, Rot_Dir, Rotary_Direction, Rotary_Direction_mem, Rotary_Steps);	

	rot_speed_read->np_piodata = 0;

	key_reset->np_piodata = 0;
	for (ct = 0; ct < 100; ct++){};
	key_reset->np_piodata = 1;

    Rotary_Changed = 1;
    //UserIface_active = 1;
    //UserIface_active_2 = 1;
       	
	rot_int->np_pioedgecapture = 0;								// clear IRQ conditions		

	if (Rotary_Switch == Rot_Dir) Rotary_Direction = 1;
    else Rotary_Direction = 0;

#ifdef _Debug_IRQ_
    if (Debug_Mode) printf("RotSW %3x RotDir %i RotaryDirec %i RotDirMem %i RotSpe : %i \n", Rotary_Switch, Rot_Dir, Rotary_Direction, Rotary_Direction_mem, Rotary_Steps);	
#endif
    Rotary_Direction_mem = Rotary_Direction;

    if (SingleMode == 1)
    {
        SingleMode = 0;

        LED_ON[14] = 0;
        LED_ON[15] = 0;
    }

}

void Hardware::Rotary_Interface(void)
{
    if (Rotary_Changed == 0) return;
    Rotary_Changed = 0;

//    ClearPlanes();

    if (Splash_drawed)
    {
        Display::REMOVE_SPLASH();
        Display::DrawStartScreen();
        Splash_drawed = false;

        TimebaseChanged = 1;
        TimeOffsetChanged = 1;
        TriggerLevelChanged = 1;
        TriggerModeChanged = 1;
        TriggerWayChanged = 1;
        VoltageChangedCh1 = 1;									// Was Voltage changed
        VoltageChangedCh2 = 1;									// Was Voltage changed
        VoltageChangedCh3 = 1;									// Was Voltage changed
        VoltageChangedCh4 = 1;									// Was Voltage changed          		
		
        Display::StatusUpdate();
	
        CursorChanged = 3;
        Cursor_Data_First_Draw = 1;
        Display::DRAWCURSORDATA(0);

        Quick_Measure_First_Draw = 1;
        Display::DRAWQMDATA(0); 	

        Display::DRAW_ALL_CURSOR();

        if (Continius) Start_Record();

        return;
    }

    if ((Active_Menu == 12) || (Active_Menu == 15)) Rotary_Direction_mem_pulse = Rotary_Direction;



#ifdef _Debug_
    if (Debug_Mode) printf("Steps = %i Dir = %i \n", Rotary_Steps, Rotary_Direction);
#endif
         if ((Rotary_Switch & 0x00000001) == 0x00000001) { ResetTimer(); ON_Rotary_Position(); }     // ON Trigger Position
    else if ((Rotary_Switch & 0x00000002) == 0x00000002) { ResetTimer(); ON_Trigger_Level(); }
    else if ((Rotary_Switch & 0x00000004) == 0x00000004) { ResetTimer(); ON_Main_Wheel(); }
    else if ((Rotary_Switch & 0x00000008) == 0x00000008) { ResetTimer(); ON_Timebase(); }
    else if ((Rotary_Switch & 0x00000010) == 0x00000010) { ResetTimer(); ON_Zero_Channel_2(); }
    else if ((Rotary_Switch & 0x00000020) == 0x00000020) { ResetTimer(); ON_Voltage_Channel_2(); }
    else if ((Rotary_Switch & 0x00000040) == 0x00000040) { ResetTimer(); ON_Voltage_Channel_1(); }
    else if ((Rotary_Switch & 0x00000080) == 0x00000080) { ResetTimer(); ON_Zero_Channel_1(); }
    else if ((Rotary_Switch & 0x00000100) == 0x00000100) { ResetTimer(); ON_Zero_Channel_4(); }
    else if ((Rotary_Switch & 0x00000200) == 0x00000200) { ResetTimer(); ON_Voltage_Channel_4(); }
    else if ((Rotary_Switch & 0x00000400) == 0x00000400) { ResetTimer(); ON_Voltage_Channel_3(); }
    else if ((Rotary_Switch & 0x00000800) == 0x00000800) { ResetTimer(); ON_Zero_Channel_3(); }

    Rotary_Steps = 0;


    ////if ((adc_started == false) && (Continius)) Start_Record();
}

void Hardware::ON_Rotary_Position(void)
{
	int pos = 0;
	
	int cd_size_buf = (int) (Cursor_Delayed_Size / 2);
	
	int rot_buf = Rotary_Steps;


//	if (Selected_Timebase > 6) rot_buf = Rotary_Steps << 2;
	
	//if (MenuStatus[10][2] == 1) return;
	
#ifdef _Debug_Memory_
    if (Debug_Mode) printf("TB Offset MS[10][1] = %d MS[10][2] = %d\n", MenuStatus[10][1], MenuStatus[10][2]);
#endif	

    if ((MenuStatus[10][1] == 0) || (MenuStatus[10][1] == 246))
    {
        rot_buf = ((int) ((float)rot_buf * ZFT_float));
        
        if ((rot_buf > ((int) ((float)5 * ZFT_float))) && (rot_buf < ((int) ((float)11 * ZFT_float)))) rot_buf = rot_buf * 3;
        else if (rot_buf > ((int) ((float)10 * ZFT_float))) rot_buf = rot_buf * 7;	

        //if ((rot_buf > 5) && (rot_buf < 11)) rot_buf = rot_buf * 15;
        //else if (rot_buf > 10) rot_buf = rot_buf * 40;	
        	
        if (Rotary_Direction)
        {
            if (Selected_Timebase < 9)
            {
                if ((Trig_Mem_Pos + SIG_Size[ZIT_short] + rot_buf) < 16250) Trig_Mem_Pos = Trig_Mem_Pos + rot_buf;
                else Trig_Mem_Pos = 16250 - SIG_Size[ZIT_short];
            }
            else
            {
                if ((Trig_Mem_Pos + SIG_Size[ZIT_short] + rot_buf) < 4070) Trig_Mem_Pos = Trig_Mem_Pos + rot_buf;
                else Trig_Mem_Pos = 4070 - SIG_Size[ZIT_short];
            }
        }
        else
        {
            if ((Trig_Mem_Pos - rot_buf) > 100) Trig_Mem_Pos = Trig_Mem_Pos - rot_buf;
            else Trig_Mem_Pos = 100;
        }

    }    		
    else  // Delayed mode
    {
        if ((rot_buf > 5) && (rot_buf < 11)) rot_buf = rot_buf * 3;
        else if (rot_buf > 10) rot_buf = rot_buf * 7;	
        
        if (Rotary_Direction)
        {
            if ((dmode_Window_Offset_Pos + rot_buf) < (300 - cd_size_buf)) dmode_Window_Offset_Pos = dmode_Window_Offset_Pos + rot_buf;
            else dmode_Window_Offset_Pos = 300 - cd_size_buf;
        }
        else
        {
            if ((dmode_Window_Offset_Pos - rot_buf) > (-300 + cd_size_buf)) dmode_Window_Offset_Pos = dmode_Window_Offset_Pos - rot_buf;
            else dmode_Window_Offset_Pos = (-300 + cd_size_buf);
        }
    }

    Recalc_Vars();
    
 // TMW changed 
	if ((MenuStatus[10][1] == 0) || (MenuStatus[10][1] == 246))
		{
        if (Memory_Window_visible)
            Display::DRAWMEMORY(0, 0, 1);
        else
	  		Display::DRAWMEMORY(0, 1, 1);
     	}
// TMW change ends
    
    
    Display::CALCPRETRIGGER();
    Display::DRAW_ALL_CURSOR();

    //Display::DRAWSTATUS(5, 1);									// Draw Pre Trigger

    //if (Continius == 0)
    //UserIface_active = 0;
    DrawSignals_Needed = 1;


#ifdef _Debug_Memory_
    if (Debug_Mode) printf("TB Offset = %d\n", Timebase_Offset_Pos);
#endif
}

void Hardware::ON_Trigger_Level(void)
{
    if (MenuStatus[14][3] == 1) return;
    if ((MenuPopupStatus[8][2] == 3) && (MenuStatus[14][2] == 1)) return;
    if (Display_Mode) return;
    
    if ((Rotary_Steps > 5) && (Rotary_Steps < 11)) Rotary_Steps = Rotary_Steps * 3;
    else if (Rotary_Steps > 10) Rotary_Steps = Rotary_Steps * 7;

    if (Rotary_Direction == 0)
    {
	    //if (triggering == 0) return;
		if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		
		switch(Selected_Trigger_Source)
		{
			case 1: if ((Trigger_Pos_CH1 + Rotary_Steps) < 386) Trigger_Pos_CH1 = Trigger_Pos_CH1 + Rotary_Steps; else Trigger_Pos_CH1 = 386; Trigger_Pos_CH1_os = 0; break;
			case 2: if ((Trigger_Pos_CH2 + Rotary_Steps) < 386) Trigger_Pos_CH2 = Trigger_Pos_CH2 + Rotary_Steps; else Trigger_Pos_CH2 = 386; Trigger_Pos_CH2_os = 0; break;
			case 3: if ((Trigger_Pos_CH3 + Rotary_Steps) < 386) Trigger_Pos_CH3 = Trigger_Pos_CH3 + Rotary_Steps; else Trigger_Pos_CH3 = 386; Trigger_Pos_CH3_os = 0; break;
			case 4: if ((Trigger_Pos_CH4 + Rotary_Steps) < 386) Trigger_Pos_CH4 = Trigger_Pos_CH4 + Rotary_Steps; else Trigger_Pos_CH4 = 386; Trigger_Pos_CH4_os = 0; break;
			case 5: if ((Trigger_Pos_CHE + 1) < 32) Trigger_Pos_CHE = Trigger_Pos_CHE + 1; else Trigger_Pos_CHE = 32; break;
		}
			
		
        UpdateTrigger(16);

		Display::DRAWSTATUS(6, 1);									// Draw Trigger Level

        //S Display::Update_Channel_Data(Selected_Trigger_Source);
        VS_TrigLevelChanged = 1;

        DrawSignals_Needed = 1;
    }

    else
    {
	   //if (triggering == 0) return;
		if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		
		switch(Selected_Trigger_Source)
		{
			case 1: if ((Trigger_Pos_CH1 - Rotary_Steps) > 0) Trigger_Pos_CH1 = Trigger_Pos_CH1 - Rotary_Steps; else Trigger_Pos_CH1 = 0; break;
			case 2: if ((Trigger_Pos_CH2 - Rotary_Steps) > 0) Trigger_Pos_CH2 = Trigger_Pos_CH2 - Rotary_Steps; else Trigger_Pos_CH2 = 0; break;
			case 3: if ((Trigger_Pos_CH3 - Rotary_Steps) > 0) Trigger_Pos_CH3 = Trigger_Pos_CH3 - Rotary_Steps; else Trigger_Pos_CH3 = 0; break;
			case 4: if ((Trigger_Pos_CH4 - Rotary_Steps) > 0) Trigger_Pos_CH4 = Trigger_Pos_CH4 - Rotary_Steps; else Trigger_Pos_CH4 = 0; break;
			case 5: if ((Trigger_Pos_CHE - 1) > 0) Trigger_Pos_CHE = Trigger_Pos_CHE - 1; else Trigger_Pos_CHE = 0; break;
		}

		
        UpdateTrigger(17);

		Display::DRAWSTATUS(6, 1);									// Draw Trigger Level

        //S Display::Update_Channel_Data(Selected_Trigger_Source);
        VS_TrigLevelChanged = 1;

        DrawSignals_Needed = 1;
    }
}

void Hardware::ON_Main_Wheel(void)
{
    if (Rotary_Direction)
    {
        HandleMainWheel(1);
    }
    else
    {
        HandleMainWheel(0);
    }
}

void Hardware::ON_Timebase(void)
{
    int rbuf = Rotary_Steps;

//    reset_watchdog->np_piodata = 0x00;

    //printf("On_TB_1_%d : rbuf : %d distb :%d = Sel %d + idx %d\n", Rotary_Direction, rbuf, Display_Timebase, Selected_Timebase, SIGNALFaktor_idx);

    Display_Timebase_Old = Display_Timebase;
    Selected_Timebase_Old = Selected_Timebase;
    SIGNALFaktor_idx_Old = SIGNALFaktor_idx;
                
    if (Rotary_Direction)
    {
//		if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }          	
		
		// Delayed Mode
		if (MenuStatus[10][1] == 1)
		{
            if (Continius == 0)
            {
                while (rbuf > 0)
                {
                    if (dmode_SIGNALFaktor_idx > 0)
                    {	
                        dmode_SIGNALFaktor_idx--;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((dmode_Selected_Timebase > 2) && (dmode_Selected_Timebase < 5) && (dmode_SIGNALFaktor_idx == 0) && (Selected_Timebase < 5))
                    {
                        dmode_Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    rbuf--;
                }

                DrawSignals_Needed = 1;
                UserIface_active = 0;

            }
            else
            {
                while (rbuf > 0)
                {
                    if ((dmode_Selected_Timebase > 4) && (dmode_SIGNALFaktor_idx == 4))
                    {
                        dmode_Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    else if (dmode_SIGNALFaktor_idx > 0)
                    {	
                        dmode_SIGNALFaktor_idx--;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((dmode_Selected_Timebase > 2) && (dmode_SIGNALFaktor_idx == 0) && (Selected_Timebase < 5))
                    {
                        dmode_Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    rbuf--;
                }
            }			
		}    /*
		// Roll Mode
		else if (MenuStatus[10][2] == 1)
		{
            while (rbuf > 0)
            {		
                if (ROLLMODE_TB > 3)
                {
                    ROLLMODE_TB--;
                    ROLLMODE_OFFSET = 601;
                    ROLLMODE_STARTED = false;
                    ROLLMODE_Value_rec = false;
                    ClearPlanes();
                }
                rbuf--;
            }
		}    */
		// Main Mode
		else		
		{	  	
            if (Continius == 0)
            {
                while (rbuf > 0)
                {
                    if (SIGNALFaktor_idx > 0)
                    {	
                        SIGNALFaktor_idx--;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((Selected_Timebase > 2) && (Selected_Timebase < 5) && (SIGNALFaktor_idx == 0))
                    {
                        Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    rbuf--;
                }

                DrawSignals_Needed = 1;
                UserIface_active = 0;

            }
            else
            {
                while (rbuf > 0)
                {
                    if ((Selected_Timebase > 4) && (SIGNALFaktor_idx == 4))
                    {
                        Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((Selected_Timebase > 6) && (SIGNALFaktor_idx == 2))
                    {
                        Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    else if (SIGNALFaktor_idx > 0)
                    {	
                        SIGNALFaktor_idx--;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((Selected_Timebase > 2) && (SIGNALFaktor_idx == 0))
                    {
                        Selected_Timebase--;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    
                    if ((Selected_Timebase == 7) && (SIGNALFaktor_idx == 4))
                    {
                        if (Selected_Timebase_Old < 6)
                        {
                            Selected_Timebase = 9;
                            SIGNALFaktor_idx = 2;
                        }
                    }

                    if ((Selected_Timebase == 8) && (SIGNALFaktor_idx == 2))
                    {
                        if (Selected_Timebase_Old == 9)
                        {
                            Selected_Timebase = 6;
                            SIGNALFaktor_idx = 4;
                        }
                    }

                    rbuf--;
                }
            }		
		}
    }
    else
    {
		if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }

        // Delayed Mode
		if (MenuStatus[10][1] == 1)
		{	
            if (Continius == 0)
            {
                while (rbuf > 0)
                {
                    if ((dmode_Selected_Timebase > 1) && (dmode_Selected_Timebase < 4) && (dmode_SIGNALFaktor_idx == 0) && (dmode_Selected_Timebase < (Selected_Timebase - 1)))
                    {
                        dmode_Selected_Timebase++;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
	
                    else if ((dmode_SIGNALFaktor_idx < 4) && (dmode_SIGNALFaktor_idx < (SIGNALFaktor_idx - 1)) && (dmode_Selected_Timebase == Selected_Timebase))
                    {	
                        dmode_SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }
                    
                    rbuf--;
                }                	

                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }	
            else
            {
                while (rbuf > 0)
                {
                    if ((dmode_Selected_Timebase > 1) && (dmode_Selected_Timebase < 5) && (((dmode_SIGNALFaktor_idx == 0) && (dmode_Selected_Timebase < (Selected_Timebase - 1)))  || ((SIGNALFaktor_idx > 0) && (dmode_Selected_Timebase < Selected_Timebase)) ))
                    {
                        dmode_Selected_Timebase++;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
	
                    else if ((dmode_SIGNALFaktor_idx < 4) && (dmode_SIGNALFaktor_idx < (SIGNALFaktor_idx - 1)) && (dmode_Selected_Timebase == Selected_Timebase))
                    {	
                        dmode_SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }

                    rbuf--;
		        }
		    }       	
		}   /*
		// Roll Mode
		else if (MenuStatus[10][2] == 1)
		{
            while (rbuf > 0)
            {		
                if (ROLLMODE_TB < 8)
                {
                    ROLLMODE_TB++;
                    ROLLMODE_OFFSET = 601;
                    ROLLMODE_STARTED = false;	
                    ROLLMODE_Value_rec = false;
                    ClearPlanes();
                }
                rbuf--;
            }
		}    */
		// Main Mode
		else
		{        		                                                             		
            if (Continius == 0)
            {
                while (rbuf > 0)
                {
                	if ((Selected_Timebase > 1) && (Selected_Timebase < 4) && (SIGNALFaktor_idx == 0))
                	{
                		Selected_Timebase++;
                		TimebaseChanged = 1;
                		SIGNALFaktorChanged = 1;
                	}                	
                	else if ((Selected_Timebase < 8) && (SIGNALFaktor_idx < 4))
                	{	
                        SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }
                	else if ((Selected_Timebase > 7) && (SIGNALFaktor_idx < 2))
                    {	
                        SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }

                    rbuf--;
                }

                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }	
            else
            {
                //printf("Here we are %d %d %d\n", Selected_Timebase, SIGNALFaktor_idx, Selected_Timebase_Old);
                		
                while (rbuf > 0)
                {
                    if (Selected_Timebase == 2)
                    {
                        Selected_Timebase++;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }
                    else if (Selected_Timebase == 3)
                    {
                        Selected_Timebase++;
                        TimebaseChanged = 1;
                        SIGNALFaktorChanged = 1;
                    }		
                    else if ((Selected_Timebase < 7) && (SIGNALFaktor_idx < 4))
                    {	
                        SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((Selected_Timebase > 6) && (SIGNALFaktor_idx < 2))
                    {	
                        SIGNALFaktor_idx++;
                        SIGNALFaktorChanged = 1;
                    }
                    else if ((Selected_Timebase < 7) && (SIGNALFaktor_idx == 4))
                    {
                        if (Selected_Timebase < 31)
                        {
                            Selected_Timebase++;
                            TimebaseChanged = 1;
                            SIGNALFaktorChanged = 1;
                        }
                    }
                    else if ((Selected_Timebase > 6) && (SIGNALFaktor_idx == 2))
                    {
                        if (Selected_Timebase < 31)
                        {
                            Selected_Timebase++;
                            TimebaseChanged = 1;
                            SIGNALFaktorChanged = 1;
                        }
                    }
                    
                    if ((Selected_Timebase == 7) && (SIGNALFaktor_idx == 4))
                    {
                        if (Selected_Timebase_Old < 7)
                        {
                            Selected_Timebase = 9;
                            SIGNALFaktor_idx = 2;
                        }
                    }

                    if ((Selected_Timebase == 8) && (SIGNALFaktor_idx == 2))
                    {
                        if (Selected_Timebase_Old > 8)
                        {
                            Selected_Timebase = 6;
                            SIGNALFaktor_idx = 4;
                        }
                    }

                    rbuf--;
		        }
                //printf("Here we are2 %d %d %d\n", Selected_Timebase, SIGNALFaktor_idx, Selected_Timebase_Old);		
		    }
        }		
    }
    
	timebase_reg = tb_value[Selected_Timebase];
    Display_Timebase = Selected_Timebase + SIGNALFaktor_idx;
    
    if (Selected_Timebase > 7) adc_change12_reg |= 0x01000000;
    else adc_change12_reg &= 0xFEFFFFFF;

//    printf("On_TB_2_O distb_old :%d = Sel_old %d + idx_old %d\n", Display_Timebase_Old, Selected_Timebase_Old, SIGNALFaktor_idx_Old);    
//    printf("On_TB_2_%d : rbuf : %d distb :%d = Sel %d + idx %d\n", Rotary_Direction, rbuf, Display_Timebase, Selected_Timebase, SIGNALFaktor_idx);
    //printf("TB_reg %8x \n", timebase_reg);

   	Recalc_Vars();

    //printf("TPM : %d  %d\n", Trig_Pos_Mem, Trig_Pos_Display);
       	   	
	if (Cursor_Enabled)
	{
        Display::CALCCURSORDATA();

        if (Active_Menu == 16)
        {
            MenuItemChanged[1] = 1;
            MenuItemChanged[2] = 1;
            New_Menu = Active_Menu;
        }
        Menu_Changed = 1;
        CursorChanged = 1;
    }
	
	Display::DRAWSTATUS(0, 1);
	SetupADC();	

	if (Channel_1_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate_delayed[0]);
	}
	
	if (Channel_2_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);
	}
	
	if (Channel_3_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);
	}
	
	if (Channel_4_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);
	}	

// TMW changed
	if (Memory_Window_visible) 			// if Memory Window visible
      Display::DRAWMEMORY(0, 0, 1); 	// redraw Memory Window
    else
	  Display::DRAWMEMORY(0, 1, 1); 	// if Memory Window not visible yet, make it visible.
// TMW change ends



   /*
    if (Cursor_Vertical_Position_Real1 < SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float)) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
    if (Cursor_Vertical_Position_Real1 > SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float)) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);

    if (Cursor_Vertical_Position_Real2 < SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float)) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
    if (Cursor_Vertical_Position_Real2 > SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float)) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);
 */

    Menu_Changed = 1;
    MenuItemChanged[4] = 1;
    Display::CALCPRETRIGGER();
    Display::CALCCURSORDATA();
    Display::DRAW_ALL_CURSOR();

//    reset_watchdog->np_piodata = 0x01;

#ifdef _Debug_
    if (Debug_Mode) printf("VCA %i CVP1 %i ST : %i SST : %i SF : %i SO : %i \n", Cursor_Vertical_Active, Cursor_Vertical_Position_Real1, Selected_Timebase, SIGNAL_StartFr_idx, SIGNALFaktor_idx , SIGNAL_OFFSET);	
    if (Debug_Mode) printf("st %d dst %d sfi %d dsfi %d   tdfm %f dtdfm %f  fac %f\n", Selected_Timebase , dmode_Selected_Timebase, SIGNALFaktor_idx, dmode_SIGNALFaktor_idx, Timebase_Delayed_Factor_Matrix[Selected_Timebase][SIGNALFaktor_idx], Timebase_Delayed_Factor_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx], Timebase_Delayed_Factor_Matrix[Selected_Timebase][SIGNALFaktor_idx] / Timebase_Delayed_Factor_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx]);
#endif
}

void Hardware::Recalc_Vars(void)
{
    ZIT_short_old = ZIT_short;
   	ZIT_short_dmode_old = ZIT_short_dmode;
   	ZFT_float_old = ZFT_float;
   	ZFT_float_dmode_old = ZFT_float_dmode;
    OFT_float_old = OFT_float;
    	
    ZIT_short = Zoom_Index_Table[Selected_Timebase][SIGNALFaktor_idx];
    ZIT_short_dmode = Zoom_Index_Table[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx];

    ZFT_float = Zoom_Faktor_Table[ZIT_short];
    ZFT_float_dmode = Zoom_Faktor_Table[ZIT_short_dmode];

    OFT_float = Offset_Faktor_Table[ZIT_short];

//    printf("1 ZITs : %d  %d  ", ZIT_short, ZIT_short_old);
//    printf("ZFTf : %f  %f  ", ZFT_float, ZFT_float_old);
//    printf("OFTf : %f  %f\n", OFT_float, OFT_float_old);    
    
//    printf("TPM : %d  %d\n", Trig_Pos_Mem, Trig_Pos_Display);

    //if ((Selected_Timebase > 3) && (Selected_Timebase_Old > 3))
    {
      //  if (ZFT_float_old != ZFT_float)
        {
            // Correct the Trigger Position
            Trig_Pos_Mem = (int)((float) Trig_Pos_Mem * (ZFT_float / ZFT_float_old));
            
            // Correct the Memory Position
            Trig_Mem_Pos = (int)((float) (Trig_Mem_Pos) * (ZFT_float / ZFT_float_old));
        }
    }
    
//    printf("A TPM : %d  %d\n\n", Trig_Pos_Mem, Trig_Pos_Display); 
    
    // Check memory pos
    
    //if (Selected_Timebase < 4)
    {
        if (Trig_Mem_Pos < 100) 
        {
//        	printf("tmp : %d = to small\n", Trig_Mem_Pos);
        	
        	Trig_Pos_Mem = Trig_Pos_Mem + (100 - Trig_Mem_Pos);
        	
        	Trig_Mem_Pos = 100;
        	
        }
       // if (Trig_Pos_Mem < 100) Trig_Pos_Mem = 100;
    }/*
    else if (Selected_Timebase == 4)
    {
        if (Trig_Mem_Pos < 100) Trig_Mem_Pos = 100;
    }        
    else */if (Selected_Timebase < 9)
    {
        if ((Trig_Mem_Pos + SIG_Size[ZIT_short]) > 16250) Trig_Mem_Pos = 16250 - SIG_Size[ZIT_short];
    }
    else
    {
        if ((Trig_Mem_Pos + SIG_Size[ZIT_short]) > 4070) Trig_Mem_Pos = 4070 - SIG_Size[ZIT_short];
    }

//   printf("B TPM : %d  %d\n\n", Trig_Pos_Mem, Trig_Pos_Display); 
    
    //// if (Trig_Mem_Pos > 583) Trig_Mem_Pos = 583;
   //// if (Trig_Mem_Pos < 1) Trig_Mem_Pos = 1;

    if (MenuStatus[10][1] == 1)
    {
        dmode_factor = Timebase_Delayed_Factor_Matrix[Selected_Timebase][SIGNALFaktor_idx] / Timebase_Delayed_Factor_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx];

        Cursor_Delayed_1 = (300 - (int) (((float) 600 / dmode_factor) / 2)) + dmode_Window_Offset_Pos;
        Cursor_Delayed_2 = Cursor_Delayed_1 + (int) ((float) 600 / dmode_factor);
        Cursor_Delayed_Size = Cursor_Delayed_2 - Cursor_Delayed_1;
    }
    
    Recalc_Trigger();

    ////if (Selected_Timebase < 4) FirStartCH = (int)((float) Trig_Mem_Pos * OFT_float) + 20;
    if (Selected_Timebase < 4) FirStartCH = Trig_Mem_Pos + 40;
    
    
//    printf("2 ZITs : %d  %d  ", ZIT_short, ZIT_short_old);
//    printf("ZFTf : %f  %f  ", ZFT_float, ZFT_float_old);
//    printf("OFTf : %f  %f\n", OFT_float, OFT_float_old);    
    
//    printf("2 TPM : %d  %d\n\n", Trig_Pos_Mem, Trig_Pos_Display);    

}

void Hardware::Recalc_Trigger(void)
{
    FirStartCH_delayed = (short) (ZFT_float * (float) (Cursor_Delayed_1 + (Cursor_Delayed_Size >> 1))) - 10;
    
//    printf("C1 pre : %x TPM : %d TMP : %d - %d\n\n", pre_reg, Trig_Pos_Mem, Trig_Mem_Pos, Trig_Pos_Display);
    
    Trig_Pos_Display = (int) ((float)(Trig_Pos_Mem - Trig_Mem_Pos) / ZFT_float);
    Trig_Pos_Display_dmode = (int) (((float)(Trig_Pos_Mem - Trig_Mem_Pos) / ZFT_float_dmode) - ((float) Cursor_Delayed_1 * (ZFT_float / ZFT_float_dmode)));
    
    if (Selected_Timebase < 9) pre_reg = (Trig_Pos_Mem >> 2) + PreReg_Offset;
    else pre_reg = (Trig_Pos_Mem) + PreReg_Offset;

//    printf("C2 pre : %x TPM : %d TMP : %d - %d\n\n", pre_reg, Trig_Pos_Mem, Trig_Mem_Pos, Trig_Pos_Display);
    
    if (pre_reg > 0x1000)
    {
    	printf("pre overrun \n");
        Trig_Pos_Mem = 300;
        Trig_Mem_Pos = 100;

        Trig_Pos_Display = (int) ((float)(Trig_Pos_Mem - Trig_Mem_Pos) / ZFT_float);

        if (Selected_Timebase < 9) pre_reg = (Trig_Pos_Mem >> 2) + PreReg_Offset;
        else pre_reg = (Trig_Pos_Mem) + PreReg_Offset;
    }
    
//    printf("C3 pre : %x TPM : %d TMP : %d - %d\n\n", pre_reg, Trig_Pos_Mem, Trig_Mem_Pos, Trig_Pos_Display);
}

void Hardware::ON_Voltage_Channel_1(void)
{
    int cnt;
    float fvolt_factor = 0;
    float fvolt_factor2 = 0;

    int shift_cnt = 0;

    if (Channel_1_Active == false) return;

    if (Rotary_Direction == 1)
    {
        if (Selected_Voltage_CH1 == 3) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH1 - Rotary_Steps) > 3)
		{
			Selected_Voltage_CH1 -= Rotary_Steps;
		}
		else Selected_Voltage_CH1 = 3;
		
		SetSwitches(1, Selected_Voltage_CH1);
		VoltageChangedCh1 = 1;

        if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }

        if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
        Display::DRAWSTATUS(1, 1);											// Draw Voltage Channel 1
        Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
        if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
        {
            MenuItemChanged[3] = 1;
			MenuItemChanged[4] = 1;
				
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }
        if (Active_Menu == 19)
        {
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }	
             /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }*/			
    }
    else
    {
        if (Selected_Voltage_CH1 == 11) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH1 + Rotary_Steps) < 11)
		{
			Selected_Voltage_CH1 += Rotary_Steps;       			
		}
        else Selected_Voltage_CH1 = 11;	

		SetSwitches(1, Selected_Voltage_CH1);
		VoltageChangedCh1 = 1;
			
		if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }
		if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
		Display::DRAWSTATUS(1, 1);											// Draw Voltage Channel 1
		Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
			
		if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
		{
            MenuItemChanged[3] = 1;
            MenuItemChanged[4] = 1;
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
		if (Active_Menu == 19)
		{
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
                  /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }   */
    }

    Rotary_Steps = 0;
    ON_Zero_Channel_1();
}

void Hardware::ON_Zero_Channel_1(void)
{
    int lChannel1_Zero_Sign_Offset_1, lChannel1_Zero_Sign_Offset_2, lChannel1_Zero_Sign_Offset_3, Virtual_ZeroLevel_Buf;

    int rotbuf;
    if (Display_Mode) return;

    if ((Rotary_Steps > 5) && (Rotary_Steps < 11)) rotbuf = Rotary_Steps * 3;
    else if (Rotary_Steps > 10) rotbuf = Rotary_Steps * 7;
    else rotbuf = Rotary_Steps;
	

    if (rotbuf)
    {
        if (Rotary_Direction == 0)
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if (Display_Mode)
            {
                if ((Virtual_ZeroLevelXYCH1 + rotbuf) > 239) // 0
                {
                    Virtual_ZeroLevelXYCH1 = Virtual_ZeroLevelXYCH1 + rotbuf;
                }		
                else
                {
                    Virtual_ZeroLevelXYCH1 = 239;  // 0
                }
            }
            else
            {
                if ((Virtual_ZeroLevelCH1 + rotbuf) < 4095) // 0
                {
                    Virtual_ZeroLevelCH1 = Virtual_ZeroLevelCH1 + rotbuf;
                }		
                else
                {
                    Virtual_ZeroLevelCH1 = 4095;  // 0
                }
            }         	
		
            if (Continius == false)
            {
                CH1_Zero_Offset = CH1_Zero_Offset + rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }  	
		
            VS_ZeroChangedCh1 = 1;

            if ((Virtual_ZeroLevelCH1 < 4095) && (Virtual_ZeroLevelCH1 > -4095))
            {
                if (Trigger_Pos_CH1_os < 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH1_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH1_os++;
                    }
                }
                if ((Trigger_Pos_CH1 + rotbuf) <= 386) Trigger_Pos_CH1 = Trigger_Pos_CH1 + rotbuf;
                else
                {
                    Trigger_Pos_CH1_os = Trigger_Pos_CH1_os + (rotbuf - (386 - Trigger_Pos_CH1));
                    Trigger_Pos_CH1 = 386;	
                }
            }
            
            if (Selected_Trigger_Source == 1)
            {
                UpdateTrigger(18);	
            }
        }
        else
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if (Display_Mode)
            {
                if ((Virtual_ZeroLevelXYCH1 - rotbuf) > -239) // 0
                {
                    Virtual_ZeroLevelXYCH1 = Virtual_ZeroLevelXYCH1 - rotbuf;
                }		
                else
                {
                    Virtual_ZeroLevelXYCH1 = -239;  // 0
                }
            }
            else
            {
                if ((Virtual_ZeroLevelCH1 - rotbuf) > -4095) // 0
                {
                    Virtual_ZeroLevelCH1 = Virtual_ZeroLevelCH1 - rotbuf;
                }		
                else
                {
                    Virtual_ZeroLevelCH1 = -4095;  // 0
                }
            }

            if (Continius == false)
            {
                CH1_Zero_Offset = CH1_Zero_Offset - rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }		
            
            VS_ZeroChangedCh1 = 1;
		
            if ((Virtual_ZeroLevelCH1 < 4095) && (Virtual_ZeroLevelCH1 > -4095))
            {
                if (Trigger_Pos_CH1_os > 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH1_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH1_os--;
                    }
                }
                if ((Trigger_Pos_CH1 - rotbuf) >= 0) Trigger_Pos_CH1 = Trigger_Pos_CH1 - rotbuf;
                else
                {
                    Trigger_Pos_CH1_os = Trigger_Pos_CH1_os - (rotbuf - Trigger_Pos_CH1);
                    
                    Trigger_Pos_CH1 = 0;
                }
            }
            
            if (Selected_Trigger_Source == 1)
            {
                UpdateTrigger(19);	
            }
        }
    }


    if (Display_Mode)
    {
        ZeroLevelCH1 = Virtual_ZeroLevelXYCH1 + 240;
        if (ZeroLevelCH1 < 0) ZeroLevelCH1 = 0;
        if (ZeroLevelCH1 > 480) ZeroLevelCH1 = 480;

        Virtual_ZeroLevel_Buf = Virtual_ZeroLevelXYCH1 >> 2;
    }
    else
    {
        ZeroLevelCH1 = Virtual_ZeroLevelCH1 + 192;
        if (ZeroLevelCH1 < 0) ZeroLevelCH1 = 0;
        if (ZeroLevelCH1 > 385) ZeroLevelCH1 = 385;

        Virtual_ZeroLevel_Buf = Virtual_ZeroLevelCH1 >> 2;
    }

    lChannel1_Zero_Sign_Offset_1 = 8192 + Channel1_Zero_Sign_Offset_1;
    lChannel1_Zero_Sign_Offset_2 = 8192 + Channel1_Zero_Sign_Offset_2;
    lChannel1_Zero_Sign_Offset_3 = 8192 + Channel1_Zero_Sign_Offset_3 + Virtual_ZeroLevel_Buf;

    if (Display_Mode)
    {
        switch(Selected_Voltage_CH1)
        {
            case 0: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 1) / Volt_Correct_float[0][0])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -   1 mV
            case 1: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 2) / Volt_Correct_float[0][1])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 -   2 mV
            case 2: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 3) / Volt_Correct_float[0][2])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 -   5 mV
            case 3: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 1) / Volt_Correct_float[0][3])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -  10 mV
            case 4: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 2) / Volt_Correct_float[0][4])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 -  20 mV
            case 5: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 3) / Volt_Correct_float[0][5])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 -  50 mV
            case 6: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 1) / Volt_Correct_float[0][6])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 - 100 mV
            case 7: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 2) / Volt_Correct_float[0][7])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 - 200 mV
            case 8: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 3) / Volt_Correct_float[0][8])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 - 500 mV
            case 9: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 1) / Volt_Correct_float[0][9])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -   1 V
            case 10: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 2) / Volt_Correct_float[0][10])) + lChannel1_Zero_Sign_Offset_2; break;   // 210 -   2 V
            case 11: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelXYCH1 * 3) / Volt_Correct_float[0][11])) + lChannel1_Zero_Sign_Offset_3; break;   // 100 -   5 V
        }
    }
    else
    {
        switch(Selected_Voltage_CH1)
        {
            case 0: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 1) / Volt_Correct_float[0][0])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -   1 mV
            case 1: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 2) / Volt_Correct_float[0][1])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 -   2 mV
            case 2: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 3) / Volt_Correct_float[0][2])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 -   5 mV
            case 3: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 1) / Volt_Correct_float[0][3])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -  10 mV
            case 4: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 2) / Volt_Correct_float[0][4])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 -  20 mV
            case 5: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 3) / Volt_Correct_float[0][5])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 -  50 mV
            case 6: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 1) / Volt_Correct_float[0][6])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 - 100 mV
            case 7: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 2) / Volt_Correct_float[0][7])) + lChannel1_Zero_Sign_Offset_2; break;    // 210 - 200 mV
            case 8: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 3) / Volt_Correct_float[0][8])) + lChannel1_Zero_Sign_Offset_3; break;    // 100 - 500 mV
            case 9: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 1) / Volt_Correct_float[0][9])) + lChannel1_Zero_Sign_Offset_1; break;    // 110 -   1 V
            case 10: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 2) / Volt_Correct_float[0][10])) + lChannel1_Zero_Sign_Offset_2; break;   // 210 -   2 V
            case 11: CH1_DAC_Offset = int ((float (Virtual_ZeroLevelCH1 * 3) / Volt_Correct_float[0][11])) + lChannel1_Zero_Sign_Offset_3; break;   // 100 -   5 V
        }
    }

    SetDacOffset(1);
}

void Hardware::ON_Voltage_Channel_2(void)
{
    int cnt;
    float fvolt_factor = 0;
    float fvolt_factor2 = 0;

    int shift_cnt = 0;

    if (Channel_2_Active == false) return;

    if (Rotary_Direction == 1)
    {
        if (Selected_Voltage_CH2 == 3) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH2 - Rotary_Steps) > 3)
		{
			Selected_Voltage_CH2 -= Rotary_Steps;
		}
		else Selected_Voltage_CH2 = 3;
		
		SetSwitches(2, Selected_Voltage_CH2);
		VoltageChangedCh2 = 1;

        if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }

        if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
        Display::DRAWSTATUS(2, 1);											// Draw Voltage Channel 1
        Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
        if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
        {
            MenuItemChanged[3] = 1;
			MenuItemChanged[4] = 1;
				
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }
        if (Active_Menu == 19)
        {
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }	
             /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }*/			
    }
    else
    {
        if (Selected_Voltage_CH2 == 11) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH2 + Rotary_Steps) < 11)
		{
			Selected_Voltage_CH2 += Rotary_Steps;       			
		}
        else Selected_Voltage_CH2 = 11;	

		SetSwitches(2, Selected_Voltage_CH2);
		VoltageChangedCh2 = 1;
			
		if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }
		if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
		Display::DRAWSTATUS(2, 1);											// Draw Voltage Channel 1
		Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
			
		if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
		{
            MenuItemChanged[3] = 1;
            MenuItemChanged[4] = 1;
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
		if (Active_Menu == 19)
		{
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
                  /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }   */
    }

    Rotary_Steps = 0;
    ON_Zero_Channel_2();
}

void Hardware::ON_Zero_Channel_2(void)
{
    int lChannel2_Zero_Sign_Offset_1, lChannel2_Zero_Sign_Offset_2, lChannel2_Zero_Sign_Offset_3, Virtual_ZeroLevel_Buf;

    if (Display_Mode) return;

    int rotbuf;

    if ((Rotary_Steps > 5) && (Rotary_Steps < 11)) rotbuf = Rotary_Steps * 3;
    else if (Rotary_Steps > 10) rotbuf = Rotary_Steps * 7;
    else rotbuf = Rotary_Steps;


    if (rotbuf)
    {
        if (Rotary_Direction == 0)
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if ((Virtual_ZeroLevelCH2 + rotbuf) < 4095) //16384
            {
                Virtual_ZeroLevelCH2 = Virtual_ZeroLevelCH2 + rotbuf;
            }
            else
            {
                Virtual_ZeroLevelCH2 = 4095; //16384
            }	
		
            if (Continius == false)
            {
                CH2_Zero_Offset = CH2_Zero_Offset + rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }  	
		
            VS_ZeroChangedCh2 = 1;

            
            if ((Virtual_ZeroLevelCH2 < 4095) && (Virtual_ZeroLevelCH2 > -4095))
            {
                if (Trigger_Pos_CH2_os < 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH2_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH2_os++;
                    }
                }
                if ((Trigger_Pos_CH2 + rotbuf) <= 386) Trigger_Pos_CH2 = Trigger_Pos_CH2 + rotbuf;
                else
                {
                    Trigger_Pos_CH2_os = Trigger_Pos_CH2_os + (rotbuf - (386 - Trigger_Pos_CH2));
                    Trigger_Pos_CH2 = 386;	
                }
            }
            

            if (Selected_Trigger_Source == 2)
            {
                UpdateTrigger(20);	
            }
        }
        else
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if ((Virtual_ZeroLevelCH2 - rotbuf) > -4095) // 0
            {
                Virtual_ZeroLevelCH2 = Virtual_ZeroLevelCH2 - rotbuf;
            }		
            else
            {
                Virtual_ZeroLevelCH2 = -4095;  // 0
            }

            if (Continius == false)
            {
                CH2_Zero_Offset = CH2_Zero_Offset - rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }		
		
            VS_ZeroChangedCh2 = 1;

            if ((Virtual_ZeroLevelCH2 < 4095) && (Virtual_ZeroLevelCH2 > -4095))
            {
                if (Trigger_Pos_CH2_os > 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH2_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH2_os--;
                    }
                }
                if ((Trigger_Pos_CH2 - rotbuf) >= 0) Trigger_Pos_CH2 = Trigger_Pos_CH2 - rotbuf;
                else
                {
                    Trigger_Pos_CH2_os = Trigger_Pos_CH2_os - (rotbuf - Trigger_Pos_CH2);

                    Trigger_Pos_CH2 = 0;
                }
            }

            if (Selected_Trigger_Source == 2)
            {
                UpdateTrigger(21);
            }	
        }
    }

    ZeroLevelCH2 = Virtual_ZeroLevelCH2 + 192;
    if (ZeroLevelCH2 < 0) ZeroLevelCH2 = 0;
    if (ZeroLevelCH2 > 385) ZeroLevelCH2 = 385;

    Virtual_ZeroLevel_Buf = Virtual_ZeroLevelCH2 >> 2;

    lChannel2_Zero_Sign_Offset_1 = 8192 + Channel2_Zero_Sign_Offset_1;
    lChannel2_Zero_Sign_Offset_2 = 8192 + Channel2_Zero_Sign_Offset_2;
    lChannel2_Zero_Sign_Offset_3 = 8192 + Channel2_Zero_Sign_Offset_3 + Virtual_ZeroLevel_Buf;

    switch(Selected_Voltage_CH2)
    {
        case 0: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 1) / Volt_Correct_float[1][0])) + lChannel2_Zero_Sign_Offset_1; break;    // 110 -   1 mV
        case 1: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 2) / Volt_Correct_float[1][1])) + lChannel2_Zero_Sign_Offset_2; break;    // 210 -   2 mV
        case 2: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 3) / Volt_Correct_float[1][2])) + lChannel2_Zero_Sign_Offset_3; break;    // 100 -   5 mV
        case 3: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 1) / Volt_Correct_float[1][3])) + lChannel2_Zero_Sign_Offset_1; break;    // 110 -  10 mV
        case 4: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 2) / Volt_Correct_float[1][4])) + lChannel2_Zero_Sign_Offset_2; break;    // 210 -  20 mV
        case 5: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 3) / Volt_Correct_float[1][5])) + lChannel2_Zero_Sign_Offset_3; break;    // 100 -  50 mV
        case 6: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 1) / Volt_Correct_float[1][6])) + lChannel2_Zero_Sign_Offset_1; break;    // 110 - 100 mV
        case 7: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 2) / Volt_Correct_float[1][7])) + lChannel2_Zero_Sign_Offset_2; break;    // 210 - 200 mV
        case 8: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 3) / Volt_Correct_float[1][8])) + lChannel2_Zero_Sign_Offset_3; break;    // 100 - 500 mV
        case 9: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 1) / Volt_Correct_float[1][9])) + lChannel2_Zero_Sign_Offset_1; break;    // 110 -   1 V
        case 10: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 2) / Volt_Correct_float[1][10])) + lChannel2_Zero_Sign_Offset_2; break;   // 210 -   2 V
        case 11: CH2_DAC_Offset = int ((float (Virtual_ZeroLevelCH2 * 3) / Volt_Correct_float[1][11])) + lChannel2_Zero_Sign_Offset_3; break;   // 100 -   5 V
    }

    SetDacOffset(2);	

}

void Hardware::ON_Voltage_Channel_3(void)
{
    int cnt;
    float fvolt_factor = 0;
    float fvolt_factor2 = 0;

    int shift_cnt = 0;

    if (Channel_3_Active == false) return;

    if (Rotary_Direction == 1)
    {
        if (Selected_Voltage_CH3 == 3) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH3 - Rotary_Steps) > 3)
		{
			Selected_Voltage_CH3 -= Rotary_Steps;
		}
		else Selected_Voltage_CH3 = 3;
		
		SetSwitches(3, Selected_Voltage_CH3);
		VoltageChangedCh3 = 1;

        if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }

        if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
        Display::DRAWSTATUS(3, 1);											// Draw Voltage Channel 1
        Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
        if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
        {
            MenuItemChanged[3] = 1;
			MenuItemChanged[4] = 1;
				
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }
        if (Active_Menu == 19)
        {
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }	
             /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }*/			
    }
    else
    {
        if (Selected_Voltage_CH3 == 11) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH3 + Rotary_Steps) < 11)
		{
			Selected_Voltage_CH3 += Rotary_Steps;       			
		}
        else Selected_Voltage_CH3 = 11;	

		SetSwitches(3, Selected_Voltage_CH3);
		VoltageChangedCh3 = 1;
			
		if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }
		if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
		Display::DRAWSTATUS(3, 1);											// Draw Voltage Channel 1
		Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
			
		if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
		{
            MenuItemChanged[3] = 1;
            MenuItemChanged[4] = 1;
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
		if (Active_Menu == 19)
		{
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
                  /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }   */
    }

    Rotary_Steps = 0;
    ON_Zero_Channel_3();
}

void Hardware::ON_Zero_Channel_3(void)
{
    int lChannel3_Zero_Sign_Offset_1, lChannel3_Zero_Sign_Offset_2, lChannel3_Zero_Sign_Offset_3, Virtual_ZeroLevel_Buf;

    if (Display_Mode) return;

    int rotbuf;

    if ((Rotary_Steps > 5) && (Rotary_Steps < 11)) rotbuf = Rotary_Steps * 3;
    else if (Rotary_Steps > 10) rotbuf = Rotary_Steps * 7;
    else rotbuf = Rotary_Steps;

    if (rotbuf)
    {
        if (Rotary_Direction == 0)
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
         if ((Virtual_ZeroLevelCH3 + rotbuf) < 4095) //16384
            {
                Virtual_ZeroLevelCH3 = Virtual_ZeroLevelCH3 + rotbuf;
            }
            else
            {
                Virtual_ZeroLevelCH3 = 4095; //16384
            }	
		
           if (Continius == false)
            {
                CH3_Zero_Offset = CH3_Zero_Offset + rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }  	
		
            VS_ZeroChangedCh3 = 1;

            if ((Virtual_ZeroLevelCH3 < 4095) && (Virtual_ZeroLevelCH3 > -4095))
            {
                if (Trigger_Pos_CH3_os < 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH3_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH3_os++;
                    }
                }
                if ((Trigger_Pos_CH3 + rotbuf) <= 386) Trigger_Pos_CH3 = Trigger_Pos_CH3 + rotbuf;
                else
                {
                    Trigger_Pos_CH3_os = Trigger_Pos_CH3_os + (rotbuf - (386 - Trigger_Pos_CH3));
                    Trigger_Pos_CH3 = 386;	
                }
            }

         if (Selected_Trigger_Source == 3)
            {
                UpdateTrigger(20);	
            }
        }
        else
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if ((Virtual_ZeroLevelCH3 - rotbuf) > -4095) // TMW repaired (xchged Rotary_Steps/rotbuf)
            {
                Virtual_ZeroLevelCH3 = Virtual_ZeroLevelCH3 - rotbuf; // TMW repaired (xchged Rotary_Steps/rotbuf)
            }		
            else
            {
                Virtual_ZeroLevelCH3 = -4095;  // 0
            }                                		

            if (Continius == false)
            {
                CH3_Zero_Offset = CH3_Zero_Offset - rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }		
		
            VS_ZeroChangedCh3 = 1;

            if ((Virtual_ZeroLevelCH3 < 4095) && (Virtual_ZeroLevelCH3 > -4095))
            {
                if (Trigger_Pos_CH3_os > 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH3_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH3_os--;
                    }
                }
                if ((Trigger_Pos_CH3 - rotbuf) >= 0) Trigger_Pos_CH3 = Trigger_Pos_CH3 - rotbuf;
                else
                {
                    Trigger_Pos_CH3_os = Trigger_Pos_CH3_os - (rotbuf - Trigger_Pos_CH3);

                    Trigger_Pos_CH3 = 0;
                }
            }

            if (Selected_Trigger_Source == 3)
            {
                UpdateTrigger(21);
            }	
        }
    }

    ZeroLevelCH3 = Virtual_ZeroLevelCH3 + 192;
    if (ZeroLevelCH3 < 0) ZeroLevelCH3 = 0;
    if (ZeroLevelCH3 > 385) ZeroLevelCH3 = 385;

    Virtual_ZeroLevel_Buf = Virtual_ZeroLevelCH3 >> 2;

    lChannel3_Zero_Sign_Offset_1 = 8192 + Channel3_Zero_Sign_Offset_1;
    lChannel3_Zero_Sign_Offset_2 = 8192 + Channel3_Zero_Sign_Offset_2;
    lChannel3_Zero_Sign_Offset_3 = 8192 + Channel3_Zero_Sign_Offset_3 + Virtual_ZeroLevel_Buf;

    switch(Selected_Voltage_CH3)
    {
        case 0: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 1) / Volt_Correct_float[2][0])) + lChannel3_Zero_Sign_Offset_1; break;    // 110 -   1 mV
        case 1: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 2) / Volt_Correct_float[2][1])) + lChannel3_Zero_Sign_Offset_2; break;    // 210 -   2 mV
        case 2: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 3) / Volt_Correct_float[2][2])) + lChannel3_Zero_Sign_Offset_3; break;    // 100 -   5 mV
        case 3: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 1) / Volt_Correct_float[2][3])) + lChannel3_Zero_Sign_Offset_1; break;    // 110 -  10 mV
        case 4: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 2) / Volt_Correct_float[2][4])) + lChannel3_Zero_Sign_Offset_2; break;    // 210 -  20 mV
        case 5: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 3) / Volt_Correct_float[2][5])) + lChannel3_Zero_Sign_Offset_3; break;    // 100 -  50 mV
        case 6: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 1) / Volt_Correct_float[2][6])) + lChannel3_Zero_Sign_Offset_1; break;    // 110 - 100 mV
        case 7: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 2) / Volt_Correct_float[2][7])) + lChannel3_Zero_Sign_Offset_2; break;    // 210 - 200 mV
        case 8: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 3) / Volt_Correct_float[2][8])) + lChannel3_Zero_Sign_Offset_3; break;    // 100 - 500 mV
        case 9: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 1) / Volt_Correct_float[2][9])) + lChannel3_Zero_Sign_Offset_1; break;    // 110 -   1 V
        case 10: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 2) / Volt_Correct_float[2][10])) + lChannel3_Zero_Sign_Offset_2; break;   // 210 -   2 V
        case 11: CH3_DAC_Offset = int ((float (Virtual_ZeroLevelCH3 * 3) / Volt_Correct_float[2][11])) + lChannel3_Zero_Sign_Offset_3; break;   // 100 -   5 V
    }

    SetDacOffset(3);	
}

void Hardware::ON_Voltage_Channel_4(void)
{
    int cnt;
    float fvolt_factor = 0;
    float fvolt_factor2 = 0;

    int shift_cnt = 0;

    if (Channel_4_Active == false) return;

    if (Rotary_Direction == 1)
    {
        if (Selected_Voltage_CH4 == 3) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH4 - Rotary_Steps) > 3)
		{
			Selected_Voltage_CH4 -= Rotary_Steps;
		}
		else Selected_Voltage_CH4 = 3;
		
		SetSwitches(4, Selected_Voltage_CH4);
		VoltageChangedCh4 = 1;

        if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }

        if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
        Display::DRAWSTATUS(4, 1);											// Draw Voltage Channel 1
        Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
        if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
        {
            MenuItemChanged[3] = 1;
			MenuItemChanged[4] = 1;
				
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }
        if (Active_Menu == 19)
        {
            New_Menu = Active_Menu;
            Menu_Changed = 1;
        }	
             /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }*/			
    }
    else
    {
        if (Selected_Voltage_CH4 == 11) return;
//		if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
		if ((Selected_Voltage_CH4 + Rotary_Steps) < 11)
		{
			Selected_Voltage_CH4 += Rotary_Steps;       			
		}
        else Selected_Voltage_CH4 = 11;	

		SetSwitches(4, Selected_Voltage_CH4);
		VoltageChangedCh4 = 1;
			
		if (Cursor_Enabled)
        {
            Display::CALCCURSORDATA();
            Menu_Changed = 1;
            CursorChanged = 4;
        }
		if (QM_Enabled)
        {
            Display::CALCQMDATA();
            Menu_Changed = 1;
        }
			
		Display::DRAWSTATUS(4, 1);											// Draw Voltage Channel 1
		Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
			
		if ((Active_Menu == 16) || (MenuButtonCheck(-1)))
		{
            MenuItemChanged[3] = 1;
            MenuItemChanged[4] = 1;
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
		if (Active_Menu == 19)
		{
            New_Menu = Active_Menu;
            Menu_Changed = 1;
		}
                  /*
            if (Continius == false)
            {
                if (signal_zoomed1 == false) for (cnt = 0; cnt < 16383; cnt++) SIGNAL1_IntBuf_YZoom[cnt] = (int) SIGNAL1[cnt];

                Voltage_Zoom(&SIGNAL1[0], &SIGNAL1_IntBuf_YZoom[0], Selected_Voltage_CH1, Selected_Voltage_CH1_Old, ZeroLevelCH1);

                UserIface_active = 0;
                DrawSignals_Needed = 1;
                signal_zoomed1 = true;
            }   */
    }

    Rotary_Steps = 0;
    ON_Zero_Channel_4();
}

void Hardware::ON_Zero_Channel_4(void)
{
    int lChannel4_Zero_Sign_Offset_1, lChannel4_Zero_Sign_Offset_2, lChannel4_Zero_Sign_Offset_3, Virtual_ZeroLevel_Buf;

    if (Display_Mode) return;

    int rotbuf;

    if ((Rotary_Steps > 5) && (Rotary_Steps < 11)) rotbuf = Rotary_Steps * 3;
    else if (Rotary_Steps > 10) rotbuf = Rotary_Steps * 7;
    else rotbuf = Rotary_Steps;


    if (rotbuf)
    {
        if (Rotary_Direction == 0)
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if ((Virtual_ZeroLevelCH4 + rotbuf) < 4095) //16384
            {
                Virtual_ZeroLevelCH4 = Virtual_ZeroLevelCH4 + rotbuf;
            }
            else
            {
                Virtual_ZeroLevelCH4 = 4095; //16384
            }	
		
            if (Continius == false)
            {
                CH4_Zero_Offset = CH4_Zero_Offset + rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }  	
		
            VS_ZeroChangedCh4 = 1;

            if ((Virtual_ZeroLevelCH4 < 4095) && (Virtual_ZeroLevelCH4 > -4095))
            {
                if (Trigger_Pos_CH4_os < 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH4_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH4_os++;
                    }
                }
                if ((Trigger_Pos_CH4 + rotbuf) <= 386) Trigger_Pos_CH4 = Trigger_Pos_CH4 + rotbuf;
                else
                {
                    Trigger_Pos_CH4_os = Trigger_Pos_CH4_os + (rotbuf - (386 - Trigger_Pos_CH4));
                    Trigger_Pos_CH4 = 386;	
                }
            }

            if (Selected_Trigger_Source == 4)
            {
                UpdateTrigger(20);	
            }
        }
        else
        {
            if (MenuButtonCheck(-1)) { New_Menu = Active_Menu; Menu_Changed = 1; }
		
            if ((Virtual_ZeroLevelCH4 - rotbuf) > -4095) // TMW repaired (xchged Rotary_Steps/rotbuf)
            {
                Virtual_ZeroLevelCH4 = Virtual_ZeroLevelCH4 - rotbuf; // TMW repaired (xchged Rotary_Steps/rotbuf)
            }		
            else
            {
                Virtual_ZeroLevelCH4 = -4095;  // 0
            }                                		

            if (Continius == false)
            {
                CH4_Zero_Offset = CH4_Zero_Offset - rotbuf;
                DrawSignals_Needed = 1;
                UserIface_active = 0;
            }		
		
            VS_ZeroChangedCh4 = 1;

            if ((Virtual_ZeroLevelCH4 < 4095) && (Virtual_ZeroLevelCH4 > -4095))
            {
                if (Trigger_Pos_CH4_os > 0)
                {
                    while ((rotbuf > 0) && (Trigger_Pos_CH4_os != 0))
                    {
                        rotbuf--;
                        Trigger_Pos_CH4_os--;
                    }
                }
                if ((Trigger_Pos_CH4 - rotbuf) >= 0) Trigger_Pos_CH4 = Trigger_Pos_CH4 - rotbuf;
                else
                {
                    Trigger_Pos_CH4_os = Trigger_Pos_CH4_os - (rotbuf - Trigger_Pos_CH4);

                    Trigger_Pos_CH4 = 0;
                }
            }

            if (Selected_Trigger_Source == 4)
            {
                UpdateTrigger(21);
            }	
        }
    }

    ZeroLevelCH4 = Virtual_ZeroLevelCH4 + 192;
    if (ZeroLevelCH4 < 0) ZeroLevelCH4 = 0;
    if (ZeroLevelCH4 > 385) ZeroLevelCH4 = 385;

    Virtual_ZeroLevel_Buf = Virtual_ZeroLevelCH4 >> 2;

    lChannel4_Zero_Sign_Offset_1 = 8192 + Channel4_Zero_Sign_Offset_1;
    lChannel4_Zero_Sign_Offset_2 = 8192 + Channel4_Zero_Sign_Offset_2;
    lChannel4_Zero_Sign_Offset_3 = 8192 + Channel4_Zero_Sign_Offset_3 + Virtual_ZeroLevel_Buf;

    switch(Selected_Voltage_CH4)
    {
        case 0: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 1) / Volt_Correct_float[3][0])) + lChannel4_Zero_Sign_Offset_1; break;    // 110 -   1 mV
        case 1: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 2) / Volt_Correct_float[3][1])) + lChannel4_Zero_Sign_Offset_2; break;    // 210 -   2 mV
        case 2: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 3) / Volt_Correct_float[3][2])) + lChannel4_Zero_Sign_Offset_3; break;    // 100 -   5 mV
        case 3: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 1) / Volt_Correct_float[3][3])) + lChannel4_Zero_Sign_Offset_1; break;    // 110 -  10 mV
        case 4: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 2) / Volt_Correct_float[3][4])) + lChannel4_Zero_Sign_Offset_2; break;    // 210 -  20 mV
        case 5: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 3) / Volt_Correct_float[3][5])) + lChannel4_Zero_Sign_Offset_3; break;    // 100 -  50 mV
        case 6: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 1) / Volt_Correct_float[3][6])) + lChannel4_Zero_Sign_Offset_1; break;    // 110 - 100 mV
        case 7: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 2) / Volt_Correct_float[3][7])) + lChannel4_Zero_Sign_Offset_2; break;    // 210 - 200 mV
        case 8: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 3) / Volt_Correct_float[3][8])) + lChannel4_Zero_Sign_Offset_3; break;    // 100 - 500 mV
        case 9: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 1) / Volt_Correct_float[3][9])) + lChannel4_Zero_Sign_Offset_1; break;    // 110 -   1 V
        case 10: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 2) / Volt_Correct_float[3][10])) + lChannel4_Zero_Sign_Offset_2; break;   // 210 -   2 V
        case 11: CH4_DAC_Offset = int ((float (Virtual_ZeroLevelCH4 * 3) / Volt_Correct_float[3][11])) + lChannel4_Zero_Sign_Offset_3; break;   // 100 -   5 V
    }

    SetDacOffset(4);	
}

void Hardware::Voltage_Zoom(unsigned char *OrgData, unsigned char *ZoomData, int NewVoltage, int OldVoltage, int ZeroLevel)
{
    int cnt;
    float vfactor = 0;
    int int_vfactor = 0;
    int int_bufval = 0;
    int int_bufzero = ZeroLevel >> 1;
#ifdef _Debug_
    printf("Start Zooom n: %d o: %d z: %d\n", NewVoltage, OldVoltage, ZeroLevel);
#endif
    if (NewVoltage > OldVoltage)
    {
        vfactor = Voltage_Value_Matrix[NewVoltage][3] / Voltage_Value_Matrix[OldVoltage][3];

        if (vfactor == 2.5)
        {
            for (cnt = 0; cnt < 16383; cnt++)
            {
                int_bufval = ((((int) ZoomData[cnt] - int_bufzero) << 2) / 10) + int_bufzero;

                if (int_bufval > 255) OrgData[cnt] = (unsigned char) 255;
                else if (int_bufval < 0) OrgData[cnt] = (unsigned char) 0;
                else OrgData[cnt] = (unsigned char) int_bufval;
            }
        }
        else
        {
            int_vfactor = (int) vfactor;
            for (cnt = 0; cnt < 16383; cnt++)
            {
                int_bufval = ((((int) ZoomData[cnt] - int_bufzero) / int_vfactor) + int_bufzero);

                if (int_bufval > 255) OrgData[cnt] = (unsigned char) 255;
                else if (int_bufval < 0) OrgData[cnt] = (unsigned char) 0;
                else OrgData[cnt] = (unsigned char) int_bufval;
            }
        }
    }
    else if (OldVoltage > NewVoltage)
    {
        vfactor = Voltage_Value_Matrix[OldVoltage][3] / Voltage_Value_Matrix[NewVoltage][3];

        if (vfactor == 2.5)
        {
            for (cnt = 0; cnt < 16383; cnt++)
            {
                int_bufval = ((((int) ZoomData[cnt] - int_bufzero) << 1) + ((ZoomData[cnt] - int_bufzero) >> 1)) + int_bufzero;

                if (int_bufval > 255) OrgData[cnt] = (unsigned char) 255;
                else if (int_bufval < 0) OrgData[cnt] = (unsigned char) 0;
                else OrgData[cnt] = (unsigned char) int_bufval;
            }
        }
        else
        {
            int_vfactor = (int) vfactor;
            for (cnt = 0; cnt < 16383; cnt++)
            {
                int_bufval = (((int) ZoomData[cnt] - int_bufzero) * int_vfactor) + int_bufzero;

                if (int_bufval > 255) OrgData[cnt] = (unsigned char) 255;
                else if (int_bufval < 0) OrgData[cnt] = (unsigned char) 0;
                else OrgData[cnt] = (unsigned char) int_bufval;
            }
        }
    }
    else  if (OldVoltage == NewVoltage)
    {
        for (cnt = 0; cnt < 16383; cnt++)
        {
            OrgData[cnt] = ZoomData[cnt];
        }
    }
#ifdef _Debug_
    printf("Stop Zooom %f %d\n", vfactor, int_vfactor);
#endif
}

void Hardware::HandleMainWheel(char Direction)					// Main Wheel Handler
{
	bool doit = false;
	bool changing = false;
	double voltoff = 0;
	double timeoff = 0;
    short pos = 0;

    int rot_buf = 0;
    int buf_int = 0; 	
    float buf_float = 0;

    int rbuf = Rotary_Steps;
    		
//	Display::DRAWP(550, 50, 80, 20, 0, 6);
//	sprintf(speedt, "%i\n" , Speed);
//	Display::TEXTOUTxvbig(speedt, 550, 50, 1, 6);				// Draw the Ground Sign
	
	Rot_Time = 0;
	
//	if (RoteryChanged == 0) return;
	
	switch(Active_Menu)
	{      /*
		// Averaging
		case 0:
		{
			if (MenuItemPushed[3] == 0) doit = true;
			MenuButtonCheck(3);

            changing = false;
            while (rbuf > 0)
            {
                switch(Direction)
                {
                    case 0: if (MenuStatus[0][2] > 74) {MenuStatus[0][2]--; changing = true;} break;
                    case 1: if (MenuStatus[0][2] < 81) {MenuStatus[0][2]++; changing = true;} break;
                }
                rbuf--;
			}
			
			if (changing)
			{
                Display::DRAWP(248, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[0][2]], 219 + MenuDataDef[MenuStatus[0][2]], 455, 1, Buffer_UI2Plane);
                Display::DRAWSTATUS(Active_Menu, 1);			
            }
			
			switch(MenuStatus[0][2])
			{
                case 74 : Average_Max = 1; break;
                case 75 : Average_Max = 2; break;
                case 76 : Average_Max = 4; break;
                case 77 : Average_Max = 8; break;
                case 78 : Average_Max = 16; break;
                case 79 : Average_Max = 32; break;
                case 80 : Average_Max = 64; break;
                case 81 : Average_Max = 128; break;
                case 82 : Average_Max = 256; break;
                case 83 : Average_Max = 512; break;
                case 84 : Average_Max = 1024; break;
                case 85 : Average_Max = 2048; break;
                case 86 : Average_Max = 4096; break;
                case 87 : Average_Max = 8192; break;
                case 88 : Average_Max = 16384; break;
            }
            Average_Cnt = 0;
						
			Menu_Changed = 1;

			break;
		}
        */	
		// Channel 1
		case 1:
		{
            if (Channel_1_Active == 0) return;

			if (MenuItemPushed[3] == 0) doit = true;
			MenuButtonCheck(3);

            changing = false;
            while (rbuf > 0)
            {
                switch(Direction)
                {
				    case 0: if (MenuStatus[1][3] > 104) {MenuStatus[1][3]--; changing = true;} break;
				    case 1: if (MenuStatus[1][3] < 113) {MenuStatus[1][3]++; changing = true;} break;
                }
                rbuf--;
			}
			
			if (changing)
			{
                Display::DRAWP(345, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[1][3]], 354, 455, 1, Buffer_UI2Plane);
                Display::DRAWSTATUS(Active_Menu, 1);		
                Display::DRAWSTATUS(6, 0);				
            }                		
			
			if (Cursor_Enabled)
			{
                CursorChanged = 4;
				Display::CALCCURSORDATA();
			}
			if (QM_Enabled)
			{					
				Display::CALCQMDATA();
			}
			
			//Display::CALCTRIGGER();
			TriggerLevelChanged = 1;
			Display::StatusUpdate();
			
			Menu_Changed = 1;

			break;
		}
		
		// Channel 2
		case 2:
		{
            if (Channel_2_Active == 0) return;

			if (MenuItemPushed[3] == 0) doit = true;
			MenuButtonCheck(3);
			
            changing = false;
            while (rbuf > 0)
            {
                switch(Direction)
                {
				    case 0: if (MenuStatus[2][3] > 104) {MenuStatus[2][3]--; changing = true;} break;
				    case 1: if (MenuStatus[2][3] < 113) {MenuStatus[2][3]++; changing = true;} break;
                }
                rbuf--;
			}
			
			if (changing)
			{
                Display::DRAWP(345, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[2][3]], 354, 455, 1, Buffer_UI2Plane);
                Display::DRAWSTATUS(Active_Menu, 1);		
                Display::DRAWSTATUS(6, 0);				
            }   			

			if (Cursor_Enabled)
			{
                CursorChanged = 4;
				Display::CALCCURSORDATA();
			}
			if (QM_Enabled)
			{					
				Display::CALCQMDATA();
			}		
			
			//Display::CALCTRIGGER();
			TriggerLevelChanged = 1;
			Display::StatusUpdate();			

            Menu_Changed = 1;	

			break;
		}
		
		// Channel 3
		case 3:
		{
            if (Channel_3_Active == 0) return;

			if (MenuItemPushed[3] == 0) doit = true;
			MenuButtonCheck(3);
			
            changing = false;
            while (rbuf > 0)
            {
                switch(Direction)
                {
				    case 0: if (MenuStatus[3][3] > 104) {MenuStatus[3][3]--; changing = true;} break;
				    case 1: if (MenuStatus[3][3] < 113) {MenuStatus[3][3]++; changing = true;} break;
                }
                rbuf--;
			}
			
			if (changing)
			{
                Display::DRAWP(345, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[3][3]], 354, 455, 1, Buffer_UI2Plane);
                Display::DRAWSTATUS(Active_Menu, 1);		
                Display::DRAWSTATUS(6, 0);				
            }
			
			if (Cursor_Enabled)
			{
                CursorChanged = 4;
				Display::CALCCURSORDATA();

			}
			if (QM_Enabled)
			{					
				Display::CALCQMDATA();
			}
			
			//Display::CALCTRIGGER();
			TriggerLevelChanged = 1;
			Display::StatusUpdate();
            			
			Menu_Changed = 1;

			break;
		}
		
		// Channel 4
		case 4:
		{
            if (Channel_4_Active == 0) return;

			if (MenuItemPushed[3] == 0) doit = true;
			MenuButtonCheck(3);
			
            changing = false;
            while (rbuf > 0)
            {
                switch(Direction)
                {
				    case 0: if (MenuStatus[4][3] > 104) {MenuStatus[4][3]--; changing = true;} break;
				    case 1: if (MenuStatus[4][3] < 113) {MenuStatus[4][3]++; changing = true;} break;
                }
                rbuf--;
			}
			
			if (changing)
			{
                Display::DRAWP(345, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[4][3]], 354, 455, 1, Buffer_UI2Plane);
                Display::DRAWSTATUS(Active_Menu, 1);		
                Display::DRAWSTATUS(6, 0);				
            }
			
			if (Cursor_Enabled)
			{
                CursorChanged = 4;
				Display::CALCCURSORDATA();

			}
			if (QM_Enabled)
			{					
				Display::CALCQMDATA();
			}	
			
			//Display::CALCTRIGGER();
			TriggerLevelChanged = 1;
			Display::StatusUpdate();			

            Menu_Changed = 1;		

			break;
		}
		
		// Display Menu
		case 5:
		{
			if (MenuItemPushed[2] == 0) doit = true;
			MenuButtonCheck(2);
			
			changing = false;
			
            while (rbuf > 0)
            {		
                switch(Direction)
                {
                    case 0:
                    {
                        if (MenuStatus[10][1] == 1)
                        {
                            if (GridColorArrayPos_Delayed > 0)
                            {
                                GridColorArrayPos_Delayed--;
                                GridColor_Val = GridColorArray[GridColorArrayPos_Delayed];

                                changing = true;
                            }
                        }
                        else
                        {
                            if (GridColorArrayPos > 0)
                            {
                                GridColorArrayPos--;
                                GridColor_Val = GridColorArray[GridColorArrayPos];

                                changing = true;
                            }				
                        }				
                        break;
                    }

                    case 1:
                    {
                        if (MenuStatus[10][1] == 1)
                        {
                            if (GridColorArrayPos_Delayed < 3)
                            {
                                GridColorArrayPos_Delayed++;
                                GridColor_Val = GridColorArray[GridColorArrayPos_Delayed];

                                changing = true;		
                            }				
                        }
                        else
                        {
                            if (GridColorArrayPos < 3)
                            {
                                GridColorArrayPos++;
                                GridColor_Val = GridColorArray[GridColorArrayPos];
						
                                changing = true;
                            }				
                        }
                        break;
                    }				
                }
                rbuf--;
			}			
			
			if (changing)
			{			
                SetupADC();
						
                MenuStatus[5][2] = GridColorArrayPos + 133;
						
                Display::DRAWP(240, 454, 60, 14, 0, Buffer_UI2Plane);
                Display::TEXTOUTxvbig(MenuData[MenuStatus[5][2]], 218 + MenuDataDef[MenuStatus[5][2]], 455, 1, Buffer_UI2Plane);			
            }			
			
#ifdef _Debug_			
			if (Debug_Mode) printf("GV %i : %2x\n", GridColorArrayPos, GridColor_Val);
#endif			
			//ResetTimer();
			
			MenuItemChanged[2] = 1;
			Menu_Changed = 1;

			break;
		}
		
		// Save / Racall Menu
		case 8:
		{		
			if (MenuItemPushed[0] == 0) doit = true;
			MenuButtonCheck(0);
			
            while (rbuf > 0)
            {				
                switch(Direction)
                {
                    case 0: if (SavePointer > 1) SavePointer--; break;
                    case 1: if (SavePointer < 80) SavePointer++; break;
                }
                rbuf--;
            }

            MenuItemChanged[0] = 1;
						
            New_Menu = 8;
            Menu_Changed = 1;

            break;	            			
		}
		
		// Edge
		case 12:
		{
            if (EdgeToggle == 0)
            {
                if (MenuItemPushed[3] == 0) doit = true;
                MenuButtonCheck(3);

                while (rbuf > 0)
                {
                    if (Direction)
                    {
                        if ((HoldOff_Expo == 4) && (HoldOff_Value == 300)) break;
                        HoldOff_Value = HoldOff_Value + HoldOff_Steps;
                    }
                    else
                    {
                        if ((HoldOff_Expo == 1) && (HoldOff_Value == 0)) break;
                        HoldOff_Value = HoldOff_Value - HoldOff_Steps;
                    }

                    if (HoldOff_Value > 1000)
                    {
                        HoldOff_Value = 1;
                        HoldOff_Steps = 1;
                        HoldOff_Expo++;
                    }
/*                  else if ((HoldOff_Value > 100) && (HoldOff_Expo != 1))
                    {
                        HoldOff_Steps = 10;
                    }*/
                    else if (HoldOff_Value <= 0)
                    {
                        if (HoldOff_Expo > 2)
                        {
                            HoldOff_Expo--;
                            HoldOff_Value = 999;
                            HoldOff_Steps = 1;
                        }
                        else if (HoldOff_Expo > 1)
                        {
                            HoldOff_Expo = 1;
                            HoldOff_Value = 960;
                            HoldOff_Steps = 40;
                        }
                    }

                    switch(HoldOff_Expo)
                    {
                        case 1:
                        {
                            //HoldOff.Write_StepSize(0.00000004);
                            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000000000);
                            break;
                        }
                        case 2:
                        {
                            //HoldOff.Write_StepSize(0.0000001);
                            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000000);
                            break;
                        }
                        case 3:
                        {
                            //HoldOff.Write_StepSize(0.001);
                            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000);
                            break;
                        }
                        case 4:
                        {
                            //HoldOff.Write_StepSize(1);
                            HoldOff.Write_Value((float) HoldOff_Value);
                            break;
                        }
                    }
                    rbuf--;
                }

                HoldOff.RenderText();

                if (HoldOff_Value) trig_holdoff_reg = (unsigned long) (HoldOff.Read_Value() / (float) 0.000000008);
                else trig_holdoff_reg = 0x00000000;

                UpdateTrigger(26);
            }
            else if (EdgeToggle == 1)
            {
                if (MenuItemPushed[4] == 0) doit = true;
                MenuButtonCheck(4);

                changing = false;

                while (rbuf > 0)
                {
                    switch(Direction)
                    {
                        case 0: if (MenuStatus[12][4] > 104) {MenuStatus[12][4]--; changing = true;} break;
				        case 1: if (MenuStatus[12][4] < 113) {MenuStatus[12][4]++; changing = true;} break;
                    }
                    rbuf--;
                }

                if (changing)
                {
                    Display::DRAWP(442, 454, 60, 14, 0, Buffer_UI2Plane);
                    Display::TEXTOUTxvbig(MenuData[MenuStatus[12][4]], 444, 455, 1, Buffer_UI2Plane);
                }
            }


			TriggerLevelChanged = 1;
			Display::StatusUpdate();
            Menu_Changed = 1;		

			break;
		}		
			
		
		// Pre Trigger
        case 14:
		{	
            if (Display_Mode) return;

            printf("TPM : %d rb : %d  %d\n", Trig_Pos_Mem, rot_buf, Trig_Pos_Display);

            while (rbuf > 0)
            {
                rot_buf = (int) ZFT_float * Rotary_Steps;
                if (rot_buf < 1) rot_buf = Rotary_Steps; // For interpolation
                
                if (Rotary_Direction)
                {
                    if ((Trig_Pos_Mem + (int) rot_buf) < 0x3FFF) Trig_Pos_Mem = Trig_Pos_Mem + rot_buf;
                    else Trig_Pos_Mem = 0x3FFF;
                }
                else
                {
                    if ((Trig_Pos_Mem - (int) rot_buf) >= 0x0064) Trig_Pos_Mem = Trig_Pos_Mem - rot_buf;
                    else Trig_Pos_Mem = 0x0064;
                }
                
                Recalc_Trigger();
                
                SetupADC();
                
            /*    	
                rot_buf = (int) ZFT_float * Rotary_Steps;
                if (rot_buf < 1) rot_buf = Rotary_Steps; // For interpolation

                if (Rotary_Direction)
                {
                    if ((Trigger_Offset_Pos + (int) rot_buf) < 0x3FFF) Trigger_Offset_Pos = Trigger_Offset_Pos + rot_buf;
                    else Trigger_Offset_Pos = 0x3FFF;
                }
                else
                {
                    if ((Trigger_Offset_Pos - (int) rot_buf) >= 0x002F) Trigger_Offset_Pos = Trigger_Offset_Pos - rot_buf;
                    else Trigger_Offset_Pos = 0x002F;
                }

                {
                    if (Trigger_Offset_Pos > SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float)) Trigger_Offset_Pos = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);	
                    if (Trigger_Offset_Pos < SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float)) Trigger_Offset_Pos = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                }


                if (Selected_Timebase < 7) pre_reg = Trigger_Offset_Pos >> 2;	
                else pre_reg = Trigger_Offset_Pos;

                pre_reg += 20;
                */
                
                TriggerOffsetChanged = true;
                
                rbuf--;
            }

            printf("TPM : %d rb : %d  %d\n", Trig_Pos_Mem, rot_buf, Trig_Pos_Display);
            
  
// TMW changed 
       		if (Memory_Window_visible)
            	Display::DRAWMEMORY(0, 0, 1);
        	else
	  			Display::DRAWMEMORY(0, 1, 1);
// TMW change ends








#ifdef _Debug_
            if (Debug_Mode) printf("before PreTrig Offset = %d  Old = %d\n", Trigger_Offset_Pos, Trigger_Offset_Pos_Old);
#endif
            Display::CALCPRETRIGGER();
            Display::DRAW_ALL_CURSOR();
#ifdef _Debug_
            if (Debug_Mode) printf("after PreTrig Offset = %d  Old = %d\n", Trigger_Offset_Pos, Trigger_Offset_Pos_Old);
#endif
            MenuItemPushed[4] = 1;
            MenuButtonCheck(4);

            Menu_Changed = 1;

            break;
        }

        // Pulse/Width
		case 15:
		{
            if (MenuStatus[15][2] == 3)     // range
            {
#ifdef _Debug_
                printf("A Dir %d PT %d \n", Direction, PulseToggle);
                printf("A PV11 %d PE11 %d PS11 %d\n", Pulse11_Value, Pulse11_Expo, Pulse11_Steps);
                printf("A PV12 %d PE12 %d PS12 %d\n", Pulse12_Value, Pulse12_Expo, Pulse12_Steps);
#endif

                if (PulseToggle == 1)
                {
                    while (rbuf > 0)
                    {
                        if (Direction)
                        {
                            if ((Pulse11_Expo == 3) && (Pulse11_Value >= 268)) break;
                            // if ((Pulse12_Expo == 3) && (Pulse12_Value >= 268)) break;
                            Pulse11_Value = Pulse11_Value + Pulse11_Steps;
                        }
                        else
                        {
                            if ((Pulse11_Expo == 1) && (Pulse11_Value <= 16)) break;
                            Pulse11_Value = Pulse11_Value - Pulse11_Steps;
                        }

                        if (Pulse11_Value >= 1000)
                        {
                            Pulse11_Value = 1;
                            Pulse11_Steps = 1;
                            Pulse11_Expo++;
                            /*
                            if ((Pulse11_Value >= Pulse12_Value) && (Pulse11_Expo == Pulse12_Expo))
                            {
                            printf("Update Val2 1\n");

                            Pulse12_Value = 2;
                            Pulse12_Steps = 1;
                            Pulse12_Expo = Pulse11_Expo;

                            switch(Pulse12_Expo)
                            {
                                case 1:
                                {
                                    Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000000);
                                    break;
                                }
                                case 2:
                                {
                                    Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000);
                                    break;
                                }
                                case 3:
                                {
                                    Pulse12.Write_Value((float) Pulse12_Value / (float) 1000);
                                    break;
                                }
                            }
                            Pulse12.RenderText();
                            } */
                        }
                        else if ((Pulse11_Value >= 100) && (Pulse11_Expo == 2))
                        {
                            Pulse11_Steps = 1;
                        }
                        else if (Pulse11_Value <= 0)
                        {
                            if (Pulse11_Expo == 3)
                            {
                                Pulse11_Expo--;
                                Pulse11_Value = 999;
                                Pulse11_Steps = 1;
                            }
                            else if (Pulse11_Expo == 2)
                            {
                                Pulse11_Expo = 1;
                                Pulse11_Value = 992;
                                Pulse11_Steps = 8;
                            }
                        }
                        rbuf--;
                    }

                    switch(Pulse11_Expo)
                    {
                        case 1:
                        {
                            Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000000);
                            break;
                        }
                        case 2:
                        {
                            Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000);
                            break;
                        }
                        case 3:
                        {
                            Pulse11.Write_Value((float) Pulse11_Value / (float) 1000);
                            break;
                        }
                    }

                    Pulse11.RenderText();
                }
                else
                {
                    while (rbuf > 0)
                    {
                        if (Direction)
                        {
                            if ((Pulse12_Expo == 2) && (Pulse12_Value >= 524)) break;
                            Pulse12_Value = Pulse12_Value + Pulse12_Steps;
                        }
                        else
                        {
                            if ((Pulse12_Expo == 1) && (Pulse12_Value <= 8)) break;
                            Pulse12_Value = Pulse12_Value - Pulse12_Steps;
                        }

                        if (Pulse12_Value >= 1000)
                        {
                            Pulse12_Value = 1;
                            Pulse12_Steps = 1;
                            Pulse12_Expo++;
                        }
                        else if ((Pulse12_Value >= 100) && (Pulse12_Expo == 2))
                        {
                            Pulse12_Steps = 1;
                        }
                        else if (Pulse12_Value <= 0)
                        {
                            if (Pulse12_Expo == 3)
                            {
                                Pulse12_Expo--;
                                Pulse12_Value = 999;
                                Pulse12_Steps = 1;
                            }
                            else if (Pulse12_Expo == 2)
                            {
                                Pulse12_Expo = 1;
                                Pulse12_Value = 992;
                                Pulse12_Steps = 8;
                            }
                        }
                        rbuf--;
                    }

                    switch(Pulse12_Expo)
                    {
                        case 1:
                        {
                            Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000000);
                            break;
                        }
                        case 2:
                        {
                            Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000);
                            break;
                        }
                        case 3:
                        {
                            Pulse12.Write_Value((float) Pulse12_Value / (float) 1000);
                            break;
                        }
                    }
                    Pulse12.RenderText();
                }

                trig_range_reg = (unsigned int) (Pulse12.Read_Value() / (float) 0.000000008);
                trig_width_reg = (unsigned int) (Pulse11.Read_Value() / (float) 0.000000008);
#ifdef _Debug_
                printf("B PV11 %d PE11 %d PS11 %d\n", Pulse11_Value, Pulse11_Expo, Pulse11_Steps);
                printf("B PV12 %d PE12 %d PS12 %d\n", Pulse12_Value, Pulse12_Expo, Pulse12_Steps);
#endif
                MenuItemChanged[3] = 1;
                MenuItemChanged[4] = 1;
            }
            else
            {
                if (PulseToggle == 1)
                {
                    while (rbuf > 0)
                    {
                        if (Direction)
                        {
                            if ((Pulse21_Expo == 3) && (Pulse21_Value >= 268)) break;
                            Pulse21_Value = Pulse21_Value + Pulse21_Steps;
                        }
                        else
                        {
                            if ((Pulse21_Expo == 1) && (Pulse21_Value <= 16)) break;
                            Pulse21_Value = Pulse21_Value - Pulse21_Steps;
                        }

                        if (Pulse21_Value >= 1000)
                        {
                            Pulse21_Value = 1;
                            Pulse21_Steps = 1;
                            Pulse21_Expo++;
                        }
                        else if ((Pulse21_Value >= 100) && (Pulse21_Expo == 2))
                        {
                            Pulse21_Steps = 10;
                        }
                        else if (Pulse21_Value <= 0)
                        {
                            if (Pulse21_Expo > 2)
                            {
                                Pulse21_Expo--;
                                Pulse21_Value = 999;
                                Pulse21_Steps = 1;
                            }
                            else if (Pulse21_Expo > 1)
                            {
                                Pulse21_Expo = 1;
                                Pulse21_Value = 992;
                                Pulse21_Steps = 8;
                            }
                        }
                        rbuf--;
                    }

                    switch(Pulse21_Expo)
                    {
                        case 1:
                        {
                            Pulse21.Write_StepSize(0.000000008);
                            Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000000);
                            break;
                        }
                        case 2:
                        {
                            Pulse21.Write_StepSize(0.0000001);
                            Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000);
                            break;
                        }
                        case 3:
                        {
                            Pulse21.Write_StepSize(0.001);
                            Pulse21.Write_Value((float) Pulse21_Value / (float) 1000);
                            break;
                        }
                    }

                    Pulse21.RenderText();

                    trig_width_reg = (unsigned int) ((Pulse21.Read_Value() / (float) 0.000000008));
                    MenuItemChanged[3] = 1;
                }
                else
                {
                    while (rbuf > 0)
                    {
                        if (Direction)
                        {
                            if ((Pulse22_Expo == 3) && (Pulse22_Value >= 268)) break;
                            Pulse22_Value = Pulse22_Value + Pulse22_Steps;
                        }
                        else
                        {
                            if ((Pulse22_Expo == 1) && (Pulse22_Value <= 16)) break;
                            Pulse22_Value = Pulse22_Value - Pulse22_Steps;
                        }

                        if (Pulse22_Value >= 1000)
                        {
                            Pulse22_Value = 1;
                            Pulse22_Steps = 1;
                            Pulse22_Expo++;
                        }
                        else if ((Pulse22_Value >= 100) && (Pulse22_Expo == 2))
                        {
                            Pulse22_Steps = 10;
                        }
                        else if (Pulse22_Value <= 0)
                        {
                            if (Pulse22_Expo > 2)
                            {
                                Pulse22_Expo--;
                                Pulse22_Value = 999;
                                Pulse22_Steps = 1;
                            }
                            else if (Pulse22_Expo > 1)
                            {
                                Pulse22_Expo = 1;
                                Pulse22_Value = 992;
                                Pulse22_Steps = 8;
                            }
                        }
                        rbuf--;
                    }

                    switch(Pulse22_Expo)
                    {
                        case 1:
                        {
                            Pulse22.Write_StepSize(0.000000008);
                            Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000000);
                            break;
                        }
                        case 2:
                        {
                            Pulse22.Write_StepSize(0.0000001);
                            Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000);
                            break;
                        }
                        case 3:
                        {
                            Pulse22.Write_StepSize(0.001);
                            Pulse22.Write_Value((float) Pulse22_Value / (float) 1000);
                            break;
                        }
                    }

                    Pulse22.RenderText();

                    trig_width_reg = (unsigned int) ((Pulse22.Read_Value() / (float) 0.000000008));
                    MenuItemChanged[4] = 1;
                }
            }

            New_Menu = 15;
            Menu_Changed = 1;
            UpdateTrigger(27);

			break;
		}

        case 16: // Main Wheel -> Cursor ( comment TMW added)
		{		
            if (Cursor_Enabled == 0) break;

		    rot_buf = (int) ZFT_float * 1;
		
		    if (rot_buf < 1) rot_buf = Rotary_Steps; // For interpolation (TMW enabled this line)		
 
            if ((rbuf > 5) && (rbuf < 11)) rbuf = rbuf * 3;
            else if (rbuf > 10) rbuf = rbuf * 7;

            while (rbuf > 0)
            {            				
  				if (Cursor_Horizontal_Active == 3)	
				{
				    if (Display_Mode == 1)
				    {

                    switch(Cursor_Vertical_Active)
					{
						case 1:
						{
							CursorChanged = 1;
							
							if (MenuItemPushed[1] == 0) doit = true;
							MenuButtonCheck(1);
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real_XY_1 - rot_buf) > DrawXYOffsetX1) Cursor_Vertical_Position_Real_XY_1 = Cursor_Vertical_Position_Real_XY_1 - rot_buf;

									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real_XY_1 + rot_buf) < DrawXYOffsetX2) Cursor_Vertical_Position_Real_XY_1 = Cursor_Vertical_Position_Real_XY_1 + rot_buf;

									break;
								}							
							}

							break;
						}
						case 2:
						{
							CursorChanged = 2;
							
							if (MenuItemPushed[2] == 0) doit = true;
							MenuButtonCheck(2);
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real_XY_2 - rot_buf) > DrawXYOffsetX1) Cursor_Vertical_Position_Real_XY_2 = Cursor_Vertical_Position_Real_XY_2 - rot_buf;

									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real_XY_2 + rot_buf) < DrawXYOffsetX2) Cursor_Vertical_Position_Real_XY_2 = Cursor_Vertical_Position_Real_XY_2 + rot_buf;

									break;
								}							
							}
							break;
						}
						case 4:
						{
							CursorChanged = 1;
							
							//if (MenuItemPushed[5] == 0) doit = true;
							//MenuButtonCheck(5);
				            MenuItemPushed[1] = 1;
                            MenuItemChanged[1] = 1;
				            MenuItemChanged[2] = 1;
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real_XY_1 - rot_buf) > DrawXYOffsetX1) Cursor_Vertical_Position_Real_XY_1 = Cursor_Vertical_Position_Real_XY_1 - rot_buf;
                                    if ((Cursor_Vertical_Position_Real_XY_2 - rot_buf) > DrawXYOffsetX1) Cursor_Vertical_Position_Real_XY_2 = Cursor_Vertical_Position_Real_XY_2 - rot_buf;

									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real_XY_1 + rot_buf) < DrawXYOffsetX2) Cursor_Vertical_Position_Real_XY_1 = Cursor_Vertical_Position_Real_XY_1 + rot_buf;
                                    if ((Cursor_Vertical_Position_Real_XY_2 + rot_buf) < DrawXYOffsetX2) Cursor_Vertical_Position_Real_XY_2 = Cursor_Vertical_Position_Real_XY_2 + rot_buf;

									break;
								}							
							}
							break;
						}                        						
					}				
				
				    }
				    else // TMW comment added: else means Display_Mode ==0
				    {
				
					switch(Cursor_Vertical_Active)
					{
						case 1: // TMW comment added: 1 means Cursor X1 is active
						{
							CursorChanged = 1;					
							if (MenuItemPushed[1] == 0) doit = true;
							MenuButtonCheck(1);
							
                            //if (Cursor_Vertical_Position_Real1 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            //if (Cursor_Vertical_Position_Real1 > (600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = 600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
							
							if (Cursor_Vertical_Position_Real1 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) 
								Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            if (Cursor_Vertical_Position_Real1 > (SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float))) 
								Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);

							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real1 - rot_buf) > 0) Cursor_Vertical_Position_Real1 = Cursor_Vertical_Position_Real1 - rot_buf;		
 				             	
									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real1 + rot_buf) < 16384) Cursor_Vertical_Position_Real1 = Cursor_Vertical_Position_Real1 + rot_buf;		

									break;
								}
							}

							break;
						}
						case 2: // TMW comment added: 2 means Cursor X2 is active
						{
							CursorChanged = 2;
							
							if (MenuItemPushed[2] == 0) doit = true;
							MenuButtonCheck(2);
							
                            //if (Cursor_Vertical_Position_Real2 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            //if (Cursor_Vertical_Position_Real2 > (600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = 600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);		

							if (Cursor_Vertical_Position_Real2 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            if (Cursor_Vertical_Position_Real2 > (SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);

							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real2 - rot_buf) > 0) Cursor_Vertical_Position_Real2 = Cursor_Vertical_Position_Real2 - rot_buf;

									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real2 + rot_buf) < 16384) Cursor_Vertical_Position_Real2 = Cursor_Vertical_Position_Real2 + rot_buf;

									break;
								}
							}
							break;
						}	
						case 4:
						{
							CursorChanged = 1;					
							//if (MenuItemPushed[5] == 0) doit = true;
							MenuItemPushed[1] = 1;
							//MenuButtonCheck(5);
				            MenuItemChanged[1] = 1;
				            MenuItemChanged[2] = 1;							
						    /*
                            if (Cursor_Vertical_Position_Real1 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            if (Cursor_Vertical_Position_Real1 > (600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = 600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
						
                            if (Cursor_Vertical_Position_Real2 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);		
                            if (Cursor_Vertical_Position_Real2 > (600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = 600 + SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);		
						    */
							if (Cursor_Vertical_Position_Real1 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            if (Cursor_Vertical_Position_Real1 > (SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real1 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);							
							
							if (Cursor_Vertical_Position_Real2 < (SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float);
                            if (Cursor_Vertical_Position_Real2 > (SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float))) Cursor_Vertical_Position_Real2 = SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float);
						
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Vertical_Position_Real1 - rot_buf) > 0) Cursor_Vertical_Position_Real1 = Cursor_Vertical_Position_Real1 - rot_buf;
                                    if ((Cursor_Vertical_Position_Real2 - rot_buf) > 0) Cursor_Vertical_Position_Real2 = Cursor_Vertical_Position_Real2 - rot_buf;		

									break;
								}
								case 1:
								{
									if ((Cursor_Vertical_Position_Real1 + rot_buf) < 16384) Cursor_Vertical_Position_Real1 = Cursor_Vertical_Position_Real1 + rot_buf;		
                                    if ((Cursor_Vertical_Position_Real2 + rot_buf) < 16384) Cursor_Vertical_Position_Real2 = Cursor_Vertical_Position_Real2 + rot_buf;

									break;
								}
							}

							break;
						}                        					
					}
                    } // if (Display_Mode == 1)				
				}
				
				else if (Cursor_Vertical_Active == 3)
				{
					switch(Cursor_Horizontal_Active)
					{
						case 1:
						{
							CursorChanged = 4;
							
							if (MenuItemPushed[3] == 0) doit = true;
							MenuButtonCheck(3);
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Horizontal_Position_Real1 + 1) < 384) Cursor_Horizontal_Position_Real1 = Cursor_Horizontal_Position_Real1 + 1;

									break;
								}							
								case 1:
								{
									if ((Cursor_Horizontal_Position_Real1 - 1) > 0) Cursor_Horizontal_Position_Real1 = Cursor_Horizontal_Position_Real1 - 1;

									break;
								}
							}
#ifdef _Debug_Cursor_							
							if (Debug_Mode) printf("Cur H1 Pos %i\n", Cursor_Horizontal_Position_Real1);
#endif							
							break;
						}
						case 2:
						{
							CursorChanged = 5;
							
							if (MenuItemPushed[4] == 0) doit = true;
							MenuButtonCheck(4);
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Horizontal_Position_Real2 + 1) < 384) Cursor_Horizontal_Position_Real2 = Cursor_Horizontal_Position_Real2 + 1;

									break;
								}							
								case 1:
								{
									if ((Cursor_Horizontal_Position_Real2 - 1) > 0) Cursor_Horizontal_Position_Real2 = Cursor_Horizontal_Position_Real2 - 1;

									break;
								}
							}
#ifdef _Debug_Cursor_							
							if (Debug_Mode) printf("Cur H2 Pos %i\n", Cursor_Horizontal_Position_Real2);
#endif							
							break;
						}
						case 4:
						{
							CursorChanged = 4;
							
							if (MenuItemPushed[5] == 0) doit = true;
							MenuButtonCheck(5);
				            MenuItemChanged[3] = 1;
				            MenuItemChanged[4] = 1;
							
							switch(Direction)
							{
								case 0:
								{
									if ((Cursor_Horizontal_Position_Real1 + 1) < 384) Cursor_Horizontal_Position_Real1 = Cursor_Horizontal_Position_Real1 + 1;
                                    if ((Cursor_Horizontal_Position_Real2 + 1) < 384) Cursor_Horizontal_Position_Real2 = Cursor_Horizontal_Position_Real2 + 1;

									break;
								}							
								case 1:
								{
									if ((Cursor_Horizontal_Position_Real1 - 1) > 0) Cursor_Horizontal_Position_Real1 = Cursor_Horizontal_Position_Real1 - 1;
                                    if ((Cursor_Horizontal_Position_Real2 - 1) > 0) Cursor_Horizontal_Position_Real2 = Cursor_Horizontal_Position_Real2 - 1;

									break;
								}
							}
#ifdef _Debug_Cursor_							
							if (Debug_Mode) printf("Cur H1H2 Pos %i  %i\n", Cursor_Horizontal_Position_Real1, Cursor_Horizontal_Position_Real2);
#endif							
							break;
						}                        						
					}			
				}	

                rbuf--;
            }
							
			if (Cursor_Enabled)
			{	
                Display::CALCCURSORDATA();
				Display::DRAW_ALL_CURSOR();
				//if (doit == 0) ResetTimer();
			}		
			
			break;	
		} // Ende Cursor Menu
		
		
		case 19:
		{
            if (QM_Enabled == 0) break; 		

            while (rbuf > 0)
            {
                if ((MenuPopupActive > -1) && (MenuPopupActive != 4)) Display::DRAWMENUPOPDOWN();
                if (MenuPopupActive == 4)
                {

                    pos = -1;
                    if (Direction == 0) MenuPopupStep(4, &MenuStatus[19][1], &MenuStatus[19][2], &MenuStatus[20][4], 19, 52, 2);
                    else if (Direction == 1) MenuPopupStep(4, &MenuStatus[19][1], &MenuStatus[19][2], &MenuStatus[20][4], 19, 52, 1);

                    MenuStatus[21][4] = MenuStatus[20][4];

                    if (((MenuStatus[19][1] - 52) == 4) || ((MenuStatus[19][1] - 52) == 13))
                    {
                        if (MenuStatus[19][4] == 244) MenuItemChanged[4] = 1;
                        MenuStatus[19][4] = 242;
                    }
                    else
                    {
                        if (MenuStatus[19][4] == 242) MenuItemChanged[4] = 1;
                        MenuStatus[19][4] = 244;
                    }

                    MenuItemChanged[1] = 1;
                    MenuItemChanged[2] = 1;
						
                    New_Menu = 19;
                    Menu_Changed = 1;
                }
                else if (MenuPopupActive == -1)
                {
                    New_Menu = 19;
                    Menu_Changed = 1;
                }


                rbuf--;
            }

            Display::DRAWMENUPOPUP(4);		

            ResetTimer();
/*			
		
			if (QM_Enabled)
			{					
				Display::CALCQMDATA();
				if (doit == 0) ResetTimer();
			}						
*/
            break;
        }		

		case 22:
		{
            if (QM_Enabled == 0) break;

            while (rbuf > 0)
            {
                switch(Quick_Measure_Threshold_btn_select)
                {
                    case 1:
                    {
                        MenuButtonCheck(2);
                        //MenuItemPushed[2] = 1;
                        //MenuItemChanged[2] = 1;
                    		
                        QM_Threshold_lower.DoStep(Direction);
                        QM_Threshold_lower.RenderText();

                        break;
                    }
                    case 2:
                    {
                        MenuButtonCheck(3);

                        //MenuItemPushed[3] = 1;
                        //MenuItemChanged[3] = 1;

                        //ResetTimer();
		
                        QM_Threshold_middle.DoStep(Direction);
                        QM_Threshold_middle.RenderText();

                        break;
                    }
                    case 3:
                    {
                        MenuButtonCheck(4);
		
                        //MenuItemPushed[4] = 1;
                        //MenuItemChanged[4] = 1;
                        //ResetTimer();

                        QM_Threshold_upper.DoStep(Direction);
                        QM_Threshold_upper.RenderText();

                        break;
                    }
                }
                rbuf--;
            }

            ResetTimer();
            New_Menu = 22;
            Menu_Changed = 1;

            	
			break;
		}
		
		
		// Math Settings - Scale and Offset
		case 29:
		{		
		    if (MathToggle == 0)
		    {
                if (MenuItemPushed[0] == 0) doit = true;
                MenuButtonCheck(0);
			
                while (rbuf > 0)
                {				
                    switch(Direction)
                    {
                        case 0:
                        {
                            if (MenuStatus[26][2] == 1){ if (math_mul_scale > 166) math_mul_scale--; }
                            else if (MenuStatus[26][3] == 1){ if (math_sub_scale > 153) math_sub_scale--; }
                            else if (MenuStatus[26][4] == 1){ if (math_add_scale > 153) math_add_scale--; }
                            break;
                        }

                        case 1:
                        {
                            if (MenuStatus[26][2] == 1){ if (math_mul_scale < 181) math_mul_scale++; }
                            else if (MenuStatus[26][3] == 1){ if (math_sub_scale < 165) math_sub_scale++; }
                            else if (MenuStatus[26][4] == 1){ if (math_add_scale < 165) math_add_scale++; }
                            break;
                        }
                    }
                    rbuf--;
                }

                MenuItemChanged[0] = 1;
			}

		    if (MathToggle == 1)
		    {
                if (MenuItemPushed[1] == 0) doit = true;
                MenuButtonCheck(1);
			
                if ((rbuf > 5) && (rbuf < 11)) rbuf = rbuf * 3;
                else if (rbuf > 10) rbuf = rbuf * 7;
    			
                if (MenuStatus[26][2] == 1)
                {
                    while (rbuf > 0)
                    {
                        //Math_Offset_mul.DoStep(Direction);
                        //Math_Offset_mul.RenderText();

                        if (Direction)
                        {
                            if ((Math_Off_Mul_Expo == 2) && (Math_Off_Mul_Value >= 999)) break;
                            Math_Off_Mul_Value = Math_Off_Mul_Value + Math_Off_Mul_Steps;
                        }
                        else
                        {
                            if ((Math_Off_Mul_Expo == -2) && (Math_Off_Mul_Value <= -999)) break;
                            Math_Off_Mul_Value = Math_Off_Mul_Value - Math_Off_Mul_Steps;
                        }

                        if ((Math_Off_Mul_Value >= 1000) && (Math_Off_Mul_Expo == 0))
                        {
                            Math_Off_Mul_Value = 1;
                            Math_Off_Mul_Steps = 1;
                            Math_Off_Mul_Expo = 1;
                        }
                        else if ((Math_Off_Mul_Value >= 1000) && (Math_Off_Mul_Expo == 1))
                        {
                            Math_Off_Mul_Value = 1;
                            Math_Off_Mul_Steps = 1;
                            Math_Off_Mul_Expo = 2;
                        }
                        else if ((Math_Off_Mul_Value <= -1000) && (Math_Off_Mul_Expo == 0))
                        {
                            Math_Off_Mul_Value = -1;
                            Math_Off_Mul_Steps = 1;
                            Math_Off_Mul_Expo = -1;
                        }
                        else if ((Math_Off_Mul_Value <= -1000) && (Math_Off_Mul_Expo == -1))
                        {
                            Math_Off_Mul_Value = -1;
                            Math_Off_Mul_Steps = 1;
                            Math_Off_Mul_Expo = -2;
                        }
                        else if ((Math_Off_Mul_Value <= 0) && (Math_Off_Mul_Expo == 1))
                        {
                            if ((math_mul_scale >= 166) && (math_mul_scale <= 168))
                            {
                                Math_Off_Mul_Value = 999;
                                Math_Off_Mul_Expo = 0;
                                Math_Off_Mul_Steps = 1;
                            }
                            else
                            {
                                Math_Off_Mul_Value = -1;
                                Math_Off_Mul_Steps = 1;
                                Math_Off_Mul_Expo = -1;
                            }
                        }
                        else if ((Math_Off_Mul_Value <= 0) && (Math_Off_Mul_Expo == 2))
                        {
                            Math_Off_Mul_Value = 999;
                            Math_Off_Mul_Expo = 1;
                            Math_Off_Mul_Steps = 1;
                        }
                        else if ((Math_Off_Mul_Value >= 0) && (Math_Off_Mul_Expo == -1))
                        {
                            if ((math_mul_scale >= 166) && (math_mul_scale <= 168))
                            {
                                Math_Off_Mul_Value = -999;
                                Math_Off_Mul_Expo = 0;
                                Math_Off_Mul_Steps = 1;
                            }
                            else
                            {
                                Math_Off_Mul_Value = 1;
                                Math_Off_Mul_Steps = 1;
                                Math_Off_Mul_Expo = 1;
                            }
                        }
                        else if ((Math_Off_Mul_Value >= 0) && (Math_Off_Mul_Expo == -2))
                        {
                            Math_Off_Mul_Value = -999;
                            Math_Off_Mul_Expo = 1;
                            Math_Off_Mul_Steps = 1;
                        }
                        rbuf--;
                    }

                    switch(Math_Off_Mul_Expo)
                    {
                        case -2:
                        {
                            Math_Offset_mul.Write_StepSize(1);
                            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1);
                            break;
                        }
                        case -1:
                        {
                            Math_Offset_mul.Write_StepSize(0.001);
                            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                            break;
                        }
                        case 0:
                        {
                            Math_Offset_mul.Write_StepSize(0.000001);
                            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000000);
                            break;
                        }
                        case 1:
                        {
                            Math_Offset_mul.Write_StepSize(0.001);
                            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                            break;
                        }
                        case 2:
                        {
                            Math_Offset_mul.Write_StepSize(1);
                            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value);
                            break;
                        }
                    }

                    Math_Offset_mul.RenderText();

                }
                else if (MenuStatus[26][3] == 1)
                {
                    while (rbuf > 0)
                    {
                        //Math_Offset_mul.DoStep(Direction);
                        //Math_Offset_mul.RenderText();

                        if (Direction)
                        {
                            if ((Math_Off_Sub_Expo == 1) && (Math_Off_Sub_Value >= 999)) break;
                            Math_Off_Sub_Value = Math_Off_Sub_Value + Math_Off_Sub_Steps;
                        }
                        else
                        {
                            if ((Math_Off_Sub_Expo == -1) && (Math_Off_Sub_Value <= -999)) break;
                            Math_Off_Sub_Value = Math_Off_Sub_Value - Math_Off_Sub_Steps;
                        }

                        if ((Math_Off_Sub_Value >= 1000) && (Math_Off_Sub_Expo == 0))
                        {
                            Math_Off_Sub_Value = 1;
                            Math_Off_Sub_Steps = 1;
                            Math_Off_Sub_Expo = 1;
                        }
                        else if ((Math_Off_Sub_Value <= -1000) && (Math_Off_Sub_Expo == 0))
                        {
                            Math_Off_Sub_Steps = 1;
                            Math_Off_Sub_Value = -1;
                            Math_Off_Sub_Expo = -1;
                        }

                        else if ((Math_Off_Sub_Value <= 0) && (Math_Off_Sub_Expo == 1))
                        {
                            Math_Off_Sub_Expo = 0;
                            Math_Off_Sub_Value = 999;
                            Math_Off_Sub_Steps = 1;
                        }
                        else if ((Math_Off_Sub_Value >= 0) && (Math_Off_Sub_Expo == -1))
                        {
                            Math_Off_Sub_Expo = 0;
                            Math_Off_Sub_Value = -999;
                            Math_Off_Sub_Steps = 1;
                        }
                        rbuf--;
                    }

                    switch(Math_Off_Sub_Expo)
                    {
                        case -1:
                        {
                            Math_Offset_sub.Write_StepSize(1);
                            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                            break;
                        }
                        case 0:
                        {
                            Math_Offset_sub.Write_StepSize(0.001);
                            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value / (float) 1000);
                            break;
                        }
                        case 1:
                        {
                            Math_Offset_sub.Write_StepSize(1);
                            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                            break;
                        }
                    }

                    Math_Offset_sub.RenderText();

                }
                /*
                if (MenuStatus[26][3] == 1)
                {
                    while (rbuf > 0)
                    {
                        //Math_Offset_sub.DoStep(Direction);
                        //Math_Offset_sub.RenderText();

                        if (Direction)
                        {
                            if ((Math_Off_Sub_Expo == 2) && (Math_Off_Sub_Value >= 999)) break;
                            Math_Off_Sub_Value = Math_Off_Sub_Value + Math_Off_Sub_Steps;
                        }
                        else
                        {
                            if ((Math_Off_Sub_Expo == 1) && (Math_Off_Sub_Value <= 1)) break;
                            Math_Off_Sub_Value = Math_Off_Sub_Value - Math_Off_Sub_Steps;
                        }

                        if (Math_Off_Sub_Value >= 1000)
                        {
                            Math_Off_Sub_Value = 1;
                            Math_Off_Sub_Steps = 1;
                            Math_Off_Sub_Expo++;
                        }
                        else if (Math_Off_Sub_Value <= 0)
                        {
                            if (Math_Off_Sub_Expo > 1)
                            {
                                Math_Off_Sub_Expo--;
                                Math_Off_Sub_Value = 999;
                                Math_Off_Sub_Steps = 1;
                            }
                        }
                        rbuf--;
                    }

                    switch(Math_Off_Sub_Expo)
                    {
                        case 1:
                        {
                            Math_Offset_sub.Write_StepSize(0.001);
                            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value / (float) 1000);
                            break;
                        }
                        case 2:
                        {
                            Math_Offset_sub.Write_StepSize(1);
                            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                            break;
                        }
                    }

                    Math_Offset_sub.RenderText();

                }
                */
                else if (MenuStatus[26][4] == 1)
                {
                    while (rbuf > 0)
                    {
                        //Math_Offset_mul.DoStep(Direction);
                        //Math_Offset_mul.RenderText();

                        if (Direction)
                        {
                            if ((Math_Off_Add_Expo == 1) && (Math_Off_Add_Value >= 999)) break;
                            Math_Off_Add_Value = Math_Off_Add_Value + Math_Off_Add_Steps;
                        }
                        else
                        {
                            if ((Math_Off_Add_Expo == -1) && (Math_Off_Add_Value <= -999)) break;
                            Math_Off_Add_Value = Math_Off_Add_Value - Math_Off_Add_Steps;
                        }

                        if ((Math_Off_Add_Value >= 1000) && (Math_Off_Add_Expo == 0))
                        {
                            Math_Off_Add_Steps = 1;
                            Math_Off_Add_Value = 1;
                            Math_Off_Add_Expo = 1;
                        }
                        else if ((Math_Off_Add_Value <= -1000) && (Math_Off_Add_Expo == 0))
                        {
                            Math_Off_Add_Steps = 1;
                            Math_Off_Add_Value = -1;
                            Math_Off_Add_Expo = -1;
                        }

                        else if ((Math_Off_Add_Value <= 0) && (Math_Off_Add_Expo == 1))
                        {
                            Math_Off_Add_Expo = 0;
                            Math_Off_Add_Value = 999;
                            Math_Off_Add_Steps = 1;
                        }
                        else if ((Math_Off_Add_Value >= 0) && (Math_Off_Add_Expo == -1))
                        {
                            Math_Off_Add_Expo = 0;
                            Math_Off_Add_Value = -999;
                            Math_Off_Add_Steps = 1;
                        }
                        rbuf--;
                    }

                    switch(Math_Off_Add_Expo)
                    {
                        case -1:
                        {
                            Math_Offset_add.Write_StepSize(1);
                            Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                            break;
                        }
                        case 0:
                        {
                            Math_Offset_add.Write_StepSize(0.001);
                            Math_Offset_add.Write_Value((float) Math_Off_Add_Value / (float) 1000);
                            break;
                        }
                        case 1:
                        {
                            Math_Offset_add.Write_StepSize(1);
                            Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                            break;
                        }
                    }

                    Math_Offset_add.RenderText();

                }
                /*
                if (MenuStatus[26][4] == 1)
                {
                    while (rbuf > 0)
                    {
                        //Math_Offset_add.DoStep(Direction);
                        //Math_Offset_add.RenderText();

                        if (Direction)
                        {
                            if ((Math_Off_Add_Expo == 2) && (Math_Off_Add_Value >= 999)) break;
                            Math_Off_Add_Value = Math_Off_Add_Value + Math_Off_Add_Steps;
                        }
                        else
                        {
                            if ((Math_Off_Add_Expo == 1) && (Math_Off_Add_Value <= 1)) break;
                            Math_Off_Add_Value = Math_Off_Add_Value - Math_Off_Add_Steps;
                        }

                        if (Math_Off_Add_Value >= 1000)
                        {
                            Math_Off_Add_Value = 1;
                            Math_Off_Add_Steps = 1;
                            Math_Off_Add_Expo++;
                        }
                        else if (Math_Off_Add_Value <= 0)
                        {
                            if (Math_Off_Add_Expo > 1)
                            {
                                Math_Off_Add_Expo--;
                                Math_Off_Add_Value = 999;
                                Math_Off_Add_Steps = 1;
                            }
                        }
                        rbuf--;
                    }

                    switch(Math_Off_Add_Expo)
                    {
                        case 1:
                        {
                            Math_Offset_add.Write_StepSize(0.001);
                            Math_Offset_add.Write_Value((float) Math_Off_Add_Value / (float) 1000);
                            break;
                        }
                        case 2:
                        {
                            Math_Offset_add.Write_StepSize(1);
                            Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                            break;
                        }
                    }

                    Math_Offset_add.RenderText();
                }
                */

                MenuItemChanged[1] = 1;
			}
			
                        			
            New_Menu = 29;
            Menu_Changed = 1;

            break;	            			
		}		
		
		
	}	
	
	if (doit)
	{
		//printf("Do it\n");
		//ResetTimer();
		Display::DRAWSTATUS(Active_Menu, 1);		
		Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel
		
        New_Menu = Active_Menu;
        Menu_Changed = 1;
	}
	UpdateMenuTextPlane = true;	
}

void Hardware::DoEnableUARTInterrupt(void)							// Enable service routine
{
	nr_installuserisr(na_uart1_irq, ISR_UART, (int)puart);			// Install ISR for UART

	puart->np_uartcontrol = np_uartcontrol_irrdy_mask;				// Enable Control Bits
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("\nUART interrupt enabled.\n"); 							// print on console
#endif	
}
	
void Hardware::DoDisableUARTInterrupt(void)							// Disable service routine
{
	puart->np_uartcontrol = 0;										// Disable Control Bits
	nr_installuserisr(na_uart1_irq, 0, 0); 							// Install empty routine for uart irq
}

void Hardware::ISR_UART(int context)									// UART Interrupt subroutine
{
	char rxchar = -1;
	int status;
	int x;		
	
	int secbuf = 0;
	
	int Press_Time = 0;											// Stores Press Time;
	char Read_Key_Buffer = -1;									// Buffer Keyboard key
	char Read_Key = -1;											// Buffer Keyboard key
	int MenuKey = -1;											// Buffer Menu Key
	char longpush = 0;											// Stores if the Button pushed long

	unsigned long buffer_long;
			
//	if (init_done) Reset_the_Watchdog();
	
	tc_test_var2++;
	
	status = puart->np_uartstatus;	
	rxchar = puart->np_uartrxdata;	
	
	puart->np_uartstatus = 0;
    	
	
	if (status & np_uartstatus_rrdy_mask)
	{
		Read_Key = rxchar;
	
		MenuKey = -1;											// Define value in MenuKey

		if (Read_Key != -1)
		{
			Read_Key_Buffer = Read_Key;							// Buffer Read_Key
			Press_Time = 0;
			longpush = 0;
				
			while (Read_Key == Read_Key_Buffer)
			{
				nr_delay(100);
				Read_Key = nr_rxchar();							// Read the Console
				Press_Time++;
			}
			if (Press_Time > 20) longpush = 1;
						
			Read_Key = Read_Key_Buffer;
		}
		
		// Identify the pressed key
		if (Read_Key == 'a' ) { MenuKey = 0; }	// Acquire
		if (Read_Key == 'i' ) { MenuKey = 1; }	// Channel 1
		if (Read_Key == 'j' ) { MenuKey = 2; }	// Channel 2
		if (Read_Key == 'k' ) { MenuKey = 3; }	// Channel 3
		if (Read_Key == 'l' ) { MenuKey = 4; }	// Channel 4
		if (Read_Key == 'd' ) { MenuKey = 5; }	// Display
		if (Read_Key == 'u' ) { MenuKey = 6; }
		if (Read_Key == 'f' ) { MenuKey = 7; }	// File
		if (Read_Key == 's' ) { MenuKey = 8; }	// Save
		if (Read_Key == 'r' ) { MenuKey = 9; }	// Recall
		if (Read_Key == 'b' ) { MenuKey = 10; }	// Timebase Main/Delayed
		if (Read_Key == 'y' ) { MenuKey = 11; }
		if (Read_Key == 't' ) { MenuKey = 12; }
		if (Read_Key == 'm' ) { MenuKey = 13; }
		if (Read_Key == 'e' ) { MenuKey = 14; }	// Edge Trigger
		if (Read_Key == 'p' ) { MenuKey = 15; }	// Pulse Width		
		if (Read_Key == 'c' ) { MenuKey = 16; }	// 16 : CursorX
		if (Read_Key == 'q' ) { MenuKey = 19; }	// Quick Measure
		if (Read_Key == 'w' ) { MenuKey = 20; }	// Quick Measure Delay Settings
		if (Read_Key == 'v' ) { MenuKey = 21; }	// Quick Measure Phase Settings
		if (Read_Key == 'n' ) { MenuKey = 22; } // New File
		if (Read_Key == 'g' ) { MenuKey = 23; } // Pattern
		if (Read_Key == 'h' ) { MenuKey = 55; } // Help Menu // 24 Trigger More  25 : Settings
		if (Read_Key == 'o' ) { MenuKey = 26; } // Math  27 : Settings
				
		if (Read_Key == '1' ) { MenuKey = 30; }
		if (Read_Key == '2' ) { MenuKey = 31; }
		if (Read_Key == '3' ) { MenuKey = 32; }
		if (Read_Key == '4' ) { MenuKey = 33; }
		if (Read_Key == '5' ) { MenuKey = 34; }
		if (Read_Key == '6' ) { MenuKey = 35; }
		if (Read_Key == '7' ) { MenuKey = 36; }
		if (Read_Key == '8' ) { MenuKey = 37; }
		if (Read_Key == '9' ) { MenuKey = 38; }
		if (Read_Key == '0' ) { MenuKey = 39; }

		if (Read_Key == 'Q' ) { MenuKey = 40; }
		if (Read_Key == 'W' ) { MenuKey = 41; }
		if (Read_Key == 'E' ) { MenuKey = 42; }
		if (Read_Key == 'R' ) { MenuKey = 43; }
		if (Read_Key == 'T' ) { MenuKey = 44; }
		if (Read_Key == 'Z' ) { MenuKey = 45; }
		if (Read_Key == 'U' ) { MenuKey = 46; }
		if (Read_Key == 'I' ) { MenuKey = 47; }
		if (Read_Key == 'O' ) { MenuKey = 48; }
		if (Read_Key == 'P' ) { MenuKey = 49; }

		if (Read_Key == 'A' ) { MenuKey = 50; }
		if (Read_Key == 'S' ) { MenuKey = 51; }
		if (Read_Key == 'D' ) { MenuKey = 52; }
		if (Read_Key == 'F' ) { MenuKey = 53; }
		if (Read_Key == 'G' ) { MenuKey = 54; }
		if (Read_Key == 'H' ) { MenuKey = 55; } // Help Menu
		if (Read_Key == 'J' ) { MenuKey = 56; }
		if (Read_Key == 'K' ) { MenuKey = 57; }
		if (Read_Key == 'L' ) { MenuKey = 58; }
		if (Read_Key == '' ) { MenuKey = 59; }
		
		if (Read_Key == 'Y' ) { MenuKey = 60; }
		if (Read_Key == 'X' ) { MenuKey = 61; }
		if (Read_Key == 'C' ) { MenuKey = 62; }
		if (Read_Key == 'V' ) { MenuKey = 63; }
		if (Read_Key == 'B' ) { MenuKey = 64; }
		if (Read_Key == 'N' ) { MenuKey = 65; }
		if (Read_Key == 'M' ) { MenuKey = 66; }		
		if (Read_Key == ';' ) { MenuKey = 67; }
		if (Read_Key == ':' ) { MenuKey = 68; }	
		if (Read_Key == ',' ) { MenuKey = 69; }	
		if (Read_Key == '.' ) { MenuKey = 70; }	
		if (Read_Key == '-' ) { MenuKey = 71; }	
		
		
		if (Read_Key == '!' ) { MenuKey = 80; }
		if (Read_Key == '"' ) { MenuKey = 81; }	
		if (Read_Key == '' ) { MenuKey = 82; }	
		if (Read_Key == '$' ) { MenuKey = 83; }	
		if (Read_Key == '%' ) { MenuKey = 84; }	

		if (Read_Key == '&' ) { MenuKey = 85; }
		if (Read_Key == '/' ) { MenuKey = 86; }	
		if (Read_Key == '(' ) { MenuKey = 87; }	
		if (Read_Key == ')' ) { MenuKey = 88; }	
		if (Read_Key == '=' ) { MenuKey = 89; }		
		
                                		
		if (Read_Key == ' ' ) { MenuKey = -2; }
		
		if (Read_Key == 0x0A ) { MenuKey = -10; }	// Enter Key
		if (Read_Key == 0x08 ) { MenuKey = -11; }	// Backspace Key
		if (Read_Key == 0x09 ) { MenuKey = -12; }	// TAB Key
//		if (Read_Key == 0x1b ) { MenuKey = -13; }	// ESC Key
		if (Read_Key == 'x' )
		{

		}
			
		if (MenuKey != -1)
		{
#ifdef _Debug_IRQ_		
			if (Debug_Mode) printf("MKey : %i RKey : %2i  PL : %i\n\n", MenuKey, Read_Key, longpush);
#endif			
			//ButtonChanged = 1;
			Buttonhandler(MenuKey, longpush);			
		}
		
		
		//if ((MenuKey == -1) && (Read_Key != -1)) printf("Key : %2x\n\n", Read_Key);
		
		/*
		if (MenuKey == -11)
		{
			for (x = 0; x < 20; x++)
			{
				buffer_long = READADC(4);
			}				
		}
		
		if (MenuKey == -12) Display::REMOVESIG(1);*/
	}
}

void Hardware::DoEnableUART2Interrupt(void)							// Enable service routine
{
	uart2_count = 0;
	
	nr_installuserisr(na_uart_usb_irq, ISR_UART2, (int)puart2);		// Install ISR for UART2

	puart2->np_uartcontrol = np_uartcontrol_irrdy_mask;				// Enable Control Bits
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("\nUART USB interrupt enabled.\n"); 						// print on console
#endif	
}
	
void Hardware::DoDisableUART2Interrupt(void)						// Disable service routine
{
	puart2->np_uartcontrol = 0;										// Disable Control Bits
	nr_installuserisr(na_uart_usb_irq, 0, 0); 							// Install empty routine for uart2 irq
}

void Hardware::ISR_UART2(int context)								// UART Interrupt subroutine
{
	char rxchar = -1;
	int status;
	int x;	
		
//	if (init_done) Reset_the_Watchdog();
		
	status = puart2->np_uartstatus;	
	rxchar = puart2->np_uartrxdata;	
	
	tc_test_var2++;
	
	puart2->np_uartstatus = 0;									// Clear Interrupt condition
	   	
	if (status & np_uartstatus_rrdy_mask)
	{
		uart2_buffer[uart2_count] = rxchar;
			
		uart2_count++;
	}	
	
	if (uart2_buffer[0] != 37) uart2_count = 0;
	
	if (uart2_count == 37)
	{		
		InterpretUART(uart2_buffer);
		
		uart2_count = 0;
		
		//config_changed = true;
#ifdef _Debug_USB_		
		if (Debug_Mode) printf("USB DATA Received\n");
#endif	
#ifdef _Debug_IRQ_		
		if (Debug_Mode) printf("USB DATA Received\n");
#endif		
	}
	
	puart2->np_uartstatus = 0;
}

void Hardware::InterpretUART(volatile unsigned char data[37])
{	
	char cnt, result_buf = 0;
	char CalcBuf;
	int	ix, CalcBufInt;
	long int libuf;
	
    int lcnt = 0;
    unsigned long buflong, buflong1, buflong2 = 0;	
	
	unsigned long *prog_flash_adr_buf;
	unsigned long *prog_flash_adr_buf2;
    unsigned char add_buf = 0;

    char DataStr[50];
	
//	unsigned char SendBuffer[37] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
#ifdef _Debug_USB_	
//	printf("Received Command %d  Which %d  dl %d  dh %d  dxl %d  dxh %d  dext %d\n", data[0], data[1], data[2], data[3], data[4], data[5], data[6]);
	if (Debug_Mode) printf("Received %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x\n", data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14], data[15], data[16], data[17], data[18], data[19], data[20], data[21], data[22], data[23], data[24], data[25], data[26], data[27]);
#endif
    if ((data[1] == 3) && (data[2] == 4))
    {
        //start_acq->np_piodata = 0x01;				//start record Port On
        //start_acq->np_piodata = 0x00;				//start record Port Off			
    }
    else
    {
	switch(data[1])
	{
		case 1: 											// Send Screen Shot
		{
			if (data[2] == 0) SendShot();
			else SendSWShot();
			break;
		}
		case 2: 											// Send Data
		{
			
			//switch(which)
			switch(data[2])
			{
				
				case 0: 									//
				{
					//
					break;
				}
				
				case 1:										// Main Time Base
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
					send_buffer[2] = Selected_Timebase;
					
					SendData(send_buffer);

					break;
				}
				
				case 2:										// Expand Time Base
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
					send_buffer[2] = Selected_Expand_Timebase;
					
					SendData(send_buffer);
					break;
				}
							
				case 8:
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
					send_buffer[2] = GridColor_Val;
					
					SendData(send_buffer);
					break;
				}				
				
				case 9:										// Main Time Base
				{
					
					for (cnt = 0; cnt < 32; cnt++)
					{
						send_buffer[0] = 3;						// Command Write Data
						send_buffer[1] = data[2];
						
						send_buffer[2] = cnt;
					
						send_buffer[3] = LogicData[cnt] & 0xFF;
						send_buffer[4] = (LogicData[cnt] & 0xFF00) >> 8;
										
						SendData(send_buffer);
					}

					break;
				}				
				
				case 12:									// Channel 1
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
										
					CalcBuf = Selected_Voltage_CH1;
									
					if ((MenuStatus[1][0] - 6) == 0) CalcBuf = CalcBuf | 0x80;   // Ground
					if ((MenuStatus[1][0] - 6) == 1) CalcBuf = CalcBuf | 0x40;   // AC
							
					send_buffer[2] = CalcBuf;

					CalcBuf = (char) MenuStatus[1][3] - 101;
					
//					if ((MenuStatus[1][4] - 99) == 1) CalcBuf = CalcBuf | 0x80;

					send_buffer[3] = CalcBuf;				
					
					send_buffer[4] = (char) (ZeroLevelCH1 / 1.5);
					
					SendData(send_buffer);
					
					break;
				}
				case 13:									// Channel 2
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
										
					CalcBuf = Selected_Voltage_CH2;
					if ((MenuStatus[2][0] - 6) == 0) CalcBuf = CalcBuf | 0x80;   // Ground
					if ((MenuStatus[2][0] - 6) == 1) CalcBuf = CalcBuf | 0x40;   // AC
			
					send_buffer[2] = CalcBuf;

					CalcBuf = (char) MenuStatus[2][3] - 101;
				//	if ((MenuStatus[2][4] - 99) == 1) CalcBuf = CalcBuf || 0x80;

					send_buffer[3] = CalcBuf;
					
					send_buffer[4] = (char) (ZeroLevelCH2 / 1.5);
					
					SendData(send_buffer);
												
					break;
				}
				case 14:									// Channel 3
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];					
					
					CalcBuf = Selected_Voltage_CH3;
					if ((MenuStatus[3][0] - 6) == 0) CalcBuf = CalcBuf | 0x80;   // Ground
					if ((MenuStatus[3][0] - 6) == 1) CalcBuf = CalcBuf | 0x40;   // AC
			
					send_buffer[2] = CalcBuf;

					CalcBuf = (char) MenuStatus[3][3] - 101;
				//	if ((MenuStatus[3][4] - 99) == 1) CalcBuf = CalcBuf | 0x80;

					send_buffer[3] = CalcBuf;
					
					
					
					
					send_buffer[4] = (char) (ZeroLevelCH3 / 1.5);
					
					SendData(send_buffer);
												
					break;
				}
				case 15:									// Channel 4
				{
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];					
					
					CalcBuf = Selected_Voltage_CH4;
					if ((MenuStatus[4][0] - 6) == 0) CalcBuf = CalcBuf | 0x80;   // Ground
					if ((MenuStatus[4][0] - 6) == 1) CalcBuf = CalcBuf | 0x40;   // AC
			
					send_buffer[2] = CalcBuf;

					CalcBuf = (char) MenuStatus[4][3] - 101;
				//	if ((MenuStatus[4][4] - 99) == 1) CalcBuf = CalcBuf | 0x80;

					send_buffer[3] = CalcBuf;
					
					send_buffer[4] = (char) (ZeroLevelCH4 / 1.5);
					
					SendData(send_buffer);
													
					break;
				}	

				case 20:										// Protected Config Shifting
				{
				
					send_buffer[0] = 2;						// Command Write Data
					send_buffer[1] = 20;
					
					send_buffer[2] = tc_model & 0x000000FF;
					send_buffer[3] = (tc_model & 0x0000FF00) >> 8;
					send_buffer[4] = (tc_model & 0x00FF0000) >> 16;
					send_buffer[5] = (tc_model & 0xFF000000) >> 24;
					
					send_buffer[6] = tc_serial & 0x000000FF;
					send_buffer[7] = (tc_serial & 0x0000FF00) >> 8;
					send_buffer[8] = (tc_serial & 0x00FF0000) >> 16;
					send_buffer[9] = (tc_serial & 0xFF000000) >> 24;

					send_buffer[10] = tc_production_lot1 & 0x000000FF;
					send_buffer[11] = (tc_production_lot1 & 0x0000FF00) >> 8;
					send_buffer[12] = (tc_production_lot1 & 0x00FF0000) >> 16;
					send_buffer[13] = (tc_production_lot1 & 0xFF000000) >> 24;

					send_buffer[14] = tc_production_lot2 & 0x000000FF;
					send_buffer[15] = (tc_production_lot2 & 0x0000FF00) >> 8;
					send_buffer[16] = (tc_production_lot2 & 0x00FF0000) >> 16;
					send_buffer[17] = (tc_production_lot2 & 0xFF000000) >> 24;

					send_buffer[18] = tc_shipment_date & 0x000000FF;
					send_buffer[19] = (tc_shipment_date & 0x0000FF00) >> 8;
					send_buffer[20] = (tc_shipment_date & 0x00FF0000) >> 16;
					send_buffer[21] = (tc_shipment_date & 0xFF000000) >> 24;

					send_buffer[22] = kill_adc & 0x000000FF;
					send_buffer[23] = (kill_adc & 0x0000FF00) >> 8;

					send_buffer[24] = m2k_filter_Mode | (volt_filter_Mode << 4);
					
					SendData(send_buffer);					
				
				    break;
				}
				
				case 21:										// Hardware Shifting
				{
					la_gate->np_piodata = 0x00;
                    				
					send_buffer[0] = 3;						// Command Write Data
					send_buffer[1] = data[2];
					send_buffer[2] = la_data->np_piodata & 0x00FF;
					send_buffer[3] = (la_data->np_piodata & 0xFF00) >> 8;
                    					
					SendData(send_buffer);
#ifdef _Debug_USB_									
					printf("Hardware read : %x \n", la_data->np_piodata);
#endif					
					break;
				}	

				case 22:
				{                  				
					send_buffer[0] = 2;
					send_buffer[1] = 22;
                    send_buffer[2] = 1;

                    send_buffer[4] = (unsigned char) Voltage_Correction[0][0];
                    send_buffer[5] = (unsigned char) Voltage_Correction[0][1];
                    send_buffer[6] = (unsigned char) Voltage_Correction[0][2];
                    send_buffer[7] = (unsigned char) Voltage_Correction[0][3];
                    send_buffer[8] = (unsigned char) Voltage_Correction[0][4];
                    send_buffer[9] = (unsigned char) Voltage_Correction[0][5];
                    send_buffer[10] = (unsigned char) Voltage_Correction[0][6];
                    send_buffer[11] = (unsigned char) Voltage_Correction[0][7];
                    send_buffer[12] = (unsigned char) Voltage_Correction[0][8];
                    send_buffer[13] = (unsigned char) Voltage_Correction[0][9];
                    send_buffer[14] = (unsigned char) Voltage_Correction[0][10];
                    send_buffer[15] = (unsigned char) Voltage_Correction[0][11];

                    send_buffer[16] = (unsigned char) Voltage_Correction[1][0];
                    send_buffer[17] = (unsigned char) Voltage_Correction[1][1];
                    send_buffer[18] = (unsigned char) Voltage_Correction[1][2];
                    send_buffer[19] = (unsigned char) Voltage_Correction[1][3];
                    send_buffer[20] = (unsigned char) Voltage_Correction[1][4];
                    send_buffer[21] = (unsigned char) Voltage_Correction[1][5];
                    send_buffer[22] = (unsigned char) Voltage_Correction[1][6];
                    send_buffer[23] = (unsigned char) Voltage_Correction[1][7];
                    send_buffer[24] = (unsigned char) Voltage_Correction[1][8];
                    send_buffer[25] = (unsigned char) Voltage_Correction[1][9];
                    send_buffer[26] = (unsigned char) Voltage_Correction[1][10];
                    send_buffer[27] = (unsigned char) Voltage_Correction[1][11];

                    send_buffer[28] = (unsigned char) Voltage_Offset[0][0];
                    send_buffer[29] = (unsigned char) Voltage_Offset[0][1];
                    send_buffer[30] = (unsigned char) Voltage_Offset[0][2];
                    send_buffer[31] = (unsigned char) Voltage_Offset[0][3];

                    send_buffer[32] = (unsigned char) Voltage_Offset[1][0];
                    send_buffer[33] = (unsigned char) Voltage_Offset[1][1];
                    send_buffer[34] = (unsigned char) Voltage_Offset[1][2];
                    send_buffer[35] = (unsigned char) Voltage_Offset[1][3];


					SendData(send_buffer);
					
					nr_delay(10);
					
					send_buffer[0] = 2;
					send_buffer[1] = 22;
                    send_buffer[2] = 2;

                    send_buffer[4] = (unsigned char) Voltage_Correction[2][0];
                    send_buffer[5] = (unsigned char) Voltage_Correction[2][1];
                    send_buffer[6] = (unsigned char) Voltage_Correction[2][2];
                    send_buffer[7] = (unsigned char) Voltage_Correction[2][3];
                    send_buffer[8] = (unsigned char) Voltage_Correction[2][4];
                    send_buffer[9] = (unsigned char) Voltage_Correction[2][5];
                    send_buffer[10] = (unsigned char) Voltage_Correction[2][6];
                    send_buffer[11] = (unsigned char) Voltage_Correction[2][7];
                    send_buffer[12] = (unsigned char) Voltage_Correction[2][8];
                    send_buffer[13] = (unsigned char) Voltage_Correction[2][9];
                    send_buffer[14] = (unsigned char) Voltage_Correction[2][10];
                    send_buffer[15] = (unsigned char) Voltage_Correction[2][11];

                    send_buffer[16] = (unsigned char) Voltage_Correction[3][0];
                    send_buffer[17] = (unsigned char) Voltage_Correction[3][1];
                    send_buffer[18] = (unsigned char) Voltage_Correction[3][2];
                    send_buffer[19] = (unsigned char) Voltage_Correction[3][3];
                    send_buffer[20] = (unsigned char) Voltage_Correction[3][4];
                    send_buffer[21] = (unsigned char) Voltage_Correction[3][5];
                    send_buffer[22] = (unsigned char) Voltage_Correction[3][6];
                    send_buffer[23] = (unsigned char) Voltage_Correction[3][7];
                    send_buffer[24] = (unsigned char) Voltage_Correction[3][8];
                    send_buffer[25] = (unsigned char) Voltage_Correction[3][9];
                    send_buffer[26] = (unsigned char) Voltage_Correction[3][10];
                    send_buffer[27] = (unsigned char) Voltage_Correction[3][11];

                    send_buffer[28] = (unsigned char) Voltage_Offset[2][0];
                    send_buffer[29] = (unsigned char) Voltage_Offset[2][1];
                    send_buffer[30] = (unsigned char) Voltage_Offset[2][2];
                    send_buffer[31] = (unsigned char) Voltage_Offset[2][3];

                    send_buffer[32] = (unsigned char) Voltage_Offset[3][0];
                    send_buffer[33] = (unsigned char) Voltage_Offset[3][1];
                    send_buffer[34] = (unsigned char) Voltage_Offset[3][2];
                    send_buffer[35] = (unsigned char) Voltage_Offset[3][3];

					SendData(send_buffer);					
#ifdef _Debug_USB_									
					printf("Sending Voltage Corretion \n");
#endif
                    break;
                }                															
			}
			
			
			break;
		}
		case 3: 											// Receive Data
		{		
			switch(data[2])
			{
				case 0: 								
				{                                           // Connection made
					if ((data[3] & 0x01) == 0x01) OneShotRestart = true;
					if ((data[3] & 0x02) == 0x02) USB_Data_Trans = true;
					if ((data[3] & 0x04) == 0x04) Continius = true;
					if ((data[3] & 0x08) == 0x08) USB_SendAllData = true;
					
					USB_At_Startup = true;
                    /*					
					if (Debug_Mode)
					{
                        if ((data[3] & 0x80) == 0x80) printf("Received USB open at startup\n");
                        else printf("Received USB open\n");
                    }
					 */
					config_changed = true;
					break;
				}
				
				case 1:										// Main Time Base
				{
					Selected_Timebase = data[3];
					break;
				}
				
				case 2:										// Expand Time Base
				{
					Selected_Expand_Timebase = data[3];
					break;
				}
				
				case 3:										// Main Registers
				{
				    AutoTimerOff = true;
				
					ctrl_reg = data[3] + (data[4] << 8);
					adc_ctrl_reg = data[20] + (data[21] << 8);
					
					if ((ctrl_reg & 0x0010) == 0x0010)
					{					
                        data_adr->np_piodata = 0x01;

                        if ((adc_ctrl_reg & 0x0100) == 0x0100) WRITEADC(1, 0x200);
                        if ((adc_ctrl_reg & 0x0200) == 0x0200) WRITEADC(2, 0x200);
                        if ((adc_ctrl_reg & 0x0400) == 0x0400) WRITEADC(3, 0x200);
                        if ((adc_ctrl_reg & 0x0800) == 0x0800) WRITEADC(4, 0x200);

                        data_adr->np_piodata = 0x00;

                        if ((adc_ctrl_reg & 0x0100) == 0x0100) printf("Read Test ADC1 : %d\n", READADC(1));
                        if ((adc_ctrl_reg & 0x0200) == 0x0200) printf("Read Test ADC2 : %d\n", READADC(2));
                        if ((adc_ctrl_reg & 0x0400) == 0x0400) printf("Read Test ADC3 : %d\n", READADC(3));
                        if ((adc_ctrl_reg & 0x0800) == 0x0800) printf("Read Test ADC4 : %d\n", READADC(4));
					}
					
					trig_holdoff_reg = 0xFFFFFFFF - (data[5] + (data[6] << 8) + (data[7] << 16) + (data[8] << 24));					
									
					timebase_reg = tb_value[data[9]];
					Selected_Timebase = data[9];
					Selected_Expand_Timebase = data[10];
					
					SIGNALFaktor_idx = data[10];
					
					pre_reg = data[11] + (data[12] << 8);
					//trg_val_CHI_reg = (data[13] + (data[14] << 8));
					//trg_val_CHII_reg = (data[15] + (data[16] << 8));
					//trg_val_CHIII_reg = (data[31] + (data[32] << 8));					
					//trg_val_CHIV_reg = (data[33] + (data[34] << 8));

					Trigger_Pos_CH1 = (unsigned int)((255 - (data[13] + (data[14] << 8))) << 1) - 64;
					Trigger_Pos_CH2 = (unsigned int)((255 - (data[15] + (data[16] << 8))) << 1) - 64;
					Trigger_Pos_CH3 = (unsigned int)((255 - (data[31] + (data[32] << 8))) << 1) - 64;
					Trigger_Pos_CH4 = (unsigned int)((255 - (data[33] + (data[34] << 8))) << 1) - 64; 	                      					
                    					
					ram_adress_reg = data[17] + (data[18] << 8);
					
					triggering = data[19];
					
                    TimebaseChanged = 1;
                    SIGNALFaktorChanged = 1;					
				    /* siehe oben
					if ((data[20] & 0x01) == 0x01) adc_ctrl_reg |= 0x0001;
					if ((data[20] & 0x02) == 0x02) adc_ctrl_reg |= 0x0002;
					if ((data[20] & 0x04) == 0x04) adc_ctrl_reg |= 0x0004;
					if ((data[20] & 0x08) == 0x08) adc_ctrl_reg |= 0x0008;					
					
					if ((data[20] & 0x10) == 0x10) adc_ctrl_reg |= 0x0010;
					if ((data[20] & 0x20) == 0x20) adc_ctrl_reg |= 0x0020;
					if ((data[20] & 0x40) == 0x40) adc_ctrl_reg |= 0x0040;
					if ((data[20] & 0x80) == 0x80) adc_ctrl_reg |= 0x0080;						
					
					if ((data[21] & 0x01) == 0x01) adc_ctrl_reg |= 0x0100;
					if ((data[21] & 0x02) == 0x02) adc_ctrl_reg |= 0x0200;
					if ((data[21] & 0x04) == 0x04) adc_ctrl_reg |= 0x0400;
					if ((data[21] & 0x08) == 0x08) adc_ctrl_reg |= 0x0800;															
					
					if ((data[21] & 0x10) == 0x10) adc_ctrl_reg |= 0x1000;
					if ((data[21] & 0x20) == 0x20) adc_ctrl_reg |= 0x2000;
					if ((data[21] & 0x40) == 0x40) adc_ctrl_reg |= 0x4000;
					if ((data[21] & 0x80) == 0x80) adc_ctrl_reg |= 0x8000;	
					*/					
					if ((data[20] & 0x10) == 0x10) Channel_1_Active = 0;
					else Channel_1_Active = 1;
					if ((data[20] & 0x20) == 0x20) Channel_2_Active = 0;
					else Channel_2_Active = 1;
					if ((data[20] & 0x40) == 0x40) Channel_3_Active = 0;
					else Channel_3_Active = 1;
					if ((data[20] & 0x80) == 0x80) Channel_4_Active = 0;
					else Channel_4_Active = 1;	
								
					Selected_Trigger_Source = 0;
					
                    CalcBufInt = (128 - ((Trigger_Pos_CH1 + 64) >> 1)) >> 1;
                    if (multi_active)
                    {
                        if (Voltage_Correction[0][Selected_Voltage_CH1] == 0) CalcBufInt = 0;
                        else CalcBufInt = int (float (CalcBufInt) / Volt_Correct_float[0][Selected_Voltage_CH1]);
                    }
                    trg_val_CHI_reg	= 255 - (((Trigger_Pos_CH1 + 64) >> 1) + CalcBufInt);

                    CalcBufInt = (128 - ((Trigger_Pos_CH2 + 64) >> 1)) >> 1;
                    if (multi_active)
                    {
                        if (Voltage_Correction[0][Selected_Voltage_CH2] == 0) CalcBufInt = 0;
                        else CalcBufInt = int (float (CalcBufInt) / Volt_Correct_float[0][Selected_Voltage_CH2]);
                    }
                    trg_val_CHII_reg = 255 - (((Trigger_Pos_CH2 + 64) >> 1) + CalcBufInt);

                    CalcBufInt = (128 - ((Trigger_Pos_CH3 + 64) >> 1)) >> 1;
                    if (multi_active)
                    {
                        if (Voltage_Correction[0][Selected_Voltage_CH3] == 0) CalcBufInt = 0;
                        else CalcBufInt = int (float (CalcBufInt) / Volt_Correct_float[0][Selected_Voltage_CH3]);
                    }
                    trg_val_CHIII_reg = 255 - (((Trigger_Pos_CH3 + 64) >> 1) + CalcBufInt);

                    CalcBufInt = (128 - ((Trigger_Pos_CH4 + 64) >> 1)) >> 1;
                    if (multi_active)
                    {
                        if (Voltage_Correction[0][Selected_Voltage_CH4] == 0) CalcBufInt = 0;
                        else CalcBufInt = int (float (CalcBufInt) / Volt_Correct_float[0][Selected_Voltage_CH4]);
                    }
                    trg_val_CHIV_reg = 255 - (((Trigger_Pos_CH4 + 64) >> 1) + CalcBufInt);


                    printf("Trig1 : %x - %x\n", Trigger_Pos_CH1, trg_val_CHI_reg);
                    printf("Trig2 : %x - %x\n", Trigger_Pos_CH2, trg_val_CHII_reg);
                    printf("Trig3 : %x - %x\n", Trigger_Pos_CH3, trg_val_CHIII_reg);
                    printf("Trig4 : %x - %x\n", Trigger_Pos_CH4, trg_val_CHIV_reg);

									
					if ((data[3] & 0x02) == 0x02)
					{
						if ((data[20] & 0x01) == 0x01) Selected_Trigger_Source = 1;
						if ((data[20] & 0x02) == 0x02) Selected_Trigger_Source = 2;
						if ((data[20] & 0x04) == 0x04) Selected_Trigger_Source = 3;
						if ((data[20] & 0x08) == 0x08) Selected_Trigger_Source = 4;
						
					}
					else Selected_Trigger_Source = 5;
					
					Trigger_Offset_Pos = pre_reg << 2;					
					
					if ((ctrl_reg & 0x40) == 0x40) MenuStatus[12][0] = 93;
					else MenuStatus[12][0] = 94;
                 									
					trig_range_reg = data[22] + (data[23] << 8);
					
					trig_width_reg = data[24] + (data[25] << 8);
					
					
					// pulse width menu update
					if ((ctrl_reg & 0x1200) == 0x1200)
					{
					   MenuStatus[15][2] = 1;
					   Pulse22.Write_Value((float) trig_width_reg * (float) 0.000000008);					
					   Pulse22.RenderText();
                    }
   					if ((ctrl_reg & 0x1400) == 0x1400)
					{
					   MenuStatus[15][2] = 2;
					   Pulse21.Write_Value((float) trig_width_reg * (float) 0.000000008);
                       Pulse21.RenderText();				
                    }
					if ((ctrl_reg & 0x1800) == 0x1800)
					{
					   MenuStatus[15][2] = 3;
					
					   Pulse11.Write_Value((float) trig_width_reg * (float) 0.000000008);
					   Pulse12.Write_Value((float) trig_range_reg * (float) 0.000000008);
					
					   Pulse11.RenderText();
					   Pulse12.RenderText();
                    }
                    				
					
					// Extern Trigger Level
					ext_trg_val_reg = data[26];
					Trigger_Pos_CHE = data[26];
					
					// Channel Address Add
					
					channel_Adr_add = data[27] + (data[28] << 8);
					channel_Adr_add2 = data[29] + (data[30] << 8);
					
					serdata->np_piodata = ext_trg_val_reg;
	
					serstartpwm->np_piodata = 1;
					serstartpwm->np_piodata = 0;						
					
    				data_adr->np_piodata = ram_adress_reg;					
	
    				mode->np_piodata = 0x00;
    				mode->np_piodata = 0x00;
					mode->np_piodata = 0x01;
    				mode->np_piodata = 0x00;
					
#ifdef _Debug_USB_
					if (Debug_Mode)
					{
                        printf("pre :%x \n", pre_reg);
					    printf("ctr :%x \n", ctrl_reg);
					    printf("adc :%x \n", adc_ctrl_reg);
					    printf("del :%x \n", adc_del_reg);
					    printf("trg1 :%x \n", trg_val_CHI_reg);
					    printf("extrg :%x \n", ext_trg_val_reg);	
					    printf("tb :%x \n", timebase_reg);
					    printf("tr :%x \n", trig_range_reg);
					    printf("tw :%x \n", trig_width_reg);
					    printf("CHA 1 :%d, 2 :%d, 3 :%d, 4 :%d\n", Channel_1_Active, Channel_2_Active, Channel_3_Active, Channel_4_Active);
					    printf("TrigSrc %d, Trig %d\n", Selected_Trigger_Source, triggering);
					    printf("Channel Add %x\n", channel_Adr_add);
						printf("Channel2 Add %x\n", channel_Adr_add2);
	                }		
#endif
                    //S Display::Update_Channel_Data(1);

					SetupADC();	
					Display::DRAW_ALL_CURSOR();
					
					config_changed = true;
					
					
                    if ((adc_ctrl_reg & 0x1000) == 0x1000)
                    {
                        tc_test_var = (unsigned long) la_data->np_piodata;

                        send_buffer[0] = 6;								 // Kennung Test Var

                        send_buffer[1] = (unsigned char) (tc_test_var & 0x000000FF);
                        send_buffer[2] = (unsigned char) ((tc_test_var & 0x0000FF00) >> 8);


                        send_buffer[3] = (unsigned char) (timebase_reg & 0x000000FF);
                        send_buffer[4] = (unsigned char) ((timebase_reg & 0x0000FF00) >> 8);
                        send_buffer[5] = (unsigned char) ((timebase_reg & 0x00FF0000) >> 16);
                        send_buffer[6] = (unsigned char) ((timebase_reg & 0xFF000000) >> 24);

                        SendData(send_buffer);
                    }
                    else					
                    {
                        tc_test_var = (unsigned long) la_data->np_piodata;

                        send_buffer[0] = 8;								 // Kennung Test Var

                        send_buffer[3] = (unsigned char) (timebase_reg & 0x000000FF);
                        send_buffer[4] = (unsigned char) ((timebase_reg & 0x0000FF00) >> 8);
                        send_buffer[5] = (unsigned char) ((timebase_reg & 0x00FF0000) >> 16);
                        send_buffer[6] = (unsigned char) ((timebase_reg & 0xFF000000) >> 24);

                        SendData(send_buffer);
                    }

                    if (Active_Menu == 15)
                    {
                        MenuItemChanged[1] = 1;
                        MenuItemChanged[2] = 1;
                        MenuItemChanged[3] = 1;
                        MenuItemChanged[4] = 1;
                        MenuChanged = 1;
                        Display::UpdateMenu();
                    }

					
					break;
				}	
				
				case 4:									
				{		
					if (data[3] == 0) USB_Data_Trans = 0;
					else USB_Data_Trans = 1;

					if (data[4] == 0) Continius = 0;
					else Continius = 1;                    				
				
					if (data[5] == 0) USB_OnlyTrigger = 0;
					else USB_OnlyTrigger = 1;
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("Trigger Only %d\n", USB_OnlyTrigger);
#endif					
				    config_changed = true;
		
					break;
				}	
						
				case 5:									
				{
					if (data[3] == 0) USB_Data_Trans = 0;
					else USB_Data_Trans = 1;

					if (data[4] == 0) Continius = 0;
					else Continius = 1;                    				
				
					if (data[5] == 0) USB_OnlyTrigger = 0;
					else USB_OnlyTrigger = 1;
					
					if (data[6] == 0) Transfer_man_data = 0;
					else Transfer_man_data = 1;
					
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("USB %d\n", USB_Data_Trans);
#endif					
				    config_changed = true;
					break;
				}	

				case 6:									
				{
					if (data[3] == 0) USB_Data_Trans = 0;
					else USB_Data_Trans = 1;

					if (data[4] == 0) Continius = 0;
					else Continius = 1;                    				
				
					if (data[5] == 0) USB_OnlyTrigger = 0;
					else USB_OnlyTrigger = 1;
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("Cont %d\n", Continius);
#endif					
				    config_changed = true;
					break;
				}
						
				case 7:
				{
				    ADC_Data_Available = 1;
					ISR_ADC_INT(0);
					
					break;
				}
				
				case 8:
				{
					GridColor_Val = data[3];
					SetupADC();
					config_changed = true;
					break;
				}

				case 9:
				{
					adc_change12_reg = data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24);
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("ADC_Change12 %x\n", adc_change12_reg);
#endif					
					SetupADC();
					AMDFlash::Write_Protected_Flash();
					break;
				}

				case 10:
				{
					adc_ctr12_reg = data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24);
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("ADC_Ctr12 %x\n", adc_ctr12_reg);
#endif					
					SetupADC();
					AMDFlash::Write_Protected_Flash();
					break;
				}                           						

				case 11:
				{
					adc_change34_reg = data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24);
#ifdef _Debug_USB_					
					if (Debug_Mode) printf("ADC_Change34 %x\n", adc_change34_reg);
#endif					
					SetupADC();
					AMDFlash::Write_Protected_Flash();
					break;
				}                           						
										
				case 12:									// Channel 1
				{
					if ((data[3] & 0x80) == 0x80) MenuStatus[1][0] = 6;
					else if ((data[3] & 0x40) == 0x40) MenuStatus[1][0] = 7;
					else MenuStatus[1][0] = 8;					
				
					Selected_Voltage_CH1 = data[3] & 0x3F;					
					
					MenuStatus[1][3] = (data[4] & 0x3F) + 101;
					
					if ((data[4] & 0x40) == 0x40) volt_filter_Mode |= 0x01;
					else volt_filter_Mode &= 0xFE;					
					
					if ((data[4] & 0x80) == 0x80) m2k_filter_Mode |= 0x01;
					else m2k_filter_Mode &= 0xFE;					
					
					SwitchesCH1 = data[5] | (data[6] << 8);

                    SwitchesCH2 &= 0xFCFF;
                    					
					switch(data[22])
					{
					   case 1 : SwitchesCH2 |= 0x0200; break;    // caution 1 & 2 turned
					   case 2 : SwitchesCH2 |= 0x0100; break;
					   case 3 : SwitchesCH2 |= 0x0300; break;
                    }
                       					
					if ((data[20] & 0x01) == 0x01)
                    {
                        multi_active = 1;
                        SwitchesCH1 |= 0x8000;					
                    }
					else
                    {
                        multi_active = 0;
                    }
                    			
					//ch1_factor = data[21];	
					
					SetSwitches(1, -1);
					
					nr_delay(10);
                    					
					SetSwitches(2, -1);
					
//					ZeroLevelCH1 = (int) (data[7] * 1.5);
					
					//CH1_DAC_Offset = data[7] | (data[8] << 8);
                    Virtual_ZeroLevelCH1 = (data[7] | (data[8] << 8)) - 8192;

					Channel1_Zero_Sign_Offset_1 = data[18] | (data[19] << 8);
					Channel1_Zero_Sign_Offset_2 = data[24] | (data[25] << 8);
					Channel1_Zero_Sign_Offset_3 = data[26] | (data[27] << 8);
					
					if (Channel1_Zero_Sign_Offset_1 > 32768) Channel1_Zero_Sign_Offset_1 -= 65536;
					if (Channel1_Zero_Sign_Offset_2 > 32768) Channel1_Zero_Sign_Offset_2 -= 65536;
					if (Channel1_Zero_Sign_Offset_3 > 32768) Channel1_Zero_Sign_Offset_3 -= 65536;
														
					//ZeroLevelCH1 = (unsigned int) CH1_DAC_Offset - 7999 + Channel1_Zero_Sign_Offset;
					
                    //ZeroLevelCH1 = (unsigned int) ((CH1_DAC_Offset - 7999) / 1.74) + Channel1_Zero_Sign_Offset;	
                    //ZeroLevelCH1 = (unsigned int) (CH1_DAC_Offset - 7999) + Channel1_Zero_Sign_Offset;//8115;

                    Rotary_Steps = 0;
                    ON_Zero_Channel_1();
                    					
					CH1_DAC_1 = data[9];
					CH1_DAC_2 = data[11];
					CH1_DAC_3 = data[13];
					CH1_DAC_4 = data[15];
					
					if ((data[16] & 0x01) == 0x01) FirEnabledCH1 = 1;
					else FirEnabledCH1 = 0;
					
					FirStartCH = data[17];		
					
					SetCHDacOffset(1);
					
					CH1_DAC_OffsetOld = CH1_DAC_Offset;
					
					CH1_DAC_1Old = CH1_DAC_1;
					CH1_DAC_2Old = CH1_DAC_2;
					CH1_DAC_3Old = CH1_DAC_3;
					CH1_DAC_4Old = CH1_DAC_4;
					
					Selected_ADCs_CH1 = data[23];					
					
					kill_adc &= 0xFFF0;
					kill_adc |= data[28];					
					
					config_changed = true;				
					break;						
				}					
				case 13:									// Channel 2
				{
					if ((data[3] & 0x80) == 0x80) MenuStatus[2][0] = 6;
					else if ((data[3] & 0x40) == 0x40) MenuStatus[2][0] = 7;
					else MenuStatus[2][0] = 8;
					
					Selected_Voltage_CH2 = data[3] & 0x3F;					
					
					MenuStatus[2][3] = (data[4] & 0x3F) + 101;
					
					if ((data[4] & 0x40) == 0x40) volt_filter_Mode |= 0x02;
					else volt_filter_Mode &= 0xFD;	
                    					
					if ((data[4] & 0x80) == 0x80) m2k_filter_Mode |= 0x02;
					else m2k_filter_Mode &= 0xFD;	
					
					SwitchesCH2 &= 0xFF00;
					SwitchesCH2 |= data[5];// | (data[6] << 8); Hier nur unteres Byte. Oberes bleibt erhalten

                    SwitchesCH2 &= 0xF3FF;
                    					
					switch(data[22])
					{
					   case 1 : SwitchesCH2 |= 0x0400; break;
					   case 2 : SwitchesCH2 |= 0x0800; break;
					   case 3 : SwitchesCH2 |= 0x0C00; break;
                    }					
					
					if ((data[20] & 0x01) == 0x01)
                    {
                        multi_active = 1;
                        SwitchesCH1 |= 0x8000;					
                    }
					else
                    {
                        multi_active = 0;
                        SwitchesCH1 &= 0x7FFF;					
                    }
                    				
					//ch2_factor = data[21];						
					
					SetSwitches(2, -1);
					
					nr_delay(10);
					
					SetSwitches(1, -1);
					
					
					//printf("serdat : %8x\n", (0x40000000 | data[5] | (data[6] * 256)) & 0xFFFF0FFF);					
					
//					ZeroLevelCH2 = (int) (data[7] * 1.5);
					
					//CH2_DAC_Offset = data[7] | (data[8] << 8);
					Virtual_ZeroLevelCH2 = (data[7] | (data[8] << 8)) - 8192;
					
					Channel2_Zero_Sign_Offset_1 = data[18] | (data[19]  << 8);
					Channel2_Zero_Sign_Offset_2 = data[24] | (data[25]  << 8);
					Channel2_Zero_Sign_Offset_3 = data[26] | (data[27]  << 8);					
					
					if (Channel2_Zero_Sign_Offset_1 > 32768) Channel2_Zero_Sign_Offset_1 -= 65536;
					if (Channel2_Zero_Sign_Offset_2 > 32768) Channel2_Zero_Sign_Offset_2 -= 65536;
					if (Channel2_Zero_Sign_Offset_3 > 32768) Channel2_Zero_Sign_Offset_3 -= 65536;
									
					//ZeroLevelCH2 = (unsigned int) CH2_DAC_Offset - 7999 + Channel2_Zero_Sign_Offset;
					//ZeroLevelCH2 = (unsigned int) ((CH2_DAC_Offset - 7999) / 1.74) + Channel2_Zero_Sign_Offset;	
					//ZeroLevelCH2 = (unsigned int) (CH2_DAC_Offset - 7999) + Channel2_Zero_Sign_Offset;//8115;
					
					Rotary_Steps = 0;
					ON_Zero_Channel_2();
					
					CH2_DAC_1 = data[9];
					CH2_DAC_2 = data[11];
					CH2_DAC_3 = data[13];
					CH2_DAC_4 = data[15];		
					
					if ((data[16] & 0x01) == 0x01) FirEnabledCH2 = 1;
					else FirEnabledCH2 = 0;
					
					FirStartCH = data[17];	                   							
					
                    SetCHDacOffset(2);						
									
					CH2_DAC_OffsetOld = CH2_DAC_Offset;
					
					CH2_DAC_1Old = CH2_DAC_1;
					CH2_DAC_2Old = CH2_DAC_2;
					CH2_DAC_3Old = CH2_DAC_3;
					CH2_DAC_4Old = CH2_DAC_4;
					
					Selected_ADCs_CH2 = data[23];
					
					kill_adc &= 0xFF0F;
					kill_adc |= (data[6] << 4);	
					
					config_changed = true;				
					break;
				}	
				
				case 14:									// Channel 3
				{
					if ((data[3] & 0x80) == 0x80) MenuStatus[3][0] = 6;
					else if ((data[3] & 0x40) == 0x40) MenuStatus[3][0] = 7;
					else MenuStatus[3][0] = 8;
					
					Selected_Voltage_CH3 = data[3] & 0x3F;					
					
					MenuStatus[3][3] = (data[4] & 0x3F) + 101;
					
					if ((data[4] & 0x40) == 0x40) volt_filter_Mode |= 0x04;
					else volt_filter_Mode &= 0xFB;	
                    					
					if ((data[4] & 0x80) == 0x80) m2k_filter_Mode |= 0x04;
					else m2k_filter_Mode &= 0xFB;	
					
					SwitchesCH3 = data[5] | (data[6] << 8);

                    SwitchesCH2 &= 0xCFFF;

					switch(data[22])
					{
					   case 1 : SwitchesCH2 |= 0x2000; break;
					   case 2 : SwitchesCH2 |= 0x1000; break;
					   case 3 : SwitchesCH2 |= 0x3000; break;
                    }	
                    					
					if ((data[20] & 0x01) == 0x01)
                    {
                        multi_active = 1;
                        SwitchesCH1 |= 0x8000;					
                    }
					else
                    {
                        multi_active = 0;
                        SwitchesCH1 &= 0x7FFF;					
                    }
                    				
					//ch3_factor = data[21];						
					
					SetSwitches(3, -1);
					
					nr_delay(10);

					SetSwitches(2, -1);		
					
					nr_delay(10);					
					
					SetSwitches(1, -1);					
					
//					ZeroLevelCH3 = (int) (data[7] * 1.5);
					
					//CH3_DAC_Offset = data[7] | (data[8] << 8);
					Virtual_ZeroLevelCH3 = (data[7] | (data[8] << 8)) - 8192;
					
                    Channel3_Zero_Sign_Offset_1 = data[18] | (data[19]  << 8);
                    Channel3_Zero_Sign_Offset_2 = data[24] | (data[25]  << 8);
                    Channel3_Zero_Sign_Offset_3 = data[26] | (data[27]  << 8);

                    if (Channel3_Zero_Sign_Offset_1 > 32768) Channel3_Zero_Sign_Offset_1 -= 65536;
                    if (Channel3_Zero_Sign_Offset_2 > 32768) Channel3_Zero_Sign_Offset_2 -= 65536;
                    if (Channel3_Zero_Sign_Offset_3 > 32768) Channel3_Zero_Sign_Offset_3 -= 65536;
                    				
					//ZeroLevelCH3 = (unsigned int) CH3_DAC_Offset - 7999 + Channel3_Zero_Sign_Offset;
					//ZeroLevelCH3 = (unsigned int) (CH3_DAC_Offset - 7999) + Channel3_Zero_Sign_Offset;//8115;
					
					Rotary_Steps = 0;
					ON_Zero_Channel_3();
					
					CH3_DAC_1 = data[9];
					CH3_DAC_2 = data[11];
					CH3_DAC_3 = data[13];
					CH3_DAC_4 = data[15];
					
					if ((data[16] & 0x01) == 0x01) FirEnabledCH3 = 1;
					else FirEnabledCH3 = 0;
					
					FirStartCH = data[17];	                   				
					
					SetCHDacOffset(3);					

					CH3_DAC_OffsetOld = CH3_DAC_Offset;
					
					CH3_DAC_1Old = CH3_DAC_1;
					CH3_DAC_2Old = CH3_DAC_2;
					CH3_DAC_3Old = CH3_DAC_3;
					CH3_DAC_4Old = CH3_DAC_4;
					
					Selected_ADCs_CH3 = data[23];
					
					kill_adc &= 0xF0FF;
					kill_adc |= (data[6] << 8);						
					
                    config_changed = true;
					break;
				}													
							
				
				case 15:									// Channel 4
				{
					if ((data[3] & 0x80) == 0x80) MenuStatus[4][0] = 6;
					else if ((data[3] & 0x40) == 0x40) MenuStatus[4][0] = 7;
					else MenuStatus[4][0] = 8;
					
					Selected_Voltage_CH4 = data[3] & 0x3F;
					
					
					MenuStatus[4][3] = (data[4] & 0x3F) + 101;
					
					if ((data[4] & 0x40) == 0x40) volt_filter_Mode |= 0x08;
					else volt_filter_Mode &= 0xF7;						
					
					if ((data[4] & 0x80) == 0x80) m2k_filter_Mode |= 0x08;
					else m2k_filter_Mode &= 0xF7;	
					
					SwitchesCH4 = data[5] | (data[6] << 8);

                    SwitchesCH2 &= 0x3FFF;
                    					
					switch(data[22])
					{
					   case 1 : SwitchesCH2 |= 0x4000; break;
					   case 2 : SwitchesCH2 |= 0x8000; break;
					   case 3 : SwitchesCH2 |= 0xC000; break;
                    }						
					
					if ((data[20] & 0x01) == 0x01)
                    {
                        multi_active = 1;
                        SwitchesCH1 |= 0x8000;					
                    }
					else
                    {
                        multi_active = 0;
                        SwitchesCH1 &= 0x7FFF;					
                    }
                    				
					//ch4_factor = data[21];						
					
					SetSwitches(4, -1);		
					
					nr_delay(10);
					
					SetSwitches(2, -1);		
					
					nr_delay(10);					
					
					SetSwitches(1, -1);					
				
//					ZeroLevelCH4 = (int) (data[7] * 1.5);  // data[8] is high byte
				
					//CH4_DAC_Offset = data[7] | (data[8] << 8);
					Virtual_ZeroLevelCH4 = (data[7] | (data[8] << 8)) - 8192;
					
                    Channel4_Zero_Sign_Offset_1 = data[18] | (data[19]  << 8);
                    Channel4_Zero_Sign_Offset_2 = data[24] | (data[25]  << 8);
                    Channel4_Zero_Sign_Offset_3 = data[26] | (data[27]  << 8);
                    		
                    if (Channel4_Zero_Sign_Offset_1 > 32768) Channel4_Zero_Sign_Offset_1 -= 65536;
                    if (Channel4_Zero_Sign_Offset_2 > 32768) Channel4_Zero_Sign_Offset_2 -= 65536;
                    if (Channel4_Zero_Sign_Offset_3 > 32768) Channel4_Zero_Sign_Offset_3 -= 65536;
                            			
					//ZeroLevelCH4 = (unsigned int) CH4_DAC_Offset - 7999 + Channel4_Zero_Sign_Offset;
					//ZeroLevelCH4 = (unsigned int) (CH4_DAC_Offset - 7999) + Channel4_Zero_Sign_Offset;//8115;
					Rotary_Steps = 0;
					ON_Zero_Channel_4();
					
					CH4_DAC_1 = data[9];
					CH4_DAC_2 = data[11];
					CH4_DAC_3 = data[13];
					CH4_DAC_4 = data[15];
					
					if ((data[16] & 0x01) == 0x01) FirEnabledCH4 = 1;
					else FirEnabledCH4 = 0;
					
					FirStartCH = data[17];	                   				
					
					SetCHDacOffset(4);                    					

					CH4_DAC_OffsetOld = CH4_DAC_Offset;
					
					CH4_DAC_1Old = CH4_DAC_1;
					CH4_DAC_2Old = CH4_DAC_2;
					CH4_DAC_3Old = CH4_DAC_3;
					CH4_DAC_4Old = CH4_DAC_4;
					
					Selected_ADCs_CH4 = data[23];
					
					kill_adc &= 0x0FFF;
					kill_adc |= (data[6] << 12);						
					
                    config_changed = true;
					break;
				}
				
				case 16:									// Trigger
				{
					SwitchesTB = data[3];		// External			
									
					SetSwitches(5, SwitchesTB);					
					config_changed = true;
					break;
				}	
				
				
				case 17:									// Spike Generator / TestPort Bits
				{				
					// TestBits
					test_port_reg = data[3];
					out_test->np_piodata = test_port_reg;
					
                    config_changed = true;			
					break;								
				}
				
				case 18:									// Triangle Generator
				{	
					rot_speed_read->np_piodata = 1;
								
					for (cnt = 0; cnt < 32; cnt++)
					{					
						serdata->np_piodata = data[cnt + 3];
	
						serstartpwm->np_piodata = 1;
						serstartpwm->np_piodata = 0;
						
						//printf("gtd :%x \n", data[cnt + 3]);
					}
					
					rot_speed_read->np_piodata = 0;
					config_changed = true;
					break;								
				}

				case 19:									// Only one shot after restart bit
				{
					OneShotRestart = data[3];
#ifdef _Debug_USB_					
					if (Debug_Mode)
                    {
                        if (OneShotRestart) printf("One shot will made after restart\n");
                        else printf("Normal mode after restart\n");
                    }
#endif					
					config_changed = true;
					
					break;
				}


				case 20:									// Protected Config
				{
					tc_model = data[4] | (data[5] << 8);

                    tc_serial = data[6] | (data[7] << 8) | (data[8] << 16) | (data[9] << 24);
					
                    tc_production_lot1 = data[10];				
                    tc_production_lot2 = data[11];

                    tc_shipment_date = (data[12] << 8) | (data[13] << 4) | (data[14] & 0x0000000F);

                    kill_adc = data[15] | (data[16] << 8);
                    m2k_filter_Mode = data[17] & 0x0F;
                    volt_filter_Mode = (data[17] & 0xF0) >> 4;

                   // if (data[19] != 5) Voltage_Correction[data[19]][data[18]] = data[20];


                   // if ((data[21] != 5) && (data[22] != 5)) Voltage_Offset[data[21]][data[22]] = data[23];



                    AMDFlash::Write_Protected_Flash();

					break;
				}

				case 22:									// Protected Config
				{				
        			switch(data[3])
		          	{
    	       			case 1:	
	       	       		{
                            Voltage_Correction[0][0] = (int) data[4];
                            Voltage_Correction[0][1] = (int) data[5];
                            Voltage_Correction[0][2] = (int) data[6];
                            Voltage_Correction[0][3] = (int) data[7];
                            Voltage_Correction[0][4] = (int) data[8];
                            Voltage_Correction[0][5] = (int) data[9];
                            Voltage_Correction[0][6] = (int) data[10];
                            Voltage_Correction[0][7] = (int) data[11];
                            Voltage_Correction[0][8] = (int) data[12];
                            Voltage_Correction[0][9] = (int) data[13];
                            Voltage_Correction[0][10] = (int) data[14];
                            Voltage_Correction[0][11] = (int) data[15];

                            Voltage_Correction[1][0] = (int) data[16];
                            Voltage_Correction[1][1] = (int) data[17];
                            Voltage_Correction[1][2] = (int) data[18];
                            Voltage_Correction[1][3] = (int) data[19];
                            Voltage_Correction[1][4] = (int) data[20];
                            Voltage_Correction[1][5] = (int) data[21];
                            Voltage_Correction[1][6] = (int) data[22];
                            Voltage_Correction[1][7] = (int) data[23];
                            Voltage_Correction[1][8] = (int) data[24];
                            Voltage_Correction[1][9] = (int) data[25];
                            Voltage_Correction[1][10] = (int) data[26];
                            Voltage_Correction[1][11] = (int) data[27];

                            Voltage_Offset[0][0] = (int) data[28];
                            Voltage_Offset[0][1] = (int) data[29];
                            Voltage_Offset[0][2] = (int) data[30];
                            Voltage_Offset[0][3] = (int) data[31];

                            Voltage_Offset[1][0] = (int) data[32];
                            Voltage_Offset[1][1] = (int) data[33];
                            Voltage_Offset[1][2] = (int) data[34];
                            Voltage_Offset[1][3] = (int) data[35];
                            
                            Volt_Correct_float[0][0] = (float) ((Voltage_Correction[0][0] + 100) / 100);
                            Volt_Correct_float[0][1] = (float) ((Voltage_Correction[0][1] + 100) / 100);
                            Volt_Correct_float[0][2] = (float) ((Voltage_Correction[0][2] + 100) / 100);
                            Volt_Correct_float[0][3] = (float) ((Voltage_Correction[0][3] + 100) / 100);
                            Volt_Correct_float[0][4] = (float) ((Voltage_Correction[0][4] + 100) / 100);
                            Volt_Correct_float[0][5] = (float) ((Voltage_Correction[0][5] + 100) / 100);
                            Volt_Correct_float[0][6] = (float) ((Voltage_Correction[0][6] + 100) / 100);
                            Volt_Correct_float[0][7] = (float) ((Voltage_Correction[0][7] + 100) / 100);
                            Volt_Correct_float[0][8] = (float) ((Voltage_Correction[0][8] + 100) / 100);
                            Volt_Correct_float[0][9] = (float) ((Voltage_Correction[0][9] + 100) / 100);
                            Volt_Correct_float[0][10] = (float) ((Voltage_Correction[0][10] + 100) / 100);
                            Volt_Correct_float[0][11] = (float) ((Voltage_Correction[0][11] + 100) / 100);

                            Volt_Correct_float[1][0] = (float) ((Voltage_Correction[1][0] + 100) / 100);
                            Volt_Correct_float[1][1] = (float) ((Voltage_Correction[1][1] + 100) / 100);
                            Volt_Correct_float[1][2] = (float) ((Voltage_Correction[1][2] + 100) / 100);
                            Volt_Correct_float[1][3] = (float) ((Voltage_Correction[1][3] + 100) / 100);
                            Volt_Correct_float[1][4] = (float) ((Voltage_Correction[1][4] + 100) / 100);
                            Volt_Correct_float[1][5] = (float) ((Voltage_Correction[1][5] + 100) / 100);
                            Volt_Correct_float[1][6] = (float) ((Voltage_Correction[1][6] + 100) / 100);
                            Volt_Correct_float[1][7] = (float) ((Voltage_Correction[1][7] + 100) / 100);
                            Volt_Correct_float[1][8] = (float) ((Voltage_Correction[1][8] + 100) / 100);
                            Volt_Correct_float[1][9] = (float) ((Voltage_Correction[1][9] + 100) / 100);
                            Volt_Correct_float[1][10] = (float) ((Voltage_Correction[1][10] + 100) / 100);
                            Volt_Correct_float[1][11] = (float) ((Voltage_Correction[1][11] + 100) / 100);

                            break;
                        }

    	       			case 2:	
	       	       		{
                            Voltage_Correction[2][0] = (int) data[4];
                            Voltage_Correction[2][1] = (int) data[5];
                            Voltage_Correction[2][2] = (int) data[6];
                            Voltage_Correction[2][3] = (int) data[7];
                            Voltage_Correction[2][4] = (int) data[8];
                            Voltage_Correction[2][5] = (int) data[9];
                            Voltage_Correction[2][6] = (int) data[10];
                            Voltage_Correction[2][7] = (int) data[11];
                            Voltage_Correction[2][8] = (int) data[12];
                            Voltage_Correction[2][9] = (int) data[13];
                            Voltage_Correction[2][10] = (int) data[14];
                            Voltage_Correction[2][11] = (int) data[15];

                            Voltage_Correction[3][0] = (int) data[16];
                            Voltage_Correction[3][1] = (int) data[17];
                            Voltage_Correction[3][2] = (int) data[18];
                            Voltage_Correction[3][3] = (int) data[19];
                            Voltage_Correction[3][4] = (int) data[20];
                            Voltage_Correction[3][5] = (int) data[21];
                            Voltage_Correction[3][6] = (int) data[22];
                            Voltage_Correction[3][7] = (int) data[23];
                            Voltage_Correction[3][8] = (int) data[24];
                            Voltage_Correction[3][9] = (int) data[25];
                            Voltage_Correction[3][10] = (int) data[26];
                            Voltage_Correction[3][11] = (int) data[27];

                            Voltage_Offset[2][0] = (int) data[28];
                            Voltage_Offset[2][1] = (int) data[29];
                            Voltage_Offset[2][2] = (int) data[30];
                            Voltage_Offset[2][3] = (int) data[31];

                            Voltage_Offset[3][0] = (int) data[32];
                            Voltage_Offset[3][1] = (int) data[33];
                            Voltage_Offset[3][2] = (int) data[34];
                            Voltage_Offset[3][3] = (int) data[35];

                            Volt_Correct_float[2][0] = (float) ((Voltage_Correction[2][0] + 100) / 100);
                            Volt_Correct_float[2][1] = (float) ((Voltage_Correction[2][1] + 100) / 100);
                            Volt_Correct_float[2][2] = (float) ((Voltage_Correction[2][2] + 100) / 100);
                            Volt_Correct_float[2][3] = (float) ((Voltage_Correction[2][3] + 100) / 100);
                            Volt_Correct_float[2][4] = (float) ((Voltage_Correction[2][4] + 100) / 100);
                            Volt_Correct_float[2][5] = (float) ((Voltage_Correction[2][5] + 100) / 100);
                            Volt_Correct_float[2][6] = (float) ((Voltage_Correction[2][6] + 100) / 100);
                            Volt_Correct_float[2][7] = (float) ((Voltage_Correction[2][7] + 100) / 100);
                            Volt_Correct_float[2][8] = (float) ((Voltage_Correction[2][8] + 100) / 100);
                            Volt_Correct_float[2][9] = (float) ((Voltage_Correction[2][9] + 100) / 100);
                            Volt_Correct_float[2][10] = (float) ((Voltage_Correction[2][10] + 100) / 100);
                            Volt_Correct_float[2][11] = (float) ((Voltage_Correction[2][11] + 100) / 100);

                            Volt_Correct_float[3][0] = (float) ((Voltage_Correction[3][0] + 100) / 100);
                            Volt_Correct_float[3][1] = (float) ((Voltage_Correction[3][1] + 100) / 100);
                            Volt_Correct_float[3][2] = (float) ((Voltage_Correction[3][2] + 100) / 100);
                            Volt_Correct_float[3][3] = (float) ((Voltage_Correction[3][3] + 100) / 100);
                            Volt_Correct_float[3][4] = (float) ((Voltage_Correction[3][4] + 100) / 100);
                            Volt_Correct_float[3][5] = (float) ((Voltage_Correction[3][5] + 100) / 100);
                            Volt_Correct_float[3][6] = (float) ((Voltage_Correction[3][6] + 100) / 100);
                            Volt_Correct_float[3][7] = (float) ((Voltage_Correction[3][7] + 100) / 100);
                            Volt_Correct_float[3][8] = (float) ((Voltage_Correction[3][8] + 100) / 100);
                            Volt_Correct_float[3][9] = (float) ((Voltage_Correction[3][9] + 100) / 100);
                            Volt_Correct_float[3][10] = (float) ((Voltage_Correction[3][10] + 100) / 100);
                            Volt_Correct_float[3][11] = (float) ((Voltage_Correction[3][11] + 100) / 100);

                            break;
                        }
                    }

                    AMDFlash::Write_Protected_Flash();

					break;
				}	

				case 23:									// USB Data Received
				{
                    switch(data[3])
		          	{
    	       			case 1: Virtual_ZeroLevelCH1 = 196 - (data[4] + (data[5] << 8)); ON_Zero_Channel_1(); break;
    	       			case 2: Virtual_ZeroLevelCH2 = 196 - (data[4] + (data[5] << 8)); ON_Zero_Channel_2(); break;
    	       			case 3: Virtual_ZeroLevelCH3 = 196 - (data[4] + (data[5] << 8)); ON_Zero_Channel_3(); break;
    	       			case 4: Virtual_ZeroLevelCH4 = 196 - (data[4] + (data[5] << 8)); ON_Zero_Channel_4(); break;
  	       			}
  	       			
  	       			if (MenuStatus[14][1] == 138) Trigger_Pos_CH1 = 384 - (data[4] + (data[5] << 8));
  	       			else if (MenuStatus[14][1] == 139) Trigger_Pos_CH2 = 384 - (data[4] + (data[5] << 8));
  	       			else if (MenuStatus[14][1] == 140) Trigger_Pos_CH3 = 384 - (data[4] + (data[5] << 8));
  	       			else if (MenuStatus[14][1] == 141) Trigger_Pos_CH4 = 384 - (data[4] + (data[5] << 8));
  	       			
  	       			UpdateTrigger(43);
  	       			
 			    }                				
			}
			
			TriggerLevelChanged = 1;
			TriggerModeChanged = 1;	
			TriggerWayChanged = 1;
			TimebaseChanged = 1;
			TimeOffsetChanged = 1;	
			
			Display::StatusUpdate();			
			
			break;
		}

		
		case 5: 											// Receive Data
		{

			start_acq->np_piodata = 0x01;				//start record Port On
			start_acq->np_piodata = 0x00;				//start record Port Off


			break;			
		}
					
		case 6: 											// Receive Data
		{
			switch(data[2])
			{
				case 1: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button1\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(30, 0);
					break;
				}		
				case 2: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button2\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(31, 0);
					break;
				}
				case 3: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button3\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(32, 0);
					break;
				}
				case 4: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button4\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(33, 0);
					break;
				}
				case 5: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button5\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(34, 0);
					break;
				}
				case 6: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Button6\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(35, 0);
					break;
				}
				case 7: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 1\n");
#endif					
//					ButtonChanged = 1;
//					Buttonhandler(1, 0);

					if ((data[3]) && (Channel_1_Active == 0)) UpdateChannel(1, 1);
					if ((data[3] == 0) && (Channel_1_Active == 1)) UpdateChannel(1, 0);
					
					if (Channel_1_Active == 0)
                    {
                        RemovePlane |= 0x01;
                        ClearPlanes();
                    }
					
					
					break;
				}
				case 8: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Math\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(26, 0);
					break;
				}
				case 9: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 2\n");
#endif					
//					ButtonChanged = 1;
//					Buttonhandler(2, 0);
					
					if ((data[3]) && (Channel_2_Active == 0)) UpdateChannel(2, 1);
					if ((data[3] == 0) && (Channel_2_Active == 1)) UpdateChannel(2, 0);
					
					if (Channel_2_Active == 0)
                    {
                        RemovePlane |= 0x02;
                        ClearPlanes();
                    }
					
				
					break;
				}
				case 10: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 3\n");
#endif					
					//ButtonChanged = 1;
					//Buttonhandler(3, 0);
					
					if ((data[3]) && (Channel_3_Active == 0)) UpdateChannel(3, 1);
					if ((data[3] == 0) && (Channel_3_Active == 1)) UpdateChannel(3, 0);
                    					
					if (Channel_3_Active == 0)
                    {
                        RemovePlane |= 0x04;
                        ClearPlanes();
                    }
					
					break;
				}
				case 11: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 4\n");
#endif					
					//ButtonChanged = 1;
					//Buttonhandler(4, 0);
					
					if ((data[3]) && (Channel_4_Active == 0)) UpdateChannel(4, 1);
					if ((data[3] == 0) && (Channel_4_Active == 1)) UpdateChannel(4, 0);
					
					if (Channel_4_Active == 0)
                    {
                        RemovePlane |= 0x08;
                        ClearPlanes();
                    }
                    					
					break;
				}
				case 12: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Auto Scale\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(23, 0);
					break;
				}
				case 13: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Save/Recall\n");
#endif					
					ButtonChanged = 1;
					break;
				}
				case 14: 									// All
    			{
#ifdef _Debug_USB_			
					if (Debug_Mode) printf("USB Function Quick Print\n");
#endif					
					ButtonChanged = 1;
					break;
				}
				case 15: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Utility\n");
#endif					
					ButtonChanged = 1;
					break;
				}
				case 16: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Pulse Width\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(15, 0);
					break;
				}
				case 17: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Cursor\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(16, 0);
					break;
				}
				case 18: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Quick Meas\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(19, 0);
					break;
				}
				case 19: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Acquire\n");
#endif
					ButtonChanged = 1;
					Buttonhandler(0, 0);
					break;
				}
				case 20: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Display\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(5, 0);
					break;
				}
				case 21: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Edge\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(14, 0);
					break;
				}
				case 22: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Mode / Coupling\n");
#endif					
					break;
				}
				case 23: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Mode\n");
#endif					
					break;
				}
				case 24: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Run/Stop\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(37, 0);
			
                    if (Continius)
                    {		
                        LED_ON[12] = 1;
                        LED_ON[13] = 0;
                        Send_LED();					
                    }
                    else
                    {		
                        LED_ON[12] = 0;
                        LED_ON[13] = 1;
                        Send_LED();					
                    }					
					break;
				}
				case 25: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Single\n");
#endif					
					ButtonChanged = 1;
					Buttonhandler(38, 0);
					
					break;
				}
				case 26: 									// All
				{
					printf("USB Test Button\n");
					
					
					
                    buflong = 0x00000000;

                    while (1 == 1)
                    {
                        data_adr->np_piodata = 0x01;
                        buflong = READADC(1);

                        if ((buflong & 0x00008000) == 0x00008000)
                        {
                            buflong1 = READADC(1);

                            if (Selected_Voltage_CH1 == 9) Channel1_Zero_Sign_Offset_1 = (int) (buflong1 - 8192);
                            else if (Selected_Voltage_CH1 == 10) Channel1_Zero_Sign_Offset_2 = (int) (buflong1 - 8192);
                            else if (Selected_Voltage_CH1 == 11) Channel1_Zero_Sign_Offset_3 = (int) (buflong1 - 8192);

                            printf("buflong %8x %d\n", buflong, buflong);
                            printf("buflong1 %8x %d\n", buflong1, buflong1);
                            printf("CH1_1 : %4.4d CH1_2 : %4.4d CH1_3 : %4.4d \n", Channel1_Zero_Sign_Offset_1, Channel1_Zero_Sign_Offset_2, Channel1_Zero_Sign_Offset_3);
                            
                            break;
                        }

                        data_adr->np_piodata = 0x00;
                        lcnt++;
                        if (lcnt == 50000) break;
                    }					
					

                    printf("lcnt %d\n", lcnt);

				}	
				case 27:
				{
					if (data[3] == 1)
					{
						USB_SendAllData = 1;
#ifdef _Debug_USB_						
						if (Debug_Mode) printf("USB Function Send All Data On\n");
#endif						
					}					
					else
					{
						USB_SendAllData = 0;
#ifdef _Debug_USB_						
						if (Debug_Mode) printf("USB Function Send All Data Off\n");
#endif						
					}
					
					if (data[4] == 1)
					{
						OneShotRestart = 1;
#ifdef _Debug_USB_						
						if (Debug_Mode) printf("USB Function OneShotRestart On\n");
#endif
					}					
					else
					{
						OneShotRestart = 0;
#ifdef _Debug_USB_						
						if (Debug_Mode) printf("USB Function OneShotRestart Off\n");
#endif						
					}
					
					config_changed = true;
                    					
					break;
				}


				case 28: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 1 ACDC\n");
#endif									
					if (data[3]) MenuStatus[1][0] = 7;  // DC
					else MenuStatus[1][0] = 8;  // AC
					
					SetSwitches(1, -1);
					
					MenuItemChanged[0] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();
                    					
					break;
				}
				case 29: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 2 ACDC\n");
#endif									
					if (data[3]) MenuStatus[2][0] = 7;  // DC
					else MenuStatus[2][0] = 8;  // AC
					
					SetSwitches(1, -1);
					
					MenuItemChanged[0] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}
				case 30: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 3 ACDC\n");
#endif									
					if (data[3]) MenuStatus[3][0] = 7;  // DC
					else MenuStatus[3][0] = 8;  // AC
					
					SetSwitches(1, -1);
					
					MenuItemChanged[0] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}
				case 31: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 4 ACDC\n");
#endif									
					if (data[3]) MenuStatus[4][0] = 7;  // DC
					else MenuStatus[4][0] = 8;  // AC
                    					
					SetSwitches(1, -1);
					
					MenuItemChanged[0] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}

				case 32: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 1 Invert\n");
#endif									
					if (data[3]) MenuStatus[1][2] = 241;  // Invert
					else MenuStatus[1][2] = 240;
				
					MenuItemChanged[2] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}

				case 33: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 2 Invert\n");
#endif									
					if (data[3]) MenuStatus[2][2] = 241;  // Invert
					else MenuStatus[2][2] = 240;
				
					MenuItemChanged[2] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}
				
				case 34: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 3 Invert\n");
#endif									
					if (data[3]) MenuStatus[3][2] = 241;  // Invert
					else MenuStatus[3][2] = 240;
				
					MenuItemChanged[2] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}

				case 35: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB Function Channel 4 Invert\n");
#endif									
					if (data[3]) MenuStatus[4][2] = 241;  // Invert
					else MenuStatus[4][2] = 240;
				
					MenuItemChanged[2] = 1;
					Menu_Changed = 1;
					Display::UpdateMenu();					
                    					
					break;
				}                				
                                                                              							
			}
			SendCtrlBlock();
			
			nr_delay(10);
			
			SendCtrlBlock3();	

			nr_delay(10);
			
			SendCtrlBlock2();

			break;
		}

		case 7: 											// Receive Data
		{
			switch(data[2])
			{
				case 1: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Channel 1\n");
#endif					
					if (data[3] == 1) Set_LED(0);
					else Reset_LED(0);					
					break;
				}	
				case 2: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Math\n");
#endif					
					if (data[3] == 1) Set_LED(4);
					else Reset_LED(4);
					break;
				}	
				case 3: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Channel 2\n");
#endif					
					if (data[3] == 1) Set_LED(1);
					else Reset_LED(1);
					break;
				}	
				case 4: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Channel 3\n");
#endif					
					if (data[3] == 1) Set_LED(2);
					else Reset_LED(2);
					break;
				}	
				case 5: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Channel 4\n");
#endif					
					if (data[3] == 1) Set_LED(3);
					else Reset_LED(3);
					break;
				}	
				case 6: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Pulse Width\n");
#endif					
					if (data[3] == 1) Set_LED(10);
					else Reset_LED(10);
					break;
				}	
				case 7: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Wheel\n");
#endif					
					if (data[3] == 1) Set_LED(6);
					else Reset_LED(6);
					break;
				}	
				case 8: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Cursor\n");
#endif					
					if (data[3] == 1) Set_LED(5);
					else Reset_LED(5);
					break;
				}	
				case 9: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Quick Meas\n");
#endif					
					if (data[3] == 1) Set_LED(7);
					else Reset_LED(7);
					break;
				}	
				case 10: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Edge\n");
#endif					
					if (data[3] == 1) Set_LED(8);
					else Reset_LED(8);
					break;
				}	
				case 11: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Run/Stop Green\n");
#endif					
					LED_ON[12] = 1;
					LED_ON[13] = 0;
					Send_LED();
					break;
				}	
				case 12: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Run/Stop Red\n");
#endif					
					LED_ON[13] = 1;
					LED_ON[12] = 0;
					Send_LED();
					break;
				}	
				case 13: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Single Green\n");
#endif					
					LED_ON[14] = 1;
					LED_ON[15] = 0;
					Send_LED();
					break;
				}	
				case 14: 									// All
				{
#ifdef _Debug_USB_				
					if (Debug_Mode) printf("USB LED Single Red\n");
#endif					
					LED_ON[15] = 1;
					LED_ON[14] = 0;
					Send_LED();
					break;
				}									
			}
			
			SendCtrlBlock();
			
			nr_delay(10);
			
			SendCtrlBlock3();			

			nr_delay(10);
			
			SendCtrlBlock2();
			
			
			break;			
		}	
		
		case 8: 											// Receive Data
		{
			switch(data[2])
			{
				case 1: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 1 Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 1 Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				case 2: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 2 Right\n");
#endif							
							break;
						}
						case 2:
						{	
#ifdef _Debug_USB_                        				
							if (Debug_Mode) printf("USB Wheel Pos Channel 2 Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				case 3: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 3 Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 3 Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				case 4: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 4 Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Pos Channel 4 Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				case 5: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 1 Right\n");
#endif							
                            Rotary_Direction = 1;
                            ON_Voltage_Channel_1();	

							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 1 Left\n");
#endif						
                            Rotary_Direction = 0;
                            ON_Voltage_Channel_1();	
                            	
							break;
						}
					}
					break;						
				}	
				case 6: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 2 Right\n");
#endif							
                            Rotary_Direction = 1;
                            ON_Voltage_Channel_2();	

							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 2 Left\n");
#endif						
                            Rotary_Direction = 0;
                            ON_Voltage_Channel_2();		

							break;
						}
					}
					break;						
				}	
				case 7: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 3 Right\n");
#endif							
                            Rotary_Direction = 1;
                            ON_Voltage_Channel_3();	
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 3 Left\n");
#endif						
                            Rotary_Direction = 0;
                            ON_Voltage_Channel_3();		
							break;
						}
					}
					break;						
				}	
				case 8: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 4 Right\n");
#endif						
                            Rotary_Direction = 1;
                            ON_Voltage_Channel_4();	
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Volt Channel 4 Left\n");
#endif							
                            Rotary_Direction = 0;
                            ON_Voltage_Channel_4();	

							break;
						}
					}
					break;						
				}	
				case 9: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Generic Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Generic Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				case 10: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Trigger Level Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Trigger Level Left\n");
#endif							
							break;
						}
					}
					break;						
				}				
				case 11: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Timebase Right\n");
#endif						
                            Rotary_Direction = 1;
                            ON_Timebase();
                            	
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Timebase Left\n");
#endif							
                            Rotary_Direction = 0;
                            ON_Timebase();

							break;
						}
					}
					break;						
				}	
				case 12: 									// All
				{
					switch(data[3])
					{				
						case 1:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Trigger Delay Right\n");
#endif							
							break;
						}
						case 2:
						{					
#ifdef _Debug_USB_						
							if (Debug_Mode) printf("USB Wheel Trigger Delay Left\n");
#endif							
							break;
						}
					}
					break;						
				}	
				
			}
			
			SendCtrlBlock();
			
			nr_delay(10);
			
			SendCtrlBlock3();			
			
			nr_delay(10);
			
			SendCtrlBlock2();			
			
			break;
		}
		
		case 9:
		{	
		
			switch(data[10])
			{
				case 1 :
				{
					CH1_X_Offset_1 = data[6];
					CH1_X_Offset_2 = data[7];
					CH1_X_Offset_3 = data[8];
					CH1_X_Offset_4 = data[9];
					
			        if (data[2] > 127) Channel1_1_ADC_Correction = 256 - (256 - data[2]);
			        else Channel1_1_ADC_Correction = data[2];
			        if (data[3] > 127) Channel1_2_ADC_Correction = 256 - (256 - data[3]);
			        else Channel1_2_ADC_Correction = data[3];
			        if (data[4] > 127) Channel1_3_ADC_Correction = 256 - (256 - data[4]);
			        else Channel1_3_ADC_Correction = data[4];
			        if (data[5] > 127) Channel1_4_ADC_Correction = 256 - (256 - data[5]);
			        else Channel1_4_ADC_Correction = data[5];					
					
					break;					
				}
				case 2 :
				{
					CH2_X_Offset_1 = data[6];
					CH2_X_Offset_2 = data[7];
					CH2_X_Offset_3 = data[8];
					CH2_X_Offset_4 = data[9];
					
			        if (data[2] > 127) Channel2_1_ADC_Correction = 256 - (256 - data[2]);
			        else Channel2_1_ADC_Correction = data[2];
			        if (data[3] > 127) Channel2_2_ADC_Correction = 256 - (256 - data[3]);
			        else Channel2_2_ADC_Correction = data[3];
			        if (data[4] > 127) Channel2_3_ADC_Correction = 256 - (256 - data[4]);
			        else Channel2_3_ADC_Correction = data[4];
			        if (data[5] > 127) Channel2_4_ADC_Correction = 256 - (256 - data[5]);
			        else Channel2_4_ADC_Correction = data[5];	
					
					break;					
				}
				case 3 :
				{
					CH3_X_Offset_1 = data[6];
					CH3_X_Offset_2 = data[7];
					CH3_X_Offset_3 = data[8];
					CH3_X_Offset_4 = data[9];	
					
			        if (data[2] > 127) Channel3_1_ADC_Correction = 256 - (256 - data[2]);
			        else Channel3_1_ADC_Correction = data[2];
			        if (data[3] > 127) Channel3_2_ADC_Correction = 256 - (256 - data[3]);
			        else Channel3_2_ADC_Correction = data[3];
			        if (data[4] > 127) Channel3_3_ADC_Correction = 256 - (256 - data[4]);
			        else Channel3_3_ADC_Correction = data[4];
			        if (data[5] > 127) Channel3_4_ADC_Correction = 256 - (256 - data[5]);
			        else Channel3_4_ADC_Correction = data[5];	
									
					break;				
				}
				case 4 :
				{
					CH4_X_Offset_1 = data[6];
					CH4_X_Offset_2 = data[7];
					CH4_X_Offset_3 = data[8];
					CH4_X_Offset_4 = data[9];
					
			        if (data[2] > 127) Channel4_1_ADC_Correction = 256 - (256 - data[2]);
			        else Channel4_1_ADC_Correction = data[2];
			        if (data[3] > 127) Channel4_2_ADC_Correction = 256 - (256 - data[3]);
			        else Channel4_2_ADC_Correction = data[3];
			        if (data[4] > 127) Channel4_3_ADC_Correction = 256 - (256 - data[4]);
			        else Channel4_3_ADC_Correction = data[4];
			        if (data[5] > 127) Channel4_4_ADC_Correction = 256 - (256 - data[5]);
			        else Channel4_4_ADC_Correction = data[5];	
								
					break;					
				}												
			}
#ifdef _Debug_USB_			
			if (Debug_Mode) printf("W : %d ; X1 : %d ; X2 : %d ; X3 : %d ; X4 : %d ; idx %i\n", data[10], data[6], data[7], data[8], data[9], data[11]);
#endif			
			
			config_changed = true;
			
			break;			
		}
		case 10: 											// Prgram the Flash
		{
			switch(data[2])
			{
				case 0 :                                    // Set programm mode
				{
                    switch(data[3])
                    {				
				        case 0 :                            // End programm mode
				        {				
//                            reset_watchdog->np_piodata = 0x01;						// Enableable WatchDog
                            Continius = true;
                            //adc_started = false;
                            result_buf = 0;
                            AutoTimerOff = false;

#ifdef _Debug_USB_
                            printf("Program mode disabled \n");
#endif
                            break;
                        }
				        case 1 :                            // Start programm mode
				        {				
//                            reset_watchdog->np_piodata = 0x00;						// Disable WatchDog
                            Continius = false;
                            //adc_started = true;
                            result_buf = 1;

                            Stop_Record();
                            AutoTimerOff = true;

#ifdef _Debug_USB_
                            printf("Program mode enabled \n");
#endif
                            break;
                        }
                    }
                    break;
                }			
				case 1 :                                    // Erase a block
				{
				    prog_flash_adr = (unsigned long *) (data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24));
#ifdef _Debug_USB_				
				    printf("Erase address %x \n", prog_flash_adr);
#endif				
				    result_buf = AMDFlash::EraseSector_Flash(prog_flash_adr);
				
				    break;
                }
				case 2 :                                    // receive offset
				{
				    prog_flash_offset = (unsigned long) (data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24));
#ifdef _Debug_USB_				
				    printf("Received Flash Offset %x \n", prog_flash_offset);
#endif				
				    result_buf = 0;
				
				    break;
                }
				case 3 :                                    // Write a block
				{
				    prog_flash_adr = (unsigned long *) ((data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24)) - prog_flash_offset);
				
                    prog_flash_length = data[7];

                    result_buf = 0;
                    for (cnt = 0; cnt < prog_flash_length; cnt++)
                    {
                        result_buf = result_buf + AMDFlash::WriteData_Byte_Flash(prog_flash_adr, cnt, data[8 + cnt]);
                        //nr_delay(20);
                    }

#ifdef _Debug_USB_
                    printf("PFD @ %x[%d]  : %d \n", prog_flash_adr, prog_flash_length, result_buf);
#endif
				    break;
                }

				case 4 :                                    // Read Data
				{
				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif				
				    break;
                }

				case 5 :                                    // Read Software Version
				{
#ifdef _Debug_USB_				
				    printf("Read Software Version %x \n", tc_version);				
				    printf("Read Software Subversion %x \n", tc_subversion);
				    printf("Read Software Reversion %x \n", tc_revision);
				    printf("Read Software Compile %x \n", tc_compile_status);
#endif				
                    result_buf = 0;

                    send_buffer[7] = (unsigned char) tc_version & 0x000000FF;
                    send_buffer[8] = (unsigned char) ((tc_version & 0x0000FF00) >> 8);
                    send_buffer[9] = (unsigned char) ((tc_version & 0x00FF0000) >> 16);
                    send_buffer[10] = (unsigned char) ((tc_version & 0xFF000000) >> 24);

                    send_buffer[11] = (unsigned char) tc_subversion & 0x000000FF;
                    send_buffer[12] = (unsigned char) ((tc_subversion & 0x0000FF00) >> 8);
                    send_buffer[13] = (unsigned char) ((tc_subversion & 0x00FF0000) >> 16);
                    send_buffer[14] = (unsigned char) ((tc_subversion & 0xFF000000) >> 24);

                    send_buffer[15] = (unsigned char) tc_revision & 0x000000FF;
                    send_buffer[16] = (unsigned char) ((tc_revision & 0x0000FF00) >> 8);
                    send_buffer[17] = (unsigned char) ((tc_revision & 0x00FF0000) >> 16);
                    send_buffer[18] = (unsigned char) ((tc_revision & 0xFF000000) >> 24);

                    send_buffer[19] = (unsigned char) tc_compile_status & 0x000000FF;
                    send_buffer[20] = (unsigned char) ((tc_compile_status & 0x0000FF00) >> 8);
                    send_buffer[21] = (unsigned char) ((tc_compile_status & 0x00FF0000) >> 16);
                    send_buffer[22] = (unsigned char) ((tc_compile_status & 0xFF000000) >> 24);

				    break;
                }

				case 6 :                                    // Read Hardware Version
				{		
#ifdef _Debug_USB_                	
				    printf("Read Hardware Version %x \n", tc_hw_version);				
				    printf("Read Hardware SW Version %x \n", tc_hw_sw_version);				
				    printf("Read Serial %d hex : %x\n", tc_serial, tc_serial);				
#endif				
                    result_buf = 0;

                    send_buffer[7] = (unsigned char) (tc_hw_version & 0x000000FF);
                    send_buffer[8] = (unsigned char) ((tc_hw_version & 0x0000FF00) >> 8);
                    send_buffer[9] = (unsigned char) ((tc_hw_version & 0x00FF0000) >> 16);
                    send_buffer[10] = (unsigned char) ((tc_hw_version & 0xFF000000) >> 24);

                    send_buffer[11] = (unsigned char) (tc_hw_sw_version & 0x000000FF);
                    send_buffer[12] = (unsigned char) ((tc_hw_sw_version & 0x0000FF00) >> 8);
                    send_buffer[13] = (unsigned char) ((tc_hw_sw_version & 0x00FF0000) >> 16);
                    send_buffer[14] = (unsigned char) ((tc_hw_sw_version & 0xFF000000) >> 24);

                    send_buffer[15] = (unsigned char) (tc_serial & 0x000000FF);
                    send_buffer[16] = (unsigned char) ((tc_serial & 0x0000FF00) >> 8);
                    send_buffer[17] = (unsigned char) ((tc_serial & 0x00FF0000) >> 16);
                    send_buffer[18] = (unsigned char) ((tc_serial & 0xFF000000) >> 24);

                    send_buffer[19] = (unsigned char) (tc_production_lot1 & 0x000000FF);
                    send_buffer[20] = (unsigned char) ((tc_production_lot1 & 0x0000FF00) >> 8);
                    send_buffer[21] = (unsigned char) ((tc_production_lot1 & 0x00FF0000) >> 16);
                    send_buffer[22] = (unsigned char) ((tc_production_lot1 & 0xFF000000) >> 24);

                    send_buffer[23] = (unsigned char) (tc_production_lot2 & 0x000000FF);
                    send_buffer[24] = (unsigned char) ((tc_production_lot2 & 0x0000FF00) >> 8);
                    send_buffer[25] = (unsigned char) ((tc_production_lot2 & 0x00FF0000) >> 16);
                    send_buffer[26] = (unsigned char) ((tc_production_lot2 & 0xFF000000) >> 24);

                    send_buffer[27] = (unsigned char) (tc_model & 0x000000FF);
                    send_buffer[28] = (unsigned char) ((tc_model & 0x0000FF00) >> 8);
                    send_buffer[29] = (unsigned char) ((tc_model & 0x00FF0000) >> 16);
                    send_buffer[30] = (unsigned char) ((tc_model & 0xFF000000) >> 24);

				    break;
                }

				case 7 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 8 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 9 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 10 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 11 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 12 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 13 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 14 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 15 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 16 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 17 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

				case 18 :                                    // Read Data
				{

				    prog_flash_adr = (unsigned long *) ((data[4] << 8) + (data[5] << 16) + (data[6] << 24));
				
				    if ((data[3] == 0x00) & ((data[4] % 0x04) == 0)) AMDFlash::ReadData_Prepare_Flash(prog_flash_adr);
				
                    result_buf = AMDFlash::ReadData_Byte_Flash(data[3] + ((data[4] & 0x03) << 8));
#ifdef _Debug_USB_
				    printf("Read address %x byte %d res = %x\n", prog_flash_adr, data[3] + ((data[4] & 0x03) << 8), result_buf);
#endif
				    break;
                }

            }

            send_buffer[0] = 10;
            send_buffer[1] = data[2];
            send_buffer[2] = data[3];
            send_buffer[3] = data[4];
            send_buffer[4] = data[5];
            send_buffer[5] = data[6];

            send_buffer[6] = result_buf;
            		
            SendData(send_buffer);

			break;
		}

		case 11: 											// Prgram the Flash
		{

            timebase_reg = data[3] + (data[4] << 8) + (data[5] << 16) + (data[6] << 24);
#ifdef _Debug_USB_
            if (Debug_Mode) printf("TB Reg written %x\n", timebase_reg);
#endif
            SetupADC();	

			break;
		}
		case 12: 											// Prgram the Flash
		{
#ifdef _Debug_USB_		
            if (Debug_Mode) printf("Read TB Reg %x\n", timebase_reg);
#endif
            send_buffer[0] = 8;								 // Kennung Test Var

            send_buffer[3] = (unsigned char) (timebase_reg & 0x000000FF);
            send_buffer[4] = (unsigned char) ((timebase_reg & 0x0000FF00) >> 8);
            send_buffer[5] = (unsigned char) ((timebase_reg & 0x00FF0000) >> 16);
            send_buffer[6] = (unsigned char) ((timebase_reg & 0xFF000000) >> 24);

            SendData(send_buffer);

			break;
		}		
		case 13: 											// Search Zeros
		{
            Search_Mode = true;

            CalcBuf = 0x01;
            while (CalcBuf != 0x00)
            {
                CalcBuf = Hardware::SearchZeros();
#ifdef _Debug_USB_
                printf("SearchResult : %i\n", CalcBuf);
#endif
            } 
			break;
		}
		
		case 14: 											// Receive Data
		{

			USB_Data_Requested = true;
			
			if (Continius == false) ISR_ADC_INT(6);

			break;			
		}	

		case 15: 											// Receive Data
        {

				    Set_Vars_Default();    			
				
				    UpdateChannel(1, 1);
				    UpdateChannel(2, 1);
				
				    VoltageChangedCh1 = 1;
				    VoltageChangedCh2 = 1;				
				
				    LED_ON[0] = 1;
				    LED_ON[1] = 1; 				
                    LED_ON[5] = 1;
                    LED_ON[6] = 0;

                    Rotary_Steps = 0;
                    ON_Zero_Channel_1();
                    Rotary_Steps = 0;
                    ON_Zero_Channel_2();

                    SetSwitches(1, Selected_Voltage_CH1);
                    SetSwitches(2, Selected_Voltage_CH2);

                    if (NumberOfChannels > 2)
                    {
                        UpdateChannel(3, 1);
                        UpdateChannel(4, 1);

				        VoltageChangedCh3 = 1;
				        VoltageChangedCh4 = 1;
				
				        LED_ON[2] = 1;
				        LED_ON[3] = 1;
				
                        ON_Zero_Channel_3();
                        ON_Zero_Channel_4();

                        SetSwitches(3, Selected_Voltage_CH3);
                        SetSwitches(4, Selected_Voltage_CH4);

                    }
                    else
                    {
                        UpdateChannel(3, 0);
                        UpdateChannel(4, 0);
                    }                 					

                    TriggerLevelChanged = 1;
                    TriggerModeChanged = 1;	
                    TriggerWayChanged = 1;
                    TimebaseChanged = 1;
                    TimeOffsetChanged = 1;
                    MenuStatusChanged = 1;
                    MenuAktive = 1;

				    Cursor_Data_First_Draw = 0;
				    Quick_Measure_First_Draw = 0;
				    	

				    UpdateTrigger(12);
				    Display::CALCPRETRIGGER();
				    Display::DRAW_ALL_CURSOR();
				
                    // remove the cursor data
				    for (ix = 408 * 20; ix < 430 * 20; ix++)
                    {
                        *(UI_Plane1 + ix) = 0;	// delete
                        *(Buffer_UI2Plane + ix) = 0;	// delete Text				
                        *(UI_Plane4 + ix) = 0;	// delete
                        *(UI_Plane5 + ix) = 0;	// delete
                    }				

                    Display::DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnDraw);							// Button
                    Display::TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text

                    Display::DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnDraw);						// Button
                    Display::TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);									// Draw Voltage Text
//                    Display::TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);									// Draw Voltage Text

				    Display::StatusUpdate();


                    if (NumberOfChannels > 2)
                    {
                        Display::DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button
                        Display::TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);								// Draw Voltage Text

                        Display::DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button		
                        Display::TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);								// Draw Voltage Text
//                        Display::TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);								// Draw Voltage Text
                    }
                    				
				    Display::DRAWSTATUS(6, 0);
				
				    Send_LED();

			break;			
		}

		case 16: 											// Receive Data
		{

			SendCtrlBlock();
			
			nr_delay(100);
			
			SendCtrlBlock3();
			
			nr_delay(10);
			
			SendCtrlBlock2();
            			
			USB_Connected = true;	

			break;			
		}             	

		case 17: 											// Receive Data
		{

			SendCtrlBlock2();

			break;			
		}
		
		case 18: 											// Receive Data
		{		
		
			New_Menu = 17;
			Menu_Changed = 1;
			
			USB_Connected = true;		
			
			break;			
		}		
	}
    }   // else			
}
/*
unsigned char Hardware::Calc_Chksum(volatile unsigned char Bytes[37])
{
    int i;

    for (i = 0; i < 37; i++)
    {
        calc_chks += Bytes[i];
        nr_uart_txchar(Bytes[i], puart2);
    }

}
*/
void Hardware::SendData(volatile unsigned char Bytes[40])
{
	int i;

#ifdef _Debug_USB_
    if (Command_Mode)
    {
        printf("Sending  0:%x  1:%x  2:%x  3:%x  4:%x  5:%x  6:%x  7:%x  8:%x 9:%x \n", Bytes[0], Bytes[1], Bytes[2], Bytes[3], Bytes[4], Bytes[5], Bytes[6], Bytes[7], Bytes[8], Bytes[9]);
        printf("Sending 10:%x 11:%x 12:%x 13:%x 14:%x 15:%x 16:%x 17:%x 18:%x 19:%x\n", Bytes[10], Bytes[11], Bytes[12], Bytes[13], Bytes[14], Bytes[15], Bytes[16], Bytes[17], Bytes[18], Bytes[19]);
        printf("Sending 20:%x 21:%x 22:%x 23:%x 24:%x 25:%x 26:%x 27:%x 28:%x 29:%x\n", Bytes[20], Bytes[21], Bytes[22], Bytes[23], Bytes[24], Bytes[25], Bytes[26], Bytes[27], Bytes[28], Bytes[29]);
        printf("Sending 30:%x 31:%x 32:%x 33:%x 34:%x 35:%x 36:%x \n", Bytes[30], Bytes[31], Bytes[32], Bytes[33], Bytes[34], Bytes[35], Bytes[36]);
    }
#endif

    nr_uart_txchar(40, puart2);
    for (i = 0; i < 40; i++)
    {
        nr_uart_txchar(Bytes[i], puart2);
    }
}

void Hardware::SendShot(void)
{
//    reset_watchdog->np_piodata = 0x00;                                  // Disable Watchdog

    // Disable all Interrupts
    DoDisableLogicAnalyserInterrupt();
	DoDisableReadVSyncInterrupt();
	DoDisableADCInterrupt();
	DoDisableTimer3Interrupt();
	DoDisableTimerInterrupt();
	DoDisableUART2Interrupt();
	DoDisableUARTInterrupt();
	DoDisableRotInterrupt();
	DoDisableKeyInterrupt();

    SendLayer(1);
    SendLayer(2);
    SendLayer(3);
    SendLayer(4);
    SendLayer(5);
    SendLayer(6);
    SendLayer(7);
    SendLayer(8);
    SendLayer(9);
    SendLayer(10);
    SendLayer(11);
    SendLayer(12);
    SendLayer(13);
    SendLayer(14);
    SendLayer(15);
    SendLayer(16);

    // Enable all Interrupts
	DoEnableKeyInterrupt();
	DoEnableRotInterrupt();
	DoEnableUARTInterrupt();
	DoEnableUART2Interrupt();
//	DoEnableTimerInterrupt();
	DoEnableTimer3Interrupt();
	DoEnableADCInterrupt();	
	DoEnableReadVSyncInterrupt();
//    DoEnableLogicAnalyserInterrupt();	

//    reset_watchdog->np_piodata = 0x01;                                  // Enable Watchdog
}

void Hardware::SendSWShot(void)
{
    unsigned int LineCnt, PackCnt;
    unsigned long *Layer1 = UI_Plane1;
    unsigned long *Layer2 = UI_Plane2;
    unsigned long *Layer3 = UI_Plane3;
    unsigned long *Layer4 = UI_Plane4;
    unsigned long *Layer5 = UI_Plane5;
    unsigned long *Layer6 = Channel_Plane1;
    unsigned long *Layer7 = Channel_Plane2;
    unsigned long *Layer8 = Channel_Plane3;
    unsigned long *Layer9 = Channel_Plane4;
    unsigned long *Layer10 = Channel_Math_Plane;
    unsigned long *Layer11 = Memory_Plane1;
    unsigned long *Layer12 = Memory_Plane2;
    unsigned long *Layer13 = Memory_Plane3;
    unsigned long *Layer14 = Marker_Plane1;
    unsigned long *Layer15 = Marker_Plane2;
    unsigned long *Layer16 = Grid_Plane;

    unsigned long BufLayer = 0x00000000;

//    reset_watchdog->np_piodata = 0x00;                                  // Disable Watchdog

    // Disable all Interrupts
    DoDisableLogicAnalyserInterrupt();
	DoDisableReadVSyncInterrupt();
	DoDisableADCInterrupt();
	DoDisableTimer3Interrupt();
	DoDisableTimerInterrupt();
	DoDisableUART2Interrupt();
	DoDisableUARTInterrupt();
	DoDisableRotInterrupt();
	DoDisableKeyInterrupt();


    send_buffer[0] = 254;                                               // Kennung Screen Data
    send_buffer[1] = 1;                                                 // Layer number

    for(LineCnt = 0; LineCnt < 1200; LineCnt++)
    {
        send_buffer[2] = (unsigned char) ((LineCnt & 0xFF00) >> 8);     // High Line Address
        send_buffer[3] = (unsigned char) (LineCnt & 0x00FF);            // Low Line Address

        for(PackCnt = 0; PackCnt < 8; PackCnt++)
        {

            BufLayer = Layer1[(LineCnt * 8) + PackCnt] | Layer2[(LineCnt * 8) + PackCnt] | Layer5[(LineCnt * 8) + PackCnt] | Layer6[(LineCnt * 8) + PackCnt] | Layer7[(LineCnt * 8) + PackCnt] | Layer8[(LineCnt * 8) + PackCnt] | Layer9[(LineCnt * 8) + PackCnt] | Layer10[(LineCnt * 8) + PackCnt] | Layer11[(LineCnt * 8) + PackCnt] | Layer12[(LineCnt * 8) + PackCnt] | Layer13[(LineCnt * 8) + PackCnt] | Layer14[(LineCnt * 8) + PackCnt] | Layer15[(LineCnt * 8) + PackCnt] | Layer16[(LineCnt * 8) + PackCnt];

            send_buffer[4 + (PackCnt * 4)] = (unsigned char) (BufLayer & 0x000000FF);
            send_buffer[5 + (PackCnt * 4)] = (unsigned char) ((BufLayer & 0x0000FF00) >> 8);
            send_buffer[6 + (PackCnt * 4)] = (unsigned char) ((BufLayer & 0x00FF0000) >> 16);
            send_buffer[7 + (PackCnt * 4)] = (unsigned char) ((BufLayer & 0xFF000000) >> 24);
        }

        SendData(send_buffer);
    }

    // Enable all Interrupts
	DoEnableKeyInterrupt();
	DoEnableRotInterrupt();
	DoEnableUARTInterrupt();
	DoEnableUART2Interrupt();
//	DoEnableTimerInterrupt();
	DoEnableTimer3Interrupt();
	DoEnableADCInterrupt();	
	DoEnableReadVSyncInterrupt();
//    DoEnableLogicAnalyserInterrupt();	

//    reset_watchdog->np_piodata = 0x01;                                  // Enable Watchdog
}

void Hardware::SendLayer(unsigned char LayerNr)							// Send a Layer through USB
{
    unsigned int LineCnt, PackCnt;
    unsigned long *Layer = Planes;

    switch(LayerNr)
    {
        case 1 : Layer = UI_Plane1; break;
        case 2 : Layer = UI_Plane2; break;
        case 3 : Layer = UI_Plane3; break;
        case 4 : Layer = UI_Plane4; break;
        case 5 : Layer = UI_Plane5; break;
        case 6 : Layer = Channel_Plane1; break;
        case 7 : Layer = Channel_Plane2; break;
        case 8 : Layer = Channel_Plane3; break;
        case 9 : Layer = Channel_Plane4; break;
        case 10 : Layer = Channel_Math_Plane; break;
        case 11 : Layer = Memory_Plane1; break;
        case 12 : Layer = Memory_Plane2; break;
        case 13 : Layer = Memory_Plane3; break;
        case 14 : Layer = Marker_Plane1; break;
        case 15 : Layer = Marker_Plane2; break;
        case 16 : Layer = Grid_Plane; break;
    }
    send_buffer[0] = 253;                                               // Kennung Screen Data
    send_buffer[1] = LayerNr;                                                 // Layer number

    for(LineCnt = 0; LineCnt < 1200; LineCnt++)
    {
        send_buffer[2] = (unsigned char) ((LineCnt & 0xFF00) >> 8);     // High Line Address
        send_buffer[3] = (unsigned char) (LineCnt & 0x00FF);            // Low Line Address

        for(PackCnt = 0; PackCnt < 8; PackCnt++)
        {
            send_buffer[4 + (PackCnt * 4)] = 0;
            send_buffer[5 + (PackCnt * 4)] = 0;
            send_buffer[6 + (PackCnt * 4)] = 0;
            send_buffer[7 + (PackCnt * 4)] = 0;

            send_buffer[4 + (PackCnt * 4)] = (unsigned char) (Layer[(LineCnt * 8) + PackCnt] & 0x000000FF);
            send_buffer[5 + (PackCnt * 4)] = (unsigned char) ((Layer[(LineCnt * 8) + PackCnt] & 0x0000FF00) >> 8);
            send_buffer[6 + (PackCnt * 4)] = (unsigned char) ((Layer[(LineCnt * 8) + PackCnt] & 0x00FF0000) >> 16);
            send_buffer[7 + (PackCnt * 4)] = (unsigned char) ((Layer[(LineCnt * 8) + PackCnt] & 0xFF000000) >> 24);
        }

        SendData(send_buffer);
    }
}

void Hardware::SendCtrlBlock(void)
{
    int intbuf, ix;
    int chk_calc = 0;

    send_buffer[0] = 105;								// Kennung Data
//    send_buffer[1] = 5;									// Kennung Datablock

    send_buffer[2] = (unsigned char) (Selected_Voltage_CH1);
    send_buffer[3] = (unsigned char) (Selected_Voltage_CH2);
    send_buffer[4] = (unsigned char) (Selected_Voltage_CH3);
    send_buffer[5] = (unsigned char) (Selected_Voltage_CH4);
    send_buffer[6] = (unsigned char) (Selected_Timebase);
    send_buffer[7] = (unsigned char) (SIGNALFaktor_idx);
		
    send_buffer[8] = (unsigned char) ((ZeroLevelCH1 + 64) >> 1);		
    send_buffer[9] = (unsigned char) ((ZeroLevelCH2 + 64) >> 1);		
    send_buffer[10] = (unsigned char) ((ZeroLevelCH3 + 64) >> 1);		
    send_buffer[11] = (unsigned char) ((ZeroLevelCH4 + 64) >> 1);		

    send_buffer[12] = (unsigned char) (NumberOfChannels);
    send_buffer[13] = (unsigned char) (ZFT_float);
        		
    send_buffer[14] = (unsigned char) SingleMode;
    send_buffer[15] = (unsigned char) Continius;

    send_buffer[16] = (unsigned char) Selected_Trigger_Source;

    send_buffer[17] = (unsigned char) 0;

    switch(Selected_Trigger_Source)
    {
        case 1 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH1 + 64) >> 1); break;
        case 2 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH2 + 64) >> 1); break;
        case 3 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH3 + 64) >> 1); break;
        case 4 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH4 + 64) >> 1); break;
        case 5 : send_buffer[17] = (unsigned char) Trigger_Pos_CHE; break;
    }

    send_buffer[18] = 0;
    if (Channel_1_Active) send_buffer[18] = send_buffer[18] | 0x01;
    if (MenuStatus[1][0] == 7) send_buffer[18] = send_buffer[18] | 0x02;  // AC
    if (MenuStatus[1][0] == 8) send_buffer[18] = send_buffer[18] | 0x04;  // AC
    if (MenuStatus[1][0] == 9) send_buffer[18] = send_buffer[18] | 0x08;  // AC
    if (MenuStatus[1][2] == 241) send_buffer[18] = send_buffer[18] | 0x10;  // Invert

    send_buffer[19] = 0;
    if (Channel_2_Active) send_buffer[19] = send_buffer[19] | 0x01;
    if (MenuStatus[2][0] == 7) send_buffer[19] = send_buffer[19] | 0x02;  // AC
    if (MenuStatus[2][0] == 8) send_buffer[19] = send_buffer[19] | 0x04;  // AC
    if (MenuStatus[2][0] == 9) send_buffer[19] = send_buffer[19] | 0x08;  // AC
    if (MenuStatus[2][2] == 241) send_buffer[18] = send_buffer[18] | 0x10;  // Invert

    send_buffer[20] = 0;
    if (Channel_3_Active) send_buffer[20] = send_buffer[20] | 0x01;
    if (MenuStatus[3][0] == 7) send_buffer[20] = send_buffer[20] | 0x02;  // AC
    if (MenuStatus[3][0] == 8) send_buffer[20] = send_buffer[20] | 0x04;  // AC
    if (MenuStatus[3][0] == 9) send_buffer[20] = send_buffer[20] | 0x08;  // AC
    if (MenuStatus[3][2] == 241) send_buffer[18] = send_buffer[18] | 0x10;  // Invert

    send_buffer[21] = 0;
    if (Channel_4_Active) send_buffer[21] = send_buffer[21] | 0x01;
    if (MenuStatus[4][0] == 7) send_buffer[21] = send_buffer[21] | 0x02;  // AC
    if (MenuStatus[4][0] == 8) send_buffer[21] = send_buffer[21] | 0x04;  // AC
    if (MenuStatus[4][0] == 9) send_buffer[21] = send_buffer[21] | 0x08;  // AC
    if (MenuStatus[4][2] == 241) send_buffer[18] = send_buffer[18] | 0x10;  // Invert

    send_buffer[22] = (unsigned char) Channel_Math_Active;

    send_buffer[23] = (unsigned char) MenuStatus[1][3];
    send_buffer[24] = (unsigned char) MenuStatus[2][3];
    send_buffer[25] = (unsigned char) MenuStatus[3][3];
    send_buffer[26] = (unsigned char) MenuStatus[4][3];
    send_buffer[27] = (unsigned char) MenuStatus[12][4];

    intbuf = (int)((float) Timebase_Offset_Pos * OFT_float);

    send_buffer[28] = (unsigned char) (intbuf & 0x00FF);
    send_buffer[29] = (unsigned char) ((intbuf & 0xFF00) >> 8);
    send_buffer[30] = (unsigned char) ((Timebase_Offset_Pos + 300) & 0x00FF);      // + 300 so it was unsigned
    send_buffer[31] = (unsigned char) (((Timebase_Offset_Pos + 300)  & 0xFF00) >> 8);

    send_buffer[32] = (unsigned char) MenuStatus[14][0];        // Trigger Edge
    send_buffer[33] = (unsigned char) MenuStatus[14][2];        // Trigger Extern

    send_buffer[34] = (unsigned char) (pre_reg & 0x00FF);
    send_buffer[35] = (unsigned char) ((pre_reg & 0xFF00) >> 8);

    chk_calc = 0;	
    for (ix = 0; ix < 32; ix++)
    {	
        chk_calc += send_buffer[3 + ix];
    }	
				
    send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
    send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
        		
    SendData(send_buffer);
}

void Hardware::SendCtrlBlock2(void)
{
    int intbuf, ix;
    int chk_calc = 0;

    send_buffer[0] = 107;								// Kennung Data
//    send_buffer[1] = 7;									// Kennung Datablock

    send_buffer[2] = (unsigned char) (Cursor_Enabled);
    send_buffer[3] = (unsigned char) (SelectedCursor);
    send_buffer[4] = (unsigned char) (Cursor_XY_Selected);
    send_buffer[5] = (unsigned char) (Cursor_Both_Selected);
    send_buffer[6] = (unsigned char) (Cursor_Horizontal_Active);
    send_buffer[7] = (unsigned char) (Cursor_Vertical_Active);

    send_buffer[8] = (unsigned char) (Cursor_Horizontal_Position_Real1 & 0x000000FF);
    send_buffer[9] = (unsigned char) ((Cursor_Horizontal_Position_Real1 & 0x0000FF00) >> 8);
    send_buffer[10] = (unsigned char) ((Cursor_Horizontal_Position_Real1 & 0x00FF0000) >> 16);
    send_buffer[11] = (unsigned char) ((Cursor_Horizontal_Position_Real1 & 0xFF000000) >> 24);

    send_buffer[12] = (unsigned char) (Cursor_Horizontal_Position_Real2 & 0x000000FF);
    send_buffer[13] = (unsigned char) ((Cursor_Horizontal_Position_Real2 & 0x0000FF00) >> 8);
    send_buffer[14] = (unsigned char) ((Cursor_Horizontal_Position_Real2 & 0x00FF0000) >> 16);
    send_buffer[15] = (unsigned char) ((Cursor_Horizontal_Position_Real2 & 0xFF000000) >> 24);

    send_buffer[16] = (unsigned char) (Cursor_Vertical_Position_Real1 & 0x000000FF);
    send_buffer[17] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0x0000FF00) >> 8);
    send_buffer[18] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0x00FF0000) >> 16);
    send_buffer[19] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0xFF000000) >> 24);

    send_buffer[20] = (unsigned char) (Cursor_Vertical_Position_Real2 & 0x000000FF);
    send_buffer[21] = (unsigned char) ((Cursor_Vertical_Position_Real2 & 0x0000FF00) >> 8);
    send_buffer[22] = (unsigned char) ((Cursor_Vertical_Position_Real2 & 0x00FF0000) >> 16);
    send_buffer[23] = (unsigned char) ((Cursor_Vertical_Position_Real2 & 0xFF000000) >> 24);

    send_buffer[24] = (unsigned char) QM_Threshold_lower.Read_Value();
    send_buffer[25] = (unsigned char) QM_Threshold_middle.Read_Value();
    send_buffer[26] = (unsigned char) QM_Threshold_upper.Read_Value();

    send_buffer[27] = (unsigned char) ((SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float)) & 0x00FF);
    send_buffer[28] = (unsigned char) (((SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float)) & 0xFF00) >> 8);

    send_buffer[29] = (unsigned char) ((SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float)) & 0x00FF);
    send_buffer[30] = (unsigned char) (((SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float)) & 0xFF00) >> 8);

    //send_buffer[31] = (unsigned char) ((SIG_Start_Stop[ZIT_short][0] + (int)((float) -300 * OFT_float)) & 0x00FF);
    //send_buffer[32] = (unsigned char) (((SIG_Start_Stop[ZIT_short][0] + (int)((float) -300 * OFT_float)) & 0xFF00) >> 8);

    send_buffer[31] = (unsigned char) (Trig_Mem_Pos & 0x00FF);
    send_buffer[32] = (unsigned char) ((Trig_Mem_Pos & 0xFF00) >> 8);


    send_buffer[33] = (unsigned char) ((Trigger_Offset_Calc + 100) & 0x00FF);
    send_buffer[34] = (unsigned char) (((Trigger_Offset_Calc + 100) & 0xFF00) >> 8);

    send_buffer[35] = (unsigned char) (FirStartCH & 0x00FF);
    send_buffer[36] = (unsigned char) ((FirStartCH & 0xFF00) >> 8);
    

    //send_buffer[8] = (unsigned char) (Cursor_Vertical_Position_Real1 & 0x000000FF);
    //send_buffer[9] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0x0000FF00) >> 8);
    //send_buffer[10] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0x00FF0000) >> 16);
    //send_buffer[11] = (unsigned char) ((Cursor_Vertical_Position_Real1 & 0xFF000000) >> 24);            		
    //send_buffer[8] = (unsigned char) ((ZeroLevelCH1 + 64) >> 1);		
    //send_buffer[9] = (unsigned char) ((ZeroLevelCH2 + 64) >> 1);		
    //send_buffer[10] = (unsigned char) ((ZeroLevelCH3 + 64) >> 1);		
    //send_buffer[11] = (unsigned char) ((ZeroLevelCH4 + 64) >> 1);		

    //send_buffer[12] = (unsigned char) (NumberOfChannels);
    //send_buffer[13] = (unsigned char) (ZFT_float);
        		
    //send_buffer[14] = (unsigned char) SingleMode;
    //send_buffer[15] = (unsigned char) Continius;

    //send_buffer[16] = (unsigned char) Selected_Trigger_Source;

    //send_buffer[17] = (unsigned char) 0;
    /*
    switch(Selected_Trigger_Source)
    {
        case 1 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH1 + 64) >> 1); break;
        case 2 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH2 + 64) >> 1); break;
        case 3 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH3 + 64) >> 1); break;
        case 4 : send_buffer[17] = (unsigned char) ((Trigger_Pos_CH4 + 64) >> 1); break;
        case 5 : send_buffer[17] = (unsigned char) Trigger_Pos_CHE; break;
    }
    */
    //send_buffer[18] = (unsigned char) Channel_1_Active;
    //send_buffer[19] = (unsigned char) Channel_2_Active;
    //send_buffer[20] = (unsigned char) Channel_3_Active;
    //send_buffer[21] = (unsigned char) Channel_4_Active;
    //send_buffer[22] = (unsigned char) Channel_Math_Active;

    //send_buffer[23] = (unsigned char) MenuStatus[1][3];
    //send_buffer[24] = (unsigned char) MenuStatus[2][3];
    //send_buffer[25] = (unsigned char) MenuStatus[3][3];
    //send_buffer[26] = (unsigned char) MenuStatus[4][3];
    //send_buffer[27] = (unsigned char) MenuStatus[12][4];

    //intbuf = (int)((float) Timebase_Offset_Pos * OFT_float);

    //send_buffer[28] = (unsigned char) (intbuf & 0x00FF);
    //send_buffer[29] = (unsigned char) ((intbuf & 0xFF) >> 8);
    //send_buffer[30] = (unsigned char) ((Timebase_Offset_Pos + 300) & 0x00FF);      // + 300 so it was unsigned
    //send_buffer[31] = (unsigned char) (((Timebase_Offset_Pos + 300)  & 0xFF00) >> 8);

    chk_calc = 0;	
    for (ix = 0; ix < 32; ix++)
    {	
        chk_calc += send_buffer[3 + ix];
    }	
				
    send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
    send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                    		
    SendData(send_buffer);
}

void Hardware::SendCtrlBlock3(void)
{
    int intbuf, ix;
    int chk_calc = 0;

    send_buffer[0] = 108;								// Kennung Data

    send_buffer[2] = (unsigned char) (Voltage_Correction[0][Selected_Voltage_CH1]);
    send_buffer[3] = (unsigned char) (Voltage_Correction[1][Selected_Voltage_CH2]);
    send_buffer[4] = (unsigned char) (Voltage_Correction[2][Selected_Voltage_CH3]);
    send_buffer[5] = (unsigned char) (Voltage_Correction[3][Selected_Voltage_CH4]);
    send_buffer[6] = (unsigned char) AutoFreeRun;
    
    send_buffer[7] = (unsigned char) 0;
    send_buffer[8] = (unsigned char) 0;
    send_buffer[9] = (unsigned char) 0;
    send_buffer[10] = (unsigned char) 0;
    send_buffer[11] = (unsigned char) 0;
    send_buffer[12] = (unsigned char) 0;
    send_buffer[13] = (unsigned char) 0;
    send_buffer[14] = (unsigned char) 0;
    send_buffer[15] = (unsigned char) 0;
    send_buffer[16] = (unsigned char) 0;
    send_buffer[17] = (unsigned char) 0;
    send_buffer[18] = (unsigned char) 0;
    send_buffer[19] = (unsigned char) 0;
    send_buffer[20] = (unsigned char) 0;
    send_buffer[21] = (unsigned char) 0;
    send_buffer[22] = (unsigned char) 0;
    send_buffer[23] = (unsigned char) 0;
    send_buffer[24] = (unsigned char) 0;
    send_buffer[25] = (unsigned char) 0;
    send_buffer[26] = (unsigned char) 0;
    send_buffer[27] = (unsigned char) 0;
    send_buffer[28] = (unsigned char) 0;
    send_buffer[29] = (unsigned char) 0;
    send_buffer[30] = (unsigned char) 0;
    send_buffer[31] = (unsigned char) 0;
    send_buffer[32] = (unsigned char) 0;
    send_buffer[33] = (unsigned char) 0;
    send_buffer[34] = (unsigned char) 0;
    send_buffer[35] = (unsigned char) 0;
    send_buffer[36] = (unsigned char) 0;

    chk_calc = 0;	
    for (ix = 0; ix < 32; ix++)
    {	
        chk_calc += send_buffer[3 + ix];
    }	
				
    send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
    send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                    		
    SendData(send_buffer);
}

void Hardware::DoEnableTimerInterrupt(void)											// Enable service routine
{	
    return;
    					
	nr_installuserisr(na_timer1_irq,ISR_TIMER,(int)timer1); 						// Install timer isr
	

//	timer1->np_timerperiodh = timer_array_first[Selected_Timebase] >> 16;					// Set High Register of Timer
//	timer1->np_timerperiodl = timer_array_first[Selected_Timebase] & 0xffff;					// Set Low Register of Timer

    timer_reload_high = timerAutoFreefirst >> 16;					// Set High Register of Timer 200 ms  -> mu in TB array
    timer_reload_low = timerAutoFreefirst & 0xffff;					// Set Low Register of Timer

    timer1->np_timerperiodh = timer_reload_high;
    timer1->np_timerperiodl = timer_reload_low;	

    timer_counter_value = 0;

    timer1->np_timercontrol = timer1->np_timercontrol | np_timercontrol_ito_mask;  	// Enable timer interrupt
    timer1->np_timercontrol = ((timer1->np_timercontrol & 3) + np_timercontrol_stop_mask);	// Stop Timer
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("\nTimer1 interrupt enabled.\n"); 										// print on console
#endif	
}
	
void Hardware::DoDisableTimerInterrupt(void)										// Disable service routine
{
	nr_installuserisr(na_timer1_irq,0,0); 											// Install empty routine for timer irq
	timer1->np_timercontrol = timer1->np_timercontrol & ~np_timercontrol_ito_mask; 	// Disable timer interrupt
}

void Hardware::Start_Timer1(void)
{
    return;

    if (init_done == false) return;

    if (Selected_Timebase < 17)
    {
        if (AutoSearchTrigger)
        {
            timer_reload_high = timerAutoFreefast >> 16;					// Set High Register of Timer 1 ms
            timer_reload_low = timerAutoFreefast & 0xffff;					// Set Low Register of Timer
        }
        else
        {
            timer_reload_high = timerAutoFreefirst >> 16;					// Set High Register of Timer 200 ms  -> mu in TB array
            timer_reload_low = timerAutoFreefirst & 0xffff;					// Set Low Register of Timer
        }
    }
    else if (Selected_Timebase < 23)
    {
        if (AutoSearchTrigger)
        {
            timer_reload_high = timerAutoFreefast >> 13;					// Set High Register of Timer 4 ms
            timer_reload_low = timerAutoFreefast & 0xffff;					// Set Low Register of Timer
        }
        else
        {
            timer_reload_high = timerAutoFreefirst >> 13;					// Set High Register of Timer 800 ms  -> mu in TB array
            timer_reload_low = timerAutoFreefirst & 0xffff;					// Set Low Register of Timer
        }
    }
    else
    {
        if (AutoSearchTrigger)
        {
            timer_reload_high = timerAutoFreefast >> (11 - (Selected_Timebase - 23));					// Set High Register of Timer 4 ms
            timer_reload_low = timerAutoFreefast & 0xffff;					// Set Low Register of Timer
        }
        else
        {
            timer_reload_high = timerAutoFreefirst >> (11 - (Selected_Timebase - 23));					// Set High Register of Timer 800 ms  -> mu in TB array
            timer_reload_low = timerAutoFreefirst & 0xffff;					// Set Low Register of Timer
        }
    }

    timer1->np_timerperiodh = timer_reload_high;
    timer1->np_timerperiodl = timer_reload_low;	

    timer_counter_value = 0;
	
    timer1->np_timercontrol = ((timer1->np_timercontrol & 3) + np_timercontrol_start_mask);	// Start Timer
}

void Hardware::Stop_Timer1(void)
{
    timer1->np_timercontrol = ((timer1->np_timercontrol & 3) + np_timercontrol_stop_mask);	// Stop Timer
}

void Hardware::ISR_TIMER(int context)												// Menu Timer service subroutine
{
	char fchanged = 0;    	

	tc_test_var2++;
	
	timer1->np_timercontrol = ((timer1->np_timercontrol & 3) + np_timercontrol_stop_mask);	// Stop Timer
	timer1->np_timerstatus = 0;										// write anything to clear the ISR

    timer1->np_timerperiodh = timer_reload_high;
    timer1->np_timerperiodl = timer_reload_low;	


#ifdef _Debug_IRQ_
	if (Debug_Mode)  printf("We got a timer1 irq  AFR %d  AST %d tcv %d tcm %d irq %d\n", AutoFreeRun, AutoSearchTrigger, timer_counter_value, timer_counter_max, acq_ready->np_piodata);
#endif

    Start_Record();  	
}

void Hardware::DoEnableTimer2Interrupt(void)										// Enable service routine
{	
    ROLLMODE_STARTED = true;

	timer2->np_timercontrol = ((timer2->np_timercontrol & 3) + np_timercontrol_stop_mask) & ~np_timercontrol_cont_mask;	// Stop Timer
	timer2->np_timerperiodh = rollmode_value[ROLLMODE_TB] >> 16;					// Set High Register of Timer
	timer2->np_timerperiodl = rollmode_value[ROLLMODE_TB] & 0xffff;					// Set Low Register of Timer
	timer2->np_timerstatus = 0;										// write anything to clear the ISR

	nr_installuserisr(na_timer2_irq,ISR_TIMER2,(int)timer2); 						// Install timer isr
	timer2->np_timercontrol = timer2->np_timercontrol | np_timercontrol_ito_mask;  	// Enable timer interrupt
	timer2->np_timercontrol = ((timer2->np_timercontrol & 3) + np_timercontrol_start_mask) | np_timercontrol_cont_mask;	// Start Timer
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("\nTimer2 interrupt enabled.\n");
#endif	
}
	
void Hardware::DoDisableTimer2Interrupt(void)										// Disable service routine
{
	nr_installuserisr(na_timer2_irq,0,0); 											// Install empty routine for timer irq
	timer2->np_timercontrol = timer2->np_timercontrol & ~np_timercontrol_ito_mask; 	// Disable timer interrupt
    timer2->np_timerstatus = 0;
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nTimer2 interrupt disabled.\n");	
#endif	
}

void Hardware::ISR_TIMER2(int context)												// Menu Timer service subroutine
{
    int cnt;

    tc_test_var2++;

	timer2->np_timerstatus = 0;														// write anything to clear the IRQ
	
	if (Search_Mode) return;
	if (Splash_drawed) return;
	if (Continius == false) return;
	
           	
    if (ROLLMODE_STARTED == false)
    {
        DoDisableTimer2Interrupt();
        return;
    }

	if (ROLLMODE_POS < 20)
    {
        ROLLMODE_POS++;
        return;
    }

#ifdef _Debug_Roll_Mode_
	if (Debug_Mode) printf("Got Rollmode irq\n");
#endif
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("Got Rollmode irq\n");
#endif		
//	{
//	   printf("ADCs per sec %d\n", sps_counter);
//	   printf("vsync per sec %d\n", vs_counter);
//    }
            	
	sps_counter = 0;
	vs_counter = 0;

	
    if (ROLLMODE_Value_rec == false) return;

    ROLLMODE_Value_rec = false;

    if (ROLLMODE_OFFSET > 5) ROLLMODE_OFFSET--;

    SIGNAL1_Intpolate[600] = ROLLMODE_BUFFVALUE_CH1;
    SIGNAL2_Intpolate[600] = ROLLMODE_BUFFVALUE_CH2;

    if (NumberOfChannels > 2)
    {
        SIGNAL3_Intpolate[600] = ROLLMODE_BUFFVALUE_CH3;
        SIGNAL4_Intpolate[600] = ROLLMODE_BUFFVALUE_CH4;
    }

    Copy_in_asm((601 - ROLLMODE_OFFSET), &SIGNAL1_Intpolate[601 - (600 - ROLLMODE_OFFSET)], &SIGNAL1_Intpolate[600 - (600 - ROLLMODE_OFFSET)]);
    Copy_in_asm((601 - ROLLMODE_OFFSET), &SIGNAL2_Intpolate[601 - (600 - ROLLMODE_OFFSET)], &SIGNAL2_Intpolate[600 - (600 - ROLLMODE_OFFSET)]);

    if (NumberOfChannels > 2)
    {
        Copy_in_asm((601 - ROLLMODE_OFFSET), &SIGNAL3_Intpolate[601 - (600 - ROLLMODE_OFFSET)], &SIGNAL3_Intpolate[600 - (600 - ROLLMODE_OFFSET)]);
        Copy_in_asm((601 - ROLLMODE_OFFSET), &SIGNAL4_Intpolate[601 - (600 - ROLLMODE_OFFSET)], &SIGNAL4_Intpolate[600 - (600 - ROLLMODE_OFFSET)]);
    }

    if (ROLLMODE_OFFSET > 597) return;

    DrawSignals_Needed = 1;


}

void Hardware::Copy_in_asm(int cnt, unsigned char *DataArray_in, unsigned char *DataArray_out)
{
    asm("
            ;MOV		%l0, %i0

            ;MOV		%l1, %i1
            ;SUB     %l1, %i0

            ;MOV		%l2, %i2
            ;SUB     %l2, %i0

        copy_asm1 :
            LD      %r0, [%i1]          ; save old value
            EXT8D   %r0, %i1            ; extract byte

            FILL8	%r0, %r0
            ST8D	[%i2], %r0

            ADDI   %i1, 1                            ; Add Address Counter
            ADDI   %i2, 1                            ; Add Address Counter
                        	
            SUBI   %i0, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     copy_asm1	
            NOP

        ");

}

void Hardware::DoEnableTimer3Interrupt(void)										// Enable service routine
{					
	timer_rotary_busy->np_timerperiodh = timerrotPeriod >> 16;									// Set High Register of Timer
	timer_rotary_busy->np_timerperiodl = timerrotPeriod & 0xffff;									// Set Low Register of Timer
    timer_rotary_busy->np_timerstatus = 0;														// write anything to clear the IRQ

	nr_installuserisr(na_timer3_irq,ISR_TIMER3,(int)timer_rotary_busy); 						// Install timer isr

	timer_rotary_busy->np_timercontrol = timer_rotary_busy->np_timercontrol | np_timercontrol_ito_mask;  	// Enable timer interrupt
	
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("Timer3 interrupt enabled & started.\n"); 										// print on console
#endif	
}
	
void Hardware::DoDisableTimer3Interrupt(void)										// Disable service routine
{
	nr_installuserisr(na_timer3_irq,0,0); 											// Install empty routine for timer irq
	timer_rotary_busy->np_timercontrol = timer_rotary_busy->np_timercontrol & ~np_timercontrol_ito_mask; 	// Disable timer interrupt
}

void Hardware::ISR_TIMER3(int context)		// Menu Timer service subroutine
{
	char fchanged = 0;
	char already_saved =0;					// TMW added variable

	tc_test_var2++;

	timer_rotary_busy->np_timerstatus = 0;	// write anything to clear the IRQ
    	
	if ((Search_Mode) || (Splash_drawed)) return;

	
 	if (MenuItemPushed[0] == 1) { fchanged = 1; MenuItemPushed[0] = 0; MenuItemPushed_old[0] = 1; MenuItemChanged[0] = 1;}
	if (MenuItemPushed[1] == 1) { fchanged = 1; MenuItemPushed[1] = 0; MenuItemPushed_old[1] = 1; MenuItemChanged[1] = 1;}
	if (MenuItemPushed[2] == 1) { fchanged = 1; MenuItemPushed[2] = 0; MenuItemPushed_old[2] = 1; MenuItemChanged[2] = 1;}
	if (MenuItemPushed[3] == 1) { fchanged = 1; MenuItemPushed[3] = 0; MenuItemPushed_old[3] = 1; MenuItemChanged[3] = 1;}
	if (MenuItemPushed[4] == 1) { fchanged = 1; MenuItemPushed[4] = 0; MenuItemPushed_old[4] = 1; MenuItemChanged[4] = 1;}
	if (MenuItemPushed[5] == 1) { fchanged = 1; MenuItemPushed[5] = 0; MenuItemPushed_old[5] = 1; MenuItemChanged[5] = 1;}

	if (StatusbarChanged) { Display::RemoveStatusBtn(); }	// Remove the Status Button
	if (MenuPopupActive > -1)
    	{
  		config_changed = true;  								// TMW changed (moved from below)
		AMDFlash::Write_Config_Flash();							// TMW changed (moved from below)
       	fchanged = 0;
        Display::DRAWMENUPOPDOWN();
		already_saved =1;										// TMW added variable
    	}	 

// TMW changed    
	if ((Memory_Window_visible) && (MenuStatus[5][4] == 240)) 	// if Memory Window is visible and
    	{													  	// Browse Function not active
		if ( already_saved == 0 )								// TMW added variable
			{
  			config_changed = true;  							// TMW changed (added to above)
			AMDFlash::Write_Config_Flash();						// TMW changed (added to above)
			}
			
      	Display::DRAWMEMORY(1, 0, 0);     					  	// Close Memory Window and
        //Display::DRAW_ALL_CURSOR();	// TMW removed			// redraw all cursors due to closure
    	}
// TMW change ends




//	if (ZeroPopupChanged) { Display::DRAWZEROPOPDOWN(); }
	
	if (fchanged == 1) { New_Menu = Active_Menu; Menu_Changed = 1; }
	

    /*
	timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_stop_mask);// & ~np_timercontrol_cont_mask;	// Stop Timer

	timer_rotary_busy->np_timerperiodh = timerrotPeriod >> 16;									// Set High Register of Timer
	timer_rotary_busy->np_timerperiodl = timerrotPeriod & 0xffff;									// Set Low Register of Timer
	*/


    ButtonChanged = 0;
    RoteryReady = 0;
    DrawSignals_Needed = 0;
    UserIface_active = 0;
	Menu_Popup_visible =0;

    acq_ready->np_pioedgecapture = 0;
    //acq_ready->np_piointerruptmask = 0x01;

    //config_changed = true;  							// TMW changed (set in comments)
    //AMDFlash::Write_Config_Flash();

    //SetupADC();										// TMW changed (set in comments)

 //   if (TriggerOffsetChanged == true) SetupADC();
 //   TriggerOffsetChanged = false;

    //if ((MenuStatus[10][2] == 1) && (ROLLMODE_STARTED == true)) return;
          /*
    if (Continius)
    {
        LED_ON[12] = 1;
        LED_ON[13] = 0;
        Send_LED();

        //if ((adc_started == false) && (OneShotRestart == false)) Start_Record();
        if (OneShotRestart == false) Start_Record();
    }   */

   	//if ((MenuStatus[10][2] == 1) && (ROLLMODE_STARTED == false)) DoEnableTimer2Interrupt();

}

void Hardware::ResetTimer(void)	// Reset Timer
{
	long timerVal;
	long timerPeriod;

	timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_stop_mask);// & ~np_timercontrol_cont_mask;	// Stop Timer
	timer_rotary_busy->np_timerstatus = 0;								// write anything to clear the IRQ
		
	timer_rotary_busy->np_timerperiodh = timerrotPeriod >> 16;			// Set High Register of Timer
	timer_rotary_busy->np_timerperiodl = timerrotPeriod & 0xffff;		// Set Low Register of Timer

	timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer

}

void Hardware::SetSwitches(char channel, int voltage)
{
	bool DoNothing = 0;
	short dat_buf = 0;
	short CalcBufInt = 0;	
	long adr_buf = 0x00000000;
	long outbuf = 0x00000000;
				
	switch(voltage)
	{
		case -1 :
		{
			switch(channel)
			{
				case 1 : dat_buf = SwitchesCH1;break;
				case 2 : dat_buf = SwitchesCH2;break;
				case 3 : dat_buf = SwitchesCH3;break;
				case 4 : dat_buf = SwitchesCH4;break;
				case 5 : dat_buf = SwitchesTB;break;				
			}	
			break;		
		}			
	
		case 0 : dat_buf = 0x0015; break;
		case 1 : dat_buf = 0x0015; break;
		case 2 : dat_buf = 0x0015; break;
		case 3 : dat_buf = 0x0015; break;
		case 4 : dat_buf = 0x0055; break;
		case 5 : dat_buf = 0x00C5; break;
		case 6 : dat_buf = 0x0019; break;
		case 7 : dat_buf = 0x0059; break;
		case 8 : dat_buf = 0x00C9; break;
		case 9 : dat_buf = 0x001A; break;
		case 10 : dat_buf = 0x005A; break;
		case 11 : dat_buf = 0x00CA; break;
	}

	switch(channel)
	{
		case 1:
		{
			adr_buf = 0x70000000;		// channel 1 = address 7 (hardware)

            // Set AC Bits
            dat_buf = dat_buf & 0xF0DF;

	        if (MenuStatus[1][0] == 8) dat_buf = dat_buf | 0x0100;
            if (MenuStatus[2][0] == 8) dat_buf = dat_buf | 0x0200;
            if (MenuStatus[3][0] == 8) dat_buf = dat_buf | 0x0400;
            if (MenuStatus[4][0] == 8) dat_buf = dat_buf | 0x0800;	

            // BW Limit
            if (MenuStatus[1][1] == 241) dat_buf = dat_buf | 0x0020;

			SwitchesCH1 = dat_buf;
			
			VoltageChangedCh1 = 1;
#ifdef _Debug_			
			if (Debug_Mode) printf("Switches : %x , erg : %x \n", SwitchesCH1, (adr_buf | SwitchesCH1));
#endif			
			break;	
		}
		case 2:
		{
			adr_buf = 0x50000000;		// channel 2 = address 5 (hardware)
						
			dat_buf = dat_buf & 0xFFDF;
			if (MenuStatus[2][1] == 241) dat_buf = dat_buf | 0x0020;
			
			SwitchesCH2 = dat_buf;
            			
			VoltageChangedCh2 = 1;
#ifdef _Debug_			
			if (Debug_Mode) printf("Switches : %x , erg : %x \n", SwitchesCH2, (adr_buf | SwitchesCH2));
#endif			
			break;	
		}
		case 3:
		{
			adr_buf = 0x10000000;		// channel 3 = address 4 (hardware)
					
			dat_buf = dat_buf & 0xFFDF;
			if (MenuStatus[3][1] == 241) dat_buf = dat_buf | 0x0020;
			
			SwitchesCH3 = dat_buf;
            			
			VoltageChangedCh3 = 1;
#ifdef _Debug_			
			if (Debug_Mode) printf("Switches : %x , erg : %x \n", SwitchesCH3, (adr_buf | SwitchesCH3));
#endif			
			break;	
		}
		case 4:
		{
			adr_buf = 0x30000000;		// channel 4 = address 3 (hardware)
				
            dat_buf = dat_buf & 0xFFDF;	
			if (MenuStatus[4][1] == 241) dat_buf = dat_buf | 0x0020;
			
			SwitchesCH4 = dat_buf;
            			
			VoltageChangedCh4 = 1;
#ifdef _Debug_			
			if (Debug_Mode) printf("Switches : %x , erg : %x \n", SwitchesCH4, (adr_buf | SwitchesCH4));
#endif			
			break;	
		}		
		case 5:
		{
			adr_buf = 0x20000000;		// trigger channel = address 2 (hardware)
			
			SwitchesTB = voltage;
#ifdef _Debug_			
			if (Debug_Mode) printf("Switches : %x , erg : %x \n", SwitchesTB, (adr_buf | SwitchesTB));
#endif			
			break;	
		}				
	}

	switch(channel)
	{
		case 1: outbuf = adr_buf | SwitchesCH1; break;
		case 2: outbuf = adr_buf | SwitchesCH2; break;
		case 3: outbuf = adr_buf | SwitchesCH3; break;
		case 4: outbuf = adr_buf | SwitchesCH4; break;
		case 5: outbuf = adr_buf | SwitchesTB; break;		
		case 6: outbuf = 0xFFFFFFFF; break;		
		case 7: outbuf = 0x00000000; break;				
	}	
#ifdef _Debug_		
    if (Debug_Mode) printf("outbuf1 : %x\n", outbuf);
#endif       		
    serdata->np_piodata = outbuf;//TurnBits(outbuf);
	
	serstartsw->np_piodata = 1;
	serstartsw->np_piodata = 0;	
		
	nr_delay(15);

	switch(channel)
	{
		case 1: outbuf = (adr_buf | SwitchesCH1) & 0xFFFFFFF0; break;
		case 2: outbuf = (adr_buf | SwitchesCH2) & 0xFFFFFFF0; break;
		case 3: outbuf = (adr_buf | SwitchesCH3) & 0xFFFFFFF0; break;
		case 4: outbuf = (adr_buf | SwitchesCH4) & 0xFFFFFFF0; break;
	}		
#ifdef _Debug_
    if (Debug_Mode) printf("outbuf2 : %x\n", outbuf);
#endif
    if ((channel > 0) && (channel < 5))
    {
        serdata->np_piodata = outbuf;//TurnBits(outbuf);	
	
	   serstartsw->np_piodata = 1;
	   serstartsw->np_piodata = 0;	

	   nr_delay(15);
    }
#ifdef _Debug_	
	if (Debug_Mode)
    {
	    switch(channel)
	    {	
		    case 1: printf("Switches : %x , erg : %x\n", SwitchesCH1, (adr_buf | SwitchesCH1) & 0xFFFFFFF0); break;
		    case 2: printf("Switches : %x , erg : %x\n", SwitchesCH2, (adr_buf | SwitchesCH2) & 0xFFFFFFF0); break;
		    case 3: printf("Switches : %x , erg : %x\n", SwitchesCH3, (adr_buf | SwitchesCH3) & 0xFFFFFFF0); break;
		    case 4: printf("Switches : %x , erg : %x\n", SwitchesCH4, (adr_buf | SwitchesCH4) & 0xFFFFFFF0); break;
		    case 5: printf("Switches : %x , erg : %x\n", SwitchesTB, (adr_buf | SwitchesTB) & 0xFFFFFFFF); break;
	    }
    }
#endif					
//	nr_delay(1);
		
	switch(channel)
	{	
		case 1: SwitchesCH1Old = SwitchesCH1; break;
		case 2: SwitchesCH2Old = SwitchesCH2; break;
		case 3: SwitchesCH3Old = SwitchesCH3; break;
		case 4: SwitchesCH4Old = SwitchesCH4; break;
	}
}

void Hardware::SetDacOffset(char channel)
{
	long CalcBufInt = 0;	
	long BufInt = 0;
	long BufInt2 = 0;	
	long outbuf = 0x00000000;		


	switch(channel)
	{
		case 1 :	//if (CH1_DAC_Offset != CH1_DAC_OffsetOld)
					{
						BufInt = CH1_DAC_Offset;
						BufInt2 = (0x00310000 | (BufInt * 4));


						// Bei gelegenheit gegen Turnbits tauschen
						outbuf = (0x60000000 | BufInt2);
						
						serdata->np_piodata = outbuf;
						
						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
										
						nr_delay(5);						
					}	
					break;	
					
		case 2 :	//if (CH2_DAC_Offset != CH2_DAC_OffsetOld)
					{
						BufInt = CH2_DAC_Offset;
						BufInt2 = (0x00300000 | (BufInt * 4));						

                        outbuf = (0x60000000 | BufInt2);
						
						serdata->np_piodata = outbuf;
						
						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
										
						nr_delay(5);						
					}	
					break;	
					
		case 3 :	//if (CH3_DAC_Offset != CH3_DAC_OffsetOld)
					{
						BufInt = CH3_DAC_Offset;
						BufInt2 = (0x00310000 | (BufInt * 4));	
						
                        outbuf = (0x40000000 | BufInt2);
						
						serdata->np_piodata = outbuf;
						
						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
										
						nr_delay(5);						
					}	
					break;	
					
		case 4 :	//if (CH4_DAC_Offset != CH4_DAC_OffsetOld)
					{
						BufInt = CH4_DAC_Offset;
						BufInt2 = (0x00300000 | (BufInt * 4));						

                        outbuf = (0x40000000 | BufInt2);
						
						serdata->np_piodata = outbuf;
						
						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
										
						nr_delay(5);						
					}	
					break;	
	}											
#ifdef _Debug_
	if (Debug_Mode) printf("ch : %d cb : %x bi : %x bi2 : %x  ob : %x \n", channel, CalcBufInt, BufInt, BufInt2, outbuf);
#endif
}

void Hardware::SetCHDacOffset(char channel)
{
	switch(channel)
	{
		case 1 : 	//if (CH1_DAC_1 != CH1_DAC_1Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH1_DAC_1 | 0x0600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	

						nr_delay(1);
					}

					//if (CH1_DAC_2 != CH1_DAC_2Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH1_DAC_2 | 0x1600; //0x0E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
										
					//if (CH1_DAC_3 != CH1_DAC_3Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH1_DAC_3 | 0x1E00; //0x1600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
				
					//if (CH1_DAC_4 != CH1_DAC_4Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH1_DAC_4 | 0x2600; //0x1E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);	
					}
					
					break;														
															
		case 2 : 	//if (CH2_DAC_1 != CH2_DAC_1Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH2_DAC_1 | 0x0E00; //0x2600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}	
						
					//if (CH2_DAC_2 != CH2_DAC_2Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH2_DAC_2 | 0x3E00; //0x2E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}				

					//if (CH2_DAC_3 != CH2_DAC_3Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH2_DAC_3 | 0x3600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
						
					//if (CH2_DAC_4 != CH2_DAC_4Old)
				 	{
						serdata->np_piodata = 0x80000000 | CH2_DAC_4 | 0x2E00; //0x3E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
										
					break;

		case 3 : 	//if (CH3_DAC_1 != CH3_DAC_1Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH3_DAC_1 | 0x0600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	

						nr_delay(1);		
					}			

					//if (CH3_DAC_2 != CH3_DAC_2Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH3_DAC_2 | 0x0E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
										
					//if (CH3_DAC_3 != CH3_DAC_3Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH3_DAC_3 | 0x1600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
				
					//if (CH3_DAC_4 != CH3_DAC_4Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH3_DAC_4 | 0x1E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);	
					}
					
					break;														
															
		case 4 : 	//if (CH4_DAC_1 != CH4_DAC_1Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH4_DAC_1 | 0x2600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);	
					}
						
					//if (CH4_DAC_2 != CH4_DAC_2Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH4_DAC_2 | 0x2E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}				

					//if (CH4_DAC_3 != CH4_DAC_3Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH4_DAC_3 | 0x3600;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
						
					//if (CH4_DAC_4 != CH4_DAC_4Old)
				 	{
						serdata->np_piodata = 0x90000000 | CH4_DAC_4 | 0x3E00;

						serstartsw->np_piodata = 1;
						serstartsw->np_piodata = 0;	
						
						nr_delay(1);
					}
										
					break;					
					
	}	
}

void Hardware::SetupADC(void)
{
	mode->np_piodata = 0x01;
		
	if (triggering == 0) WRITEADC(1, (ctrl_reg | 0x0001) + (adc_ctrl_reg << 16));																		
	else if(triggering == 1) WRITEADC(1, ctrl_reg + (adc_ctrl_reg << 16));
	else WRITEADC(1, (ctrl_reg & 0xFFFE) + (adc_ctrl_reg << 16));					

	WRITEADC(1, timebase_reg);
	
	WRITEADC(1, pre_reg + (channel_Adr_add << 16));
    	
	WRITEADC(1, trg_val_CHI_reg + (trg_val_CHII_reg << 8) + (trig_range_reg << 16));
	WRITEADC(1, (0xFFFFFFFF - trig_holdoff_reg));    	
	WRITEADC(1, trig_width_reg + (GridColor_Val << 26));
	WRITEADC(1, adc_change12_reg);
	
	WRITEADC(1, adc_ctr12_reg);

	mode->np_piodata = 0x00;
						
	if (NumberOfChannels == 4)
	{
        mode->np_piodata = 0x01;
                            				
        if(triggering == 3) WRITEADC(3, ctrl_reg + (adc_ctrl_reg << 16));
        else WRITEADC(3, (ctrl_reg & 0xFFFE) + (adc_ctrl_reg << 16));

        WRITEADC(3, timebase_reg);
	
        WRITEADC(3, pre_reg + (channel_Adr_add2 << 16));
	
        WRITEADC(3, trg_val_CHIII_reg + (trg_val_CHIV_reg << 8) + (trig_range_reg << 16));	
        WRITEADC(3, (0xFFFFFFFF - trig_holdoff_reg));
        WRITEADC(3, trig_width_reg + (GridColor_Val << 26));
        WRITEADC(3, adc_change34_reg);

        WRITEADC(3, adc_ctr12_reg);

        mode->np_piodata = 0x00;
    }
#ifdef _Debug_	
	if (Debug_Mode) printf("ctr %x actr %x tb %x pr %x tv1 %x tv2 %x tv1 %x tv2 %x trr %x trw %x cha %x adcch12 %x adcch34 %x adcctr12 %x adcctr34 %x\n", ctrl_reg, adc_ctrl_reg, timebase_reg, pre_reg, trg_val_CHI_reg, trg_val_CHII_reg, trg_val_CHIII_reg, trg_val_CHIV_reg, trig_range_reg, trig_width_reg, channel_Adr_add, adc_change12_reg, adc_change34_reg, adc_ctr12_reg, adc_ctr34_reg);
#endif
}

void Hardware::WRITEADC(unsigned char which, unsigned long value)
{	
	switch(which)
	{
		case 1 :
				asm("		
						MOV		%r0,%i1											; Address of Buffer
						PFX		%hi(0x00A00000)
						MOVI	%l0,%lo(0x00A00000)
						PFX		%xhi(0x00A00000)
						MOVHI	%l0,%xlo(0x00A00000)				
			
						ST		[%l0], %r0		
					");	
				break;
		case 2 :
				asm("		
						MOV		%r0,%i1											; Address of Buffer
						PFX		%hi(0x00A00010)
						MOVI	%l0,%lo(0x00A00010)
						PFX		%xhi(0x00A00010)
						MOVHI	%l0,%xlo(0x00A00010)				
			
						ST		[%l0], %r0		
					");	
				break;
		case 3 :
				asm("		
						MOV		%r0,%i1											; Address of Buffer
						PFX		%hi(0x00A00020)
						MOVI	%l0,%lo(0x00A00020)
						PFX		%xhi(0x00A00020)
						MOVHI	%l0,%xlo(0x00A00020)				
			
						ST		[%l0], %r0		
					");	
				break;
		case 4 :
				asm("		
						MOV		%r0,%i1											; Address of Buffer
						PFX		%hi(0x00A00030)
						MOVI	%l0,%lo(0x00A00030)
						PFX		%xhi(0x00A00030)
						MOVHI	%l0,%xlo(0x00A00030)				
			
						ST		[%l0], %r0		
					");	
				break;
	}
}

unsigned long Hardware::READADC(unsigned char which)
{
	switch(which)
	{
		case 1 :
				asm("		
						PFX		%hi(0x00A00000)
						MOVI	%l0,%lo(0x00A00000)
						PFX		%xhi(0x00A00000)
						MOVHI	%l0,%xlo(0x00A00000)				
		
						LD		%r0,[%l0]	
		
						MOV		%i0, %r0
					");	
				break;
		case 2 :
				asm("		
						PFX		%hi(0x00A00010)
						MOVI	%l0,%lo(0x00A00010)
						PFX		%xhi(0x00A00010)
						MOVHI	%l0,%xlo(0x00A00010)				
		
						LD		%r0,[%l0]	
		
						MOV		%i0, %r0	
					");	
				break;
		case 3 :
				asm("		
						PFX		%hi(0x00A00020)
						MOVI	%l0,%lo(0x00A00020)
						PFX		%xhi(0x00A00020)
						MOVHI	%l0,%xlo(0x00A00020)				
		
						LD		%r0,[%l0]	
		
						MOV		%i0, %r0	
					");	
				break;
		case 4 :
				asm("		
						PFX		%hi(0x00A00030)
						MOVI	%l0,%lo(0x00A00030)
						PFX		%xhi(0x00A00030)
						MOVHI	%l0,%xlo(0x00A00030)				
		
						LD		%r0,[%l0]	
		
						MOV		%i0, %r0	
					");	
				break;
	}
}	

void Hardware::PREPARE_READADC(unsigned char correct1, unsigned char correct2, unsigned char correct3, unsigned char correct4, unsigned int count)
{
    asm("
            MOV		%r3, %i0
            MOV		%r4, %i1
            MOV		%r5, %i2
            MOV		%r6, %i3
            MOV		%r7, %i4
        ");
}
/*
void Hardware::READADC_ALL(unsigned char which, unsigned char *DataArray1, unsigned char inverse, unsigned int zero, unsigned char averageval, unsigned char highspeed)
{
    asm("
            MOV		%l1, %r7               ; set address offset memory 2

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow                ; jump to slow tb configuration
            NOP                   									

            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x0001)
            ADDI    %l4, %lo(0x0001);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x0002)
            ADDI    %l5, %lo(0x0002);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x0003)
            ADDI    %l6, %lo(0x0003);

            BR      lpr_channel
            NOP

        lpr_slow:
            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x1000)
            ADDI    %l4, %lo(0x1000);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x2000)
            ADDI    %l5, %lo(0x2000);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x3000)
            ADDI    %l6, %lo(0x3000);

      lpr_channel:

            CMPI    %i0, 0x01               ; Is it channel 1
            IFS     cc_z
            BR      lpr1ch1
            NOP

            CMPI    %i0, 0x02               ; Is it channel 2
            IFS     cc_z
            BR      lpr1ch2
            NOP

            CMPI    %i0, 0x03               ; Is it channel 3
            IFS     cc_z
            BR      lpr1ch3
            NOP

            CMPI    %i0, 0x04               ; Is it channel 4
            IFS     cc_z
            BR      lpr1ch4
            NOP

        lpr1ch1:
            PFX     %hi(0x00A00000)         ; load address channel 1
            MOVI	%l0,%lo(0x00A00000)
            PFX		%xhi(0x00A00000)
            MOVHI	%l0,%xlo(0x00A00000)
            BR      lpr1
            NOP

        lpr1ch2:
            PFX     %hi(0x00A00010)         ; load address channel 2
            MOVI	%l0,%lo(0x00A00010)
            PFX		%xhi(0x00A00010)
            MOVHI	%l0,%xlo(0x00A00010)
            BR      lpr1
            NOP

        lpr1ch3:
            PFX     %hi(0x00A00020)         ; load address channel 3
            MOVI	%l0,%lo(0x00A00020)
            PFX		%xhi(0x00A00020)
            MOVHI	%l0,%xlo(0x00A00020)
            BR      lpr1
            NOP

        lpr1ch4:
            PFX     %hi(0x00A00030)         ; load address channel 4
            MOVI	%l0,%lo(0x00A00030)
            PFX		%xhi(0x00A00030)
            MOVHI	%l0,%xlo(0x00A00030)
                       						                       		
        lpr1:
            LD		%l2, [%l0]
            NOT     %l2	
                       						
            ; start mem 1			
            MOV		%r0, %l2  							

            EXT8S	%r0, 0
						
            IFRZ      %i2                 ; inverting
            BR        lpr1s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr1i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr1s
            NOP								
						
        lpr1i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(0)
            MOVI      %r2, %lo(0)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr1s:
      						
            IFRZ      %i4                 ; is average = 0
            BR        lpr1e
            NOP						
	
            ; start averaging

            LD        %l7, [%i1]          ; save old value
            EXT8D     %l7, %i1            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr1a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr1e
            NOP	
						
        lpr1a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr1e:							
            SUB     %r0, %r3	

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%i1], %r0          					
												
            ; start mem 2		
            MOV		%r0, %l2  							

            EXT8S	%r0, 1
						
            IFRZ      %i2                 ; inverting
            BR        lpr2s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr2i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr2s
            NOP								
						
        lpr2i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr2s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr2e
            NOP						
	
            ; start averaging

            LD        %l7, [%l4]          ; save old value
            EXT8D     %l7, %l4            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr2a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr2e
            NOP	
						
        lpr2a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr2e:							
			SUB     %r0, %r4
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l4], %r0

            ; start mem 3								
            MOV     %r0, %l2  							

            EXT8S	%r0, 2
						
            IFRZ    %i2                 ; inverting
            BR      lpr3s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr3i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr3s
            NOP								
						
        lpr3i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr3s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr3e
            NOP						
	
            ; start averaging

            LD        %l7, [%l5]          ; save old value
            EXT8D     %l7, %l5            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr3a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr3e
            NOP	
						
        lpr3a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr3e:							
            SUB     %r0, %r5

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%l5], %r0
						
            ; start mem 4								
            MOV		%r0, %l2  							

            EXT8S	%r0, 3
						
            IFRZ      %i2                 ; inverting
            BR        lpr4s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr4i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)	; (0) ???	
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr4s
            NOP								
						
        lpr4i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr4s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr4e
            NOP						
	
            ; start averaging

            LD        %l7, [%l6]          ; save old value
            EXT8D     %l7, %l6            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr4a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr4e
            NOP	
						
        lpr4a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr4e:							
			SUB     %r0, %r6
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l6], %r0

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow_ac             ; jump to slow address calculaten
            NOP
						
            ; calc new adresses
            ADDI   %i1, 4                            ; Add Address Counter
            ADDI   %l4, 4                            ; Add Address Counter
            ADDI   %l5, 4                            ; Add Address Counter
            ADDI   %l6, 4                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP	

            BR     lprend
            NOP	


        lpr_slow_ac:
            ; calc new adresses
            ADDI   %i1, 1                            ; Add Address Counter
            ADDI   %l4, 1                            ; Add Address Counter
            ADDI   %l5, 1                            ; Add Address Counter
            ADDI   %l6, 1                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP

        lprend:					
							
    ");
}
*/

/* Test Plain
void Hardware::READADC_ALL(unsigned char which, unsigned char *DataArray1, unsigned char inverse, unsigned int zero, unsigned char averageval, unsigned char highspeed)
{
    asm("
            MOV		%l1, %r7               ; set address offset memory 2

            PFX     %hi(0x00917440)         ; load address channel
            MOVI	%l0,%lo(0x00917440)
            PFX		%xhi(0x00917440)
            MOVHI	%l0,%xlo(0x00917440)

        lpr1:
            LD		%l2, [%l0]
            MOV		%r0, %l2  							
            ST      [%i1], %r0          					

            ADDI   %l0, 4                            ; Add Address Counter
            ADDI   %i1, 4                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP	
					
							
    ");
}
*/
/**
void Hardware::READADC_ALL(unsigned char which, unsigned char *DataArray1, unsigned char inverse, unsigned int zero, unsigned char averageval, unsigned char highspeed)
{
    asm("
            MOV		%l1, %r7               ; set address offset memory 2

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow                ; jump to slow tb configuration
            NOP                   									

            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x0001)
            ADDI    %l4, %lo(0x0001);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x0002)
            ADDI    %l5, %lo(0x0002);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x0003)
            ADDI    %l6, %lo(0x0003);

            BR      lpr_channel
            NOP

        lpr_slow:
            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x1000)
            ADDI    %l4, %lo(0x1000);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x2000)
            ADDI    %l5, %lo(0x2000);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x3000)
            ADDI    %l6, %lo(0x3000);

      lpr_channel:


            PFX     %hi(0x00917440)         ; load address channel
            MOVI	%l0,%lo(0x00917440)
            PFX		%xhi(0x00917440)
            MOVHI	%l0,%xlo(0x00917440)


                       						                       		
        lpr1:
            LD		%l2, [%l0]
            NOT     %l2	
                       						
            ; start mem 1			
            MOV		%r0, %l2  							

            EXT8S	%r0, 0
        					
            SUB     %r0, %r3	

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%i1], %r0          					
												
            ; start mem 2		
            MOV		%r0, %l2  							

            EXT8S	%r0, 1
            						
			SUB     %r0, %r4
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l4], %r0

            ; start mem 3								
            MOV     %r0, %l2  							

            EXT8S	%r0, 2
												
            SUB     %r0, %r5

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%l5], %r0
						
            ; start mem 4								
            MOV		%r0, %l2  							

            EXT8S	%r0, 3
											
			SUB     %r0, %r6
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l6], %r0


            ADDI   %l0, 4                            ; Add Address Counter

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow_ac             ; jump to slow address calculaten
            NOP
						
            ; calc new adresses
            ADDI   %i1, 4                            ; Add Address Counter
            ADDI   %l4, 4                            ; Add Address Counter
            ADDI   %l5, 4                            ; Add Address Counter
            ADDI   %l6, 4                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP	

            BR     lprend
            NOP	


        lpr_slow_ac:
            ; calc new adresses
            ADDI   %i1, 1                            ; Add Address Counter
            ADDI   %l4, 1                            ; Add Address Counter
            ADDI   %l5, 1                            ; Add Address Counter
            ADDI   %l6, 1                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP

        lprend:					
							
    ");
}
**/


void Hardware::READADC_ALL(unsigned char which, unsigned char *DataArray1, unsigned char inverse, unsigned int zero, unsigned char averageval, unsigned char highspeed)
{
    asm("
                     PFX	%hi(0xFEFEFEFE)                   ; Set MASK
                     MOVI	%r10,%lo(0xFEFEFEFE)
                     PFX	%xhi(0xFEFEFEFE)
                     MOVHI	%r10,%xlo(0xFEFEFEFE)

           MOV		%l1, %r7               ; set address offset memory 2

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow                ; jump to slow tb configuration
            NOP                   									

            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x0001)
            ADDI    %l4, %lo(0x0001);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x0002)
            ADDI    %l5, %lo(0x0002);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x0003)
            ADDI    %l6, %lo(0x0003);

            BR      lpr_channel
            NOP

        lpr_slow:
            MOV		%l4, %i1               ; set address offset memory 2
            PFX     %hi(0x1000)
            ADDI    %l4, %lo(0x1000);
						
            MOV		%l5, %i1               ; set address offset memory 3
            PFX     %hi(0x2000)
            ADDI    %l5, %lo(0x2000);
						
            MOV		%l6, %i1               ; set address offset memory 4
            PFX     %hi(0x3000)
            ADDI    %l6, %lo(0x3000);

      lpr_channel:


            PFX     %hi(0x00917440)         ; load address channel
            MOVI	%l0,%lo(0x00917440)
            PFX		%xhi(0x00917440)
            MOVHI	%l0,%xlo(0x00917440)


                       						                       		
        lpr1:
            LD		%l2, [%l0]
            NOT     %l2	
            ;AND		%l2,%r10
           						
            ; start mem 1			
            MOV		%r0, %l2  							

            EXT8S	%r0, 0
						
            IFRZ      %i2                 ; inverting
            BR        lpr1s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr1i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr1s
            NOP								
						
        lpr1i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(0)
            MOVI      %r2, %lo(0)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr1s:
      						
            IFRZ      %i4                 ; is average = 0
            BR        lpr1e
            NOP						
	
            ; start averaging

            LD        %l7, [%i1]          ; save old value
            EXT8D     %l7, %i1            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr1a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr1e
            NOP	
						
        lpr1a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr1e:							
            SUB     %r0, %r3	

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%i1], %r0          					
												
            ; start mem 2		
            MOV		%r0, %l2  							

            EXT8S	%r0, 1
						
            IFRZ      %i2                 ; inverting
            BR        lpr2s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr2i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr2s
            NOP								
						
        lpr2i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr2s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr2e
            NOP						
	
            ; start averaging

            LD        %l7, [%l4]          ; save old value
            EXT8D     %l7, %l4            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr2a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr2e
            NOP	
						
        lpr2a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr2e:							
			SUB     %r0, %r4
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l4], %r0

            ; start mem 3								
            MOV     %r0, %l2  							

            EXT8S	%r0, 2
						
            IFRZ    %i2                 ; inverting
            BR      lpr3s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr3i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)		
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr3s
            NOP								
						
        lpr3i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr3s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr3e
            NOP						
	
            ; start averaging

            LD        %l7, [%l5]          ; save old value
            EXT8D     %l7, %l5            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr3a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr3e
            NOP	
						
        lpr3a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr3e:							
            SUB     %r0, %r5

            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)	
						
            FILL8	%r0, %r0
            ST8D	[%l5], %r0
						
            ; start mem 4								
            MOV		%r0, %l2  							

            EXT8S	%r0, 3
						
            IFRZ      %i2                 ; inverting
            BR        lpr4s
            NOP						
						
            ; start inverting
						
            CMP       %r0, %i3            ; is Vnew > ZL
            IFS       cc_nc
            BR        lpr4i
            NOP						
						
            ; Vnew < ZeroLevel
						
            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r2, %r0            ; ZL - Vnew = Vcalc0						
            ADD       %r2, %i3            ; Vcalc0 + ZL = Vcalc1
						
            PFX       %hi(255)
            CMPI      %r2, %lo(255)
            IFS       cc_nc
            PFX       %hi(255)
            MOVI      %r2, %lo(255)	; (0) ???	
						
            MOV       %r0, %r2            ; store result
                        						
            BR        lpr4s
            NOP								
						
        lpr4i:

            MOV       %r2, %i3            ; store ZeroLevel							
            SUB       %r0, %r2            ; Vnew - ZL = Vcalc0						
            SUB       %r2, %r0            ; ZL - Vcalc0 = Vcalc1
            IFS       cc_v						
            PFX       %hi(255)
            MOVI      %r2, %lo(255)								
						
            MOV       %r0, %r2            ; store result

            ; end inverting						
						
						
        lpr4s:
                    						
            IFRZ      %i4                 ; is average = 0
            BR        lpr4e
            NOP						
	
            ; start averaging

            LD        %l7, [%l6]          ; save old value
            EXT8D     %l7, %l6            ; extract byte

            CMP       %r0, %l7
            IFS       cc_nc
            BR        lpr4a						
            NOP
						
            ; Vnew < ZL

            MOV       %r2, %l7            ; store Vold	
            SUB       %r2, %r0            ; Vold - Vnew = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1
            SUB       %l7, %r2            ; Vold - Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0

            BR        lpr4e
            NOP	
						
        lpr4a:
                	
            ; Vnew > ZL
						
            MOV       %r2, %r0            ; store Vnew	
            SUB       %r2, %l7            ; Vnew - Vold = Vcalc0
            LSR       %r2, %i4            ; Vcalc0 >> avg = Vcalc1						
            ADD       %l7, %r2            ; Vold + Vcalc1 = Vcalc2

            MOV       %r0, %l7            ; store result in r0
						
        lpr4e:							
			SUB     %r0, %r6
			
            IFS     cc_n
            PFX     %hi(0)
            MOVI    %r0, %lo(0)			
            			
            FILL8	%r0, %r0
            ST8D	[%l6], %r0


            ADDI   %l0, 4                            ; Add Address Counter

            IFRZ    %i5                     ; highspeeed timebases?
            BR      lpr_slow_ac             ; jump to slow address calculaten
            NOP
						
            ; calc new adresses
            ADDI   %i1, 4                            ; Add Address Counter
            ADDI   %l4, 4                            ; Add Address Counter
            ADDI   %l5, 4                            ; Add Address Counter
            ADDI   %l6, 4                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP	

            BR     lprend
            NOP	


        lpr_slow_ac:
            ; calc new adresses
            ADDI   %i1, 1                            ; Add Address Counter
            ADDI   %l4, 1                            ; Add Address Counter
            ADDI   %l5, 1                            ; Add Address Counter
            ADDI   %l6, 1                            ; Add Address Counter
                        	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1	
            NOP

        lprend:					
							
    ");
}

void Hardware::READADC_ALL2(unsigned char which, unsigned long *DataArray1, unsigned int count)
{
    asm("
            CMPI    %i0, 0x01               ; Is it channel 1
            IFS     cc_z
            BR      lpr1ch1n
            NOP

            CMPI    %i0, 0x02               ; Is it channel 2
            IFS     cc_z
            BR      lpr1ch2n
            NOP

            CMPI    %i0, 0x03               ; Is it channel 3
            IFS     cc_z
            BR      lpr1ch3n
            NOP

            CMPI    %i0, 0x04               ; Is it channel 4
            IFS     cc_z
            BR      lpr1ch4n
            NOP

        lpr1ch1n:
            PFX     %hi(0x00A00000)         ; load address channel 1
            MOVI	%l0,%lo(0x00A00000)
            PFX		%xhi(0x00A00000)
            MOVHI	%l0,%xlo(0x00A00000)
            BR      lpr1n
            NOP

        lpr1ch2n:
            PFX     %hi(0x00A00010)         ; load address channel 2
            MOVI	%l0,%lo(0x00A00010)
            PFX		%xhi(0x00A00010)
            MOVHI	%l0,%xlo(0x00A00010)
            BR      lpr1n
            NOP

        lpr1ch3n:
            PFX     %hi(0x00A00020)         ; load address channel 3
            MOVI	%l0,%lo(0x00A00020)
            PFX		%xhi(0x00A00020)
            MOVHI	%l0,%xlo(0x00A00020)
            BR      lpr1n
            NOP

        lpr1ch4n:
            PFX     %hi(0x00A00030)         ; load address channel 4
            MOVI	%l0,%lo(0x00A00030)
            PFX		%xhi(0x00A00030)
            MOVHI	%l0,%xlo(0x00A00030)
                       						                       		
        lpr1n:
            LD		%l2, [%l0]
                       								
            MOV		%r0, %l2  	

            ST  	[%i1], %r0
						
            ; calc new adresses
            ADDI   %i1, 4                            ; Add Address Counter
                        	
            SUBI   %i2, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     lpr1n	
            NOP

							
    ");
}

unsigned char Hardware::EXTRACTADCVAL(unsigned char which, unsigned long value)
{
	switch(which)
	{
		case 1 :
				asm("		
						MOV		%r0,%i1
						EXT8S	%r0,3
						MOV		%i0, %r0					
					");	
				break;
		case 2 :
				asm("		
						MOV		%r0,%i1
						EXT8S	%r0,2
						MOV		%i0, %r0						
					");	
				break;
		case 3 :
				asm("		
						MOV		%r0,%i1
						EXT8S	%r0,1
						MOV		%i0, %r0
					");	
				break;
		case 4 :
				asm("		
						MOV		%r0,%i1
						EXT8S	%r0,0
						MOV		%i0, %r0
					");	
				break;
	}												
}

void Hardware::DoEnableADCInterrupt(void)							// Enable ADC service routine
{
	acq_ready->np_pioedgecapture = 0x00; 							// clear existing IRQ conditions
	acq_ready->np_piodirection = 0;									// set bit to input
	acq_ready->np_piointerruptmask = 0x01;							// enable interrupt

	nr_installuserisr(na_data_acq_interrupt_irq,ISR_ADC_INT,(int)acq_ready);		// Install ISR for ADC
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nADC interrupt enabled.\n"); 							// print on console
#endif
}

void Hardware::DoDisableADCInterrupt(void)							// Disable ADC service routine
{
	
	nr_installuserisr(na_data_acq_interrupt_irq,0,0); 				// Install empty routine for adc irq
	acq_ready->np_piointerruptmask = 0x00;							// disable all IRQs
	
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nADC interrupt disabled.\n"); 							// print on console
#endif	
}

void Hardware::ISR_ADC_INT(int context)						// ADC interrupt subroutine
{
    long buffer;
    int ix2;

    tc_test_var2++;

    adc_started = false;

	acq_ready->np_pioedgecapture = 0;

    ADC_Data_Available = 1;
}

int Hardware::Read_IRQ(void)
{
    return acq_ready->np_piodata;
}

void Hardware::Handle_ADC(void)						// ADC interrupt subroutine
{
    int chk_calc = 0;
    unsigned char chk_sum = 0;
    unsigned long ldataa = 0;
    unsigned long lzeroa = 0;
    unsigned long ldiva = 0;
    unsigned long loffseta = 0;
    unsigned long ltempa = 0;
    unsigned long ldatab = 0;
    unsigned long lzerob = 0;
    unsigned long ldivb = 0;
    unsigned long loffsetb = 0;
    unsigned long ltempb = 0;
    unsigned long loffset = 0;
    unsigned long loffset_neg_tag = 0;
    unsigned long lprefix = 0;
    int bufdata = 0;
out_test->np_piodata = 0x01;	// Testbit+++++++++++++++++++++++
	volatile long buffer_addr = 0;	
	volatile long buffer_peak = 0;	
	volatile long buffer_witten = 0;	
	volatile long buffer_long = 0;	
	volatile long buffer_adradd = 0;
	
	int channel_trig = 0;
	long ix, ix2, ix3, enddata = 0;

    //if (screen_sel != screen_sel_old) return;

	if (UserIface_active) return;
	
	
	if (ADC_Data_Available == 0) return;
    ADC_Data_Available = 0;
    
    if (Signal_Loaded) return;

    signal_zoomed1 = false;
    signal_zoomed2 = false;
    signal_zoomed3 = false;
    signal_zoomed4 = false;

	data_adr->np_piodata = 0x01;

    CH1_Zero_Offset = 0;
    CH2_Zero_Offset = 0;
    CH3_Zero_Offset = 0;
    CH4_Zero_Offset = 0;
out_test->np_piodata = 0x00;	// Testbit+++++++++++++++++++++++		
	if ((Selected_Trigger_Source == 3) || (Selected_Trigger_Source == 4))	
	{
		buffer_addr = READADC(3);
		buffer_peak = READADC(3);
	}
	else
	{
		buffer_addr = READADC(1);
		buffer_peak = READADC(1);
	}
	
	AutoFreeRun = false;
	
#ifdef _Debug_	
	if ((Debug_Mode) && (ADC_Debug_Mode)) printf("Peak %x \n", buffer_peak);
#endif

    if ((buffer_addr & 0x00001000) == 0x00001000)
    {
        if ((buffer_addr & 0x00000FFF) == 0x00000000)
        {
            // buffer_witten = (buffer_addr & 0x00000FFF) + ((pre_reg - 8) >> 1);
            if (Selected_Timebase < 9) buffer_witten = (buffer_addr & 0x00000FFF) + ((pre_reg - 8) >> 1);
            else buffer_witten = (buffer_addr & 0x00000FFF) + ((pre_reg - 8));
        }
        else
        {
            //buffer_witten = pre_reg >> 1;
            if (Selected_Timebase < 9) buffer_witten = pre_reg >> 1;
            else buffer_witten = pre_reg;
        }

        AutoFreeRun = true;
        
        //printf("Auto Free Run   RA : %4x  RW : %4x\n", buffer_addr, buffer_witten);
    }
    else if (Selected_Timebase < 7) buffer_witten = ((buffer_addr & 0x0FFF) - (pre_reg >> 1)) & 0x00000FFF;
    else buffer_witten = ((buffer_addr & 0x0FFF) - pre_reg) & 0x00000FFF;
   	 	
   	channel_trig = (buffer_addr & 0xC000) >> 14;
#ifdef _Debug_   	
   	if (Debug_Mode) printf("ChannelTrig %d\n", channel_trig);
#endif   	

#ifdef _Debug_
    if ((Debug_Mode) && (ADC_Debug_Mode)) printf("RTA : %x  WTA : %x PreReg %x\n", buffer_addr, buffer_witten, pre_reg);
#endif

    if (triggering)
    {
        buffer_long1 = buffer_witten;
        buffer_long2 = buffer_witten;
        buffer_long3 = buffer_witten;
        buffer_long4 = buffer_witten;
        buffer_addi = buffer_addr;
    }
    else
    {
        buffer_long1 = 0;
        buffer_long2 = 0;
        buffer_long3 = 0;
        buffer_long4 = 0;
        buffer_addi = 0;
    }

    if (NumberOfChannels < 4)
    {				
		if ((triggering != 0) || (Selected_Trigger_Source == 5))
		{
            WRITEADC(1, buffer_witten);
            WRITEADC(2, buffer_witten);
#ifdef _Debug_
			if ((Debug_Mode) && (ADC_Debug_Mode)) printf("Wr Tr ADR %x \n", buffer_witten);
#endif			
		}   /*
		else if (MenuStatus[10][2] == 1) // Rollmode
		{
			WRITEADC(1, buffer_adradd);
			WRITEADC(2, buffer_adradd);		
		}     */
		else
		{
			WRITEADC(1, ram_adress_reg + buffer_adradd);
			WRITEADC(2, ram_adress_reg + buffer_adradd);
         //   printf("Write FreeRun Address 0x00 \n");
		}
    }
    else
    {				
		if ((triggering != 0) || (Selected_Trigger_Source == 5))
		{		
            WRITEADC(1, buffer_witten);
            WRITEADC(2, buffer_witten);
            WRITEADC(3, buffer_witten);
            WRITEADC(4, buffer_witten);
#ifdef _Debug_
			if ((Debug_Mode) && (ADC_Debug_Mode)) printf("Wr Tr ADR %x \n", buffer_witten);
#endif			
		}          /*
		else if (MenuStatus[10][2] == 1) // Rollmode
		{
			WRITEADC(1, buffer_adradd);
			WRITEADC(2, buffer_adradd);		
			WRITEADC(3, buffer_adradd);
			WRITEADC(4, buffer_adradd);					
		}		     */
		else
		{
			WRITEADC(1, ram_adress_reg + buffer_adradd);
			WRITEADC(2, ram_adress_reg + buffer_adradd);
			WRITEADC(3, ram_adress_reg + buffer_adradd);
			WRITEADC(4, ram_adress_reg + buffer_adradd);
		//	printf("Write FreeRun Address 0x00 \n");
		}
    }
	
	data_adr->np_piodata = 0x00;
	
	
	if (Channel_1_Active == 1)
	{	
        ReadOut_Signal(1, buffer_addr & 0x3FFF, buffer_long1);
        ///if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate[0]);
        ///if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate_delayed[0]);

        //if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1[0]);
	}
	
	if (Channel_2_Active == 1)
	{	
        ReadOut_Signal(2, buffer_addr & 0x3FFF, buffer_long2);
        ///if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate[0]);

        //if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2[0]);
	}	
	
	if (NumberOfChannels > 2)
	{	
        if (Channel_3_Active == 1)
        {	
            ReadOut_Signal(3, buffer_addr & 0x3FFF, buffer_long3);
            //if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate[0]);
        }         	
	
	    if (Channel_4_Active == 1)
	    {		   	
            ReadOut_Signal(4, buffer_addr & 0x3FFF, buffer_long4);
            //if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate[0]);
        }
	}	

	if (Channel_Math_Active == 1)
	{
        // offset fehlt
        // loffsetb 0 = 24 1 = 24000 2 = 24000000 3 = 24000000000

        if (MenuStatus[26][2] == 1)
        {
            if (Math_Off_Mul_Value < 0)
            {
                loffseta = abs((int) Math_Off_Mul_Value);
                loffset_neg_tag = 1;
            }
            else loffseta = (int)  Math_Off_Mul_Value;

            if (Math_Off_Mul_Expo == 0) loffsetb = 2;
            else if (Math_Off_Mul_Expo == 1) loffsetb = 3;
            else if (Math_Off_Mul_Expo == 2) loffsetb = 4;
            else if (Math_Off_Mul_Expo == -1) loffsetb = 3;
            else if (Math_Off_Mul_Expo == -2) loffsetb = 4;

            if (Debug_Mode) printf("Val : %f Expo %d\n", Math_Off_Mul_Value, Math_Off_Mul_Expo);
        }
        else if (MenuStatus[26][3] == 1)
        {
            if (Math_Off_Sub_Value < 0)
            {
                loffseta = abs((int) Math_Off_Sub_Value);
                loffset_neg_tag = 1;
            }
            else loffseta = (int) Math_Off_Sub_Value;

            if (Math_Off_Sub_Expo == 0) loffsetb = 0;
            else if (Math_Off_Sub_Expo == 1) loffsetb = 1;
            else if (Math_Off_Sub_Expo == -1) loffsetb = 1;

            if (Debug_Mode) printf("Val : %f Expo %d\n", Math_Off_Sub_Value, Math_Off_Sub_Expo);
        }
        else if (MenuStatus[26][4] == 1)
        {
            if (Math_Off_Add_Value < 0)
            {
                loffseta = abs((int) Math_Off_Add_Value);
                loffset_neg_tag = 1;
            }
            else loffseta = (int) Math_Off_Add_Value;

            if (Math_Off_Add_Expo == 0) loffsetb = 0;
            else if (Math_Off_Add_Expo == 1) loffsetb = 1;
            else if (Math_Off_Add_Expo == -1) loffsetb = 1;

            if (Debug_Mode) printf("Val : %f Expo %d\n", Math_Off_Add_Value, Math_Off_Add_Expo);
        }
        else
        {
            loffseta = 1;
            loffsetb = 0;
        }

        lzeroa = ((ZeroLevelCH1 + 59) >> 1) << 8;
        ldiva = voltage_relevat[MenuStatus[1][3] - 104][Selected_Voltage_CH1 - 3] << 16;

        ltempa = lzeroa | ldiva | (loffseta << 21);

        lzerob = ((ZeroLevelCH2 + 59) >> 1) << 8;
        ldivb = voltage_relevat[MenuStatus[2][3] - 104][Selected_Voltage_CH2 - 3] << 16;

        ltempb = lzerob | ldivb | (loffsetb << 21);

        if (loffset_neg_tag == false) ltempb = ltempb | 0x80000000;

        if (Debug_Mode) printf("tempa : %8x tempb %8x\n", ltempa, ltempb);
  	
        if ((MenuStatus[26][1] == 1) && ((Channel_1_Active) || (Channel_2_Active)))                 // fft
        {
            if (UserIface_active_2 == false) Do_FFT();// return;
        }	
        else if ((MenuStatus[26][2] == 1) && ((Channel_1_Active) && (Channel_2_Active)))           // multiply
        {
            if (math_mul_scale == 166)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x020D, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 167)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x020E, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 168)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x020F, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 169)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0210, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 170)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0211, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 171)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0212, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 172)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0213, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 173)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0214, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 174)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0215, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 175)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0216, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 176)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0217, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 177)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0218, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 178)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0219, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 179)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x021A, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 180)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x021B, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_mul_scale == 181)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x021C, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
        }
        else if ((MenuStatus[26][3] == 1) && ((Channel_1_Active) && (Channel_2_Active)))            // subtract
        {
            if (math_sub_scale == 153)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0000, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 154)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0001, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 155)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0002, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 156)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0003, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 157)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0004, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 158)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0005, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 159)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0006, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 160)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0007, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 161)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0008, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 162)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0009, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 163)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x000A, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 164)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x000B, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_sub_scale == 165)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x000C, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
        }
        else if ((MenuStatus[26][4] == 1) && ((Channel_1_Active) && (Channel_2_Active)))            // add
        {
            if (math_add_scale == 153)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0400, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 154)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0401, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 155)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0402, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 156)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0403, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 157)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0404, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 158)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0405, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 159)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0406, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 160)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0407, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 161)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0408, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 162)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x0409, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 163)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x040A, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 164)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x040B, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
            else if (math_add_scale == 165)
            {
                for (ix2 = 10; ix2 < 16384; ix2++)
                {
                    bufdata = nm_math_pfx(0x040C, ltempa | SIGNAL1[ix2], ltempb | SIGNAL2[ix2 + 10]);
                    if ((bufdata & 0xF00) == 0x300) bufdata = 0;
                    else if ((bufdata & 0xF00) == 0xA00) bufdata = 255;
                    SIGNALM[ix2] = (bufdata & 0xFF);
                }
            }
        }      /*
        else if (MenuStatus[26][5] == 1)            // free
        {
            for (ix2 = 0; ix2 < 16384; ix2++)
            {
                SIGNALM[ix2] = (unsigned char) ((int) 127 + (((int) SIGNAL1[ix2] - ((ZeroLevelCH1 + (int) 60) >> 1)) - ((int) SIGNAL2[ix2] - ((ZeroLevelCH2 + (int) 60) >> 1))));
            }
        }    */
    }
    


    //if ((Selected_Timebase < 7) && ((Selected_Trigger_Source > 0) && (Selected_Trigger_Source < 5)) && (MenuStatus[10][2] == 0) && (AutoFreeRun == false))
    if ((Selected_Timebase < 7) && ((Selected_Trigger_Source > 0) && (Selected_Trigger_Source < 5)) && (AutoFreeRun == false))
    {
        //Trigger_Offset_Calc = 30 - ((Trigger_Offset_Pos + 30) - FindTrigger(Selected_Trigger_Source, MenuStatus[14][0] - 2, Trigger_Offset_Pos + 30));
        //Trigger_Offset_Calc = 5 - (((int)((float) Trig_Pos_Mem / ZFT_float) + 50) - FindTrigger(Selected_Trigger_Source, MenuStatus[14][0] - 2, (int)((float) Trig_Pos_Mem / ZFT_float) + 50));

        Trigger_Offset_Calc = 15 - ((Trig_Pos_Mem + 50) - FindTrigger(Selected_Trigger_Source, MenuStatus[14][0] - 2, Trig_Pos_Mem + 50));
    }
    else  Trigger_Offset_Calc = -15;

    //printf("TOC %d\n", Trigger_Offset_Calc);

    if (triggering == 0) Trigger_Offset_Calc = 0;

	if (Channel_1_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc + CH1OffsetX, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc + CH1OffsetX, &SIGNAL_IntBuf[0], &SIGNAL1[0], &SIGNAL1_Intpolate_delayed[0]);
	}
	
	if (Channel_2_Active == 1)
	{	
        if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc + CH2OffsetX, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate[0]);
        if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc + CH2OffsetX, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);
	}	

	if (NumberOfChannels > 2)
	{	
        if (Channel_3_Active == 1)
        {	
            if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc + CH3OffsetX, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate[0]);
            if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc + CH3OffsetX, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);
        }         	
	
	    if (Channel_4_Active == 1)
	    {		   	
            if (Selected_Timebase < 4) Display::PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc + CH4OffsetX, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate[0]);
            if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) Display::PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc + CH4OffsetX, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);
        }
	}	



	// Submit Data to USB Client
	if (USB_Data_Requested) enddata = 511;
	else enddata = 75;

    if (USB_Data_Trans)
    {
	   if (USB_SendAllData) enddata = 511;
	   else enddata = 75;
	
	   USB_Data_Requested = true;
    }
	
	if ((USB_Data_Requested) && (Transfer_man_data))
	{
        //printf("ba : %x bp : %x bw : %x\n", buffer_addr, buffer_peak, buffer_witten);		
		
		

		
	
		if ((Channel_1_Active == 1) && (USB_OnlyTrigger == false))
		{

			send_buffer[0] = 101;								// Kennung Data
			//send_buffer[1] = 1;									// Kennung Channel
			
			
			for (ix2 = 0; ix2 <= enddata; ix2++)
			{
                ix3 = ix2 * 32;

				send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
				send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                chk_calc = 0;
                
                for (ix = 0; ix < 32; ix++)
                {	
                	chk_calc += SIGNAL1[(ix2 * 32) + ix];
                	send_buffer[3 + ix] = SIGNAL1[(ix2 * 32) + ix];
				}
                
				send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
				send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
				SendData(send_buffer);
				
				//printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
				nr_delay(10);
			}	
		}
		
		if ((Channel_2_Active == 1) && (USB_OnlyTrigger == false))
		{
			send_buffer[0] = 102;								// Kennung Data
			//send_buffer[1] = 2;									// Kennung Channel
			
			for (ix2 = 0; ix2 <= enddata; ix2++)
			{
                ix3 = ix2 * 32;

				send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
				send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
				
				chk_calc = 0;
				
                for (ix = 0; ix < 32; ix++)
                {	
                	chk_calc += SIGNAL2[(ix2 * 32) + ix];
                	send_buffer[3 + ix] = SIGNAL2[(ix2 * 32) + ix];
				}              

				send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
				send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
				
				SendData(send_buffer);
				nr_delay(10);
			}	
		}
		
		if (NumberOfChannels > 2)
		{
			if ((Channel_3_Active == 1) && (USB_OnlyTrigger == false))
			{
				send_buffer[0] = 103;								// Kennung Data
				//send_buffer[1] = 3;									// Kennung Channel
				
                for (ix2 = 0; ix2 <= enddata; ix2++)
                {
                    ix3 = ix2 * 32;

				    send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
				    send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
				
				    chk_calc = 0;
                    for (ix = 0; ix < 32; ix++)
                    {	
                        chk_calc += SIGNAL3[(ix2 * 32) + ix];
                        send_buffer[3 + ix] = SIGNAL3[(ix2 * 32) + ix];
				    }	
				
				    send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
				    send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));				
				
				    SendData(send_buffer);
				    nr_delay(10);
                }
			}
			
			if ((Channel_4_Active == 1) && (USB_OnlyTrigger == false))
			{		
				send_buffer[0] = 104;								// Kennung Data
				//send_buffer[1] = 4;									// Kennung Channel
				
                for (ix2 = 0; ix2 <= enddata; ix2++)
                {
                    ix3 = ix2 * 32;

				    send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
				    send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
				
				    chk_calc = 0;
                    for (ix = 0; ix < 32; ix++)
                    {	
                        chk_calc += SIGNAL4[(ix2 * 32) + ix];
                        send_buffer[3 + ix] = SIGNAL4[(ix2 * 32) + ix];
				    }	
				
				    send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
				    send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                    				
				    SendData(send_buffer);
				    nr_delay(10);
                }
			}		
			
	
		}

		
		if ((Channel_Math_Active == 1) && (USB_OnlyTrigger == false))
		{

			send_buffer[0] = 105;								// Kennung Data
			//send_buffer[1] = 1;									// Kennung Channel
			
			
			for (ix2 = 0; ix2 <= enddata; ix2++)
			{
                ix3 = ix2 * 32;

				send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
				send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                chk_calc = 0;	
                for (ix = 0; ix < 32; ix++)
                {	
                    chk_calc += SIGNALM[(ix2 * 32) + ix];
                    send_buffer[3 + ix] = SIGNALM[(ix2 * 32) + ix];
				}	
				
				send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
				send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
				SendData(send_buffer);
				
				//printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
				nr_delay(10);
			}	
		}
		
		send_buffer[0] = 100;								// Kennung Data
//		send_buffer[1] = 0;									// Kennung Datablock

		send_buffer[2] = (unsigned char) (buffer_addr & 0x000000FF);
		send_buffer[3] = (unsigned char) ((buffer_addr & 0x0000FF00) >> 8);
        send_buffer[4] = (unsigned char) ((buffer_addr & 0x00FF0000) >> 16);
        send_buffer[5] = (unsigned char) ((buffer_addr & 0xFF000000) >> 24);

		send_buffer[6] = (unsigned char) (buffer_peak & 0x000000FF);
		send_buffer[7] = (unsigned char) ((buffer_peak & 0x0000FF00) >> 8);
        send_buffer[8] = (unsigned char) ((buffer_peak & 0x00FF0000) >> 16);
        send_buffer[9] = (unsigned char) ((buffer_peak & 0xFF000000) >> 24);

		send_buffer[10] = (unsigned char) (buffer_witten & 0x000000FF);
		send_buffer[11] = (unsigned char) ((buffer_witten & 0x0000FF00) >> 8);
        send_buffer[12] = (unsigned char) ((buffer_witten & 0x00FF0000) >> 16);
        send_buffer[13] = (unsigned char) ((buffer_witten & 0xFF000000) >> 24);
        send_buffer[14] = (unsigned char) Selected_Timebase;
        send_buffer[15] = (unsigned char) SIGNALFaktor_idx;
		
        chk_calc = 0;	
        for (ix = 0; ix < 32; ix++)
        {	
            chk_calc += send_buffer[3 + ix];
        }	
				
        send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
        send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));		
		
		SendData(send_buffer);
		nr_delay(10);		
        		
		if (USB_OnlyTrigger == false)
		{
            SendCtrlBlock();
            nr_delay(50);			
            SendCtrlBlock3();		
            nr_delay(50);	
            SendCtrlBlock2();		
            nr_delay(50);
        }

        //if (MenuStatus[17][2] == 144) MenuStatus[17][2] = 143;	
        //Menu_Changed = 1;		

//		reset_watchdog->np_piodata = 0x01;							// Enable WatchDog
		
		USB_Data_Requested = false;
	}
    	

	if (SingleMode == 1)
	{
	    Single_Restart = 0;

		// Run/Stop LED red
		LED_ON[12] = 0;
		LED_ON[13] = 1;			
        	
		// Single Mode LED green
		LED_ON[14] = 0;
		LED_ON[15] = 0;				
		Send_LED();		
	}

	
//    if ((QM_Enabled) && (QM_Type[0] > 0)) Display::CALCQMDATA();	
	

#ifdef _Debug_	
	if ((ADC_Debug_Mode) && (Debug_Mode)) printf("ADC IRQ handled %d\n", triggering);
#endif
//    if ((SingleMode == false) && (Continius) && (OneShotRestart == false) && (UserIface_active == false)) Start_Record();

	if ((Search_Hidden == 0) && (Search_Mode)) DrawSignals_Needed = 0;
	else
    {
        //if (MenuStatus[10][2] == 0)
        {
            DrawSignals_Needed = 1;
        } /*
        else
        {
            ROLLMODE_BUFFVALUE_CH1 = SIGNAL1[200];
            ROLLMODE_BUFFVALUE_CH2 = SIGNAL2[200];
            ROLLMODE_BUFFVALUE_CH3 = SIGNAL3[200];
            ROLLMODE_BUFFVALUE_CH4 = SIGNAL4[200];
            ROLLMODE_BUFFVALUE_CHM = SIGNALM[200];
            ROLLMODE_Value_rec = true;

            Start_Record();
        }   */
    }

    if (Search_Mode)
    {
        Search_Step++;
        DrawSignals_Needed = 1;	
        //Start_Record();
    }
    
    if (Search_Step == 40) Search_Step = 99;
    //Search_Step = 0;           		
    //Search_Mode = true;
    /*
    if (Search_Step == 4)
    {
        if ((Search_Mode) || (Search_Auto)) Search_Step = 5;	
    }
    */


}

void Hardware::ReadOut_Signal(char channel, unsigned long adr_read, unsigned long adr_written)
{
    int ix, ix2, ix3, enddata;
    int chk_calc = 0;
    int buffer_int = 0;
	long buffer_long = 0;
	unsigned char buffer_byte1 = 0;
	unsigned char buffer_byte2 = 0;
	unsigned char buffer_byte3 = 0;	
	unsigned char buffer_byte4 = 0;	
	
	float interpolation_steps = 0;
	unsigned char interpolation_cnt = 2;
	
	unsigned int interpolation_start = 0;
	unsigned int interpolation_1 = 0;
	unsigned int interpolation_2 = 0;
	unsigned int interpolation_3 = 0;
	unsigned int interpolation_int = 0;
	
	float interpolation_start_float = 0;
	float interpolation_start_div = 0;
	
	unsigned int read_out_count = 0x1000;

	//if (MenuStatus[10][2] == 1) read_out_count = 0x100;
               	
	switch(channel)
	{	
        case 1 :
        {
            buffer_long = READADC(1);    // Read correction
            buffer_long = READADC(1);

            READADC_ALL2(1, &readout_sigbuf[0], read_out_count);
               	   	
            // Get new Signal Data
            if (Selected_Timebase < 7)
            {
                PREPARE_READADC(Voltage_Offset[0][0], Voltage_Offset[0][1],Voltage_Offset[0][2], Voltage_Offset[0][3], read_out_count);

                tc_test_var2 = 0;

                if (MenuStatus[0][1] == 1) READADC_ALL(1, &SIGNAL1[0], MenuStatus[1][2] - 240, (ZeroLevelCH1 + 64) >> 1, 1, 1);
                else READADC_ALL(1, &SIGNAL1[0], MenuStatus[1][2] - 240, (ZeroLevelCH1 + 64) >> 1, 0, 1);

//                printf("TC: %d\n", tc_test_var2);

            }
            else
            {

                PREPARE_READADC(Voltage_Offset[0][0], Voltage_Offset[0][1],Voltage_Offset[0][2], Voltage_Offset[0][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(1, &SIGNAL1[0], MenuStatus[1][2] - 240, (ZeroLevelCH1 + 64) >> 1, 1, 0);
                else READADC_ALL(1, &SIGNAL1[0], MenuStatus[1][2] - 240, (ZeroLevelCH1 + 64) >> 1, 0, 0);

            }
                 
            if (((USB_Data_Requested) || (USB_Data_Trans)) && (Transfer_man_data == false))
            {
                // Submit Data to USB Client
                if (USB_Data_Requested) enddata = 511;
                else enddata = 75;

                if (USB_Data_Trans)
                {
                    if (USB_SendAllData) enddata = 511;
                    else enddata = 75;
	
                    USB_Data_Requested = true;
                }

                if (USB_OnlyTrigger == false)
                {

                    send_buffer[0] = 100 + channel;								// Kennung Data	
			
                    for (ix2 = 0; ix2 <= enddata; ix2++)
                    {
                        ix3 = ix2 * 32;

                        send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
                        send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                        chk_calc = 0;	
                        for (ix = 0; ix < 32; ix++)
                        {	
                            chk_calc += readout_sigbuf_char[(ix2 * 32) + ix];
                            send_buffer[3 + ix] = readout_sigbuf_char[(ix2 * 32) + ix];
                        }	
				
                        send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
                        send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
                        SendData(send_buffer);
				
                        //printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
                        nr_delay(10);
                    }
                }	
            }    

            break;
        }

        case 2 :
        {
            buffer_long = READADC(2);    // Read correction
            buffer_long = READADC(2);
               	
            READADC_ALL2(2, &readout_sigbuf[0], read_out_count);                      	
			                         	   	
            // Get new Signal Data
            if (Selected_Timebase < 7)
            {
                PREPARE_READADC(Voltage_Offset[1][0], Voltage_Offset[1][1],Voltage_Offset[1][2], Voltage_Offset[1][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(2, &SIGNAL2[0], MenuStatus[2][2] - 240, (ZeroLevelCH2 + 64) >> 1, 1, 1);
                else READADC_ALL(2, &SIGNAL2[0], MenuStatus[2][2] - 240, (ZeroLevelCH2 + 64) >> 1, 0, 1);

            }
            else
            {
                PREPARE_READADC(Voltage_Offset[1][0], Voltage_Offset[1][1],Voltage_Offset[1][2], Voltage_Offset[1][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(2, &SIGNAL2[0], MenuStatus[2][2] - 240, (ZeroLevelCH2 + 64) >> 1, 1, 0);
                else READADC_ALL(2, &SIGNAL2[0], MenuStatus[2][2] - 240, (ZeroLevelCH2 + 64) >> 1, 0, 0);

            }
               
            if (((USB_Data_Requested) || (USB_Data_Trans)) && (Transfer_man_data == false))
            {
                // Submit Data to USB Client
                if (USB_Data_Requested) enddata = 511;
                else enddata = 75;

                if (USB_Data_Trans)
                {
                    if (USB_SendAllData) enddata = 511;
                    else enddata = 75;
	
                    USB_Data_Requested = true;
                }

                if (USB_OnlyTrigger == false)
                {

                    send_buffer[0] = 100 + channel;								// Kennung Data	
			
                    for (ix2 = 0; ix2 <= enddata; ix2++)
                    {
                        ix3 = ix2 * 32;

                        send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
                        send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                        chk_calc = 0;	
                        for (ix = 0; ix < 32; ix++)
                        {	
                            chk_calc += readout_sigbuf_char[(ix2 * 32) + ix];
                            send_buffer[3 + ix] = readout_sigbuf_char[(ix2 * 32) + ix];
                        }	
				
                        send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
                        send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
                        SendData(send_buffer);
				
                        //printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
                        nr_delay(10);
                    }
                }	
            }
            

            break;
        }

        case 3 :
        {
            buffer_long = READADC(3);    // Read correction
            buffer_long = READADC(3);
            buffer_long = READADC(3);    // Read correction
             
            READADC_ALL2(3, &readout_sigbuf[0], read_out_count);
				
            if (((USB_Data_Requested) || (USB_Data_Trans)) && (Transfer_man_data == false))
            {
                // Submit Data to USB Client
                if (USB_Data_Requested) enddata = 511;
                else enddata = 75;

                if (USB_Data_Trans)
                {
                    if (USB_SendAllData) enddata = 511;
                    else enddata = 75;
	
                    USB_Data_Requested = true;
                }

                if (USB_OnlyTrigger == false)
                {

                    send_buffer[0] = 100 + channel;								// Kennung Data	
			
                    for (ix2 = 0; ix2 <= enddata; ix2++)
                    {
                        ix3 = ix2 * 32;

                        send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
                        send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                        chk_calc = 0;	
                        for (ix = 0; ix < 32; ix++)
                        {	
                            chk_calc += readout_sigbuf_char[(ix2 * 32) + ix];
                            send_buffer[3 + ix] = readout_sigbuf_char[(ix2 * 32) + ix];
                        }	
				
                        send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
                        send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
                        SendData(send_buffer);
				
                        //printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
                        nr_delay(10);
                    }
                }	
            }
                                  	
            // Get new Signal Data
            if (Selected_Timebase < 7)
            {
                PREPARE_READADC(Voltage_Offset[2][0], Voltage_Offset[2][1],Voltage_Offset[2][2], Voltage_Offset[2][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(3, &SIGNAL3[0], MenuStatus[3][2] - 240, (ZeroLevelCH3 + 64) >> 1, 1, 1);
                else READADC_ALL(3, &SIGNAL3[0], MenuStatus[3][2] - 240, (ZeroLevelCH3 + 64) >> 1, 0, 1);

            }
            else
            {
                PREPARE_READADC(Voltage_Offset[2][0], Voltage_Offset[2][1],Voltage_Offset[2][2], Voltage_Offset[2][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(3, &SIGNAL3[0], MenuStatus[3][2] - 240, (ZeroLevelCH3 + 64) >> 1, 1, 0);
                else READADC_ALL(3, &SIGNAL3[0], MenuStatus[3][2] - 240, (ZeroLevelCH3 + 64) >> 1, 0, 0);

            }

            break;
        }
        case 4 :
        {
            buffer_long = READADC(4);    // Read correction
            buffer_long = READADC(4);
            buffer_long = READADC(4);
            
            READADC_ALL2(4, &readout_sigbuf[0], read_out_count);
			
            if (((USB_Data_Requested) || (USB_Data_Trans)) && (Transfer_man_data == false))
            {
                // Submit Data to USB Client
                if (USB_Data_Requested) enddata = 511;
                else enddata = 75;

                if (USB_Data_Trans)
                {
                    if (USB_SendAllData) enddata = 511;
                    else enddata = 75;
	
                    USB_Data_Requested = true;
                }

                if (USB_OnlyTrigger == false)
                {

                    send_buffer[0] = 100 + channel;								// Kennung Data	
			
                    for (ix2 = 0; ix2 <= enddata; ix2++)
                    {
                        ix3 = ix2 * 32;

                        send_buffer[1] = (unsigned char) ((ix3 & 0xFF00) >> 8);		// Address Hight
                        send_buffer[2] = (unsigned char) (ix3 & 0x00FF);			// Address Low
			
                        chk_calc = 0;	
                        for (ix = 0; ix < 32; ix++)
                        {	
                            chk_calc += readout_sigbuf_char[(ix2 * 32) + ix];
                            send_buffer[3 + ix] = readout_sigbuf_char[(ix2 * 32) + ix];
                        }	
				
                        send_buffer[37] = (unsigned char)(0xFF - (chk_calc & 0x00FF));
                        send_buffer[38] = (unsigned char)(0xFF - ((chk_calc & 0xFF00) >> 8));
                							
                        SendData(send_buffer);
				
                        //printf("DS %3d %3d %3d\n", send_buffer[2], send_buffer[3], send_buffer[4]);
                        nr_delay(10);
                    }
                }	
            }
                                           	   	
            // Get new Signal Data
            if (Selected_Timebase < 7)
            {
                PREPARE_READADC(Voltage_Offset[3][0], Voltage_Offset[3][1],Voltage_Offset[3][2], Voltage_Offset[3][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(4, &SIGNAL4[0], MenuStatus[4][2] - 240, (ZeroLevelCH4 + 64) >> 1, 1, 1);
                else READADC_ALL(4, &SIGNAL4[0], MenuStatus[4][2] - 240, (ZeroLevelCH4 + 64) >> 1, 0, 1);

            }
            else
            {
                PREPARE_READADC(Voltage_Offset[3][0], Voltage_Offset[3][1], Voltage_Offset[3][2], Voltage_Offset[3][3], read_out_count);

                if (MenuStatus[0][1] == 1) READADC_ALL(4, &SIGNAL4[0], MenuStatus[4][2] - 240, (ZeroLevelCH4 + 64) >> 1, 1, 0);
                else READADC_ALL(4, &SIGNAL4[0], MenuStatus[4][2] - 240, (ZeroLevelCH4 + 64) >> 1, 0, 0);
            }

            break;
        }                                                    	
	}

}

void Hardware::Do_FFT(void)
{
    int icnt;
    float areal, img, f_abs;

#ifdef _Debug_FFT_
    printf("starting fft\n");
#endif

    for (icnt = 0; icnt < 600; icnt++) SIGNALM[icnt] = FFTOffsetY;
    
    if ((MenuStatus[27][0] - 137) == 1)
    {
        if (Selected_Timebase > 3)
        {
            for (icnt = 0; icnt < fft_length; icnt++)                                            //(icnt << 3)
            {
                fft_values[icnt] = fft_window[MenuStatus[27][1] - 182][icnt] * (((float) SIGNAL1[icnt * (int) ZFT_float] - 128));
                fft_frequencies[icnt] = 0.0;
                fft_mag[icnt] = 0.0;
            }
        }
        else
        {
            for (icnt = 0; icnt < fft_length; icnt++)
            {
                fft_values[icnt] = fft_window[MenuStatus[27][1] - 182][icnt] * (((float) SIGNAL1_Intpolate[icnt] - 128));
                fft_frequencies[icnt] = 0.0;
                fft_mag[icnt] = 0.0;
            }
        }
    }
    else if ((MenuStatus[27][0] - 137) == 2)
    {
        for (icnt = 0; icnt < fft_length; icnt++)
        {
            fft_values[icnt] = fft_window[MenuStatus[27][1] - 182][icnt] * (((float) SIGNAL2[(icnt << 3) * (int) ZFT_float] - 128));
            fft_frequencies[icnt] = 0.0;
            fft_mag[icnt] = 0.0;
        }
    }
    else if ((MenuStatus[27][0] - 137) == 3)
    {
        for (icnt = 0; icnt < fft_length; icnt++)
        {
            fft_values[icnt] = fft_window[MenuStatus[27][1] - 182][icnt] * (((float) SIGNAL3[(icnt << 3) * (int) ZFT_float] - 128));
            fft_frequencies[icnt] = 0.0;
            fft_mag[icnt] = 0.0;
        }
    }
    else if ((MenuStatus[27][0] - 137) == 4)
    {
        for (icnt = 0; icnt < fft_length; icnt++)
        {
            fft_values[icnt] = fft_window[MenuStatus[27][1] - 182][icnt] * (((float) SIGNAL4[(icnt << 3) * (int) ZFT_float] - 128));
            fft_frequencies[icnt] = 0.0;
            fft_mag[icnt] = 0.0;
        }
    }

#ifdef _Debug_FFT_
    printf("pre fft ready\n");
#endif

    fft_object.do_fft(fft_frequencies, fft_values);     // x (real) --FFT---> f (complex)
    //fft_object.do_ifft(fft_frequencies, fft_values);     // x (real) --FFT---> f (complex)
    fft_object.rescale(fft_values);

#ifdef _Debug_FFT_
    printf("fft ready\n");
#endif

    for (icnt = 0; icnt < (fft_length / 2); icnt++)
    {
        areal = fft_frequencies[icnt];
        
        if ((icnt > 0) && (icnt < (fft_length / 2))) img = fft_frequencies[icnt + (fft_length / 2)];
        else img = 0;
        
        f_abs = sqrt(areal * areal + img * img);
        
        fft_mag[icnt] = f_abs;
    }
    
#ifdef _Debug_FFT_
    printf("post fft ready\n");
#endif

#ifdef _Debug_FFT_
    printf("Search max \n");
#endif
    fft_max = 0.0;
    
    for (icnt = 2; icnt < fft_length; icnt++) if (fft_mag[icnt] > fft_max) fft_max = fft_mag[icnt];
    
    fft_max = ((float) 192 / fft_max);

#ifdef _Debug_FFT_
    printf("fftmax : %f \n", fft_max);
    printf("copy fft to math\n");
#endif
/*
    for (icnt = 2; icnt < fft_length; icnt++)
    {
        SIGNALM[icnt + 5] = (unsigned char) (FFTOffsetY - (fft_mag[icnt] * fft_max));
    }
*/
    if (Selected_Timebase > 3)
    {
        for (icnt = 2; icnt < fft_length; icnt++)
        {
            SIGNALM[(icnt << 1) + 0] = (unsigned char) (FFTOffsetY - (fft_mag[icnt] * fft_max));
            SIGNALM[(icnt << 1) + 1] = (unsigned char) (FFTOffsetY - (((fft_mag[icnt] + fft_mag[icnt + 1]) / 2) * fft_max));
        }
    }
    else
    {
        for (icnt = 2; icnt < fft_length; icnt++)    //SIGNALM_Intpolate
        {
            SIGNALM[(icnt << 1) + 0] = (unsigned char) (FFTOffsetY - (fft_mag[icnt] * fft_max));
            SIGNALM[(icnt << 1) + 1] = (unsigned char) (FFTOffsetY - (((fft_mag[icnt] + fft_mag[icnt + 1]) / 2) * fft_max));
        }
    }

#ifdef _Debug_FFT_
    printf("copy fft to math ready \n");
    printf("fft ready\n");
#endif
}

void Hardware::Do_Gen_Signal(void)	
{
    float wert;
    float grad;
    int icnt;
    
#ifdef _Debug_FFT_
    printf("starting generate signal\n");
#endif                                    	

    for(icnt = 0; icnt <= 700; icnt ++ ) SIGNAL1[icnt] = 0;
    
    for(icnt = 0; icnt <= fft_length; icnt ++ )
    {
        //wert = 0.5 - cos(2*PI*(float)icnt/(float)fft_length);
        //wert = fft_window[icnt];
        //wert = fft_window[ix] = 0.5 * cos(2*PI*(float)ix/(float)fft_length) - 0.5 * cos(2*PI*(float)ix/(float)fft_length);
        wert = (0.281 * cos(2*PI*(float)icnt/(float)fft_length)) + (-0.521 * cos(2*PI*(float)icnt/(float)fft_length)) + (0.198 * cos(2*PI*(float)icnt/(float)fft_length));
        SIGNAL1[icnt + 100] = ((unsigned char) ((wert * 130) + 128));
    }
/*
    for(grad = 0; grad <= (float)(fft_length*4); grad += 4 )
    {
        icnt = (int) (grad / 4);
        wert = -1 + sin (3*2*PI*(float)grad/(float)fft_length) + cos (5*2*PI*(float)grad/(float)fft_length) * 2 - sin (7*2*PI*(float)grad/(float)fft_length) * 3 + cos (8*2*PI*(float)grad/(float)fft_length) * 5;

        SIGNAL1[icnt] = ((unsigned char) ((wert * 30) + 128));
       // printf( "%d\n", (int) wert );
    }
*/
#ifdef _Debug_FFT_
    printf("generate signal ready\n");
#endif
}

void Hardware::Do_Gen_Signal2(void)	
{
    float wert;
    float grad;
    int icnt;

#ifdef _Debug_FFT_
    printf("starting generate signal\n");
#endif
    for(icnt = 0; icnt <= fft_length; icnt++)
    {
        grad = (float) (icnt);
        
        if (((int)(grad * 0.015625) %2) == 0) wert = -1.0; // 0.03125
        else wert = 1.0;
               
       // fft_values[icnt] = wert;

        SIGNAL1[icnt] = ((unsigned char) ((wert * 30) + 128));
       // printf( "%d\n", (int) wert );
    }
#ifdef _Debug_FFT_
    printf("generate signal ready\n");
#endif
}

            /*
void Hardware::FFT2_init(void)
{
}

void Hardware::FFT2_do_fft(void)
{
}

void Hardware::FFT2_do_ifft(void)
{
}

void Hardware::FFT2_rescale(void)
{
}

bool Hardware::FFT2_is_pow2(long x)
{
    assert(x > 0);
    
    return ((x & -x) == x);
}

int Hardware::FFT2_get_next_pow2(long x)
{
    int p = 0;
    
    --x;

    while ((x & ~0xFFFFL) != 0)
    {
        p += 16;
        x >>= 16;
    }
    while ((x & ~0xFL) != 0)
    {
        p += 4;
        x >>= 4;
    }
    while (x > 0)
    {
        ++p;
        x >>= 1;
    }
    
    return(p);
}
   */
	
int Hardware::FindTrigger(unsigned char channel, unsigned char negativ, int TriggerPos)
{
    int ix, foundat = 0, range = 50;
    int tl_buf = 0;

    unsigned char neg_buf = negativ;
    
    // if channel inverted
    if (MenuStatus[channel][2] == 241)
    {
        if (negativ) negativ = 0;
        else negativ = 1;
    }

    switch(channel)
    {
        case 1 : tl_buf = (Trigger_Pos_CH1 + 64) >> 1; break;
        case 2 : tl_buf = (Trigger_Pos_CH2 + 64) >> 1; break;
        case 3 : tl_buf = (Trigger_Pos_CH3 + 64) >> 1; break;
        case 4 : tl_buf = (Trigger_Pos_CH4 + 64) >> 1; break;
    }

    if (negativ)
    {
        switch(channel)
        {
            case 1 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL1[ix] > tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 2 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL2[ix] > tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 3 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL3[ix] > tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 4 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL4[ix] > tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
        }
    }
    else
    {
        switch(channel)
        {
            case 1 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL1[ix] < tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 2 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL2[ix] < tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 3 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL3[ix] < tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
            case 4 :
            {
                foundat = TriggerPos;
                for (ix = TriggerPos - range; ix < TriggerPos + range; ix++)
                {
                    if (SIGNAL4[ix] < tl_buf)
                    {
                        foundat = ix;
                        break;
                    }
                }
                break;
            }
        }
    }

    return foundat;
}

int Hardware::AutoScale(void)
{
    int result = 0;

    triggering_bak = triggering;
    ctrl_reg_bak = ctrl_reg;
    adc_ctrl_reg_bak = adc_ctrl_reg;

    Channel_1_Active_bak = Channel_1_Active;
    Channel_2_Active_bak = Channel_2_Active;
    Channel_3_Active_bak = Channel_3_Active;
    Channel_4_Active_bak = Channel_4_Active;

    Selected_Timebase_bak = Selected_Timebase;
    SIGNALFaktor_idx_bak = SIGNALFaktor_idx;
    SIGNAL_StartFr_idx_bak = SIGNAL_StartFr_idx;
    timebase_reg_bak = timebase_reg;
    Display_Timebase_bak = Display_Timebase;
    Continius_bak = Continius;
    SingleMode_bak = SingleMode;

    Selected_Voltage_CH1_bak = Selected_Voltage_CH1;
    Selected_Voltage_CH2_bak = Selected_Voltage_CH2;
    Selected_Voltage_CH3_bak = Selected_Voltage_CH3;
    Selected_Voltage_CH4_bak = Selected_Voltage_CH4;   	

    ZeroLevelCH1_bak = ZeroLevelCH1;
    ZeroLevelCH2_bak = ZeroLevelCH2;
    ZeroLevelCH3_bak = ZeroLevelCH3;
    ZeroLevelCH4_bak = ZeroLevelCH4;

    Virtual_ZeroLevelCH1_bak = Virtual_ZeroLevelCH1;
    Virtual_ZeroLevelCH2_bak = Virtual_ZeroLevelCH2;
    Virtual_ZeroLevelCH3_bak = Virtual_ZeroLevelCH3;
    Virtual_ZeroLevelCH4_bak = Virtual_ZeroLevelCH4;

    Trigger_Pos_CH1_bak = Trigger_Pos_CH1;	
    Trigger_Pos_CH2_bak = Trigger_Pos_CH2;
    Trigger_Pos_CH3_bak = Trigger_Pos_CH3;
    Trigger_Pos_CH4_bak = Trigger_Pos_CH4;

    Timebase_Offset_Pos_bak = Timebase_Offset_Pos;
    Trigger_Offset_Pos_bak = Trigger_Offset_Pos;

    AC_CH1_bak = MenuStatus[1][0];
    AC_CH2_bak = MenuStatus[2][0];
    AC_CH3_bak = MenuStatus[3][0];
    AC_CH4_bak = MenuStatus[4][0];
    
    Invert_CH1_bak = MenuStatus[1][2];
    Invert_CH2_bak = MenuStatus[2][2];
    Invert_CH3_bak = MenuStatus[3][2];
    Invert_CH4_bak = MenuStatus[4][2];

    MAINMODE_bak = MenuStatus[10][0];
    //ROLLMODE_bak = MenuStatus[10][2];
    ROLLMODESTARTED_bak = ROLLMODE_STARTED;

    Acquire_bak_0 = MenuStatus[0][0];
    Acquire_bak_1 = MenuStatus[0][1];
    
    AUTOMODE_bak = MenuStatus[12][0];
			
    Stop_Record();			
    AutoTimerOff = true;
    Search_Mode = true;

    DoDisableUARTInterrupt();
    DoDisableADCInterrupt();
    DoDisableKeyInterrupt();
    DoDisableRotInterrupt();

    ADC_Data_Available = 0;
	acq_ready->np_pioedgecapture = 0;
	
    MenuStatus[12][0] = 93;
    MenuPopupStatus[9][0] = 3;
    MenuPopupStatus[9][1] = 2;

    // Averaging off			
    MenuStatus[0][1] = 0;
    MenuStatus[0][0] = 1;
			

    // All AC
    MenuStatus[1][0] = 7;
    MenuStatus[2][0] = 7;
    MenuStatus[3][0] = 7;
    MenuStatus[4][0] = 7;
    
    // All invert off
    MenuStatus[1][2] = 240;
    MenuStatus[2][2] = 240;
    MenuStatus[3][2] = 240;
    MenuStatus[4][2] = 240;



    Selected_Timebase = 4;                                          //  50 nS
    SIGNALFaktor_idx = 0;                                           // zoom factor 1 = 50 nS
    SIGNAL_StartFr_idx = 0;                                         // running. so 0

    timebase_reg = tb_value[Selected_Timebase];
    Display_Timebase = 4;                                          // Displayed timebase is 50 ns

    triggering = 0;								
    ctrl_reg = 0x0087;							                    // Trigger_Master / Trigger_INT / Free Run
    adc_ctrl_reg &= 0xFFF0;						                    // Disable Trigger sources

    pre_reg = 0x006C;
    Trigger_Offset_Pos = 353;
    Timebase_Offset_Pos = -300;
    
  // TMW complete changed (2-Channel Version)

	Virtual_ZeroLevelCH1 = 0;                                
    CH1_Zero_Offset = 0;                                     

    Virtual_ZeroLevelCH2 = 0;                                
    CH2_Zero_Offset = 0;                                       

    Rotary_Steps = 0;
    ON_Zero_Channel_1();
    Rotary_Steps = 0;
    ON_Zero_Channel_2();
	
  	if ( NumberOfChannels == 4) // TMW complete changed (4-Channel Version)
 		{
		Virtual_ZeroLevelCH3 = 0;                                
    	CH3_Zero_Offset = 0;                                     

    	Virtual_ZeroLevelCH4 = 0;                                
    	CH4_Zero_Offset = 0;                                       

    	Rotary_Steps = 0;
    	ON_Zero_Channel_3();
    	Rotary_Steps = 0;
    	ON_Zero_Channel_4();
		}
 
    Trigger_Pos_CH1 = ZeroLevelCH1;
    Trigger_Pos_CH2 = ZeroLevelCH2;
    Trigger_Pos_CH3 = ZeroLevelCH3;
    Trigger_Pos_CH4 = ZeroLevelCH4;

    if (Channel_1_Active) result = FindTimebase(1);
    else if (Channel_2_Active) result = FindTimebase(2);
    else if (Channel_3_Active) result = FindTimebase(3);
    else if (Channel_4_Active) result = FindTimebase(4);

  // TMW complete changed (2-Channel Version)

	Virtual_ZeroLevelCH1 = 0;                                
    CH1_Zero_Offset = 0;                                     

    Virtual_ZeroLevelCH2 = 0;                                
    CH2_Zero_Offset = 0;                                       

    Rotary_Steps = 0;
    ON_Zero_Channel_1();
    Rotary_Steps = 0;
    ON_Zero_Channel_2();
	
  	if ( NumberOfChannels == 4) // TMW complete changed (4-Channel Version)
 		{
		Virtual_ZeroLevelCH3 = 0;                                
    	CH3_Zero_Offset = 0;                                     

    	Virtual_ZeroLevelCH4 = 0;                                
    	CH4_Zero_Offset = 0;                                       

    	Rotary_Steps = 0;
    	ON_Zero_Channel_3();
    	Rotary_Steps = 0;
    	ON_Zero_Channel_4();
		}
 
    Trigger_Pos_CH1 = ZeroLevelCH1;
    Trigger_Pos_CH2 = ZeroLevelCH2;
    Trigger_Pos_CH3 = ZeroLevelCH3;
    Trigger_Pos_CH4 = ZeroLevelCH4;

			
    if (Channel_1_Active) FindVoltage(1);
    if (Channel_2_Active) FindVoltage(2);

    if (NumberOfChannels > 2)
    {
        if (Channel_3_Active) FindVoltage(3);
        if (Channel_4_Active) FindVoltage(4);
    }


    			
    AutoTimerOff = false;
    Search_Mode = false;

    triggering = triggering_bak;
    ctrl_reg = ctrl_reg_bak;
    adc_ctrl_reg = adc_ctrl_reg_bak;

    Continius = Continius_bak;
    SingleMode = SingleMode_bak;
    UserIface_active = 0;
/*
    Trigger_Pos_CH1 = Trigger_Pos_CH1_bak;
    Trigger_Pos_CH2 = Trigger_Pos_CH2_bak;
    Trigger_Pos_CH3 = Trigger_Pos_CH3_bak;
    Trigger_Pos_CH4 = Trigger_Pos_CH4_bak;
*/


  	if ( NumberOfChannels == 2) // TMW complete changed (2-Channel Version)
		{
       	if (Channel_2_Active) Virtual_ZeroLevelCH1 = -96;           
       	else Virtual_ZeroLevelCH1 = 0;                              
       	CH1_Zero_Offset = 0;                                       

       	if (Channel_1_Active) Virtual_ZeroLevelCH2 = 96;           
       	else Virtual_ZeroLevelCH2 = 0;
       	CH2_Zero_Offset = 0;                                     

       	Rotary_Steps = 0;
       	if (Channel_1_Active)
       		{
            ON_Zero_Channel_1();
            Trigger_Pos_CH1 = ZeroLevelCH1 - 5;

            SetDacOffset(1);
            SetCHDacOffset(1);
        	}

        Rotary_Steps = 0;
        if (Channel_2_Active)
        	{
            ON_Zero_Channel_2();
            Trigger_Pos_CH2 = ZeroLevelCH2 - 5;

            SetDacOffset(2);
            SetCHDacOffset(2);
        	}
    	}
  	else // TMW complete changed (4-Channel Version)
		{
       	Virtual_ZeroLevelCH1 = -120;           
       	CH1_Zero_Offset = 0;                                       
       	if (Channel_1_Active)
       		{
       		Rotary_Steps = 0;
            ON_Zero_Channel_1();
            Trigger_Pos_CH1 = ZeroLevelCH1 - 5;

            SetDacOffset(1);
            SetCHDacOffset(1);
        	}
       	
		Virtual_ZeroLevelCH2 = -24;           
       	CH2_Zero_Offset = 0;                                       
       	if (Channel_2_Active)
       		{
       		Rotary_Steps = 0;
            ON_Zero_Channel_2();
            Trigger_Pos_CH2 = ZeroLevelCH2 - 5;

            SetDacOffset(2);
            SetCHDacOffset(2);
        	}
			
		Virtual_ZeroLevelCH3 = 72;           
       	CH3_Zero_Offset = 0;                                       
       	if (Channel_3_Active)
       		{
       		Rotary_Steps = 0;
            ON_Zero_Channel_3();
            Trigger_Pos_CH3 = ZeroLevelCH3 - 5;

            SetDacOffset(3);
            SetCHDacOffset(3);
        	}
			
		Virtual_ZeroLevelCH4 = 168;           
       	CH4_Zero_Offset = 0;                                       
       	if (Channel_4_Active)
       		{
       		Rotary_Steps = 0;
            ON_Zero_Channel_4();
            Trigger_Pos_CH4 = ZeroLevelCH4 - 5;

            SetDacOffset(4);
            SetCHDacOffset(4);
        	}
			
			
			
			
			
			
			
			
			
			
		}


    acq_ready->np_pioedgecapture = 0;

    DoEnableRotInterrupt();
    DoEnableKeyInterrupt();
    DoEnableADCInterrupt();
    DoEnableUARTInterrupt();

    Recalc_Vars();

    UpdateTrigger(35);

    TimebaseChanged = 1;
    TimeOffsetChanged = 1;
    TriggerLevelChanged = 1;
    TriggerModeChanged = 1;
    TriggerWayChanged = 1;
    VoltageChangedCh1 = 1;									// Was Voltage changed
    VoltageChangedCh2 = 1;									// Was Voltage changed
    VoltageChangedCh3 = 1;									// Was Voltage changed
    VoltageChangedCh4 = 1;									// Was Voltage changed          		
		
    Display::StatusUpdate();


/* TMW 	if (Memory_Window_visible)
	{
        Display::DRAWMEMORY(0, 0, 1);
    } TMW*/

    if (Cursor_Enabled)
    {
        Display::CALCCURSORDATA();
        Menu_Changed = 1;
        CursorChanged = 4;
    }

    if (QM_Enabled)
    {
        Display::CALCQMDATA();
        Menu_Changed = 1;
    }

    Display::DRAW_ALL_CURSOR();

    LED_ON[12] = 1;
    LED_ON[13] = 0;

    LED_ON[14] = 0;
    LED_ON[15] = 0;

    Send_LED();

    nr_delay(10);

    SetupADC();

    Start_Record();

//    RemovePlane |= 0x1F;
 //   ClearPlanes();

    return 0;
}

int Hardware::FindTimebase(char channel)
{
    volatile int ix, result, max_cnt, cnt = 0, cnt2 = 0;
    volatile int buf_int = 0;
    volatile long buf_long = 0;

    volatile unsigned char buf_byte = 0;
    volatile unsigned char buf_byte2 = 0;

    int max_tb = 22;

#ifdef _Debug_FindTimebase_
    printf("Start FTB Channel %d\n", channel);
#endif

    switch(channel)
    {
        case 1: serdata->np_piodata = 0x70000015; break;
        case 2: serdata->np_piodata = 0x50000015; break;
        case 3: serdata->np_piodata = 0x10000015; break;
        case 4: serdata->np_piodata = 0x30000015; break;
    }


	serstartsw->np_piodata = 1;
	serstartsw->np_piodata = 0;
	nr_delay(20);



    Selected_Timebase = 4;                                          //  50 nS
    SIGNALFaktor_idx = 0;                                           // zoom factor 1 = 50 nS
    SIGNAL_StartFr_idx = 0;                                         // running. so 0

    timebase_reg = tb_value[Selected_Timebase];
    Display_Timebase = 4;                                          // Displayed timebase is 50 ns

    triggering = 0;								
    ctrl_reg = 0x0087;							                    // Trigger_Master / Trigger_INT / Free Run
    adc_ctrl_reg &= 0xFFF0;						                    // Disable Trigger sources

    SetupADC();

    result = 0;

    max_cnt = 0;

    if (MenuStatus[23][1] == 240) max_tb = 16;
			
    while ((result < 15) || (result > 50))
    {
        max_cnt++;

        start_acq->np_piodata = 0x01;				//start record Port On
        start_acq->np_piodata = 0x00;				//start record Port Off

        while (acq_ready->np_piodata == 0x01) {}

        data_adr->np_piodata = 0x01;

        buf_long = READADC(1);
        buf_long = READADC(1);

        WRITEADC(1, ram_adress_reg);
        WRITEADC(2, ram_adress_reg);

        if (NumberOfChannels > 2)
        {
            WRITEADC(3, ram_adress_reg);
            WRITEADC(4, ram_adress_reg);
        }
    	
        data_adr->np_piodata = 0x00;   	

        switch(channel)
        {
            case 1 : ReadOut_Signal(1, 0, 0); break;
            case 2 : ReadOut_Signal(2, 0, 0); break;
            case 3 : ReadOut_Signal(3, 0, 0); break;
            case 4 : ReadOut_Signal(4, 0, 0); break;
        }

        result = 0;
        buf_byte = 0;
        cnt = 0;

        buf_int = (int) ZFT_float;

        if (buf_int <= 0) buf_int = 1;

        switch(channel)
        {
            case 1 :
            {
                buf_min = 255;
                buf_max = 0;

                for (ix = 50; ix < 650; ix++)
                {
                    buf_byte = SIGNAL1[ix * buf_int];
                    buf_arr[cnt++] = buf_byte;
                    if (buf_min < buf_byte) buf_min = buf_byte;
                    if (buf_max > buf_byte) buf_max = buf_byte;
                }

                buf_byte2 = (unsigned char) (((int) buf_min + (int) buf_max) >> 1);

                for (ix = 3; ix < 596; ix++)
                {
                    if ((buf_arr[ix - 3] > buf_byte2 + 1) && (buf_arr[ix + 3] < buf_byte2 - 1)) result++;
                    if ((buf_arr[ix - 3] < buf_byte2 - 1) && (buf_arr[ix + 3] > buf_byte2 + 1)) result++;
                }
#ifdef _Debug_FindTimebase_

                printf("FTB %d cnt %d bi %d st %d sfi %d bb %d bmin %d bmax %d\n", result, cnt, buf_int, Selected_Timebase, SIGNALFaktor_idx, buf_byte2, buf_min, buf_max);
#endif
                break;
            }

            case 2 :
            {
                buf_min = 255;
                buf_max = 0;

                for (ix = 50; ix < 650; ix++)
                {
                    buf_byte = SIGNAL2[ix * buf_int];
                    buf_arr[cnt++] = buf_byte;
                    if (buf_min < buf_byte) buf_min = buf_byte;
                    if (buf_max > buf_byte) buf_max = buf_byte;
                }

                buf_byte2 = (unsigned char) (((int) buf_min + (int) buf_max) >> 1);

                for (ix = 1; ix < 599; ix++)
                {
                    if ((buf_arr[ix - 3] > buf_byte2 + 1) && (buf_arr[ix + 3] < buf_byte2 - 1)) result++;
                    if ((buf_arr[ix - 3] < buf_byte2 - 1) && (buf_arr[ix + 3] > buf_byte2 + 1)) result++;
                }
#ifdef _Debug_FindTimebase_


                printf("FTB %d cnt %d bi %d st %d sfi %d bb %d bmin %d bmax %d\n", result, cnt, buf_int, Selected_Timebase, SIGNALFaktor_idx, buf_byte2, buf_min, buf_max);
#endif
                break;
            }

            case 3 :
            {
                buf_min = 255;
                buf_max = 0;

                for (ix = 50; ix < 650; ix++)
                {
                    buf_byte = SIGNAL3[ix * buf_int];
                    buf_arr[cnt++] = buf_byte;
                    if (buf_min < buf_byte) buf_min = buf_byte;
                    if (buf_max > buf_byte) buf_max = buf_byte;
                }

                buf_byte2 = (unsigned char) (((int) buf_min + (int) buf_max) >> 1);

                for (ix = 1; ix < 599; ix++)
                {
                    if ((buf_arr[ix - 3] > buf_byte2 + 1) && (buf_arr[ix + 3] < buf_byte2 - 1)) result++;
                    if ((buf_arr[ix - 3] < buf_byte2 - 1) && (buf_arr[ix + 3] > buf_byte2 + 1)) result++;
                }
#ifdef _Debug_FindTimebase_


                printf("FTB %d cnt %d bi %d st %d sfi %d bb %d bmin %d bmax %d\n", result, cnt, buf_int, Selected_Timebase, SIGNALFaktor_idx, buf_byte2, buf_min, buf_max);
#endif
                break;
            }

            case 4 :
            {
                buf_min = 255;
                buf_max = 0;

                for (ix = 50; ix < 650; ix++)
                {
                    buf_byte = SIGNAL4[ix * buf_int];
                    buf_arr[cnt++] = buf_byte;
                    if (buf_min < buf_byte) buf_min = buf_byte;
                    if (buf_max > buf_byte) buf_max = buf_byte;
                }

                buf_byte2 = (unsigned char) (((int) buf_min + (int) buf_max) >> 1);

                for (ix = 1; ix < 599; ix++)
                {
                    if ((buf_arr[ix - 3] > buf_byte2 + 1) && (buf_arr[ix + 3] < buf_byte2 - 1)) result++;
                    if ((buf_arr[ix - 3] < buf_byte2 - 1) && (buf_arr[ix + 3] > buf_byte2 + 1)) result++;
                }
#ifdef _Debug_FindTimebase_

                for (cnt2 = 0; cnt2 < 35; cnt2++)
                {
                    printf("%2d : %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d\n", cnt, buf_arr[(cnt * 16) + 0], buf_arr[(cnt * 16) + 1], buf_arr[(cnt * 16) + 2], buf_arr[(cnt * 16) + 3], buf_arr[(cnt * 16) + 4], buf_arr[(cnt * 16) + 5], buf_arr[(cnt * 16) + 6], buf_arr[(cnt * 16) + 7], buf_arr[(cnt * 16) + 8], buf_arr[(cnt * 16) + 9], buf_arr[(cnt * 16) + 10], buf_arr[(cnt * 16) + 11], buf_arr[(cnt * 16) + 12], buf_arr[(cnt * 16) + 13], buf_arr[(cnt * 16) + 14], buf_arr[(cnt * 16) + 15]);
                }

                printf("FTB %d cnt %d bi %d st %d sfi %d bb %d bmin %d bmax %d\n", result, cnt, buf_int, Selected_Timebase, SIGNALFaktor_idx, buf_byte2, buf_min, buf_max);
#endif
                break;
            }
        }
	
        if (result < 15)
        {
            Selected_Timebase_Old = Selected_Timebase;

            if ((Selected_Timebase < 4) && (SIGNALFaktor_idx == 0)) Selected_Timebase++;
            else if ((Selected_Timebase < 7) && (SIGNALFaktor_idx < 4)) SIGNALFaktor_idx++;
            else if ((Selected_Timebase > 6) && (SIGNALFaktor_idx < 2)) SIGNALFaktor_idx++;
            else if (Selected_Timebase < max_tb) Selected_Timebase++;

            if ((Selected_Timebase == 7) && (SIGNALFaktor_idx == 4))
            {
                if (Selected_Timebase_Old == 6)
                {
                    Selected_Timebase = 9;
                    SIGNALFaktor_idx = 2;
                }
            }

            if ((Selected_Timebase == 8) && (SIGNALFaktor_idx == 2))
            {
                if (Selected_Timebase_Old == 9)
                {
                    Selected_Timebase = 6;
                    SIGNALFaktor_idx = 4;
                }
            }

            timebase_reg = tb_value[Selected_Timebase];
            
            if (Selected_Timebase > 7) adc_change12_reg |= 0x01000000;
            else adc_change12_reg &= 0xFEFFFFFF;
            
            SetupADC();
        }

        if (result > 50)
        {
            Selected_Timebase_Old = Selected_Timebase;

            if ((Selected_Timebase > 4) && (SIGNALFaktor_idx == 4)) Selected_Timebase--;
            else if (SIGNALFaktor_idx > 0) SIGNALFaktor_idx--;
            else if ((Selected_Timebase > 2) && (SIGNALFaktor_idx == 0)) Selected_Timebase--;

            if ((Selected_Timebase == 7) && (SIGNALFaktor_idx == 4))
            {
                if (Selected_Timebase_Old == 6)
                {
                    Selected_Timebase = 9;
                    SIGNALFaktor_idx = 2;
                }
            }

            if ((Selected_Timebase == 8) && (SIGNALFaktor_idx == 2))
            {
                if (Selected_Timebase_Old == 9)
                {
                    Selected_Timebase = 6;
                    SIGNALFaktor_idx = 4;
                }
            }

			if ( Selected_Timebase <4 )
				Selected_Timebase =4;

            timebase_reg = tb_value[Selected_Timebase];
            
            if (Selected_Timebase > 7) adc_change12_reg |= 0x01000000;
            else adc_change12_reg &= 0xFEFFFFFF;
            
            SetupADC();

            if ((Selected_Timebase == 2) && (SIGNALFaktor_idx == 0)) result = 25;   // set break condition
        }


        if (Selected_Timebase == max_tb) result = 25;   // set break condition
        if (max_cnt == 25) result = 25;   // set break condition
    }

    Display_Timebase = Selected_Timebase + SIGNALFaktor_idx;

    Stop_Record();

    serdata->np_piodata = 0x700000CA;
	serstartsw->np_piodata = 1;
	serstartsw->np_piodata = 0;
	nr_delay(50);

    serdata->np_piodata = 0x500000CA;
	serstartsw->np_piodata = 1;
	serstartsw->np_piodata = 0;
	nr_delay(50);
	
	if (NumberOfChannels != 2)
	{
        serdata->np_piodata = 0x100000CA;
	    serstartsw->np_piodata = 1;
	    serstartsw->np_piodata = 0;
	    nr_delay(50);

        serdata->np_piodata = 0x300000CA;
	    serstartsw->np_piodata = 1;
	    serstartsw->np_piodata = 0;
	    nr_delay(50);	
    }
	
    nr_delay(300);

    return result;
}

int Hardware::FindVoltage(char channel)
{
    int ix, ix2, buf_int, volt = 12;
    long buf_long = 0;
    volatile unsigned char buf_byte = 0;

    int deltaV = 100;
    int topV = 40;
    int bottomV = 220;

    int posmin = 0, posmax = 0;

#ifdef _Debug_FindVoltage_
    printf("Start Channel %d\n", channel);
#endif

        			
    while (1)
    {
        if (volt > 3)
        {
            volt--;
#ifdef _Debug_FindVoltage_
            printf("decrement volt %d\n", volt);
#endif
        }
        else break;

        topV = 30;
        bottomV = 226;

                /*
        if ((Channel_1_Active) && (Channel_2_Active))
        {
            if (channel == 1)
            {
                topV = 30;
                bottomV = 128;
            }
            else
            {
                topV = 128;
                bottomV = 226;
            }
        }     */

        SetSwitches(channel, volt);

#ifdef _Debug_FindVoltage_
            printf("switches set\n");
#endif
/*
        Selected_Timebase = 15;                                          //  50 nS
        SIGNALFaktor_idx = 2;                                           // zoom factor 1 = 50 nS
//        Selected_Timebase = 4;                                          //  50 nS
//        SIGNALFaktor_idx = 0;                                           // zoom factor 1 = 50 nS
        SIGNAL_StartFr_idx = 0;                                         // running. so 0

        SIGNAL_StartFr_idx = 0;                                         // running. so 0

        timebase_reg = tb_value[Selected_Timebase];
        Display_Timebase = 17;                                          // Displayed timebase is 50 ns
//        Display_Timebase = 4;                                          // Displayed timebase is 50 ns
*/
        triggering = 0;								
        ctrl_reg = 0x0087;							                    // Trigger_Master / Trigger_INT / Free Run
        adc_ctrl_reg &= 0xFFF0;						                    // Disable Trigger sources

        pre_reg = 0x002D;
        Trigger_Offset_Pos = 162;

        if (Display_Timebase == 4)
        {
            pre_reg = 0x002D;
            Trigger_Offset_Pos = 162;
        }
        else if (Display_Timebase == 5)
        {
            pre_reg = 0x003C;
            Trigger_Offset_Pos = 162;
        }
        else if (Display_Timebase == 6)
        {
            pre_reg = 0x0055;
            Trigger_Offset_Pos = 262;
        }
        else if (Display_Timebase == 7)
        {
            pre_reg = 0x00A1;
            Trigger_Offset_Pos = 560;
        }
        else if (Display_Timebase == 8)
        {
            pre_reg = 0x0120;
            Trigger_Offset_Pos = 1075;
        }
        else if (Display_Timebase == 9)
        {
            pre_reg = 0x0120;
            Trigger_Offset_Pos = 1075;
        }
        else if (Display_Timebase == 10)
        {
            pre_reg = 0x0120;
            Trigger_Offset_Pos = 1075;
        }
        else if (Display_Timebase > 10)
        {
            pre_reg = 0x0110;
            Trigger_Offset_Pos = 252;
        }

        SetupADC();


#ifdef _Debug_FindVoltage_
            printf("Setup ADC - start record ctrl %x  pre %x  trig %d   irq %d\n", ctrl_reg, pre_reg, triggering, acq_ready->np_piodata);
#endif

        // first reag
        start_acq->np_piodata = 0x01;				//start record Port On
        start_acq->np_piodata = 0x00;				//start record Port Off	

        while (acq_ready->np_piodata == 0x01) {}

#ifdef _Debug_FindVoltage_
            printf("Data received\n");
#endif

        data_adr->np_piodata = 0x01;

        buf_long = READADC(1);
        buf_long = READADC(1);

        WRITEADC(1, ram_adress_reg);
        WRITEADC(2, ram_adress_reg);

        if (NumberOfChannels > 2)
        {
            WRITEADC(3, ram_adress_reg);
            WRITEADC(4, ram_adress_reg);
        }
    	
        data_adr->np_piodata = 0x00;

#ifdef _Debug_FindVoltage_
            printf("Start read out\n");
#endif         	

        switch(channel)
        {
            case 1 : ReadOut_Signal(1, 0, 0); break;
            case 2 : ReadOut_Signal(2, 0, 0); break;
            case 3 : ReadOut_Signal(3, 0, 0); break;
            case 4 : ReadOut_Signal(4, 0, 0); break;
        }

        buf_int = (int) ZFT_float;

        if (buf_int <= 0) buf_int = 1;


        switch(channel)
        {
            case 1 :
            {

                buf_min = 255;
                buf_max = 0;

#ifdef _Debug_FindVoltage_
                printf("acquire data\n");
#endif
                ix2 = 0;

                for (ix = 150; ix < 650; ix++)
                {
                    buf_byte = SIGNAL1[ix * buf_int];
                    buf_arr[ix2++] = buf_byte;
                    if (buf_min > buf_byte)
                    {
                        buf_min = buf_byte;
                        posmin = ix;
                    }
                    if (buf_max < buf_byte)
                    {
                        buf_max = buf_byte;
                        posmax = ix;
                    }
                }

                break;
            }
            case 2 :
            {
                buf_min = 255;
                buf_max = 0;

                ix2 = 0;

                for (ix = 150; ix < 650; ix++)
                {
                    buf_byte = SIGNAL2[ix * buf_int];
                    buf_arr[ix2++] = buf_byte;
                    if (buf_min > buf_byte)
                    {
                        buf_min = buf_byte;
                        posmin = ix;
                    }
                    if (buf_max < buf_byte)
                    {
                        buf_max = buf_byte;
                        posmax = ix;
                    }
                }

                break;
            }
            case 3 :
            {
                buf_min = 255;
                buf_max = 0;

                ix2 = 0;

                for (ix = 150; ix < 650; ix++)
                {
                    buf_byte = SIGNAL3[ix * buf_int];
                    buf_arr[ix2++] = buf_byte;
                    if (buf_min > buf_byte)
                    {
                        buf_min = buf_byte;
                        posmin = ix;
                    }
                    if (buf_max < buf_byte)
                    {
                        buf_max = buf_byte;
                        posmax = ix;
                    }
                }


                break;
            }
            case 4 :
            {
                buf_min = 255;
                buf_max = 0;

                ix2 = 0;

                for (ix = 150; ix < 650; ix++)
                {
                    buf_byte = SIGNAL4[ix * buf_int];
                    buf_arr[ix2++] = buf_byte;
                    if (buf_min > buf_byte)
                    {
                        buf_min = buf_byte;
                        posmin = ix;
                    }
                    if (buf_max < buf_byte)
                    {
                        buf_max = buf_byte;
                        posmax = ix;
                    }
                }

                break;
            }
        }

#ifdef _Debug_FindVoltage_
        printf("Min %d  Max %d  Volt %d \n", buf_min, buf_max, volt);

        for (ix2 = (posmin - 1); ix2 < (posmin + 10); ix2++) printf("S1[%3d] : %d\n", ix2, buf_arr[ix2]);
#endif
        if ((buf_min > topV) && (buf_max < bottomV) && (abs(buf_max - buf_min) > 40)) break;
    }
#ifdef _Debug_FindVoltage_
    printf("Res : Min %d  Max %d  Volt %d \n", buf_min, buf_max, volt);
#endif

	
    switch(channel)
    {
        case 1 : Selected_Voltage_CH1 = volt; SetSwitches(1, Selected_Voltage_CH1); VoltageChangedCh1 = 1; Display::DRAWSTATUS(1, 0); Rotary_Steps = 0; ON_Zero_Channel_1();break;											// Draw Voltage Channel 1
        case 2 : Selected_Voltage_CH2 = volt; SetSwitches(2, Selected_Voltage_CH2); VoltageChangedCh2 = 1; Display::DRAWSTATUS(2, 0); Rotary_Steps = 0; ON_Zero_Channel_2();break;											// Draw Voltage Channel 2
        case 3 : Selected_Voltage_CH3 = volt; SetSwitches(3, Selected_Voltage_CH3); VoltageChangedCh3 = 1; Display::DRAWSTATUS(3, 0); Rotary_Steps = 0; ON_Zero_Channel_3();break;											// Draw Voltage Channel 3
        case 4 : Selected_Voltage_CH4 = volt; SetSwitches(4, Selected_Voltage_CH4); VoltageChangedCh4 = 1; Display::DRAWSTATUS(4, 0); Rotary_Steps = 0; ON_Zero_Channel_4();break;											// Draw Voltage Channel 4

    }
    Display::DRAWSTATUS(6, 0);											// Draw TriggerLevel

#ifdef _Debug_FindVoltage_
    printf("Ready FV\n");
#endif
}

void Hardware::FindSlope(void)
{
	long buf_long = 0, buf_long1 = 0;
	int cnt = 0;
	// Only two channels so far
	
    Hardware::DoDisableUARTInterrupt();
    Hardware::DoDisableADCInterrupt();
    Hardware::DoDisableKeyInterrupt();
    Hardware::DoDisableRotInterrupt();

    Stop_Record();


    AutoTimerOff = true;    	
/*	
    Display::DRAWROUNDBUTTON(230, 180, 220, 80, 0, 0);
    Display::TEXTOUTxvbig("For startup calibration", 247, 192, 1, UI_Plane2);
    Display::TEXTOUTxvbig("remove all input lines.", 247, 212, 1, UI_Plane2);
    Display::TEXTOUTxvbig("Press any key to continue.", 247, 232, 1, UI_Plane2);

  //  printf("Press a key\n");

	key_reset->np_piodata = 0;										// Reset Keyboard
	nr_delay(1);
	key_reset->np_piodata = 1;
	key_int->np_pioedgecapture = 0;									// clear IRQ conditions	
*/	
 //   while (key_int->np_pioedgecapture == 0) {};

//   printf("Yes, a key\n");
	
	// Backup old
    triggering_bak = triggering;
    ctrl_reg_bak = ctrl_reg;
    adc_ctrl_reg_bak = adc_ctrl_reg;
    adc_change12_reg_bak = adc_change12_reg;
    adc_change34_reg_bak = adc_change34_reg;

    Selected_Timebase_bak = Selected_Timebase;
    SIGNALFaktor_idx_bak = SIGNALFaktor_idx;
    SIGNAL_StartFr_idx_bak = SIGNAL_StartFr_idx;
    timebase_reg_bak = timebase_reg;
    Display_Timebase_bak = Display_Timebase;
    Continius_bak = Continius;
    SingleMode_bak = SingleMode;

    Selected_Voltage_CH1_bak = Selected_Voltage_CH1;
    Selected_Voltage_CH2_bak = Selected_Voltage_CH2;
    Selected_Voltage_CH3_bak = Selected_Voltage_CH3;
    Selected_Voltage_CH4_bak = Selected_Voltage_CH4;   	

    ZeroLevelCH1_bak = ZeroLevelCH1;
    ZeroLevelCH2_bak = ZeroLevelCH2;
    ZeroLevelCH3_bak = ZeroLevelCH3;
    ZeroLevelCH4_bak = ZeroLevelCH4;

    Virtual_ZeroLevelCH1_bak = Virtual_ZeroLevelCH1;
    Virtual_ZeroLevelCH2_bak = Virtual_ZeroLevelCH2;
    Virtual_ZeroLevelCH3_bak = Virtual_ZeroLevelCH3;
    Virtual_ZeroLevelCH4_bak = Virtual_ZeroLevelCH4;


    Channel1_Zero_Sign_Offset_1_bak = Channel1_Zero_Sign_Offset_1;	
    Channel1_Zero_Sign_Offset_2_bak = Channel1_Zero_Sign_Offset_2;
    Channel1_Zero_Sign_Offset_3_bak = Channel1_Zero_Sign_Offset_3;

    Channel2_Zero_Sign_Offset_1_bak = Channel2_Zero_Sign_Offset_1;	
    Channel2_Zero_Sign_Offset_2_bak = Channel2_Zero_Sign_Offset_2;
    Channel2_Zero_Sign_Offset_3_bak = Channel2_Zero_Sign_Offset_3;

    Channel3_Zero_Sign_Offset_1_bak = Channel3_Zero_Sign_Offset_1;	
    Channel3_Zero_Sign_Offset_2_bak = Channel3_Zero_Sign_Offset_2;
    Channel3_Zero_Sign_Offset_3_bak = Channel3_Zero_Sign_Offset_3;

    Channel4_Zero_Sign_Offset_1_bak = Channel4_Zero_Sign_Offset_1;	
    Channel4_Zero_Sign_Offset_2_bak = Channel4_Zero_Sign_Offset_2;
    Channel4_Zero_Sign_Offset_3_bak = Channel4_Zero_Sign_Offset_3;
	
	// set test data
	
    Channel1_Zero_Sign_Offset_1 = 0;	
    Channel1_Zero_Sign_Offset_2 = 0;
    Channel1_Zero_Sign_Offset_3 = 0;

    Channel2_Zero_Sign_Offset_1 = 0;	
    Channel2_Zero_Sign_Offset_2 = 0;
    Channel2_Zero_Sign_Offset_3 = 0;

    Channel3_Zero_Sign_Offset_1 = 0;	
    Channel3_Zero_Sign_Offset_2 = 0;
    Channel3_Zero_Sign_Offset_3 = 0;

    Channel4_Zero_Sign_Offset_1 = 0;	
    Channel4_Zero_Sign_Offset_2 = 0;
    Channel4_Zero_Sign_Offset_3 = 0;	

    ZeroLevelCH1 = 192;
    Virtual_ZeroLevelCH1 = 0;                                 // Virtual ZeroLevel
    CH1_Zero_Offset = 0;                                        // Shift offset when stopped

    ZeroLevelCH2 = 192;
    Virtual_ZeroLevelCH2 = 0;                                 // Virtual ZeroLevel
    CH2_Zero_Offset = 0;                                        // Shift offset when stopped

    Rotary_Steps = 0;
    Hardware::ON_Zero_Channel_1();

    nr_delay(100);

    Rotary_Steps = 0;
    Hardware::ON_Zero_Channel_2();

    Hardware::SetSwitches(1, 11);

    nr_delay(100);

    Hardware::SetSwitches(2, 11);    	

    nr_delay(100);

    Selected_Timebase = 4;                                          //  50 nS
    SIGNALFaktor_idx = 0;                                           // zoom factor 1 = 50 nS
    SIGNAL_StartFr_idx = 0;                                         // running. so 0

    timebase_reg = tb_value[Selected_Timebase];
    Display_Timebase = 4;                                          // Displayed timebase is 50 ns

    HoldOff_Value = 0;
    triggering = 0;								
    //ctrl_reg &= 0xC0FF;							// Clear Pulse and HoldOff bits
    ctrl_reg = 0x0087;							                    // Trigger_Master / Trigger_INT / Free Run
    adc_ctrl_reg &= 0x0100;						                    // Disable Trigger sources
	                     	

    // test generator settings
    adc_change12_reg = 0x30000000;                //  Bit 28 - TestGenerator  - Filter
    adc_change34_reg = 0x10000000;                //  Bit 28 - TestGenerator
    SwitchesCH2 = 0x66DA;                       // TestCounter CH I - IV + 5V Channel II
					
    Hardware::SetSwitches(2, -1);


    la_pulse->np_piodata = 0x01;				//stop record Port On
    la_pulse->np_piodata = 0x00;				//stop record Port Off	
                             																						
    Hardware::SetupADC();
    nr_delay(100);
    Hardware::SetupADC();

    // Run as long not found


//    Hardware::READADC(1);

    acq_ready->np_pioedgecapture = 0;
    acq_ready->np_piodata = 0x00;

 //   while ((buf_long & 0x1000) == 0)
    {
        // first reag
        start_acq->np_piodata = 0x01;				//start record Port On
        start_acq->np_piodata = 0x00;				//start record Port Off

        //printf("slope started\n");	

        while (acq_ready->np_piodata == 0x01)
        {
//#ifdef _Debug_
            //printf("1\n");
            nr_delay(500);
/*
            Hardware::SetupADC();
            start_acq->np_piodata = 0x01;				//start record Port On
            start_acq->np_piodata = 0x00;				//start record Port Off	
*/
            cnt++;
            if (cnt == 20)
            {
//                printf("Slope stoped");
                break;
            }
//#endif
        }


        data_adr->np_piodata = 0x01;

        buf_long = Hardware::READADC(1);
        buf_long1 = Hardware::READADC(1);

        Hardware::WRITEADC(1, ram_adress_reg);
        Hardware::WRITEADC(2, ram_adress_reg);

        if (NumberOfChannels > 2)
        {
            Hardware::WRITEADC(3, ram_adress_reg);
            Hardware::WRITEADC(4, ram_adress_reg);
        }
    	
        data_adr->np_piodata = 0x00;

        ReadOut_Signal(1, buf_long, 0);
        ReadOut_Signal(2, buf_long, 0);
        if (NumberOfChannels > 2)
        {
            ReadOut_Signal(3, buf_long, 0);
            ReadOut_Signal(4, buf_long, 0);
        }
#ifdef _Debug_
        printf("bl %04x bl1 %08x\n", buf_long, buf_long1);
#endif
    }

    la_gate->np_piodata = 0x00;
    slope_value = la_data->np_piodata;


    // restore old
    triggering = triggering_bak;
    ctrl_reg = ctrl_reg_bak;
    adc_ctrl_reg = adc_ctrl_reg_bak;

    Continius = Continius_bak;
    SingleMode = SingleMode_bak;
    UserIface_active = 0;

    SwitchesCH2 &= 0x00FF;
    adc_change12_reg = adc_change12_reg_bak;
    adc_change34_reg = adc_change34_reg_bak;

    Selected_Timebase = Selected_Timebase_bak;
    SIGNALFaktor_idx = SIGNALFaktor_idx_bak;
    SIGNAL_StartFr_idx = SIGNAL_StartFr_idx_bak;
    timebase_reg = timebase_reg_bak;
    Display_Timebase = Display_Timebase_bak;

    Selected_Voltage_CH1 = Selected_Voltage_CH1_bak;
    Selected_Voltage_CH2 = Selected_Voltage_CH2_bak;
    Selected_Voltage_CH3 = Selected_Voltage_CH3_bak;
    Selected_Voltage_CH4 = Selected_Voltage_CH4_bak;   	

    ZeroLevelCH1 = ZeroLevelCH1_bak;
    ZeroLevelCH2 = ZeroLevelCH2_bak;
    ZeroLevelCH3 = ZeroLevelCH3_bak;
    ZeroLevelCH4 = ZeroLevelCH4_bak;

    Virtual_ZeroLevelCH1 = Virtual_ZeroLevelCH1_bak;
    Virtual_ZeroLevelCH2 = Virtual_ZeroLevelCH2_bak;
    Virtual_ZeroLevelCH3 = Virtual_ZeroLevelCH3_bak;
    Virtual_ZeroLevelCH4 = Virtual_ZeroLevelCH4_bak;

    Channel1_Zero_Sign_Offset_1 = Channel1_Zero_Sign_Offset_1_bak;	
    Channel1_Zero_Sign_Offset_2 = Channel1_Zero_Sign_Offset_2_bak;
    Channel1_Zero_Sign_Offset_3 = Channel1_Zero_Sign_Offset_3_bak;

    Channel2_Zero_Sign_Offset_1 = Channel2_Zero_Sign_Offset_1_bak;	
    Channel2_Zero_Sign_Offset_2 = Channel2_Zero_Sign_Offset_2_bak;
    Channel2_Zero_Sign_Offset_3 = Channel2_Zero_Sign_Offset_3_bak;

    Channel3_Zero_Sign_Offset_1 = Channel3_Zero_Sign_Offset_1_bak;	
    Channel3_Zero_Sign_Offset_2 = Channel3_Zero_Sign_Offset_2_bak;
    Channel3_Zero_Sign_Offset_3 = Channel3_Zero_Sign_Offset_3_bak;

    Channel4_Zero_Sign_Offset_1 = Channel4_Zero_Sign_Offset_1_bak;	
    Channel4_Zero_Sign_Offset_2 = Channel4_Zero_Sign_Offset_2_bak;
    Channel4_Zero_Sign_Offset_3 = Channel4_Zero_Sign_Offset_3_bak;

    Hardware::UpdateTrigger(33);

    Rotary_Steps = 0;
    Hardware::ON_Zero_Channel_1();
    Rotary_Steps = 0;
    Hardware::ON_Zero_Channel_2();

    Hardware::SetSwitches(1, Selected_Voltage_CH1);
    Hardware::SetSwitches(2, Selected_Voltage_CH2);


/*
    Display::DRAWROUNDBUTTON(230, 180, 220, 80, 0, 1);
    Display::TEXTOUTxvbig("For startup calibration", 247, 192, 0, UI_Plane2);
    Display::TEXTOUTxvbig("remove all input lines.", 247, 212, 0, UI_Plane2);
    Display::TEXTOUTxvbig("Press any key to continue.", 247, 232, 0, UI_Plane2);	
*/
    AutoTimerOff = false;    	

    Hardware::DoEnableRotInterrupt();
    Hardware::DoEnableKeyInterrupt();
    Hardware::DoEnableADCInterrupt();
    Hardware::DoEnableUARTInterrupt();	
#ifdef _Debug_
    printf("Slope : %x\n", slope_value);
#endif
}

/*

int Hardware::FindTimebase(char channel)
{
    int ix, result, cnt = 0;
    int buf_int = 0;
    float buf_float = 0;
    long buf_long = 0;
    long buf_long2 = 0;

    char buf_byte = 0;
    char buf_byte2 = 0;

    int zl_buf = 0;

    switch(channel)
    {
        case 1 : zl_buf = (ZeroLevelCH1 + 64) >> 1; break;
        case 2 : zl_buf = (ZeroLevelCH2 + 64) >> 1; break;
        case 3 : zl_buf = (ZeroLevelCH3 + 64) >> 1; break;
        case 4 : zl_buf = (ZeroLevelCH4 + 64) >> 1; break;
    }

    result = 0;
			
    while ((result < 30) || (result > 60))
    {
        start_acq->np_piodata = 0x01;				//start record Port On
        start_acq->np_piodata = 0x00;				//start record Port Off	

        while (acq_ready->np_piodata == 0x01) {}

        data_adr->np_piodata = 0x01;

        buf_long = READADC(1);
        buf_long = READADC(1);

        WRITEADC(1, ram_adress_reg);
        WRITEADC(2, ram_adress_reg);

        if (NumberOfChannels > 2)
        {
            WRITEADC(3, ram_adress_reg);
            WRITEADC(4, ram_adress_reg);
        }
    	
        data_adr->np_piodata = 0x00;
	
        for (cnt = 0; cnt < 25; cnt++)
        {
            switch(channel)
            {
                case 1 : buf_long = READADC(1); break;
                case 2 : buf_long = READADC(2); break;
                case 3 : buf_long = READADC(3); break;
                case 4 : buf_long = READADC(4); break;
            }
        }	
	
        switch(channel)
        {
            case 1 : buf_long = READADC(1) ^ 0xFFFFFFFF; break;
            case 2 : buf_long = READADC(2) ^ 0xFFFFFFFF; break;
            case 3 : buf_long = READADC(3) ^ 0xFFFFFFFF; break;
            case 4 : buf_long = READADC(4) ^ 0xFFFFFFFF; break;
        }

        buf_byte = (buf_long & 0xFF);
	
//        buf_int = (int) ZFT_float;
 //     if (buf_int < 1) buf_int = 1;

        printf("stb %d  %d\n", Selected_Timebase, SIGNALFaktor_idx);
        printf("st %d\n", SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float));
        printf("sp %d\n", SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float));
	
        result = 0;

        for (ix = SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float); ix < SIG_Start_Stop[ZIT_short][1] + (int)((float) Timebase_Offset_Pos * OFT_float); ix++)
        {
            switch(channel)
            {
                case 1 : buf_long2 = READADC(1) ^ 0xFFFFFFFF; break;
                case 2 : buf_long2 = READADC(2) ^ 0xFFFFFFFF; break;
                case 3 : buf_long2 = READADC(3) ^ 0xFFFFFFFF; break;
                case 4 : buf_long2 = READADC(4) ^ 0xFFFFFFFF; break;
            }
            buf_byte2 = (buf_long2 & 0xFF);

            if ((buf_byte < zl_buf) && (buf_byte2 > zl_buf))
            {
                result++;
            }

            buf_byte = buf_byte2;
        }

        printf("FTB %d\n", result);
			
        if (result < 30)
        {
            if ((Selected_Timebase < 4) && (SIGNALFaktor_idx == 0)) Selected_Timebase++;
            else if (SIGNALFaktor_idx < 4) SIGNALFaktor_idx++;
            else if (Selected_Timebase < 31) Selected_Timebase++;

            timebase_reg = tb_value[Selected_Timebase];
            SetupADC();
        }

        if (result > 60)
        {
            if ((Selected_Timebase > 4) && (SIGNALFaktor_idx == 4)) Selected_Timebase--;
            else if (SIGNALFaktor_idx > 0) SIGNALFaktor_idx--;
            else if ((Selected_Timebase > 2) && (SIGNALFaktor_idx == 0)) Selected_Timebase--;

            timebase_reg = tb_value[Selected_Timebase];
            SetupADC();
        }
    }

    return result;
}

*/

void Hardware::DoEnableReadVSyncInterrupt(void)						// Enable ReadVSync service routine
{

	read_vsync->np_pioedgecapture = 0x00; 							// clear existing IRQ conditions
	read_vsync->np_piodirection = 0;								// set bit to input
	read_vsync->np_piointerruptmask = 0x01;							// enable interrupt

	nr_installuserisr(na_read_vsync_irq,ISR_ReadVSync_INT,(int)read_vsync);		// Install ISR for ReadVSync
#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("read_vsync interrupt enabled.\n"); 					// print on console
#endif	

}

void Hardware::DoDisableReadVSyncInterrupt(void)					// Disable ReadVSync service routine
{
	nr_installuserisr(na_read_vsync_irq,0,0); 						// Install empty routine for ReadVSync irq
	read_vsync->np_piointerruptmask = 0x00;							// disable all IRQs
}

void Hardware::ISR_ReadVSync_INT(int context)						// ReadVSync interrupt subroutine
{
    tc_test_var2++;
	VSync_Needed = 1;	
	vs_counter++;
	read_vsync->np_pioedgecapture = 0;								// clear IRQ conditions	

#ifdef _Debug_IRQ_
	//if (Debug_Mode) printf("read_vsync interrupt enabled.\n"); 					// print on console
#endif		
}

void Hardware::TransferPlanes(void)
{
    int cnt;

    if (VSync_Needed == 0) return;
    if (MenuPopupActive > -1) return;

    if (UpdateMarkerPlane) TransferPlanes_asm_persistant(0x008CABE4, 0x009D9DF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
    UpdateMarkerPlane = false;

    if (UpdateMenuTextPlane)
    {
        TransferDataPlane_asm_persistant(0x008DBB24, 0x00970F30);
    }
    UpdateMenuTextPlane = false;

    if (Splash_drawed) return;
    
    //printf("ClearPlane : %x  started : %d MenuStatus[1][2]x : %d \n", ClearPlane, adc_started, MenuStatus[1][2]);

	//reset_watchdog->np_piodata = 0x00;								// Disable WatchDog 	   	
      	   	
    if (MenuStatus[5][0] == 240)
    {
        switch(ClearPlane)
        {
            case 0x01 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1); break;
            case 0x02 : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1); break;
            case 0x03 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 2); break;
            case 0x04 : TransferPlanes_asm(0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1); break;	
            case 0x05 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2); break;
            case 0x06 : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2); break;	
            case 0x07 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 3); break;
            case 0x08 : TransferPlanes_asm(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1); break;
            case 0x09 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2); break;
            case 0x0A : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2); break;	
            case 0x0B : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 3); break;
            case 0x0C : TransferPlanes_asm(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2); break;	
            case 0x0D : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3); break;
            case 0x0E : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3); break;

            case 0x0F :
            {
                TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                break;
            }

            case 0x10 : TransferPlanes_asm(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1); break;	
            case 0x11 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2); break;
            case 0x12 : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2); break;	
            case 0x13 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 3); break;	
            case 0x14 : TransferPlanes_asm(0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2); break;
            case 0x15 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3); break;	
            case 0x16 : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3); break;

            case 0x17 :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                break;
            }

            case 0x18 : TransferPlanes_asm(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2); break;		
            case 0x19 : TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3); break;		
            case 0x1A : TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3); break;		

            case 0x1B :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1C : TransferPlanes_asm(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3); break;	

            case 0x1D :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1E :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1F :
            {
                TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 5);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 5);
                break;
            }  		
        }
    }
    else
    {	
        switch(ClearPlane)
        {
            case 0x01 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);break;
            case 0x02 : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);break;
            case 0x03 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 2);break;
            case 0x04 : TransferPlanes_asm_persistant(0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);break;	
            case 0x05 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2);break;
            case 0x06 : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2);break;
            case 0x07 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 3);break;
            case 0x08 : TransferPlanes_asm_persistant(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);break;                               		
            case 0x09 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);break;
            case 0x0A : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);break;
            case 0x0B : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 3);break;
            case 0x0C : TransferPlanes_asm_persistant(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);break;
            case 0x0D : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3);break;
            case 0x0E : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3);break;

            case 0x0F :
            {
                TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                break;
            }

            case 0x10 : TransferPlanes_asm_persistant(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);break;
            case 0x11 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);break;
            case 0x12 : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);break;
            case 0x13 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 3);break;
            case 0x14 : TransferPlanes_asm_persistant(0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);break;
            case 0x15 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3);break;
            case 0x16 : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3);break;

            case 0x17 :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
                break;
            }

            case 0x18 : TransferPlanes_asm_persistant(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);break;                              		
            case 0x19 : TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);break;     		
            case 0x1A : TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);break;

            case 0x1B :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1C : TransferPlanes_asm_persistant(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);break;

            case 0x1D :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1E :
            {
                TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                else TransferPlanes_asm_persistant(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
                break;
            }

            case 0x1F :
            {
                TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0);
                if (MenuStatus[5][0] == 240) TransferPlanes_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 5);
                else TransferPlanes_asm_persistant(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 5);
                break;
            }
        }
    }

     /*
	// pixel error correction
	if ((ClearPlane & 0x01) == 0x01)
    {
    //    for (cnt = 20; cnt < 480; cnt++) Buffer_Plane1[cnt * 20] = Buffer_Plane1[cnt * 20] << 2;	
        	
    }

    for (cnt = 20; cnt < 480; cnt++)
    {
        if ((ClearPlane & 0x01) == 0x01) Channel_Plane1[cnt * 20] = Channel_Plane1[cnt * 20] << 2;
        if ((ClearPlane & 0x02) == 0x02) Channel_Plane2[cnt * 20] = Channel_Plane2[cnt * 20] << 2;
        if ((ClearPlane & 0x04) == 0x04) Channel_Plane3[cnt * 20] = Channel_Plane3[cnt * 20] << 2;
        if ((ClearPlane & 0x08) == 0x08) Channel_Plane4[cnt * 20] = Channel_Plane4[cnt * 20] << 2;
        if ((ClearPlane & 0x10) == 0x10) Channel_Math_Plane[cnt * 20] = Channel_Math_Plane[cnt * 20] << 2;

    }
    */

	if (Splash_drawed == false)
	{
        if (init_done) Display::DRAWSIGNS();//DRAWSIGNS();

        if (Menu_Changed) Display::UpdateMenu();
    }

	ClearPlane &= 0xE0;	
    VSync_Needed = 0;
    	
	//reset_watchdog->np_piodata = 0x01;								// Enable WatchDog	
	
	/////if ((adc_started == false) && (SingleMode == false) && (Continius) && (OneShotRestart == false) && (UserIface_active == false)&& (ROLLMODE_STARTED == false)) Hardware::Start_Record();
}

void Hardware::ClearPlanes(void)
{
//	reset_watchdog->np_piodata = 0x00;								// Disable WatchDog
	
    if (Channel_1_Active == 1) DrawPlane |= 0x01;	
    if (Channel_2_Active == 1) DrawPlane |= 0x02;
    if (Channel_Math_Active == 1) DrawPlane |= 0x10;

    if (NumberOfChannels > 2)
    {
        if (Channel_3_Active == 1) DrawPlane |= 0x04;
        if (Channel_4_Active == 1) DrawPlane |= 0x08;
    }
#ifdef _Debug_
    printf("we clear\n");
#endif       	
    ClearPlane = DrawPlane | RemovePlane;
    DrawPlane = 0;
   	   	
	switch(ClearPlane)
	{
	    case 0x01 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
            break;
		}
	    case 0x02 :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
            break;
		}
	    case 0x03 :
	    {  	
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x00000000, 0x00000000, 2);
            break;
		}
	    case 0x04 :
	    {
            TransferPlanes_clear_asm(0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
            break;	
		}
	    case 0x05 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2);
            break;
		}
	    case 0x06 :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x00000000, 0x00000000, 2);
            break;	
		}
	    case 0x07 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 3);
            break;
		}	
        case 0x08 :
	    {
            TransferPlanes_clear_asm(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
            break;
		}                                        		
        case 0x09 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);
            break;
		}
        case 0x0A :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);
            break;	
		}
        case 0x0B :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 3);
            break;
		}
        case 0x0C :
	    {
            TransferPlanes_clear_asm(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000, 2);
            break;	
		}
        case 0x0D :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3);
            break;
		}
        case 0x0E :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 3);
            break;
		}
        case 0x0F :
	    {
            TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x00000000, 0x00000000);
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
            break;
		}     	
	    case 0x10 :
	    {
            TransferPlanes_clear_asm(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1);
            break;	
		}
	    case 0x11 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);
            break;
		}
	    case 0x12 :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);
            break;	
		}
	    case 0x13 :
	    {  	
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009311F0, 0x009B45F0, 3);
            break;	
		}
	    case 0x14 :
	    {
            TransferPlanes_clear_asm(0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);
            break;
		}
	    case 0x15 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3);
            break;	
		}
	    case 0x16 :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009311F0, 0x009B45F0, 3);
            break;
		}
	    case 0x17 :
	    {
            TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 4);
            break;		
		}
        case 0x18 :
	    {
            TransferPlanes_clear_asm(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 0x00000000, 0x00000000, 2);
            break;		
		}                                        		
        case 0x19 :
	    {
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);
            break;		
		}               		
        case 0x1A :
	    {
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);
            break;		
		}
        case 0x1B :
	    {
            TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);	
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x009569F0, 0x009AAFF0, 4);
            break;		
		}
        case 0x1C :
	    {
            TransferPlanes_clear_asm(0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0, 3);
            break;	
		}
        case 0x1D :
	    {
            TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
            break;
		}
        case 0x1E :
	    {
            TransferPlane_Set_Buffer_Adr(0x009311F0, 0x009B45F0, 0x00000000, 0x00000000);
            TransferPlanes_clear_asm(0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 0x009569F0, 0x009AAFF0, 4);
            break;	
		}           		
        case 0x1F :
	    {
            TransferPlane_Set_Buffer_Adr(0x009569F0, 0x009AAFF0, 0x009311F0, 0x009B45F0);
            TransferPlanes_clear_asm(0x0093A7F0, 0x0098EDF0, 0x00943DF0, 0x009983F0, 0x0094D3F0, 0x009A19F0, 5);
            break;
		}		
	}	
	
	if (init_done) Display::DRAWSIGNS();

	ClearPlane &= 0xE0;	
    	
//	reset_watchdog->np_piodata = 0x01;								// Enable WatchDog	
}

void Hardware::TransferDataPlane_asm_persistant(unsigned long Buffer_Adr1, unsigned long Plane_Adr1)
{
	asm("
            PFX	    %hi(1460)                         ; Set Counter
            MOVI	%l1,%lo(1460)

            loopmtpp1:
            LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
            ST     [%i1], %l0                        ; Store it to Plane
                                                               	
            ADDI   %i0, 4                            ; Add Address Counter
            ADDI   %i1, 4	
	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     loopmtpp1
            NOP 	
        ");
}

void Hardware::TransferPlane_Set_Buffer_Adr(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2)
{
    asm("
            MOV		%r4,%i0	
            MOV		%r5,%i1

            MOV		%r6,%i2
            MOV		%r7,%i3
        ");
}

void Hardware::TransferPlanes_asm(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count)
{
	switch(count)
	{
	    case 1 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptp1:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                    ST     [%i0], %l2                        ; Clear Buffer

                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptp1
                    NOP 	
                ");
            break;
        }
	    case 2 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptp2:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                    ST     [%i0], %l2                        ; Clear Buffer

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                    ST     [%i2], %l2                        ; Clear Buffer
                                                              	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptp2
                    NOP 	
                ");
            break;
        }

	    case 3 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptp3:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                    ST     [%i0], %l2                        ; Clear Buffer

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                    ST     [%i2], %l2                        ; Clear Buffer

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane
                    ST     [%i4], %l2                        ; Clear Buffer
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptp3
                    NOP 	
                ");
            break;
        }

	    case 4 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptp4:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                    ST     [%i0], %l2                        ; Clear Buffer

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                    ST     [%i2], %l2                        ; Clear Buffer

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane
                    ST     [%i4], %l2                        ; Clear Buffer

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane
                    ST     [%r4], %l2                        ; Clear Buffer
                          	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptp4
                    NOP 	
                ");
            break;
        }                        	
	    case 5 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptp5:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                    ST     [%i0], %l2                        ; Clear Buffer

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                    ST     [%i2], %l2                        ; Clear Buffer

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane
                    ST     [%i4], %l2                        ; Clear Buffer

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane
                    ST     [%r4], %l2                        ; Clear Buffer

                    LD     %l0, [%r6]                        ; Load Buffer Data to %r0
                    ST     [%r7], %l0                       ; Store it to Plane
                    ST     [%r6], %l2                        ; Clear Buffer
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    ADDI   %r6, 4
                    ADDI   %r7, 4		
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptp5
                    NOP 	
                ");
            break;
        }
    }
}

void Hardware::TransferPlanes_asm_persistant(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count)
{
	switch(count)
	{
	    case 1 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    looptpp1:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpp1
                    NOP 	
                ");
            break;
        }
	    case 2 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)
	
                    looptpp2:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                                                              	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpp2
                    NOP 	
                ");
            break;
        }

	    case 3 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)
	
                    looptpp3:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpp3
                    NOP 	
                ");
            break;
        }
	    case 4 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    looptpp4:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane
                          	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpp4
                    NOP 	
                ");
            break;
        }                        	
	    case 5 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    looptpp5:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane

                    LD     %l0, [%r6]                        ; Load Buffer Data to %r0
                    ST     [%r7], %l0                       ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    ADDI   %r6, 4
                    ADDI   %r7, 4		
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpp5
                    NOP 	
                ");
            break;
        }
    }
}

void Hardware::TransferPlanes_clear_asm(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count)
{
	switch(count)
	{
	    case 1 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptpc1:
                    ST     [%i0], %l2                        ; Clear Buffer
                    ST     [%i1], %l2                        ; Store it to Plane

                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpc1
                    NOP 	
                ");
            break;
        }
	    case 2 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptpc2:
                    ST     [%i0], %l2                        ; Clear Buffer
                    ST     [%i1], %l2                        ; Store it to Plane

                    ST     [%i2], %l2                        ; Clear Buffer
                    ST     [%i3], %l2                        ; Store it to Plane
                                                              	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpc2
                    NOP 	
                ");
            break;
        }

	    case 3 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptpc3:
                    ST     [%i0], %l2                        ; Clear Buffer
                    ST     [%i1], %l2                        ; Store it to Plane

                    ST     [%i2], %l2                        ; Clear Buffer
                    ST     [%i3], %l2                        ; Store it to Plane

                    ST     [%i4], %l2                        ; Clear Buffer
                    ST     [%i5], %l2                        ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpc3
                    NOP 	
                ");
            break;
        }
	    case 4 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptpc4:
                    ST     [%i0], %l2                        ; Clear Buffer
                    ST     [%i1], %l2                        ; Store it to Plane

                    ST     [%i2], %l2                        ; Clear Buffer
                    ST     [%i3], %l2                        ; Store it to Plane

                    ST     [%i4], %l2                        ; Clear Buffer
                    ST     [%i5], %l2                        ; Store it to Plane

                    ST     [%r4], %l2                        ; Clear Buffer
                    ST     [%r5], %l2                        ; Store it to Plane
                          	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpc4
                    NOP 	
                ");
            break;
        }                        	
	    case 5 :
	    {
	        asm("
                    PFX	    %hi(7740)                         ; Set Counter
                    MOVI	%l1,%lo(7740)

                    PFX	    %hi(0)                            ; Set Clear register
                    MOVI	%l2,%lo(0)
                    PFX	    %xhi(0)
                    MOVHI	%l2,%xlo(0)	
	
                    looptpc5:
                    ST     [%i0], %l2                        ; Clear Buffer
                    ST     [%i1], %l2                        ; Store it to Plane

                    ST     [%i2], %l2                        ; Clear Buffer
                    ST     [%i3], %l2                        ; Store it to Plane

                    ST     [%i4], %l2                        ; Clear Buffer
                    ST     [%i5], %l2                        ; Store it to Plane

                    ST     [%r4], %l2                        ; Clear Buffer
                    ST     [%r5], %l2                        ; Store it to Plane

                    ST     [%r6], %l2                        ; Clear Buffer
                    ST     [%r7], %l2                        ; Store it to Plane

                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    ADDI   %r6, 4
                    ADDI   %r7, 4		
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     looptpc5
                    NOP 	
                ");
            break;
        }
    }
}

void Hardware::Planes_clear_asm(unsigned long Buffer_Adr1)
{
	asm("
            PFX	    %hi(7740)                         ; Set Counter
            MOVI	%l1,%lo(7740)

            PFX	    %hi(0)                            ; Set Clear register
            MOVI	%l2,%lo(0)
            PFX	    %xhi(0)
            MOVHI	%l2,%xlo(0)	
	
        looptpcc1:
            ST     [%i0], %l2                        ; Clear Buffer

            ADDI   %i0, 4                            ; Add Address Counter
	
            SUBI   %l1, 1                            ; Decrement Line Counter
            SKPS   cc_z
            BR     looptpcc1
            NOP 	
        ");
}

void Hardware::Planes_clear_asm_all(unsigned char count, unsigned long Buffer_Adr1, unsigned long Buffer_Adr2, unsigned long Buffer_Adr3, unsigned long Buffer_Adr4, unsigned long Buffer_Adr5)
{
    switch(count)
    {
        case 1 :
        {
	       asm("
                PFX	    %hi(7740)                         ; Set Counter
                MOVI	%l1,%lo(7740)

                PFX	    %hi(0)                            ; Set Clear register
                MOVI	%l2,%lo(0)
                PFX	    %xhi(0)
                MOVHI	%l2,%xlo(0)	
	
            looptpcc21:
                ST     [%i1], %l2                        ; Clear Buffer

                ADDI   %i1, 4                            ; Add Address Counter
            	
                SUBI   %l1, 1                            ; Decrement Line Counter
                SKPS   cc_z
                BR     looptpcc21
                NOP 	
            ");
            break;
        }
        case 2 :
        {
	       asm("
                PFX	    %hi(7740)                         ; Set Counter
                MOVI	%l1,%lo(7740)

                PFX	    %hi(0)                            ; Set Clear register
                MOVI	%l2,%lo(0)
                PFX	    %xhi(0)
                MOVHI	%l2,%xlo(0)	
	
            looptpcc22:
                ST     [%i1], %l2                        ; Clear Buffer
                ST     [%i2], %l2                        ; Clear Buffer

                ADDI   %i1, 4                            ; Add Address Counter
                ADDI   %i2, 4                            ; Add Address Counter
            	
                SUBI   %l1, 1                            ; Decrement Line Counter
                SKPS   cc_z
                BR     looptpcc22
                NOP 	
            ");
            break;
        }
        case 3 :
        {
	       asm("
                PFX	    %hi(7740)                         ; Set Counter
                MOVI	%l1,%lo(7740)

                PFX	    %hi(0)                            ; Set Clear register
                MOVI	%l2,%lo(0)
                PFX	    %xhi(0)
                MOVHI	%l2,%xlo(0)	
	
            looptpcc23:
                ST     [%i1], %l2                        ; Clear Buffer
                ST     [%i2], %l2                        ; Clear Buffer
                ST     [%i3], %l2                        ; Clear Buffer

                ADDI   %i1, 4                            ; Add Address Counter
                ADDI   %i2, 4                            ; Add Address Counter
                ADDI   %i3, 4                            ; Add Address Counter
            	
                SUBI   %l1, 1                            ; Decrement Line Counter
                SKPS   cc_z
                BR     looptpcc23
                NOP 	
            ");
            break;
        }
        case 4 :
        {
	       asm("
                PFX	    %hi(7740)                         ; Set Counter
                MOVI	%l1,%lo(7740)

                PFX	    %hi(0)                            ; Set Clear register
                MOVI	%l2,%lo(0)
                PFX	    %xhi(0)
                MOVHI	%l2,%xlo(0)	
	
            looptpcc24:
                ST     [%i1], %l2                        ; Clear Buffer
                ST     [%i2], %l2                        ; Clear Buffer
                ST     [%i3], %l2                        ; Clear Buffer
                ST     [%i4], %l2                        ; Clear Buffer

                ADDI   %i1, 4                            ; Add Address Counter
                ADDI   %i2, 4                            ; Add Address Counter
                ADDI   %i3, 4                            ; Add Address Counter
                ADDI   %i4, 4                            ; Add Address Counter
            	
                SUBI   %l1, 1                            ; Decrement Line Counter
                SKPS   cc_z
                BR     looptpcc24
                NOP 	
            ");
            break;
        }
        case 5 :
        {
	       asm("
                PFX	    %hi(7740)                         ; Set Counter
                MOVI	%l1,%lo(7740)

                PFX	    %hi(0)                            ; Set Clear register
                MOVI	%l2,%lo(0)
                PFX	    %xhi(0)
                MOVHI	%l2,%xlo(0)	
	
            looptpcc25:
                ST     [%i1], %l2                        ; Clear Buffer
                ST     [%i2], %l2                        ; Clear Buffer
                ST     [%i3], %l2                        ; Clear Buffer
                ST     [%i4], %l2                        ; Clear Buffer
                ST     [%i5], %l2                        ; Clear Buffer

                ADDI   %i1, 4                            ; Add Address Counter
                ADDI   %i2, 4                            ; Add Address Counter
                ADDI   %i3, 4                            ; Add Address Counter
                ADDI   %i4, 4                            ; Add Address Counter
                ADDI   %i5, 4                            ; Add Address Counter
            	
                SUBI   %l1, 1                            ; Decrement Line Counter
                SKPS   cc_z
                BR     looptpcc25
                NOP 	
            ");
            break;
        }
    }
}

void Hardware::DoEnableLogicAnalyserInterrupt(void)						// Enable service routine
{
	la_interrupt->np_pioedgecapture = 0x00; 							// clear all existing IRQ conditions
	la_interrupt->np_piodirection = 0x00;								// set all bits to input
	la_interrupt->np_piointerruptmask = 0x01;							// enable Button IRQs
	la_interrupt->np_piodata = 0;

	nr_installuserisr(na_la_interrupt_irq,ISR_LogicAnalyser,(int)la_interrupt);	// Install ISR for parallel I/Os

#ifdef _Debug_IRQ_
	if (Debug_Mode) printf("\nLogicAnalyser interrupt enabled.\n"); 						// print on console
#endif	
}
	
void Hardware::DoDisableLogicAnalyserInterrupt(void)						// Disable parallel I/O service routine
{
	nr_installuserisr(na_la_interrupt_irq,0,0); 				// Install empty routine for pio irq
	la_interrupt->np_piointerruptmask = 0x00;						// disable all IRQs
}


void Hardware::ISR_LogicAnalyser(int context)
{
	char la_data_cnt;
	
	tc_test_var2++;

	la_gate->np_piodata = 0x01;
	
	for (la_data_cnt = 0; la_data_cnt < 32; la_data_cnt++)
	{
		la_pulse->np_piodata = 0x01;
		
		LogicData[la_data_cnt] = la_data-> np_piodata;
		
		la_pulse->np_piodata = 0x00;		
	}	
	
	la_gate->np_piodata = 0x00;
	
    la_interrupt->np_pioedgecapture = 0; 								// clear IRQ conditions		

	//if (USB_Data_Trans == 1)
	{
		send_buffer[0] = 3;						// Command Write Data
		send_buffer[1] = 20;
		send_buffer[2] = 1;
		
		SendData(send_buffer);	
	}
#ifdef _Debug_IRQ_	
	if (Debug_Mode) printf("\nLogicAnalyser interrupt received\n");
#endif	
}








/****************************************************************************/
/* clear: zeroize a FIR delay line                                          */
/****************************************************************************/
void clear(int ntaps, SAMPLE z[])
{
    int ii;
    for (ii = 0; ii < ntaps; ii++) {
        z[ii] = 0;
    }
}

/****************************************************************************
* fir_basic: Does the basic FIR algorithm: store input sample, calculate
* output sample, move delay line
*****************************************************************************/
SAMPLE fir_basic(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[])
{
    int ii;
    SAMPLE accum;

    /* store input at the beginning of the delay line */
    z[0] = input;

    /* calc FIR */
    accum = 0;
    for (ii = 0; ii < ntaps; ii++) {
        accum += h[ii] * z[ii];
    }

    /* shift delay line */
    for (ii = ntaps - 2; ii >= 0; ii--) {
        z[ii + 1] = z[ii];
    }

    return accum;
}

/****************************************************************************
* fir_circular: This function illustrates the use of "circular" buffers
* in FIR implementations.  The advantage of circular buffers is that they
* alleviate the need to move data samples around in the delay line (as
* was done in all the functions above).  Most DSP microprocessors implement
* circular buffers in hardware, which allows a single FIR tap can be
* calculated in a single instruction.  That works fine when programming in
* assembly, but since C doesn't have any constructs to represent circular
* buffers, you need to "fake" them in C by adding an extra "if" statement
* inside the FIR calculation, even if the DSP processor provides hardware to
* implement them without overhead.
*****************************************************************************/
SAMPLE fir_circular(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[],
                    int *p_state)
{
    int ii, state;
    SAMPLE accum;

    state = *p_state;               /* copy the filter's state to a local */

    /* store input at the beginning of the delay line */
    z[state] = input;
    if (++state >= ntaps) {         /* incr state and check for wrap */
        state = 0;
    }

    /* calc FIR and shift data */
    accum = 0;
    for (ii = ntaps - 1; ii >= 0; ii--) {
        accum += h[ii] * z[state];
        if (++state >= ntaps) {     /* incr state and check for wrap */
            state = 0;
        }
    }

    *p_state = state;               /* return new state to caller */

    return accum;
}

/****************************************************************************
* fir_shuffle: This is like fir_basic, except that data is shuffled by
* moving it _inside_ the calculation loop.  This is similar to the MACD
* instruction on TI's fixed-point processors
*****************************************************************************/
SAMPLE fir_shuffle(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[])
{
    int ii;
    SAMPLE accum;

    /* store input at the beginning of the delay line */
    z[0] = input;

    /* calc FIR and shift data */
    accum = h[ntaps - 1] * z[ntaps - 1];
    for (ii = ntaps - 2; ii >= 0; ii--) {
        accum += h[ii] * z[ii];
        z[ii + 1] = z[ii];
    }

    return accum;
}

/****************************************************************************
* fir_split: This splits the calculation into two parts so the circular
* buffer logic doesn't have to be done inside the calculation loop
*****************************************************************************/
SAMPLE fir_split(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[],
                 int *p_state)
{
    int ii, end_ntaps, state = *p_state;
    SAMPLE accum;
    SAMPLE const *p_h;
    SAMPLE *p_z;

    /* setup the filter */
    accum = 0;
    p_h = h;

    /* calculate the end part */
    p_z = z + state;
    *p_z = input;
    end_ntaps = ntaps - state;
    for (ii = 0; ii < end_ntaps; ii++) {
        accum += *p_h++ * *p_z++;
    }

    /* calculate the beginning part */
    p_z = z;
    for (ii = 0; ii < state; ii++) {
        accum += *p_h++ * *p_z++;
    }

    /* decrement the state, wrapping if below zero */
    if (--state < 0) {
        state += ntaps;
    }
    *p_state = state;       /* return new state to caller */

    return accum;
}

/****************************************************************************
* fir_double_z: double the delay line so the FIR calculation always
* operates on a flat buffer
*****************************************************************************/
SAMPLE fir_double_z(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[],
            int *p_state)
{
    SAMPLE accum;
    int ii, state = *p_state;
    SAMPLE const *p_h, *p_z;

    /* store input at the beginning of the delay line as well as ntaps more */
    z[state] = z[state + ntaps] = input;

    /* calculate the filter */
    p_h = h;
    p_z = z + state;
    accum = 0;
    for (ii = 0; ii < ntaps; ii++) {
        accum += *p_h++ * *p_z++;
    }

    /* decrement state, wrapping if below zero */
    if (--state < 0) {
        state += ntaps;
    }
    *p_state = state;       /* return new state to caller */

    return accum;
}

/****************************************************************************
* fir_double_h: uses doubled coefficients (supplied by caller) so that the
* filter calculation always operates on a flat buffer.
*****************************************************************************/
SAMPLE fir_double_h(SAMPLE input, int ntaps, const SAMPLE h[], SAMPLE z[],
                    int *p_state)
{
    SAMPLE accum;
    int ii, state = *p_state;
    SAMPLE const *p_h, *p_z;

    /* store input at the beginning of the delay line */
    z[state] = input;

    /* calculate the filter */
    p_h = h + ntaps - state;
    p_z = z;
    accum = 0;
    for (ii = 0; ii < ntaps; ii++) {
        accum += *p_h++ * *p_z++;
    }

    /* decrement state, wrapping if below zero */
    if (--state < 0) {
        state += ntaps;
    }
    *p_state = state;       /* return new state to caller */

    return accum;
}

/****************************************************************************
* main: This provides a simple test suite for the functions above.  An
* impulse is fed into each filter implementation, so the output should be
* the "impulse response", that is, the coefficients of the filter.  You
* should see some zeroes, followed by the "coefficents" below, followed by a
* few more zeroes.
*****************************************************************************/
int Hardware::TestFir(void)
{
    static const SAMPLE h[NTAPS] = { 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2 };
    static SAMPLE h2[2 * NTAPS];
    static SAMPLE z[2 * NTAPS];
    static SAMPLE imp[IMP_SIZE];

    SAMPLE output;
    int ii, state;

    /* make impulse input signal */
    clear(IMP_SIZE, imp);


    imp[0]  = 0.0;
    imp[1]  = 0.0;
    imp[2]  = 1.0;
    imp[3]  = 2.0;
    imp[4]  = 3.0;
    imp[5]  = 4.0;
    imp[6]  = 5.0;
    imp[7]  = 4.0;
    imp[8]  = 3.0;
    imp[9]  = 2.0;
    imp[10] = 1.0;
    imp[11] = 0.0;
    imp[12] = -1.0;
    imp[13] = -2.0;
    imp[14] = -3.0;
    imp[15] = -4.0;
    imp[16] = -5.0;
    imp[17] = -4.0;
    imp[18] = -3.0;
    imp[19] = -2.0;
    imp[20] = -1.0;
    imp[21] = 0.0;
    imp[22] = 1.0;
    imp[23] = 2.0;
    imp[24] = 3.0;
    imp[25] = 4.0;
    imp[26] = 5.0;
    imp[27] = 4.0;
    imp[28] = 3.0;
    imp[29] = 2.0;
    imp[30] = 1.0;
    imp[31] = 0.0;
    imp[32] = 0.0;
/*
    imp[0]  = 0.0;
    imp[1]  = 0.0;
    imp[2]  = 0.0;
    imp[3]  = 0.0;
    imp[4]  = 0.0;
    imp[5]  = 0.0;
    imp[6]  = 0.0;
    imp[7]  = 0.0;
    imp[8]  = 0.0;
    imp[9]  = 0.0;
    imp[10] = 0.0;
    imp[11] = 0.0;
    imp[12] = 0.0;
    imp[13] = 0.0;
    imp[14] = 0.0;
    imp[15] = 0.0;
    imp[16] = 0.0;
    imp[17] = 0.0;
    imp[18] = 0.0;
    imp[19] = 0.0;
    imp[20] = 0.0;
*/
/*
    imp[0]  = 0.0;
    imp[1]  = 0.0;
    imp[2]  = 0.0;
    imp[3]  = 0.0;
    imp[4]  = 0.0;
    imp[5]  = 0.0;
    imp[6]  = 0.0;
    imp[7]  = 0.0;
    imp[8]  = 0.0;
    imp[9]  = 0.0;
    imp[10] = 0.0;
    imp[11] = 0.0;
    imp[12] = 0.0;
    imp[13] = 0.0;
    imp[14] = 0.0;
    imp[15] = 0.0;
    imp[16] = 0.0;
    imp[17] = 0.0;
    imp[18] = 0.0;
    imp[19] = 0.0;
    imp[20] = 0.0;
*/

    /* create a SAMPLEd h */
    for (ii = 0; ii < NTAPS; ii++) {
        h2[ii] = h2[ii + NTAPS] = h[ii];
    }

    /* test FIR algorithms */

    printf("Testing fir_basic:\n   ");
    clear(NTAPS, z);
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_basic(imp[ii], NTAPS, h, z);
        printf("%3.1lf ", (double) output);
    }
    printf("\n\n");

    printf("Testing fir_shuffle:\n   ");
    clear(NTAPS, z);
    state = 0;
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_shuffle(imp[ii], NTAPS, h, z);
        printf("%3.1lf ", (double) output);
    }
    printf("\n\n");

    printf("Testing fir_circular:\n   ");
    clear(NTAPS, z);
    state = 0;
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_circular(imp[ii], NTAPS, h, z, &state);
        printf("%3.1lf ", (double) output);
    }
    printf("\n\n");

    printf("Testing fir_split:\n   ");
    clear(NTAPS, z);
    state = 0;
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_split(imp[ii], NTAPS, h, z, &state);
        printf("%3.1lf ", (double) output);
    }
    printf("\n\n");

    printf("Testing fir_double_z:\n   ");
    clear(2 * NTAPS, z);
    state = 0;
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_double_z(imp[ii], NTAPS, h, z, &state);
        printf("%3.1lf ", (double) output);
    }
    printf("\n\n");

    printf("Testing fir_double_h:\n   ");
    clear(NTAPS, z);
    state = 0;
    for (ii = 0; ii < IMP_SIZE; ii++) {
        output = fir_double_h(imp[ii], NTAPS, h2, z, &state);
        printf("%3.1lf ", (double) output);
    }

    #ifdef WIN32
        printf("\n\nHit any key to continue.");
        getch();
    #endif

    return 0;
}













// Class Display
// Public Functions
void Display::Init(void)											// Init Display Subroutine
{
	unsigned long *flash_address;
	int x, result = 0;
#ifdef _Debug_	
	if (Debug_Mode) printf("Starting Init Display \n");
#endif			
	Pulse11.Init(0.000000016, 0.000000016, 0.268435448, 0.000000008, 2, 3, "", "", "s");
	Pulse12.Init(0.000000008, 0.000000008, 0.000524000, 0.000000008, 2, 3, "", "", "s");
	Pulse21.Init(0.000000016, 0.000000016, 0.268435448, 0.000000008, 2, 3, "", "", "s");
	Pulse22.Init(0.000000016, 0.000000016, 0.268435448, 0.000000008, 2, 3, "", "", "s");
	
        switch(Pulse11_Expo)
        {
            case 1:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000);
                break;
            }
        }
        Pulse11.RenderText();

        switch(Pulse12_Expo)
        {
            case 1:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000);
                break;
            }
        }
        Pulse12.RenderText();

        switch(Pulse21_Expo)
        {
            case 1:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000);
                break;
            }
        }
        Pulse21.RenderText();

        switch(Pulse22_Expo)
        {
            case 1:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000);
                break;
            }
        }
        Pulse22.RenderText();	
	
	Cursor_Delta_X.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "@X = ", "s");
	Cursor_Delta_1X.Init(0.00000001, 0.00000001, 10, 0.000000005, 3, 5, "", "1/@X = ", "Hz");
	Cursor_Delta_XY_X.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	Cursor_Delta_Y.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");

	Cursor_Vertical_Pos_1_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "s");
	Cursor_Vertical_Pos_2_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "s");

	Cursor_Vertical_Pos_XY_1_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	Cursor_Vertical_Pos_XY_2_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");

	Cursor_Horizontal_Pos_1_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	Cursor_Horizontal_Pos_2_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	
	QM_Slot1.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Freq(@) :", "");
	QM_Slot2.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Pk-Pk(@) :", "");
	QM_Slot3.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Pk-Pk(@) :", "");	

//	QM_Slot1_Value.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "Hz");
//	QM_Slot2_Value.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
//	QM_Slot3_Value.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");	

	QM_Threshold_lower.Init(30, 5, 100, 1, 0, 3, "", "", "%");
	QM_Threshold_middle.Init(50, 5, 100, 1, 0, 3, "", "", "%");
	QM_Threshold_upper.Init(70, 5, 100, 1, 0, 3, "", "", "%");
	
	Math_Offset.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	
	Math_Offset_mul.Init(0.001, 0.001, 1000, 0.001, 2, 3, "", "", "V");
	Math_Offset_add.Init(0.001, 0.001, 1000, 0.001, 2, 3, "", "", "V");
	Math_Offset_sub.Init(0.001, 0.001, 1000, 0.001, 2, 3, "", "", "V");

	Zero_Level1_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Ch(1) = ", "V");
	Zero_Level2_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Ch(2) = ", "V");
	Zero_Level3_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Ch(3) = ", "V");
	Zero_Level4_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "Ch(4) = ", "V");
	
	Trigger_Level_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");
	Trigger_ExtLevel_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "V");	
	Trigger_Offset_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "s");	
	
	Timebase_Offset_Str.Init(0.00000001, 0.00000001, 10, 0.000000005, 2, 3, "", "", "s");

	HoldOff.Init(0.00000004, 0.00000004, 300, 0.00000004, 2, 5, "", "", "s");  // start 10 ns , min 10 ns, max 274 s, steps 8 ns , 2 afterdot, 4 maxlength, '' Text, '' PreText, 'S' Unit
	
	FFT_Scale_Str.Init(0.00000004, 0.00000004, 300, 0.00000004, 2, 5, "", "", "dBV/");
	FFT_Offset_Str.Init(0.00000004, 0.00000004, 300, 0.00000004, 2, 5, "", "", "dBV");
	
    switch(HoldOff_Expo)
    {
        case 1:
        {
            HoldOff.Write_StepSize(0.00000004);
            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000000000);
            break;
        }
        case 2:
        {
            HoldOff.Write_StepSize(0.0000001);
            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000000);
            break;
        }
        case 3:
        {
            HoldOff.Write_StepSize(0.001);
            HoldOff.Write_Value((float) HoldOff_Value / (float) 1000);
            break;
        }
        case 4:
        {
            HoldOff.Write_StepSize(1);
            HoldOff.Write_Value((float) HoldOff_Value);
            break;
        }
    }

    HoldOff.RenderText();	
    if (HoldOff_Value) trig_holdoff_reg = (unsigned long) (HoldOff.Read_Value() / (float) 0.000000008);
    else trig_holdoff_reg = 0x00000000;
	
	
    QM_Threshold_lower.Write_Value(20);	
    QM_Threshold_lower.RenderText();

    QM_Threshold_middle.Write_Value(50);	
    QM_Threshold_middle.RenderText();

    QM_Threshold_upper.Write_Value(80);	
    QM_Threshold_upper.RenderText();   	

    switch(Math_Off_Mul_Expo)
    {
        case -2:
        {
            Math_Offset_mul.Write_StepSize(1);
            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1);
            break;
        }
        case -1:
        {
            Math_Offset_mul.Write_StepSize(0.001);
            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
            break;
        }
        case 0:
        {
            Math_Offset_mul.Write_StepSize(0.000001);
            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000000);
            break;
        }
        case 1:
        {
            Math_Offset_mul.Write_StepSize(0.001);
            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
            break;
        }
        case 2:
        {
            Math_Offset_mul.Write_StepSize(1);
            Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value);
            break;
        }
    }

    Math_Offset_mul.RenderText();

    switch(Math_Off_Sub_Expo)
    {
        case -1:
        {
            Math_Offset_sub.Write_StepSize(1);
            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
            break;
        }
        case 0:
        {
            Math_Offset_sub.Write_StepSize(0.001);
            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value / (float) 1000);
            break;
        }
        case 1:
        {
            Math_Offset_sub.Write_StepSize(1);
            Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
            break;
        }
    }

    Math_Offset_sub.RenderText();

    switch(Math_Off_Add_Expo)
    {
        case -1:
        {
            Math_Offset_add.Write_StepSize(1);
            Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
            break;
        }
        case 0:
        {
            Math_Offset_add.Write_StepSize(0.001);
            Math_Offset_add.Write_Value((float) Math_Off_Add_Value / (float) 1000);
            break;
        }
        case 1:
        {
            Math_Offset_add.Write_StepSize(1);
            Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
            break;
        }
    }

    Math_Offset_add.RenderText();

	if (config_loaded == false)
	{
#ifdef _Debug_	
		printf("Generating Flash\n");
#endif			
		// Generate Logo
				
		// Clear All Planes
		for (x = 0; x < 153600; x++) Planes[x] = 0;		

        dma->np_piodata = 1;											// enable DMA Transfer
	    dma->np_piodata = 0;

		//Generate_FLASH();
		
	    // Write Config to Flash
	    config_changed = true;
	    AMDFlash::Write_Config_Flash();		
#ifdef _Debug_		
		printf("Flash Generated\n");
		
		printf("Resetting Hardware\n");		
#endif		
		// Reset
//		Hardware::Reset_the_Watchdog();
		config_loaded = true;
		nr_delay(3000);
	}
	

	
    // execute config functions

    CALCTIMEBASE();

    CALCTRIGGER();
    CALCPRETRIGGER();

    CALCCURSORDATA();
    CALCQMDATA();
#ifdef _Debug_
	printf("Init : df : %f c1 : %d c2 : %d cs %d st %d sfi %d dst %d dsfi %d dwop %d\n", dmode_factor, Cursor_Delayed_1, Cursor_Delayed_2, Cursor_Delayed_Size, Selected_Timebase, SIGNALFaktor_idx, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dmode_Window_Offset_Pos);
#endif	
	Hardware::Send_LED();
	
	if (Channel_1_Active) Hardware::UpdateChannel(1, 1);
	else
    {
        Hardware::UpdateChannel(1, 0);
        Channel_1_Active_Old = 1;
        VoltageChangedCh1 = 1;
    }

	if (Channel_2_Active) Hardware::UpdateChannel(2, 1);
	else
    {
        Hardware::UpdateChannel(2, 0);
        Channel_2_Active_Old = 1;
        VoltageChangedCh2 = 1;
    }

	if (Channel_3_Active) Hardware::UpdateChannel(3, 1);
	else
    {
        Hardware::UpdateChannel(3, 0);
        Channel_3_Active_Old = 1;
        VoltageChangedCh3 = 1;
    }

	if (Channel_4_Active) Hardware::UpdateChannel(4, 1);
	else
    {
        Hardware::UpdateChannel(4, 0);
        Channel_4_Active_Old = 1;
        VoltageChangedCh4 = 1;
    }

    Rotary_Steps = 0;
    Hardware::ON_Zero_Channel_1();
    Hardware::SetSwitches(1, Selected_Voltage_CH1);
    Hardware::SetDacOffset(1);
    Hardware::SetCHDacOffset(1);
	
	Rotary_Steps = 0;
	Hardware::ON_Zero_Channel_2();
	Hardware::SetSwitches(2, -1); // zwecks andere daten -switches2 in config
	Hardware::SetDacOffset(2);
	Hardware::SetCHDacOffset(2);
	
	if (NumberOfChannels > 2)
	{
        Rotary_Steps = 0;
        Hardware::ON_Zero_Channel_3();
		Hardware::SetSwitches(3, Selected_Voltage_CH3);
		Hardware::SetDacOffset(3);
		Hardware::SetCHDacOffset(3);
		
		Rotary_Steps = 0;
		Hardware::ON_Zero_Channel_4();
		Hardware::SetSwitches(4, Selected_Voltage_CH4);
		Hardware::SetDacOffset(4);
		Hardware::SetCHDacOffset(4);
	}
		
	
    data_adr->np_piodata = ram_adress_reg;	

//	printf("Math aktiv %d - %d\n", Channel_Math_Active, NumberOfChannels);
	
    if (Channel_Math_Active == 1)
    {
        if (NumberOfChannels == 2)
        {
            //if (MenuPopupStatus[1][2] == 1) MenuPopupStatus[1][2] = 2;
            //if (MenuPopupStatus[3][2] == 1) MenuPopupStatus[3][2] = 2;
        }
        else
        {
            //if (MenuPopupStatus[1][4] == 1) MenuPopupStatus[1][4] = 2;
            //if (MenuPopupStatus[3][4] == 1) MenuPopupStatus[3][4] = 2;
        }
    }

	DRAW_SPLASH(true);	
		// Draw Startscreen
	DrawStartScreen();

    TimebaseChanged = 1;
    TimeOffsetChanged = 1;
    TriggerLevelChanged = 1;
    TriggerModeChanged = 1;
    TriggerWayChanged = 1;    		
		
	StatusUpdate();
	
    CursorChanged = 3;
    Cursor_Data_First_Draw = 1;
    DRAWCURSORDATA(0);

    Quick_Measure_First_Draw = 1;
    DRAWQMDATA(0); 	

    DRAW_ALL_CURSOR();
#ifdef _Debug_    		
	if (Debug_Mode) printf("Flash Drawed\n");					
#endif

 /* TMW    if (MenuStatus[5][4] == 241) DRAWMEMORY(0, 1, 1);  TMW */  				
	
	if (Display_Mode) Display::GRIDXY(80, 20, Grid_Plane);
	
    // must be set bevor SetupADC						
    init_done = true;	
    first_start = true;                        																							
    Hardware::UpdateTrigger(30);
	first_start = false; 	
	
	serdata->np_piodata = ext_trg_val_reg;

	serstartpwm->np_piodata = 1;
	serstartpwm->np_piodata = 0;	
	
	
	/*
    send_buffer[0] = 3;						// Command Write Data
    send_buffer[1] = 0;
					
    Hardware::SendData(send_buffer);	
    */

    Hardware::Start_Record();

}

void Display::DRAW_SPLASH(unsigned char remove)
{
	unsigned long x;
	char BufText[80];
	char BufText2[80];	
	char BufText3[80];	
	char BufText4[80];
	unsigned char Grid_Color_Buff = GridColor_Val;
	

#ifdef _Debug_
	if (Debug_Mode) printf("Draw Splash\n");
#endif
	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}	
	
	GridColor_Val = WT_Logo_Color_Val;
	Hardware::SetupADC();
	
	sprintf(BufText, "%1i.%1i", tc_version, tc_subversion);
	sprintf(BufText2, "%X.%c%c", tc_hw_version, tc_production_lot1, tc_production_lot2);
	sprintf(BufText3, "%06d%02d%1X%1X", tc_serial, ((tc_shipment_date & 0x0000FF00) >> 8), ((tc_shipment_date & 0x000000F0) >> 4), (tc_shipment_date & 0x0000000F));	
	sprintf(BufText4, "W%04dA", tc_model);
	
	// Mu auch ins flash
		
    //TEXTOUTvbig("Developed and manufactured by", Splash_Data_PosX + 28, Splash_Data_PosY - 20, 1, UI_Plane1);		
    //TEXTOUTxvbig("Wittig Technologies, Germany", Splash_Logo_PosX - 59, Splash_Data_PosY + 0, 1, UI_Plane1);	
    //TEXTOUTxvbig("Wittig Electronics, Germany", Splash_Logo_PosX - 59, Splash_Data_PosY - 20, 1, UI_Plane1);	
    TEXTOUTxvbig("Welec Germany", Splash_Logo_PosX - 14, Splash_Data_PosY - 20, 1, UI_Plane1);	
    
    TEXTOUTvbig("Model : ", Splash_Data_PosX + 28, Splash_Data_PosY + 50, 1, UI_Plane1);
    TEXTOUTvbig(BufText4, Splash_Data_PosX + 148, Splash_Data_PosY + 50, 1, UI_Plane1);	
	
    TEXTOUTvbig("Hardware Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 70, 1, UI_Plane1);
    TEXTOUTvbig(BufText2, Splash_Data_PosX + 148, Splash_Data_PosY + 70, 1, UI_Plane1);		
    TEXTOUTvbig("Software Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 90, 1, UI_Plane1);
    TEXTOUTvbig(BufText, Splash_Data_PosX + 148, Splash_Data_PosY + 90, 1, UI_Plane1);	
	
    TEXTOUTvbig("Serial Number : ", Splash_Data_PosX + 28, Splash_Data_PosY + 110, 1, UI_Plane1);
    TEXTOUTvbig(BufText3, Splash_Data_PosX + 148, Splash_Data_PosY + 110, 1, UI_Plane1);	 	
	
    TEXTOUTvbig("All Rights Reserved _ 2008", Splash_Data_PosX + 236, Splash_Data_PosY + 250, 1, UI_Plane1);

	AMDFlash::copy_flash_to_plane(WTAG_Logo_Half_Flash, UI_Plane5);
	AMDFlash::copy_flash_to_plane(WTAG_Logo, Grid_Plane);

	Splash_drawed = true;
	
	// Clear Buffer Planes
	for (x = 0; x < 9600; x++)
	{
		Buffer_Plane1[x] = 0;
		Buffer_Plane2[x] = 0;
		Buffer_Plane3[x] = 0;
		Buffer_Plane4[x] = 0;
		Buffer_PlaneM[x] = 0;
		//Buffer_UI2Plane[x] = 0;		 is in marker 1
		Buffer_Mark1Plane[x] = 0;
	}

    dma->np_piodata = 1;											// enable DMA Transfer
    dma->np_piodata = 0;    	
    	
	if (remove)
	{
		Hardware::Setup_Interrupts();  		
		
        Search_Auto = true;
        //Hardware::SearchZeros();
    		
		nr_delay(3000);      	

		REMOVE_SPLASH();
		Splash_drawed = false;
	}
#ifdef _Debug_	
	if (Debug_Mode) printf("Draw Splash finished\n");	
#endif	
}

void Display::REMOVE_SPLASH(void)
{
	unsigned long x;
	char BufText[80];
	char BufText2[80];	
	char BufText3[80];	
	char BufText4[80];
	
	sprintf(BufText, "%1i.%1i", tc_version, tc_subversion);
	sprintf(BufText2, "%X.%c%c", tc_hw_version, tc_production_lot1, tc_production_lot2);
	sprintf(BufText3, "%06d%02d%1X%1X", tc_serial, ((tc_shipment_date & 0x0000FF00) >> 8), ((tc_shipment_date & 0x000000F0) >> 4), (tc_shipment_date & 0x0000000F));	
	sprintf(BufText4, "W%04dA", tc_model);
		
	// Clear Buffer Planes
	for (x = 0; x < 9600; x++)
	{
		Buffer_Plane1[x] = 0;
		Buffer_Plane2[x] = 0;
		Buffer_Plane3[x] = 0;
		Buffer_Plane4[x] = 0;
		Buffer_PlaneM[x] = 0;
		//Buffer_UI2Plane[x] = 0;		 is in marker 1
		Buffer_Mark1Plane[x] = 0;
	}

    for (x = 0; x < 9600; x++)
    {
        UI_Plane5[x] = 0;
    }	  	
		
    BITBITMAP(bitbmWTAG, Splash_Logo_PosX, Splash_Logo_PosY, 0, Grid_Plane);
		
    //TEXTOUTvbig("Developed and manufactured by", Splash_Data_PosX + 28, Splash_Data_PosY - 20, 0, UI_Plane1);		
    //TEXTOUTxvbig("Wittig Technologies, Germany", Splash_Logo_PosX - 59, Splash_Data_PosY + 0, 0, UI_Plane1);	
    //TEXTOUTxvbig("Wittig Electronics, Germany", Splash_Logo_PosX - 59, Splash_Data_PosY - 20, 0, UI_Plane1);
    TEXTOUTxvbig("Welec Germany", Splash_Logo_PosX - 14, Splash_Data_PosY - 20, 0, UI_Plane1);

    TEXTOUTvbig("Model : ", Splash_Data_PosX + 28, Splash_Data_PosY + 50, 0, UI_Plane1);
    TEXTOUTvbig(BufText4, Splash_Data_PosX + 148, Splash_Data_PosY + 50, 0, UI_Plane1);	
	
    TEXTOUTvbig("Hardware Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 70, 0, UI_Plane1);
    TEXTOUTvbig(BufText2, Splash_Data_PosX + 148, Splash_Data_PosY + 70, 0, UI_Plane1);		
    TEXTOUTvbig("Software Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 90, 0, UI_Plane1);
    TEXTOUTvbig(BufText, Splash_Data_PosX + 148, Splash_Data_PosY + 90, 0, UI_Plane1);	
	
    TEXTOUTvbig("Serial Number : ", Splash_Data_PosX + 28, Splash_Data_PosY + 110, 0, UI_Plane1);
    TEXTOUTvbig(BufText3, Splash_Data_PosX + 148, Splash_Data_PosY + 110, 0, UI_Plane1);	 	
	
    TEXTOUTvbig("All Rights Reserved _ 2008", Splash_Data_PosX + 236, Splash_Data_PosY + 250, 0, UI_Plane1);		
		
	GridColor_Val = GridColorArray[GridColorArrayPos];
	Hardware::SetupADC();
#ifdef _Debug_	
	if (Debug_Mode) printf("Remove Splash finished\n");	
#endif	
	Splash_removed = true;
}

void Display::DrawStartScreen(void)
{
	unsigned long lX;
	
	for (lX = 0; lX < 360; lX++) //400
	{
		Buffer_UI2Plane[lX] = *(UI_Plane2_Flash + lX);
		UI_Plane3[lX] = *(UI_Plane3_Flash + lX);		
	}
	
	for (lX = 380; lX < 8120; lX++) //400
	{
		Grid_Plane[lX] = *(Grid_Plane_Flash + lX);
		
		if (tc_hw_version < 0x4c7) {if ((lX % 20) == 0) Grid_Plane[lX] = Grid_Plane[lX] << 2;} // Gap
	}	
	
	for (lX = 8140; lX < 9600; lX++)
	{
		UI_Plane1[lX] = *(UI_Plane1_Flash + lX);
		Buffer_UI2Plane[lX] = *(UI_Plane2_Flash + lX);		
		UI_Plane3[lX] = *(UI_Plane3_Flash + lX);
		UI_Plane4[lX] = *(UI_Plane4_Flash + lX);
		UI_Plane5[lX] = *(UI_Plane5_Flash + lX);
	}
	
	if (Channel_1_Active == 1)
	{
		TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);								// Draw Voltage Text
//		TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);								// Draw Voltage Text
	}
	if (Channel_2_Active == 1)
	{
		TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);								// Draw Voltage Text
//		TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);								// Draw Voltage Text
	}
	if (Channel_3_Active == 1)
	{
		DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button	
		TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);							// Draw Voltage Text
//		TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);							// Draw Voltage Text
	}
	if (Channel_4_Active == 1)
	{
		DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button			
		TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);							// Draw Voltage Text
//		TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);							// Draw Voltage Text
	}

	if (Splash_drawed == false) New_Menu = 14;
	Menu_Changed = 1;
    UpdateMenuTextPlane = true;	
    Display::GRID(20, 20, Grid_Plane);
}

void Display::DRAWP(int x, int y, int dx, int dy, char set, unsigned long *planeaddress)
{
	int pos;
	int bit;
	int bitbuf;
	int intbuf;
	long BitMaskBuf;
	
	int ctx, cty;
		
	intbuf = (x >> 5);	
	
	bit = (x - (intbuf << 5));
	bitbuf = bit;
		
	for (cty = y; cty < (y + dy); cty++)
	{
		bit = bitbuf;
		if (set == 1) BitMaskBuf = BitMasks2[bit];
		else BitMaskBuf = BitMasks[bit];
		
		pos = (cty * 20) + intbuf;
				
		for (ctx = dx; ctx > 0; ctx--)
		{
			if (set == 1)
			{
				*(planeaddress + pos) = *(planeaddress + pos) | BitMaskBuf;
				BitMaskBuf >>= 1;
			}
			else
			{
				*(planeaddress + pos) = *(planeaddress + pos) & BitMaskBuf;
				BitMaskBuf >>= 1;
				BitMaskBuf |= 0x80000000;				
			}			
		
			bit++;
			
			if (bit > 31)
			{
				bit = 0;
				pos++;
				if (set == 1) BitMaskBuf = 0x80000000;
				else BitMaskBuf = 0x7FFFFFFF;
			}
		}		
	}	
}

void Display::PIXELP(int x, int y, char set, unsigned long *planeaddress)
{
	int pos;
	int bit;
	int intbuf;
	
	intbuf = x >> 5;	
	pos = Display_Line_Adresses[y] + intbuf;		
	bit = x - (intbuf << 5);
	
	if (set == 1) *(planeaddress + pos) |= BitMasks2[bit];
	else *(planeaddress + pos) &= BitMasks[bit];
}

void Display::DRAWLINEP(int x1, int y1, int x2, int y2, char set, unsigned long *plane)	// Draw a Line
{
	float isw, iswb = 0;
	int cxe = 0;
	float fx1, fx2, fy1, fy2, x, ix, dx, y, iy, dy = 0;
	
	fx1 = (float) x1;
	fx2 = (float) x2;
	fy1 = (float) y1;
	fy2 = (float) y2;
	
	if (fx1 > fx2) dx = fx1 - fx2;
	else dx = fx2 - fx1;
	if (dx < 0) dx = -dx;	
	
	if (fy1 > fy2) dy = fy1 - fy2;
	else dy = fy2 - fy1;
	if (dy < 0) dy = -dy;
		
//	dx = abs(fx1 - fx2);// + 1;
//	dy = abs(fy1 - fy2);// + 1;	
	
	if ((fx1 < fx2) && (fy1 < fy2))
	{
		if (dx < dy)
		{
			iswb = dy / dx;
			
			isw = iswb;
			x = fx1;
			for (y = fy1; y < fy2; y++)
			{
				if (y == (int) (y1 + isw))
				{
					isw = isw + iswb;
					x = x + 1;
				}
				PIXELP((int) x, (int) y, set, plane);				
			}					
		}
		else if (dx > dy)
		{
			iswb = dx / dy;
			
			isw = iswb;
			y = fy1;
			for (x = fx1; x < fx2; x++)
			{
				if (x == (int) (fx1 + isw))
				{
					isw = isw + iswb;
					y = y + 1;
				}
				PIXELP((int) x, (int) y, set, plane);
			}				
		}
		else
		{
			y = fy1;
			for (x = fx1; x < fx2; x++)
			{
				PIXELP((int) x, (int) y, set, plane);
				y = y + 1;				
			}		
		}		
	}
	else if ((fx1 < fx2) && (fy1 > fy2))
	{
		if (dx < dy)
		{
			iswb = dy / dx;
			
			isw = iswb;
			x = x1;
			for (y = fy1; y > fy2; y--)
			{
				if (y == (int) (fy1 - isw))
				{
					isw = isw + iswb;
					x = x + 1;
				}
				PIXELP((int) x, (int) y, set, plane);			
			}					
		}
		else if (dx > dy)
		{
			iswb = dx / dy;
			
			isw = iswb;
			y = fy1;
			for (x = fx1; x < fx2; x++)
			{
				if (x == (int) (fx1 + isw))
				{
					isw = isw + iswb;
					y = y - 1;
				}
				PIXELP((int) x, (int) y, set, plane);	
			}				
		}
		else
		{
			y = fy1;
			for (x = fx1; x < fx2; x++)
			{
				PIXELP((int) x, (int) y, set, plane);
				y = y - 1;				
			}		
		}						
	}
	else if ((x1 < x2) && (y1 == y2)) for (x = x1; x < x2; x++) { PIXELP((int) x, (int) y1, set, plane); }		
	
	else if ((x1 == x2) && (y1 < y2)) for (y = y1; y < y2; y++) { PIXELP((int) x1, (int) y, set, plane); }	
	else if ((x1 == x2) && (y1 > y2)) for (y = y1; y > y2; y--) { PIXELP((int) x1, (int) y, set, plane); }	
	else if ((x1 == x2) && (y1 == y2)) { PIXELP((int) x1, (int) y1, set, plane); }	
		
//	else for (x = x1; x < x2; x++) { PIXELP(x, y1, color, layer); }	
}

void Display::DRAWZEROLINE(int y, char set, unsigned long *plane)
{
    int pos, cnt;

    pos = Display_Line_Adresses[y + 20];

    if (set) *(plane + pos) |= 0x00000FFF;
    else *(plane + pos) &= 0xFFF00000;

    for (cnt = 1; cnt < 19; cnt++)
    {
        if (set) *(plane + pos + cnt) = 0xFFFFFFFF;
        else *(plane + pos + cnt) = 0x00000000;
    }

    if (set) *(plane + pos + 19) |= 0xFFE00000;
    else *(plane + pos + 19) &= 0x001FFFFF;
}

void Display::TEXTOUTvbig(char *String, int x, int y, char set, unsigned long *layer)	// Draw Text at Pos X / Y with Color and BackColor (FF = Transparent)
{
	int Buf, Ct, Ctt, Bit;
	int count;
	
	count = strlen(String);

	// Start drawing background
	Bit = 0;												// Correction Counter for different letter size (e.g. i or w)
	
	for (Ct = 0;Ct < count; Ct++)							// Calculate the correction for the background
	{
		Buf = String[Ct] - 32;								// get the letter
		
		for (Ctt = 0;Ctt < 14; Ctt++)						// test the Bytes of the letter (x size)
		{
			if (FONT10X9[Buf][(Ctt * 2) + 1] == 0x80) Bit++;	// if its size small than the minimum size 0x80 signals it
		}
	}	
	
	//Draw Background	
//	if (backcolor != 0xFF) DRAWP(x - 3, y - 4, (14 * count) + 5 - Bit, 18, backcolor, layer);	// Text background (0xFF transparent) (Lettercount * Minimumsize) - Lettersize correktion
	
	//Start drawing letters
	Bit = 0;													// Correction Counter for different letter size (e.g. i or w)
	
	for (Ct = 0;Ct < count; Ct++)								// Letterloop
	{
		Buf = String[Ct] - 32;									// get the letter
		
		for (Ctt = 0;Ctt < 14; Ctt++)							// Letterbyteloop
		{		
			if (FONT10X9[Buf][(Ctt * 2) + 1] == 0x80) Bit++;	// if Letterbyte = 0x80 the end of the letter is reached and the next letter not move forward
			else
			{
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x01) == 1) PIXELP(x + Ctt + (Ct * 14) - Bit, y, set, layer);					// If Bit 0 set Pixel 0 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x02) == 2) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 1, set, layer);				// If Bit 1 set Pixel 1 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x04) == 4) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 2, set, layer);				// If Bit 2 set Pixel 2 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x08) == 8) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 3, set, layer);				// If Bit 3 set Pixel 3 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x10) == 16) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 4, set, layer);				// If Bit 4 set Pixel 4 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x20) == 32) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 5, set, layer);				// If Bit 5 set Pixel 5 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x40) == 64) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 6, set, layer);				// If Bit 6 set Pixel 6 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2)] & 0x80) == 128) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 7, set, layer);				// If Bit 7 set Pixel 7 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x01) == 1) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 8, set, layer);			// If Bit 8 set Pixel 8 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x02) == 2) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 9, set, layer);			// If Bit 9 set Pixel 9 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x04) == 4) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 10, set, layer);			// If Bit 10 set Pixel 10 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x08) == 8) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 11, set, layer);			// If Bit 11 set Pixel 11 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x10) == 16) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 12, set, layer);		// If Bit 12 set Pixel 12 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x20) == 32) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 13, set, layer);		// If Bit 13 set Pixel 13 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x40) == 64) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 14, set, layer);		// If Bit 14 set Pixel 14 in the Row is drawed in the color
				if ((FONT10X9[Buf][(Ctt * 2) + 1] & 0x80) == 128) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 15, set, layer);		// If Bit 15 set Pixel 15 in the Row is drawed in the color
			}							
		}
	}
}

void Display::TEXTOUTxvbig(char *String, int x, int y, char set, unsigned long *layer)	// Draw Text at Pos X / Y with Color and BackColor (FF = Transparent)
{
	int Ct, Ctt, Bit;
	int count;
	unsigned char Buf;
	
	count = strlen(String);
	
	// Start drawing background
	Bit = 0;												// Correction Counter for different letter size (e.g. i or w)
	
	for (Ct = 0;Ct < count; Ct++)							// Calculate the correction for the background
	{
		Buf = String[Ct] - 32;								// get the letter
				
		for (Ctt = 0;Ctt < 14; Ctt++)						// test the Bytes of the letter (x size)
		{
			if (FONT12X9[Buf][(Ctt * 2) + 1] == 0x80) Bit++;	// if its size small than the minimum size 0x80 signals it		
		}
	}	
	
	//Draw Background	
//	if (backcolor != 0xFF) DRAWP(x - 3, y - 3, (14 * count) + 5 - Bit, 19, backcolor, layer);	// Text background (0xFF transparent) (Lettercount * Minimumsize) - Lettersize correktion
	
	//Start drawing letters
	Bit = 0;													// Correction Counter for different letter size (e.g. i or w)
	
	for (Ct = 0;Ct < count; Ct++)								// Letterloop
	{
		Buf = String[Ct] - 32;									// get the letter
		for (Ctt = 0;Ctt < 14; Ctt++)							// Letterbyteloop
		{
			if (FONT12X9[Buf][(Ctt * 2) + 1] == 0x80) Bit++;	// if Letterbyte = 0x80 the end of the letter is reached and the next letter not move forward
			else
			{
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x01) == 1) PIXELP(x + Ctt + (Ct * 14) - Bit, y, set, layer);					// If Bit 0 set Pixel 0 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x02) == 2) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 1, set, layer);				// If Bit 1 set Pixel 1 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x04) == 4) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 2, set, layer);				// If Bit 2 set Pixel 2 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x08) == 8) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 3, set, layer);				// If Bit 3 set Pixel 3 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x10) == 16) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 4, set, layer);				// If Bit 4 set Pixel 4 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x20) == 32) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 5, set, layer);				// If Bit 5 set Pixel 5 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x40) == 64) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 6, set, layer);				// If Bit 6 set Pixel 6 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2)] & 0x80) == 128) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 7, set, layer);				// If Bit 7 set Pixel 7 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x01) == 1) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 8, set, layer);			// If Bit 8 set Pixel 8 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x02) == 2) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 9, set, layer);			// If Bit 9 set Pixel 9 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x04) == 4) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 10, set, layer);			// If Bit 10 set Pixel 10 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x08) == 8) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 11, set, layer);			// If Bit 11 set Pixel 11 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x10) == 16) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 12, set, layer);		// If Bit 12 set Pixel 12 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x20) == 32) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 13, set, layer);		// If Bit 13 set Pixel 13 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x40) == 64) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 14, set, layer);		// If Bit 14 set Pixel 14 in the Row is drawed in the color
				if ((FONT12X9[Buf][(Ctt * 2) + 1] & 0x80) == 128) PIXELP(x + Ctt + (Ct * 14) - Bit, y + 15, set, layer);		// If Bit 15 set Pixel 15 in the Row is drawed in the color
			}								
		}
	}
}

void Display::BITBITMAP(unsigned char *pointer, int x, int y, unsigned char set, unsigned long *layer)	// Draw two color bitmap
{
	int cc, cx, cy, pos;
	unsigned char ccmask;

	int sizex = (int) pointer[0] / 8;
	int sizey = pointer[1];


	pos = 2;

	for (cy = 0; cy < sizey; cy++)
	{
		for (cx = 0; cx < sizex; cx++)
		{
			ccmask = 0x80;			
			
			for (cc = 0; cc < 8; cc++)
			{			
				if ((pointer[pos] & ccmask) == ccmask)
				{
					PIXELP(x + cc + (cx * 8), y + cy, set, layer);
				}
				ccmask = ccmask >> 1;
			}
			pos++;			
		}
	}
}
// TMW changed (complete grid changed)
void Display::GRID(unsigned long x, unsigned long y, unsigned long *layer) 		// Draw Grid subroutine
{
	unsigned long lX;
	unsigned long lY;
	
	// Clear Gridplane
	for (lX = 0; lX < 9600; lX++)
	{
		layer[lX] = 0;
	}
    	
	for (lX = x; lX < (x + 601); lX ++)
	{
		if ((lX - x)%2 == 0) 
			{
			PIXELP(lX, y - 1, 1, layer);			// 2 er Dots Top Line
			PIXELP(lX, y + 192, 1, layer);			// 2 er Dots Middle Line
			PIXELP(lX, y + 385, 1, layer);			// 2 er Dots Bottom Line
			}
		
		
		if((((lX - x)%25 == 0)&&((lX - x) > 5) && ((lX - x) < 595)) || ( (lX - x) == 12 ) || ( (lX - x) == 588 ))
			{
			PIXELP(lX, y + 0, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX, y + 2, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX, y + 189, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 191, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 193, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 195, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 382, 1, layer); 		// 10 er Dots Bottom Line
			PIXELP(lX, y + 384, 1, layer); 		// 10 er Dots Bottom Line
			}		
		if (((lX - x)%50 == 0)&&((lX - x) > 5) && ((lX - x) < 595))
			{
			PIXELP(lX-12, y + 0, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX-12, y + 2, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX-12, y + 189, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX-12, y + 191, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX-12, y + 193, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX-12, y + 195, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX-12, y + 382, 1, layer); 		// 10 er Dots Bottom Line
			PIXELP(lX-12, y + 384, 1, layer); 		// 10 er Dots Bottom Line

			PIXELP(lX+12, y + 0, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX+12, y + 2, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX+12, y + 189, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX+12, y + 191, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX+12, y + 193, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX+12, y + 195, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX+12, y + 382, 1, layer); 		// 10 er Dots Bottom Line
			PIXELP(lX+12, y + 384, 1, layer); 		// 10 er Dots Bottom Line
			}		


		if (((lX - x)%50 == 0) && ((lX - x) > 5) && ((lX - x) < 595) && ((lX - x) != 300))
		{

			PIXELP(lX, y + 1, 1, layer); 		// 10 er Dots Top Line
			PIXELP(lX, y + 3, 1, layer); 		// 10 er Dots Top Line			
			PIXELP(lX, y + 5, 1, layer); 		// 10 er Dots Top Line			
			PIXELP(lX, y + 186, 1, layer); 		// 10 er Dots Middle Line			
			PIXELP(lX, y + 188, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 190, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 194, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 196, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(lX, y + 198, 1, layer); 		// 10 er Dots Middle Line			
			PIXELP(lX, y + 379, 1, layer); 		// 10 er Dots Bottom Line			
			PIXELP(lX, y + 381, 1, layer); 		// 10 er Dots Bottom Line			
			PIXELP(lX, y + 383, 1, layer); 		// 10 er Dots Bottom Line	

			for (lY = y; lY < (y + 384); lY += 12)
				PIXELP(lX, lY, 1, layer); 		// 50 er Dots
		}
		
	}
	
	for	(lY = y; lY < (y + 385); lY += 2) 		//401
	{
		PIXELP(x - 1, lY, 1, layer);			// 2 er Dots Left Line
		PIXELP(x + 300, lY, 1, layer);			// 2 er Dots Middle Line
		PIXELP(x + 601, lY, 1, layer);			// 2 er Dots Right Line		
		
		if (((lY - y)%12== 0) && ((lY - y) > 4) && ((lY - y) < 380) && ((lY - y) != 192) && ((lY - y)%48 != 0))
		{
			PIXELP(x + 0, lY, 1, layer); 		// 10 er Dots Left Line
			PIXELP(x + 2, lY, 1, layer); 		// 10 er Dots Left Line
			PIXELP(x + 297, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 299, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 301, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 303, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 598, lY, 1, layer); 		// 10 er Dots Right Line
			PIXELP(x + 600, lY, 1, layer); 		// 10 er Dots Right Line					
		}		
		
		if (((lY - y)%48 == 0) && ((lY - y) > 4) && ((lY - y) < 380) && ((lY - y) != 192))
		{

			PIXELP(x + 1, lY, 1, layer); 		// 10 er Dots Left Line
			PIXELP(x + 3, lY, 1, layer); 		// 10 er Dots Left Line			
			PIXELP(x + 5, lY, 1, layer); 		// 10 er Dots Left Line			
			PIXELP(x + 294, lY, 1, layer); 		// 10 er Dots Middle Line			
			PIXELP(x + 296, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 298, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 302, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 304, lY, 1, layer); 		// 10 er Dots Middle Line
			PIXELP(x + 306, lY, 1, layer); 		// 10 er Dots Middle Line			
			PIXELP(x + 595, lY, 1, layer); 		// 10 er Dots Right Line			
			PIXELP(x + 597, lY, 1, layer); 		// 10 er Dots Right Line	
			PIXELP(x + 599, lY, 1, layer); 		// 10 er Dots Right Line

		for (lX = x ; lX < (x + 600); lX += 25)
			{
			PIXELP(lX, lY, 1, layer); 		// 50 er Dots
			if (((lX - x)%50 == 0)&&((lX - x) > 5) && ((lX - x) < 595))
				{
				PIXELP(lX-12, lY, 1, layer); 		// 50 er Dots
				PIXELP(lX+12, lY, 1, layer); 		// 50 er Dots
				}
			if ((lX - x) == 0 )
				PIXELP(lX+12, lY, 1, layer); 		// 50 er Dots
			if ((lX - x) == 575 )
				PIXELP(lX+13, lY, 1, layer); 		// 50 er Dots
	
				
				
				
				
			}
		}		
	}
	
	PIXELP(x - 1, y - 1, 1, layer); 			// Left Top Edge
	PIXELP(x + 601, y - 1, 1, layer); 			// Right Top Edge
	PIXELP(x - 1, y + 385, 1, layer); 			// Left Bottom Edge
	PIXELP(x + 601, y + 385, 1, layer); 		// Right Bottom Edge
}
// TMW change ends

void Display::GRIDDELAYED(unsigned long x, unsigned long y, unsigned long *layer) 		// Draw Grid subroutine
{
	unsigned long lX;
	unsigned long lY;
	unsigned long by = y + 192;	
	
	// Clear Gridplane
	for (lX = 0; lX < 9600; lX++)
	{
		layer[lX] = 0;
	}	
	
	for (lX = x; lX < (x + 601); lX += 2)
	{
		PIXELP(lX, y - 1, 1, layer);											// 2 er Dots Top Line
		PIXELP(lX, y + 96, 1, layer);											// 2 er Dots Middle Line
		PIXELP(lX, y + 193, 1, layer);											// 2 er Dots Bottom Line
		
		
		if (((lX - x)%10 == 0) && ((lX - x) > 5) && ((lX - x) < 595) && ((lX - x) != 300) && ((lX - x)%50 != 0))
		{
			PIXELP(lX, y + 0, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 2, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 93, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 95, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 97, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 99, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 190, 1, layer); 									// 10 er Dots Bottom Line
			PIXELP(lX, y + 192, 1, layer); 									// 10 er Dots Bottom Line
	
		}		

		if (((lX - x)%50 == 0) && ((lX - x) > 5) && ((lX - x) < 595) && ((lX - x) != 300))
		{

			PIXELP(lX, y + 1, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 3, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, y + 5, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, y + 90, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, y + 92, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 94, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 98, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 100, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 102, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, y + 187, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, y + 189, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, y + 191, 1, layer); 									// 10 er Dots Bottom Line	

			for (lY = (y + 8); lY < (y + 192); lY += 8)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}
		
	}
	
	for	(lY = y; lY < (y + 193); lY += 2) //401
	{
		PIXELP(x - 1, lY, 1, layer);											// 2 er Dots Left Line
		PIXELP(x + 300, lY, 1, layer);											// 2 er Dots Middle Line
		PIXELP(x + 601, lY, 1, layer);											// 2 er Dots Right Line		
		
		if (((lY - y)%4 == 0) && ((lY - y) > 2) && ((lY - y) < 190) && ((lY - y) != 96) && ((lY - y)%24 != 0))
		{
			PIXELP(x + 0, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 2, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 297, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 299, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 301, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 303, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 598, lY, 1, layer); 									// 10 er Dots Right Line
			PIXELP(x + 600, lY, 1, layer); 									// 10 er Dots Right Line					
		}		
		
		if (((lY - y)%24 == 0) && ((lY - y) > 2) && ((lY - y) < 190) && ((lY - y) != 96))
		{

			PIXELP(x + 1, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 3, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 5, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 294, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 296, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 298, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 302, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 304, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 306, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 595, lY, 1, layer); 									// 10 er Dots Right Line			
			PIXELP(x + 597, lY, 1, layer); 									// 10 er Dots Right Line	
			PIXELP(x + 599, lY, 1, layer); 									// 10 er Dots Right Line

			for (lX = (x + 10); lX < (x + 600); lX += 10)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}		
	}
	
	PIXELP(x - 1, y - 1, 1, layer); 											// Left Top Edge
	PIXELP(x + 601, y - 1, 1, layer); 											// Right Top Edge
	PIXELP(x - 1, y + 193, 1, layer); 											// Left Bottom Edge
	PIXELP(x + 601, y + 193, 1, layer); 										// Right Bottom Edge
	
    // Delayed Part

	for (lX = x; lX < (x + 601); lX += 2)
	{
		PIXELP(lX, by - 1, 1, layer);											// 2 er Dots Top Line
		PIXELP(lX, by + 96, 1, layer);											// 2 er Dots Middle Line
		PIXELP(lX, by + 193, 1, layer);											// 2 er Dots Bottom Line
		
		
		if (((lX - x)%10 == 0) && ((lX - x) > 5) && ((lX - x) < 595) && ((lX - x) != 300) && ((lX - x)%50 != 0))
		{
			PIXELP(lX, by + 0, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, by + 2, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, by + 93, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 95, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 97, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 99, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 190, 1, layer); 									// 10 er Dots Bottom Line
			PIXELP(lX, by + 192, 1, layer); 									// 10 er Dots Bottom Line
	
		}		

		if (((lX - x)%50 == 0) && ((lX - x) > 5) && ((lX - x) < 595) && ((lX - x) != 300))
		{

			PIXELP(lX, by + 1, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, by + 3, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, by + 5, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, by + 90, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, by + 92, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 94, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 98, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 100, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, by + 102, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, by + 187, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, by + 189, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, by + 191, 1, layer); 									// 10 er Dots Bottom Line	

			for (lY = (by + 8); lY < (by + 192); lY += 8)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}
		
	}
	
	for	(lY = by; lY < (by + 193); lY += 2) //401
	{
		PIXELP(x - 1, lY, 1, layer);											// 2 er Dots Left Line
		PIXELP(x + 300, lY, 1, layer);											// 2 er Dots Middle Line
		PIXELP(x + 601, lY, 1, layer);											// 2 er Dots Right Line		
		
		if (((lY - by)%4 == 0) && ((lY - by) > 2) && ((lY - by) < 190) && ((lY - by) != 96) && ((lY - by)%24 != 0))
		{
			PIXELP(x + 0, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 2, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 297, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 299, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 301, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 303, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 598, lY, 1, layer); 									// 10 er Dots Right Line
			PIXELP(x + 600, lY, 1, layer); 									// 10 er Dots Right Line					
		}		
		
		if (((lY - by)%24 == 0) && ((lY - by) > 2) && ((lY - by) < 190) && ((lY - by) != 96))
		{

			PIXELP(x + 1, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 3, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 5, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 294, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 296, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 298, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 302, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 304, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 306, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 595, lY, 1, layer); 									// 10 er Dots Right Line			
			PIXELP(x + 597, lY, 1, layer); 									// 10 er Dots Right Line	
			PIXELP(x + 599, lY, 1, layer); 									// 10 er Dots Right Line

			for (lX = (x + 10); lX < (x + 600); lX += 10)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}		
	}
	
	PIXELP(x - 1, by - 1, 1, layer); 											// Left Top Edge
	PIXELP(x + 601, by - 1, 1, layer); 											// Right Top Edge
	PIXELP(x - 1, by + 193, 1, layer); 											// Left Bottom Edge
	PIXELP(x + 601, by + 193, 1, layer); 										// Right Bottom Edge

	for (lX = x; lX < (x + 601); lX ++)
	{
		PIXELP(lX, by - 1, 1, layer);											// 2 er Dots Top Line
		PIXELP(lX, by + 0, 1, layer);											// 2 er Dots Middle Line
		PIXELP(lX, by + 1, 1, layer);											// 2 er Dots Bottom Line
    }
}

void Display::GRIDXY(unsigned long x, unsigned long y, unsigned long *layer) 		// Draw Grid subroutine
{
	unsigned long lX;
	unsigned long lY;
	
	// Clear Gridplane
	for (lX = 0; lX < 9600; lX++)
	{
		layer[lX] = 0;
	}
    	
	for (lX = x; lX < (x + 481); lX += 2)
	{
		PIXELP(lX, y - 1, 1, layer);											// 2 er Dots Top Line
		PIXELP(lX, y + 192, 1, layer);											// 2 er Dots Middle Line
		PIXELP(lX, y + 385, 1, layer);											// 2 er Dots Bottom Line
		
		
		if (((lX - x)%8 == 0) && ((lX - x) > 4) && ((lX - x) < 476) && ((lX - x) != 240) && ((lX - x)%48 != 0))
		{
			PIXELP(lX, y + 0, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 2, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 189, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 191, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 193, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 195, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 382, 1, layer); 									// 10 er Dots Bottom Line
			PIXELP(lX, y + 384, 1, layer); 									// 10 er Dots Bottom Line
	
		}		

		if (((lX - x)%48 == 0) && ((lX - x) > 4) && ((lX - x) < 476) && ((lX - x) != 240))
		{

			PIXELP(lX, y + 1, 1, layer); 										// 10 er Dots Top Line
			PIXELP(lX, y + 3, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, y + 5, 1, layer); 										// 10 er Dots Top Line			
			PIXELP(lX, y + 186, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, y + 188, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 190, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 194, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 196, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(lX, y + 198, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(lX, y + 379, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, y + 381, 1, layer); 									// 10 er Dots Bottom Line			
			PIXELP(lX, y + 383, 1, layer); 									// 10 er Dots Bottom Line	

			for (lY = (y + 8); lY < (y + 384); lY += 8)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}
		
	}
	
	for	(lY = y; lY < (y + 385); lY += 2) //401
	{
		PIXELP(x - 1, lY, 1, layer);											// 2 er Dots Left Line
		PIXELP(x + 240, lY, 1, layer);											// 2 er Dots Middle Line
		PIXELP(x + 481, lY, 1, layer);											// 2 er Dots Right Line		
		
		if (((lY - y)%8 == 0) && ((lY - y) > 4) && ((lY - y) < 380) && ((lY - y) != 192) && ((lY - y)%48 != 0))
		{
			PIXELP(x + 0, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 2, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 237, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 239, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 241, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 243, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 478, lY, 1, layer); 									// 10 er Dots Right Line
			PIXELP(x + 480, lY, 1, layer); 									// 10 er Dots Right Line					
		}		
		
		if (((lY - y)%48 == 0) && ((lY - y) > 4) && ((lY - y) < 380) && ((lY - y) != 192))
		{

			PIXELP(x + 1, lY, 1, layer); 										// 10 er Dots Left Line
			PIXELP(x + 3, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 5, lY, 1, layer); 										// 10 er Dots Left Line			
			PIXELP(x + 234, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 236, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 238, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 242, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 244, lY, 1, layer); 									// 10 er Dots Middle Line
			PIXELP(x + 246, lY, 1, layer); 									// 10 er Dots Middle Line			
			PIXELP(x + 379, lY, 1, layer); 									// 10 er Dots Right Line			
			PIXELP(x + 477, lY, 1, layer); 									// 10 er Dots Right Line	
			PIXELP(x + 479, lY, 1, layer); 									// 10 er Dots Right Line

			for (lX = (x + 8); lX < (x + 479); lX += 8)
			{
				PIXELP(lX, lY, 1, layer); 										// 50 er Dots
			}
		}		
	}
	
	PIXELP(x - 1, y - 1, 1, layer); 											// Left Top Edge
	PIXELP(x + 481, y - 1, 1, layer); 											// Right Top Edge
	PIXELP(x - 1, y + 385, 1, layer); 											// Left Bottom Edge
	PIXELP(x + 481, y + 385, 1, layer); 										// Right Bottom Edge
}

void Display::StatusUpdate(void)
{
	if ((Channel_1_Active == 0) && (Channel_1_Active_Old == 1) && (VoltageChangedCh1 == 1))
	{
		DRAWP(6, 4, 6, 10, 0, Channel_Plane1);										// Clear Channel Text	
//		DRAWP(6, 4, 6, 10, 0, Buffer_Plane1);										// Clear Channel Text	
		DRAWP(3, 0, 68, 18, 0, UI_Plane2);											// Clear Text

		DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnRemove);						// Button
		
	}
	else if ((Channel_1_Active == 1) && (Channel_1_Active_Old == 0) && (VoltageChangedCh1 == 1))
	{
		DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnDraw);							// Button
		TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//		TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text
		
		//VoltageChangedCh1 = 1;

	}
	
	if ((Channel_2_Active == 0) && (Channel_2_Active_Old == 1) && (VoltageChangedCh2 == 1))
	{
		DRAWP(82, 4, 6, 10, 0, Channel_Plane2);										// Clear Channel Text	
//		DRAWP(82, 4, 6, 10, 0, Buffer_Plane2);										// Clear Channel Text	
		DRAWP(79, 0, 68, 18, 0, UI_Plane2);											// Clear Text

		DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnRemove);						// Button
				

	}
	else if ((Channel_2_Active == 1) && (Channel_2_Active_Old == 0) && (VoltageChangedCh2 == 1))
	{
		DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnDraw);						// Button
		TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);									// Draw Voltage Text
//		TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);									// Draw Voltage Text
		
		//VoltageChangedCh2 = 1;
		
	}
	
	if (NumberOfChannels > 2)
	{
	if ((Channel_3_Active == 0) && (Channel_3_Active_Old == 1) && (VoltageChangedCh3 == 1))
	{
		DRAWP(158, 4, 6, 10, 0, Channel_Plane3);									// Clear Channel Text	
//		DRAWP(158, 4, 6, 10, 0, Buffer_Plane3);									// Clear Channel Text	
		DRAWP(155, 0, 68, 18, 0, UI_Plane2);										// Clear Text

		DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnRemove);						// Button
		
	}
	else if ((Channel_3_Active == 1) && (Channel_3_Active_Old == 0) && (VoltageChangedCh3 == 1))
	{
		DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button
//		TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);								// Draw Voltage Text		
		TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);								// Draw Voltage Text		
		
		//VoltageChangedCh3 = 1;
		
		//DRAWZERO(3, 0);																// Draw Zero Marker	
	}
	
	if ((Channel_4_Active == 0) && (Channel_4_Active_Old == 1) && (VoltageChangedCh4 == 1))
	{
		DRAWP(234, 4, 6, 10, 0, Channel_Plane4);									// Clear Channel Text	
		DRAWP(234, 4, 6, 10, 0, Buffer_Plane4);									// Clear Channel Text	
		DRAWP(231, 0, 68, 18, 0, UI_Plane2);										// Clear Text

		DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnRemove);						// Button
		
		//REMOVEZERO(4);																// Remove Zero Marker		
	}
	else if ((Channel_4_Active == 1) && (Channel_4_Active_Old == 0) && (VoltageChangedCh4 == 1))
	{
		DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button		
		TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);								// Draw Voltage Text		
		TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);								// Draw Voltage Text		
		
		//VoltageChangedCh4 = 1;
		
		//DRAWZERO(4, 0);	
	}
    }			
	
	// Update Statusbar
	if ((Channel_1_Active == 1) && (VoltageChangedCh1 == 1)) DRAWSTATUS(1, 0);		// Draw Voltage Channel 1
	if ((Channel_2_Active == 1) && (VoltageChangedCh2 == 1)) DRAWSTATUS(2, 0);		// Draw Voltage Channel 2
	if (NumberOfChannels > 2)
	{
	   if ((Channel_3_Active == 1) && (VoltageChangedCh3 == 1)) DRAWSTATUS(3, 0);		// Draw Voltage Channel 3
	   if ((Channel_4_Active == 1) && (VoltageChangedCh4 == 1)) DRAWSTATUS(4, 0);		// Draw Voltage Channel 4		
	}
	
	if (TimebaseChanged == 1) DRAWSTATUS(0, 0);										// Draw Timebase
	if (TimeOffsetChanged == 1) DRAWSTATUS(5, 0);									// Draw Timebase Offset
	if (TriggerLevelChanged == 1) DRAWSTATUS(6, 0);									// Draw Trigger Level
	if (TriggerModeChanged == 1) DRAWSTATUS(7, 0);									// Draw Auto	
	if (TriggerWayChanged == 1) DRAWSTATUS(8, 0);									// Draw Trigger way	
	
//	if (Selected_Trigger_Source != Selected_Trigger_Source_Old)
	{
		//DRAWZEROS();		
	}	
	
	MenuTimeCounter = 0;	
}

void Display::DRAWSTATUS(int Which, int isChanging)
{
	unsigned char xe = 0;
	unsigned char xf = 0;	
	unsigned short Buffer = 0;
	char BufferText[17];
	char BufferText2[17];
#ifdef _Debug_	
    printf("DS %d iC %d\n", Which, isChanging);
#endif			
	switch(Which)
	{
		// Timebase
		case 0:
		{
            if (MenuStatus[10][1] == 1) // Delayed Mode
            {
                // If One statusbutton aktive and not the timebase -> remove it
                if ((isChanging == 1) && (StatusbarChanged > 0))
                {
				    if (StatusbarChanged != 11) Display::RemoveStatusBtn();
				    Hardware::ResetTimer();												// Reset the Timer
                }	
						
                if ((isChanging == 1) && (StatusbarChanged == 0))
                {
                    DRAWROUNDBUTTON(326, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				    //timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				    StatusbarChanged = 11;
                }

                DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0

                sprintf(BufferText, "");
                for (xe = 0; xe < 10; xe++)
                {
				    BufferText[xe] = TimebaseData_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx][xe];	
                }
                TEXTOUTxvbig(BufferText, 335 + TimebaseDataDef[dmode_Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
			
                sprintf(BufferText, "");
                for (xe = 0; xe < 10; xe++)
                {
                    BufferText[xe] = TimebaseData_Matrix[Selected_Timebase][SIGNALFaktor_idx][xe];	
                }
                TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
            }  /*
            else if (MenuStatus[10][2] == 1) // Roll Mode
            {
                // If One statusbutton aktive and not the timebase -> remove it
                if ((isChanging == 1) && (StatusbarChanged > 0))
                {
				    if (StatusbarChanged != 10) Display::RemoveStatusBtn();
				    Hardware::ResetTimer();												// Reset the Timer
                }	
						
                if ((isChanging == 1) && (StatusbarChanged == 0))
                {
                    DRAWROUNDBUTTON(404, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				    //timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				    StatusbarChanged = 10;
                }

                DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0
               */  /*
                sprintf(BufferText, "");
                for (xe = 0; xe < 10; xe++)
                {
				    BufferText[xe] = SampleRateData[Selected_Timebase][xe];	// Offset to Text in MenuBlock 0x00200000
                }
                TEXTOUTxvbig(BufferText, 335 + SampleRateDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
			    */  /*
                sprintf(BufferText, "");
                for (xe = 0; xe < 10; xe++)
                {
                    BufferText[xe] = TimebaseData[25 + ROLLMODE_TB][xe];	// Offset to Text in MenuBlock 0x00200000
                }
                TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[25 + ROLLMODE_TB], 2, 1, UI_Plane2);					// Draw Menu Text
            }	*/			
            else // Main Mode
            {
                // If One statusbutton aktive and not the timebase -> remove it
                if ((isChanging == 1) && (StatusbarChanged > 0))
                {
				    if (StatusbarChanged != 10) Display::RemoveStatusBtn();
				    Hardware::ResetTimer();												// Reset the Timer
                }	
						
                if ((isChanging == 1) && (StatusbarChanged == 0))
                {
                    DRAWROUNDBUTTON(404, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				    //timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				    StatusbarChanged = 10;
                }

                DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0

                sprintf(BufferText, "");
                for (xe = 0; xe < 11; xe++)
                {
				    BufferText[xe] = SampleRateData[Selected_Timebase][xe];	// Offset to Text in MenuBlock 0x00200000
                }
                TEXTOUTxvbig(BufferText, 335 + SampleRateDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
			
                sprintf(BufferText, "");
                for (xe = 0; xe < 10; xe++)
                {
                    BufferText[xe] = TimebaseData_Matrix[Selected_Timebase][SIGNALFaktor_idx][xe];	// Offset to Text in MenuBlock 0x00200000
                }
                TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
            }
						
			
            TimebaseChanged = 0;
			
			break;
		}
			
		// Voltage CH 1	
		case 1:
		{	
			CALCVOLTAGE(1, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 1) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}
					
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(15, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 1;
			}

			DRAWP(16, 0, 62, 18, 0, UI_Plane2);										// Clear First
								
			TEXTOUTxvbig(BufferText, 24, 2, 1, UI_Plane2);				// Draw Voltage Text
			
			VoltageChangedCh1 = 0;
			
			break;
		}
		
		// Voltage CH 2	
		case 2:
		{
			CALCVOLTAGE(2, &BufferText[0]);											// Calculate Text
			
			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 2) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(91, 0, 64, 20, btnUnpushed, btnDraw);			// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 2;
			}	
	
			DRAWP(92, 0, 61, 18, 0, UI_Plane2);											// Clear First
			
			TEXTOUTxvbig(BufferText, 100, 2, 1, UI_Plane2);					// Draw Voltage Text

			VoltageChangedCh2 = 0;
			
			break;
		}

		// Voltage CH 3	
		case 3:
		{
			CALCVOLTAGE(3, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 3) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}	
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(167, 0, 64, 20, btnUnpushed, btnDraw);			// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 3;
			}	

			DRAWP(174, 0, 55, 18, 0, UI_Plane2);									// Clear First
		
			TEXTOUTxvbig(BufferText, 176, 2, 1, UI_Plane2);				// Draw Voltage Text

			VoltageChangedCh3 = 0;
			
			break;
		}
		
		// Voltage CH 4
		case 4:
		{
			CALCVOLTAGE(4, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 4) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}	
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(243, 0, 64, 20, btnUnpushed, btnDraw);			// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 4;
			}

			DRAWP(244, 0, 65, 18, 0, UI_Plane2);									// Clear First

			TEXTOUTxvbig(BufferText, 252, 2, 1, UI_Plane2);				// Draw Voltage Text

			VoltageChangedCh4 = 0;
			
			break;
		}	
		
		// Timebase Offset  // Mu noch upgedated werden
		case 5:
		{

			
	//		if (isChanging == 1) DRAWROUNDBUTTON(330, 0, 76, 20, btnUnpushed, btnDraw);			// Button
	//		else
//			DRAWP(338, 0, 62, 18, 0, UI_Plane2);										// Clear First
			
            Display::DRAW_ALL_CURSOR();			
            			
			TimeOffsetChanged = 0;

    			
			break;
		}		
		
		// Trigger Level
		case 6:
		{		
			DRAWP(560, 0, 79, 18, 0, UI_Plane2);									// Clear First
            		
            //if (triggering == 0) return;
            if (MenuStatus[14][3] == 1) return;       // Ext Trig TV Ch1
            if (MenuPopupStatus[8][2] == 3) return;   // Ext Trig Line

			CALCTRIGGER();															// Calculate Text
            /*
			if (((isChanging == 1) && (StatusbarChanged > 0)) || (MenuStatus[10][2] == 1))
			{
				if (StatusbarChanged != 6) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}	
          	*/		
			//if ((isChanging == 1) && (StatusbarChanged == 0) && (MenuStatus[10][2] == 0))
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(558, 0, 82, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 6;
			}		
				
			//if (MenuStatus[10][2] == 0)
			{
                if (MenuStatus[14][2] == 1) TEXTOUTxvbig(Trigger_ExtLevel_Str.Read_Text(), 567, 2, 1, UI_Plane2);					// Draw Voltage Text		
                else TEXTOUTxvbig(Trigger_Level_Str.Read_Text(), 567, 2, 1, UI_Plane2);					// Draw Voltage Text		
            }
			
		
			TriggerLevelChanged = 0;
			
			break;
		}	
		
		// Trigger Auto
		case 7:
		{
            if (Continius)
            {	
                BITBITMAP(bitbmStopTrigger, 464, 0, 1, UI_Plane3);           // Mu eventuell ins Flashen vom Flash beim starten
                BITBITMAP(bitbmStopTrigger_stop, 464, 6, 0, UI_Plane1);           // Mu eventuell ins Flashen vom Flash beim starten
                //DRAWP(464, 0, 50, 18, 1, UI_Plane3);								// Clear First
                DRAWP(464, 0, 50, 18, 0, UI_Plane2);								// Clear First
                DRAWP(464, 0, 50, 18, 0, Channel_Plane4);								// Clear First
                DRAWP(464, 0, 50, 18, 0, Buffer_Plane4);								// Clear First
			
                //if (MenuStatus[10][2] == 1) sprintf(BufferText, "Free");
                //else
                if (MenuStatus[12][0] == 93) sprintf(BufferText, "Auto");
                else sprintf(BufferText, "Norm");
			
					
                TEXTOUTxvbig(BufferText, 471, 2, 1, UI_Plane2);					// Draw Voltage Text		
            }
            else
            {
                DRAWP(464, 0, 50, 18, 0, UI_Plane2);								// Clear First
                //DRAWP(464, 0, 50, 18, 0, UI_Plane3);								// Clear First
                //DRAWP(464, 0, 50, 18, 0, UI_Plane4);								// Clear First
                BITBITMAP(bitbmStopTrigger, 464, 0, 0, UI_Plane3);              // Mu eventuell ins Flashen vom Flash beim starten
                BITBITMAP(bitbmStopTrigger, 464, 0, 1, Channel_Plane4);           // Mu eventuell ins Flashen vom Flash beim starten
                BITBITMAP(bitbmStopTrigger, 464, 0, 1, Buffer_Plane4);           // Mu eventuell ins Flashen vom Flash beim starten
                BITBITMAP(bitbmStopTrigger_stop, 464, 6, 1, UI_Plane1);           // Mu eventuell ins Flashen vom Flash beim starten


            }
			
			TriggerModeChanged = 0;
			
			break;
		}
		
		// Trigger Way
		case 8:
		{
			DRAWP(517, 0, 40, 18, 0, UI_Plane2);									// Clear First
#ifdef _Debug_			
			printf("TW %d MS[14][1] %d MS[14][2] %d MS[14][3] %d STS %d SEE %d\n", TriggerWay, MenuStatus[14][1], MenuStatus[14][2], MenuStatus[14][3], Selected_Trigger_Source, SelectedEdgeExtern);
#endif
			switch(TriggerWay)
			{
				case 1:	
				{
					if (MenuStatus[14][1] == 138)
					{
						xe = '1';
						xf = ' ';
						Selected_Trigger_Source = 1;
					}					
					else if (MenuStatus[14][1] == 139)
					{
						xe = '2';
						xf = ' ';
						Selected_Trigger_Source = 2;
					}
					else if (MenuStatus[14][1] == 140)
					{
						xe = '3';
						xf = ' ';
						Selected_Trigger_Source = 3;
					}
                    else if (MenuStatus[14][1] == 141)
					{
						xe = '4';
						xf = ' ';
						Selected_Trigger_Source = 4;
					}
					
                    if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 0) && (MenuPopupStatus[8][0] == 3))
					{
						xe = 'X';
						xf = 'L';
						Selected_Trigger_Source = 5;
					}
					
                    if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 0) && (MenuPopupStatus[8][1] == 3))
					{
						xe = 'X';
						xf = 'H';
						Selected_Trigger_Source = 5;
					}					
					
                    if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 1) && (MenuPopupStatus[8][2] == 3))
					{
						xe = 'L';
						xf = ' ';
						Selected_Trigger_Source = 6;
					}
					
                    if ((MenuStatus[14][3] == 1) && (SelectedEdgeExtern == 2))
					{
						xe = 'T';
						xf = 'V';
						Selected_Trigger_Source = 6;
					}

                    // if channel who triggers is inverted
                    if (MenuStatus[(MenuStatus[14][1] - 137)][2] == 241)
                    {					
                        switch(MenuStatus[14][0])
                        {
                            case 2:	sprintf(BufferText, "~ %c%c", xe, xf); break;
                            case 3:	sprintf(BufferText, "} %c%c", xe, xf); break;			
                        }	
                    }
                    else
                    {					
                        switch(MenuStatus[14][0])
                        {
                            case 2:	sprintf(BufferText, "} %c%c", xe, xf); break;
                            case 3:	sprintf(BufferText, "~ %c%c", xe, xf); break;			
                        }	
                    }
                    
					break;	
                    		
				}
							
				case 2:
				{				
					switch(MenuStatus[15][0])
					{
						case 138 : xe = '1'; Selected_Trigger_Source = 1; break;
						case 139 : xe = '2'; Selected_Trigger_Source = 2; break;
						case 140 : xe = '3'; Selected_Trigger_Source = 3; break;
						case 141 : xe = '4'; Selected_Trigger_Source = 4; break;
						case 142 : xe = 'X'; Selected_Trigger_Source = 5; break;
					}
					/*				
					switch(MenuStatus[15][1])
					{
						case 2:	sprintf(BufferText, "%c %c", 138, xe); break;
						case 3:	sprintf(BufferText, "%c %c", 139, xe); break;			
					}	
                    */					
					sprintf(BufferText, "%c %c", 138, xe);
					
					break;
				}
				
				case 3:  // Kann raus
				{				
					switch(MenuStatus[23][0])
					{
						case 138 : xe = '1'; Selected_Trigger_Source = 1; break;
						case 139 : xe = '2'; Selected_Trigger_Source = 2; break;
						case 140 : xe = '3'; Selected_Trigger_Source = 3; break;
						case 141 : xe = '4'; Selected_Trigger_Source = 4; break;
						case 142 : xe = 'X'; Selected_Trigger_Source = 5; break;
					}
									
					sprintf(BufferText, "Pat %c", xe);
						
					break;
				}						
			}
			
			
			//if (MenuStatus[10][2] == 0)
			{            	
                TEXTOUTxvbig(BufferText, 520, 2, 1, UI_Plane2);					// Draw Triggerway Text
            }			
			TriggerWayChanged = 0;
			
			break;
		}				
	}
}		

void Display::RemoveStatusBtn(void)
{
	switch(StatusbarChanged)
	{
		case 1:
		{
			DRAWROUNDBUTTON(15, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}
		case 2:
		{
			DRAWROUNDBUTTON(91, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}
		case 3:
		{
			DRAWROUNDBUTTON(167, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}
		case 4:
		{
			DRAWROUNDBUTTON(243, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}	

		case 6:
		{
			DRAWROUNDBUTTON(558, 0, 82, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}			
		case 10: // Timebase
		{
			DRAWROUNDBUTTON(404, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}
		case 11: // Timebase Delayed
		{
			DRAWROUNDBUTTON(326, 0, 64, 20, btnUnpushed, btnRemove);						// Remove Button
			break;
		}							
		
	}

	StatusbarChanged = 0;	
}

void Display::UpdateMenu(void)
{
    int cnt;
	char BufferText[20];
	char MenuAktMem;

    char Btns_to_remove[6] = {0, 0, 0, 0, 0, 0};           //remove the button + text
    char Btns_to_remove_text[6] = {0, 0, 0, 0, 0, 0};      //remove the text
    char Btns_to_draw[6] = {0, 0, 0, 0, 0, 0};             //draw button
    char Btns_to_redraw[6] = {0, 0, 0, 0, 0, 0};           //draw text
#ifdef _Debug_
    printf("UpdateMenu\n");
#endif
    if (Splash_removed) for (cnt = 0; cnt < 6; cnt++) if (MenuItemDef[New_Menu][cnt] != 0) { Btns_to_draw[cnt] = 1; Btns_to_redraw[cnt] = 1; MenuItemPushed[cnt] = 0; MenuItemPushed_old[cnt] = 0;}
    Splash_removed = false;

    // printf("We are here2 and NewMenu is %d Active_Menu is %d MenuAktive is %d\n", New_Menu, Active_Menu, MenuAktive);

    // Check if Menu changed
    if (New_Menu != Active_Menu)
    {
        MenuAktive = 1;

        if (((New_Menu == 17) && (USB_Connected == false))) MenuAktive = 0; // Grayed menus
        for (cnt = 0; cnt < 6; cnt++)
        {

        if (MenuItemDef[Active_Menu][cnt] != 0)
            {
                if (MenuItemDef[New_Menu][cnt] == 0) Btns_to_remove[cnt] = 1;
                else
                {
                    /////if ((Active_Menu == 16) && (Channel_Math_Active)) Btns_to_draw[cnt] = 1;
                    Btns_to_remove_text[cnt] = 1;
                    Btns_to_redraw[cnt] = 1;
                }
            }
            else
            {
                if (MenuItemDef[New_Menu][cnt] != 0) { Btns_to_draw[cnt] = 1; Btns_to_redraw[cnt] = 1; }
            }
            /*
            //if ((Channel_Math_Active) && (MenuStatus[26][1] == 1) && (cnt > 1) && ((MenuAktive == 16) || (New_Menu == 16)))
            if ((Channel_Math_Active) && (MenuStatus[26][1] == 1) && (cnt > 1) && (New_Menu == 16))
            {
                Btns_to_remove[cnt] = 1;
                Btns_to_remove_text[cnt] = 0;
                Btns_to_redraw[cnt] = 0;
                Btns_to_draw[cnt] = 0;
            } */
        }		
    }
    else
    {
       	if (((New_Menu == 17) && (USB_Connected == false))) MenuAktive = 0; // Grayed menus
        for (cnt = 0; cnt < 6; cnt++)
        {
        if (((MenuAktive != MenuAktive_old) || (MenuItemChanged[cnt] == 1)) && (MenuItemDef[New_Menu][cnt] != 0))
            {
                if ((MenuItemPushed[cnt]) || (MenuItemPushed_old[cnt]))
                {
                    Btns_to_remove[cnt] = 1;
                    Btns_to_draw[cnt] = 1;
                    MenuItemPushed_old[cnt] = 0;

                    //timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
                }
                else
                {
                    Btns_to_remove_text[cnt] = 1;
                }
                Btns_to_redraw[cnt] = 1;

            }
                        /*
            if ((Channel_Math_Active) && (MenuStatus[26][1] == 1) && (cnt > 1) && ((Active_Menu == 16) || (New_Menu == 16)))
            {
                Btns_to_remove[cnt] = 1;
                Btns_to_remove_text[cnt] = 0;
                Btns_to_redraw[cnt] = 0;
                Btns_to_draw[cnt] = 0;

            }         */
        }
    }

    // TMW changed; placed below in different way to accelerate menu update
	MenuAktMem =MenuAktive; // TMW added to disable FFT Button (grayed out)
   	for (cnt = 0; cnt < 6; cnt++)
    	{
        if (Btns_to_remove[cnt] == 1) Display::ClearMenuItemAsm(cnt, 34560, 44);
        if (Btns_to_draw[cnt] == 1) Display::DrawMenuItemButton(cnt, 1, MenuItemPushed[cnt]);
          if (Btns_to_remove_text[cnt] == 1) Display::ClearMenuItemTextAsm(cnt, 35040, 32);
  	if ( New_Menu == 26 ) { if ( cnt ==1 )MenuAktive = 0; else MenuAktive =MenuAktMem; }
		if (Btns_to_redraw[cnt] == 1) Display::DrawMenuItem(New_Menu, cnt, MenuAktive, 0);
 		} 
	// TMW change ends


    if (Cursor_Enabled) DRAWCURSORDATA(0);
    //if (QM_Enabled) CALCQMDATA();

    MenuAktive_old = MenuAktive;
    Active_Menu = New_Menu;
    Menu_Changed = 0;
    UpdateMenuTextPlane = true;
    VSync_Needed = 1;	
    
    UserIface_active_2 = 0;
    
/////    if ((adc_started == false) && (SingleMode == false) && (Continius) && (OneShotRestart == false) && (UserIface_active == false)&& (ROLLMODE_STARTED == false)) Hardware::Start_Record();
}

void Display::ClearMenuAsm(long start, long count)
{
    asm(" 	
	         PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	         MOVI	%r3,%lo(0x0095FA00)
	         PFX	%xhi(0x0095FA00)
	         MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
             PFX	%hi(0x00969000)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x00969000)
             PFX	%xhi(0x00969000)
             MOVHI	%r4,%xlo(0x00969000)*/
	
/*	
             PFX	%hi(0x009F5A00)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x009F5A00)
             PFX	%xhi(0x009F5A00)
             MOVHI	%r4,%xlo(0x009F5A00)
*/
             PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x008D3BF4)
             PFX	%xhi(0x008D3BF4)
             MOVHI	%r4,%xlo(0x008D3BF4)

             PFX	%hi(0x00972600)                   ; Set UI3 Address
             MOVI	%r5,%lo(0x00972600)
             PFX	%xhi(0x00972600)
             MOVHI	%r5,%xlo(0x00972600)	
	
             PFX	%hi(0x0097BC00)                   ; Set UI4 Address
             MOVI	%r6,%lo(0x0097BC00)
             PFX	%xhi(0x0097BC00)
             MOVHI	%r6,%xlo(0x0097BC00)                     	

             PFX	%hi(0x00985200)                   ; Set UI5 Address
             MOVI	%r7,%lo(0x00985200)
             PFX	%xhi(0x00985200)
             MOVHI	%r7,%xlo(0x00985200)	
	
             PFX	%hi(0x009AAA00)                   ; Set CH4 Address
             MOVI	%r8,%lo(0x009AAA00)
             PFX	%xhi(0x009AAA00)
             MOVHI	%r8,%xlo(0x009AAA00)

             ADD    %r3, %i0                          ; Add Address Counter
             ADD    %r4, %i0
             ADD    %r5, %i0
             ADD    %r6, %i0
             ADD    %r7, %i0
             ADD    %r8, %i0

             MOV    %r1, %i1	

             PFX	%hi(0)                            ; Set Clear register
             MOVI	%r2,%lo(0)
             PFX	%xhi(0)
             MOVHI	%r2,%xlo(0)	

             PFX	%hi(0xFFFFFFFF)                            ; Set Clear register
             MOVI	%r9,%lo(0xFFFFFFFF)
             PFX	%xhi(0xFFFFFFFF)
             MOVHI	%r9,%xlo(0xFFFFFFFF)	
	
             loopCM:
             ST     [%r3], %r2                        ; Clear Buffer
             ST     [%r4], %r2                        ; Clear Buffer
             ST     [%r5], %r9                        ; Clear Buffer
             ST     [%r6], %r2                        ; Clear Buffer
             ST     [%r7], %r2                        ; Clear Buffer
             ST     [%r8], %r2                        ; Clear Buffer
                                          	
             ADDI   %r3, 4                            ; Add Address Counter
             ADDI   %r4, 4
             ADDI   %r5, 4
             ADDI   %r6, 4
             ADDI   %r7, 4
             ADDI   %r8, 4	

             SUBI   %r1, 1                            ; Decrement Line Counter
             SKPS   cc_z
             BR     loopCM
             NOP 	
        ");

   // UpdateMenuTextPlane = true;
}

void Display::ClearMenuItemAsm(long which, long start, long count)
{
    switch(which)
    {
        case 0 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0x0001FFFF)                   ; Set MASK
                     MOVI	%r10,%lo(0x0001FFFF)
                     PFX	%xhi(0x0001FFFF)
                     MOVHI	%r10,%xlo(0x0001FFFF)

                     PFX	%hi(0xFFFE0000)                   ; Set MASK
                     MOVI	%r11,%lo(0xFFFE0000)
                     PFX	%xhi(0xFFFE0000)
                     MOVHI	%r11,%xlo(0xFFFE0000)   	


                     loopCMI0:

                     ;// UI 1
                     MOV    %L0, %r3

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     ST     [%L0], %r9                        ; Clear Buffer
                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI0
                     NOP 	
                ");
            break;
        }

        case 1 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
	
/*
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)

                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFF0000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFF0000)
                     PFX	%xhi(0xFFFF0000)
                     MOVHI	%r10,%xlo(0xFFFF0000)

                     PFX	%hi(0x0000FFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000FFFF)
                     PFX	%xhi(0x0000FFFF)
                     MOVHI	%r11,%xlo(0x0000FFFF)             	

                     PFX	%hi(0x000003FF)                   ; Set MASK
                     MOVI	%r12,%lo(0x000003FF)
                     PFX	%xhi(0x000003FF)
                     MOVHI	%r12,%xlo(0x000003FF)

                     PFX	%hi(0xFFFFFC00)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFC00)
                     PFX	%xhi(0xFFFFFC00)
                     MOVHI	%r13,%xlo(0xFFFFFC00)             	
	
                     loopCMI1:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI1
                     NOP 	
                 ");
            break;
        }

        case 2 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFFF80)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFFF80)
                     PFX	%xhi(0xFFFFFF80)
                     MOVHI	%r10,%xlo(0xFFFFFF80)

                     PFX	%hi(0x0000007F)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000007F)
                     PFX	%xhi(0x0000007F)
                     MOVHI	%r11,%xlo(0x0000007F)             	

                     loopCMI2:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer


                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer
                     STP    [%L0, 9], %r9                     ; Clear Buffer

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI2
                     NOP 	
                 ");
            break;
        }

        case 3 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0x00FFFFFF)                   ; Set MASK
                     MOVI	%r10,%lo(0x00FFFFFF)
                     PFX	%xhi(0x00FFFFFF)
                     MOVHI	%r10,%xlo(0x00FFFFFF)

                     PFX	%hi(0xFF000000)                   ; Set MASK
                     MOVI	%r11,%lo(0xFF000000)
                     PFX	%xhi(0xFF000000)
                     MOVHI	%r11,%xlo(0xFF000000)             	
	
                     loopCMI3:

                     ;// UI 1
                     MOV    %L0, %r3

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     STP    [%L0, 10], %r9                      ; Clear Buffer
                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI3
                     NOP 	
                ");
            break;
        }

        case 4 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFE00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFE00000)
                     PFX	%xhi(0xFFE00000)
                     MOVHI	%r10,%xlo(0xFFE00000)

                     PFX	%hi(0x001FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x001FFFFF)
                     PFX	%xhi(0x001FFFFF)
                     MOVHI	%r11,%xlo(0x001FFFFF)             	

                     PFX	%hi(0x00007FFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x00007FFF)
                     PFX	%xhi(0x00007FFF)
                     MOVHI	%r12,%xlo(0x00007FFF)

                     PFX	%hi(0xFFFF8000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFF8000)
                     PFX	%xhi(0xFFFF8000)
                     MOVHI	%r13,%xlo(0xFFFF8000)             	
	
                     loopCMI4:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI4
                     NOP 	
                 ");

            break;
        }

        case 5 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFF000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFF000)
                     PFX	%xhi(0xFFFFF000)
                     MOVHI	%r10,%xlo(0xFFFFF000)

                     PFX	%hi(0x00000FFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x00000FFF)
                     PFX	%xhi(0x00000FFF)
                     MOVHI	%r11,%xlo(0x00000FFF)             	

                     loopCMI5:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer


                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer
                     STP    [%L0, 19], %r9                    ; Clear Buffer

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
                     STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI5
                     NOP 	
                 ");
            break;
        }
    }
    //UpdateMenuTextPlane = true;
}

void Display::ClearMenuItemTextAsm(long which, long start, long count)
{
    switch(which)
    {
        case 0 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFC00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFC00000)
                     PFX	%xhi(0xFFC00000)
                     MOVHI	%r10,%xlo(0xFFC00000)

                     PFX	%hi(0x003FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x003FFFFF)
                     PFX	%xhi(0x003FFFFF)
                     MOVHI	%r11,%xlo(0x003FFFFF)

                     PFX	%hi(0x003FFFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x003FFFFF)
                     PFX	%xhi(0x003FFFFF)
                     MOVHI	%r12,%xlo(0x003FFFFF)

                     PFX	%hi(0xFFC00000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFC00000)
                     PFX	%xhi(0xFFC00000)
                     MOVHI	%r13,%xlo(0xFFC00000)                                	
	
                     loopCMIT0:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back


                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
 	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
                     STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT0
                     NOP 	
                ");
            break;
        }

        case 1 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFE000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFE000)
                     PFX	%xhi(0xFFFFE000)
                     MOVHI	%r10,%xlo(0xFFFFE000)

                     PFX	%hi(0x00001FFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x00001FFF)
                     PFX	%xhi(0x00001FFF)
                     MOVHI	%r11,%xlo(0x00001FFF)             	

                     PFX	%hi(0x00001FFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x00001FFF)
                     PFX	%xhi(0x00001FFF)
                     MOVHI	%r12,%xlo(0x00001FFF)

                     PFX	%hi(0xFFFFE000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFE000)
                     PFX	%xhi(0xFFFFE000)
                     MOVHI	%r13,%xlo(0xFFFFE000)             	
	
                     loopCMIT1:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT1
                     NOP 	
                 ");
            break;
        }

        case 2 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFFFE0)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFFFE0)
                     PFX	%xhi(0xFFFFFFE0)
                     MOVHI	%r10,%xlo(0xFFFFFFE0)

                     PFX	%hi(0x0000001F)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000001F)
                     PFX	%xhi(0x0000001F)
                     MOVHI	%r11,%xlo(0x0000001F)

                     PFX	%hi(0x0000000F)                   ; Set MASK
                     MOVI	%r12,%lo(0x0000000F)
                     PFX	%xhi(0x0000000F)
                     MOVHI	%r12,%xlo(0x0000000F)

                     PFX	%hi(0xFFFFFFF0)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFFF0)
                     PFX	%xhi(0xFFFFFFF0)
                     MOVHI	%r13,%xlo(0xFFFFFFF0)                                	

                     loopCMIT2:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back


                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT2
                     NOP 	
                 ");
            break;
        }

        case 3 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xF1000000)                   ; Set MASK
                     MOVI	%r10,%lo(0xF1000000)
                     PFX	%xhi(0xF1000000)
                     MOVHI	%r10,%xlo(0xF1000000)

                     PFX	%hi(0x07FFFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x07FFFFFF)
                     PFX	%xhi(0x07FFFFFF)
                     MOVHI	%r11,%xlo(0x07FFFFFF)

                     PFX	%hi(0x07FFFFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x07FFFFFF)
                     PFX	%xhi(0x07FFFFFF)
                     MOVHI	%r12,%xlo(0x07FFFFFF)

                     PFX	%hi(0xF8000000)                   ; Set MASK
                     MOVI	%r13,%lo(0xF8000000)
                     PFX	%xhi(0xF8000000)
                     MOVHI	%r13,%xlo(0xF8000000)                                 	
	
                     loopCMIT3:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT3
                     NOP 	
                ");
            break;
        }

        case 4 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFE00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFE00000)
                     PFX	%xhi(0xFFE00000)
                     MOVHI	%r10,%xlo(0xFFE00000)

                     PFX	%hi(0x001FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x001FFFFF)
                     PFX	%xhi(0x001FFFFF)
                     MOVHI	%r11,%xlo(0x001FFFFF)             	

                     PFX	%hi(0x0003FFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x0003FFFF)
                     PFX	%xhi(0x0003FFFF)
                     MOVHI	%r12,%xlo(0x0003FFFF)

                     PFX	%hi(0xFFFC0000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFC0000)
                     PFX	%xhi(0xFFFC0000)
                     MOVHI	%r13,%xlo(0xFFFC0000)             	
	
                     loopCMIT4:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT4
                     NOP 	
                 ");

            break;
        }

        case 5 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFC000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFC000)
                     PFX	%xhi(0xFFFFC000)
                     MOVHI	%r10,%xlo(0xFFFFC000)

                     PFX	%hi(0x000003FF)                   ; Set MASK
                     MOVI	%r11,%lo(0x000003FF)
                     PFX	%xhi(0x000003FF)
                     MOVHI	%r11,%xlo(0x000003FF)

                     PFX	%hi(0x000001FF)                   ; Set MASK
                     MOVI	%r12,%lo(0x000001FF)
                     PFX	%xhi(0x000001FF)
                     MOVHI	%r12,%xlo(0x000001FF)

                     PFX	%hi(0xFFFFFE00)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFE00)
                     PFX	%xhi(0xFFFFFE00)
                     MOVHI	%r13,%xlo(0xFFFFFE00)                                  	

                     loopCMIT5:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT5
                     NOP 	
                 ");
            break;
        }
    }
   // UpdateMenuTextPlane = true;
}

void Display::DrawMenuItemButton(int ItemNr, unsigned char active, unsigned char pushed)
{
	int ispacer = 0;
	
	//if ((Active_Menu == 15) && (ItemNr == 1)) return; // for pulse width
	
	// Get Menuitem Pos
	switch(ItemNr)
	{
		case 0:
		{
			ispacer = 8;
			break;
		}
		case 1:
		{
			ispacer = 113;
			break;
		}
		case 2:
		{
			ispacer = 218;
			break;
		}
		case 3:
		{
			ispacer = 323;
			break;
		}
		case 4:
		{
			ispacer = 428;
			break;
		}
		case 5:
		{
			ispacer = 533;
			break;
		}
	}									
			
	// Draw Button Frame
	DRAWROUNDBUTTON(ispacer - 3, 432, 106, 46, pushed, btnDraw);	
}

void Display::DrawMenuItem(int MenuNr,int ItemNr, unsigned char active, unsigned char pushed)
{
	int ispacer = 0;
	int xe, textcorr = 0;
	char BufferText[17];	
	char BufferText2[17];	
	
	//if ((MenuNr == 15) && (ItemNr == 1)) return; // For Pulse Width button 1 remove
	
	// Get Menuitem Pos
	switch(ItemNr)
	{
		case 0:
		{
			ispacer = 8;
			break;
		}
		case 1:
		{
			ispacer = 113;
			break;
		}
		case 2:
		{
			ispacer = 218;
			break;
		}
		case 3:
		{
			ispacer = 323;
			break;
		}
		case 4:
		{
			ispacer = 428;
			break;
		}
		case 5:
		{
			ispacer = 533;
			break;
		}
	}									
	
	
	
	// Get the Items Caption Text	
	for (xe = 0; xe < 16; xe++)
	{
        if ((MenuNr == 15) && (ItemNr == 3) && (MenuStatus[15][2] == 3)) BufferText[xe] = MenuItem[MenuNr][ItemNr + 1][xe]; //change items
		else if ((MenuNr == 15) && (ItemNr == 4) && (MenuStatus[15][2] == 3)) BufferText[xe] = MenuItem[MenuNr][ItemNr + 1][xe]; // delta t
		//else if ((MenuNr == 15) && (ItemNr == 1)) BufferText[xe] = MenuItem151[xe]; // delta t		
		else BufferText[xe] = MenuItem[MenuNr][ItemNr][xe];
	}
	
	if ((MenuStatus[MenuNr][ItemNr] > 243) && (MenuStatus[MenuNr][ItemNr] < 247))
	{
        // Draw Items Caption Text
        TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5);	// Draw Menu Text		
        TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane);	// Draw Menu Text	
	}
	else
	{	
	
	    //if ((MenuNr == 15) && (ItemNr == 1)) TEXTOUTxvbig(BufferText, ispacer + 22, 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
	    //else
        if ((MenuNr == 15) && ((ItemNr == 3) || (ItemNr == 4)))
        {
            if (ItemNr == 3)
            {
                if (MenuStatus[15][2] == 1)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
                else if (MenuStatus[15][2] == 2)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
            }

            if (ItemNr == 4)
            {
                if (MenuStatus[15][2] == 2)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
                else if (MenuStatus[15][2] == 1)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
            }
        }
        else
        {	
            if (active)
            {
                // Draw Items Caption Text	
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane);	// Draw Menu Text					
            }
            else
            {
                // Draw Items Caption Text
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5);	// Draw Menu Text		
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane);	// Draw Menu Text
            }
        }
    }
	
	switch(MenuNr)
	{
		// Acquire
		case 0:
		{
			if (ItemNr == 2) DrawMenuArrowCycle(ispacer + 6, active);	
			break;
		}
		
		// Channels Probe
		case 1:
		case 2:
		case 3:
		case 4:						
		{
			if (ItemNr == 3) DrawMenuArrowCycle(ispacer + 6, active);	
			break;
		}	
		
		// Display
		case 5:
		{
			if (ItemNr == 2) DrawMenuArrowCycle(ispacer + 6, active);	
			break;
		}	
		
		// Save / Recall
		case 8:
		{
			if (ItemNr == 0)
            {
                DrawMenuArrowCycle(ispacer + 6, active);
                sprintf(BufferText, "%d", SavePointer);		
                TEXTOUTxvbig(BufferText, ispacer + 46, 455, 1, Buffer_UI2Plane);					// Draw memory Text
			}
            	
			break;
		}		

		// Trigger Mode
		case 12:
		{
			if (ItemNr == 3)
			{
				if (EdgeToggle == 0) DrawMenuArrowCycle(ispacer + 6, active);
				else DrawMenuArrowCycle(ispacer + 6, 0);
				
                if (HoldOff_Value) TEXTOUTxvbig(HoldOff.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
				else TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
				
				// grayed "off"
				//TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 0, Buffer_UI2Plane);
				//TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 1, UI_Plane5);
			}
			if (ItemNr == 4)
			{
				if (EdgeToggle == 1) DrawMenuArrowCycle(ispacer + 6, active);
				else DrawMenuArrowCycle(ispacer + 6, 0);
			}			
			break;
		}
		
		// Trigger Edge PreTrigger
		case 14:
		{
			if (ItemNr == 4)
            {
                DrawMenuArrowCycle(ispacer + 6, active);	
                TEXTOUTxvbig(Trigger_Offset_Str.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
            }
			break;
		}
        			
		// Pulse Width
		case 15:
		{		
			if (ItemNr == 3)
			{
                if (MenuStatus[15][2] == 1) DrawMenuArrowCycle(ispacer + 6, 0);
                else if (MenuStatus[15][2] == 2) DrawMenuArrowCycle(ispacer + 6, active);
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1)) DrawMenuArrowCycle(ispacer + 6, active);			
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2)) DrawMenuArrowCycle(ispacer + 6, 0);
            }

			if (ItemNr == 4)
			{
                if (MenuStatus[15][2] == 2)
                DrawMenuArrowCycle(ispacer + 6, 0);
                else if (MenuStatus[15][2] == 1) DrawMenuArrowCycle(ispacer + 6, active);
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2)) DrawMenuArrowCycle(ispacer + 6, active);			
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1)) DrawMenuArrowCycle(ispacer + 6, 0);
            }            			

			if (MenuStatus[15][2] != 3)
			{
				if (ItemNr == 3)
				{
                    if (MenuStatus[15][2] == 1)
                    {
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
                    }
                    else if (MenuStatus[15][2] == 2)
                    {
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                    }
                    else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                    {
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
                    }
                    else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                    {
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                        TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
                    }
                }

				if (ItemNr == 4)
				{
                    if (MenuStatus[15][2] == 2)
                    {
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
                    }
                    else if (MenuStatus[15][2] == 1)
                    {
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                    }
                    else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                    {
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
                    }
                    else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                    {
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                        TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
                    }
                }

			}
			else
			{
				if (ItemNr == 3)
				{
					TEXTOUTxvbig(Pulse11.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
				}
				if (ItemNr == 4)
				{
					TEXTOUTxvbig(Pulse12.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
				}
			}
			break;
		}	

		// Cursor X Menu
		case 16:
		{
			switch(ItemNr)
			{
				case 1:
				{
					if (Cursor_Vertical_Active == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (Display_Mode == 1)
					{
                        if (active)	
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        }
                        else
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
                        }					
                    }
					else
					{
                        if (active)	
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        }
                        else
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
                        }
					}
					break;
				}
				
				case 2:
				{
					if (Cursor_Vertical_Active == 2) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (Display_Mode == 1)
					{
                        if (active)	
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        }
                        else
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
                        }					
                    }
					else
					{
                        if (active)	
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        }
                        else
                        {
                            TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
                        }
					}
					break;
				}

				case 3:
				{
					if (Cursor_Horizontal_Active == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
						TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
						TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
						TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
					}
					break;
				}
						
				case 4:
				{
					if (Cursor_Horizontal_Active == 2) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
						TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
						TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
						TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text
					}
					break;
				}
				
				case 5:
				{
					if (Cursor_Vertical_Active == 4)
                    {
                        DrawMenuArrowCycle(ispacer + 6, active);
                        DrawMenuArrowCycle2(ispacer + 6, 0);
                    }
					else if (Cursor_Horizontal_Active == 4)
                    {
                        DrawMenuArrowCycle(ispacer + 6, 0);
                        DrawMenuArrowCycle2(ispacer + 6, active);
                    }
					else
                    {
                        DrawMenuArrowCycle(ispacer + 6, 0);
                        DrawMenuArrowCycle2(ispacer + 6, 0);
                    }					
				}				
			}
			break;
		}

		// Quick Measure
		case 19:
		{
			if (ItemNr == 1 ) DrawMenuBiggerArrowCycle(ispacer + 6, active);	
			break;
		}
			
		// Quick Measurment Threshold
		case 22:
		{
			if (ItemNr == 2)
            {
                if (Quick_Measure_Threshold_btn_select == 1) DrawMenuArrowCycle(ispacer + 6, active);	
                else DrawMenuArrowCycle(ispacer + 6, 0);	

                TEXTOUTxvbig(QM_Threshold_lower.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
            }
			if (ItemNr == 3)
            {
                if (Quick_Measure_Threshold_btn_select == 2) DrawMenuArrowCycle(ispacer + 6, active);	
                else DrawMenuArrowCycle(ispacer + 6, 0);	

                TEXTOUTxvbig(QM_Threshold_middle.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
            }
			if (ItemNr == 4)
            {
                if (Quick_Measure_Threshold_btn_select == 3) DrawMenuArrowCycle(ispacer + 6, active);	
                else DrawMenuArrowCycle(ispacer + 6, 0);	

                TEXTOUTxvbig(QM_Threshold_upper.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
            }
			break;
		}
		            /*
		// FFT Settings		
		case 27:						
		{
			if (ItemNr == 1)
            {
                if (FFTToggle == 0) DrawMenuArrowCycle(ispacer + 6, active);	
                else DrawMenuArrowCycle(ispacer + 6, 0);	
                
                TEXTOUTxvbig(FFT_Scale_Str.Read_Text(), ispacer + 8, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
            }
			if (ItemNr == 2)
            {
                if (FFTToggle == 1) DrawMenuArrowCycle(ispacer + 6, active);	
                else DrawMenuArrowCycle(ispacer + 6, 0);
                
                TEXTOUTxvbig(FFT_Offset_Str.Read_Text(), ispacer + 10, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text	
            }
			break;
		}		   */

		// Math Channel Settings
		case 29:
		{
			switch(ItemNr)
			{
				case 0:
				{
					if (MathToggle == 0) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + MenuDataDef[math_mul_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + MenuDataDef[math_sub_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(MenuData[math_add_scale], ispacer + MenuDataDef[math_add_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
                        if (MenuStatus[26][2] == 1)	
                        {
                            TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][3] == 1)	
                        {
                            TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][4] == 1)	
                        {
                            TEXTOUTxvbig(MenuData[math_add_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(MenuData[math_add_scale], ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
					}

					break;
				}			
			
				case 1:
				{
					if (MathToggle == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
                        if (MenuStatus[26][2] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][3] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][4] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
					}

					break;
				}
				
				case 2:
				{
					if (1 == 0) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
                        if (MenuStatus[26][2] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][3] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][4] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
					}
					break;
				}
            }
            break;
        }        	
	}
	
	// Text Correction for Pulse Width Item 2
	if ((MenuNr == 15) && (ItemNr == 2))
	{
		if (MenuStatus[MenuNr][ItemNr] == 2) textcorr = -9;
		else if (MenuStatus[MenuNr][ItemNr] == 3) textcorr = 8;
	}	

	if (MenuStatus[MenuNr][ItemNr] < 240)
	{
		if (active)
		{
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 1, Buffer_UI2Plane);				// Draw Menu Data Text
		}
		else
		{
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 0, Buffer_UI2Plane);				// Draw Menu Data Text
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 1, UI_Plane5);				// Draw Menu Data Text			
		}		
	}
	else if ((MenuStatus[MenuNr][ItemNr] > 239) && (MenuStatus[MenuNr][ItemNr] < 242)) DrawMenuCheckBox(ispacer + 46, 457, MenuStatus[MenuNr][ItemNr] - 240, active);  	// Draw a Checkbox
	else if ((MenuStatus[MenuNr][ItemNr] > 241) && (MenuStatus[MenuNr][ItemNr] < 244)) DrawMenuArrow(ispacer + 31, MenuStatus[MenuNr][ItemNr] - 242, active);			// Draw a Arrow
	else if ((MenuStatus[MenuNr][ItemNr] > 243) && (MenuStatus[MenuNr][ItemNr] < 246)) DrawMenuArrow(ispacer + 31, MenuStatus[MenuNr][ItemNr] - 244, 0);			    // Draw a Arrow Grayed	
	else if (MenuStatus[MenuNr][ItemNr] == 247) DrawSubMenuArrow(ispacer + 31, active);																					// Draw a SubArrow	
#ifdef _Debug_	
	printf("MNr %d  INr %d : %d\n", MenuNr, ItemNr, MenuStatus[MenuNr][ItemNr]);
#endif	
	MenuItemChanged[ItemNr] = 0;
//	UpdateMenuTextPlane = true;
}

void Display::ClearMenuItem(int ItemNr)											// Clear a Menuitem            berarbeiten mit Assembler Funktion
{
	int xa, Ct;
	
	switch(ItemNr)
	{
		case 0:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{			
				*(UI_Plane1 + xa) = 0; *(UI_Plane1 + xa + 1) = 0; *(UI_Plane1 + xa + 2) = 0; *(UI_Plane1 + xa + 3) = *(UI_Plane1 + xa + 3) & 0x0007FFFF;			
				*(Buffer_UI2Plane + xa) = 0; *(Buffer_UI2Plane + xa + 1) = 0; *(Buffer_UI2Plane + xa + 2) = 0; *(Buffer_UI2Plane + xa + 3) = *(Buffer_UI2Plane + xa + 3) & 0x0007FFFF;
//				*(UI_Plane3 + xa) = 0; *(UI_Plane3 + xa + 1) = 0; *(UI_Plane3 + xa + 2) = 0; *(UI_Plane3 + xa + 3) = *(UI_Plane3 + xa + 3) & 0x0007FFFF;
				*(UI_Plane4 + xa) = 0; *(UI_Plane4 + xa + 1) = 0; *(UI_Plane4 + xa + 2) = 0; *(UI_Plane4 + xa + 3) = *(UI_Plane4 + xa + 3) & 0x0007FFFF;
				*(UI_Plane5 + xa) = 0; *(UI_Plane5 + xa + 1) = 0; *(UI_Plane5 + xa + 2) = 0; *(UI_Plane5 + xa + 3) = *(UI_Plane5 + xa + 3) & 0x0007FFFF;
				xa += 20;
			}
			break;
		}
		case 1:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 3) = *(UI_Plane1 + xa + 3) & 0xFFFF0000; *(UI_Plane1 + xa + 4) = 0; *(UI_Plane1 + xa + 5) = 0; *(UI_Plane1 + xa + 6) = *(UI_Plane1 + xa + 6) & 0x000003FF;								
				*(Buffer_UI2Plane + xa + 3) = *(Buffer_UI2Plane + xa + 3) & 0xFFFF0000; *(Buffer_UI2Plane + xa + 4) = 0; *(Buffer_UI2Plane + xa + 5) = 0; *(Buffer_UI2Plane + xa + 6) = *(Buffer_UI2Plane + xa + 6) & 0x000003FF;
//				*(UI_Plane3 + xa + 3) = *(UI_Plane3 + xa + 3) & 0xFFFF0000; *(UI_Plane3 + xa + 4) = 0; *(UI_Plane3 + xa + 5) = 0; *(UI_Plane3 + xa + 6) = *(UI_Plane3 + xa + 6) & 0x000003FF;
				*(UI_Plane4 + xa + 3) = *(UI_Plane4 + xa + 3) & 0xFFFF0000; *(UI_Plane4 + xa + 4) = 0; *(UI_Plane4 + xa + 5) = 0; *(UI_Plane4 + xa + 6) = *(UI_Plane4 + xa + 6) & 0x000003FF;
				*(UI_Plane5 + xa + 3) = *(UI_Plane5 + xa + 3) & 0xFFFF0000; *(UI_Plane5 + xa + 4) = 0; *(UI_Plane5 + xa + 5) = 0; *(UI_Plane5 + xa + 6) = *(UI_Plane5 + xa + 6) & 0x000003FF;
				xa += 20;
			}
			break;
		}
		case 2:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 6) = *(UI_Plane1 + xa + 6) & 0xFFFFFF00; *(UI_Plane1 + xa + 7) = 0; *(UI_Plane1 + xa + 8) = 0; *(UI_Plane1 + xa + 9) = 0;	
				*(Buffer_UI2Plane + xa + 6) = *(Buffer_UI2Plane + xa + 6) & 0xFFFFFF00; *(Buffer_UI2Plane + xa + 7) = 0; *(Buffer_UI2Plane + xa + 8) = 0; *(Buffer_UI2Plane + xa + 9) = 0;	
//				*(UI_Plane3 + xa + 6) = *(UI_Plane3 + xa + 6) & 0xFFFFFF00; *(UI_Plane3 + xa + 7) = 0; *(UI_Plane3 + xa + 8) = 0; *(UI_Plane3 + xa + 9) = 0;
				*(UI_Plane4 + xa + 6) = *(UI_Plane4 + xa + 6) & 0xFFFFFF00; *(UI_Plane4 + xa + 7) = 0; *(UI_Plane4 + xa + 8) = 0; *(UI_Plane4 + xa + 9) = 0;
				*(UI_Plane5 + xa + 6) = *(UI_Plane5 + xa + 6) & 0xFFFFFF00; *(UI_Plane5 + xa + 7) = 0; *(UI_Plane5 + xa + 8) = 0; *(UI_Plane5 + xa + 9) = 0;
				xa += 20;
			}
			break;
		}
		case 3:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 10) = 0; *(UI_Plane1 + xa + 11) = 0; *(UI_Plane1 + xa + 12) = 0; *(UI_Plane1 + xa + 13) = *(UI_Plane1 + xa + 13) & 0x00FFFFFF;
				*(Buffer_UI2Plane + xa + 10) = 0; *(Buffer_UI2Plane + xa + 11) = 0; *(Buffer_UI2Plane + xa + 12) = 0; *(Buffer_UI2Plane + xa + 13) = *(Buffer_UI2Plane + xa + 13) & 0x00FFFFFF;				
//				*(UI_Plane3 + xa + 10) = 0; *(UI_Plane3 + xa + 11) = 0; *(UI_Plane3 + xa + 12) = 0; *(UI_Plane3 + xa + 13) = *(UI_Plane3 + xa + 13) & 0x00FFFFFF;
				*(UI_Plane4 + xa + 10) = 0; *(UI_Plane4 + xa + 11) = 0; *(UI_Plane4 + xa + 12) = 0; *(UI_Plane4 + xa + 13) = *(UI_Plane4 + xa + 13) & 0x00FFFFFF;
				*(UI_Plane5 + xa + 10) = 0; *(UI_Plane5 + xa + 11) = 0; *(UI_Plane5 + xa + 12) = 0; *(UI_Plane5 + xa + 13) = *(UI_Plane5 + xa + 13) & 0x00FFFFFF;
				xa += 20;
			}
			break;
		}
		case 4:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 13) = *(UI_Plane1 + xa + 13) & 0xFF000000; *(UI_Plane1 + xa + 14) = 0; *(UI_Plane1 + xa + 15) = 0; *(UI_Plane1 + xa + 16) =  *(UI_Plane1 + xa + 16) & 0x00007FFF;
				*(Buffer_UI2Plane + xa + 13) = *(Buffer_UI2Plane + xa + 13) & 0xFF000000; *(Buffer_UI2Plane + xa + 14) = 0; *(Buffer_UI2Plane + xa + 15) = 0; *(Buffer_UI2Plane + xa + 16) =  *(Buffer_UI2Plane + xa + 16) & 0x00007FFF;				
//				*(UI_Plane3 + xa + 13) = *(UI_Plane3 + xa + 13) & 0xFF000000; *(UI_Plane3 + xa + 14) = 0; *(UI_Plane3 + xa + 15) = 0; *(UI_Plane3 + xa + 16) =  *(UI_Plane3 + xa + 16) & 0x00007FFF;
				*(UI_Plane4 + xa + 13) = *(UI_Plane4 + xa + 13) & 0xFF000000; *(UI_Plane4 + xa + 14) = 0; *(UI_Plane4 + xa + 15) = 0; *(UI_Plane4 + xa + 16) =  *(UI_Plane4 + xa + 16) & 0x00007FFF;
				*(UI_Plane5 + xa + 13) = *(UI_Plane5 + xa + 13) & 0xFF000000; *(UI_Plane5 + xa + 14) = 0; *(UI_Plane5 + xa + 15) = 0; *(UI_Plane5 + xa + 16) =  *(UI_Plane5 + xa + 16) & 0x00007FFF;
				xa += 20;
			}
			break;
		}
		case 5:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 16) = *(UI_Plane1 + xa + 16) & 0xFFFFC000; *(UI_Plane1 + xa + 17) = 0; *(UI_Plane1 + xa + 18) = 0; *(UI_Plane1 + xa + 19) = 0;
				*(Buffer_UI2Plane + xa + 16) = *(Buffer_UI2Plane + xa + 16) & 0xFFFFC000; *(Buffer_UI2Plane + xa + 17) = 0; *(Buffer_UI2Plane + xa + 18) = 0; *(Buffer_UI2Plane + xa + 19) = 0;
//				*(UI_Plane3 + xa + 16) = *(UI_Plane3 + xa + 16) & 0xFFFFC000; *(UI_Plane3 + xa + 17) = 0; *(UI_Plane3 + xa + 18) = 0; *(UI_Plane3 + xa + 19) = 0;
				*(UI_Plane4 + xa + 16) = *(UI_Plane4 + xa + 16) & 0xFFFFC000; *(UI_Plane4 + xa + 17) = 0; *(UI_Plane4 + xa + 18) = 0; *(UI_Plane4 + xa + 19) = 0;
				*(UI_Plane5 + xa + 16) = *(UI_Plane5 + xa + 16) & 0xFFFFC000; *(UI_Plane5 + xa + 17) = 0; *(UI_Plane5 + xa + 18) = 0; *(UI_Plane5 + xa + 19) = 0;
				xa += 20;
			}
			break;
		}
	}	
 //   UpdateMenuTextPlane = true;								
}

void Display::DRAWMENUPOPUP(int PopupNr)
{
	int x, xe, y;
	int pos = 0;

	int posx = 0;
	int sizex = 0;
	int posy = 0;
	int sizey = 0;
	int count = 0;	
	int button = 0;
	
	char BufferText[22];
	char BufferText2[22];	
		
	button = MenuPopupDef[PopupNr][0];
	count = MenuPopupDef[PopupNr][1];
	
	posx = (button * 100) + 15;
	sizey = (count * 17) + 37;
	posy = 420 - sizey;

	if ((PopupNr == 4) || (PopupNr == 22)) sizex = 150;
	else sizex = 120;

	MenuPopupX = posx - 2;
	MenuPopupY = posy;
	MenuPopupSizeX = sizex + 4;
	MenuPopupSizeY = sizey + 15;

	// Clear


	if (MenuPopupActive != PopupNr)
	{
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane1); //sizey = 5	
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane2);
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane5);		
	
		DRAWROUNDBUTTON(posx - 3, posy, sizex + 6, sizey + 3, btnUnpushed, btnDraw);
		DRAWMENUBUTTONSELECT(button);		

		//Draw Popup Caption
		sprintf(BufferText, "");
		for (xe = 0; xe < 20; xe++)
		{
			BufferText[xe] = MenuPopupText[PopupNr][0][xe];
		}
		TEXTOUTxvbig(BufferText, posx + 5, posy + 5, 1, UI_Plane2);								// Draw Menu Text
		
		// Div Line
		DRAWP(posx + 2, posy + 20, sizex - 4, 1, 1, UI_Plane5);
		DRAWP(posx + 2, posy + 21, sizex - 4, 1, 1, UI_Plane1);	
		
		for (x = 0;x < count;x++)
		{
			sprintf(BufferText, "");
			for (xe = 0; xe < 20; xe++)
			{
				BufferText[xe] = MenuPopupText[PopupNr][x + 1][xe];
			}
		
			if (MenuPopupStatus[PopupNr][x] == 1)
			{
	//			TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 0, UI_Plane2);			// Draw Popup Item Text
				TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 1, UI_Plane5);			// Draw Popup Item Text						
			}
			else if (MenuPopupStatus[PopupNr][x] == 2)
			{
				TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 1, UI_Plane2);	// Draw Popup Item Text
			}
			else if (MenuPopupStatus[PopupNr][x] == 3)
			{
				sprintf(BufferText2, "%c  %s", Menu_Select, BufferText);
				TEXTOUTxvbig(BufferText2, posx + 5, posy + 28 + (x * 17), 1, UI_Plane2);								// Draw Popup Item Text		
			}			
		}
	}
	else
	{
		DRAWP(posx + 4, posy + 27, 15, sizey - 35, 0, UI_Plane2);
		
		for (x = 0;x < count;x++)
		{		
			if (MenuPopupStatus[PopupNr][x] == 3)
			{
				sprintf(BufferText2, "%c", Menu_Select);
				TEXTOUTxvbig(BufferText2, posx + 5, posy + 28 + (x * 17), 1, UI_Plane2);								// Draw Popup Item Text		
			}
		}
	}		
		
	MenuPopupChanged = 1;
	MenuPopupActive = PopupNr;	
	
//	MenuTimeCounter = 0;
	//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
}

void Display::DRAWMENUPOPDOWN(void)
{
	int x, y;
	int posy = 0;
	int sizey = 0;
	int count = 0;	
	int xa, xo, Ct;	

	// Clean Up the Popup
	xa = MenuPopupY * 20;
	xo = MenuPopupX / 32;

	for (Ct = 0; Ct < MenuPopupSizeY - 5; Ct++)
	{			
		*(UI_Plane1 + xo + xa) = 0; *(UI_Plane1 + xo + xa + 1) = 0; *(UI_Plane1 + xo + xa + 2) = 0; *(UI_Plane1 + xo + xa + 3) = 0; *(UI_Plane1 + xo + xa + 4) = 0; *(UI_Plane1 + xo + xa + 5) = 0;
		*(Buffer_UI2Plane + xo + xa) = 0; *(Buffer_UI2Plane + xo + xa + 1) = 0; *(Buffer_UI2Plane + xo + xa + 2) = 0; *(Buffer_UI2Plane + xo + xa + 3) = 0; *(Buffer_UI2Plane + xo + xa + 4) = 0; *(Buffer_UI2Plane + xo + xa + 5) = 0;
		*(UI_Plane2 + xo + xa) = 0; *(UI_Plane2 + xo + xa + 1) = 0; *(UI_Plane2 + xo + xa + 2) = 0; *(UI_Plane2 + xo + xa + 3) = 0; *(UI_Plane2 + xo + xa + 4) = 0; *(UI_Plane2 + xo + xa + 5) = 0;
		*(UI_Plane3 + xo + xa) = 0; *(UI_Plane3 + xo + xa + 1) = 0; *(UI_Plane3 + xo + xa + 2) = 0; *(UI_Plane3 + xo + xa + 3) = 0; *(UI_Plane3 + xo + xa + 4) = 0; *(UI_Plane3 + xo + xa + 5) = 0;
		*(UI_Plane4 + xo + xa) = 0; *(UI_Plane4 + xo + xa + 1) = 0; *(UI_Plane4 + xo + xa + 2) = 0; *(UI_Plane4 + xo + xa + 3) = 0; *(UI_Plane4 + xo + xa + 4) = 0; *(UI_Plane4 + xo + xa + 5) = 0;
		*(UI_Plane5 + xo + xa) = 0; *(UI_Plane5 + xo + xa + 1) = 0; *(UI_Plane5 + xo + xa + 2) = 0; *(UI_Plane5 + xo + xa + 3) = 0; *(UI_Plane5 + xo + xa + 4) = 0; *(UI_Plane5 + xo + xa + 5) = 0;
		xa += 20;
	}	
	
	// Repaire Menu Down
	xa = 407 * 20;	
	for (Ct = 0; Ct < 23; Ct++)
	{			
		*(UI_Plane3 + xo + xa) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 1) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 2) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 3) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 4) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 5) = 0xFFFFFFFF;
		xa += 20;
	}	

	if (MenuPopupActive == 4)
    {
        // Repaire Menu Up
        xa = 9 * 20;
        for (Ct = 0; Ct < 9; Ct++)
        {			
            *(UI_Plane3 + xo + xa) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 1) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 2) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 3) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 4) = 0xFFFFFFFF; *(UI_Plane3 + xo + xa + 5) = 0xFFFFFFFF;
            xa += 20;
        }

 /* TMW        if (MenuStatus[5][4] == 241)
        {
            Display::DRAWMEMORY(0, 1, 1);
        } TMW*/

//        Channel_2_Active = 1;
        VoltageChangedCh1 = 1;
        VoltageChangedCh2 = 1;

        Channel_1_Active_Old = 0;
        Channel_2_Active_Old = 0;

        if (NumberOfChannels > 2)
        {
//            Channel_3_Active = 1;
            VoltageChangedCh3 = 1;

//            Channel_4_Active = 1;
            VoltageChangedCh4 = 1;

            Channel_3_Active_Old = 0;
            Channel_4_Active_Old = 0;
        }

        StatusUpdate();
    }
	
	MenuPopupActive = -1;
	MenuPopupChanged = 0;
	New_Menu = Active_Menu;
    Menu_Changed = 1;

	// Repaire Menu	
	if (Cursor_Enabled)
    {
        CursorChanged = 3;
        Cursor_Data_First_Draw = true;
        DRAWCURSORDATA(0);
    }
	if (QM_Enabled)
    {
        Quick_Measure_First_Draw = true;
        DRAWQMDATA(0);
    }
	
  
//    Hardware::TransferDataPlane_asm_persistant(0x008DBB24, 0x00970F30);
//    UpdateMenuTextPlane = true;
}

void Display::DRAWMENUBUTTONSELECT(int buttonnr)
{
	int x, y, c, posx = 0;
	posx = 40 + (buttonnr * 100);
	
	c = 21;	
	for (y = 0; y < 10; y++)
	{
		for (x = 0; x < c; x++)
		{
			if (x == 0) PIXELP(posx + y + x, 420 + y, 1, UI_Plane5);				//clBlack
			else if (x == (c - 1)) PIXELP(posx + y + x, 420 + y, 1, UI_Plane5);
			else PIXELP(posx + y + x, 420 + y, 1, UI_Plane4);		
			PIXELP(posx + y + x, 420 + y, 0, UI_Plane2);
		}
		c--;
		c--;
	}	
 }

void Display::DRAWROUNDBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove)
{
	char set;
	unsigned long *iplane;	
	int x, y, c;
		
	if (remove) set = 0;
	else set = 1;		
		
	// Up
	// Left Edge
	c = 8;
	for (y = 1; y < 7; y++)
	{
		if (y < 6) c--;	
		for (x = c; x < 9; x++)
		{
			if ((y == 1) && (pushed == 0)) iplane = UI_Plane1;
			else if ((y == 1) && (pushed == 1)) iplane = UI_Plane5;
			else if ((x == c) && (pushed == 0)) iplane = UI_Plane1;
			else if ((x == c) && (pushed == 1)) iplane = UI_Plane5;
			else iplane = UI_Plane4;
			
			PIXELP(posx + x, posy + y, set, iplane);
		}
	}
	
	if (pushed) iplane = UI_Plane5;
	else iplane = UI_Plane1;	

	// Upper Middle
	DRAWP(posx + 9, posy, sizex - 18, 1, set, iplane);		// TopLine

	// Middle Block
	DRAWP(posx + 9, posy + 1, sizex - 18, 6, set, UI_Plane4);

	// Right Edge
	c = 1;
	for (y = 1; y < 7; y++)
	{
		if (y < 6) c++;	
		for (x = 0; x < c; x++)
		{
			if ((y == 1) && (pushed == 0)) iplane = UI_Plane1;
			else if ((y == 1) && (pushed == 1)) iplane = UI_Plane5;
			else if ((x == (c - 1)) && (pushed == 0)) iplane = UI_Plane1;
			else if ((x == (c - 1)) && (pushed == 1)) iplane = UI_Plane5;
			else iplane = UI_Plane4;
			
			PIXELP(posx + (sizex - 9) + x, posy + y, set, iplane);
		}
	}		

	// Middle Block
	DRAWP(posx + 3, posy + 7, sizex - 6, sizey - 16, set, UI_Plane4);

	// Sidelines
	if (pushed)
	{
		DRAWP(posx + 2, posy + 7, 1, sizey - 16, set, UI_Plane5);
		DRAWP(posx + sizex - 3, posy + 7, 1, sizey - 16, set, UI_Plane1);
	}
	else
	{
		DRAWP(posx + 2, posy + 7, 1, sizey - 16, set, UI_Plane1);
		DRAWP(posx + sizex - 3, posy + 7, 1, sizey - 16, set, UI_Plane5);
	}

	// Down
	// Left Edge
	c = 3;
	for (y = 0; y < 6; y++)
	{
		if (y > 1) c++;	
		for (x = c; x < 9; x++)
		{		
			if ((y == 5) && (pushed == 0)) iplane = UI_Plane5;
			else if ((y == 5) && (pushed == 1)) iplane = UI_Plane1;
			else if ((x == c) && (pushed == 0)) iplane = UI_Plane5;
			else if ((x == c) && (pushed == 1)) iplane = UI_Plane1;
			else iplane = UI_Plane4;			
			
			PIXELP(posx + x, posy + (sizey - 9) + y, set, iplane);
		}
	}

	if (pushed) iplane = UI_Plane1;
	else iplane = UI_Plane5;
	
	// Lower Middle
	DRAWP(posx + 9, posy + (sizey - 9) + 6, sizex - 18, 1, set, iplane);	// BottomLine

	// Middle Block
	DRAWP(posx + 9, posy + (sizey - 9), sizex - 18, 6, set, UI_Plane4);

	// Right Edge
	c = 6;
	for (y = 0; y < 6; y++)
	{
		if (y > 1) c--;	
		for (x = 0; x < c; x++)
		{		
			if ((y == 5) && (pushed == 0)) iplane = UI_Plane5;
			else if ((y == 5) && (pushed == 1)) iplane = UI_Plane1;
			else if ((x == (c - 1)) && (pushed == 0)) iplane = UI_Plane5;
			else if ((x == (c - 1)) && (pushed == 1)) iplane = UI_Plane1;
			else iplane = UI_Plane4;						
			
			PIXELP(posx + (sizex - 9) + x, posy + (sizey - 9) + y, set, iplane);
		}
	}
}

void Display::DRAWSQUAREBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove)
{
	char set;
	unsigned long *iplane;			
		
	if (remove) set = 0;
	else set = 1;
	
	// Left Edge	
	if (pushed) iplane = UI_Plane5;
	else iplane = UI_Plane1;
	
	PIXELP(posx + 1, posy + 2, set, iplane);
	PIXELP(posx + 2, posy + 1, set, iplane);
	
	PIXELP(posx + 2, posy + 2, !set, UI_Plane3);	
	
	// Upper Middle
	DRAWP(posx + 3, posy, sizex - 6, 1, set, iplane);					// TopLine

	// Middle Block
	DRAWP(posx + 3, posy + 1, sizex - 6, 2, !set, UI_Plane3);				// Middle Block	
	
	// Right Edge		
	PIXELP(posx + (sizex - 3), posy + 1, set, iplane);
	PIXELP(posx + (sizex - 3) + 1, posy + 2, set, iplane);
	PIXELP(posx + (sizex - 3), posy + 2, !set, UI_Plane3);
	
	// Middle Block
	DRAWP(posx + 1, posy + 3, sizex - 2, sizey - 6, !set, UI_Plane3); //1
	
	// Sidelines
	if (pushed)
	{
		DRAWP(posx, posy + 3, 1, sizey - 6, set, UI_Plane5);
		DRAWP(posx + sizex - 1, posy + 3, 1, sizey - 6, set, UI_Plane1);
	}
	else
	{
		DRAWP(posx, posy + 3, 1, sizey - 6, set, UI_Plane1);
		DRAWP(posx + sizex - 1, posy + 3, 1, sizey - 6, set, UI_Plane5);
	}
		
	if (pushed) iplane = UI_Plane1;
	else iplane = UI_Plane5;
			
	// Down
	// Left Edge	
	PIXELP(posx + 1, posy + (sizey - 3), set, iplane);
	PIXELP(posx + 2, posy + (sizey - 3) + 1, set, iplane);
	PIXELP(posx + 2, posy + (sizey - 3), !set, UI_Plane3);

	// Lower Middle
	DRAWP(posx + 3, posy + (sizey - 1), sizex - 6, 1, set, iplane);	// Bottom Line

	DRAWP(posx + 3, posy + (sizey - 3), sizex - 6, 2, !set, UI_Plane3);		// Middle Block //1

	// Right Edge
	PIXELP(posx + (sizex - 3) + 1, posy + (sizey - 3), set, iplane);
	PIXELP(posx + (sizex - 3), posy + (sizey - 3) + 1, set, iplane);
	PIXELP(posx + (sizex - 3), posy + (sizey - 3), !set, UI_Plane3);
}

void Display::DrawMenuCheckBox(int posx, int posy, char checked, char active)				// Draw a Checkbox in menu
{
	if (checked)
	{	
		DRAWLINEP(posx, posy, posx + 10, posy, 1, UI_Plane5);
		DRAWLINEP(posx + 1, posy + 10, posx + 11, posy + 10, 1, UI_Plane1);
		DRAWLINEP(posx, posy + 1, posx, posy + 10, 1, UI_Plane5);				
		DRAWLINEP(posx + 10, posy, posx + 10, posy + 10, 1, UI_Plane1);
		
		if (active) DRAWP(posx + 2, posy + 2, 7, 7, 1, Buffer_UI2Plane);								// Checkbox Filling Black
		else
		{
			DRAWP(posx + 2, posy + 2, 7, 7, 1, UI_Plane5);										// Checkbox Filling Gray
		}
	}
	else
	{
		DRAWLINEP(posx, posy, posx + 10, posy, 1, UI_Plane1);	
		DRAWLINEP(posx + 1, posy + 10, posx + 11, posy + 10, 1, UI_Plane5);
		DRAWLINEP(posx, posy + 1, posx, posy + 10, 1, UI_Plane1);		
		DRAWLINEP(posx + 10, posy, posx + 10, posy + 10, 1, UI_Plane5);					
		
		DRAWP(posx + 2, posy + 2, 7, 7, 0, Buffer_UI2Plane);								// Checkbox Filling
		DRAWP(posx + 2, posy + 2, 7, 7, 0, UI_Plane5);								// Checkbox Filling

	}	
    UpdateMenuTextPlane = true;		
}

void Display::DrawMenuArrow(int posx, int updn, int active)								// Draw Sub-Menu Arrow
{	
	if (updn == 0)  // Down
	{
		BITBITMAP(bitbmBigArrowDown, posx, 455, active, Buffer_UI2Plane);
		BITBITMAP(bitbmBigArrowDown, posx, 455, !active, UI_Plane5);
	}
	else			// Up , it is always displayed without Text -> 10 Dots heigher
	{
		BITBITMAP(bitbmBigArrowUp, posx, 445, active, Buffer_UI2Plane);
		BITBITMAP(bitbmBigArrowUp, posx, 445, !active, UI_Plane5);
	}	
	UpdateMenuTextPlane = true;
}

void Display::DrawMenuArrowCycle(int posx, int active)						// Draw the knob turn cycle
{
	if (active)
	{
		BITBITMAP(bitbmCycleArrow, posx, 438, 1, Channel_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 438, 1, Buffer_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 438, 0, UI_Plane3);
		BITBITMAP(bitbmCycleArrow, posx, 438, 0, UI_Plane4);		
	}
	else BITBITMAP(bitbmCycleArrow, posx, 438, 1, UI_Plane5);
}

void Display::DrawMenuArrowCycle2(int posx, int active)						// Draw the knob turn cycle
{
	if (active)
	{
		BITBITMAP(bitbmCycleArrow, posx, 455, 1, Channel_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 455, 1, Buffer_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 455, 0, UI_Plane3);
		BITBITMAP(bitbmCycleArrow, posx, 455, 0, UI_Plane4);		
	}
	else BITBITMAP(bitbmCycleArrow, posx, 455, 1, UI_Plane5);
}

void Display::DrawMenuBiggerArrowCycle(int posx, int active)						// Draw the knob turn cycle with popup arrow
{
	if (active)
	{
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, Channel_Plane4);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, Buffer_Plane4);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 0, UI_Plane3);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 0, UI_Plane4);
	}
	else BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, UI_Plane5);
}

void Display::DrawSubMenuArrow(int posx, int active)						// Draw the sub menu arrow
{
	if (active)  BITBITMAP(bitbmSubMenu, posx, 458, 1, Buffer_UI2Plane);
	else BITBITMAP(bitbmSubMenu, posx, 458, 1, UI_Plane5);
	UpdateMenuTextPlane = true;
}

void Display::DRAW_ALL_CURSOR(void)												// Draw the Cursors
{
	int c;
    int BufVal1 = 0;
    int BufVal2 = 0;
    int BufVal3 = 0;
    int BufVal4 = 0;
    int BufVal5 = 0;
    int BufVal6 = 0;
	int vert_cursor_max = 385;
	
	int horz_cursor_start = 0;
	int horz_cursor_stop = 600;
	
    long Cursor_Vertical_Position1 = 0;								// Store Cursor vertical I position
    long Cursor_Vertical_Position2 = 0;								// Store Cursor vertical II position
	
    long Cursor_Horizontal_Position1 = 0;							// Store Cursor horizontal I position
    long Cursor_Horizontal_Position2 = 0;							// Store Cursor horizontal II position

    long QM_Vertical_Position1 = 0;
    long QM_Vertical_Position2 = 0;

    long QM_Horizontal_Position1 = 0;
    long QM_Horizontal_Position2 = 0;
    
    if (Splash_drawed) return;

    if (MenuStatus[10][1] == 1) vert_cursor_max = 190;

    // New Trigger Position
    BufVal1 = Trig_Pos_Display + DrawOffsetX;
    BufVal2 = Trig_Pos_Display_dmode + DrawOffsetX;

    if (BufVal2 > (599 + DrawOffsetX)) BufVal2 = 599 + DrawOffsetX;
    if (BufVal2 < (DrawOffsetX - 2)) BufVal2 = DrawOffsetX - 2;
    
    if (MenuStatus[10][1] == 0) BufVal2 = 0;
    
    //printf("BV1 : %5d BV2 : %5d\n", BufVal1, BufVal2);

    if (BufVal1 != Trig_Pos_Display_old)
    {
        // Remove Trigger Offset
        if (Trig_Pos_Display_old <= (DrawOffsetX - 2))
        {
            DRAWLINEP(Trig_Pos_Display_old + 0, 24, Trig_Pos_Display_old + 11, 24, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_old + 1, 23, Trig_Pos_Display_old + 1, 26, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old + 2, 22, Trig_Pos_Display_old + 2, 27, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old + 3, 21, Trig_Pos_Display_old + 3, 28, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old + 4, 20, Trig_Pos_Display_old + 4, 29, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old + 5, 19, Trig_Pos_Display_old + 5, 30, 0, Buffer_Mark1Plane);
        }
        else if (Trig_Pos_Display_old >= (599 + DrawOffsetX))
        {
            DRAWLINEP(Trig_Pos_Display_old - 10, 24, Trig_Pos_Display_old + 2, 24, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_old - 1, 23, Trig_Pos_Display_old - 1, 26, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 2, 22, Trig_Pos_Display_old - 2, 27, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 3, 21, Trig_Pos_Display_old - 3, 28, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 4, 20, Trig_Pos_Display_old - 4, 29, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 5, 19, Trig_Pos_Display_old - 5, 30, 0, Buffer_Mark1Plane);
        }
        else
        {
            DRAWLINEP(Trig_Pos_Display_old - 3, 19, Trig_Pos_Display_old + 4, 19, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 3, 20, Trig_Pos_Display_old + 4, 20, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 3, 21, Trig_Pos_Display_old + 4, 21, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 3, 22, Trig_Pos_Display_old + 4, 22, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_old - 3, 23, Trig_Pos_Display_old + 4, 23, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 2, 24, Trig_Pos_Display_old + 3, 24, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_old - 1, 25, Trig_Pos_Display_old + 2, 25, 0, Buffer_Mark1Plane);
            PIXELP(Trig_Pos_Display_old, 26, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_old - 3, 19, Trig_Pos_Display_old + 4, 19, 0, Marker_Plane1);
            DRAWLINEP(Trig_Pos_Display_old - 3, 20, Trig_Pos_Display_old + 4, 20, 0, Marker_Plane1);
            DRAWLINEP(Trig_Pos_Display_old - 3, 21, Trig_Pos_Display_old + 4, 21, 0, Marker_Plane1);
            DRAWLINEP(Trig_Pos_Display_old - 3, 22, Trig_Pos_Display_old + 4, 22, 0, Marker_Plane1);

            DRAWLINEP(Trig_Pos_Display_old - 3, 23, Trig_Pos_Display_old + 4, 23, 0, Marker_Plane1);
            DRAWLINEP(Trig_Pos_Display_old - 2, 24, Trig_Pos_Display_old + 3, 24, 0, Marker_Plane1);
            DRAWLINEP(Trig_Pos_Display_old - 1, 25, Trig_Pos_Display_old + 2, 25, 0, Marker_Plane1);
            PIXELP(Trig_Pos_Display_old, 26, 0, Marker_Plane1);

            DRAWLINEP(Trig_Pos_Display_old - 2, 20, Trig_Pos_Display_old + 3, 20, 0, UI_Plane2);
            DRAWLINEP(Trig_Pos_Display_old, 20, Trig_Pos_Display_old, 25, 0, UI_Plane2);
        }
    }
    
    if (BufVal2 != Trig_Pos_Display_dmode_old)
    {
        if (Trig_Pos_Display_dmode_old <= (DrawOffsetX - 2))
        {
            DRAWLINEP(Trig_Pos_Display_dmode_old + 0, 219, Trig_Pos_Display_dmode_old + 11, 219, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_dmode_old + 1, 218, Trig_Pos_Display_dmode_old + 1, 221, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old + 2, 217, Trig_Pos_Display_dmode_old + 2, 222, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old + 3, 216, Trig_Pos_Display_dmode_old + 3, 223, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old + 4, 215, Trig_Pos_Display_dmode_old + 4, 224, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old + 5, 214, Trig_Pos_Display_dmode_old + 5, 225, 0, Buffer_Mark1Plane);
        }
        else if (Trig_Pos_Display_dmode_old >= (599 + DrawOffsetX))
        {
            DRAWLINEP(Trig_Pos_Display_dmode_old - 10, 219, Trig_Pos_Display_dmode_old + 1, 219, 0, Buffer_Mark1Plane);

            DRAWLINEP(Trig_Pos_Display_dmode_old - 1, 218, Trig_Pos_Display_dmode_old - 1, 221, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 2, 217, Trig_Pos_Display_dmode_old - 2, 222, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 3, 216, Trig_Pos_Display_dmode_old - 3, 223, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 4, 215, Trig_Pos_Display_dmode_old - 4, 224, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 5, 214, Trig_Pos_Display_dmode_old - 5, 225, 0, Buffer_Mark1Plane);
        }
        else
        {
            // Remove Trigger sign in delayed window
            DRAWLINEP(Trig_Pos_Display_dmode_old - 5, 214, Trig_Pos_Display_dmode_old + 6, 214, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 4, 215, Trig_Pos_Display_dmode_old + 5, 215, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 3, 216, Trig_Pos_Display_dmode_old + 4, 216, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 2, 217, Trig_Pos_Display_dmode_old + 3, 217, 0, Buffer_Mark1Plane);
            DRAWLINEP(Trig_Pos_Display_dmode_old - 1, 218, Trig_Pos_Display_dmode_old + 2, 218, 0, Buffer_Mark1Plane);
            PIXELP(Trig_Pos_Display_dmode_old, 219, 0, Buffer_Mark1Plane);
        }
    }


    for (c = DrawOffsetY; c < (193 + DrawOffsetY); c++)
    {
        // Remove vertical Cursor first	
        *(Buffer_Mark1Plane + (Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;

        // Remove vertical quick measurement cursor
        *(Buffer_Mark1Plane + (QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;

        // Remove delayed cursor		
        *(Buffer_Mark1Plane + (Cursor_Delayed_1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (Cursor_Delayed_2_Old / 32) + (c * 20)) = 0;
    }		
       		
    for (c = (193 + DrawOffsetY); c < (386 + DrawOffsetY); c++)
    {	
        *(Buffer_Mark1Plane + (Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;

        *(Buffer_Mark1Plane + (QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;

        *(Buffer_Mark1Plane + (dmode_Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (dmode_Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;

        *(Buffer_Mark1Plane + (dmode_QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
        *(Buffer_Mark1Plane + (dmode_QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	}

    for (c = 0; c < 20; c++)
    {
        // Remove horizontal cursor first	
        *(Buffer_Mark1Plane + (Cursor_Horizontal_Position1_Old * 20) + c) = 0;
        *(Buffer_Mark1Plane + (Cursor_Horizontal_Position2_Old * 20) + c) = 0;	

        // Remove horizontal quick measurement cursor
        *(Buffer_Mark1Plane + (QM_Horizontal_Position1_Old * 20) + c) = 0;
        *(Buffer_Mark1Plane + (QM_Horizontal_Position2_Old * 20) + c) = 0;	

        // Remove horizontal cursor first	
        *(Buffer_Mark1Plane + ((Cursor_Horizontal_Position1_Old + 193) * 20) + c) = 0;
        *(Buffer_Mark1Plane + ((Cursor_Horizontal_Position2_Old + 193) * 20) + c) = 0;	

        // Remove horizontal quick measurement cursor
        *(Buffer_Mark1Plane + ((QM_Horizontal_Position1_Old + 193) * 20) + c) = 0;
        *(Buffer_Mark1Plane + ((QM_Horizontal_Position2_Old + 193) * 20) + c) = 0;
	}
	
	// Everything removed - start drawing

    // Draw Tigger sign in main window
    // Draw the filled Triangle for Offset Position
    if (Display_Mode == 0)
    {

		if (BufVal1 <= (DrawOffsetX - 2))
        {
            BufVal1 = DrawOffsetX - 2;

            DRAWLINEP(BufVal1 + 0, 24, BufVal1 + 11, 24, 1, Buffer_Mark1Plane);

            DRAWLINEP(BufVal1 + 1, 23, BufVal1 + 1, 26, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 + 2, 22, BufVal1 + 2, 27, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 + 3, 21, BufVal1 + 3, 28, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 + 4, 20, BufVal1 + 4, 29, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 + 5, 19, BufVal1 + 5, 30, 1, Buffer_Mark1Plane);

        }
        else if (BufVal1 >= (599 + DrawOffsetX))
        {
            BufVal1 = 599 + DrawOffsetX;

            DRAWLINEP(BufVal1 - 10, 24, BufVal1 + 1, 24, 1, Buffer_Mark1Plane);

            DRAWLINEP(BufVal1 - 1, 23, BufVal1 - 1, 26, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 2, 22, BufVal1 - 2, 27, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 3, 21, BufVal1 - 3, 28, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 4, 20, BufVal1 - 4, 29, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 5, 19, BufVal1 - 5, 30, 1, Buffer_Mark1Plane);

        }
        else
        {
            DRAWLINEP(BufVal1 - 3, 19, BufVal1 + 4, 19, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 3, 20, BufVal1 + 4, 20, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 3, 21, BufVal1 + 4, 21, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 3, 22, BufVal1 + 4, 22, 1, Buffer_Mark1Plane);

            DRAWLINEP(BufVal1 - 3, 23, BufVal1 + 4, 23, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 2, 24, BufVal1 + 3, 24, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal1 - 1, 25, BufVal1 + 2, 25, 1, Buffer_Mark1Plane);
            PIXELP(BufVal1, 26, 1, Buffer_Mark1Plane);

            DRAWLINEP(BufVal1 - 3, 19, BufVal1 + 4, 19, 1, Marker_Plane1);
            DRAWLINEP(BufVal1 - 3, 20, BufVal1 + 4, 20, 1, Marker_Plane1);
            DRAWLINEP(BufVal1 - 3, 21, BufVal1 + 4, 21, 1, Marker_Plane1);
            DRAWLINEP(BufVal1 - 3, 22, BufVal1 + 4, 22, 1, Marker_Plane1);

            DRAWLINEP(BufVal1 - 3, 23, BufVal1 + 4, 23, 1, Marker_Plane1);
            DRAWLINEP(BufVal1 - 2, 24, BufVal1 + 3, 24, 1, Marker_Plane1);
            DRAWLINEP(BufVal1 - 1, 25, BufVal1 + 2, 25, 1, Marker_Plane1);
            PIXELP(BufVal1, 26, 1, Marker_Plane1);

            DRAWLINEP(BufVal1 - 2, 20, BufVal1 + 3, 20, 1, UI_Plane2);
            DRAWLINEP(BufVal1, 20, BufVal1, 25, 1, UI_Plane2);
        }

        //Trigger_Offset_Pos_Old = BufVal1; // Save actual position	
        Trig_Pos_Display_old = BufVal1; // Save actual position	

#ifdef _Debug_
        if (Debug_Mode) printf("trof %d trofold %d bufval %d tof %d st %d sfi %d dmst %d dmsfi %d dwop %d df %f  cd1 %d cd2 %d  vc1 %d vc2 %d \n", Trigger_Offset_Pos, Trigger_Offset_Pos_Old, BufVal1, Timebase_Offset_Pos, Selected_Timebase, SIGNALFaktor_idx, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dmode_Window_Offset_Pos, dmode_factor, Cursor_Delayed_1, Cursor_Delayed_2, Cursor_Vertical_Position_Real1, Cursor_Vertical_Position_Real2);
#endif        		
        // Draw Trigger in delayed window
        if (MenuStatus[10][1] == 1)
        {

#ifdef _Debug_
            if (Debug_Mode) printf("TrOfPo %d bv : %d dWOP %d df %f cd1 %d SS %d\n", Trigger_Offset_Pos, BufVal1, dmode_Window_Offset_Pos, dmode_factor, Cursor_Delayed_1, SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float));
#endif

            DRAWLINEP(BufVal2 - 5, 214, BufVal2 + 6, 214, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal2 - 4, 215, BufVal2 + 5, 215, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal2 - 3, 216, BufVal2 + 4, 216, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal2 - 2, 217, BufVal2 + 3, 217, 1, Buffer_Mark1Plane);
            DRAWLINEP(BufVal2 - 1, 218, BufVal2 + 2, 218, 1, Buffer_Mark1Plane);
            PIXELP(BufVal2, 219, 1, Buffer_Mark1Plane);

            //dmode_Trigger_Offset_Pos_Old = BufVal2;
            Trig_Pos_Display_dmode_old = BufVal2;

            // draw delayed cursor
            BufVal1 = Cursor_Delayed_1 + DrawOffsetX;
            BufVal2 = Cursor_Delayed_2 + DrawOffsetX;

            if (BufVal1 > (600 + DrawOffsetX)) BufVal1 = 600 + DrawOffsetX;
            if (BufVal1 < DrawOffsetX) BufVal1 = DrawOffsetX;
            if (BufVal2 > (600 + DrawOffsetX)) BufVal2 = 600 + DrawOffsetX;
            if (BufVal2 < DrawOffsetX) BufVal2 = DrawOffsetX;

            for (c = 0; c < 193; c++)
            {			
                if (c % 2 == 0) PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                if ((c + 1) % 2 == 0) PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
            }

            Cursor_Delayed_1_Old = BufVal1;
            Cursor_Delayed_2_Old = BufVal2;
        }
    }

    // Draw Cursor
    if (Cursor_Enabled)
    {    	
//        Cursor_Vertical_Position1 = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);	
//        Cursor_Vertical_Position2 = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);	

        if (Display_Mode == 1)
        {
            Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real_XY_1;
            Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real_XY_2;
        }
        else
        {
            Cursor_Vertical_Position1 = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);
            Cursor_Vertical_Position2 = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);
       }
//        Cursor_Vertical_Position1 = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))));	
//        Cursor_Vertical_Position2 = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))));	

/*
        if (Cursor_Vertical_Position_Real1 > 600) Cursor_Vertical_Position1 = 600;
        else Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real1;

        if (Cursor_Vertical_Position_Real2 > 600) Cursor_Vertical_Position2 = 600;
        else Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real2;
*/
//        Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real1;
        if (Cursor_Vertical_Position1 > 600) Cursor_Vertical_Position1 = 600;
        else if (Cursor_Vertical_Position1 < 0) Cursor_Vertical_Position1 = 0;	
	
//        Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real2;
        if (Cursor_Vertical_Position2 > 600) Cursor_Vertical_Position2 = 600;
        else if (Cursor_Vertical_Position2 < 0) Cursor_Vertical_Position2 = 0;


        if (Display_Mode == 1)
        {
            if (Cursor_Vertical_Position1 < DrawXYOffsetX1) Cursor_Vertical_Position1 = DrawXYOffsetX1;
            else if (Cursor_Vertical_Position1 > DrawXYOffsetX2) Cursor_Vertical_Position1 = DrawXYOffsetX2;	
	
            if (Cursor_Vertical_Position2 < DrawXYOffsetX1) Cursor_Vertical_Position2 = DrawXYOffsetX1;
            else if (Cursor_Vertical_Position2 > DrawXYOffsetX2) Cursor_Vertical_Position2 = DrawXYOffsetX2;
        }	
	
        Cursor_Horizontal_Position1 = Cursor_Horizontal_Position_Real1;
        if (Cursor_Horizontal_Position1 > 384) Cursor_Horizontal_Position1 = 384;
        else if (Cursor_Horizontal_Position1 < 0) Cursor_Horizontal_Position1 = 0;
		
        Cursor_Horizontal_Position2 = Cursor_Horizontal_Position_Real2;
        if (Cursor_Horizontal_Position2 > 384) Cursor_Horizontal_Position2 = 384;
        else if (Cursor_Horizontal_Position2 < 0) Cursor_Horizontal_Position2 = 0;
	
        BufVal1 = Cursor_Vertical_Position1 + DrawOffsetX;
        BufVal2 = Cursor_Vertical_Position2 + DrawOffsetX;

        if (MenuStatus[10][1] == 1)
        {
            BufVal3 = ((int)((float) (Cursor_Vertical_Position1 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal3 > (600 + DrawOffsetX)) BufVal3 = (600 + DrawOffsetX);
            if (BufVal3 < DrawOffsetX) BufVal3 = DrawOffsetX;

            BufVal4 = ((int)((float) (Cursor_Vertical_Position2 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal4 > (600 + DrawOffsetX)) BufVal4 = (600 + DrawOffsetX);
            if (BufVal4 < DrawOffsetX) BufVal4 = DrawOffsetX;
        }

        // Draw New Vertical Cursor
        switch(Cursor_Vertical_Active)
        {
            // Cursor 1 is active
            case 1:
            {
       
              if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                   for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }			
		}
		
		Cursor_Vertical_Position1_Old = BufVal1;
		Cursor_Vertical_Position2_Old = BufVal2;
		dmode_Cursor_Vertical_Position1_Old = BufVal3;
		dmode_Cursor_Vertical_Position2_Old = BufVal4;
		Cursor_Vertical_Active_Old = Cursor_Vertical_Active;

        if (MenuStatus[10][1] == 1)
        {
            BufVal1 = (Cursor_Horizontal_Position1 >> 1) + DrawOffsetY;
            BufVal2 = (Cursor_Horizontal_Position2 >> 1) + DrawOffsetY;	
        }
        else
        {
            BufVal1 = Cursor_Horizontal_Position1 + DrawOffsetY;
            BufVal2 = Cursor_Horizontal_Position2 + DrawOffsetY;	
        }


        if (Display_Mode == 1)
        {
            horz_cursor_start = DrawXYOffsetX1;
            horz_cursor_stop = DrawXYOffsetX2 - 5;
        }
        else
        {
            horz_cursor_start = 0;
            horz_cursor_stop = 600;
        }

        // Draw New Horizontal Cursor
        switch(Cursor_Horizontal_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + 193, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + 193, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 + 193, 1, Buffer_Mark1Plane);	
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			
                    }
                }
                break;
            }
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + 193, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + 193, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 + 193, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }					
		}
		
		Cursor_Horizontal_Position1_Old = BufVal1;
		Cursor_Horizontal_Position2_Old = BufVal2;
		Cursor_Horizontal_Active_Old = Cursor_Horizontal_Active;
	}	
	
	// Draw quick measurment cursor
    if (QM_Enabled)
    {
        QM_Vertical_Position1 = QM_Vertical_Position_Real1;
        if (QM_Vertical_Position1 > 600) QM_Vertical_Position1 = 600;
        else if (QM_Vertical_Position1 < 0) QM_Vertical_Position1 = 0;	
	
        QM_Vertical_Position2 = QM_Vertical_Position_Real2;
        if (QM_Vertical_Position2 > 600) QM_Vertical_Position2 = 600;
        else if (QM_Vertical_Position2 < 0) QM_Vertical_Position2 = 0;	
	
        QM_Horizontal_Position1 = QM_Horizontal_Position_Real1;
        if (QM_Horizontal_Position1 > 384) QM_Horizontal_Position1 = 384;
        else if (QM_Horizontal_Position1 < 0) QM_Horizontal_Position1 = 0;
		
        QM_Horizontal_Position2 = QM_Horizontal_Position_Real2;
        if (QM_Horizontal_Position2 > 384) QM_Horizontal_Position2 = 384;
        else if (QM_Horizontal_Position2 < 0) QM_Horizontal_Position2 = 0;		
	
        if (Display_Mode == 1)
        {
            if (QM_Vertical_Position1 < DrawXYOffsetX1) QM_Vertical_Position1 = DrawXYOffsetX1;
            else if (QM_Vertical_Position1 > DrawXYOffsetX2) QM_Vertical_Position1 = DrawXYOffsetX2;	
	
            if (QM_Vertical_Position2 < DrawXYOffsetX1) QM_Vertical_Position2 = DrawXYOffsetX1;
            else if (QM_Vertical_Position2 > DrawXYOffsetX2) QM_Vertical_Position2 = DrawXYOffsetX2;
        }		
	
        BufVal1 = QM_Vertical_Position1 + DrawOffsetX - 2;// + 18;
        BufVal2 = QM_Vertical_Position2 + DrawOffsetX - 2;// + 18;

        if (MenuStatus[10][1] == 1)
        {
            BufVal3 = ((int)((float) (QM_Vertical_Position1 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal3 > (600 + DrawOffsetX)) BufVal3 = (600 + DrawOffsetX);
            if (BufVal3 < DrawOffsetX) BufVal3 = DrawOffsetX;

            BufVal4 = ((int)((float) (QM_Vertical_Position2 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal4 > (600 + DrawOffsetX)) BufVal4 = (600 + DrawOffsetX);
            if (BufVal4 < DrawOffsetX) BufVal4 = DrawOffsetX;
        }

        // Draw New Vertical Cursor
        switch(QM_Vertical_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                    for (c = 194; c < 385; c++)
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // only Cursor 1 is active
            case 5:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 2 is active
            case 6:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = 194; c < 385; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
		}
		
		QM_Vertical_Position1_Old = BufVal1;
		QM_Vertical_Position2_Old = BufVal2;
		dmode_QM_Vertical_Position1_Old = BufVal3;
		dmode_QM_Vertical_Position2_Old = BufVal4;
		QM_Vertical_Active_Old = QM_Vertical_Active;

        if (Display_Mode == 1)
        {
            horz_cursor_start = DrawXYOffsetX1;
            horz_cursor_stop = DrawXYOffsetX2;
        }
        else
        {
            horz_cursor_start = 0;
            horz_cursor_stop = 600;
        }
        // Draw New Horizontal Cursor
        if (MenuStatus[10][1] == 1)
        {
            //BufVal1 = (QM_Horizontal_Position1 >> 1) + DrawOffsetY;
           // BufVal2 = (QM_Horizontal_Position2 >> 1) + DrawOffsetY;
                    /*
            if (multi_active)
            {
                BufVal1 = (int (float (QM_Horizontal_Position1) * Volt_Correct_float[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
                BufVal2 = (int (float (QM_Horizontal_Position2) * Volt_Correct_float[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;

//                BufVal1 = (nm_mult(QM_Horizontal_Position1 - 128, Voltage_Correction[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
//                BufVal2 = (nm_mult(QM_Horizontal_Position2 - 128, Voltage_Correction[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
            }
            else  */
            {
                BufVal1 = (QM_Horizontal_Position1 >> 1) + DrawOffsetY;
                BufVal2 = (QM_Horizontal_Position2 >> 1) + DrawOffsetY;
            }
        }
        else
        {             /*
            if (multi_active)           //QM_Horizontal_Position_Real1
            {
                BufVal1 = int (float (QM_Horizontal_Position1) * Volt_Correct_float[0][Selected_Voltage_CH1]) + DrawOffsetY;
                BufVal2 = int (float (QM_Horizontal_Position2) * Volt_Correct_float[0][Selected_Voltage_CH1]) + DrawOffsetY;
            }
            else        */
            {
                BufVal1 = QM_Horizontal_Position1 + DrawOffsetY;
                BufVal2 = QM_Horizontal_Position2 + DrawOffsetY;
            }
        }

        switch(QM_Horizontal_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + 193, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + 193, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 * 193, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			
                    }
                }
                break;
            }
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + 193, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + 193, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 + 193, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 1 is active
            case 5:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 2 is active
            case 6:
            {
                if (MenuStatus[10][1] == 1)
                {
                    for (c = 0; c < 600; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + 193, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }                					
		}
		
		QM_Horizontal_Position1_Old = BufVal1;
		QM_Horizontal_Position2_Old = BufVal2;
		QM_Horizontal_Active_Old = QM_Horizontal_Active;
	}	                         	
		
    Cursor_Enabled_Old = Cursor_Enabled;
	QM_Enabled_Old = QM_Enabled;
	
    UpdateMarkerPlane = true;    		
}

void Display::DRAWMEMORY(char remove, char firstdraw, char redraw)
{
    int intbuf = 0;
    int pos_wst = 0;
    int pos_wsp = 0;
    int pos_to = 0;

    if (remove)
    {
        DRAWP(104, 28, 430, 19, 0, UI_Plane1);									 // Clear First	
        DRAWP(104, 28, 430, 19, 0, UI_Plane2);									 // Clear First	
        DRAWP(104, 28, 430, 19, 0, UI_Plane4);									 // Clear First	
        DRAWP(104, 28, 430, 19, 0, UI_Plane5);									 // Clear First	
        DRAWP(104, 28, 430, 19, 0, Marker_Plane2);							     // Clear First	
        DRAWP(104, 28, 430, 19, 0, Buffer_Mark1Plane);							 // Clear First	

        Memory_Window_visible = false;
    }

    if (firstdraw)
    {
        Memory_Window_visible = true;

        DRAWROUNDBUTTON(106, 28, 430, 19, btnUnpushed, btnDraw);						// Draw Button	
        DRAWP(116, 30, 410, 13, 1, UI_Plane2);									 // Clear First	

        // Testen welche genau
        //DRAWP(116, 30, 410, 13, 0, UI_Plane3);									 // Clear First	
        DRAWP(116, 30, 410, 13, 0, UI_Plane4);									 // Clear First	

        DRAWP(116, 30, 410, 13, 0, Marker_Plane2);									 // Clear First
    }

    if (redraw)
    {
        Memory_Window_visible = true;

        if (Selected_Timebase < 7)
        {
            pos_wst = (int) (Trig_Mem_Pos / 40) + 116;
            pos_wsp = (int) ((Trig_Mem_Pos + SIG_Size[ZIT_short]) / 40) + 116;

            pos_to = (int) (Trig_Pos_Mem / 40) + 116;
        }
        else
        {
            pos_wst = (int) (Trig_Mem_Pos / 10) + 116;
            pos_wsp = (int) ((Trig_Mem_Pos + SIG_Size[ZIT_short]) / 10) + 116;

            pos_to = (int) (Trig_Pos_Mem / 10) + 116;
        }
/*
        if (Selected_Timebase < 7)
        {
            pos_wst = (int) ((float) (Trig_Mem_Pos * OFT_float) / 40) + 116;
            pos_wsp = (int) ((float) ((Trig_Mem_Pos * OFT_float) + SIG_Size[ZIT_short]) / 40) + 116;

            pos_to = (int) (Trig_Pos_Mem / 40) + 116;
        }
        else
        {
            pos_wst = (int) ((float) (Trig_Mem_Pos * OFT_float) / 10) + 116;
            pos_wsp = (int) ((float) ((Trig_Mem_Pos * OFT_float) + SIG_Size[ZIT_short]) / 10) + 116;

            pos_to = (int) (Trig_Pos_Mem / 10) + 116;
        }
         */

#ifdef _Debug_
        if (Debug_Mode) printf("Redraw MemBr wst : %d wsto : %d wsp : %d wspo : %d to : %d too : %d\n", pos_wst, mb_window_start_old, pos_wsp, mb_window_stop_old, pos_to, mb_window_trigger_old);
#endif


        ////if (Selected_Timebase < 4) FirStartCH = (int)((float) Trig_Mem_Pos * OFT_float) + 20;
        if (Selected_Timebase < 4) FirStartCH = Trig_Mem_Pos + 40;
        
        // Remove
        // Window Start Pos
       // if (pos_wst != mb_window_start_old)
        {
            DRAWLINEP(mb_window_start_old, 31, mb_window_start_old, 42, 0, UI_Plane5);
            DRAWLINEP(mb_window_start_old, 31, mb_window_start_old, 42, 1, UI_Plane2);
        }

        // Window Stop Pos
      //  if (pos_wsp != mb_window_stop_old)
        {
            DRAWLINEP(mb_window_stop_old, 31, mb_window_stop_old, 42, 0, UI_Plane5);
            DRAWLINEP(mb_window_stop_old, 31, mb_window_stop_old, 42, 1, UI_Plane2);
        }

        // Trigger Pos
      //  if (pos_to != mb_window_trigger_old)
        {
//            DRAWLINEP(pos_to, 34, pos_to, 39, 0, Buffer_Mark1Plane);
//            DRAWLINEP(pos_to - 2, 34, pos_to + 3, 34, 0, Buffer_Mark1Plane);
            DRAWLINEP(mb_window_trigger_old, 34, mb_window_trigger_old, 39, 0, Marker_Plane2);
            DRAWLINEP(mb_window_trigger_old - 2, 34, mb_window_trigger_old + 3, 34, 0, Marker_Plane2);
            DRAWLINEP(mb_window_trigger_old, 34, mb_window_trigger_old, 39, 1, UI_Plane2);
            DRAWLINEP(mb_window_trigger_old - 2, 34, mb_window_trigger_old + 3, 34, 1, UI_Plane2);

            if (mb_window_trigger_old < 119)
            {
                DRAWP(113, 34, 3, 5, 0, Marker_Plane2);
                DRAWP(113, 34, 3, 5, 0, UI_Plane2);
            }
            if (mb_window_trigger_old > 522)
            {
                PIXELP(526, 34, 0, Marker_Plane2);
                PIXELP(526, 34, 0, UI_Plane2);
            }
        }


        // Redraw

        // Window Start Pos
        DRAWLINEP(pos_wst, 31, pos_wst, 42, 1, UI_Plane5);
        DRAWLINEP(pos_wst, 31, pos_wst, 42, 0, UI_Plane2);
        mb_window_start_old = pos_wst;

        // Window Stop Pos
        DRAWLINEP(pos_wsp, 31, pos_wsp, 42, 1, UI_Plane5);
        DRAWLINEP(pos_wsp, 31, pos_wsp, 42, 0, UI_Plane2);
        mb_window_stop_old = pos_wsp;

        // Trigger Pos
        DRAWLINEP(pos_to, 34, pos_to, 39, 1, Marker_Plane2);
        DRAWLINEP(pos_to - 2, 34, pos_to + 3, 34, 1, Marker_Plane2);
        DRAWLINEP(pos_to, 34, pos_to, 39, 0, UI_Plane2);
        DRAWLINEP(pos_to - 2, 34, pos_to + 3, 34, 0, UI_Plane2);
        DRAWLINEP(pos_to, 34, pos_to, 39, 0, UI_Plane5);
        DRAWLINEP(pos_to - 2, 34, pos_to + 3, 34, 0, UI_Plane5);
        mb_window_trigger_old = pos_to;
    }

    //UpdateMarkerPlane = true;
}

void Display::DRAWCURSORDATA(char dir)
{
	int posx = 0;
	int posy = 0;
	
	if (MenuPopupActive > -1) return;
		
	if (dir == 0)
	{			
		//if (redraw == false) for (posx = 408 * 20; posx < 428 * 20; posx++) *(UI_Plane2 + posx) = 0;	// delete Text
		
	//	if ((CursorChanged == 1) || (CursorChanged == 2) || (CursorChanged == 3))
		{
            for (posy = 408 * 20; posy < 428 * 20; posy+=20)
            {
                for (posx = 0; posx < 13; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
            }	
		}
	//	if ((CursorChanged == 4) || (CursorChanged == 5) || (CursorChanged == 3))
		{
            for (posy = 408 * 20; posy < 428 * 20; posy+=20)
            {
                for (posx = 14; posx < 20; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
            }	
		}
        if (Cursor_Enabled)
        {        		
       //     if (Cursor_Data_First_Draw)
            {
                DRAWROUNDBUTTON(1, 408, 214, 23, btnUnpushed, btnDraw);						// Button
                if (Display_Mode == false) DRAWROUNDBUTTON(214, 408, 214, 23, btnUnpushed, btnDraw);					// Button
                DRAWROUNDBUTTON(426, 408, 214, 23, btnUnpushed, btnDraw);					// Button	
            }
	
            if (Display_Mode) TEXTOUTxvbig(Cursor_Delta_XY_X.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            else
            {
                TEXTOUTxvbig(Cursor_Delta_X.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
                TEXTOUTxvbig(Cursor_Delta_1X.Read_Text(), 230, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            }

            TEXTOUTxvbig(Cursor_Delta_Y.Read_Text(), 440, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
        }
		
		Cursor_Data_First_Draw = 0;
		Cursor_Data_Draw_Pos = 0;
		CursorChanged = 0;
	}
	else
	{
		// Es fehlt noch das lschen der Textebene
		
		if (Cursor_Data_First_Draw)
		{
			DRAWROUNDBUTTON(398, 231, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 256, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 281, 214, 23, btnUnpushed, btnDraw);					// Button		
		}
		
//		TEXTOUTxvbig(Cursor_Delta_X.Read_Text(), 412, 235, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(Cursor_Delta_1X.Read_Text(), 412, 260, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(Cursor_Delta_Y.Read_Text(), 412, 285, 1, UI_Plane4);		// Draw Cursor Text	
		
		Cursor_Data_First_Draw = 0;
		Cursor_Data_Draw_Pos = 1;
	}

    UpdateMenuTextPlane = true;	
}

void Display::DRAWQMDATA(char dir)
{
	int posx = 0;
	int posy = 0;
	
	if (MenuPopupActive > -1) return;
	
	if (dir == 0)
	{			
		if (Quick_Measure_First_Draw)
		{
            // remove the cursor data
            for (posx = 408 * 20; posx < 430 * 20; posx++)
            {
                *(UI_Plane1 + posx) = 0;	// delete
                *(Buffer_UI2Plane + posx) = 0;	// delete Text				
                *(UI_Plane4 + posx) = 0;	// delete
                *(UI_Plane5 + posx) = 0;	// delete
            }
        }
        else		
        {
            if (QM_Changed[0] == 1)
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 0; posx < 6; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
            if (QM_Changed[1] == 1)
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 6; posx < 13; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
            if (QM_Changed[2] == 1)     // Mu gre des lschbereichs noch getestet werden
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 14; posx < 19; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
		}

        if (QM_Enabled)
        {		
            if (Quick_Measure_First_Draw)
            {
                if (QM_Type[0] > 0) DRAWROUNDBUTTON(1, 408, 214, 23, btnUnpushed, btnDraw);						// Button
                if (QM_Type[1] > 0) DRAWROUNDBUTTON(214, 408, 214, 23, btnUnpushed, btnDraw);					// Button
                if (QM_Type[2] > 0) DRAWROUNDBUTTON(426, 408, 214, 23, btnUnpushed, btnDraw);					// Button	
            }
	
            if (QM_Type[0] > 0) TEXTOUTxvbig(QM_Slot1.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            if (QM_Type[1] > 0) TEXTOUTxvbig(QM_Slot2.Read_Text(), 230, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            if (QM_Type[2] > 0) TEXTOUTxvbig(QM_Slot3.Read_Text(), 440, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
        }
		
		Quick_Measure_First_Draw = 0;
		Quick_Measure_Data_Draw_Pos = 0;
		if (QM_Type[0] > 0) QM_Changed[0] = 0;
		if (QM_Type[1] > 0) QM_Changed[1] = 0;
		if (QM_Type[2] > 0) QM_Changed[2] = 0;
	}
	else
	{
		// Es fehlt noch das lschen der Textebene
		
		if (Cursor_Data_First_Draw)
		{
			DRAWROUNDBUTTON(398, 231, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 256, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 281, 214, 23, btnUnpushed, btnDraw);					// Button		
		}
		
//		TEXTOUTxvbig(QM_Slot1.Read_Text(), 412, 235, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(QM_Slot2.Read_Text(), 412, 260, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(QM_Slot3.Read_Text(), 412, 285, 1, UI_Plane4);		// Draw Cursor Text	
		
		Quick_Measure_First_Draw = 0;
		Quick_Measure_Data_Draw_Pos = 1;
		if (QM_Type[0] > 0) QM_Changed[0] = 0;
		if (QM_Type[1] > 0) QM_Changed[1] = 0;
		if (QM_Type[2] > 0) QM_Changed[2] = 0;
	}    	
/* ???	
    QM_Type_Old[0] = QM_Type[0];
    QM_Type_Old[1] = QM_Type[1];
    QM_Type_Old[2] = QM_Type[2];	
 */
    UpdateMenuTextPlane = true;
}

void Display::CALCCURSORDATA(void)  // channel = source im cursor menu
{
	int buf_int = 0;	
		
	char doit = 0;	
	int volt = 0;		
	int zero = 0;		
	int voltmfactor = 0;
	double vfactor = 0;	
	double vfactor2 = 0;	
	double voltoff = 0;		
	
	int time = 0;
	double tfactor = 0;
	double timeoff = 0;			
	
	char BufferText[10];
	
	int channel = MenuStatus[16][0] - 26;
			
	if (dcd_channel_buf != channel) doit = 5;
		
	switch(channel)
	{
	 	case 1:	// TMW comment added: case 1 means Cursor Source 1 set (use CH1 voltage)
		{				
			volt = Selected_Voltage_CH1;
			zero = ZeroLevelCH1;
			voltmfactor = MenuStatus[1][3];
			break;
		}
		case 2: // TMW comment added: case 2 means Cursor Source 2 set (use CH2 voltage)
		{				
			volt = Selected_Voltage_CH2;
			zero = ZeroLevelCH2;
			voltmfactor = MenuStatus[2][3];
			break;
		}
		case 3: // TMW comment added: case 3 means Cursor Source 3 set (use CH3 voltage)
		{				
			volt = Selected_Voltage_CH3;
			zero = ZeroLevelCH3;
			voltmfactor = MenuStatus[3][3];
			break;
		}
		case 4: // TMW comment added: case 4 means Cursor Source 4 set (use CH4 voltage)
		{				
			volt = Selected_Voltage_CH4;
			zero = ZeroLevelCH4;
			voltmfactor = MenuStatus[4][3];
			break;	
		}
	}
	
	// Start calculate horizontal Data
//	if ((volt != dcd_volt_buf) || (voltmfactor != dcd_voltmfactor_buf))
	{		
		switch(volt)
		{
			case 0 : vfactor = 20.833333; break;
			case 1 : vfactor = 41.666666; break;
			case 2 : vfactor = 104.166666; break;
			case 3 : vfactor = 208.333333; break;
			case 4 : vfactor = 416.666666; break;
			case 5 : vfactor = 1041.666666; break;
			case 6 : vfactor = 2083.333333; break;
			case 7 : vfactor = 4166.666666; break;
			case 8 : vfactor = 10416.66666; break;
			case 9 : vfactor = 20833.33333; break;
			case 10 : vfactor = 41666.66666; break;
			case 11 : vfactor = 104166.6666; break;
		}
		
		vfactor = vfactor / 1000000;

		switch(voltmfactor)
		{
			case 101: vfactor2 = 0.1; break;	
			case 102: vfactor2 = 0.2; break;
			case 103: vfactor2 = 0.5; break;
			case 104: vfactor2 = 1; break;
			case 105: vfactor2 = 2; break;
			case 106: vfactor2 = 5; break;
			case 107: vfactor2 = 10; break;
			case 108: vfactor2 = 20; break;
			case 109: vfactor2 = 50; break;
			case 110: vfactor2 = 100; break;
			case 111: vfactor2 = 200; break;
			case 112: vfactor2 = 500; break;
			case 113: vfactor2 = 1000; break;
		}	
		vfactor = vfactor * vfactor2;
		
		dcd_volt_buf = volt;
		dcd_voltmfactor_buf = voltmfactor;
	
		dcd_vfactor_buf = vfactor;
		doit = 3;
	}
/*	else
	{
		vfactor = dcd_vfactor_buf;
	}
*/	
	buf_int = zero - Cursor_Horizontal_Position_Real1;
	
//	if ((dcd_hz1_buf != buf_int) || (doit > 0))
	{	
		voltoff =  (float)buf_int * vfactor;  // Mitte ist 192 (0xC0) =>  Mitte 128 (0x80) * 1.5
		voltoff1 = voltoff;

		Cursor_Horizontal_Pos_1_Str.Write_Value(voltoff);
		Cursor_Horizontal_Pos_1_Str.RenderText();
		
		dcd_hz1_buf = buf_int;
		doit++;
	}
	
	buf_int = zero - Cursor_Horizontal_Position_Real2;	
	
//	if ((dcd_hz2_buf != buf_int) || (doit > 2))
	{		
		voltoff =  (float)buf_int * vfactor;  // Mitte ist 192 (0xC0) =>  Mitte 128 (0x80) * 1.5
		voltoff2 = voltoff;

		Cursor_Horizontal_Pos_2_Str.Write_Value(voltoff);
		Cursor_Horizontal_Pos_2_Str.RenderText();	
		
		dcd_hz2_buf = buf_int;
		doit++;
	}
	
//	if (doit > 0)
	{
		if (voltoff1 > voltoff2) voltoff = voltoff1 - voltoff2;
		else voltoff = voltoff2 - voltoff1;
		if (voltoff < 0) voltoff = -voltoff;

		//o	voltoff = abs(voltoff1 - voltoff2);
			
        if (Display_Mode)
        {			
            sprintf(BufferText, "@Y = ");
        }
        else
        {			
            switch(channel)
            {
                case 1: sprintf(BufferText, "@Y [ = "); break;
                case 2: sprintf(BufferText, "@Y \\ = "); break;
                case 3: sprintf(BufferText, "@Y ] = "); break;
                case 4: sprintf(BufferText, "@Y ^ = "); break;
                case 5: sprintf(BufferText, "@Y(M) = "); break;
            }
        }
        //sprintf(BufferText, "@Y (%d) = ", channel);
		
		Cursor_Delta_Y.Write_PreText(BufferText);
		Cursor_Delta_Y.Write_Value(voltoff);
		Cursor_Delta_Y.RenderText();				
	}	
	
	doit = 0;	
	
	// fr xy mode
	
	buf_int = Cursor_Vertical_Position_Real_XY_1 - 300;
	
//	if ((dcd_hz1_buf != buf_int) || (doit > 0))
	{	
		voltoff =  (float)buf_int * vfactor;  // Mitte ist 192 (0xC0) =>  Mitte 128 (0x80) * 1.5
		voltoff1 = voltoff;

		Cursor_Vertical_Pos_XY_1_Str.Write_Value(voltoff);
		Cursor_Vertical_Pos_XY_1_Str.RenderText();
		
		dcd_hz1_buf = buf_int;
		doit++;
	}
	
	buf_int = Cursor_Vertical_Position_Real_XY_2 - 300;	
	
//	if ((dcd_hz2_buf != buf_int) || (doit > 2))
	{		
		voltoff =  (float)buf_int * vfactor;  // Mitte ist 192 (0xC0) =>  Mitte 128 (0x80) * 1.5
		voltoff2 = voltoff;

		Cursor_Vertical_Pos_XY_2_Str.Write_Value(voltoff);
		Cursor_Vertical_Pos_XY_2_Str.RenderText();	
		
		dcd_hz2_buf = buf_int;
		doit++;
	}	

//	if (doit > 0)
	{
		if (voltoff1 > voltoff2) voltoff = voltoff1 - voltoff2;
		else voltoff = voltoff2 - voltoff1;
		if (voltoff < 0) voltoff = -voltoff;

		//o	voltoff = abs(voltoff1 - voltoff2);
			
		sprintf(BufferText, "@X = ");

        //sprintf(BufferText, "@Y (%d) = ", channel);
		
		Cursor_Delta_XY_X.Write_PreText(BufferText);
		Cursor_Delta_XY_X.Write_Value(voltoff);
		Cursor_Delta_XY_X.RenderText();				
	}	
	
	doit = 0;
	
	if (dcd_channel_buf != channel) doit = 5;
	dcd_channel_buf = channel;	
		
	// Start calculate vertical Data
//	if (dcd_time_buf != Display_Timebase)
	{
		switch(Display_Timebase)
		{
			case  0: tfactor = 0.00004; break;		//   2 	ns
			case  1: tfactor = 0.0001; break;		//   5 	ns
			case  2: tfactor = 0.0002; break;		//  10 	ns
			case  3: tfactor = 0.0004; break;		//  20 	ns
			case  4: tfactor = 0.001; break;		//  50 	ns
			case  5: tfactor = 0.002; break;		// 100 	ns
			case  6: tfactor = 0.004; break;		// 200 	ns
			case  7: tfactor = 0.01; break;			// 500 	ns		
			case  8: tfactor = 0.02; break;			//   1 	s
			case  9: tfactor = 0.04; break;			//   2 	s
			case 10: tfactor = 0.1; break;			//   5 	s
			case 11: tfactor = 0.2; break;			//  10 	s
			case 12: tfactor = 0.4; break;			//  20 	s
			case 13: tfactor = 1; break;			//  50 	s
			case 14: tfactor = 2; break;			// 100 	s
			case 15: tfactor = 4; break;			// 200 	s
			case 16: tfactor = 10; break;			// 500 	s
			case 17: tfactor = 20; break;			//   1 	ms
			case 18: tfactor = 40; break;			//   2 	ms
			case 19: tfactor = 100; break;			//   5 	ms
			case 20: tfactor = 200; break;			//  10 	ms
			case 21: tfactor = 400; break;			//  20 	ms
			case 22: tfactor = 1000; break;			//  50 	ms
			case 23: tfactor = 2000; break;			// 100 	ms
			case 24: tfactor = 4000; break;			// 200 	ms
			case 25: tfactor = 10000; break;		// 500 	ms
			case 26: tfactor = 20000; break;		//   1 	s
			case 27: tfactor = 40000; break;		//   2 	s
			case 28: tfactor = 100000; break;		//   5 	s
			case 29: tfactor = 200000; break;		//  10 	s
			case 30: tfactor = 400000; break;		//  20 	s
			case 31: tfactor = 1000000; break;		//  50 	s
		}
			
//		tfactor = tfactor / 1000000;
		tfactor = tfactor / 1000000 / ZFT_float;
		
		dcd_time_buf = Display_Timebase;
		dcd_tfactor_buf = tfactor;
		
		doit = 3;
	}
//	else tfactor = dcd_tfactor_buf;
	

    buf_int = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) );// / ZFT_float);	
	
	//buf_int = Cursor_Vertical_Position_Real1 - 53;	
//	if ((buf_int != dcd_vz1_buf) || (doit > 0))
	{	
		timeoff =  (float)buf_int * tfactor;  // Mitte ist 300
		timeoff1 = timeoff;
			
		Cursor_Vertical_Pos_1_Str.Write_Value(timeoff);
		Cursor_Vertical_Pos_1_Str.RenderText();	
		
		dcd_vz1_buf = buf_int;
		doit++;
	}

    buf_int = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) ); /// ZFT_float);		

	//buf_int = Cursor_Vertical_Position_Real2 - 53;	
//	if ((buf_int != dcd_vz2_buf) || (doit > 2))
	{
		timeoff =  (float)buf_int * tfactor;  // Mitte ist 300
		timeoff2 = timeoff;

		Cursor_Vertical_Pos_2_Str.Write_Value(timeoff);	
		Cursor_Vertical_Pos_2_Str.RenderText();	
		
		dcd_vz2_buf = buf_int;
		doit++;
	}
	
//	if (doit > 0)
	{
		if (timeoff1 > timeoff2) timeoff = timeoff1 - timeoff2;
		else timeoff = timeoff2 - timeoff1;
		if (timeoff < 0) timeoff = -timeoff;
		
		Cursor_Delta_X.Write_Value(timeoff);	
		Cursor_Delta_X.RenderText();
		
		timeoff = 1 / timeoff;
		Cursor_Delta_1X.Write_Value(timeoff);
		Cursor_Delta_1X.RenderText();
	}
}

void Display::CALCQMDATA(void)
{
    float BufVal = 1;

    int ixs, ixss, cnt, mid_buf = 0;
    int off_buf = 0;
    short PBuf;

    short thres_low = (int) QM_Threshold_lower.Read_Value();
    short thres_mdl = (int) QM_Threshold_middle.Read_Value();
    short thres_up = (int) QM_Threshold_upper.Read_Value();

    short SIGNAL_THRES_PRE_POSITIV = -1;
    short SIGNAL_THRES_LOW_POSITIV = -1;
    short SIGNAL_THRES_MDL_POSITIV = -1;
    short SIGNAL_THRES_UP_POSITIV = -1;
    short SIGNAL_THRES_OVER_POSITIV = -1;

    short SIGNAL_THRES_PRE_NEGATIV = -1;
    short SIGNAL_THRES_LOW_NEGATIV = -1;
    short SIGNAL_THRES_MDL_NEGATIV = -1;
    short SIGNAL_THRES_UP_NEGATIV = -1;
    short SIGNAL_THRES_OVER_NEGATIV = -1;

    // mu berarbeitet werden
    //rot_int->np_piointerruptmask = 0x00;						
    //key_int->np_piointerruptmask = 0x00;
	
    if (SIGNALFaktor_idx == 0)
    {
        if (Timebase_Offset_Pos < 0)
        {
	        ixs = SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float);

	        if (ixs < 100) ixs = 100;
	
	        //if (ixs < 500) ixs = 500; // if (ixs < 0) ixs = 0;
	
	        ixss = ixs + 600;
        }	
        else if (Timebase_Offset_Pos > 0)
        {
	        ixss = SIG_Start_Stop[ZIT_short][1] + (int) ((float) Timebase_Offset_Pos * OFT_float);       	

	        if (ixss > 16000) ixss = 16000; // if (ixss > 16383) ixs = 16383;
	
	        ixs = ixss - 600;
        }	
        else
        {
	        ixs = SIG_Start_Stop[ZIT_short][0] - SIGNAL_OFFSET;
	
	        if (ixs < 100) ixs = 100;
	
	        ixss = ixs + 600;
        }
    }
    else
    {
        ixs = 16;
        ixss = 590;

    }

#ifdef _Debug_QM_
    if (Debug_Mode)
    {
        printf("QM ixs %d ixss %d\n", ixs, ixss);
        printf("QM_TYPE[0] %d QM_TYPE[1] %d QM_TYPE[2] %d\n", QM_Type[0], QM_Type[1], QM_Type[2]);
        printf("QM_Channel[0] %d QM_Channel[1] %d QM_Channel[2] %d\n", QM_Channel[0], QM_Channel[1], QM_Channel[2]);
    }
#endif

    if (QM_Type[0] == 2)
    {
        QM_Second_Channel[0] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[0] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[0] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[0] == 10)
    {
        QM_Second_Channel[0] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[0] = 0;

    if (QM_Type[1] == 2)
    {
        QM_Second_Channel[1] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[1] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[1] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[1] == 10)
    {
        QM_Second_Channel[1] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[1] = 0;

    if (QM_Type[2] == 2)
    {
        QM_Second_Channel[2] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[2] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[2] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[2] == 10)
    {
        QM_Second_Channel[2] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[2] = 0;

    SIGNAL1_AVG_CNT = 0;
    SIGNAL1_AVG = 0;
    SIGNAL2_AVG_CNT = 0;
    SIGNAL2_AVG = 0;
    SIGNAL3_AVG_CNT = 0;
    SIGNAL3_AVG = 0;
    SIGNAL4_AVG_CNT = 0;
    SIGNAL4_AVG = 0;
    SIGNALM_AVG_CNT = 0;
    SIGNALM_AVG = 0;

    // Max = Top Screen - positiv Voltage
    // Min = Bottom Screen - negativ Voltage

    if ((QM_Channel[0] == 1) || (QM_Channel[1] == 1) || (QM_Channel[2] == 1) || (QM_Second_Channel[0] == 1) || (QM_Second_Channel[1] == 1) || (QM_Second_Channel[2] == 1))
    {
        SIGNAL1_MAX = 255;
        SIGNAL1_MIN = 0;

        for (cnt = 0; cnt < 256; cnt++) SIGNAL1_Histo[cnt] = 0;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL1_Histo[SIGNAL1[cnt]]++;

                if (SIGNAL1_MAX > SIGNAL1[cnt]) SIGNAL1_MAX = SIGNAL1[cnt];
                if (SIGNAL1_MIN < SIGNAL1[cnt]) SIGNAL1_MIN = SIGNAL1[cnt];
            }
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL1_Histo[SIGNAL1_SUM_MIN[cnt]]++;
                SIGNAL1_Histo[SIGNAL1_SUM_MAX[cnt]]++;

                if (SIGNAL1_MAX > SIGNAL1_SUM_MIN[cnt]) SIGNAL1_MAX = SIGNAL1_SUM_MIN[cnt];
                if (SIGNAL1_MIN < SIGNAL1_SUM_MAX[cnt]) SIGNAL1_MIN = SIGNAL1_SUM_MAX[cnt];
            }
        }

        if (SIGNAL1_MAX > SIGNAL1_MIN)
        {
            PBuf = SIGNAL1_MAX;
            SIGNAL1_MAX = SIGNAL1_MIN;
            SIGNAL1_MIN = PBuf;
        }

        SIGNAL1_MDL = (SIGNAL1_MIN + SIGNAL1_MAX) >> 1;

        SIGNAL1_TOP = 0;
        SIGNAL1_BASE = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNAL1_MIN + SIGNAL1_MAX) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNAL1_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL1_Histo[cnt];
                SIGNAL1_TOP = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNAL1_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL1_Histo[cnt];
                SIGNAL1_BASE = cnt;
            }
        }

        if (SIGNAL1_TOP > SIGNAL1_BASE)
        {
            PBuf = SIGNAL1_TOP;
            SIGNAL1_TOP = SIGNAL1_BASE;
            SIGNAL1_BASE = PBuf;
        }

        SIGNAL1_THRES_UP  = (short) (SIGNAL1_BASE - (((float) thres_up / 100) * (SIGNAL1_BASE - SIGNAL1_TOP)));
        SIGNAL1_THRES_MDL = (short) (SIGNAL1_BASE - (((float) thres_mdl / 100) * (SIGNAL1_BASE - SIGNAL1_TOP)));
        SIGNAL1_THRES_LOW = (short) (SIGNAL1_BASE - (((float) thres_low / 100) * (SIGNAL1_BASE - SIGNAL1_TOP)));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("1 : tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("1 : THR2L %d THR2M %d THR2U %d \n", SIGNAL1_THRES_LOW, SIGNAL1_THRES_MDL, SIGNAL1_THRES_UP);
            printf("1 : Top %d Base %d \n", SIGNAL1_TOP, SIGNAL1_BASE);
            printf("1 : Min %d Mdl %d Max %d\n", SIGNAL1_MIN, SIGNAL1_MDL, SIGNAL1_MAX);
        }
#endif
        SIGNAL1_THRES_PRE_POSITIV_1 = -1;
        SIGNAL1_THRES_LOW_POSITIV_1 = -1;
        SIGNAL1_THRES_MDL_POSITIV_1 = -1;
        SIGNAL1_THRES_UP_POSITIV_1 = -1;
        SIGNAL1_THRES_OVER_POSITIV_1 = -1;

        SIGNAL1_THRES_PRE_NEGATIV_1 = -1;
        SIGNAL1_THRES_LOW_NEGATIV_1 = -1;
        SIGNAL1_THRES_MDL_NEGATIV_1 = -1;
        SIGNAL1_THRES_UP_NEGATIV_1 = -1;
        SIGNAL1_THRES_OVER_NEGATIV_1 = -1;

        SIGNAL1_THRES_PRE_POSITIV_2 = -1;
        SIGNAL1_THRES_LOW_POSITIV_2 = -1;
        SIGNAL1_THRES_MDL_POSITIV_2 = -1;
        SIGNAL1_THRES_UP_POSITIV_2 = -1;
        SIGNAL1_THRES_OVER_POSITIV_2 = -1;

        SIGNAL1_THRES_PRE_NEGATIV_2 = -1;
        SIGNAL1_THRES_LOW_NEGATIV_2 = -1;
        SIGNAL1_THRES_MDL_NEGATIV_2 = -1;
        SIGNAL1_THRES_UP_NEGATIV_2 = -1;
        SIGNAL1_THRES_OVER_NEGATIV_2 = -1;

        SIGNAL1_THRES_PRE_NEGATIV_LAST = -1;
        SIGNAL1_THRES_LOW_NEGATIV_LAST = -1;
        SIGNAL1_THRES_MDL_NEGATIV_LAST = -1;
        SIGNAL1_THRES_UP_NEGATIV_LAST = -1;
        SIGNAL1_THRES_OVER_NEGATIV_LAST = -1;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL1_THRES_MDL_POSITIV_1 != 1) && (SIGNAL1_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL1_AVG += (SIGNAL1[cnt] - SIGNAL1_THRES_MDL);
                    SIGNAL1_AVG_CNT++;
                }

                if (SIGNAL1_THRES_UP_POSITIV_1 == -1)
                {
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1_THRES_PRE_POSITIV_1 != -1) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_LOW_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_PRE_POSITIV_1 != -1) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_LOW_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL1_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                        SIGNAL1_THRES_LOW_POSITIV_1 = -1;
                    }
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1)) SIGNAL1_THRES_MDL_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1)) SIGNAL1_THRES_MDL_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_MDL_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_1 == -1)) SIGNAL1_THRES_UP_POSITIV_1 = cnt - ixs - 30;
                }
                if (SIGNAL1_THRES_LOW_NEGATIV_1 == -1)
                {
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_UP_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_UP_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL1_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                        SIGNAL1_THRES_UP_NEGATIV_1 = -1;
                    }
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1)) SIGNAL1_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1)) SIGNAL1_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_1 == -1)) SIGNAL1_THRES_LOW_NEGATIV_1 = cnt - ixs - 30;
                }
                if ((SIGNAL1_THRES_UP_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 == -1))
                {
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1_THRES_PRE_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_LOW_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_PRE_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_LOW_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL1_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                        SIGNAL1_THRES_LOW_POSITIV_2 = -1;
                    }
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1)) SIGNAL1_THRES_MDL_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1)) SIGNAL1_THRES_MDL_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_MDL_POSITIV_2 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 == -1)) SIGNAL1_THRES_UP_POSITIV_2 = cnt - ixs - 30;
                }
                if ((SIGNAL1_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 == -1))
                {
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_UP_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_UP_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL1_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                        SIGNAL1_THRES_UP_NEGATIV_2 = -1;
                    }
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1)) SIGNAL1_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1)) SIGNAL1_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL1_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 == -1)) SIGNAL1_THRES_LOW_NEGATIV_2 = cnt - ixs - 30;
                }


                if ((SIGNAL1_THRES_UP_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 != -1))
                {
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL1_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL1_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL1_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL1_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL1_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL1_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 != -1))
                {
                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] < SIGNAL1_THRES_MDL) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_UP) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] < SIGNAL1_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] < SIGNAL1_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL1[cnt] > SIGNAL1_THRES_MDL) && (SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL1[cnt] > SIGNAL1_THRES_LOW) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL1_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL1_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL1_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL1_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL1_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNAL1_THRES_UP_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */
            }

            if (SIGNAL1_THRES_PRE_POSITIV_LAST == -1) SIGNAL1_THRES_PRE_POSITIV_LAST = SIGNAL1_THRES_PRE_POSITIV_2;
            if (SIGNAL1_THRES_LOW_POSITIV_LAST == -1) SIGNAL1_THRES_LOW_POSITIV_LAST = SIGNAL1_THRES_LOW_POSITIV_2;
            if (SIGNAL1_THRES_MDL_POSITIV_LAST == -1) SIGNAL1_THRES_MDL_POSITIV_LAST = SIGNAL1_THRES_MDL_POSITIV_2;
            if (SIGNAL1_THRES_UP_POSITIV_LAST == -1) SIGNAL1_THRES_UP_POSITIV_LAST = SIGNAL1_THRES_UP_POSITIV_2;
            if (SIGNAL1_THRES_OVER_POSITIV_LAST == -1) SIGNAL1_THRES_OVER_POSITIV_LAST = SIGNAL1_THRES_OVER_POSITIV_2;

            if (SIGNAL1_THRES_PRE_NEGATIV_LAST == -1) SIGNAL1_THRES_PRE_NEGATIV_LAST = SIGNAL1_THRES_PRE_NEGATIV_2;
            if (SIGNAL1_THRES_LOW_NEGATIV_LAST == -1) SIGNAL1_THRES_LOW_NEGATIV_LAST = SIGNAL1_THRES_LOW_NEGATIV_2;
            if (SIGNAL1_THRES_MDL_NEGATIV_LAST == -1) SIGNAL1_THRES_MDL_NEGATIV_LAST = SIGNAL1_THRES_MDL_NEGATIV_2;
            if (SIGNAL1_THRES_UP_NEGATIV_LAST == -1) SIGNAL1_THRES_UP_NEGATIV_LAST = SIGNAL1_THRES_UP_NEGATIV_2;
            if (SIGNAL1_THRES_OVER_NEGATIV_LAST == -1) SIGNAL1_THRES_OVER_NEGATIV_LAST = SIGNAL1_THRES_OVER_NEGATIV_2;

#ifdef _Debug_QM_
            if (Debug_Mode)
            {
                printf("1 : ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL1_THRES_PRE_POSITIV_1, SIGNAL1_THRES_LOW_POSITIV_1, SIGNAL1_THRES_MDL_POSITIV_1, SIGNAL1_THRES_UP_POSITIV_1);
                printf("1 : ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_1, SIGNAL1_THRES_LOW_NEGATIV_1, SIGNAL1_THRES_MDL_NEGATIV_1, SIGNAL1_THRES_UP_NEGATIV_1);
                printf("1 : ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL1_THRES_PRE_POSITIV_2, SIGNAL1_THRES_LOW_POSITIV_2, SIGNAL1_THRES_MDL_POSITIV_2, SIGNAL1_THRES_UP_POSITIV_2);
                printf("1 : ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_2, SIGNAL1_THRES_LOW_NEGATIV_2, SIGNAL1_THRES_MDL_NEGATIV_2, SIGNAL1_THRES_UP_NEGATIV_2);
                printf("1 : ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL1_THRES_OVER_POSITIV_LAST, SIGNAL1_THRES_LOW_POSITIV_LAST, SIGNAL1_THRES_MDL_POSITIV_LAST, SIGNAL1_THRES_UP_POSITIV_LAST);
                printf("1 : ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_LAST, SIGNAL1_THRES_LOW_NEGATIV_LAST, SIGNAL1_THRES_MDL_NEGATIV_LAST, SIGNAL1_THRES_UP_NEGATIV_LAST);
            }
#endif
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL1_THRES_MDL_POSITIV_1 != 1) && (SIGNAL1_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL1_AVG += (((SIGNAL1_SUM_MIN[cnt] + SIGNAL1_SUM_MAX[cnt]) >> 1) - SIGNAL1_THRES_MDL);
                    SIGNAL1_AVG_CNT++;
                }

                if (SIGNAL1_THRES_UP_POSITIV_1 == -1)
                {
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_PRE_POSITIV_1 = cnt;
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && (SIGNAL1_THRES_PRE_POSITIV_1 != -1) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_LOW_POSITIV_1 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_PRE_POSITIV_1 != -1) && (SIGNAL1_THRES_LOW_POSITIV_1 == -1)) SIGNAL1_THRES_LOW_POSITIV_1 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL1_THRES_PRE_POSITIV_1 = cnt;
                        SIGNAL1_THRES_LOW_POSITIV_1 = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1)) SIGNAL1_THRES_MDL_POSITIV_1 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_LOW_POSITIV_1 != -1) && (SIGNAL1_THRES_MDL_POSITIV_1 == -1)) SIGNAL1_THRES_MDL_POSITIV_1 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_MDL_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_1 == -1)) SIGNAL1_THRES_UP_POSITIV_1 = cnt;
                }

                else if (SIGNAL1_THRES_LOW_NEGATIV_1 == -1)
                {
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_OVER_NEGATIV_1 = cnt;
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && (SIGNAL1_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_UP_NEGATIV_1 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL1_THRES_UP_NEGATIV_1 == -1)) SIGNAL1_THRES_UP_NEGATIV_1 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL1_THRES_OVER_NEGATIV_1 = cnt;
                        SIGNAL1_THRES_UP_NEGATIV_1 = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1)) SIGNAL1_THRES_MDL_NEGATIV_1 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_UP_NEGATIV_1 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_1 == -1)) SIGNAL1_THRES_MDL_NEGATIV_1 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_1 == -1)) SIGNAL1_THRES_LOW_NEGATIV_1 = cnt;
                }

                else if ((SIGNAL1_THRES_UP_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 == -1))
                {
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_PRE_POSITIV_2 = cnt;
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && (SIGNAL1_THRES_PRE_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_LOW_POSITIV_2 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_PRE_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_POSITIV_2 == -1)) SIGNAL1_THRES_LOW_POSITIV_2 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL1_THRES_PRE_POSITIV_2 = cnt;
                        SIGNAL1_THRES_LOW_POSITIV_2 = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1)) SIGNAL1_THRES_MDL_POSITIV_2 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_LOW_POSITIV_2 != -1) && (SIGNAL1_THRES_MDL_POSITIV_2 == -1)) SIGNAL1_THRES_MDL_POSITIV_2 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_MDL_POSITIV_2 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 == -1)) SIGNAL1_THRES_UP_POSITIV_2 = cnt;
                }

                else if ((SIGNAL1_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 == -1))
                {
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_OVER_NEGATIV_2 = cnt;
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && (SIGNAL1_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_UP_NEGATIV_2 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL1_THRES_UP_NEGATIV_2 == -1)) SIGNAL1_THRES_UP_NEGATIV_2 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL1_THRES_OVER_NEGATIV_2 = cnt;
                        SIGNAL1_THRES_UP_NEGATIV_2 = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1)) SIGNAL1_THRES_MDL_NEGATIV_2 = cnt;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_UP_NEGATIV_2 != -1) && (SIGNAL1_THRES_MDL_NEGATIV_2 == -1)) SIGNAL1_THRES_MDL_NEGATIV_2 = cnt;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL1_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 == -1)) SIGNAL1_THRES_LOW_NEGATIV_2 = cnt;
                }



                if ((SIGNAL1_THRES_UP_POSITIV_1 != -1) && (SIGNAL1_THRES_UP_POSITIV_2 != -1))
                {
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL1_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL1_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL1_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL1_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL1_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL1_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 != -1))
                {
                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_MDL)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_UP)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_UP) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] < SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] < SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_MDL) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_MDL)) && ((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL1_SUM_MIN[cnt] > SIGNAL1_THRES_LOW) || (SIGNAL1_SUM_MAX[cnt] > SIGNAL1_THRES_LOW)) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL1_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL1_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL1_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL1_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL1_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }



                /*
                if ((SIGNAL1_THRES_UP_POSITIV_2 != -1) && (SIGNAL1_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */

            }
#ifdef _Debug_QM_
            if (Debug_Mode)
            {
                printf("1 : ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL1_THRES_PRE_POSITIV_1, SIGNAL1_THRES_LOW_POSITIV_1, SIGNAL1_THRES_MDL_POSITIV_1, SIGNAL1_THRES_UP_POSITIV_1);
                printf("1 : ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_1, SIGNAL1_THRES_LOW_NEGATIV_1, SIGNAL1_THRES_MDL_NEGATIV_1, SIGNAL1_THRES_UP_NEGATIV_1);
                printf("1 : ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL1_THRES_PRE_POSITIV_2, SIGNAL1_THRES_LOW_POSITIV_2, SIGNAL1_THRES_MDL_POSITIV_2, SIGNAL1_THRES_UP_POSITIV_2);
                printf("1 : ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_2, SIGNAL1_THRES_LOW_NEGATIV_2, SIGNAL1_THRES_MDL_NEGATIV_2, SIGNAL1_THRES_UP_NEGATIV_2);
                printf("1 : ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL1_THRES_OVER_POSITIV_LAST, SIGNAL1_THRES_LOW_POSITIV_LAST, SIGNAL1_THRES_MDL_POSITIV_LAST, SIGNAL1_THRES_UP_POSITIV_LAST);
                printf("1 : ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL1_THRES_OVER_NEGATIV_LAST, SIGNAL1_THRES_LOW_NEGATIV_LAST, SIGNAL1_THRES_MDL_NEGATIV_LAST, SIGNAL1_THRES_UP_NEGATIV_LAST);
            }
#endif
        }
    }

    if ((QM_Channel[0] == 2) || (QM_Channel[1] == 2) || (QM_Channel[2] == 2) || (QM_Second_Channel[0] == 2) || (QM_Second_Channel[1] == 2) || (QM_Second_Channel[2] == 2))
    {
        SIGNAL2_MAX = 255;
        SIGNAL2_MIN = 0;

        for (cnt = 0; cnt < 256; cnt++) SIGNAL2_Histo[cnt] = 0;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL2_Histo[SIGNAL2[cnt]]++;

                if (SIGNAL2_MAX > SIGNAL2[cnt]) SIGNAL2_MAX = SIGNAL2[cnt];
                if (SIGNAL2_MIN < SIGNAL2[cnt]) SIGNAL2_MIN = SIGNAL2[cnt];
            }
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL2_Histo[SIGNAL2_SUM_MIN[cnt]]++;
                SIGNAL2_Histo[SIGNAL2_SUM_MAX[cnt]]++;

                if (SIGNAL2_MAX > SIGNAL2_SUM_MIN[cnt]) SIGNAL2_MAX = SIGNAL2_SUM_MIN[cnt];
                if (SIGNAL2_MIN < SIGNAL2_SUM_MAX[cnt]) SIGNAL2_MIN = SIGNAL2_SUM_MAX[cnt];
            }
        }

        if (SIGNAL2_MAX > SIGNAL2_MIN)
        {
            PBuf = SIGNAL2_MAX;
            SIGNAL2_MAX = SIGNAL2_MIN;
            SIGNAL2_MIN = PBuf;
        }

        SIGNAL2_MDL = (SIGNAL2_MIN + SIGNAL2_MAX) >> 1;

        SIGNAL2_TOP = 0;
        SIGNAL2_BASE = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNAL2_MIN + SIGNAL2_MAX) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNAL2_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL2_Histo[cnt];
                SIGNAL2_TOP = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNAL2_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL2_Histo[cnt];
                SIGNAL2_BASE = cnt;
            }
        }

        if (SIGNAL2_TOP > SIGNAL2_BASE)
        {
            PBuf = SIGNAL2_TOP;
            SIGNAL2_TOP = SIGNAL2_BASE;
            SIGNAL2_BASE = PBuf;
        }

        SIGNAL2_THRES_UP  = (short) (SIGNAL2_BASE - (((float) thres_up / 100) * (SIGNAL2_BASE - SIGNAL2_TOP)));
        SIGNAL2_THRES_MDL = (short) (SIGNAL2_BASE - (((float) thres_mdl / 100) * (SIGNAL2_BASE - SIGNAL2_TOP)));
        SIGNAL2_THRES_LOW = (short) (SIGNAL2_BASE - (((float) thres_low / 100) * (SIGNAL2_BASE - SIGNAL2_TOP)));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("2 : tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("2 : THR2L %d THR2M %d THR2U %d \n", SIGNAL2_THRES_LOW, SIGNAL2_THRES_MDL, SIGNAL2_THRES_UP);
            printf("2 : Top %d Base %d \n", SIGNAL2_TOP, SIGNAL2_BASE);
            printf("2 : Min %d Mdl %d Max %d\n", SIGNAL2_MIN, SIGNAL2_MDL, SIGNAL2_MAX);
        }
#endif
        SIGNAL2_THRES_PRE_POSITIV_1 = -1;
        SIGNAL2_THRES_LOW_POSITIV_1 = -1;
        SIGNAL2_THRES_MDL_POSITIV_1 = -1;
        SIGNAL2_THRES_UP_POSITIV_1 = -1;
        SIGNAL2_THRES_OVER_POSITIV_1 = -1;

        SIGNAL2_THRES_PRE_NEGATIV_1 = -1;
        SIGNAL2_THRES_LOW_NEGATIV_1 = -1;
        SIGNAL2_THRES_MDL_NEGATIV_1 = -1;
        SIGNAL2_THRES_UP_NEGATIV_1 = -1;
        SIGNAL2_THRES_OVER_NEGATIV_1 = -1;

        SIGNAL2_THRES_PRE_POSITIV_2 = -1;
        SIGNAL2_THRES_LOW_POSITIV_2 = -1;
        SIGNAL2_THRES_MDL_POSITIV_2 = -1;
        SIGNAL2_THRES_UP_POSITIV_2 = -1;
        SIGNAL2_THRES_OVER_POSITIV_2 = -1;

        SIGNAL2_THRES_PRE_NEGATIV_2 = -1;
        SIGNAL2_THRES_LOW_NEGATIV_2 = -1;
        SIGNAL2_THRES_MDL_NEGATIV_2 = -1;
        SIGNAL2_THRES_UP_NEGATIV_2 = -1;
        SIGNAL2_THRES_OVER_NEGATIV_2 = -1;

        SIGNAL2_THRES_PRE_NEGATIV_LAST = -1;
        SIGNAL2_THRES_LOW_NEGATIV_LAST = -1;
        SIGNAL2_THRES_MDL_NEGATIV_LAST = -1;
        SIGNAL2_THRES_UP_NEGATIV_LAST = -1;
        SIGNAL2_THRES_OVER_NEGATIV_LAST = -1;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL2_THRES_MDL_POSITIV_1 != 1) && (SIGNAL2_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL2_AVG += (SIGNAL2[cnt] - SIGNAL2_THRES_MDL);
                    SIGNAL2_AVG_CNT++;
                }

                if (SIGNAL2_THRES_UP_POSITIV_1 == -1)
                {
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2_THRES_PRE_POSITIV_1 != -1) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_LOW_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_PRE_POSITIV_1 != -1) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_LOW_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL2_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                        SIGNAL2_THRES_LOW_POSITIV_1 = -1;
                    }
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1)) SIGNAL2_THRES_MDL_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1)) SIGNAL2_THRES_MDL_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_MDL_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_1 == -1)) SIGNAL2_THRES_UP_POSITIV_1 = cnt - ixs - 30;
                }
                if (SIGNAL2_THRES_LOW_NEGATIV_1 == -1)
                {
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_UP_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_UP_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL2_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                        SIGNAL2_THRES_UP_NEGATIV_1 = -1;
                    }
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1)) SIGNAL2_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1)) SIGNAL2_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_1 == -1)) SIGNAL2_THRES_LOW_NEGATIV_1 = cnt - ixs - 30;
                }
                if ((SIGNAL2_THRES_UP_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 == -1))
                {
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2_THRES_PRE_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_LOW_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_PRE_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_LOW_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL2_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                        SIGNAL2_THRES_LOW_POSITIV_2 = -1;
                    }
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1)) SIGNAL2_THRES_MDL_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1)) SIGNAL2_THRES_MDL_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_MDL_POSITIV_2 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 == -1)) SIGNAL2_THRES_UP_POSITIV_2 = cnt - ixs - 30;
                }
                if ((SIGNAL2_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 == -1))
                {
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_UP_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_UP_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL2_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                        SIGNAL2_THRES_UP_NEGATIV_2 = -1;
                    }
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1)) SIGNAL2_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1)) SIGNAL2_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL2_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 == -1)) SIGNAL2_THRES_LOW_NEGATIV_2 = cnt - ixs - 30;
                }


                if ((SIGNAL2_THRES_UP_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 != -1))
                {
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL2_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL2_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL2_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL2_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL2_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL2_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 != -1))
                {
                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] < SIGNAL2_THRES_MDL) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_UP) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] < SIGNAL2_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] < SIGNAL2_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL2[cnt] > SIGNAL2_THRES_MDL) && (SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL2[cnt] > SIGNAL2_THRES_LOW) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL2_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL2_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL2_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL2_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL2_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNAL2_THRES_UP_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */
            }

            if (SIGNAL2_THRES_PRE_POSITIV_LAST == -1) SIGNAL2_THRES_PRE_POSITIV_LAST = SIGNAL2_THRES_PRE_POSITIV_2;
            if (SIGNAL2_THRES_LOW_POSITIV_LAST == -1) SIGNAL2_THRES_LOW_POSITIV_LAST = SIGNAL2_THRES_LOW_POSITIV_2;
            if (SIGNAL2_THRES_MDL_POSITIV_LAST == -1) SIGNAL2_THRES_MDL_POSITIV_LAST = SIGNAL2_THRES_MDL_POSITIV_2;
            if (SIGNAL2_THRES_UP_POSITIV_LAST == -1) SIGNAL2_THRES_UP_POSITIV_LAST = SIGNAL2_THRES_UP_POSITIV_2;
            if (SIGNAL2_THRES_OVER_POSITIV_LAST == -1) SIGNAL2_THRES_OVER_POSITIV_LAST = SIGNAL2_THRES_OVER_POSITIV_2;

            if (SIGNAL2_THRES_PRE_NEGATIV_LAST == -1) SIGNAL2_THRES_PRE_NEGATIV_LAST = SIGNAL2_THRES_PRE_NEGATIV_2;
            if (SIGNAL2_THRES_LOW_NEGATIV_LAST == -1) SIGNAL2_THRES_LOW_NEGATIV_LAST = SIGNAL2_THRES_LOW_NEGATIV_2;
            if (SIGNAL2_THRES_MDL_NEGATIV_LAST == -1) SIGNAL2_THRES_MDL_NEGATIV_LAST = SIGNAL2_THRES_MDL_NEGATIV_2;
            if (SIGNAL2_THRES_UP_NEGATIV_LAST == -1) SIGNAL2_THRES_UP_NEGATIV_LAST = SIGNAL2_THRES_UP_NEGATIV_2;
            if (SIGNAL2_THRES_OVER_NEGATIV_LAST == -1) SIGNAL2_THRES_OVER_NEGATIV_LAST = SIGNAL2_THRES_OVER_NEGATIV_2;

#ifdef _Debug_QM_
            if (Debug_Mode)
            {
                printf("2 : ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL2_THRES_PRE_POSITIV_1, SIGNAL2_THRES_LOW_POSITIV_1, SIGNAL2_THRES_MDL_POSITIV_1, SIGNAL2_THRES_UP_POSITIV_1);
                printf("2 : ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_1, SIGNAL2_THRES_LOW_NEGATIV_1, SIGNAL2_THRES_MDL_NEGATIV_1, SIGNAL2_THRES_UP_NEGATIV_1);
                printf("2 : ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL2_THRES_PRE_POSITIV_2, SIGNAL2_THRES_LOW_POSITIV_2, SIGNAL2_THRES_MDL_POSITIV_2, SIGNAL2_THRES_UP_POSITIV_2);
                printf("2 : ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_2, SIGNAL2_THRES_LOW_NEGATIV_2, SIGNAL2_THRES_MDL_NEGATIV_2, SIGNAL2_THRES_UP_NEGATIV_2);
                printf("2 : ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL2_THRES_OVER_POSITIV_LAST, SIGNAL2_THRES_LOW_POSITIV_LAST, SIGNAL2_THRES_MDL_POSITIV_LAST, SIGNAL2_THRES_UP_POSITIV_LAST);
                printf("2 : ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_LAST, SIGNAL2_THRES_LOW_NEGATIV_LAST, SIGNAL2_THRES_MDL_NEGATIV_LAST, SIGNAL2_THRES_UP_NEGATIV_LAST);
            }
#endif
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL2_THRES_MDL_POSITIV_1 != 1) && (SIGNAL2_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL2_AVG += (((SIGNAL2_SUM_MIN[cnt] + SIGNAL2_SUM_MAX[cnt]) >> 1) - SIGNAL2_THRES_MDL);
                    SIGNAL2_AVG_CNT++;
                }

                if (SIGNAL2_THRES_UP_POSITIV_1 == -1)
                {
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_PRE_POSITIV_1 = cnt;
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && (SIGNAL2_THRES_PRE_POSITIV_1 != -1) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_LOW_POSITIV_1 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_PRE_POSITIV_1 != -1) && (SIGNAL2_THRES_LOW_POSITIV_1 == -1)) SIGNAL2_THRES_LOW_POSITIV_1 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL2_THRES_PRE_POSITIV_1 = cnt;
                        SIGNAL2_THRES_LOW_POSITIV_1 = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1)) SIGNAL2_THRES_MDL_POSITIV_1 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_LOW_POSITIV_1 != -1) && (SIGNAL2_THRES_MDL_POSITIV_1 == -1)) SIGNAL2_THRES_MDL_POSITIV_1 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_MDL_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_1 == -1)) SIGNAL2_THRES_UP_POSITIV_1 = cnt;
                }

                else if (SIGNAL2_THRES_LOW_NEGATIV_1 == -1)
                {
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_OVER_NEGATIV_1 = cnt;
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && (SIGNAL2_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_UP_NEGATIV_1 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL2_THRES_UP_NEGATIV_1 == -1)) SIGNAL2_THRES_UP_NEGATIV_1 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL2_THRES_OVER_NEGATIV_1 = cnt;
                        SIGNAL2_THRES_UP_NEGATIV_1 = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1)) SIGNAL2_THRES_MDL_NEGATIV_1 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_UP_NEGATIV_1 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_1 == -1)) SIGNAL2_THRES_MDL_NEGATIV_1 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_1 == -1)) SIGNAL2_THRES_LOW_NEGATIV_1 = cnt;
                }

                else if ((SIGNAL2_THRES_UP_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 == -1))
                {
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_PRE_POSITIV_2 = cnt;
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && (SIGNAL2_THRES_PRE_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_LOW_POSITIV_2 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_PRE_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_POSITIV_2 == -1)) SIGNAL2_THRES_LOW_POSITIV_2 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL2_THRES_PRE_POSITIV_2 = cnt;
                        SIGNAL2_THRES_LOW_POSITIV_2 = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1)) SIGNAL2_THRES_MDL_POSITIV_2 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_LOW_POSITIV_2 != -1) && (SIGNAL2_THRES_MDL_POSITIV_2 == -1)) SIGNAL2_THRES_MDL_POSITIV_2 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_MDL_POSITIV_2 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 == -1)) SIGNAL2_THRES_UP_POSITIV_2 = cnt;
                }

                else if ((SIGNAL2_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 == -1))
                {
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_OVER_NEGATIV_2 = cnt;
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && (SIGNAL2_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_UP_NEGATIV_2 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL2_THRES_UP_NEGATIV_2 == -1)) SIGNAL2_THRES_UP_NEGATIV_2 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL2_THRES_OVER_NEGATIV_2 = cnt;
                        SIGNAL2_THRES_UP_NEGATIV_2 = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1)) SIGNAL2_THRES_MDL_NEGATIV_2 = cnt;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_UP_NEGATIV_2 != -1) && (SIGNAL2_THRES_MDL_NEGATIV_2 == -1)) SIGNAL2_THRES_MDL_NEGATIV_2 = cnt;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL2_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 == -1)) SIGNAL2_THRES_LOW_NEGATIV_2 = cnt;
                }



                if ((SIGNAL2_THRES_UP_POSITIV_1 != -1) && (SIGNAL2_THRES_UP_POSITIV_2 != -1))
                {
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL2_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL2_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL2_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL2_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL2_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL2_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 != -1))
                {
                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_MDL)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_UP)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_UP) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] < SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] < SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_MDL) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_MDL)) && ((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL2_SUM_MIN[cnt] > SIGNAL2_THRES_LOW) || (SIGNAL2_SUM_MAX[cnt] > SIGNAL2_THRES_LOW)) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL2_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL2_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL2_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL2_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL2_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }



                /*
                if ((SIGNAL2_THRES_UP_POSITIV_2 != -1) && (SIGNAL2_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */

            }
#ifdef _Debug_QM_
            if (Debug_Mode)
            {
                printf("2 : ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL2_THRES_PRE_POSITIV_1, SIGNAL2_THRES_LOW_POSITIV_1, SIGNAL2_THRES_MDL_POSITIV_1, SIGNAL2_THRES_UP_POSITIV_1);
                printf("2 : ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_1, SIGNAL2_THRES_LOW_NEGATIV_1, SIGNAL2_THRES_MDL_NEGATIV_1, SIGNAL2_THRES_UP_NEGATIV_1);
                printf("2 : ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL2_THRES_PRE_POSITIV_2, SIGNAL2_THRES_LOW_POSITIV_2, SIGNAL2_THRES_MDL_POSITIV_2, SIGNAL2_THRES_UP_POSITIV_2);
                printf("2 : ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_2, SIGNAL2_THRES_LOW_NEGATIV_2, SIGNAL2_THRES_MDL_NEGATIV_2, SIGNAL2_THRES_UP_NEGATIV_2);
                printf("2 : ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL2_THRES_OVER_POSITIV_LAST, SIGNAL2_THRES_LOW_POSITIV_LAST, SIGNAL2_THRES_MDL_POSITIV_LAST, SIGNAL2_THRES_UP_POSITIV_LAST);
                printf("2 : ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL2_THRES_OVER_NEGATIV_LAST, SIGNAL2_THRES_LOW_NEGATIV_LAST, SIGNAL2_THRES_MDL_NEGATIV_LAST, SIGNAL2_THRES_UP_NEGATIV_LAST);
            }
#endif
        }
    }

    if ((QM_Channel[0] == 3) || (QM_Channel[1] == 3) || (QM_Channel[2] == 3) || (QM_Second_Channel[0] == 3) || (QM_Second_Channel[1] == 3) || (QM_Second_Channel[2] == 3))
    {
        SIGNAL3_MAX = 255;
        SIGNAL3_MIN = 0;

        for (cnt = 0; cnt < 256; cnt++) SIGNAL3_Histo[cnt] = 0;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL3_Histo[SIGNAL3[cnt]]++;

                if (SIGNAL3_MAX > SIGNAL3[cnt]) SIGNAL3_MAX = SIGNAL3[cnt];
                if (SIGNAL3_MIN < SIGNAL3[cnt]) SIGNAL3_MIN = SIGNAL3[cnt];
            }
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL3_Histo[SIGNAL3_SUM_MIN[cnt]]++;
                SIGNAL3_Histo[SIGNAL3_SUM_MAX[cnt]]++;

                if (SIGNAL3_MAX > SIGNAL3_SUM_MIN[cnt]) SIGNAL3_MAX = SIGNAL3_SUM_MIN[cnt];
                if (SIGNAL3_MIN < SIGNAL3_SUM_MAX[cnt]) SIGNAL3_MIN = SIGNAL3_SUM_MAX[cnt];
            }
        }

        if (SIGNAL3_MAX > SIGNAL3_MIN)
        {
            PBuf = SIGNAL3_MAX;
            SIGNAL3_MAX = SIGNAL3_MIN;
            SIGNAL3_MIN = PBuf;
        }

        SIGNAL3_MDL = (SIGNAL3_MIN + SIGNAL3_MAX) >> 1;

        SIGNAL3_TOP = 0;
        SIGNAL3_BASE = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNAL3_MIN + SIGNAL3_MAX) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNAL3_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL3_Histo[cnt];
                SIGNAL3_TOP = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNAL3_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL3_Histo[cnt];
                SIGNAL3_BASE = cnt;
            }
        }

        if (SIGNAL3_TOP > SIGNAL3_BASE)
        {
            PBuf = SIGNAL3_TOP;
            SIGNAL3_TOP = SIGNAL3_BASE;
            SIGNAL3_BASE = PBuf;
        }

        SIGNAL3_THRES_UP  = (short) (SIGNAL3_BASE - (((float) thres_up / 100) * (SIGNAL3_BASE - SIGNAL3_TOP)));
        SIGNAL3_THRES_MDL = (short) (SIGNAL3_BASE - (((float) thres_mdl / 100) * (SIGNAL3_BASE - SIGNAL3_TOP)));
        SIGNAL3_THRES_LOW = (short) (SIGNAL3_BASE - (((float) thres_low / 100) * (SIGNAL3_BASE - SIGNAL3_TOP)));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("THR2L %d THR2M %d THR2U %d \n", SIGNAL3_THRES_LOW, SIGNAL3_THRES_MDL, SIGNAL3_THRES_UP);
            printf("Top %d Base %d \n", SIGNAL3_TOP, SIGNAL3_BASE);
            printf("Min %d Mdl %d Max %d\n", SIGNAL3_MIN, SIGNAL3_MDL, SIGNAL3_MAX);
        }
#endif
        SIGNAL3_THRES_PRE_POSITIV_1 = -1;
        SIGNAL3_THRES_LOW_POSITIV_1 = -1;
        SIGNAL3_THRES_MDL_POSITIV_1 = -1;
        SIGNAL3_THRES_UP_POSITIV_1 = -1;
        SIGNAL3_THRES_OVER_POSITIV_1 = -1;

        SIGNAL3_THRES_PRE_NEGATIV_1 = -1;
        SIGNAL3_THRES_LOW_NEGATIV_1 = -1;
        SIGNAL3_THRES_MDL_NEGATIV_1 = -1;
        SIGNAL3_THRES_UP_NEGATIV_1 = -1;
        SIGNAL3_THRES_OVER_NEGATIV_1 = -1;

        SIGNAL3_THRES_PRE_POSITIV_2 = -1;
        SIGNAL3_THRES_LOW_POSITIV_2 = -1;
        SIGNAL3_THRES_MDL_POSITIV_2 = -1;
        SIGNAL3_THRES_UP_POSITIV_2 = -1;
        SIGNAL3_THRES_OVER_POSITIV_2 = -1;

        SIGNAL3_THRES_PRE_NEGATIV_2 = -1;
        SIGNAL3_THRES_LOW_NEGATIV_2 = -1;
        SIGNAL3_THRES_MDL_NEGATIV_2 = -1;
        SIGNAL3_THRES_UP_NEGATIV_2 = -1;
        SIGNAL3_THRES_OVER_NEGATIV_2 = -1;

        SIGNAL3_THRES_PRE_NEGATIV_LAST = -1;
        SIGNAL3_THRES_LOW_NEGATIV_LAST = -1;
        SIGNAL3_THRES_MDL_NEGATIV_LAST = -1;
        SIGNAL3_THRES_UP_NEGATIV_LAST = -1;
        SIGNAL3_THRES_OVER_NEGATIV_LAST = -1;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL3_THRES_MDL_POSITIV_1 != 1) && (SIGNAL3_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL3_AVG += (SIGNAL3[cnt] - SIGNAL3_THRES_MDL);
                    SIGNAL3_AVG_CNT++;
                }

                if (SIGNAL3_THRES_UP_POSITIV_1 == -1)
                {
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3_THRES_PRE_POSITIV_1 != -1) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_LOW_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_PRE_POSITIV_1 != -1) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_LOW_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL3_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                        SIGNAL3_THRES_LOW_POSITIV_1 = -1;
                    }
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1)) SIGNAL3_THRES_MDL_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1)) SIGNAL3_THRES_MDL_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_MDL_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_1 == -1)) SIGNAL3_THRES_UP_POSITIV_1 = cnt - ixs - 30;
                }
                if (SIGNAL3_THRES_LOW_NEGATIV_1 == -1)
                {
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_UP_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_UP_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL3_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                        SIGNAL3_THRES_UP_NEGATIV_1 = -1;
                    }
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1)) SIGNAL3_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1)) SIGNAL3_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_1 == -1)) SIGNAL3_THRES_LOW_NEGATIV_1 = cnt - ixs - 30;
                }
                if ((SIGNAL3_THRES_UP_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 == -1))
                {
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3_THRES_PRE_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_LOW_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_PRE_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_LOW_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL3_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                        SIGNAL3_THRES_LOW_POSITIV_2 = -1;
                    }
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1)) SIGNAL3_THRES_MDL_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1)) SIGNAL3_THRES_MDL_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_MDL_POSITIV_2 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 == -1)) SIGNAL3_THRES_UP_POSITIV_2 = cnt - ixs - 30;
                }
                if ((SIGNAL3_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 == -1))
                {
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_UP_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_UP_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL3_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                        SIGNAL3_THRES_UP_NEGATIV_2 = -1;
                    }
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1)) SIGNAL3_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1)) SIGNAL3_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL3_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 == -1)) SIGNAL3_THRES_LOW_NEGATIV_2 = cnt - ixs - 30;
                }


                if ((SIGNAL3_THRES_UP_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 != -1))
                {
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL3_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL3_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL3_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL3_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL3_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL3_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 != -1))
                {
                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] < SIGNAL3_THRES_MDL) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_UP) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] < SIGNAL3_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] < SIGNAL3_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL3[cnt] > SIGNAL3_THRES_MDL) && (SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL3[cnt] > SIGNAL3_THRES_LOW) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL3_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL3_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL3_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL3_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL3_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNAL3_THRES_UP_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */
            }

            if (SIGNAL3_THRES_PRE_POSITIV_LAST == -1) SIGNAL3_THRES_PRE_POSITIV_LAST = SIGNAL3_THRES_PRE_POSITIV_2;
            if (SIGNAL3_THRES_LOW_POSITIV_LAST == -1) SIGNAL3_THRES_LOW_POSITIV_LAST = SIGNAL3_THRES_LOW_POSITIV_2;
            if (SIGNAL3_THRES_MDL_POSITIV_LAST == -1) SIGNAL3_THRES_MDL_POSITIV_LAST = SIGNAL3_THRES_MDL_POSITIV_2;
            if (SIGNAL3_THRES_UP_POSITIV_LAST == -1) SIGNAL3_THRES_UP_POSITIV_LAST = SIGNAL3_THRES_UP_POSITIV_2;
            if (SIGNAL3_THRES_OVER_POSITIV_LAST == -1) SIGNAL3_THRES_OVER_POSITIV_LAST = SIGNAL3_THRES_OVER_POSITIV_2;

            if (SIGNAL3_THRES_PRE_NEGATIV_LAST == -1) SIGNAL3_THRES_PRE_NEGATIV_LAST = SIGNAL3_THRES_PRE_NEGATIV_2;
            if (SIGNAL3_THRES_LOW_NEGATIV_LAST == -1) SIGNAL3_THRES_LOW_NEGATIV_LAST = SIGNAL3_THRES_LOW_NEGATIV_2;
            if (SIGNAL3_THRES_MDL_NEGATIV_LAST == -1) SIGNAL3_THRES_MDL_NEGATIV_LAST = SIGNAL3_THRES_MDL_NEGATIV_2;
            if (SIGNAL3_THRES_UP_NEGATIV_LAST == -1) SIGNAL3_THRES_UP_NEGATIV_LAST = SIGNAL3_THRES_UP_NEGATIV_2;
            if (SIGNAL3_THRES_OVER_NEGATIV_LAST == -1) SIGNAL3_THRES_OVER_NEGATIV_LAST = SIGNAL3_THRES_OVER_NEGATIV_2;

#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL3_THRES_PRE_POSITIV_1, SIGNAL3_THRES_LOW_POSITIV_1, SIGNAL3_THRES_MDL_POSITIV_1, SIGNAL3_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL3_THRES_OVER_NEGATIV_1, SIGNAL3_THRES_LOW_NEGATIV_1, SIGNAL3_THRES_MDL_NEGATIV_1, SIGNAL3_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL3_THRES_PRE_POSITIV_2, SIGNAL3_THRES_LOW_POSITIV_2, SIGNAL3_THRES_MDL_POSITIV_2, SIGNAL3_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL3_THRES_OVER_NEGATIV_2, SIGNAL3_THRES_LOW_NEGATIV_2, SIGNAL3_THRES_MDL_NEGATIV_2, SIGNAL3_THRES_UP_NEGATIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL3_THRES_OVER_POSITIV_LAST, SIGNAL3_THRES_LOW_POSITIV_LAST, SIGNAL3_THRES_MDL_POSITIV_LAST, SIGNAL3_THRES_UP_POSITIV_LAST);
            if (Debug_Mode) printf("ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL3_THRES_OVER_NEGATIV_LAST, SIGNAL3_THRES_LOW_NEGATIV_LAST, SIGNAL3_THRES_MDL_NEGATIV_LAST, SIGNAL3_THRES_UP_NEGATIV_LAST);
#endif
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL3_THRES_MDL_POSITIV_1 != 1) && (SIGNAL3_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL3_AVG += (((SIGNAL3_SUM_MIN[cnt] + SIGNAL3_SUM_MAX[cnt]) >> 1) - SIGNAL3_THRES_MDL);
                    SIGNAL3_AVG_CNT++;
                }

                if (SIGNAL3_THRES_UP_POSITIV_1 == -1)
                {
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_PRE_POSITIV_1 = cnt;
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && (SIGNAL3_THRES_PRE_POSITIV_1 != -1) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_LOW_POSITIV_1 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_PRE_POSITIV_1 != -1) && (SIGNAL3_THRES_LOW_POSITIV_1 == -1)) SIGNAL3_THRES_LOW_POSITIV_1 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL3_THRES_PRE_POSITIV_1 = cnt;
                        SIGNAL3_THRES_LOW_POSITIV_1 = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1)) SIGNAL3_THRES_MDL_POSITIV_1 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_LOW_POSITIV_1 != -1) && (SIGNAL3_THRES_MDL_POSITIV_1 == -1)) SIGNAL3_THRES_MDL_POSITIV_1 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_MDL_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_1 == -1)) SIGNAL3_THRES_UP_POSITIV_1 = cnt;
                }

                else if (SIGNAL3_THRES_LOW_NEGATIV_1 == -1)
                {
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_OVER_NEGATIV_1 = cnt;
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && (SIGNAL3_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_UP_NEGATIV_1 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL3_THRES_UP_NEGATIV_1 == -1)) SIGNAL3_THRES_UP_NEGATIV_1 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL3_THRES_OVER_NEGATIV_1 = cnt;
                        SIGNAL3_THRES_UP_NEGATIV_1 = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1)) SIGNAL3_THRES_MDL_NEGATIV_1 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_UP_NEGATIV_1 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_1 == -1)) SIGNAL3_THRES_MDL_NEGATIV_1 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_1 == -1)) SIGNAL3_THRES_LOW_NEGATIV_1 = cnt;
                }

                else if ((SIGNAL3_THRES_UP_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 == -1))
                {
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_PRE_POSITIV_2 = cnt;
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && (SIGNAL3_THRES_PRE_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_LOW_POSITIV_2 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_PRE_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_POSITIV_2 == -1)) SIGNAL3_THRES_LOW_POSITIV_2 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL3_THRES_PRE_POSITIV_2 = cnt;
                        SIGNAL3_THRES_LOW_POSITIV_2 = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1)) SIGNAL3_THRES_MDL_POSITIV_2 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_LOW_POSITIV_2 != -1) && (SIGNAL3_THRES_MDL_POSITIV_2 == -1)) SIGNAL3_THRES_MDL_POSITIV_2 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_MDL_POSITIV_2 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 == -1)) SIGNAL3_THRES_UP_POSITIV_2 = cnt;
                }

                else if ((SIGNAL3_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 == -1))
                {
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_OVER_NEGATIV_2 = cnt;
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && (SIGNAL3_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_UP_NEGATIV_2 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL3_THRES_UP_NEGATIV_2 == -1)) SIGNAL3_THRES_UP_NEGATIV_2 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL3_THRES_OVER_NEGATIV_2 = cnt;
                        SIGNAL3_THRES_UP_NEGATIV_2 = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1)) SIGNAL3_THRES_MDL_NEGATIV_2 = cnt;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_UP_NEGATIV_2 != -1) && (SIGNAL3_THRES_MDL_NEGATIV_2 == -1)) SIGNAL3_THRES_MDL_NEGATIV_2 = cnt;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL3_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 == -1)) SIGNAL3_THRES_LOW_NEGATIV_2 = cnt;
                }



                if ((SIGNAL3_THRES_UP_POSITIV_1 != -1) && (SIGNAL3_THRES_UP_POSITIV_2 != -1))
                {
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL3_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL3_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL3_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL3_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL3_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL3_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 != -1))
                {
                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_MDL)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_UP)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_UP) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] < SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] < SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_MDL) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_MDL)) && ((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL3_SUM_MIN[cnt] > SIGNAL3_THRES_LOW) || (SIGNAL3_SUM_MAX[cnt] > SIGNAL3_THRES_LOW)) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL3_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL3_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL3_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL3_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL3_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }



                /*
                if ((SIGNAL3_THRES_UP_POSITIV_2 != -1) && (SIGNAL3_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */

            }
#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL3_THRES_PRE_POSITIV_1, SIGNAL3_THRES_LOW_POSITIV_1, SIGNAL3_THRES_MDL_POSITIV_1, SIGNAL3_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL3_THRES_OVER_NEGATIV_1, SIGNAL3_THRES_LOW_NEGATIV_1, SIGNAL3_THRES_MDL_NEGATIV_1, SIGNAL3_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL3_THRES_PRE_POSITIV_2, SIGNAL3_THRES_LOW_POSITIV_2, SIGNAL3_THRES_MDL_POSITIV_2, SIGNAL3_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL3_THRES_OVER_NEGATIV_2, SIGNAL3_THRES_LOW_NEGATIV_2, SIGNAL3_THRES_MDL_NEGATIV_2, SIGNAL3_THRES_UP_NEGATIV_2);
#endif
        }
    }

    if ((QM_Channel[0] == 4) || (QM_Channel[1] == 4) || (QM_Channel[2] == 4) || (QM_Second_Channel[0] == 4) || (QM_Second_Channel[1] == 4) || (QM_Second_Channel[2] == 4))
    {
        SIGNAL4_MAX = 255;
        SIGNAL4_MIN = 0;

        for (cnt = 0; cnt < 256; cnt++) SIGNAL4_Histo[cnt] = 0;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL4_Histo[SIGNAL4[cnt]]++;

                if (SIGNAL4_MAX > SIGNAL4[cnt]) SIGNAL4_MAX = SIGNAL4[cnt];
                if (SIGNAL4_MIN < SIGNAL4[cnt]) SIGNAL4_MIN = SIGNAL4[cnt];
            }
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNAL4_Histo[SIGNAL4_SUM_MIN[cnt]]++;
                SIGNAL4_Histo[SIGNAL4_SUM_MAX[cnt]]++;

                if (SIGNAL4_MAX > SIGNAL4_SUM_MIN[cnt]) SIGNAL4_MAX = SIGNAL4_SUM_MIN[cnt];
                if (SIGNAL4_MIN < SIGNAL4_SUM_MAX[cnt]) SIGNAL4_MIN = SIGNAL4_SUM_MAX[cnt];
            }
        }

        if (SIGNAL4_MAX > SIGNAL4_MIN)
        {
            PBuf = SIGNAL4_MAX;
            SIGNAL4_MAX = SIGNAL4_MIN;
            SIGNAL4_MIN = PBuf;
        }

        SIGNAL4_MDL = (SIGNAL4_MIN + SIGNAL4_MAX) >> 1;

        SIGNAL4_TOP = 0;
        SIGNAL4_BASE = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNAL4_MIN + SIGNAL4_MAX) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNAL4_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL4_Histo[cnt];
                SIGNAL4_TOP = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNAL4_Histo[cnt] > PBuf)
            {
                PBuf = SIGNAL4_Histo[cnt];
                SIGNAL4_BASE = cnt;
            }
        }

        if (SIGNAL4_TOP > SIGNAL4_BASE)
        {
            PBuf = SIGNAL4_TOP;
            SIGNAL4_TOP = SIGNAL4_BASE;
            SIGNAL4_BASE = PBuf;
        }

        SIGNAL4_THRES_UP  = (short) (SIGNAL4_BASE - (((float) thres_up / 100) * (SIGNAL4_BASE - SIGNAL4_TOP)));
        SIGNAL4_THRES_MDL = (short) (SIGNAL4_BASE - (((float) thres_mdl / 100) * (SIGNAL4_BASE - SIGNAL4_TOP)));
        SIGNAL4_THRES_LOW = (short) (SIGNAL4_BASE - (((float) thres_low / 100) * (SIGNAL4_BASE - SIGNAL4_TOP)));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("THR2L %d THR2M %d THR2U %d \n", SIGNAL4_THRES_LOW, SIGNAL4_THRES_MDL, SIGNAL4_THRES_UP);
            printf("Top %d Base %d \n", SIGNAL4_TOP, SIGNAL4_BASE);
            printf("Min %d Mdl %d Max %d\n", SIGNAL4_MIN, SIGNAL4_MDL, SIGNAL4_MAX);
        }
#endif
        SIGNAL4_THRES_PRE_POSITIV_1 = -1;
        SIGNAL4_THRES_LOW_POSITIV_1 = -1;
        SIGNAL4_THRES_MDL_POSITIV_1 = -1;
        SIGNAL4_THRES_UP_POSITIV_1 = -1;
        SIGNAL4_THRES_OVER_POSITIV_1 = -1;

        SIGNAL4_THRES_PRE_NEGATIV_1 = -1;
        SIGNAL4_THRES_LOW_NEGATIV_1 = -1;
        SIGNAL4_THRES_MDL_NEGATIV_1 = -1;
        SIGNAL4_THRES_UP_NEGATIV_1 = -1;
        SIGNAL4_THRES_OVER_NEGATIV_1 = -1;

        SIGNAL4_THRES_PRE_POSITIV_2 = -1;
        SIGNAL4_THRES_LOW_POSITIV_2 = -1;
        SIGNAL4_THRES_MDL_POSITIV_2 = -1;
        SIGNAL4_THRES_UP_POSITIV_2 = -1;
        SIGNAL4_THRES_OVER_POSITIV_2 = -1;

        SIGNAL4_THRES_PRE_NEGATIV_2 = -1;
        SIGNAL4_THRES_LOW_NEGATIV_2 = -1;
        SIGNAL4_THRES_MDL_NEGATIV_2 = -1;
        SIGNAL4_THRES_UP_NEGATIV_2 = -1;
        SIGNAL4_THRES_OVER_NEGATIV_2 = -1;

        SIGNAL4_THRES_PRE_NEGATIV_LAST = -1;
        SIGNAL4_THRES_LOW_NEGATIV_LAST = -1;
        SIGNAL4_THRES_MDL_NEGATIV_LAST = -1;
        SIGNAL4_THRES_UP_NEGATIV_LAST = -1;
        SIGNAL4_THRES_OVER_NEGATIV_LAST = -1;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL4_THRES_MDL_POSITIV_1 != 1) && (SIGNAL4_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL4_AVG += (SIGNAL4[cnt] - SIGNAL4_THRES_MDL);
                    SIGNAL4_AVG_CNT++;
                }

                if (SIGNAL4_THRES_UP_POSITIV_1 == -1)
                {
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4_THRES_PRE_POSITIV_1 != -1) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_LOW_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_PRE_POSITIV_1 != -1) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_LOW_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL4_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                        SIGNAL4_THRES_LOW_POSITIV_1 = -1;
                    }
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1)) SIGNAL4_THRES_MDL_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1)) SIGNAL4_THRES_MDL_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_MDL_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_1 == -1)) SIGNAL4_THRES_UP_POSITIV_1 = cnt - ixs - 30;
                }
                if (SIGNAL4_THRES_LOW_NEGATIV_1 == -1)
                {
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_UP_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_UP_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL4_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                        SIGNAL4_THRES_UP_NEGATIV_1 = -1;
                    }
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1)) SIGNAL4_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1)) SIGNAL4_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_1 == -1)) SIGNAL4_THRES_LOW_NEGATIV_1 = cnt - ixs - 30;
                }
                if ((SIGNAL4_THRES_UP_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 == -1))
                {
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4_THRES_PRE_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_LOW_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_PRE_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_LOW_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL4_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                        SIGNAL4_THRES_LOW_POSITIV_2 = -1;
                    }
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1)) SIGNAL4_THRES_MDL_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1)) SIGNAL4_THRES_MDL_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_MDL_POSITIV_2 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 == -1)) SIGNAL4_THRES_UP_POSITIV_2 = cnt - ixs - 30;
                }
                if ((SIGNAL4_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 == -1))
                {
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_UP_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_UP_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL4_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                        SIGNAL4_THRES_UP_NEGATIV_2 = -1;
                    }
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1)) SIGNAL4_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1)) SIGNAL4_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL4_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 == -1)) SIGNAL4_THRES_LOW_NEGATIV_2 = cnt - ixs - 30;
                }


                if ((SIGNAL4_THRES_UP_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 != -1))
                {
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL4_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL4_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL4_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL4_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL4_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL4_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 != -1))
                {
                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] < SIGNAL4_THRES_MDL) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_UP) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] < SIGNAL4_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] < SIGNAL4_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNAL4[cnt] > SIGNAL4_THRES_MDL) && (SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if ((SIGNAL4[cnt] > SIGNAL4_THRES_LOW) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL4_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL4_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL4_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL4_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL4_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNAL4_THRES_UP_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */
            }

            if (SIGNAL4_THRES_PRE_POSITIV_LAST == -1) SIGNAL4_THRES_PRE_POSITIV_LAST = SIGNAL4_THRES_PRE_POSITIV_2;
            if (SIGNAL4_THRES_LOW_POSITIV_LAST == -1) SIGNAL4_THRES_LOW_POSITIV_LAST = SIGNAL4_THRES_LOW_POSITIV_2;
            if (SIGNAL4_THRES_MDL_POSITIV_LAST == -1) SIGNAL4_THRES_MDL_POSITIV_LAST = SIGNAL4_THRES_MDL_POSITIV_2;
            if (SIGNAL4_THRES_UP_POSITIV_LAST == -1) SIGNAL4_THRES_UP_POSITIV_LAST = SIGNAL4_THRES_UP_POSITIV_2;
            if (SIGNAL4_THRES_OVER_POSITIV_LAST == -1) SIGNAL4_THRES_OVER_POSITIV_LAST = SIGNAL4_THRES_OVER_POSITIV_2;

            if (SIGNAL4_THRES_PRE_NEGATIV_LAST == -1) SIGNAL4_THRES_PRE_NEGATIV_LAST = SIGNAL4_THRES_PRE_NEGATIV_2;
            if (SIGNAL4_THRES_LOW_NEGATIV_LAST == -1) SIGNAL4_THRES_LOW_NEGATIV_LAST = SIGNAL4_THRES_LOW_NEGATIV_2;
            if (SIGNAL4_THRES_MDL_NEGATIV_LAST == -1) SIGNAL4_THRES_MDL_NEGATIV_LAST = SIGNAL4_THRES_MDL_NEGATIV_2;
            if (SIGNAL4_THRES_UP_NEGATIV_LAST == -1) SIGNAL4_THRES_UP_NEGATIV_LAST = SIGNAL4_THRES_UP_NEGATIV_2;
            if (SIGNAL4_THRES_OVER_NEGATIV_LAST == -1) SIGNAL4_THRES_OVER_NEGATIV_LAST = SIGNAL4_THRES_OVER_NEGATIV_2;

#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL4_THRES_PRE_POSITIV_1, SIGNAL4_THRES_LOW_POSITIV_1, SIGNAL4_THRES_MDL_POSITIV_1, SIGNAL4_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL4_THRES_OVER_NEGATIV_1, SIGNAL4_THRES_LOW_NEGATIV_1, SIGNAL4_THRES_MDL_NEGATIV_1, SIGNAL4_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL4_THRES_PRE_POSITIV_2, SIGNAL4_THRES_LOW_POSITIV_2, SIGNAL4_THRES_MDL_POSITIV_2, SIGNAL4_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL4_THRES_OVER_NEGATIV_2, SIGNAL4_THRES_LOW_NEGATIV_2, SIGNAL4_THRES_MDL_NEGATIV_2, SIGNAL4_THRES_UP_NEGATIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL4_THRES_OVER_POSITIV_LAST, SIGNAL4_THRES_LOW_POSITIV_LAST, SIGNAL4_THRES_MDL_POSITIV_LAST, SIGNAL4_THRES_UP_POSITIV_LAST);
            if (Debug_Mode) printf("ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL4_THRES_OVER_NEGATIV_LAST, SIGNAL4_THRES_LOW_NEGATIV_LAST, SIGNAL4_THRES_MDL_NEGATIV_LAST, SIGNAL4_THRES_UP_NEGATIV_LAST);
#endif
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNAL4_THRES_MDL_POSITIV_1 != 1) && (SIGNAL4_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNAL4_AVG += (((SIGNAL4_SUM_MIN[cnt] + SIGNAL4_SUM_MAX[cnt]) >> 1) - SIGNAL4_THRES_MDL);
                    SIGNAL4_AVG_CNT++;
                }

                if (SIGNAL4_THRES_UP_POSITIV_1 == -1)
                {
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_PRE_POSITIV_1 = cnt;
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && (SIGNAL4_THRES_PRE_POSITIV_1 != -1) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_LOW_POSITIV_1 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_PRE_POSITIV_1 != -1) && (SIGNAL4_THRES_LOW_POSITIV_1 == -1)) SIGNAL4_THRES_LOW_POSITIV_1 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNAL4_THRES_PRE_POSITIV_1 = cnt;
                        SIGNAL4_THRES_LOW_POSITIV_1 = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1)) SIGNAL4_THRES_MDL_POSITIV_1 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_LOW_POSITIV_1 != -1) && (SIGNAL4_THRES_MDL_POSITIV_1 == -1)) SIGNAL4_THRES_MDL_POSITIV_1 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_MDL_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_1 == -1)) SIGNAL4_THRES_UP_POSITIV_1 = cnt;
                }

                else if (SIGNAL4_THRES_LOW_NEGATIV_1 == -1)
                {
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_OVER_NEGATIV_1 = cnt;
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && (SIGNAL4_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_UP_NEGATIV_1 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_OVER_NEGATIV_1 != -1) && (SIGNAL4_THRES_UP_NEGATIV_1 == -1)) SIGNAL4_THRES_UP_NEGATIV_1 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNAL4_THRES_OVER_NEGATIV_1 = cnt;
                        SIGNAL4_THRES_UP_NEGATIV_1 = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1)) SIGNAL4_THRES_MDL_NEGATIV_1 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_UP_NEGATIV_1 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_1 == -1)) SIGNAL4_THRES_MDL_NEGATIV_1 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_MDL_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_1 == -1)) SIGNAL4_THRES_LOW_NEGATIV_1 = cnt;
                }

                else if ((SIGNAL4_THRES_UP_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 == -1))
                {
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_PRE_POSITIV_2 = cnt;
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && (SIGNAL4_THRES_PRE_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_LOW_POSITIV_2 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_PRE_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_POSITIV_2 == -1)) SIGNAL4_THRES_LOW_POSITIV_2 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNAL4_THRES_PRE_POSITIV_2 = cnt;
                        SIGNAL4_THRES_LOW_POSITIV_2 = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1)) SIGNAL4_THRES_MDL_POSITIV_2 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_LOW_POSITIV_2 != -1) && (SIGNAL4_THRES_MDL_POSITIV_2 == -1)) SIGNAL4_THRES_MDL_POSITIV_2 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_MDL_POSITIV_2 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 == -1)) SIGNAL4_THRES_UP_POSITIV_2 = cnt;
                }

                else if ((SIGNAL4_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 == -1))
                {
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_OVER_NEGATIV_2 = cnt;
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && (SIGNAL4_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_UP_NEGATIV_2 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_OVER_NEGATIV_2 != -1) && (SIGNAL4_THRES_UP_NEGATIV_2 == -1)) SIGNAL4_THRES_UP_NEGATIV_2 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNAL4_THRES_OVER_NEGATIV_2 = cnt;
                        SIGNAL4_THRES_UP_NEGATIV_2 = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1)) SIGNAL4_THRES_MDL_NEGATIV_2 = cnt;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_UP_NEGATIV_2 != -1) && (SIGNAL4_THRES_MDL_NEGATIV_2 == -1)) SIGNAL4_THRES_MDL_NEGATIV_2 = cnt;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL4_THRES_MDL_NEGATIV_2 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 == -1)) SIGNAL4_THRES_LOW_NEGATIV_2 = cnt;
                }



                if ((SIGNAL4_THRES_UP_POSITIV_1 != -1) && (SIGNAL4_THRES_UP_POSITIV_2 != -1))
                {
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNAL4_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL4_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL4_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL4_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL4_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL4_THRES_LOW_NEGATIV_1 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 != -1))
                {
                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_MDL)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_UP)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_UP) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] < SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] < SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_MDL) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_MDL)) && ((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if (((SIGNAL4_SUM_MIN[cnt] > SIGNAL4_THRES_LOW) || (SIGNAL4_SUM_MAX[cnt] > SIGNAL4_THRES_LOW)) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNAL4_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL4_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL4_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL4_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL4_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }



                /*
                if ((SIGNAL4_THRES_UP_POSITIV_2 != -1) && (SIGNAL4_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */

            }
#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL4_THRES_PRE_POSITIV_1, SIGNAL4_THRES_LOW_POSITIV_1, SIGNAL4_THRES_MDL_POSITIV_1, SIGNAL4_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL4_THRES_OVER_NEGATIV_1, SIGNAL4_THRES_LOW_NEGATIV_1, SIGNAL4_THRES_MDL_NEGATIV_1, SIGNAL4_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL4_THRES_PRE_POSITIV_2, SIGNAL4_THRES_LOW_POSITIV_2, SIGNAL4_THRES_MDL_POSITIV_2, SIGNAL4_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL4_THRES_OVER_NEGATIV_2, SIGNAL4_THRES_LOW_NEGATIV_2, SIGNAL4_THRES_MDL_NEGATIV_2, SIGNAL4_THRES_UP_NEGATIV_2);
#endif
        }
    }

    if ((QM_Channel[0] == 5) || (QM_Channel[1] == 5) || (QM_Channel[2] == 5) || (QM_Second_Channel[0] == 5) || (QM_Second_Channel[1] == 5) || (QM_Second_Channel[2] == 5))
    {
        SIGNALM_MAX = 255;
        SIGNALM_MIN = 0;

        for (cnt = 0; cnt < 256; cnt++) SIGNALM_Histo[cnt] = 0;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNALM_Histo[SIGNALM[cnt]]++;

                if (SIGNALM_MAX > SIGNALM[cnt]) SIGNALM_MAX = SIGNALM[cnt];
                if (SIGNALM_MIN < SIGNALM[cnt]) SIGNALM_MIN = SIGNALM[cnt];
            }
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                SIGNALM_Histo[SIGNALM_SUM_MIN[cnt]]++;
                SIGNALM_Histo[SIGNALM_SUM_MAX[cnt]]++;

                if (SIGNALM_MAX > SIGNALM_SUM_MIN[cnt]) SIGNALM_MAX = SIGNALM_SUM_MIN[cnt];
                if (SIGNALM_MIN < SIGNALM_SUM_MAX[cnt]) SIGNALM_MIN = SIGNALM_SUM_MAX[cnt];
            }
        }

        if (SIGNALM_MAX > SIGNALM_MIN)
        {
            PBuf = SIGNALM_MAX;
            SIGNALM_MAX = SIGNALM_MIN;
            SIGNALM_MIN = PBuf;
        }

        SIGNALM_MDL = (SIGNALM_MIN + SIGNALM_MAX) >> 1;

        SIGNALM_TOP = 0;
        SIGNALM_BASE = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNALM_MIN + SIGNALM_MAX) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNALM_Histo[cnt] > PBuf)
            {
                PBuf = SIGNALM_Histo[cnt];
                SIGNALM_TOP = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNALM_Histo[cnt] > PBuf)
            {
                PBuf = SIGNALM_Histo[cnt];
                SIGNALM_BASE = cnt;
            }
        }

        if (SIGNALM_TOP > SIGNALM_BASE)
        {
            PBuf = SIGNALM_TOP;
            SIGNALM_TOP = SIGNALM_BASE;
            SIGNALM_BASE = PBuf;
        }

        SIGNALM_THRES_UP  = (short) (SIGNALM_BASE - (((float) thres_up / 100) * (SIGNALM_BASE - SIGNALM_TOP)));
        SIGNALM_THRES_MDL = (short) (SIGNALM_BASE - (((float) thres_mdl / 100) * (SIGNALM_BASE - SIGNALM_TOP)));
        SIGNALM_THRES_LOW = (short) (SIGNALM_BASE - (((float) thres_low / 100) * (SIGNALM_BASE - SIGNALM_TOP)));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("THR2L %d THR2M %d THR2U %d \n", SIGNALM_THRES_LOW, SIGNALM_THRES_MDL, SIGNALM_THRES_UP);
            printf("Top %d Base %d \n", SIGNALM_TOP, SIGNALM_BASE);
            printf("Min %d Mdl %d Max %d\n", SIGNALM_MIN, SIGNALM_MDL, SIGNALM_MAX);
        }
#endif
        SIGNALM_THRES_PRE_POSITIV_1 = -1;
        SIGNALM_THRES_LOW_POSITIV_1 = -1;
        SIGNALM_THRES_MDL_POSITIV_1 = -1;
        SIGNALM_THRES_UP_POSITIV_1 = -1;
        SIGNALM_THRES_OVER_POSITIV_1 = -1;

        SIGNALM_THRES_PRE_NEGATIV_1 = -1;
        SIGNALM_THRES_LOW_NEGATIV_1 = -1;
        SIGNALM_THRES_MDL_NEGATIV_1 = -1;
        SIGNALM_THRES_UP_NEGATIV_1 = -1;
        SIGNALM_THRES_OVER_NEGATIV_1 = -1;

        SIGNALM_THRES_PRE_POSITIV_2 = -1;
        SIGNALM_THRES_LOW_POSITIV_2 = -1;
        SIGNALM_THRES_MDL_POSITIV_2 = -1;
        SIGNALM_THRES_UP_POSITIV_2 = -1;
        SIGNALM_THRES_OVER_POSITIV_2 = -1;

        SIGNALM_THRES_PRE_NEGATIV_2 = -1;
        SIGNALM_THRES_LOW_NEGATIV_2 = -1;
        SIGNALM_THRES_MDL_NEGATIV_2 = -1;
        SIGNALM_THRES_UP_NEGATIV_2 = -1;
        SIGNALM_THRES_OVER_NEGATIV_2 = -1;

        SIGNALM_THRES_PRE_NEGATIV_LAST = -1;
        SIGNALM_THRES_LOW_NEGATIV_LAST = -1;
        SIGNALM_THRES_MDL_NEGATIV_LAST = -1;
        SIGNALM_THRES_UP_NEGATIV_LAST = -1;
        SIGNALM_THRES_OVER_NEGATIV_LAST = -1;

        if (SIGNALFaktor_idx == 0)
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNALM_THRES_MDL_POSITIV_1 != 1) && (SIGNALM_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNALM_AVG += (SIGNALM[cnt] - SIGNALM_THRES_MDL);
                    SIGNALM_AVG_CNT++;
                }

                if (SIGNALM_THRES_UP_POSITIV_1 == -1)
                {
                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                    if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM_THRES_PRE_POSITIV_1 != -1) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_LOW_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_PRE_POSITIV_1 != -1) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_LOW_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNALM_THRES_PRE_POSITIV_1 = cnt - ixs - 30;
                        SIGNALM_THRES_LOW_POSITIV_1 = -1;
                    }
                    if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1)) SIGNALM_THRES_MDL_POSITIV_1 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1)) SIGNALM_THRES_MDL_POSITIV_1 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_MDL_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_1 == -1)) SIGNALM_THRES_UP_POSITIV_1 = cnt - ixs - 30;
                }
                if (SIGNALM_THRES_LOW_NEGATIV_1 == -1)
                {
                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                    if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM_THRES_OVER_NEGATIV_1 != -1) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_UP_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_OVER_NEGATIV_1 != -1) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_UP_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNALM_THRES_OVER_NEGATIV_1 = cnt - ixs - 30;
                        SIGNALM_THRES_UP_NEGATIV_1 = -1;
                    }
                    if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1)) SIGNALM_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1)) SIGNALM_THRES_MDL_NEGATIV_1 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_MDL_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_1 == -1)) SIGNALM_THRES_LOW_NEGATIV_1 = cnt - ixs - 30;
                }
                if ((SIGNALM_THRES_UP_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_2 == -1))
                {
                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                    if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM_THRES_PRE_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_LOW_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_PRE_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_LOW_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNALM_THRES_PRE_POSITIV_2 = cnt - ixs - 30;
                        SIGNALM_THRES_LOW_POSITIV_2 = -1;
                    }
                    if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1)) SIGNALM_THRES_MDL_POSITIV_2 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1)) SIGNALM_THRES_MDL_POSITIV_2 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_MDL_POSITIV_2 != -1) && (SIGNALM_THRES_UP_POSITIV_2 == -1)) SIGNALM_THRES_UP_POSITIV_2 = cnt - ixs - 30;
                }
                if ((SIGNALM_THRES_LOW_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 == -1))
                {
                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                    if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM_THRES_OVER_NEGATIV_2 != -1) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_UP_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_OVER_NEGATIV_2 != -1) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_UP_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNALM_THRES_OVER_NEGATIV_2 = cnt - ixs - 30;
                        SIGNALM_THRES_UP_NEGATIV_2 = -1;
                    }
                    if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1)) SIGNALM_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1)) SIGNALM_THRES_MDL_NEGATIV_2 = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNALM_THRES_MDL_NEGATIV_2 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 == -1)) SIGNALM_THRES_LOW_NEGATIV_2 = cnt - ixs - 30;
                }


                if ((SIGNALM_THRES_UP_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_2 != -1))
                {
                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNALM_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNALM_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNALM_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNALM_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNALM_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNALM_THRES_LOW_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 != -1))
                {
                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] < SIGNALM_THRES_MDL) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_UP) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if ((SIGNALM[cnt] < SIGNALM_THRES_UP) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] < SIGNALM_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if ((SIGNALM[cnt] > SIGNALM_THRES_MDL) && (SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if ((SIGNALM[cnt] > SIGNALM_THRES_LOW) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNALM_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNALM_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNALM_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNALM_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNALM_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNALM_THRES_UP_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */
            }

            if (SIGNALM_THRES_PRE_POSITIV_LAST == -1) SIGNALM_THRES_PRE_POSITIV_LAST = SIGNALM_THRES_PRE_POSITIV_2;
            if (SIGNALM_THRES_LOW_POSITIV_LAST == -1) SIGNALM_THRES_LOW_POSITIV_LAST = SIGNALM_THRES_LOW_POSITIV_2;
            if (SIGNALM_THRES_MDL_POSITIV_LAST == -1) SIGNALM_THRES_MDL_POSITIV_LAST = SIGNALM_THRES_MDL_POSITIV_2;
            if (SIGNALM_THRES_UP_POSITIV_LAST == -1) SIGNALM_THRES_UP_POSITIV_LAST = SIGNALM_THRES_UP_POSITIV_2;
            if (SIGNALM_THRES_OVER_POSITIV_LAST == -1) SIGNALM_THRES_OVER_POSITIV_LAST = SIGNALM_THRES_OVER_POSITIV_2;

            if (SIGNALM_THRES_PRE_NEGATIV_LAST == -1) SIGNALM_THRES_PRE_NEGATIV_LAST = SIGNALM_THRES_PRE_NEGATIV_2;
            if (SIGNALM_THRES_LOW_NEGATIV_LAST == -1) SIGNALM_THRES_LOW_NEGATIV_LAST = SIGNALM_THRES_LOW_NEGATIV_2;
            if (SIGNALM_THRES_MDL_NEGATIV_LAST == -1) SIGNALM_THRES_MDL_NEGATIV_LAST = SIGNALM_THRES_MDL_NEGATIV_2;
            if (SIGNALM_THRES_UP_NEGATIV_LAST == -1) SIGNALM_THRES_UP_NEGATIV_LAST = SIGNALM_THRES_UP_NEGATIV_2;
            if (SIGNALM_THRES_OVER_NEGATIV_LAST == -1) SIGNALM_THRES_OVER_NEGATIV_LAST = SIGNALM_THRES_OVER_NEGATIV_2;

#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNALM_THRES_PRE_POSITIV_1, SIGNALM_THRES_LOW_POSITIV_1, SIGNALM_THRES_MDL_POSITIV_1, SIGNALM_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNALM_THRES_OVER_NEGATIV_1, SIGNALM_THRES_LOW_NEGATIV_1, SIGNALM_THRES_MDL_NEGATIV_1, SIGNALM_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNALM_THRES_PRE_POSITIV_2, SIGNALM_THRES_LOW_POSITIV_2, SIGNALM_THRES_MDL_POSITIV_2, SIGNALM_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNALM_THRES_OVER_NEGATIV_2, SIGNALM_THRES_LOW_NEGATIV_2, SIGNALM_THRES_MDL_NEGATIV_2, SIGNALM_THRES_UP_NEGATIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNALM_THRES_OVER_POSITIV_LAST, SIGNALM_THRES_LOW_POSITIV_LAST, SIGNALM_THRES_MDL_POSITIV_LAST, SIGNALM_THRES_UP_POSITIV_LAST);
            if (Debug_Mode) printf("ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNALM_THRES_OVER_NEGATIV_LAST, SIGNALM_THRES_LOW_NEGATIV_LAST, SIGNALM_THRES_MDL_NEGATIV_LAST, SIGNALM_THRES_UP_NEGATIV_LAST);
#endif
        }
        else
        {
            for (cnt = ixs; cnt < ixss; cnt++)
            {
                if ((SIGNALM_THRES_MDL_POSITIV_1 != 1) && (SIGNALM_THRES_MDL_POSITIV_LAST != -1))
                {
                    SIGNALM_AVG += (((SIGNALM_SUM_MIN[cnt] + SIGNALM_SUM_MAX[cnt]) >> 1) - SIGNALM_THRES_MDL);
                    SIGNALM_AVG_CNT++;
                }

                if (SIGNALM_THRES_UP_POSITIV_1 == -1)
                {
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_PRE_POSITIV_1 = cnt;
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && (SIGNALM_THRES_PRE_POSITIV_1 != -1) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_LOW_POSITIV_1 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_PRE_POSITIV_1 != -1) && (SIGNALM_THRES_LOW_POSITIV_1 == -1)) SIGNALM_THRES_LOW_POSITIV_1 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1))
                    {
                        SIGNALM_THRES_PRE_POSITIV_1 = cnt;
                        SIGNALM_THRES_LOW_POSITIV_1 = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1)) SIGNALM_THRES_MDL_POSITIV_1 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_LOW_POSITIV_1 != -1) && (SIGNALM_THRES_MDL_POSITIV_1 == -1)) SIGNALM_THRES_MDL_POSITIV_1 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_MDL_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_1 == -1)) SIGNALM_THRES_UP_POSITIV_1 = cnt;
                }

                else if (SIGNALM_THRES_LOW_NEGATIV_1 == -1)
                {
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_OVER_NEGATIV_1 = cnt;
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && (SIGNALM_THRES_OVER_NEGATIV_1 != -1) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_UP_NEGATIV_1 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_OVER_NEGATIV_1 != -1) && (SIGNALM_THRES_UP_NEGATIV_1 == -1)) SIGNALM_THRES_UP_NEGATIV_1 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1))
                    {
                        SIGNALM_THRES_OVER_NEGATIV_1 = cnt;
                        SIGNALM_THRES_UP_NEGATIV_1 = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1)) SIGNALM_THRES_MDL_NEGATIV_1 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_UP_NEGATIV_1 != -1) && (SIGNALM_THRES_MDL_NEGATIV_1 == -1)) SIGNALM_THRES_MDL_NEGATIV_1 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_MDL_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_1 == -1)) SIGNALM_THRES_LOW_NEGATIV_1 = cnt;
                }

                else if ((SIGNALM_THRES_UP_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_2 == -1))
                {
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_PRE_POSITIV_2 = cnt;
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && (SIGNALM_THRES_PRE_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_LOW_POSITIV_2 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_PRE_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_POSITIV_2 == -1)) SIGNALM_THRES_LOW_POSITIV_2 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1))
                    {
                        SIGNALM_THRES_PRE_POSITIV_2 = cnt;
                        SIGNALM_THRES_LOW_POSITIV_2 = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1)) SIGNALM_THRES_MDL_POSITIV_2 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_LOW_POSITIV_2 != -1) && (SIGNALM_THRES_MDL_POSITIV_2 == -1)) SIGNALM_THRES_MDL_POSITIV_2 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_MDL_POSITIV_2 != -1) && (SIGNALM_THRES_UP_POSITIV_2 == -1)) SIGNALM_THRES_UP_POSITIV_2 = cnt;
                }

                else if ((SIGNALM_THRES_LOW_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 == -1))
                {
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_OVER_NEGATIV_2 = cnt;
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && (SIGNALM_THRES_OVER_NEGATIV_2 != -1) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_UP_NEGATIV_2 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_OVER_NEGATIV_2 != -1) && (SIGNALM_THRES_UP_NEGATIV_2 == -1)) SIGNALM_THRES_UP_NEGATIV_2 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1))
                    {
                        SIGNALM_THRES_OVER_NEGATIV_2 = cnt;
                        SIGNALM_THRES_UP_NEGATIV_2 = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1)) SIGNALM_THRES_MDL_NEGATIV_2 = cnt;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_UP_NEGATIV_2 != -1) && (SIGNALM_THRES_MDL_NEGATIV_2 == -1)) SIGNALM_THRES_MDL_NEGATIV_2 = cnt;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNALM_THRES_MDL_NEGATIV_2 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 == -1)) SIGNALM_THRES_LOW_NEGATIV_2 = cnt;
                }
                
                if ((SIGNALM_THRES_UP_POSITIV_1 != -1) && (SIGNALM_THRES_UP_POSITIV_2 != -1))
                {
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt - ixs - 30;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt - ixs - 30;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;
                    else if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt - ixs - 30;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt - ixs - 30;

                        SIGNALM_THRES_PRE_POSITIV_LAST = SIGNAL_THRES_PRE_POSITIV;
                        SIGNALM_THRES_LOW_POSITIV_LAST = SIGNAL_THRES_LOW_POSITIV;
                        SIGNALM_THRES_MDL_POSITIV_LAST = SIGNAL_THRES_MDL_POSITIV;
                        SIGNALM_THRES_UP_POSITIV_LAST = SIGNAL_THRES_UP_POSITIV;
                        SIGNALM_THRES_OVER_POSITIV_LAST = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }

                if ((SIGNALM_THRES_LOW_NEGATIV_1 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 != -1))
                {
                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_MDL)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_UP)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt - ixs - 30;

                    if (((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_UP) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_UP)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt - ixs - 30;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] < SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] < SIGNALM_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;
                    else if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_MDL) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_MDL)) && ((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt - ixs - 30;

                    if (((SIGNALM_SUM_MIN[cnt] > SIGNALM_THRES_LOW) || (SIGNALM_SUM_MAX[cnt] > SIGNALM_THRES_LOW)) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt - ixs - 30;

                        SIGNALM_THRES_PRE_NEGATIV_LAST = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNALM_THRES_LOW_NEGATIV_LAST = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNALM_THRES_MDL_NEGATIV_LAST = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNALM_THRES_UP_NEGATIV_LAST = SIGNAL_THRES_UP_NEGATIV;
                        SIGNALM_THRES_OVER_NEGATIV_LAST = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }



                /*
                if ((SIGNALM_THRES_UP_POSITIV_2 != -1) && (SIGNALM_THRES_LOW_NEGATIV_2 != -1))
                {
                    break;
                } */

            }
#ifdef _Debug_QM_
            if (Debug_Mode) printf("ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNALM_THRES_PRE_POSITIV_1, SIGNALM_THRES_LOW_POSITIV_1, SIGNALM_THRES_MDL_POSITIV_1, SIGNALM_THRES_UP_POSITIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNALM_THRES_OVER_NEGATIV_1, SIGNALM_THRES_LOW_NEGATIV_1, SIGNALM_THRES_MDL_NEGATIV_1, SIGNALM_THRES_UP_NEGATIV_1);
            if (Debug_Mode) printf("ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNALM_THRES_PRE_POSITIV_2, SIGNALM_THRES_LOW_POSITIV_2, SIGNALM_THRES_MDL_POSITIV_2, SIGNALM_THRES_UP_POSITIV_2);
            if (Debug_Mode) printf("ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNALM_THRES_OVER_NEGATIV_2, SIGNALM_THRES_LOW_NEGATIV_2, SIGNALM_THRES_MDL_NEGATIV_2, SIGNALM_THRES_UP_NEGATIV_2);
#endif
        }
    }


    QM_V_A_Buf[0] = 0;
    QM_H_A_Buf[0] = 0;

    if (QM_Type[0] > 0)
    {
        BufVal = Measure(0, (char) QM_Channel[0], (char) QM_Type[0], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot1.Write_Value(BufVal);
        QM_Slot1.Write_Unit(BufUnit);
#ifdef _Debug_QM_
        printf("qm1 val : %f  unit : %s type : %d\n", BufVal, BufUnit, QM_Type[0]);
#endif

        //if (QM_Type[0] != QM_Type_Old[0])
        {
            QM_Slot1.Write_PreText(BufPre);
        }

        QM_Slot1.RenderText();

        QM_Changed[0] = 1;
    }

    if (QM_Type[1] > 0)
    {
        BufVal = Measure(1, (char) QM_Channel[1], (char) QM_Type[1], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot2.Write_Value(BufVal);
        QM_Slot2.Write_Unit(BufUnit);

        //if (QM_Type[1] != QM_Type_Old[1])
        {
            QM_Slot2.Write_PreText(BufPre);
        }

        QM_Slot2.RenderText();

        QM_Changed[1] = 1;
    }

    if (QM_Type[2] > 0)
    {
        BufVal = Measure(2, (char) QM_Channel[2], (char) QM_Type[2], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot3.Write_Value(BufVal);
        QM_Slot3.Write_Unit(BufUnit);

        //if (QM_Type[2] != QM_Type_Old[2])
        {

            QM_Slot3.Write_PreText(BufPre);
        }

        QM_Slot3.RenderText();

        QM_Changed[2] = 1;
    }

    QM_Vertical_Active = QM_V_A_Buf[0];
    QM_Horizontal_Active = QM_H_A_Buf[0];

    Display::DRAW_ALL_CURSOR();
    Display::DRAWQMDATA(0);	

    //rot_int->np_piointerruptmask = 0x01;						
    //key_int->np_piointerruptmask = 0x01;    		
}

float Display::Measure(char nr, char channel, char type, char *pretext, char *unittext, char *returntext, char *qm_vertical_active, char *qm_horizontal_active)
{
    float return_val = 0;
    int ixs, ixss, cnt, zero_buf = 0, off_buf = 0;

    char buf_text[30];

	short s_max = 0;
	short s_mdl = 0;	
	short s_min = 0;
	short s_max_raw = 0;
	short s_mdl_raw = 0;	
	short s_min_raw = 0;	
	short s_top = 0;	
	short s_base = 0;

	short s_avg = 0;
	short s_avg_cnt = 0;    	
	
	short s_sec_mdl = 0;
	short s_sec_mdl_raw = 0;	
	
	short s_thres_up_negativ_1 = 0;
	short s_thres_up_positiv_1 = 0;

	short s_thres_low_negativ_1 = 0;
	short s_thres_low_positiv_1 = 0;

	short s_thres_mdl_negativ_1 = 0;
	short s_thres_mdl_positiv_1 = 0;

	short s_thres_mdl_negativ_2 = 0;
	short s_thres_mdl_positiv_2 = 0;

	short s_thres_mdl_negativ_last = 0;
	short s_thres_mdl_positiv_last = 0;	
    	
	short s_thres_sec_mdl_negativ_1 = 0;
	short s_thres_sec_mdl_positiv_1 = 0;

	short s_thres_sec_mdl_negativ_2 = 0;
	short s_thres_sec_mdl_positiv_2 = 0;	
	
   	
	short P1 = 0;
	short P2 = 0;
	short P3 = 0;
	short PBuf = 0;
	
	// Prpare for delay measurment
    if ((type == 3) || (type == 12))
    {
        switch(QM_Second_Channel[nr])
        {
            case 1 :
            {
                s_thres_sec_mdl_negativ_1 = SIGNAL1_THRES_MDL_NEGATIV_1;
                s_thres_sec_mdl_positiv_1 = SIGNAL1_THRES_MDL_POSITIV_1;
                s_thres_sec_mdl_negativ_2 = SIGNAL1_THRES_MDL_NEGATIV_2;
                s_thres_sec_mdl_positiv_2 = SIGNAL1_THRES_MDL_POSITIV_2;

                s_sec_mdl = (SIGNAL1_MDL << 1) - 64 + off_buf;
                s_sec_mdl_raw = SIGNAL1_MDL;

                break;
            }
            case 2 :
            {
                s_thres_sec_mdl_negativ_1 = SIGNAL2_THRES_MDL_NEGATIV_1;
                s_thres_sec_mdl_positiv_1 = SIGNAL2_THRES_MDL_POSITIV_1;
                s_thres_sec_mdl_negativ_2 = SIGNAL2_THRES_MDL_NEGATIV_2;
                s_thres_sec_mdl_positiv_2 = SIGNAL2_THRES_MDL_POSITIV_2;

                s_sec_mdl = (SIGNAL2_MDL << 1) - 64 + off_buf;
                s_sec_mdl_raw = SIGNAL2_MDL;

                break;
            }
            case 3 :
            {
                s_thres_sec_mdl_negativ_1 = SIGNAL3_THRES_MDL_NEGATIV_1;
                s_thres_sec_mdl_positiv_1 = SIGNAL3_THRES_MDL_POSITIV_1;
                s_thres_sec_mdl_negativ_2 = SIGNAL3_THRES_MDL_NEGATIV_2;
                s_thres_sec_mdl_positiv_2 = SIGNAL3_THRES_MDL_POSITIV_2;

                s_sec_mdl = (SIGNAL3_MDL << 1) - 64 + off_buf;
                s_sec_mdl_raw = SIGNAL3_MDL;

                break;
            }
            case 4 :
            {
                s_thres_sec_mdl_negativ_1 = SIGNAL4_THRES_MDL_NEGATIV_1;
                s_thres_sec_mdl_positiv_1 = SIGNAL4_THRES_MDL_POSITIV_1;
                s_thres_sec_mdl_negativ_2 = SIGNAL4_THRES_MDL_NEGATIV_2;
                s_thres_sec_mdl_positiv_2 = SIGNAL4_THRES_MDL_POSITIV_2;

                s_sec_mdl = (SIGNAL4_MDL << 1) - 64 + off_buf;
                s_sec_mdl_raw = SIGNAL4_MDL;

                break;
            }
            case 5 :
            {
                s_thres_sec_mdl_negativ_1 = SIGNALM_THRES_MDL_NEGATIV_1;
                s_thres_sec_mdl_positiv_1 = SIGNALM_THRES_MDL_POSITIV_1;
                s_thres_sec_mdl_negativ_2 = SIGNALM_THRES_MDL_NEGATIV_2;
                s_thres_sec_mdl_positiv_2 = SIGNALM_THRES_MDL_POSITIV_2;

                s_sec_mdl = (SIGNALM_MDL << 1) - 64 + off_buf;
                s_sec_mdl_raw = SIGNALM_MDL;

                break;
            }
        }
    }	
	
    switch(channel)
    {
        case 1:
        {
            off_buf = CH1_Zero_Offset;	
            zero_buf = ZeroLevelCH1;
            s_max = (SIGNAL1_MAX << 1) - 64 + off_buf;
            s_mdl = (SIGNAL1_MDL << 1) - 64 + off_buf;
            s_min = (SIGNAL1_MIN << 1) - 64 + off_buf;
            s_max_raw = SIGNAL1_MAX;
            s_mdl_raw = SIGNAL1_MDL;
            s_min_raw = SIGNAL1_MIN;
            s_top = (SIGNAL1_TOP << 1) - 64 + off_buf;
            s_base = (SIGNAL1_BASE << 1) - 64 + off_buf;

            s_avg = SIGNAL1_AVG;
            s_avg_cnt = SIGNAL1_AVG_CNT;

            s_thres_up_negativ_1 = SIGNAL1_THRES_UP_NEGATIV_1;
            s_thres_up_positiv_1 = SIGNAL1_THRES_UP_POSITIV_1;

            s_thres_low_negativ_1 = SIGNAL1_THRES_LOW_NEGATIV_1;
            s_thres_low_positiv_1 = SIGNAL1_THRES_LOW_POSITIV_1;

            s_thres_mdl_negativ_1 = SIGNAL1_THRES_MDL_NEGATIV_1;
            s_thres_mdl_positiv_1 = SIGNAL1_THRES_MDL_POSITIV_1;

            s_thres_mdl_negativ_2 = SIGNAL1_THRES_MDL_NEGATIV_2;
            s_thres_mdl_positiv_2 = SIGNAL1_THRES_MDL_POSITIV_2;

            s_thres_mdl_negativ_last = SIGNAL1_THRES_MDL_NEGATIV_LAST;
            s_thres_mdl_positiv_last = SIGNAL1_THRES_MDL_POSITIV_LAST;

            break;
        }
        case 2:
        {
            off_buf = CH2_Zero_Offset;	
            zero_buf = ZeroLevelCH2;
            s_max = (SIGNAL2_MAX << 1) - 64 + off_buf;
            s_mdl = (SIGNAL2_MDL << 1) - 64 + off_buf;
            s_min = (SIGNAL2_MIN << 1) - 64 + off_buf;
            s_max_raw = SIGNAL2_MAX;
            s_mdl_raw = SIGNAL2_MDL;
            s_min_raw = SIGNAL2_MIN;
            s_top = (SIGNAL2_TOP << 1) - 64 + off_buf;
            s_base = (SIGNAL2_BASE << 1) - 64 + off_buf;

            s_avg = SIGNAL2_AVG;
            s_avg_cnt = SIGNAL2_AVG_CNT;

            s_thres_up_negativ_1 = SIGNAL2_THRES_UP_NEGATIV_1;
            s_thres_up_positiv_1 = SIGNAL2_THRES_UP_POSITIV_1;

            s_thres_low_negativ_1 = SIGNAL2_THRES_LOW_NEGATIV_1;
            s_thres_low_positiv_1 = SIGNAL2_THRES_LOW_POSITIV_1;

            s_thres_mdl_negativ_1 = SIGNAL2_THRES_MDL_NEGATIV_1;
            s_thres_mdl_positiv_1 = SIGNAL2_THRES_MDL_POSITIV_1;

            s_thres_mdl_negativ_2 = SIGNAL2_THRES_MDL_NEGATIV_2;
            s_thres_mdl_positiv_2 = SIGNAL2_THRES_MDL_POSITIV_2;

            break;
        }
        case 3:
        {
            off_buf = CH3_Zero_Offset;
            zero_buf = ZeroLevelCH3;
            s_max = (SIGNAL3_MAX << 1) - 64 + off_buf;
            s_mdl = (SIGNAL3_MDL << 1) - 64 + off_buf;
            s_min = (SIGNAL3_MIN << 1) - 64 + off_buf;
            s_max_raw = SIGNAL3_MAX;
            s_mdl_raw = SIGNAL3_MDL;
            s_min_raw = SIGNAL3_MIN;
            s_top = (SIGNAL3_TOP << 1) - 64 + off_buf;
            s_base = (SIGNAL3_BASE << 1) - 64 + off_buf;

            s_avg = SIGNAL3_AVG;
            s_avg_cnt = SIGNAL3_AVG_CNT;

            s_thres_up_negativ_1 = SIGNAL3_THRES_UP_NEGATIV_1;
            s_thres_up_positiv_1 = SIGNAL3_THRES_UP_POSITIV_1;

            s_thres_low_negativ_1 = SIGNAL3_THRES_LOW_NEGATIV_1;
            s_thres_low_positiv_1 = SIGNAL3_THRES_LOW_POSITIV_1;

            s_thres_mdl_negativ_1 = SIGNAL3_THRES_MDL_NEGATIV_1;
            s_thres_mdl_positiv_1 = SIGNAL3_THRES_MDL_POSITIV_1;

            s_thres_mdl_negativ_2 = SIGNAL3_THRES_MDL_NEGATIV_2;
            s_thres_mdl_positiv_2 = SIGNAL3_THRES_MDL_POSITIV_2;

            break;
        }
        case 4:
        {
            off_buf = CH4_Zero_Offset;
            zero_buf = ZeroLevelCH4;
            s_max = (SIGNAL4_MAX << 1) - 64 + off_buf;
            s_mdl = (SIGNAL4_MDL << 1) - 64 + off_buf;
            s_min = (SIGNAL4_MIN << 1) - 64 + off_buf;
            s_max_raw = SIGNAL4_MAX;
            s_mdl_raw = SIGNAL4_MDL;
            s_min_raw = SIGNAL4_MIN;
            s_top = (SIGNAL4_TOP << 1) - 64 + off_buf;
            s_base = (SIGNAL4_BASE << 1) - 64 + off_buf;

            s_avg = SIGNAL4_AVG;
            s_avg_cnt = SIGNAL4_AVG_CNT;

            s_thres_up_negativ_1 = SIGNAL4_THRES_UP_NEGATIV_1;
            s_thres_up_positiv_1 = SIGNAL4_THRES_UP_POSITIV_1;

            s_thres_low_negativ_1 = SIGNAL4_THRES_LOW_NEGATIV_1;
            s_thres_low_positiv_1 = SIGNAL4_THRES_LOW_POSITIV_1;

            s_thres_mdl_negativ_1 = SIGNAL4_THRES_MDL_NEGATIV_1;
            s_thres_mdl_positiv_1 = SIGNAL4_THRES_MDL_POSITIV_1;

            s_thres_mdl_negativ_2 = SIGNAL4_THRES_MDL_NEGATIV_2;
            s_thres_mdl_positiv_2 = SIGNAL4_THRES_MDL_POSITIV_2;

            break;
        }
        case 5:
        {
            off_buf = 0;
            zero_buf = 128;
            s_max = (SIGNALM_MAX << 1) - 64 + off_buf;
            s_mdl = (SIGNALM_MDL << 1) - 64 + off_buf;
            s_min = (SIGNALM_MIN << 1) - 64 + off_buf;
            s_max_raw = SIGNALM_MAX;
            s_mdl_raw = SIGNALM_MDL;
            s_min_raw = SIGNALM_MIN;
            s_top = (SIGNALM_TOP << 1) - 64 + off_buf;
            s_base = (SIGNALM_BASE << 1) - 64 + off_buf;

            s_avg = SIGNALM_AVG;
            s_avg_cnt = SIGNALM_AVG_CNT;

            s_thres_up_negativ_1 = SIGNALM_THRES_UP_NEGATIV_1;
            s_thres_up_positiv_1 = SIGNALM_THRES_UP_POSITIV_1;

            s_thres_low_negativ_1 = SIGNALM_THRES_LOW_NEGATIV_1;
            s_thres_low_positiv_1 = SIGNALM_THRES_LOW_POSITIV_1;

            s_thres_mdl_negativ_1 = SIGNALM_THRES_MDL_NEGATIV_1;
            s_thres_mdl_positiv_1 = SIGNALM_THRES_MDL_POSITIV_1;

            s_thres_mdl_negativ_2 = SIGNALM_THRES_MDL_NEGATIV_2;
            s_thres_mdl_positiv_2 = SIGNALM_THRES_MDL_POSITIV_2;

            break;
        }
    }


    switch(type)
    {
        case 1:    // Average
        {
            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_mdl_negativ_last;

            QM_Horizontal_Position_Real1 = int (float (s_avg) / float (s_avg_cnt)) + s_mdl;

            //return_val = MEASUREVOLTAGE(channel, (int) (zero_buf - QM_Horizontal_Position_Real1), unittext);
            return_val = MEASUREVOLTAGE(channel, (int) (zero_buf - QM_Horizontal_Position_Real1));
            sprintf(unittext, "V");

            qm_horizontal_active[0] = 5;
            qm_vertical_active[0] = 3;

            switch(channel)
            {
                case 1 : sprintf(pretext, "Average [ = "); break;
                case 2 : sprintf(pretext, "Average \\ = "); break;
                case 3 : sprintf(pretext, "Average ] = "); break;
                case 4 : sprintf(pretext, "Average ^ = "); break;
                case 5 : sprintf(pretext, "Average (M) = "); break;
            }

            break;
        }
        case 2:  // Delay - Done
        {
            QM_Horizontal_Position_Real1 = s_mdl;
            QM_Horizontal_Position_Real2 = s_sec_mdl;

            if ((QM_CHI_Edge[nr] == 1) && (QM_CHII_Edge[nr] == 1))
            {
                QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
                QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;
            }
            else if ((QM_CHI_Edge[nr] == 1) && (QM_CHII_Edge[nr] == 2))
            {
                QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
                QM_Vertical_Position_Real2 = s_thres_sec_mdl_negativ_1;
            }
            else if ((QM_CHI_Edge[nr] == 2) && (QM_CHII_Edge[nr] == 1))
            {
                QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
                QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;
            }
            else if ((QM_CHI_Edge[nr] == 2) && (QM_CHII_Edge[nr] == 2))
            {
                QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
                QM_Vertical_Position_Real2 = s_thres_sec_mdl_negativ_1;
            }

            //return_val = MEASURETIME(1, (int) (QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1), unittext);
            return_val = MEASURETIME(1, (int) (QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1));
            sprintf(unittext, "s");

            qm_horizontal_active[0] = 3;
            qm_vertical_active[0] = 3;

            switch(channel)
            {
                case 1 : sprintf(pretext, "Delay [ = "); break;
                case 2 : sprintf(pretext, "Delay \\ = "); break;
                case 3 : sprintf(pretext, "Delay ] = "); break;
                case 4 : sprintf(pretext, "Delay ^ = "); break;
                case 5 : sprintf(pretext, "Delay (M) = "); break;
            }

            break;
        }
        case 3:  // Duty Cycle - Done
        {

            QM_Horizontal_Position_Real1 = s_mdl;

            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;

            qm_horizontal_active[0] = 5;
            qm_vertical_active[0] = 3;

            if (s_thres_mdl_negativ_1 > s_thres_mdl_positiv_1) return_val = (100 / (float (s_thres_mdl_positiv_2) - float (s_thres_mdl_positiv_1))) * (float (s_thres_mdl_negativ_1) - float (s_thres_mdl_positiv_1));
            else return_val = (100 / (float (s_thres_mdl_positiv_2) - float (s_thres_mdl_positiv_1))) * (float (s_thres_mdl_negativ_2) - float (s_thres_mdl_positiv_1));

            sprintf(unittext, "%%");

            switch(channel)
            {
                case 1 : sprintf(pretext, "DutyCycle [ = "); break;
                case 2 : sprintf(pretext, "DutyCycle \\ = "); break;
                case 3 : sprintf(pretext, "DutyCycle ] = "); break;
                case 4 : sprintf(pretext, "DutyCycle ^ = "); break;
                case 5 : sprintf(pretext, "DutyCycle (M) = "); break;
            }

            break;
        }
        case 4:  // Fall Time - Done
        {
            QM_Vertical_Position_Real1 = s_thres_up_negativ_1;
            QM_Vertical_Position_Real2 = s_thres_low_negativ_1;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(1, (int) abs(s_thres_low_negativ_1 - s_thres_up_negativ_1), unittext);
            return_val = MEASURETIME(1, (int) abs(s_thres_low_negativ_1 - s_thres_up_negativ_1));
            sprintf(unittext, "s");

            switch(channel)
            {
                case 1 : sprintf(pretext, "FallTime [ = "); break;
                case 2 : sprintf(pretext, "FallTime \\ = "); break;
                case 3 : sprintf(pretext, "FallTime ] = "); break;
                case 4 : sprintf(pretext, "FallTime ^ = "); break;
                case 5 : sprintf(pretext, "FallTime (M) = "); break;
            }

            break;
        }
        case 5:  // Frequency - Done
        {
            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(2, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1), unittext);
            return_val = MEASURETIME(2, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1));
            sprintf(unittext, "Hz");

            sprintf(buf_text, "%f", return_val);

            if (buf_text[0] == 'I') return_val = 0.0;

            switch(channel)
            {
                case 1 : sprintf(pretext, "Freq [ = "); break;
                case 2 : sprintf(pretext, "Freq \\ = "); break;
                case 3 : sprintf(pretext, "Freq ] = "); break;
                case 4 : sprintf(pretext, "Freq ^ = "); break;
                case 5 : sprintf(pretext, "Freq (M) = "); break;
            }

            break;
        }
        case 6:   // Maximum - Done
        {
            QM_Horizontal_Position_Real1 = s_max;
            QM_Horizontal_Position_Real2 = s_min;

            qm_horizontal_active[0] = 5;
            qm_vertical_active[0] = 0;

            //return_val = MEASUREVOLTAGE(channel, (int) abs(s_max - zero_buf), unittext);
            return_val = MEASUREVOLTAGE(channel, (int) abs(s_max - zero_buf));

            sprintf(unittext, "V");

            if (s_max > zero_buf) return_val = 0 - return_val;         // Verbesserbar. - Werte direkt verarbeiten

            switch(channel)
            {
                case 1 : sprintf(pretext, "Max [ = "); break;
                case 2 : sprintf(pretext, "Max \\ = "); break;
                case 3 : sprintf(pretext, "Max ] = "); break;
                case 4 : sprintf(pretext, "Max ^ = "); break;
                case 5 : sprintf(pretext, "Max (M) = "); break;
            }
            break;
        }
        case 7:  // Minimum - Done
        {
            QM_Horizontal_Position_Real1 = s_max;
            QM_Horizontal_Position_Real2 = s_min;

            qm_horizontal_active[0] = 6;
            qm_vertical_active[0] = 0;

            //return_val = MEASUREVOLTAGE(channel, (int) abs(s_min - zero_buf), unittext);
            return_val = MEASUREVOLTAGE(channel, (int) abs(s_min - zero_buf));

            sprintf(unittext, "V");

            if (s_min > zero_buf) return_val = 0 - return_val;          // Verbesserbar. - Werte direkt verarbeiten

            switch(channel)
            {
                case 1 : sprintf(pretext, "Min [ = "); break;
                case 2 : sprintf(pretext, "Min \\ = "); break;
                case 3 : sprintf(pretext, "Min ] = "); break;
                case 4 : sprintf(pretext, "Min ^ = "); break;
                case 5 : sprintf(pretext, "Min (M) = "); break;
            }

            break;
        }
        case 8:   // Peak-Peak - Done
        {
            QM_Horizontal_Position_Real1 = s_max;
            QM_Horizontal_Position_Real2 = s_min;

            qm_horizontal_active[0] = 3;
            qm_vertical_active[0] = 0;

            //return_val = MEASUREVOLTAGE(channel, (int) (s_min - s_max), unittext);
            return_val = MEASUREVOLTAGE(channel, (int) (s_min - s_max));
            sprintf(unittext, "V");

            switch(channel)
            {
                case 1 : sprintf(pretext, "Pk-Pk [ = "); break;
                case 2 : sprintf(pretext, "Pk-Pk \\ = "); break;
                case 3 : sprintf(pretext, "Pk-Pk ] = "); break;
                case 4 : sprintf(pretext, "Pk-Pk ^ = "); break;
                case 5 : sprintf(pretext, "Pk-Pk (M) = "); break;
            }

            break;
        }
        case 9:   // Period - Done
        {
            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(1, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1), unittext);
            return_val = MEASURETIME(1, (int) abs(s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1));
            sprintf(unittext, "s");

            switch(channel)
            {
                case 1 : sprintf(pretext, "Period [ = "); break;
                case 2 : sprintf(pretext, "Period \\ = "); break;
                case 3 : sprintf(pretext, "Period ] = "); break;
                case 4 : sprintf(pretext, "Period ^ = "); break;
                case 5 : sprintf(pretext, "Period (M) = "); break;
            }

            break;
        }
        case 10:  // Phase - Done
        {
            QM_Horizontal_Position_Real1 = s_mdl;
            QM_Horizontal_Position_Real2 = s_sec_mdl;

            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_sec_mdl_positiv_1;

            return_val = ((float) (s_thres_sec_mdl_positiv_1 - s_thres_mdl_positiv_1) / (float) (s_thres_mdl_positiv_2 - s_thres_mdl_positiv_1)) * 360;

            qm_horizontal_active[0] = 3;
            qm_vertical_active[0] = 3;

            sprintf(unittext, "Deg");

            switch(channel)
            {
                case 1 : sprintf(pretext, "Phase [ = "); break;
                case 2 : sprintf(pretext, "Phase \\ = "); break;
                case 3 : sprintf(pretext, "Phase ] = "); break;
                case 4 : sprintf(pretext, "Phase ^ = "); break;
                case 5 : sprintf(pretext, "Phase (M) = "); break;
            }

            break;
        }
        case 11:  // Rise Time - Done
        {
            QM_Vertical_Position_Real1 = s_thres_low_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_up_positiv_1;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(1, (int) abs(s_thres_up_positiv_1 - s_thres_low_positiv_1), unittext);
            return_val = MEASURETIME(1, (int) abs(s_thres_up_positiv_1 - s_thres_low_positiv_1));
            sprintf(unittext, "s");

            switch(channel)
            {
                case 1 : sprintf(pretext, "RiseTime [ = "); break;
                case 2 : sprintf(pretext, "RiseTime \\ = "); break;
                case 3 : sprintf(pretext, "RiseTime ] = "); break;
                case 4 : sprintf(pretext, "RiseTime ^ = "); break;
                case 5 : sprintf(pretext, "RiseTime (M) = "); break;
            }

            break;
        }
        case 12:  // RMS
        {
            ///QM_Horizontal_Position_Real1 = zero_buf - (int (float (zero_buf - s_max) / 1.414));
            QM_Horizontal_Position_Real1 = (int (float (zero_buf - s_max) / 1.414));

            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            QM_Vertical_Position_Real2 = s_thres_mdl_positiv_last;

            qm_horizontal_active[0] = 5;
            qm_vertical_active[0] = 3;

            //return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1 - zero_buf), unittext);
            ///return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1 - zero_buf));
            return_val = MEASUREVOLTAGE(channel, (int) abs(QM_Horizontal_Position_Real1));
            sprintf(unittext, "V");

            if (QM_Horizontal_Position_Real1 > zero_buf) return_val = 0 - return_val;         // Verbesserbar. - Werte direkt verarbeiten

            switch(channel)
            {
                case 1 : sprintf(pretext, "RMS [ = "); break;
                case 2 : sprintf(pretext, "RMS \\ = "); break;
                case 3 : sprintf(pretext, "RMS ] = "); break;
                case 4 : sprintf(pretext, "RMS ^ = "); break;
                case 5 : sprintf(pretext, "RMS (M) = "); break;
            }

            break;
        }
        case 13:  // + Width - Done
        {
            QM_Vertical_Position_Real1 = s_thres_mdl_positiv_1;
            if (s_thres_mdl_positiv_1 < s_thres_mdl_negativ_1) QM_Vertical_Position_Real2 = s_thres_mdl_negativ_1;
            else QM_Vertical_Position_Real2 = s_thres_mdl_negativ_2;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - s_thres_mdl_positiv_1), unittext);
            return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - s_thres_mdl_positiv_1));
            sprintf(unittext, "s");

            switch(channel)
            {
                case 1 : sprintf(pretext, "+Width [ = "); break;
                case 2 : sprintf(pretext, "+Width \\ = "); break;
                case 3 : sprintf(pretext, "+Width ] = "); break;
                case 4 : sprintf(pretext, "+Width ^ = "); break;
                case 5 : sprintf(pretext, "+Width (M) = "); break;
            }

            break;
        }
        case 14:  // - Width - Done
        {
            QM_Vertical_Position_Real1 = s_thres_mdl_negativ_1;
            if (s_thres_mdl_negativ_1 < s_thres_mdl_positiv_1) QM_Vertical_Position_Real2 = s_thres_mdl_positiv_1;
            else QM_Vertical_Position_Real2 = s_thres_mdl_positiv_2;

            qm_horizontal_active[0] = 0;
            qm_vertical_active[0] = 3;

            //return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1), unittext);
            return_val = MEASURETIME(1, (int) abs(QM_Vertical_Position_Real2 - QM_Vertical_Position_Real1));
            sprintf(unittext, "s");

            switch(channel)
            {
                case 1 : sprintf(pretext, "-Width [ = "); break;
                case 2 : sprintf(pretext, "-Width \\ = "); break;
                case 3 : sprintf(pretext, "-Width ] = "); break;
                case 4 : sprintf(pretext, "-Width ^ = "); break;
                case 5 : sprintf(pretext, "-Width (M) = "); break;
            }
            break;
        }
    }
    return return_val;
}

//float Display::MEASUREVOLTAGE(char channel, int points, char *UnitString)				// Calculate the Voltage String
float Display::MEASUREVOLTAGE(char channel, int points)				// Calculate the Voltage String
{
	short *fprobe = 0;
	short *funits = 0;	
	volatile char *fselected_voltage = 0;	
	
	char dim = 2;
	
	int cmpvar = 0;
	
	float sfactor = 0;
	float ffactor = 0;	
	float result = 0;	
	
	float floattempad;
	int inttempbd;
	int inttempad;
			
	int xe;
	
	switch (channel)
	{
		case 1:
		{
			fprobe = &MenuStatus[1][3];
			fselected_voltage = &Selected_Voltage_CH1;
			break;
		}	
		case 2:
		{
			fprobe = &MenuStatus[2][3];
			fselected_voltage = &Selected_Voltage_CH2;
			break;
		}
		case 3:
		{
			fprobe = &MenuStatus[3][3];
			fselected_voltage = &Selected_Voltage_CH3;
			break;
		}
		case 4:
		{
			fprobe = &MenuStatus[4][3];
			fselected_voltage = &Selected_Voltage_CH4;
			break;
		}		
		case 5:
		{
            // Sollange noch kein multiplizieren Channel 1 dominant
			fprobe = (short *) 104;
			if (MenuStatus[26][2] == 1) fselected_voltage = (volatile char *) math_mul_scale - 166;
			if (MenuStatus[26][3] == 1) fselected_voltage = (volatile char *) math_sub_scale - 150;//153;
			if (MenuStatus[26][4] == 1) fselected_voltage = (volatile char *) math_add_scale - 150;//153;			
			break;
		}		
	}

	switch ((int) *fselected_voltage)
	{
		case 0:
		{
			sfactor = 0.001;
			break;
		}
		case 1:
		{
			sfactor = 0.002;
			break;
		}
		case 2:
		{
			sfactor = 0.005;
			break;
		}
		case 3:
		{
			sfactor = 0.01;
			break;
		}
		case 4:
		{
			sfactor = 0.02;
			break;
		}
		case 5:
		{
			sfactor = 0.05;
			break;
		}
		case 6:
		{
			sfactor = 0.1;
			break;
		}
		case 7:
		{
			sfactor = 0.2;
			break;
		}
		case 8:
		{
			sfactor = 0.5;
			break;
		}
		case 9:
		{
			sfactor = 1;
			break;
		}
		case 10:
		{
			sfactor = 2;
			break;
		}
		case 11:
		{
			sfactor = 5;
			break;
		}	             		
		case 12:
		{
			sfactor = 10;
			break;
		}
		case 13:
		{
			sfactor = 20;
			break;
		}
		case 14:
		{
			sfactor = 50;
			break;
		}
		case 15:
		{
			sfactor = 100;
			break;
		}                        		
	}
	
	switch ((int) *fprobe)
	{
		case 101:
		{
			ffactor = 0.1;
			break;
		}
		case 102:
		{
			ffactor = 0.2;
			break;
		}
		case 103:
		{
			ffactor = 0.5;
			break;
		}
		case 104:
		{
			ffactor = 1;
			break;
		}
		case 105:
		{
			ffactor = 2;
			break;
		}
		case 106:
		{
			ffactor = 5;
			break;
		}
		case 107:
		{
			ffactor = 10;
			break;
		}
		case 108:
		{
			ffactor = 20;
			break;
		}
		case 109:
		{
			ffactor = 50;
			break;
		}
		case 110:
		{
			ffactor = 100;
			break;
		}
		case 111:
		{
			ffactor = 200;
			break;
		}
		case 112:
		{
			ffactor = 500;
			break;
		}
		case 113:
		{
			ffactor = 1000;
			break;
		}
	}

	result = ((sfactor * ffactor) / 48) * points;	
	/*	
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result > 999)
	{
		result = result / 1000;
		dim++;
	}
	
	switch(dim)
	{
	   case 0 : sprintf(UnitString, "&V"); break;
	   case 1 : sprintf(UnitString, "mV"); break;
	   case 2 : sprintf(UnitString, "V"); break;
	   case 3 : sprintf(UnitString, "kV"); break;
    }
    */
    //sprintf(UnitString, "V");

#ifdef _Debug_QM_
    printf("MV dim %d  %s\n", dim, UnitString);
#endif

    return result;	
}

//float Display::MEASURETIME(char sec_hz, int points, char *UnitString)
float Display::MEASURETIME(char sec_hz, int points)
{
	int time = 0;
	
	float tfactor = 0;
	float timeoff = 0;

	char dim = 3;
		
	switch(Display_Timebase)
	{
		case  0: tfactor = 0.00004; break;		//   2 	ns
		case  1: tfactor = 0.0001; break;		//   5 	ns
		case  2: tfactor = 0.0002; break;		//  10 	ns
		case  3: tfactor = 0.0004; break;		//  20 	ns
		case  4: tfactor = 0.001; break;		//  50 	ns
		case  5: tfactor = 0.002; break;		// 100 	ns
		case  6: tfactor = 0.004; break;		// 200 	ns
		case  7: tfactor = 0.01; break;			// 500 	ns		
		case  8: tfactor = 0.02; break;			//   1 	s
		case  9: tfactor = 0.04; break;			//   2 	s
		case 10: tfactor = 0.1; break;			//   5 	s
		case 11: tfactor = 0.2; break;			//  10 	s
		case 12: tfactor = 0.4; break;			//  20 	s
		case 13: tfactor = 1; break;			//  50 	ns
		case 14: tfactor = 2; break;			// 100 	s
		case 15: tfactor = 4; break;			// 200 	s
		case 16: tfactor = 10; break;			// 500 	s
		case 17: tfactor = 20; break;			//   1 	ms
		case 18: tfactor = 40; break;			//   2 	ms
		case 19: tfactor = 100; break;			//   5 	ms
		case 20: tfactor = 200; break;			//  10 	ms
		case 21: tfactor = 400; break;			//  20 	ms
		case 22: tfactor = 1000; break;			//  50 	ms
		case 23: tfactor = 2000; break;			// 100 	ms
		case 24: tfactor = 4000; break;			// 200 	ms
		case 25: tfactor = 10000; break;		// 500 	ms
		case 26: tfactor = 20000; break;		//   1 	s
		case 27: tfactor = 40000; break;		//   2 	s
		case 28: tfactor = 100000; break;		//   5 	s
		case 29: tfactor = 200000; break;		//  10 	s
		case 30: tfactor = 400000; break;		//  20 	s
		case 31: tfactor = 1000000; break;		//  50 	s
	}
		
	tfactor = tfactor / 1000000;
	
	//tfactor = tfactor / 1000000 / ZFT_float;
	
	timeoff = (float)(points) * tfactor;
	
	if (sec_hz == 1)
	{   /*
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        if (timeoff < 1)
        {
            timeoff = timeoff * 1000;
            dim--;
        }
        	
        switch(dim)
        {
            case 0 : sprintf(UnitString, "ns"); break;
            case 1 : sprintf(UnitString, "&s"); break;
            case 2 : sprintf(UnitString, "ms"); break;
            case 3 : sprintf(UnitString, "s"); break;
        }	
        */
        //sprintf(UnitString, "s");

#ifdef _Debug_QM_
        printf("MT1 dim %d  %s\n", dim, UnitString);
#endif
    }
    else
	{
        timeoff = 1 / timeoff;
         /*
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }
        if (timeoff > 999.99999)
        {
            timeoff = timeoff / 1000;
            dim--;
        }	
	    */    /*
        switch(dim)
        {
            case 0 : sprintf(UnitString, "GHz"); break;
            case 1 : sprintf(UnitString, "MHz"); break;
            case 2 : sprintf(UnitString, "kHz"); break;
            case 3 : sprintf(UnitString, "Hz"); break;
        }   */
        //sprintf(UnitString, "Hz");

#ifdef _Debug_QM_
        printf("MT2 dim %d  %s\n", dim, UnitString);	
#endif
    }

    return timeoff;
}

void Display::CALCTRIGGER(void)
{
	int volt = 0;		
	int voltmfactor = 0;
	
	int tpos = 0;
	double vfactor = 0;	
	double vfactor2 = 0;	
	float voltoff = 0;
			
	switch(Selected_Trigger_Source)
	{
		case 1:
		{				
			volt = Selected_Voltage_CH1;
			voltmfactor = MenuStatus[1][3];
			tpos = ZeroLevelCH1 - Trigger_Pos_CH1;
			break;
		}
		case 2:
		{				
			volt = Selected_Voltage_CH2;
			voltmfactor = MenuStatus[2][3];
			tpos = ZeroLevelCH2 - Trigger_Pos_CH2;
			break;
		}
		case 3:
		{				
			volt = Selected_Voltage_CH3;
			voltmfactor = MenuStatus[3][3];
			tpos = ZeroLevelCH3 - Trigger_Pos_CH3;
			break;
		}
		case 4:
		{				
			volt = Selected_Voltage_CH4;
			voltmfactor = MenuStatus[4][3];
			tpos = ZeroLevelCH4 - Trigger_Pos_CH4;
			break;
		}
		case 5:
		{				
			volt = 7;
			voltmfactor = MenuStatus[12][4];
			tpos = Trigger_Pos_CHE - 15;
			break;
		}		
	}
	
	
	if (Selected_Trigger_Source == 5)
	{		
		switch(voltmfactor)
		{
			case 101: vfactor2 = 0.1; break;	
			case 102: vfactor2 = 0.2; break;
			case 103: vfactor2 = 0.5; break;
			case 104: vfactor2 = 1; break;
			case 105: vfactor2 = 2; break;
			case 106: vfactor2 = 5; break;
			case 107: vfactor2 = 10; break;
			case 108: vfactor2 = 20; break;
			case 109: vfactor2 = 50; break;
			case 110: vfactor2 = 100; break;
			case 111: vfactor2 = 200; break;
			case 112: vfactor2 = 500; break;
			case 113: vfactor2 = 1000; break;
		}
		
		voltoff = Extern_Trigger_Strs[Trigger_Pos_CHE] * vfactor2;
		
        Trigger_ExtLevel_Str.Write_Value(voltoff);	
        Trigger_ExtLevel_Str.RenderText();			
    }
    else
    {	  	
	
        if ((Selected_Trigger_Source != ct_Selected_Trigger_Source_buf) || (volt != ct_volt_buf) || (voltmfactor != ct_voltmfactor_buf))
        {	
            // Start calculate horizontal Data
				
            switch(volt)
            {
                case 0 : vfactor = 20.833333; break;
                case 1 : vfactor = 41.666666; break;
                case 2 : vfactor = 104.166666; break;
                case 3 : vfactor = 208.333333; break;
                case 4 : vfactor = 416.666666; break;
                case 5 : vfactor = 1041.666666; break;
                case 6 : vfactor = 2083.333333; break;
                case 7 : vfactor = 4166.666666; break;
                case 8 : vfactor = 10416.66666; break;
                case 9 : vfactor = 20833.33333; break;
                case 10 : vfactor = 41666.66666; break;
                case 11 : vfactor = 104166.6666; break;
            }
		
            vfactor = vfactor / 1000000;
		
            switch(voltmfactor)
            {
                case 101: vfactor2 = 0.1; break;	
                case 102: vfactor2 = 0.2; break;
                case 103: vfactor2 = 0.5; break;
                case 104: vfactor2 = 1; break;
                case 105: vfactor2 = 2; break;
                case 106: vfactor2 = 5; break;
                case 107: vfactor2 = 10; break;
                case 108: vfactor2 = 20; break;
                case 109: vfactor2 = 50; break;
                case 110: vfactor2 = 100; break;
                case 111: vfactor2 = 200; break;
                case 112: vfactor2 = 500; break;
                case 113: vfactor2 = 1000; break;
            }	
		
            ct_Selected_Trigger_Source_buf = Selected_Trigger_Source;
            ct_volt_buf = volt;
            ct_voltmfactor_buf = voltmfactor;
            ct_vfactor_buf = vfactor;
            ct_vfactor2_buf = vfactor2;			
        }
        else
        {
            vfactor = ct_vfactor_buf;
            vfactor2 = ct_vfactor2_buf;
        }

        voltoff = (float)(tpos) * vfactor;
        voltoff = voltoff * vfactor2;

        Trigger_Level_Str.Write_Value(voltoff);	
        Trigger_Level_Str.RenderText();	
    }	
}

void Display::CALCPRETRIGGER(void)
{
	int time = 0;
	
	float tfactor = 0;
	float timeoff = 0;
		
	switch(Display_Timebase)
	{
		case  0: tfactor = 0.00004; break;		//   2 	ns
		case  1: tfactor = 0.0001; break;		//   5 	ns
		case  2: tfactor = 0.0002; break;		//  10 	ns
		case  3: tfactor = 0.0004; break;		//  20 	ns
		case  4: tfactor = 0.001; break;		//  50 	ns
		case  5: tfactor = 0.002; break;		// 100 	ns
		case  6: tfactor = 0.004; break;		// 200 	ns
		case  7: tfactor = 0.01; break;			// 500 	ns		
		case  8: tfactor = 0.02; break;			//   1 	s
		case  9: tfactor = 0.04; break;			//   2 	s
		case 10: tfactor = 0.1; break;			//   5 	s
		case 11: tfactor = 0.2; break;			//  10 	s
		case 12: tfactor = 0.4; break;			//  20 	s
		case 13: tfactor = 1; break;			//  50 	s
		case 14: tfactor = 2; break;			// 100 	s
		case 15: tfactor = 4; break;			// 200 	s
		case 16: tfactor = 10; break;			// 500 	s
		case 17: tfactor = 20; break;			//   1 	ms
		case 18: tfactor = 40; break;			//   2 	ms
		case 19: tfactor = 100; break;			//   5 	ms
		case 20: tfactor = 200; break;			//  10 	ms
		case 21: tfactor = 400; break;			//  20 	ms
		case 22: tfactor = 1000; break;			//  50 	ms
		case 23: tfactor = 2000; break;			// 100 	ms
		case 24: tfactor = 4000; break;			// 200 	ms
		case 25: tfactor = 10000; break;		// 500 	ms
		case 26: tfactor = 20000; break;		//   1 	s
		case 27: tfactor = 40000; break;		//   2 	s
		case 28: tfactor = 100000; break;		//   5 	s
		case 29: tfactor = 200000; break;		//  10 	s
		case 30: tfactor = 400000; break;		//  20 	s
		case 31: tfactor = 1000000; break;		//  50 	s
	}
		
	tfactor = tfactor / 1000000 / ZFT_float;
/*
    if (Selected_Timebase < 9) timeoff = (float)((Trigger_Offset_Pos - 53)) * tfactor;
    else timeoff = (float)((Trigger_Offset_Pos - 3)) * tfactor;
*/
    timeoff = (float)(Trig_Pos_Mem - (100 * ZFT_float)) * tfactor;
    	
	Trigger_Offset_Str.Write_Value(timeoff);
	Trigger_Offset_Str.RenderText();
}

void Display::CALCTIMEBASE(void)
{
	int time = 0;
	
	float tfactor = 0;
	float timeoff = 0;
		
	switch(Display_Timebase)
	{
		case  0: tfactor = 0.00004; break;		//   2 	ns
		case  1: tfactor = 0.0001; break;		//   5 	ns
		case  2: tfactor = 0.0002; break;		//  10 	ns
		case  3: tfactor = 0.0004; break;		//  20 	ns
		case  4: tfactor = 0.001; break;		//  50 	ns
		case  5: tfactor = 0.002; break;		// 100 	ns
		case  6: tfactor = 0.004; break;		// 200 	ns
		case  7: tfactor = 0.01; break;			// 500 	ns		
		case  8: tfactor = 0.02; break;			//   1 	s
		case  9: tfactor = 0.04; break;			//   2 	s
		case 10: tfactor = 0.1; break;			//   5 	s
		case 11: tfactor = 0.2; break;			//  10 	s
		case 12: tfactor = 0.4; break;			//  20 	s
		case 13: tfactor = 1; break;			//  50 	s
		case 14: tfactor = 2; break;			// 100 	s
		case 15: tfactor = 4; break;			// 200 	s
		case 16: tfactor = 10; break;			// 500 	s
		case 17: tfactor = 20; break;			//   1 	ms
		case 18: tfactor = 40; break;			//   2 	ms
		case 19: tfactor = 100; break;			//   5 	ms
		case 20: tfactor = 200; break;			//  10 	ms
		case 21: tfactor = 400; break;			//  20 	ms
		case 22: tfactor = 1000; break;			//  50 	ms
		case 23: tfactor = 2000; break;			// 100 	ms
		case 24: tfactor = 4000; break;			// 200 	ms
		case 25: tfactor = 10000; break;		// 500 	ms
		case 26: tfactor = 20000; break;		//   1 	s
		case 27: tfactor = 40000; break;		//   2 	s
		case 28: tfactor = 100000; break;		//   5 	s
		case 29: tfactor = 200000; break;		//  10 	s
		case 30: tfactor = 400000; break;		//  20 	s
		case 31: tfactor = 1000000; break;		//  50 	s
	}
		
	tfactor = tfactor / 1000000;
	
	timeoff = (float)(Timebase_Offset_Pos) * tfactor;  // Mitte ist 300
	
	Timebase_Offset_Str.Write_Value(timeoff);
	Timebase_Offset_Str.RenderText();
}

void Display::CALCVOLTAGE(char channel, char *String)				// Calculate the Voltage String
{
	short fprobe = 0;
	char fselected_voltage = 0;	
	
	char dim = 2;
	
	int cmpvar = 0;
	
	float sfactor = 0;
	float ffactor = 0;	
	float result = 0;	
	
	float floattempad;
	int inttempbd;
	int inttempad;
	
	char DimString[4];
		
	int xe;
	
	switch (channel)
	{
		case 1:
		{
			fprobe = MenuStatus[1][3];
			fselected_voltage = Selected_Voltage_CH1;
			break;
		}	
		case 2:
		{
			fprobe = MenuStatus[2][3];
			fselected_voltage = Selected_Voltage_CH2;
			break;
		}
		case 3:
		{
			fprobe = MenuStatus[3][3];
			fselected_voltage = Selected_Voltage_CH3;
			break;
		}
		case 4:
		{
			fprobe = MenuStatus[4][3];
			fselected_voltage = Selected_Voltage_CH4;
			break;
		}
	}

	switch (fselected_voltage)
	{
		case 0:
		{
			sfactor = 0.001;
			break;
		}
		case 1:
		{
			sfactor = 0.002;
			break;
		}
		case 2:
		{
			sfactor = 0.005;
			break;
		}
		case 3:
		{
			sfactor = 0.01;
			break;
		}
		case 4:
		{
			sfactor = 0.02;
			break;
		}
		case 5:
		{
			sfactor = 0.05;
			break;
		}
		case 6:
		{
			sfactor = 0.1;
			break;
		}
		case 7:
		{
			sfactor = 0.2;
			break;
		}
		case 8:
		{
			sfactor = 0.5;
			break;
		}
		case 9:
		{
			sfactor = 1;
			break;
		}
		case 10:
		{
			sfactor = 2;
			break;
		}
		case 11:
		{
			sfactor = 5;
			break;
		}	
	}
	
	switch (fprobe)
	{
		case 101:
		{
			ffactor = 0.1;
			break;
		}
		case 102:
		{
			ffactor = 0.2;
			break;
		}
		case 103:
		{
			ffactor = 0.5;
			break;
		}
		case 104:
		{
			ffactor = 1;
			break;
		}
		case 105:
		{
			ffactor = 2;
			break;
		}
		case 106:
		{
			ffactor = 5;
			break;
		}
		case 107:
		{
			ffactor = 10;
			break;
		}
		case 108:
		{
			ffactor = 20;
			break;
		}
		case 109:
		{
			ffactor = 50;
			break;
		}
		case 110:
		{
			ffactor = 100;
			break;
		}
		case 111:
		{
			ffactor = 200;
			break;
		}
		case 112:
		{
			ffactor = 500;
			break;
		}
		case 113:
		{
			ffactor = 1000;
			break;
		}
	}

	result = sfactor * ffactor;	
		
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result < 1)
	{
		result = result * 1000;
		dim--;
	}
	if (result > 500)
	{
		result = result / 1000;
		dim++;
	}
	
	//sprintf(DimString, "");
	for (xe = 0; xe < 3; xe++)
	{
		DimString[xe] = VoltageData[dim][xe];
	}
	DimString[3] = 0;	
	
	// Copy Float to Integer
	cmpvar = (int) result;
	
#ifdef _Debug_	
	printf("Res %f cmpvar %f\n", result, (float) cmpvar);
#endif		
	// Compare if there is a after Dot integer
	if ((float) cmpvar == result)
    {
        sprintf(String, "%3d %s", cmpvar, DimString);
    }      /*
	else if ((((float) cmpvar + 0) - result) < 0.0001)
    {
        sprintf(String, "%3d %s", cmpvar + 0, DimString);
        printf("S2\n");
    }    */
	else
	{
		inttempbd = (int) result;
		floattempad = result - (float) inttempbd;
		
		inttempad = (int) (floattempad * (float) 10);
		
		if (inttempad == 9)
        {
            inttempad = 0;
            inttempbd++;
        }
		
		sprintf(String, "%3d.%1d %s", inttempbd, inttempad, DimString);
#ifdef _Debug_		
		printf("Res %f inttempbd %d  inttempad %d\n", result, inttempbd, inttempad);
#endif		
	}	
}

void Display::DRAWSIGNS(void)
{
    long Adr_Front_Old_1, Adr_Front_Old_2, Adr_Front_New_1, Adr_Front_New_2, Adr_Front_Old_3, Adr_Front_Old_4, Adr_Front_New_3, Adr_Front_New_4;
    long Adr_Back_Old_1, Adr_Back_Old_2, Adr_Back_New_1, Adr_Back_New_2, Adr_Back_Old_3, Adr_Back_Old_4, Adr_Back_New_3, Adr_Back_New_4;

    unsigned char *signbuff = 0;
    /*
    if ((MenuStatus[1][0] == 6) && (Channel_1_Active))
    {
        if (ZeroLevelCH1 != ZeroLevelCH1_Old)
        {
            Display::DRAWZEROLINE(ZeroLevelCH1_Old, 0, Channel_Plane1);
            Display::DRAWZEROLINE(ZeroLevelCH1_Old, 0, Buffer_Plane1);
        }

        Display::DRAWZEROLINE(ZeroLevelCH1, 1, Channel_Plane1);
        Display::DRAWZEROLINE(ZeroLevelCH1, 1, Buffer_Plane1);
    }
    if ((MenuStatus[2][0] == 6) && (Channel_2_Active))
    {
        if (ZeroLevelCH2 != ZeroLevelCH2_Old)
        {
            Display::DRAWZEROLINE(ZeroLevelCH2_Old, 0, Channel_Plane2);
            Display::DRAWZEROLINE(ZeroLevelCH2_Old, 0, Buffer_Plane2);
        }

        Display::DRAWZEROLINE(ZeroLevelCH2, 1, Channel_Plane2);
        Display::DRAWZEROLINE(ZeroLevelCH2, 1, Buffer_Plane2);
    }
    if ((MenuStatus[3][0] == 6) && (Channel_3_Active))
    {
        if (ZeroLevelCH3 != ZeroLevelCH3_Old)
        {
            Display::DRAWZEROLINE(ZeroLevelCH3_Old, 0, Channel_Plane3);
            Display::DRAWZEROLINE(ZeroLevelCH3_Old, 0, Buffer_Plane3);
        }

        Display::DRAWZEROLINE(ZeroLevelCH3, 1, Channel_Plane3);
        Display::DRAWZEROLINE(ZeroLevelCH3, 1, Buffer_Plane3);
    }
    if ((MenuStatus[4][0] == 6) && (Channel_4_Active))
    {
        if (ZeroLevelCH4 != ZeroLevelCH4_Old)
        {
            Display::DRAWZEROLINE(ZeroLevelCH4_Old, 0, Channel_Plane4);
            Display::DRAWZEROLINE(ZeroLevelCH4_Old, 0, Buffer_Plane4);
        }

        Display::DRAWZEROLINE(ZeroLevelCH4, 1, Channel_Plane4);
        Display::DRAWZEROLINE(ZeroLevelCH4, 1, Buffer_Plane4);
    }
    */


  //  printf("DrawSigns : STSO %d  TPCH1O : %d  TPCH1 : %d \n",Selected_Trigger_Source_Old ,Trigger_Pos_CH1_Old , Trigger_Pos_CH1);

    // Remove Trigger Channel 1
    //if (Selected_Trigger_Source_Old == 1)
    {
        if (MenuStatus[1][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) + 13) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + ((Trigger_Pos_CH1_Old + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + ((Trigger_Pos_CH1_Old + 13) * 80);
        }
        
        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);

        // for delayed mode

        if (MenuStatus[1][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane1 + ((((ZeroLevelCH1_Old + (ZeroLevelCH1_Old - Trigger_Pos_CH1_Old)) >> 1) + 206) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane1 + (((Trigger_Pos_CH1_Old >> 1) + 206) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSign(Adr_Front_Old_3);
        RemoveZeroSign(Adr_Front_Old_4);
    }

    // Remove Channel 1 Zero
    if (Display_Mode)
    {
        //DrawZeroSignXY(ZeroLevelCH1_Old, 0);
    }
    else
    {
        Adr_Front_Old_1 = v_Channel_Plane1 + ((ZeroLevelCH1_Old + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + ((ZeroLevelCH1_Old + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + ((ZeroLevelCH1_Old + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + ((ZeroLevelCH1_Old + 11) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        // for delayed mode

        Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 11) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        Adr_Front_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204) * 80);
        Adr_Back_Old_1 = v_Channel_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane1 + (((ZeroLevelCH1_Old >> 1) + 204) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);
    }

    // Draw Channel 1 Zero
    if ((Channel_1_Active) && (ZeroLevelCH1 > 0) && (ZeroLevelCH1 < 480) && (Display_Mode))
    {
        //DrawZeroSignXY(ZeroLevelCH1, 1);
        //ZeroLevelCH1_Old = ZeroLevelCH1;
    }

    if ((Channel_1_Active) && (ZeroLevelCH1 > 0) && (ZeroLevelCH1 < 385) && (Display_Mode == false))
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 11) * 80);

            Adr_Front_New_3 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Back_New_3 = v_Channel_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);
            Adr_Back_New_4 = v_Buffer_Plane1 + (((ZeroLevelCH1 >> 1) + 204) * 80);

            DrawZeroSign(bitbmCH1, Adr_Front_New_1);
            DrawZeroSign(bitbmCH1, Adr_Front_New_2);
            DrawZeroSign(bitbmCH1, Adr_Front_New_3);
            DrawZeroSign(bitbmCH1, Adr_Front_New_4);

            if (MenuStatus[1][0] == 6)
            {
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
            }
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane1 + ((ZeroLevelCH1 + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane1 + ((ZeroLevelCH1 + 11) * 80);

            DrawZeroSign(bitbmCH1, Adr_Front_New_1);
            DrawZeroSign(bitbmCH1, Adr_Front_New_2);

            if (MenuStatus[1][0] == 6)
            {
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH1_gnd, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 240) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] != 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[1][0] == 7) && (MenuStatus[1][1] == 241) && (MenuStatus[1][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
            }
        }

        ZeroLevelCH1_Old = ZeroLevelCH1;
    }
    else if ((Channel_1_Active) && (ZeroLevelCH1 == 0) && (Display_Mode == false))      // mu fr xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (20 * 80);
            Adr_Front_New_3 = v_Channel_Plane1 + (213 * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (213 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);
            DrawZeroSign(bitbmMin, Adr_Front_New_3);
            DrawZeroSign(bitbmMin, Adr_Front_New_4);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (20 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
    }
    else if ((Channel_1_Active) && (ZeroLevelCH1 == 385) && (Display_Mode == false))   // mu fr xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (203 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (203 * 80);
            Adr_Front_New_3 = v_Channel_Plane1 + (396 * 80);
            Adr_Front_New_4 = v_Buffer_Plane1 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);
            DrawZeroSign(bitbmMax, Adr_Front_New_3);
            DrawZeroSign(bitbmMax, Adr_Front_New_4);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane1 + (396 * 80);
            Adr_Front_New_2 = v_Buffer_Plane1 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);

            ZeroLevelCH1_Old = ZeroLevelCH1;
        }
    }

    // Draw Trigger Channel 1
    //if ((triggering) && (Selected_Trigger_Source == 1))
    if ((Selected_Trigger_Source == 1) && (Display_Mode == false))
    {
        if (MenuStatus[10][1] == 1)
        {
            if (MenuStatus[1][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane1 + ((((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane1 + (((Trigger_Pos_CH1 >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + (((Trigger_Pos_CH1 >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane1 + (((Trigger_Pos_CH1 >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane1 + (((Trigger_Pos_CH1 >> 1) + 206) * 80);
            }
            
            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
            }
        }
        else
        {
            if (MenuStatus[1][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane1 + (((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + (((ZeroLevelCH1 + (ZeroLevelCH1 - Trigger_Pos_CH1)) + 13) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane1 + ((Trigger_Pos_CH1 + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane1 + ((Trigger_Pos_CH1 + 13) * 80);
            }
            
            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
            }
        }
        Trigger_Pos_CH1_Old = Trigger_Pos_CH1;
    }

    // Remove Trigger Channel 2
    //if (Selected_Trigger_Source_Old == 2)
    {
        if (MenuStatus[2][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) + 13) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((Trigger_Pos_CH2_Old + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((Trigger_Pos_CH2_Old + 13) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);

        // for delayed mode

        if (MenuStatus[2][2] == 241)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane2 + ((((ZeroLevelCH2_Old + (ZeroLevelCH2_Old - Trigger_Pos_CH2_Old)) >> 1) + 206) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 13) * 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 13) * 80);
            Adr_Front_Old_3 = v_Channel_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 206) * 80);
            Adr_Front_Old_4 = v_Buffer_Plane2 + (((Trigger_Pos_CH2_Old >> 1) + 206) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSign(Adr_Front_Old_3);
        RemoveZeroSign(Adr_Front_Old_4);
    }

    // Remove Channel 2 Zero
  /*  if (Display_Mode)
    {
        Adr_Front_Old_1 = v_Channel_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Back_Old_1 = v_Channel_Plane2 + (ZeroLevelCH2_Old + 1360);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (ZeroLevelCH2_Old + 1360);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);
    }
    else   */
    {
        if (Display_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane2 + ((ZeroLevelCH2_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane2 + ((ZeroLevelCH2_Old + 11) * 80);
        }

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        // for delayed mode

        Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11) * 80);
        Adr_Back_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 11) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);

        Adr_Front_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204)* 80);
        Adr_Front_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204) * 80);
        Adr_Back_Old_1 = v_Channel_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204)* 80);
        Adr_Back_Old_2 = v_Buffer_Plane2 + (((ZeroLevelCH2_Old >> 1) + 204) * 80);

        RemoveZeroSign(Adr_Front_Old_1);
        RemoveZeroSign(Adr_Front_Old_2);
        RemoveZeroSignBack(Adr_Back_Old_1);
        RemoveZeroSignBack(Adr_Back_Old_2);
    }

    // Draw Channel 2 Zero
    if ((Channel_2_Active) && (ZeroLevelCH2 > 0) && (ZeroLevelCH2 < 385))
    {
        if (Display_Mode == false)    // nur zum ausblenden der zero bei XY
        {
        if (MenuStatus[10][1] == 1)
        {
            if (Display_Mode)
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane2 + (((ZeroLevelCH2 >> 1) + 204) * 80);
            }

            DrawZeroSign(bitbmCH2, Adr_Front_New_1);
            DrawZeroSign(bitbmCH2, Adr_Front_New_2);
            DrawZeroSign(bitbmCH2, Adr_Front_New_3);
            DrawZeroSign(bitbmCH2, Adr_Front_New_4);

            if (MenuStatus[2][0] == 6)
            {
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
            }
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Back_New_1 = v_Channel_Plane2 + ((ZeroLevelCH2 + 11) * 80);
            Adr_Back_New_2 = v_Buffer_Plane2 + ((ZeroLevelCH2 + 11) * 80);

            DrawZeroSign(bitbmCH2, Adr_Front_New_1);
            DrawZeroSign(bitbmCH2, Adr_Front_New_2);

            if (MenuStatus[2][0] == 6)
            {
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCH2_gnd, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 240) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 240))
            {
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] != 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
            }
            else if ((MenuStatus[2][0] == 7) && (MenuStatus[2][1] == 241) && (MenuStatus[2][2] == 241))
            {
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
            }
        }
        }

        ZeroLevelCH2_Old = ZeroLevelCH2;
    }
    else if ((Channel_2_Active) && (ZeroLevelCH2 == 0))      // mu fr xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (20 * 80);
            Adr_Front_New_3 = v_Channel_Plane2 + (213 * 80);
            Adr_Front_New_4 = v_Buffer_Plane2 + (213 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);
            DrawZeroSign(bitbmMin, Adr_Front_New_3);
            DrawZeroSign(bitbmMin, Adr_Front_New_4);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (20 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (20 * 80);

            DrawZeroSign(bitbmMin, Adr_Front_New_1);
            DrawZeroSign(bitbmMin, Adr_Front_New_2);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
    }
    else if ((Channel_2_Active) && (ZeroLevelCH2 == 385))   // mu fr xy upgedatet werden
    {
        if (MenuStatus[10][1] == 1)
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (203 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (203 * 80);
            Adr_Front_New_3 = v_Channel_Plane2 + (396 * 80);
            Adr_Front_New_4 = v_Buffer_Plane2 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);
            DrawZeroSign(bitbmMax, Adr_Front_New_3);
            DrawZeroSign(bitbmMax, Adr_Front_New_4);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
        else
        {
            Adr_Front_New_1 = v_Channel_Plane2 + (396 * 80);
            Adr_Front_New_2 = v_Buffer_Plane2 + (396 * 80);

            DrawZeroSign(bitbmMax, Adr_Front_New_1);
            DrawZeroSign(bitbmMax, Adr_Front_New_2);

            ZeroLevelCH2_Old = ZeroLevelCH2;
        }
    }

    // Draw Trigger Channel 2
    //if ((triggering) && (Selected_Trigger_Source == 2))
    if ((Selected_Trigger_Source == 2) && (Display_Mode == false))
    {
        if (MenuStatus[10][1] == 1)
        {
            if (MenuStatus[2][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + ((((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((Trigger_Pos_CH2 >> 1) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((Trigger_Pos_CH2 >> 1) + 13) * 80);
                Adr_Front_New_3 = v_Channel_Plane2 + (((Trigger_Pos_CH2 >> 1) + 206) * 80);
                Adr_Front_New_4 = v_Buffer_Plane2 + (((Trigger_Pos_CH2 >> 1) + 206) * 80);
            }

            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
            }
        }
        else
        {
            if (MenuStatus[2][2] == 241) // inverted
            {
                Adr_Front_New_1 = v_Channel_Plane2 + (((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + (((ZeroLevelCH2 + (ZeroLevelCH2 - Trigger_Pos_CH2)) + 13) * 80);
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane2 + ((Trigger_Pos_CH2 + 13) * 80);
                Adr_Front_New_2 = v_Buffer_Plane2 + ((Trigger_Pos_CH2 + 13) * 80);
            }

            if (MenuStatus[0][1] == 1)
            {
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
            }
            else
            {
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
            }
        }
        Trigger_Pos_CH2_Old = Trigger_Pos_CH2;
    }

    if (NumberOfChannels > 2)
    {
        // Remove Trigger Channel 3
        //if (Selected_Trigger_Source_Old == 3)
        {
            if (MenuStatus[3][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) + 13) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + ((Trigger_Pos_CH3_Old + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + ((Trigger_Pos_CH3_Old + 13) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);

            // for delayed mode

            if (MenuStatus[3][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane3 + ((((ZeroLevelCH3_Old + (ZeroLevelCH3_Old - Trigger_Pos_CH3_Old)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane3 + (((Trigger_Pos_CH3_Old >> 1) + 206) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSign(Adr_Front_Old_3);
            RemoveZeroSign(Adr_Front_Old_4);
        }

        // Remove Channel 3 Zero
        if (Display_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Back_Old_1 = v_Channel_Plane3 + (ZeroLevelCH3_Old + 1360);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (ZeroLevelCH3_Old + 1360);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane3 + ((ZeroLevelCH3_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + ((ZeroLevelCH3_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + ((ZeroLevelCH3_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + ((ZeroLevelCH3_Old + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            // for delayed mode

            Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            Adr_Front_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204) * 80);
            Adr_Back_Old_1 = v_Channel_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane3 + (((ZeroLevelCH3_Old >> 1) + 204) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);
        }

        // Draw Channel 3 Zero
        if ((Channel_3_Active) && (ZeroLevelCH3 > 0) && (ZeroLevelCH3 < 385))
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane3 + (((ZeroLevelCH3 >> 1) + 204) * 80);

                DrawZeroSign(bitbmCH3, Adr_Front_New_1);
                DrawZeroSign(bitbmCH3, Adr_Front_New_2);
                DrawZeroSign(bitbmCH3, Adr_Front_New_3);
                DrawZeroSign(bitbmCH3, Adr_Front_New_4);

                if (MenuStatus[3][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
                }
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane3 + ((ZeroLevelCH3 + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane3 + ((ZeroLevelCH3 + 11) * 80);

                DrawZeroSign(bitbmCH3, Adr_Front_New_1);
                DrawZeroSign(bitbmCH3, Adr_Front_New_2);

                if (MenuStatus[3][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH3_gnd, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 240) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] != 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[3][0] == 7) && (MenuStatus[3][1] == 241) && (MenuStatus[3][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                }
            }

            ZeroLevelCH3_Old = ZeroLevelCH3;
        }
        else if ((Channel_3_Active) && (ZeroLevelCH3 == 0))      // mu fr xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (20 * 80);
                Adr_Front_New_3 = v_Channel_Plane3 + (213 * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (213 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);
                DrawZeroSign(bitbmMin, Adr_Front_New_3);
                DrawZeroSign(bitbmMin, Adr_Front_New_4);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (20 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
        }
        else if ((Channel_3_Active) && (ZeroLevelCH3 == 385))   // mu fr xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (203 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (203 * 80);
                Adr_Front_New_3 = v_Channel_Plane3 + (396 * 80);
                Adr_Front_New_4 = v_Buffer_Plane3 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);
                DrawZeroSign(bitbmMax, Adr_Front_New_3);
                DrawZeroSign(bitbmMax, Adr_Front_New_4);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane3 + (396 * 80);
                Adr_Front_New_2 = v_Buffer_Plane3 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);

                ZeroLevelCH3_Old = ZeroLevelCH3;
            }
        }


        // Draw Trigger Channel 3
        //if ((triggering) && (Selected_Trigger_Source == 3))
        if ((Selected_Trigger_Source == 3) && (Display_Mode == false))
        {
            if (MenuStatus[10][1] == 1)
            {
                if (MenuStatus[3][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane3 + ((((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) >> 1) + 206) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + (((Trigger_Pos_CH3 >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + (((Trigger_Pos_CH3 >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane3 + (((Trigger_Pos_CH3 >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane3 + (((Trigger_Pos_CH3 >> 1) + 206) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
                }
            }
            else
            {
                if (MenuStatus[3][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + (((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + (((ZeroLevelCH3 + (ZeroLevelCH3 - Trigger_Pos_CH3)) + 13) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane3 + ((Trigger_Pos_CH3 + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane3 + ((Trigger_Pos_CH3 + 13) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                }
            }
            Trigger_Pos_CH3_Old = Trigger_Pos_CH3;
        }

        // Remove Trigger Channel 4
        //if (Selected_Trigger_Source_Old == 4)
        {
            if (MenuStatus[4][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) + 13) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + ((Trigger_Pos_CH4_Old + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + ((Trigger_Pos_CH4_Old + 13) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);

            // for delayed mode

            if (MenuStatus[4][2] == 241)
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane4 + ((((ZeroLevelCH4_Old + (ZeroLevelCH4_Old - Trigger_Pos_CH4_Old)) >> 1) + 206) * 80);
            }
            else
            {
                Adr_Front_Old_1 = v_Channel_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 13) * 80);
                Adr_Front_Old_2 = v_Buffer_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 13) * 80);
                Adr_Front_Old_3 = v_Channel_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 206) * 80);
                Adr_Front_Old_4 = v_Buffer_Plane4 + (((Trigger_Pos_CH4_Old >> 1) + 206) * 80);
            }

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSign(Adr_Front_Old_3);
            RemoveZeroSign(Adr_Front_Old_4);
        }

        // Remove Channel 4 Zero
        if (Display_Mode)
        {
            Adr_Front_Old_1 = v_Channel_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Back_Old_1 = v_Channel_Plane4 + (ZeroLevelCH4_Old + 1360);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (ZeroLevelCH4_Old + 1360);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);
        }
        else
        {
            Adr_Front_Old_1 = v_Channel_Plane4 + ((ZeroLevelCH4_Old + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + ((ZeroLevelCH4_Old + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + ((ZeroLevelCH4_Old + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + ((ZeroLevelCH4_Old + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            // for delayed mode

            Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 11) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);

            Adr_Front_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204)* 80);
            Adr_Front_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204) * 80);
            Adr_Back_Old_1 = v_Channel_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204)* 80);
            Adr_Back_Old_2 = v_Buffer_Plane4 + (((ZeroLevelCH4_Old >> 1) + 204) * 80);

            RemoveZeroSign(Adr_Front_Old_1);
            RemoveZeroSign(Adr_Front_Old_2);
            RemoveZeroSignBack(Adr_Back_Old_1);
            RemoveZeroSignBack(Adr_Back_Old_2);
        }

        // Draw Channel 4 Zero
        if ((Channel_4_Active) && (ZeroLevelCH4 > 0) && (ZeroLevelCH4 < 385))
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 11) * 80);

                Adr_Front_New_3 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Back_New_3 = v_Channel_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);
                Adr_Back_New_4 = v_Buffer_Plane4 + (((ZeroLevelCH4 >> 1) + 204) * 80);

                DrawZeroSign(bitbmCH4, Adr_Front_New_1);
                DrawZeroSign(bitbmCH4, Adr_Front_New_2);
                DrawZeroSign(bitbmCH4, Adr_Front_New_3);
                DrawZeroSign(bitbmCH4, Adr_Front_New_4);

                if (MenuStatus[4][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_4);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_3);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_4);
                }
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Back_New_1 = v_Channel_Plane4 + ((ZeroLevelCH4 + 11) * 80);
                Adr_Back_New_2 = v_Buffer_Plane4 + ((ZeroLevelCH4 + 11) * 80);

                DrawZeroSign(bitbmCH4, Adr_Front_New_1);
                DrawZeroSign(bitbmCH4, Adr_Front_New_2);

                if (MenuStatus[4][0] == 6)
                {
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCH4_gnd, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppDC, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppAC, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 240) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACInv, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 240))
                {
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppACLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] != 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppInvLimit, Adr_Back_New_2);
                }
                else if ((MenuStatus[4][0] == 7) && (MenuStatus[4][1] == 241) && (MenuStatus[4][2] == 241))
                {
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_1);
                    DrawZeroSignBack(bitbmCoppFull, Adr_Back_New_2);
                }
            }

            ZeroLevelCH4_Old = ZeroLevelCH4;
        }
        else if ((Channel_4_Active) && (ZeroLevelCH4 == 0))      // mu fr xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (20 * 80);
                Adr_Front_New_3 = v_Channel_Plane4 + (213 * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (213 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);
                DrawZeroSign(bitbmMin, Adr_Front_New_3);
                DrawZeroSign(bitbmMin, Adr_Front_New_4);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (20 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (20 * 80);

                DrawZeroSign(bitbmMin, Adr_Front_New_1);
                DrawZeroSign(bitbmMin, Adr_Front_New_2);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
        }
        else if ((Channel_4_Active) && (ZeroLevelCH4 == 385))   // mu fr xy upgedatet werden
        {
            if (MenuStatus[10][1] == 1)
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (203 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (203 * 80);
                Adr_Front_New_3 = v_Channel_Plane4 + (396 * 80);
                Adr_Front_New_4 = v_Buffer_Plane4 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);
                DrawZeroSign(bitbmMax, Adr_Front_New_3);
                DrawZeroSign(bitbmMax, Adr_Front_New_4);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
            else
            {
                Adr_Front_New_1 = v_Channel_Plane4 + (396 * 80);
                Adr_Front_New_2 = v_Buffer_Plane4 + (396 * 80);

                DrawZeroSign(bitbmMax, Adr_Front_New_1);
                DrawZeroSign(bitbmMax, Adr_Front_New_2);

                ZeroLevelCH4_Old = ZeroLevelCH4;
            }
        }

        // Draw Trigger Channel 4
        //if ((triggering) && (Selected_Trigger_Source == 4))
        if ((Selected_Trigger_Source == 4) && (Display_Mode == false))
        {
            if (MenuStatus[10][1] == 1)
            {
                if (MenuStatus[4][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane4 + ((((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) >> 1) + 206) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + (((Trigger_Pos_CH4 >> 1) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + (((Trigger_Pos_CH4 >> 1) + 13) * 80);
                    Adr_Front_New_3 = v_Channel_Plane4 + (((Trigger_Pos_CH4 >> 1) + 206) * 80);
                    Adr_Front_New_4 = v_Buffer_Plane4 + (((Trigger_Pos_CH4 >> 1) + 206) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_4);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_3);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_4);
                }
            }
            else
            {
                if (MenuStatus[4][2] == 241) // inverted
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + (((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + (((ZeroLevelCH4 + (ZeroLevelCH4 - Trigger_Pos_CH4)) + 13) * 80);
                }
                else
                {
                    Adr_Front_New_1 = v_Channel_Plane4 + ((Trigger_Pos_CH4 + 13) * 80);
                    Adr_Front_New_2 = v_Buffer_Plane4 + ((Trigger_Pos_CH4 + 13) * 80);
                }

                if (MenuStatus[0][1] == 1)
                {
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigAVG, Adr_Front_New_2);
                }
                else
                {
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_1);
                    OverDrawZeroSign(bitbmTrigger, Adr_Front_New_2);
                }
            }
            Trigger_Pos_CH4_Old = Trigger_Pos_CH4;
        }
    }

    if (ZeroLevelCH1 < 5) TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
//    if (ZeroLevelCH1 < 5) TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text
}

void Display::RemoveZeroSign(long addressold)
{
    CLEAR2BYTE(addressold + 0x000);
    CLEAR2BYTE(addressold + 0x050);
    CLEAR2BYTE(addressold + 0x0A0);
    CLEAR2BYTE(addressold + 0x0F0);
    CLEAR2BYTE(addressold + 0x140);
    CLEAR2BYTE(addressold + 0x190);
    CLEAR2BYTE(addressold + 0x1E0);
    CLEAR2BYTE(addressold + 0x230);
    CLEAR2BYTE(addressold + 0x280);
    CLEAR2BYTE(addressold + 0x2D0);
    CLEAR2BYTE(addressold + 0x320);
    CLEAR2BYTE(addressold + 0x370);
    CLEAR2BYTE(addressold + 0x3C0);
    CLEAR2BYTE(addressold + 0x410);
    CLEAR2BYTE(addressold + 0x460);
    CLEAR2BYTE(addressold + 0x4B0);
}

void Display::DrawZeroSign(unsigned char *sign, long addressnew)
{
    WRITE2BYTE(sign[2], sign[3], addressnew + 0x000);
    WRITE2BYTE(sign[4], sign[5], addressnew + 0x050);
    WRITE2BYTE(sign[6], sign[7], addressnew + 0x0A0);
    WRITE2BYTE(sign[8], sign[9], addressnew + 0x0F0);
    WRITE2BYTE(sign[10], sign[11], addressnew + 0x140);
    WRITE2BYTE(sign[12], sign[13], addressnew + 0x190);
    WRITE2BYTE(sign[14], sign[15], addressnew + 0x1E0);
    WRITE2BYTE(sign[16], sign[17], addressnew + 0x230);
    WRITE2BYTE(sign[18], sign[19], addressnew + 0x280);
    WRITE2BYTE(sign[20], sign[21], addressnew + 0x2D0);
    WRITE2BYTE(sign[22], sign[23], addressnew + 0x320);
    WRITE2BYTE(sign[24], sign[25], addressnew + 0x370);
    WRITE2BYTE(sign[26], sign[27], addressnew + 0x3C0);
    WRITE2BYTE(sign[28], sign[29], addressnew + 0x410);
    WRITE2BYTE(sign[30], sign[31], addressnew + 0x460);
    WRITE2BYTE(sign[32], sign[33], addressnew + 0x4B0);
}

void Display::DrawZeroSignXY(int position, char set)
{
    int posiy = 20;

    DRAWLINEP(position + 80, posiy, position + 80, posiy + 6, set, Buffer_Plane1);

    DRAWLINEP(position + 80 - 1, posiy + 1, position + 80 + 2, posiy + 1, set, Buffer_Plane1);
    DRAWLINEP(position + 80 - 2, posiy + 2, position + 80 + 3, posiy + 2, set, Buffer_Plane1);
    DRAWLINEP(position + 80 - 3, posiy + 3, position + 80 + 4, posiy + 3, set, Buffer_Plane1);

    DRAWLINEP(position + 80 - 2, posiy + 6, position + 80 + 3, posiy + 6, set, Buffer_Plane1);
    DRAWLINEP(position + 80 - 1, posiy + 8, position + 80 + 2, posiy + 8, set, Buffer_Plane1);
    PIXELP(position + 80, posiy + 10, set, Buffer_Plane1);

    PIXELP(position + 80 - 7, posiy + 3, set, Buffer_Plane1);
    PIXELP(position + 80 - 6, posiy + 2, set, Buffer_Plane1);
    DRAWLINEP(position + 80 - 5, posiy + 1, position + 80 - 5, posiy + 7, set, Buffer_Plane1);
}

void Display::OverDrawZeroSign(unsigned char *sign, long addressnew)
{
    OVERWRITE2BYTE(sign[2], sign[3], addressnew + 0x000);
    OVERWRITE2BYTE(sign[4], sign[5], addressnew + 0x050);
    OVERWRITE2BYTE(sign[6], sign[7], addressnew + 0x0A0);
    OVERWRITE2BYTE(sign[8], sign[9], addressnew + 0x0F0);
    OVERWRITE2BYTE(sign[10], sign[11], addressnew + 0x140);
    OVERWRITE2BYTE(sign[12], sign[13], addressnew + 0x190);
    OVERWRITE2BYTE(sign[14], sign[15], addressnew + 0x1E0);
    OVERWRITE2BYTE(sign[16], sign[17], addressnew + 0x230);
    OVERWRITE2BYTE(sign[18], sign[19], addressnew + 0x280);
    OVERWRITE2BYTE(sign[20], sign[21], addressnew + 0x2D0);
    OVERWRITE2BYTE(sign[22], sign[23], addressnew + 0x320);
    OVERWRITE2BYTE(sign[24], sign[25], addressnew + 0x370);
    OVERWRITE2BYTE(sign[26], sign[27], addressnew + 0x3C0);
    OVERWRITE2BYTE(sign[28], sign[29], addressnew + 0x410);
    OVERWRITE2BYTE(sign[30], sign[31], addressnew + 0x460);
    OVERWRITE2BYTE(sign[32], sign[33], addressnew + 0x4B0);
}

void Display::RemoveZeroSignBack(long addressold)
{
    CLEAR2BYTEBACK(addressold + 0x04F);
    CLEAR2BYTEBACK(addressold + 0x09F);
    CLEAR2BYTEBACK(addressold + 0x0EF);
    CLEAR2BYTEBACK(addressold + 0x13F);
    CLEAR2BYTEBACK(addressold + 0x18F);
    CLEAR2BYTEBACK(addressold + 0x1DF);
    CLEAR2BYTEBACK(addressold + 0x22F);
    CLEAR2BYTEBACK(addressold + 0x27F);
    CLEAR2BYTEBACK(addressold + 0x2CF);
    CLEAR2BYTEBACK(addressold + 0x31F);
    CLEAR2BYTEBACK(addressold + 0x36F);
    CLEAR2BYTEBACK(addressold + 0x3BF);
    CLEAR2BYTEBACK(addressold + 0x40F);
    CLEAR2BYTEBACK(addressold + 0x45F);
    CLEAR2BYTEBACK(addressold + 0x4AF);
    CLEAR2BYTEBACK(addressold + 0x4FF);
    CLEAR2BYTEBACK(addressold + 0x54F);
    CLEAR2BYTEBACK(addressold + 0x59F);
    CLEAR2BYTEBACK(addressold + 0x5EF);
    CLEAR2BYTEBACK(addressold + 0x63F);
    CLEAR2BYTEBACK(addressold + 0x68F);
    CLEAR2BYTEBACK(addressold + 0x6DF);
    CLEAR2BYTEBACK(addressold + 0x72F);
    CLEAR2BYTEBACK(addressold + 0x77F);
    CLEAR2BYTEBACK(addressold + 0x7CF);
    CLEAR2BYTEBACK(addressold + 0x81F);
    CLEAR2BYTEBACK(addressold + 0x86F);
    CLEAR2BYTEBACK(addressold + 0x8BF);
    CLEAR2BYTEBACK(addressold + 0x90F);
}

void Display::DrawZeroSignBack(unsigned char *sign, long addressnew)
{
    WRITE2BYTEBACK(sign[2], sign[3], addressnew + 0x04F);
    WRITE2BYTEBACK(sign[4], sign[5], addressnew + 0x09F);
    WRITE2BYTEBACK(sign[6], sign[7], addressnew + 0x0EF);
    WRITE2BYTEBACK(sign[8], sign[9], addressnew + 0x13F);
    WRITE2BYTEBACK(sign[10], sign[11], addressnew + 0x18F);
    WRITE2BYTEBACK(sign[12], sign[13], addressnew + 0x1DF);
    WRITE2BYTEBACK(sign[14], sign[15], addressnew + 0x22F);
    WRITE2BYTEBACK(sign[16], sign[17], addressnew + 0x27F);
    WRITE2BYTEBACK(sign[18], sign[19], addressnew + 0x2CF);
    WRITE2BYTEBACK(sign[20], sign[21], addressnew + 0x31F);
    WRITE2BYTEBACK(sign[22], sign[23], addressnew + 0x36F);
    WRITE2BYTEBACK(sign[24], sign[25], addressnew + 0x3BF);
    WRITE2BYTEBACK(sign[26], sign[27], addressnew + 0x40F);
    WRITE2BYTEBACK(sign[28], sign[29], addressnew + 0x45F);
    WRITE2BYTEBACK(sign[30], sign[31], addressnew + 0x4AF);
    WRITE2BYTEBACK(sign[32], sign[33], addressnew + 0x4FF);
    WRITE2BYTEBACK(sign[34], sign[35], addressnew + 0x54F);
    WRITE2BYTEBACK(sign[36], sign[37], addressnew + 0x59F);
    WRITE2BYTEBACK(sign[38], sign[39], addressnew + 0x5EF);
    WRITE2BYTEBACK(sign[40], sign[41], addressnew + 0x63F);
    WRITE2BYTEBACK(sign[42], sign[43], addressnew + 0x68F);
    WRITE2BYTEBACK(sign[44], sign[45], addressnew + 0x6DF);
    WRITE2BYTEBACK(sign[46], sign[47], addressnew + 0x72F);
    WRITE2BYTEBACK(sign[48], sign[49], addressnew + 0x77F);
    WRITE2BYTEBACK(sign[50], sign[51], addressnew + 0x7CF);
    WRITE2BYTEBACK(sign[52], sign[53], addressnew + 0x81F);
    WRITE2BYTEBACK(sign[54], sign[55], addressnew + 0x86F);
    WRITE2BYTEBACK(sign[56], sign[57], addressnew + 0x8BF);
    WRITE2BYTEBACK(sign[58], sign[59], addressnew + 0x90F);
}

void Display::CLEAR2BYTE(long addressold)
{
    asm("
  		   PFX      %hi(0x00)
  		   MOVI     %l1, %lo(0x00)
           FILL8	%r0, %l1				
           ST8S		[%i0], %r0, 2

  		   PFX      %hi(0x00)
  		   MOVI     %l1, %lo(0x00)
           FILL8	%r0, %l1				
           ST8S		[%i0], %r0, 3
		");	
}

void Display::WRITE2BYTE(unsigned char byte1, unsigned char byte2, long addressnew)
{
    asm("
           FILL8	%r0, %i1             			
           ST8S		[%i2], %r0, 2
  				
           FILL8	%r0, %i0             			
           ST8S		[%i2], %r0, 3
		");	
}

void Display::OVERWRITE2BYTE(unsigned char byte1, unsigned char byte2, long addressnew)
{
    asm("
           LD       %r0, [%i2]
           EXT8S    %r0, 2
           OR       %r0, %i1
           FILL8	%r0, %r0
           ST8S		[%i2], %r0, 2

           LD       %r0, [%i2]
           EXT8S    %r0, 3
           OR       %r0, %i0
           FILL8	%r0, %r0             			
           ST8S		[%i2], %r0, 3
		");	
}

void Display::CLEAR2BYTEBACK(long addressold)
{
    asm("
  		   PFX      %hi(0x00)
  		   MOVI     %l1, %lo(0x00)
           FILL8	%r0, %l1				
           ST8S		[%i0], %r0, 0

  		   PFX      %hi(0x00)
  		   MOVI     %l1, %lo(0x00)
           FILL8	%r0, %l1				
           ST8S		[%i0], %r0, 1
		");	
}

void Display::WRITE2BYTEBACK(unsigned char byte1, unsigned char byte2, long addressnew)
{
    asm("
           FILL8	%r0, %i1             			
           ST8S		[%i2], %r0, 0
  				
           FILL8	%r0, %i0             			
           ST8S		[%i2], %r0, 1
		");	
}

void Display::DRAWZEROPOPUP(int channel)
{
	int x, y;
	int pos = 0;
	int volt = 0;
	
	
	float voltoff = 0;
	char voltstrn[20];
	char voltunit[3] = "uV";	
	
	unsigned char PixelBuffer;

	double factor = 0;
	double ffactor = 0;	
	
	short *fprobe = 0;
	int *fzeropos = 0;
	volatile char *fselected_voltage = 0;
	
	Hardware::ResetTimer();

	switch (channel)
	{
		case 1:
		{
			fprobe = &MenuStatus[1][3];
			fselected_voltage = &Selected_Voltage_CH1;
			fzeropos = &ZeroLevelCH1;			
			break;
		}	
		case 2:
		{
			fprobe = &MenuStatus[2][3];
			fselected_voltage = &Selected_Voltage_CH2;
			fzeropos = &ZeroLevelCH2;
			break;
		}
		case 3:
		{
			fprobe = &MenuStatus[3][3];
			fselected_voltage = &Selected_Voltage_CH3;
			fzeropos = &ZeroLevelCH3;
			break;
		}
		case 4:
		{
			fprobe = &MenuStatus[4][3];
			fselected_voltage = &Selected_Voltage_CH4;
			fzeropos = &ZeroLevelCH4;
			break;
		}
	}
	
	if ((channel != dzp_channel_buf) || (*fprobe != dzp_fprobe_buf) || (*fselected_voltage != dzp_fselected_voltage_buf))
	{								
		switch((int) *fselected_voltage)
		{
			case 0:	 factor = 20.833333; break;
			case 1:	 factor = 41.666666; break;
			case 2:	 factor = 104.166666; break;
			case 3:	 factor = 208.333333; break;
			case 4:	 factor = 416.666666; break;
			case 5:	 factor = 1041.666666; break;
			case 6:	 factor = 2083.33333; break;
			case 7:	 factor = 4166.66666; break;
			case 8:	 factor = 10416.6666; break;
			case 9:	 factor = 20833.3333; break;
			case 10: factor = 41666.6666; break;
			case 11: factor = 104166.66; break;																						
		}

		switch ((int) *fprobe)
		{
			case 101: ffactor = 10000000; break;
			case 102: ffactor = 5000000; break;
			case 103: ffactor = 2000000; break;
			case 104: ffactor = 1000000; break;
			case 105: ffactor = 500000; break;
			case 106: ffactor = 200000; break;
			case 107: ffactor = 100000; break;
			case 108: ffactor = 50000; break;
			case 109: ffactor = 20000; break;
			case 110: ffactor = 10000; break;
			case 111: ffactor = 5000; break;
			case 112: ffactor = 2000; break;
			case 113: ffactor = 1000; break;
		}
			
		factor = factor / ffactor;
		
		dzp_factor_buf = factor;
		dzp_channel_buf = channel;
		dzp_fprobe_buf = *fprobe;
		dzp_fselected_voltage_buf = *fselected_voltage;
	}
	else factor = dzp_factor_buf;
		
	voltoff =  (float)(*fzeropos - 0xC0) * factor;  // Mitte ist 192 (0xC0) =>  Mitte 128 (0x80) * 1.5
					
	switch (channel)
	{
		case 1:			
		{
			Zero_Level1_Str.Write_Value(voltoff);	
			Zero_Level1_Str.RenderText();
			break;
		}
		case 2:	
		{
			Zero_Level2_Str.Write_Value(voltoff);	
			Zero_Level2_Str.RenderText();
			break;
		}
		case 3:			
		{
			Zero_Level3_Str.Write_Value(voltoff);	
			Zero_Level3_Str.RenderText();
			break;
		}
		case 4:			
		{
			Zero_Level4_Str.Write_Value(voltoff);	
			Zero_Level4_Str.RenderText();
			break;
		}
	}	
	if (ZeroPopupChanged == 0)
	{
		//DRAWP(450, 51, 160, 22, 1, UI_Plane1);	
		//DRAWP(450, 51, 160, 22, 1, Buffer_UI2Plane);
		
		DRAWROUNDBUTTON(447, 51, 166, 25, btnUnpushed, btnDraw);
		
	}
	else DRAWP(460, 51, 150, 21, 0, UI_Plane2);
	
	ZeroPopupChanged = 1;		
	
	switch (channel)
	{
		case 1:	TEXTOUTxvbig(Zero_Level1_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 2:	TEXTOUTxvbig(Zero_Level2_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 3:	TEXTOUTxvbig(Zero_Level3_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 4:	TEXTOUTxvbig(Zero_Level4_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text
	}
	//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
}

void Display::DRAWZEROPOPDOWN(void)
{
	char Ct;
	
	int xa = 50 * 20;
	
	for (Ct = 0; Ct < 24; Ct++)
	{			
		*(UI_Plane1 + xa + 14) = 0; *(UI_Plane1 + xa + 15) = 0; *(UI_Plane1 + xa + 16) = 0; *(UI_Plane1 + xa + 17) = 0; *(UI_Plane1 + xa + 18) = 0; *(UI_Plane1 + xa + 19) = *(UI_Plane1 + xa + 19) & 0x0000000F;
		*(Buffer_UI2Plane + xa + 14) = 0; *(Buffer_UI2Plane + xa + 15) = 0; *(Buffer_UI2Plane + xa + 16) = 0; *(Buffer_UI2Plane + xa + 17) = 0; *(Buffer_UI2Plane + xa + 18) = 0; *(Buffer_UI2Plane + xa + 19) = *(Buffer_UI2Plane + xa + 19) & 0x0000000F;
		*(UI_Plane3 + xa + 14) = 0; *(UI_Plane3 + xa + 15) = 0; *(UI_Plane3 + xa + 16) = 0; *(UI_Plane3 + xa + 17) = 0; *(UI_Plane3 + xa + 18) = 0; *(UI_Plane3 + xa + 19) = *(UI_Plane3 + xa + 19) & 0x0000000F;
		*(UI_Plane4 + xa + 14) = 0; *(UI_Plane4 + xa + 15) = 0; *(UI_Plane4 + xa + 16) = 0; *(UI_Plane4 + xa + 17) = 0; *(UI_Plane4 + xa + 18) = 0; *(UI_Plane4 + xa + 19) = *(UI_Plane4 + xa + 19) & 0x0000000F;
		*(UI_Plane5 + xa + 14) = 0; *(UI_Plane5 + xa + 15) = 0; *(UI_Plane5 + xa + 16) = 0; *(UI_Plane5 + xa + 17) = 0; *(UI_Plane5 + xa + 18) = 0; *(UI_Plane5 + xa + 19) = *(UI_Plane5 + xa + 19) & 0x0000000F;
		xa += 20;
	}	
	ZeroPopupChanged = 0;
	UpdateMenuTextPlane = true;
}

void Display::PreInterpolate(int timebase, int fir_start, unsigned char *InterpolateBuff, unsigned char *SignalData, unsigned char *InterpolateResult)
{
    int ix;

    if (timebase == 2)
	{
		for (ix = 0; ix < 151; ix++)
		{
			InterpolateBuff[ix] = SignalData[(fir_start - 10) + ix];
		}

		// Interpolate Data
		Interpolate(InterpolateBuff, 5, 124, InterpolateResult);
	}
	else if (timebase == 3)
	{
		for (ix = 0; ix < 301; ix++)
		{
			InterpolateBuff[ix] = SignalData[(fir_start - 10) + ix];
		}

		// Interpolate Data
		Interpolate(InterpolateBuff, 5, 244, InterpolateResult);

		for (ix = 0; ix < 601; ix++)
		{
            InterpolateResult[ix] = InterpolateResult[ix << 1];
        }        	
	}
}

void Display::Interpolate(unsigned char *RawData, int start, int stop, unsigned char *DisplayData)
{
	int n, si, ci, oi, t2 = 0;
	long temp = 0;
			
	oi = 0;
	for (n = start; n <= stop; n++)
	{
		for (si = 0; si <= 4; si++)
		{
			temp = 0;
			for (ci = -4; ci <= 4; ci++)
			{
                temp = temp + FIR_Tab_big[RawData[n + ci]][si][ci + 4];
			}

			DisplayData[oi++] = short (Hardware::EXTRACTADCVAL(3, temp));
		}		
	}
	//interpolation
	//printf("start : %d - stop : %d - oi : %d \n", start, stop, oi);
}

void Display::DRAWSIGNALS(unsigned char on)	// Draw Signal
{
    short rollmode_offset_buf = 0;
    int ix2;
    int bufdata;

    float SIGNAL_1_rel = 0, SIGNAL_2_rel = 0, SIGNAL_3_rel = 0, SIGNAL_4_rel = 0;
    float SIGNAL_1_fac = 0, SIGNAL_2_fac = 0, SIGNAL_3_fac = 0, SIGNAL_4_fac = 0;

    unsigned int ldataa, lzeroa, ldiva, ltempa, ldatab, lzerob, ldivb, ltempb, lprefix;

    //if (on == 0) DrawSignals_Needed = 1;

    if ((UserIface_active) || (DrawSignals_Needed != 1) || (Splash_drawed == true))  return;
 	
// TMW added
	if ( Menu_Popup_visible )  {	// if a menu popup is visible, do the same as Oli's below
									// however, do not write signals in planes
        if (Channel_1_Active == 1) DrawPlane |= 0x01;	
        if (Channel_2_Active == 1) DrawPlane |= 0x02;	
        if (Channel_3_Active == 1) DrawPlane |= 0x04;	
        if (Channel_4_Active == 1) DrawPlane |= 0x08;	
       	ClearPlane = DrawPlane | RemovePlane;
        DrawPlane = 0;	
        DrawSignals_Needed = 0;
        if ((SingleMode == false) && 
			(Continius) && 
			(OneShotRestart == false) && 
			(UserIface_active == false)&& 
			(ROLLMODE_STARTED == false)) Hardware::Start_Record();
		return;
	}
// TMW add ends

    if (DrawSignals_Needed)
    {
        if (Selected_Timebase < 4)
        {
            draw_start = 0;
            draw_stop = 600;
        }
        else
        {
            ////draw_start = (short) ((float)(Trig_Mem_Pos) * OFT_float) + 40;
            draw_start = (short) Trig_Mem_Pos + 40;
	
            if (draw_start < 0) draw_start = 0;
	
            draw_stop = draw_start + SIG_Size[ZIT_short] - 1;
            
            draw_factor = (int) ZFT_float;

        }

  //      printf("*** tbo %d if %d io %d st %d sfi %d sta %d sto %d\n", Timebase_Offset_Pos, ixfactor, ixoffset, Selected_Timebase, SIGNALFaktor_idx, draw_start, draw_stop);

        if (MenuStatus[10][1] == 1)
        {
            if (dmode_Selected_Timebase < 4)
            {
                draw_dm_ixstart = 1;
                draw_dm_ixstop = 599;

                draw_dm_ixfactor = (short) ZFT_float_dmode;	

                draw_dm_ixoffset = (short) ((float) dmode_Window_Offset_Pos * ZFT_float) + (Trig_Mem_Pos + 40);

            }
            else
            {
                ////draw_dm_ixstart = ((short) ((float)(Trig_Mem_Pos) * OFT_float) + 40) + (short)((float)((300 - (short) (Cursor_Delayed_Size / 2)) + dmode_Window_Offset_Pos) * ZFT_float);
                draw_dm_ixstart = (Trig_Mem_Pos + 40) + (short)((float)((300 - (short) (Cursor_Delayed_Size / 2)) + dmode_Window_Offset_Pos) * ZFT_float);
                
                draw_dm_ixstop = draw_dm_ixstart + SIG_Size[ZIT_short_dmode];
                
                draw_dm_ixfactor = (short) ZFT_float_dmode;	

                // mu geklrt werden warum bei dieser timebase ein versatz ist. wahrscheinlich liegt es an der zeichen routine
                if (dmode_Selected_Timebase == 4) draw_dm_ixstart += 20;
                
                //printf("Thats 5 = ddstart : %d ddstop : %d  CDS : %d  dWOP : %d  ZTF : %f  ddfactor : %d\n", draw_dm_ixstart, draw_dm_ixstop, Cursor_Delayed_Size, dmode_Window_Offset_Pos, ZFT_float, ZFT_float_dmode);

            }
            //if (Debug_Mode) printf("ooo dmif %d dmio %d dmto %d dmst %d dmsfi %d   dm_sta %d dm_sto %d\n", dm_ixfactor, dm_ixoffset, dmode_Window_Offset_Pos, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dm_ixstart, dm_ixstop);
        }                         /*
        else if (MenuStatus[10][2] == 1)
        {
            rollmode_offset_buf = ROLLMODE_OFFSET;
            draw_start = ROLLMODE_OFFSET;
            draw_stop = 598;
        }                           */

//#ifdef _Debug_
        if (Debug_Mode)
        {
            printf("Startx %d  Stopx %d  SIGS %d  st %d  sfi %d  \n", draw_start, draw_stop, SIG_Start_Stop[ZIT_short][0], Selected_Timebase, SIGNALFaktor_idx);
            printf("top %d  Zoom_Index_Table % d  oft %f   \n", Timebase_Offset_Pos, ZIT_short, OFT_float);
            printf("pre %d  trop %d\n", pre_reg, Trigger_Offset_Pos);
        }
//#endif
         /*
 	    if (Channel_1_Active == 1)
        {	
            if (SIGNALFaktor_idx == 0) DRAWSIG(1, 1, rollmode_offset_buf, &SIGNAL1[0], 1);
            else DRAWSIG2(1, 1, draw_factor, rollmode_offset_buf, &SIGNAL1[0], 1);

            DrawPlane |= 0x01;	
        }

 	    if (Channel_2_Active == 1)
        {	
            if (SIGNALFaktor_idx == 0) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2[0], 1);
            else DRAWSIG2(1, 1, draw_factor, rollmode_offset_buf, &SIGNAL2[0], 1);

            DrawPlane |= 0x02;	
        }
         */
 	    if (Channel_1_Active == 1)
        {	
	        if (Display_Mode) DRAWXY(1, on);
	        else if (MenuStatus[1][0] == 6)
            {
                //DRAWZEROLINE(ZeroLevelCH1, 1, Channel_Plane1);
                DRAWZEROLINE(ZeroLevelCH1, 1, Buffer_Plane1);
            }
            else
            {
                if (Selected_Timebase < 4)
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG(1, 1, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                                else DRAWSIG2(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);
                                else DRAWSIG2(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);
                            }
                        }
                    }
                    else
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 1, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                            	if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);
                                else DRAWSIG2_vector(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate[0], on);
                            }
                        }
                    }
                }
                else
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG(1, 1, rollmode_offset_buf, &SIGNAL1[0], on);
                        else DRAWSIG2(1, 1, draw_factor, rollmode_offset_buf, &SIGNAL1[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                           // printf("dst %d dsfi %d\n", dmode_Selected_Timebase, dmode_SIGNALFaktor_idx);

                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                                else DRAWSIG2(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(1, 2, rollmode_offset_buf, &SIGNAL1[0], on);
                                else DRAWSIG2(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1[0], on);
                            }
                        }
                    }
                    else
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 1, rollmode_offset_buf, &SIGNAL1[0], on);
                        else DRAWSIG2_vector(1, 1, draw_factor, rollmode_offset_buf, &SIGNAL1[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 2, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(1, 2, rollmode_offset_buf, &SIGNAL1[0], on);
                                else DRAWSIG2_vector(1, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL1[0], on);
                            }
                        }
                    }
                }
            }
            DrawPlane |= 0x01;	
        }
 	    
 	    if (Channel_2_Active == 1)
        {	
	        if (Display_Mode) DRAWXY(2, on);
	        else if (MenuStatus[2][0] == 6)
            {
                DRAWZEROLINE(ZeroLevelCH2, 1, Buffer_Plane1);
            }
            else
            {
                if (Selected_Timebase < 4)
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                            }
                        }
                    }
                    else
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                            }
                        }
                    }
                }
                else
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2[0], on);
                        else DRAWSIG2(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2[0], on);
                            }
                        }
                    }
                    else
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 1, rollmode_offset_buf, &SIGNAL2[0], on);
                        else DRAWSIG2_vector(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2[0], on);
                            }
                        }
                    }
                }
            }
            DrawPlane |= 0x02;	
        }
/* 	    
	    if (Channel_2_Active == 1)
        {
            //if ((Display_Timebase => 4) && (Display_Timebase =< 6)) rollmode_offset_buf = rollmode_offset_buf - 5;

            //if (Selected_Timebase < 4) PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate[0]);
	        if (Display_Mode) DRAWXY(2, on);
	        else if (MenuStatus[2][0] == 6)
            {
                //DRAWZEROLINE(ZeroLevelCH2, 1, Channel_Plane2);
                DRAWZEROLINE(ZeroLevelCH2, 1, Buffer_Plane2);
            }	
            else
            {
                if (Selected_Timebase < 4)
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                        else DRAWSIG2(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                            }
                        }
                    }
                    else
                    {
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                        else DRAWSIG2_vector(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                            }
                        }

                    }
                }
                else
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG(2, 1, rollmode_offset_buf, &SIGNAL2[0], on);
                        else DRAWSIG2(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                           // printf("dst %d dsfi %d\n", dmode_Selected_Timebase, dmode_SIGNALFaktor_idx);

                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(2, 2, rollmode_offset_buf, &SIGNAL2[0], on);
                                else DRAWSIG2(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2[0], on);
                            }
                        }
                    }
                    else
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG_vector(2, 1, rollmode_offset_buf, &SIGNAL2_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 1, rollmode_offset_buf, &SIGNAL2[0], on);
                        else DRAWSIG2_vector(2, 1, draw_factor, rollmode_offset_buf, &SIGNAL2[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(2, 2, rollmode_offset_buf, &SIGNAL2[0], on);
                                else DRAWSIG2_vector(2, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL2[0], on);
                            }
                        }
                    }
                }
            }

	        DrawPlane |= 0x02;
        }
*/    	
    	
        if (NumberOfChannels > 2)
        {
            if (Channel_3_Active == 1)
            {
                //if (Selected_Timebase < 4) PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate[0]);
                if (Display_Mode) DRAWXY(3, on);
                else if (MenuStatus[3][0] == 6)
                {
                    //DRAWZEROLINE(ZeroLevelCH3, 1, Channel_Plane3);
                    DRAWZEROLINE(ZeroLevelCH3, 1, Buffer_Plane3);
                }
                else
                {
                    if (Selected_Timebase < 4)
                    {
                        if (MenuStatus[5][3] == 241)
                        {
                            if (SIGNALFaktor_idx == 0) DRAWSIG(3, 1, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                            else DRAWSIG2(3, 1, draw_factor, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                    else DRAWSIG2(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                                    else DRAWSIG2(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                                }
                            }
                        }
                        else
                        {
                            if (SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 1, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                            else DRAWSIG2_vector(3, 1, draw_factor, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                    else DRAWSIG2_vector(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                                    else DRAWSIG2_vector(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                                }
                            }
                        }
                    }
                    else
                    {
                        if (MenuStatus[5][3] == 241)
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG(3, 1, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG(3, 1, rollmode_offset_buf, &SIGNAL3[0], on);
                            else DRAWSIG2(3, 1, draw_factor, rollmode_offset_buf, &SIGNAL3[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                // printf("dst %d dsfi %d\n", dmode_Selected_Timebase, dmode_SIGNALFaktor_idx);

                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                    else DRAWSIG2(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(3, 2, rollmode_offset_buf, &SIGNAL3[0], on);
                                    else DRAWSIG2(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3[0], on);
                                }
                            }
                        }
                        else
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG_vector(3, 1, rollmode_offset_buf, &SIGNAL3_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 1, rollmode_offset_buf, &SIGNAL3[0], on);
                            else DRAWSIG2_vector(3, 1, draw_factor, rollmode_offset_buf, &SIGNAL3[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 2, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                    else DRAWSIG2_vector(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(3, 2, rollmode_offset_buf, &SIGNAL3[0], on);
                                    else DRAWSIG2_vector(3, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL3[0], on);
                                }
                            }
                        }
                    }
                }
                DrawPlane |= 0x04;
            }

            if (Channel_4_Active == 1)
            {
                //if (Selected_Timebase < 4) PreInterpolate(Selected_Timebase, FirStartCH + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate[0]);
                if (Display_Mode) DRAWXY(4, on);
                else if (MenuStatus[4][0] == 6)
                {
                    //DRAWZEROLINE(ZeroLevelCH4, 1, Channel_Plane4);
                    DRAWZEROLINE(ZeroLevelCH4, 1, Buffer_Plane4);
                }
                else
                {
                    if (Selected_Timebase < 4)
                    {
                        if (MenuStatus[5][3] == 241)
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            else DRAWSIG2(4, 1, draw_factor, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                    else DRAWSIG2(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                                    else DRAWSIG2(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                                }
                            }
                        }
                        else
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG_vector(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            else DRAWSIG2_vector(4, 1, draw_factor, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                    else DRAWSIG2_vector(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                                    else DRAWSIG2_vector(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                                }
                            }
                        }
                    }
                    else
                    {
                        if (MenuStatus[5][3] == 241)
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG(4, 1, rollmode_offset_buf, &SIGNAL4[0], on);
                            else DRAWSIG2(4, 1, draw_factor, rollmode_offset_buf, &SIGNAL4[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                // printf("dst %d dsfi %d\n", dmode_Selected_Timebase, dmode_SIGNALFaktor_idx);

                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                    else DRAWSIG2(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(4, 2, rollmode_offset_buf, &SIGNAL4[0], on);
                                    else DRAWSIG2(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4[0], on);
                                }
                            }
                        }
                        else
                        {
                            //if (MenuStatus[10][2] == 1) DRAWSIG_vector(4, 1, rollmode_offset_buf, &SIGNAL4_Intpolate[0], on);
                            //else
                            if (SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 1, rollmode_offset_buf, &SIGNAL4[0], on);
                            else DRAWSIG2_vector(4, 1, draw_factor, rollmode_offset_buf, &SIGNAL4[0], on);

                            if (MenuStatus[10][1] == 1)
                            {
                                if (dmode_Selected_Timebase < 4)
                                {
                                    PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed + Trigger_Offset_Calc, &SIGNAL_IntBuf[0], &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]);

                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 2, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                    else DRAWSIG2_vector(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4_Intpolate_delayed[0], on);
                                }
                                else
                                {
                                    if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(4, 2, rollmode_offset_buf, &SIGNAL4[0], on);
                                    else DRAWSIG2_vector(4, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNAL4[0], on);
                                }
                            }
                        }
                    }
                }
	           DrawPlane |= 0x08;
           }
       }

	    if (Channel_Math_Active == 1)
        {
            if (MenuStatus[26][1] == 1)
            {
                DRAWSIG(5, 1, rollmode_offset_buf, &SIGNALM[0], on);
            }
            else
            {

            //if (Selected_Timebase < 4) PreInterpolate(Selected_Timebase, FirStartCH, &SIGNAL_IntBuf[0], &SIGNALM[0], &SIGNALM_Intpolate[0]);
	        if (Display_Mode == 0)
            {
                if (Selected_Timebase < 4)
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        else DRAWSIG2(5, 1, draw_factor, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed, &SIGNAL_IntBuf[0], &SIGNALM[0], &SIGNALM_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                                else DRAWSIG2(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                                else DRAWSIG2(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                            }
                        }
                    }
                    else
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG_vector(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        else DRAWSIG2_vector(5, 1, draw_factor, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed, &SIGNAL_IntBuf[0], &SIGNALM[0], &SIGNALM_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                                else DRAWSIG2_vector(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                            }
                        }
                    }
                }
                else
                {
                    if (MenuStatus[5][3] == 241)
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG(5, 1, rollmode_offset_buf, &SIGNALM[0], on);
                        else DRAWSIG2(5, 1, draw_factor, rollmode_offset_buf, &SIGNALM[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                           // printf("dst %d dsfi %d\n", dmode_Selected_Timebase, dmode_SIGNALFaktor_idx);

                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed, &SIGNAL_IntBuf[0], &SIGNALM[0], &SIGNALM_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                                else DRAWSIG2(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG(5, 2, rollmode_offset_buf, &SIGNALM[0], on);
                                else DRAWSIG2(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM[0], on);
                            }
                        }
                    }
                    else
                    {
                        //if (MenuStatus[10][2] == 1) DRAWSIG_vector(5, 1, rollmode_offset_buf, &SIGNALM_Intpolate[0], on);
                        //else
                        if (SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 1, rollmode_offset_buf, &SIGNALM[0], on);
                        else DRAWSIG2_vector(5, 1, draw_factor, rollmode_offset_buf, &SIGNALM[0], on);

                        if (MenuStatus[10][1] == 1)
                        {
                            if (dmode_Selected_Timebase < 4)
                            {
                                PreInterpolate(dmode_Selected_Timebase, FirStartCH_delayed, &SIGNAL_IntBuf[0], &SIGNALM[0], &SIGNALM_Intpolate_delayed[0]);

                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 2, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                                else DRAWSIG2_vector(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM_Intpolate_delayed[0], on);
                            }
                            else
                            {
                                if (dmode_SIGNALFaktor_idx == 0) DRAWSIG_vector(5, 2, rollmode_offset_buf, &SIGNALM[0], on);
                                else DRAWSIG2_vector(5, 2, draw_dm_ixfactor, rollmode_offset_buf, &SIGNALM[0], on);
                            }
                        }
                    }
                }
            }
            }
	        DrawPlane |= 0x10;
        }
       	
        ClearPlane = DrawPlane | RemovePlane;
        DrawPlane = 0;	
        DrawSignals_Needed = 0;

        if (on)
        {
            /*
            if (screen_sel == 0) screen_sel = 1;
            else screen_sel = 0;
            */
            //Clear_Flips();

            //reset_watchdog->np_piodata = screen_sel;


            if (Debug_Mode) printf("watchdog = %d\n", screen_sel);
        }
	
        if ((QM_Enabled) && (QM_Type[0] > 0)) Display::CALCQMDATA();
	
//	   while (ClearPlane) asm("nop");

        if ((SingleMode == false) && (Continius) && (OneShotRestart == false) && (UserIface_active == false)&& (ROLLMODE_STARTED == false)) Hardware::Start_Record();
    }
}

void Display::Clear_Flips(void)
{
    return;

    if (screen_sel == 0)
    {
        if (NumberOfChannels == 2) Hardware::Planes_clear_asm_all(3, 0x009311F0, 0x0093A7F0, 0x009569F0, 0x00000000, 0x00000000);
        else Hardware::Planes_clear_asm_all(5, 0x009311F0, 0x0093A7F0, 0x00943DF0, 0x0094D3F0, 0x009569F0);
        /*
        Hardware::Planes_clear_asm(0x009311F0);
        Hardware::Planes_clear_asm(0x0093A7F0);
        Hardware::Planes_clear_asm(0x00943DF0);
        Hardware::Planes_clear_asm(0x0094D3F0);
        Hardware::Planes_clear_asm(0x009569F0);
        */
    }
    else
    {
        if (NumberOfChannels == 2) Hardware::Planes_clear_asm_all(3, 0x0098EDF0, 0x009983F0, 0x009B45F0, 0x00000000, 0x00000000);
        else Hardware::Planes_clear_asm_all(5, 0x0098EDF0, 0x009983F0, 0x009A19F0, 0x009AAFF0, 0x009B45F0);
        /*
        Hardware::Planes_clear_asm(0x0098EDF0);
        Hardware::Planes_clear_asm(0x009983F0);
        Hardware::Planes_clear_asm(0x009A19F0);
        Hardware::Planes_clear_asm(0x009AAFF0);
        Hardware::Planes_clear_asm(0x009B45F0);
        */
    }
    if (Debug_Mode) printf("clear flips\n");
}

//void Display::CopySignal(unsigned long *Buffer_Adr1, unsigned long *Plane_Adr1, unsigned long *Buffer_Adr2, unsigned long *Plane_Adr2, unsigned long *Buffer_Adr3, unsigned long *Plane_Adr3, unsigned char count)
void Display::CopySignal(unsigned long Buffer_Adr1, unsigned long Plane_Adr1, unsigned long Buffer_Adr2, unsigned long Plane_Adr2, unsigned long Buffer_Adr3, unsigned long Plane_Adr3, unsigned char count)
{
    return;

	switch(count)
	{
	    case 1 :
	    {
	        asm("
                    PFX	    %hi(4096)                         ; Set Counter
                    MOVI	%l1,%lo(4096)

                    loopcs1:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     loopcs1
                    NOP 	
                ");
            break;
        }
	    case 2 :
	    {
	        asm("
                    PFX	    %hi(4096)                         ; Set Counter
                    MOVI	%l1,%lo(4096)
	
                    loopcs2:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane
                                                              	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     loopcs2
                    NOP 	
                ");
            break;
        }

	    case 3 :
	    {
	        asm("
                    PFX	    %hi(4096)                         ; Set Counter
                    MOVI	%l1,%lo(4096)
	
                    loopcs3:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     loopcs3
                    NOP 	
                ");
            break;
        }
	    case 4 :
	    {
	        asm("
                    PFX	    %hi(4096)                         ; Set Counter
                    MOVI	%l1,%lo(4096)

                    loopcs4:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane
                          	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     loopcs4
                    NOP 	
                ");
            break;
        }                        	
	    case 5 :
	    {
	        asm("
                    PFX	    %hi(4096)                         ; Set Counter
                    MOVI	%l1,%lo(4096)

                    loopcs5:
                    LD     %l0, [%i0]                        ; Load Buffer Data to %r0 	
                    ST     [%i1], %l0                        ; Store it to Plane

                    LD     %l0, [%i2]                        ; Load Buffer Data to %r0
                    ST     [%i3], %l0                        ; Store it to Plane

                    LD     %l0, [%i4]                        ; Load Buffer Data to %r0
                    ST     [%i5], %l0                        ; Store it to Plane

                    LD     %l0, [%r4]                        ; Load Buffer Data to %r0
                    ST     [%r5], %l0                       ; Store it to Plane

                    LD     %l0, [%r6]                        ; Load Buffer Data to %r0
                    ST     [%r7], %l0                       ; Store it to Plane
                                                               	
                    ADDI   %i0, 4                            ; Add Address Counter
                    ADDI   %i1, 4	

                    ADDI   %i2, 4
                    ADDI   %i3, 4	

                    ADDI   %i4, 4
                    ADDI   %i5, 4	

                    ADDI   %r4, 4
                    ADDI   %r5, 4	
	
                    ADDI   %r6, 4
                    ADDI   %r7, 4		
	
                    SUBI   %l1, 1                            ; Decrement Line Counter
                    SKPS   cc_z
                    BR     loopcs5
                    NOP 	
                ");
            break;
        }
    }
}

void Display::DRAWSIG(unsigned int inr, unsigned char windows, short offset, unsigned char *DisplayData, unsigned char on)	// Draw Signal
{
	int ix, iy, ixs, ixss, posx, off_buf = 0;

	volatile short P1 = 0;
	volatile short P2 = 0;
	volatile short P3 = 0;		
	
	volatile short shift_factor = 1;
	volatile short display_min = 1;
	volatile short display_max = 387;    	
	volatile short signal_offset = 60;	

	int merker = 0;
	int end_merker = 0;	
	unsigned long *icolor = NULL;
	short *pix = 0;
	int *pzero = 0;	
	int limit = 386;
	
	int p_mul_value = 0;
	int p_mul_factor = 0;	
	
    short ixstart = 0;
    short ixstop = 0;

    int TOC_Buf = Trigger_Offset_Calc;

    //if ((Selected_Timebase < 4) || (MenuStatus[10][2] == 1) || (MenuStatus[26][1] == 1)) TOC_Buf = 0;
    if ((Selected_Timebase < 4) || (MenuStatus[26][1] == 1)) TOC_Buf = 0;

	if (windows == 1)
    {	
        ixstart = draw_start;	
        ixstop = draw_stop - 1;
    }
    else
    {	
        ixstart = draw_dm_ixstart;	
        ixstop = draw_dm_ixstop - 1;
        TOC_Buf = 0;
    }
    
    if (MenuStatus[26][1] == 1)
    {
        ixstart = 0;
        ixstop = 600;
    }
		
	if (inr == 1)											// Pointer to Data Array
	{		
	
        icolor = Buffer_Plane1;

		off_buf = CH1_Zero_Offset + ZeroLevelCH1_cor_offset;
		p_mul_factor = Voltage_Correction[0][Selected_Voltage_CH1];
		
		//if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + CH1OffsetX;

	}	

	if (inr == 2)											// Pointer to Data Array
	{
        icolor = Buffer_Plane2; 							

		off_buf = CH2_Zero_Offset + ZeroLevelCH2_cor_offset;
		p_mul_factor = Voltage_Correction[1][Selected_Voltage_CH2];
		
        if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + 10;
	}
	
	if (inr == 3)											// Pointer to Data Array
	{	

        icolor = Buffer_Plane3;	

		off_buf = CH3_Zero_Offset + ZeroLevelCH3_cor_offset;
		p_mul_factor = Voltage_Correction[2][Selected_Voltage_CH3];

		//if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + CH3OffsetX;
	}
	if (inr == 4)											// Pointer to Data Array
	{						

        icolor = Buffer_Plane4;		

        off_buf = CH4_Zero_Offset + ZeroLevelCH4_cor_offset;
		p_mul_factor = Voltage_Correction[3][Selected_Voltage_CH4];

		//if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + CH4OffsetX;
	}	
	if (inr == 5)											// Pointer to Data Array
	{	

        icolor = Buffer_PlaneM;
        	
        off_buf = 0;
		p_mul_factor = 0;

	}

    posx = 20 + offset;

    if (MenuStatus[10][1] == 1)
    {
        shift_factor = 0;
        signal_offset = 30;

        if (windows == 1)
        {
            display_min = 1;
            display_max = 190;
        }
        else
        {
            off_buf += 194;
            display_min = 194;
            display_max = 384;
        }
    }
    else
    {
        shift_factor = 1;
        display_min = 1;
        display_max = 387;
        signal_offset = 60;
    }

    P2 = (short) DisplayData[ixstart + 0 + TOC_Buf];
    P3 = (short) DisplayData[ixstart + 1 + TOC_Buf];

    if (multi_active)
    {
        p_mul_value = P2 - 128;
        P2 = nm_mult(p_mul_value, p_mul_factor);

        p_mul_value = P3 - 128;
        P3 = nm_mult(p_mul_value, p_mul_factor);
    }

    P2 = (P2 << shift_factor) - signal_offset + off_buf;
    P3 = (P3 << shift_factor) - signal_offset + off_buf;


    if (P2 > display_max) P2 = display_max;
    if (P2 < display_min) P2 = display_min;
    if (P3 > display_max) P3 = display_max;
    if (P3 < display_min) P3 = display_min;

#ifdef _Debug_
    if (Debug_Mode) printf("start sig %d  TOC %d\n", ixstart, TOC_Buf);
#endif
            		
	//for (ix = ixstart; ix < ixstop; ix++)								// Draw Holy Screen
	for (ix = ixstart + 2 + TOC_Buf; ix < ixstop + TOC_Buf; ix++)								// Draw Holy Screen
	{
	
        posx++;

		P1 = P2;
		P2 = P3;		
		P3 = (short) DisplayData[ix];

        if (multi_active)
        {
            p_mul_value = P3 - 128;
            P3 = nm_mult(p_mul_value, p_mul_factor);
        }

        P3 = (P3 << shift_factor) - signal_offset + off_buf;

        if (P3 > display_max) P3 = display_max;
        if (P3 < display_min) P3 = display_min;

        //if (P3 > display_max) P3 = 0;
        //if (P3 < display_min) P3 = 387;


        //Fall 1   ( 1 == 2 == 3 )
		if ((P1 == P2) && (P2 == P3))
		{
			PIXELP(posx, P1 + correction, on, icolor);
		}

		//Fall 2   ( 1 < 2 < 3 )
		else if ((P1 < P2) && (P2 < P3))
		{
			if (P2 == P3)
			{			
				Connect_Pixels(posx, P1, P2, 1, icolor, on);
			}
			else
			{
				Connect_Pixels(posx, P1, P2, 1, icolor, on);
			}			
		}
	
		//Fall 3   ( 1 > 2 > 3 )
		else if ((P1 > P2) && (P2 > P3))
		{
			if (P2 == P3)
			{			
				Connect_Pixels(posx, P1, P2, 0, icolor, on);
			}
			else
			{
				Connect_Pixels(posx, P1, P2, 0, icolor, on);
			}			
		}				
	
		//Fall 4   ( 1 < 2 = 3 )
		else if ((P1 < P2) && (P2 == P3))
		{
			Connect_Pixels(posx, P1, P2, 1, icolor, on);		
		}	
		
		//Fall 5   ( 1 > 2 = 3 )
		else if ((P1 > P2) && (P2 == P3))
		{		
			Connect_Pixels(posx, P1, P2, 0, icolor, on);
		}		
		
		//Fall 6   ( 1 = 2 < 3 )
		else if ((P1 == P2) && (P2 < P3))
		{		
			PIXELP(posx, P1 + correction, on, icolor);
		}	
		
		//Fall 7   ( 1 = 2 > 3 )
		else if ((P1 == P2) && (P2 > P3))
		{		
			PIXELP(posx, P1 + correction, on, icolor); 	
		}			
	
		//Fall 8   ( 1 > 2 < 3 )
		else if ((P1 > P2) && (P2 < P3))
		{		
        	Connect_Pixels(posx, P1, P2, 0, icolor, on);
		}	
		
		//Fall 9   ( 1 < 2 > 3 )
		else if ((P1 < P2) && (P2 > P3))
		{	
        	Connect_Pixels(posx, P1, P2, 1, icolor, on);
		}	
		else PIXELP(posx, P1 + correction, on, icolor);	
	}	
}

void Display::DRAWSIG_vector(unsigned int inr, unsigned char windows, short offset, unsigned char *DisplayData, unsigned char on)	// Draw Signal
{
	int ix, iy, ixs, ixss, posx, off_buf = 0;

	short P1 = 0;

	unsigned long *icolor = NULL;
//	short *pix = 0;
	int *pzero = 0;	
	int limit = 386;
	
	int p_mul_value = 0;
	int p_mul_factor = 0;

	short shift_factor = 1;
	short display_min = 1;
	short display_max = 387;
	short signal_offset = 60;
	
    short ixstart = 0;
    short ixstop = 0;

    int TOC_Buf = Trigger_Offset_Calc;
    	
	if (windows == 1)
    {	
        ixstart = draw_start;	
        ixstop = draw_stop - 1;
    }
    else
    {	
        ixstart = draw_dm_ixstart;	
        ixstop = draw_stop - 1;
    }	
	
	if (inr == 1)											// Pointer to Data Array
	{														// Channel One & Zero

		icolor = Buffer_Plane1;//Channel_Plane1;
		//pix = &SIGNAL1[0];
		off_buf = CH1_Zero_Offset + ZeroLevelCH1_cor_offset;
		p_mul_factor = Voltage_Correction[0][Selected_Voltage_CH1];
	}	

	if (inr == 2)											// Pointer to Data Array
	{														// Channel Two & Zero
   	
		icolor = Buffer_Plane2;//Channel_Plane2;
		//pix = &SIGNAL2[0];
		off_buf = CH2_Zero_Offset + ZeroLevelCH2_cor_offset;
		p_mul_factor = Voltage_Correction[1][Selected_Voltage_CH2];
		
		if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + 10;
	}
	
	if (inr == 3)											// Pointer to Data Array
	{														// Channel Three & Zero

		icolor = Buffer_Plane3;//Channel_Plane3;
		//pix = &SIGNAL3[0];
		off_buf = CH3_Zero_Offset + ZeroLevelCH3_cor_offset;
		p_mul_factor = Voltage_Correction[2][Selected_Voltage_CH3];
	}
	if (inr == 4)											// Pointer to Data Array
	{														// Channel Four & Zero
    	
		icolor = Buffer_Plane4;//Channel_Plane4;
		//pix = &SIGNAL4[0];
        off_buf = CH4_Zero_Offset + ZeroLevelCH4_cor_offset;
		p_mul_factor = Voltage_Correction[3][Selected_Voltage_CH4];
	}	
	if (inr == 5)											// Pointer to Data Array
	{														// Channel Four & Zero
    	
		icolor = Buffer_PlaneM;//Channel_Plane4;
		//pix = &SIGNALM[0];
        off_buf = 0;
		p_mul_factor = 0;
	}	

    posx = 20 + offset;

    if (MenuStatus[10][1] == 1)
    {
        shift_factor = 0;
        signal_offset = 30;

        if (windows == 1)
        {
            display_min = 1;
            display_max = 190;
        }
        else
        {
            off_buf += 194;
            display_min = 194;
            display_max = 384;
        }
    }
    else
    {
        shift_factor = 1;
        display_max = 387;
        display_min = 1;
        signal_offset = 60;
    }
        		
	for (ix = ixstart; ix < ixstop; ix++)								// Draw Holy Screen
	{
        posx++;

		P1 = DisplayData[ix + TOC_Buf];//(*(pix + (ix + 0)));

        if (multi_active)
        {
            p_mul_value = P1 - 128;
            P1 = nm_mult(p_mul_value, p_mul_factor);
        }

        P1 = (P1 << shift_factor) - signal_offset + off_buf;

        if (P1 > display_max) P1 = display_max;
        if (P1 < display_min) P1 = display_min;

		PIXELP(posx, P1 + correction, on, icolor);
    }
}


void Display::DRAWSIG2(unsigned int inr, unsigned char windows, short factor, short offset, unsigned char *DisplayData, unsigned char on)	// Draw Signal
{
	int off_buf = 0, ix = 0;
	
	unsigned long *icolor = NULL;
	
	unsigned char *pix = 0;
	unsigned char *pix2 = 0;
//	unsigned char *pix3 = 0;	

	short P1 = 0;
	short P2 = 0;
	short P3 = 0;	

	short mem_factor = factor;	
	short shift_factor = 1;
	short display_min = 1;
	short display_max = 387;
	short signal_offset = 60;

	short P_Min = 0;	
	short P_Max = 0;	

	short P_Min_Pre = 0;	
	short P_Max_Pre = 0;	
    	
    short SIGNAL_SUM_CNT = 0;
    short SIGNAL_SUM_IX = 0;

    short ixstart = 0;
    short ixstop = 0;

	int p_mul_value = 0;
	int p_mul_factor = 0;
	
	int TOC_Buf = Trigger_Offset_Calc;

	if (windows == 1)
    {	
        ixstart = draw_start;	
        ixstop = draw_stop;
    }
    else
    {	
        ixstart = draw_dm_ixstart;	
        ixstop = draw_dm_ixstop;
    }

	if (inr == 1)											// Pointer to Data Array
	{	
		icolor = Buffer_Plane1;//Channel_Plane1;
		pix = &SIGNAL1_SUM_MIN[0];
		pix2 = &SIGNAL1_SUM_MAX[0];		
//		pix3 = &SIGNAL1[0];	
        off_buf	= CH1_Zero_Offset + ZeroLevelCH1_cor_offset;
        p_mul_factor = Voltage_Correction[0][Selected_Voltage_CH1];
	}	

	if (inr == 2)											// Pointer to Data Array
	{	
		icolor = Buffer_Plane2;//Channel_Plane2;
		pix = &SIGNAL2_SUM_MIN[0];
		pix2 = &SIGNAL2_SUM_MAX[0];	
//		pix3 = &SIGNAL2[0];	
        off_buf	= CH2_Zero_Offset + ZeroLevelCH2_cor_offset;	
        p_mul_factor = Voltage_Correction[1][Selected_Voltage_CH2];

        if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + 10;
	}
	
	if (inr == 3)											// Pointer to Data Array
	{		
		icolor = Buffer_Plane3;//Channel_Plane3;
		pix = &SIGNAL3_SUM_MIN[0];
		pix2 = &SIGNAL3_SUM_MAX[0];	
//		pix3 = &SIGNAL3[0];	
        off_buf	= CH3_Zero_Offset + ZeroLevelCH3_cor_offset;	
        p_mul_factor = Voltage_Correction[2][Selected_Voltage_CH3];
	}
	if (inr == 4)											// Pointer to Data Array
	{	
		icolor = Buffer_Plane4;//Channel_Plane4;
		pix = &SIGNAL4_SUM_MIN[0];
		pix2 = &SIGNAL4_SUM_MAX[0];	
//		pix3 = &SIGNAL4[0];	
        off_buf	= CH4_Zero_Offset + ZeroLevelCH4_cor_offset;	
        p_mul_factor = Voltage_Correction[3][Selected_Voltage_CH4];
	}		
	if (inr == 5)											// Pointer to Data Array
	{														// Channel Four & Zero
        icolor = Buffer_PlaneM;//Channel_Plane4;
		pix = &SIGNALM_SUM_MIN[0];
		pix2 = &SIGNALM_SUM_MAX[0];	
//		pix3 = &SIGNALM[0];	
        off_buf	= 0;	
		p_mul_factor = 0;

	}
	   		
//	reset_watchdog->np_piodata = 0x00;                                                                                                 	
			
//	printf("nr : %i st : %i sfi : %i faktor : %i  start : %i stop : %i so: %i\n", inr, Selected_Timebase, SIGNALFaktor_idx, factor, ixstart, ixstop, offset);		

    if (MenuStatus[10][1] == 1)
    {
        shift_factor = 0;
        signal_offset = 30;

        if (windows == 1)
        {
            display_min = 1;
            display_max = 190;
        }
        else
        {
            off_buf += 194;
            display_min = 194;
            display_max = 384;
        }
    }
    else
    {
        shift_factor = 1;
        display_min = 1;
        display_max = 387;
        signal_offset = 60;
    }

	SIGNAL_SUM_CNT = 0;
	SIGNAL_SUM_IX = 0;

    P_Min = 255;
    P_Max = 0;

    ix = ixstart;
    
	//for (ix = ixstart; ix < ixstop; ix++)
	while (SIGNAL_SUM_IX < 600)
	{
	    P3 = (short) DisplayData[ix + TOC_Buf];//(*(pix3 + ix));
	    ix++;
	    
        if (multi_active)
        {
            p_mul_value = P3 - 128;
            P3 = nm_mult(p_mul_value, p_mul_factor);
        }	
	
        if (P3 < P_Min) P_Min = P3;
	    if (P3 > P_Max) P_Max = P3;
			
        if (SIGNAL_SUM_CNT == factor)
        {
            if (mem_factor == 3)
            {
                if (factor == 2) factor = 3;
                else factor = 2;
            }

            if (Connect_Vals)
            {
                if (P_Min > P_Max_Pre) P_Min = P_Max_Pre;
                if (P_Max < P_Min_Pre) P_Max = P_Min_Pre;
            }
            /*
            // remove overlap
            if (P_Max > P_Min_Pre) P_Max = P_Min_Pre;
            if (P_Min > P_Max_Pre) P_Min = P_Max_Pre;
            */
            (*(pix + SIGNAL_SUM_IX)) = P_Min;
            (*(pix2 + SIGNAL_SUM_IX)) = P_Max;

            P_Min_Pre = P_Min;
            P_Max_Pre = P_Max;

            SIGNAL_SUM_IX++;
            SIGNAL_SUM_CNT = 0;

            P_Min = 255;
            P_Max = 0;
        }
		SIGNAL_SUM_CNT++;
    }
       		
	for (ix = 1; ix < 600; ix++)								// Draw Holy Screen
	{
		P1 = (*(pix + ix));
		P2 = (*(pix2 + ix));

        P1 = (P1 << shift_factor) - signal_offset + off_buf;
        P2 = (P2 << shift_factor) - signal_offset + off_buf;

        if (P1 > display_max) P1 = display_max;
        if (P1 < display_min) P1 = display_min;
        if (P2 > display_max) P2 = display_max;
        if (P2 < display_min) P2 = display_min;

        if (P1 < P2) Connect_Pixels(ix + 20 + offset, P1, P2, 1, icolor, on);
        else if (P1 > P2) Connect_Pixels(ix + 20 + offset, P1, P2, 0, icolor, on);
        else PIXELP(ix + 20 + offset, P1 + 18, on, icolor);
    }
//	reset_watchdog->np_piodata = 0x01;	    	
}

void Display::DRAWSIG2_vector(unsigned int inr, unsigned char windows, short factor, short offset, unsigned char *DisplayData, unsigned char on)	// Draw Signal
{
	int off_buf = 0, ix = 0;
	
	unsigned long *icolor = NULL;
	
	unsigned char  *pix = 0;
	unsigned char  *pix2 = 0;
//	short *pix3 = 0;	

	short P1 = 0;
	short P2 = 0;
	short P3 = 0;	
	
	short shift_factor = 1;
	short display_min = 1;
	short display_max = 387;
	short signal_offset = 60;

	short P_Min;	
	short P_Max;	
    	
    short SIGNAL_SUM_CNT;
    short SIGNAL_SUM_IX;

    short ixstart = 0;
    short ixstop = 0;

	int p_mul_value = 0;
	int p_mul_factor = 0;
	
	int TOC_Buf = Trigger_Offset_Calc;

	if (windows == 1)
    {	
        ixstart = draw_start;	
        ixstop = draw_stop - 2;
    }
    else
    {	
        ixstart = draw_dm_ixstart;	
        ixstop = draw_stop - 2;
    }    	

	if (inr == 1)											// Pointer to Data Array
	{	
		icolor = Buffer_Plane1;//Channel_Plane1;
		pix = &SIGNAL1_SUM_MIN[0];
		pix2 = &SIGNAL1_SUM_MAX[0];		
	//	pix3 = &SIGNAL1[0];	
        off_buf	= CH1_Zero_Offset + ZeroLevelCH1_cor_offset;
		p_mul_factor = Voltage_Correction[0][Selected_Voltage_CH1];
	}	

	if (inr == 2)											// Pointer to Data Array
	{														// Channel Two & Zero
		icolor = Buffer_Plane2;//Channel_Plane2;
		pix = &SIGNAL2_SUM_MIN[0];
		pix2 = &SIGNAL2_SUM_MAX[0];	
	//	pix3 = &SIGNAL2[0];	
        off_buf	= CH2_Zero_Offset + ZeroLevelCH2_cor_offset;
		p_mul_factor = Voltage_Correction[1][Selected_Voltage_CH2];

        if ((Selected_Timebase > 3) && (Selected_Timebase < 9)) TOC_Buf = TOC_Buf + 10;	
	}
	
	if (inr == 3)											// Pointer to Data Array
	{														// Channel Three & Zero
		icolor = Buffer_Plane3;//Channel_Plane3;
		pix = &SIGNAL3_SUM_MIN[0];
		pix2 = &SIGNAL3_SUM_MAX[0];	
	//	pix3 = &SIGNAL3[0];	
        off_buf	= CH3_Zero_Offset + ZeroLevelCH3_cor_offset;
		p_mul_factor = Voltage_Correction[2][Selected_Voltage_CH3];	
	}
	if (inr == 4)											// Pointer to Data Array
	{														// Channel Four & Zero
		icolor = Buffer_Plane4;//Channel_Plane4;
		pix = &SIGNAL4_SUM_MIN[0];
		pix2 = &SIGNAL4_SUM_MAX[0];	
	//	pix3 = &SIGNAL4[0];	
        off_buf	= CH4_Zero_Offset + ZeroLevelCH4_cor_offset;	
		p_mul_factor = Voltage_Correction[3][Selected_Voltage_CH4];
	}		
	if (inr == 5)											// Pointer to Data Array
	{														// Channel Four & Zero
		icolor = Buffer_PlaneM;//Channel_Plane4;
		pix = &SIGNALM_SUM_MIN[0];
		pix2 = &SIGNALM_SUM_MAX[0];	
	//	pix3 = &SIGNALM[0];	
        off_buf	= 0;	
		p_mul_factor = 0;
	}
    		   		
//	reset_watchdog->np_piodata = 0x00;
                                                                                            	
			
//	if (Debug_Mode) printf("nr : %i st : %i sfi : %i faktor : %i  start : %i stop : %i so: %i\n", inr, Selected_Timebase, SIGNALFaktor_idx, SIGNAL_FAK_BUF, SIGNAL_START, SIGNAL_STOP, SIGNAL_OFFSET);		

    if (MenuStatus[10][1] == 1)
    {
        shift_factor = 0;
        signal_offset = 30;

        if (windows == 1)
        {
            display_min = 1;
            display_max = 190;
        }
        else
        {
            off_buf += 194;
            display_min = 194;
            display_max = 384;
        }
    }
    else
    {
        shift_factor = 1;
        display_max = 387;
        display_min = 1;
        signal_offset = 60;
    }
		
	SIGNAL_SUM_CNT = 0;
	SIGNAL_SUM_IX = 0;

    P_Min = 255;
    P_Max = 0;
			
    ix = ixstart;

	//for (ix = ixstart; ix < ixstop; ix++)
	while (SIGNAL_SUM_IX < 600)
	{			
	    P3 = DisplayData[ix + TOC_Buf];//(*(pix3 + ix));
        ix++;
        
        if (multi_active)
        {
            p_mul_value = P3 - 128;
            P3 = nm_mult(p_mul_value, p_mul_factor);
        }
        	
        if (P3 < P_Min) P_Min = P3;//SIGNAL1[ix];
	    if (P3 > P_Max) P_Max = P3;//SIGNAL1[ix];
			
        if (SIGNAL_SUM_CNT == factor)
        {
            if (Connect_Vals)
            {
                if (P_Min > (*(pix2 + SIGNAL_SUM_IX - 1))) P_Min = (*(pix2 + SIGNAL_SUM_IX - 1));
                if (P_Max < (*(pix + SIGNAL_SUM_IX - 1))) P_Max = (*(pix + SIGNAL_SUM_IX - 1));
            }

            (*(pix + SIGNAL_SUM_IX)) = P_Min;
            (*(pix2 + SIGNAL_SUM_IX)) = P_Max;

            SIGNAL_SUM_IX++;
            SIGNAL_SUM_CNT = 0;

            P_Min = 255;
            P_Max = 0;
        }
		SIGNAL_SUM_CNT++;
    }
    		
	for (ix = 1; ix < 600; ix++)								// Draw Holy Screen
	{
		P1 = (short) (((*(pix + ix)) + (*(pix2 + ix))) / 2);

        P1 = (P1 << shift_factor) - signal_offset + off_buf;

        if (P1 > display_max) P1 = display_max;
        if (P1 < display_min) P1 = display_min;

        PIXELP(ix + 20 + offset, P1 + 18, on, icolor);
    }
//	reset_watchdog->np_piodata = 0x01;	    	
}

void Display::DRAWXY(int channel, unsigned char on)
{
	int ix, iy, ixs, ixss, posx, off_buf = 0;

    short P1 = 0;
	short P2 = 0;	


	unsigned long *icolor = NULL;
	unsigned char *pix_x = 0;
	unsigned char *pix_y = 0;

	pix_x = &SIGNAL1[0];
	pix_y = &SIGNAL2[0];
	
    icolor = Buffer_Plane1;//Channel_Plane1;

	for (ix = 6; ix < 4048; ix++)								// Draw Holy Screen
	{
        if (((*(pix_x + ix) << 1) + 48 + CH1_Zero_Offset) > 80) PIXELP(((*(pix_x + ix) << 1) + 48 + CH1_Zero_Offset), ((*(pix_y + ix) << 1) - 64 + CH2_Zero_Offset), on, icolor);
        else PIXELP(80, ((*(pix_y + ix) << 1) - 64 + CH2_Zero_Offset), on, icolor);
	}
}

void Display::Connect_Pixels(int x, short y, short y2, int dir, unsigned long *planeaddress, unsigned char on)
{
    if (on)
    {
        if (dir == 1)
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                       ; Load Y to %r3

             ADDI   %r3, 18                        ; Add Correction Value

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                       ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop1:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop1                       ; Jump to Loop
             NOP

            ");
        }
    	else
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i2                       ; Load Y to %r3

             ADDI   %r3, 18                        ; Add Correction Value

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i1                       ; Load End Y to %r6

             SUB    %r6, %i2                       ; Get the Difference

             cp_loop2:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop2                       ; Jump to Loop
             NOP

            ");
	   }		
    }
    else
    {
        if (dir == 1)
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                       ; Load Y to %r3

             ADDI   %r3, 18                        ; Add Correction Value

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x00000000)                ; Load bitmask
             MOVI	%r5,%lo(0x00000000)
             PFX	%xhi(0x00000000)
             MOVHI	%r5,%xlo(0x00000000)

             ;LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                       ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop01:

             ;LD     %r0, [%r4]                     ; Load Value from Memory
             MOV    %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop01                      ; Jump to Loop
             NOP

            ");
        }
    	else
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i2                       ; Load Y to %r3

             ADDI   %r3, 18                        ; Add Correction Value

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x00000000)                ; Load bitmask
             MOVI	%r5,%lo(0x00000000)
             PFX	%xhi(0x00000000)
             MOVHI	%r5,%xlo(0x00000000)

             ;LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i1                       ; Load End Y to %r6

             SUB    %r6, %i2                       ; Get the Difference

             cp_loop02:

             ;LD     %r0, [%r4]                     ; Load Value from Memory
             MOV    %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop02                      ; Jump to Loop
             NOP

            ");
        }		
    }
}


void Display::Test_Pixels(int x, int y, int y2, int dir, unsigned long *planeaddress)
{
    asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                       ; Load Y to %r3

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             ;MOV	%r4, %i4                       ; Load BufferAddress to %r4

             PFX	%hi(0x0093A200)                ; Load BufferAddress
             MOVI	%r4,%lo(0x0093A200)
             PFX	%xhi(0x0093A200)
             MOVHI	%r4,%xlo(0x0093A200)

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                       ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop4:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop4                       ; Jump to Loop
             NOP

         ");
}


// temporary Signal calculation
void Display::CALCSIG(void)											// Build screen
{
	short ix, iy, tog;
	double iyr, iyr2;

	// Signal 1 (Yellow)
	tog = 0;	
	iy = 100;
	
	for (ix = 0; ix < 601; ix++)
	{	
		if (tog == 0)
		{
			if (ix > 50)
			{
				iy = 50;
				tog++;
			}
		}
		else if (tog == 1)
		{			
			if (ix > 350)
			{	
				iy = 100;
				tog++;
			}
		}		
				
		if (ix < 601) SIGNAL1[ix] = iy;
	}	

	// Signal 2 (Green)
	tog = 0;	
	iy = 350;
		
	for (ix = 0; ix < 601; ix++)
	{
		if (ix %80 == 0)
		{
			if (tog == 0) tog = 1;
			else tog = 0;
		}
		
		if (ix %2 == 0)
		{
			if (tog == 0) iy++;
			else iy--;
		}
		
		if (ix < 601) SIGNAL2[ix] = iy;
	}	
	
	// Signal 3 (Purple)
	tog = 0;	
	iy = 280;
	
	for (ix = 0; ix < 601; ix++)
	{	
		if (tog == 0)
		{
			if (ix > 80)
			{
				iy = 230;
				tog++;
			}
		}
		else if (tog == 1)
		{			
			if (ix > 150)
			{	
				iy = 280;
				tog++;
			}
		}	
					
		if (ix < 601) SIGNAL3[ix] = iy;
	}	
	
	// Signal 4 (Red)
	tog = 0;	
	iy = 170;
	
	for (ix = 0; ix < 601; ix++)
	{	
		if (tog == 0)
		{
			if (ix > 50)
			{
				iy = 120;
				tog++;
			}
		}
		else if (tog == 1)
		{			
			if (ix > 70)
			{	
				iy = 170;
				tog++;
			}
		}
				
		if (ix < 601) SIGNAL4[ix] = iy;
	}	

#ifdef _Debug_
	if (Debug_Mode) printf("Calculate Signals Ready\n");	
#endif	
}


void Display::DrawColorDemoBox(int posx, int posy, int sizex, int sizey, unsigned long *planeaddress)							
{
    int x;

	for (x = 0; x <= sizex; x++)
	{
	   Connect_Pixels(posx + x, posy, posy + sizey, 1, planeaddress, 1);
    }
}

void Display::ColorDemo(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}	


    // All Colors
	for (x = 0; x < 15; x++)
	{
	    DrawColorDemoBox(x * 40, 0, 39, 39, (unsigned long *) (0x0095FA00 + (x * 0x00009600)));
	}

    // UI Blocks
	for (x = 0; x < 5; x++)
	{
	    DrawColorDemoBox(x * 128, 40, 127, 37, (unsigned long *) (0x0095FA00 + (x * 0x00009600)));
	}
	
	// UI Mix 1
	DrawColorDemoBox(0, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(32, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(64, 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(96, 46, 32, 27, UI_Plane5);
	
	// UI Mix 2
	DrawColorDemoBox(128, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(160, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(192, 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(224, 46, 32, 27, UI_Plane5);

	// UI Mix 3
	DrawColorDemoBox(256, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(288, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(320, 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(352, 46, 32, 27, UI_Plane5);

	// UI Mix 4
	DrawColorDemoBox(384, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(416, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(448, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(480, 46, 32, 27, UI_Plane5);

	// UI Mix 5
	DrawColorDemoBox(512, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(544, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(576, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(608, 46, 32, 27, UI_Plane4);
	
	// Channel 4 remix
	DrawColorDemoBox(0, 70, 639, 9, Channel_Plane4);
	
	
	Connect_Pixels(123, 210, 220, 1, UI_Plane1, 1);
	Connect_Pixels(123, 220, 230, 1, UI_Plane2, 1);
	Connect_Pixels(123, 230, 240, 1, UI_Plane3, 1);
	Connect_Pixels(123, 240, 250, 1, UI_Plane4, 1);
	Connect_Pixels(123, 250, 260, 1, UI_Plane5, 1);
	Connect_Pixels(123, 260, 270, 1, Channel_Plane1, 1);
	Connect_Pixels(123, 270, 280, 1, Channel_Plane2, 1);
	Connect_Pixels(123, 280, 290, 1, Channel_Plane3, 1);
	Connect_Pixels(123, 290, 300, 1, Channel_Plane4, 1);
	Connect_Pixels(123, 300, 310, 1, Channel_Math_Plane, 1);
	Connect_Pixels(123, 310, 320, 1, Memory_Plane1, 1);
	Connect_Pixels(123, 320, 330, 1, Memory_Plane2, 1);
	Connect_Pixels(123, 330, 340, 1, Memory_Plane3, 1);
	Connect_Pixels(123, 340, 350, 1, Marker_Plane1, 1);
	Connect_Pixels(123, 350, 360, 1, Marker_Plane2, 1);
	Connect_Pixels(123, 360, 370, 1, Grid_Plane, 1);
	
	DRAWLINEP(223, 210, 232, 210, 1, UI_Plane1);
	DRAWLINEP(223, 211, 232, 211, 1, UI_Plane2);
	DRAWLINEP(223, 212, 232, 212, 1, UI_Plane3);
	DRAWLINEP(223, 213, 232, 213, 1, UI_Plane4);
	DRAWLINEP(223, 214, 232, 214, 1, UI_Plane5);
	DRAWLINEP(223, 215, 232, 215, 1, Channel_Plane1);
	DRAWLINEP(223, 216, 232, 216, 1, Channel_Plane2);
	DRAWLINEP(223, 217, 232, 217, 1, Channel_Plane3);
	DRAWLINEP(223, 218, 232, 218, 1, Channel_Plane4);
	DRAWLINEP(223, 219, 232, 219, 1, Channel_Math_Plane);
	DRAWLINEP(223, 220, 232, 220, 1, Memory_Plane1);
	DRAWLINEP(223, 221, 232, 221, 1, Memory_Plane2);
	DRAWLINEP(223, 222, 232, 222, 1, Memory_Plane3);
	DRAWLINEP(223, 223, 232, 223, 1, Marker_Plane1);
	DRAWLINEP(223, 224, 232, 224, 1, Marker_Plane2);
	DRAWLINEP(223, 225, 232, 225, 1, Grid_Plane);
	
	
	
	
	// Stop the system
    while (1 != 0);
}

void Display::ColorDemo2(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}
	
    DRAWLINEP(0, 0, 31, 0, 1, UI_Plane1);
	DRAWLINEP(0, 1, 31, 1, 1, UI_Plane2);
	DRAWLINEP(0, 2, 31, 2, 1, UI_Plane3);
	DRAWLINEP(0, 3, 31, 3, 1, UI_Plane4);
	DRAWLINEP(0, 4, 31, 4, 1, UI_Plane5);
	DRAWLINEP(0, 5, 31, 5, 1, Channel_Plane1);
	DRAWLINEP(0, 6, 31, 6, 1, Channel_Plane2);
	DRAWLINEP(0, 7, 31, 7, 1, Channel_Plane3);
	DRAWLINEP(0, 8, 31, 8, 1, Channel_Plane4);
	DRAWLINEP(0, 9, 31, 9, 1, Channel_Math_Plane);
	DRAWLINEP(0, 10, 31, 10, 1, Memory_Plane1);
	DRAWLINEP(0, 11, 31, 11, 1, Memory_Plane2);
	DRAWLINEP(0, 12, 31, 12, 1, Memory_Plane3);
	DRAWLINEP(0, 13, 31, 13, 1, Marker_Plane1);
	DRAWLINEP(0, 14, 31, 14, 1, Marker_Plane2);
	DRAWLINEP(0, 15, 31, 15, 1, Grid_Plane); 	
	
	
	// Stop the system
    while (1 != 0);
}

void Display::ColorDemo3(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}
	
	PIXELP(0, 0, 1, UI_Plane1);
	PIXELP(16, 0, 1, UI_Plane1);
	PIXELP(1, 0, 1, UI_Plane2);
	PIXELP(17, 0, 1, UI_Plane2);
	PIXELP(2, 0, 1, UI_Plane3);
	PIXELP(18, 0, 1, UI_Plane3);
	PIXELP(3, 0, 1, UI_Plane4);
	PIXELP(19, 0, 1, UI_Plane4);
	PIXELP(4, 0, 1, UI_Plane5);
	PIXELP(20, 0, 1, UI_Plane5);
	
	PIXELP(5, 0, 1, Channel_Plane1);
	PIXELP(21, 0, 1, Channel_Plane1);
	PIXELP(6, 0, 1, Channel_Plane2);
	PIXELP(22, 0, 1, Channel_Plane2);
	PIXELP(7, 0, 1, Channel_Plane3);
	PIXELP(23, 0, 1, Channel_Plane3);
	PIXELP(8, 0, 1, Channel_Plane4);
	PIXELP(24, 0, 1, Channel_Plane4);
	PIXELP(9, 0, 1, Channel_Math_Plane);
	PIXELP(25, 0, 1, Channel_Math_Plane);        	
	
	PIXELP(10, 0, 1, Memory_Plane1);
	PIXELP(26, 0, 1, Memory_Plane1);   	
	PIXELP(11, 0, 1, Memory_Plane2);
	PIXELP(27, 0, 1, Memory_Plane2);   	
	PIXELP(12, 0, 1, Memory_Plane3);
	PIXELP(28, 0, 1, Memory_Plane3);   	
	
	PIXELP(13, 0, 1, Marker_Plane1);
	PIXELP(29, 0, 1, Marker_Plane1);   	
	PIXELP(14, 0, 1, Marker_Plane2);
	PIXELP(30, 0, 1, Marker_Plane2);
       	
	PIXELP(15, 0, 1, Grid_Plane);
	PIXELP(31, 0, 1, Grid_Plane);   	
	
	// Stop the system
    while (1 != 0);
}

void Display::ColorDemo5(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}

	// Clear test Plane
	for (x = 0; x < 9600; x++)
	{
        Channel_Plane1[x] = 0;	
   		Buffer_Plane1[x] = 0;
	}
	
	DrawColorDemoBox(64, 64, 64, 64, Channel_Plane1);
	DrawColorDemoBox(172, 64, 64, 64, Buffer_Plane1);
	
    reset_watchdog->np_piodata = 0;
	
    screen_sel = 0;

	// Stop the system
    while (1 != 0);
}

void Display::ColorDemo6(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}

	// Clear test Plane
	for (x = 0; x < 9600; x++)
	{
        Channel_Plane1[x] = 0;	
		Buffer_Plane1[x] = 0;
	}
	
	DrawColorDemoBox(64, 64, 64, 64, Channel_Plane1);
	DrawColorDemoBox(172, 64, 64, 64, Buffer_Plane1);
	
    reset_watchdog->np_piodata = 1;
	
    screen_sel = 1;

	// Stop the system
    while (1 != 0);
}

// Class FloatStr
void FloatStr::Init(float In_Value, float In_Min_Value, float In_Max_Value, float In_StepSize, int In_AfterDot, int In_MaxLength, char In_Text[20], char In_PreText[10], char In_Unit[5])
{
	Value = In_Value;
	Stored_Value = In_Value;
	Min_Value = In_Min_Value;
	Max_Value = In_Max_Value;
	StepSize = In_StepSize;
	AfterDot = In_AfterDot;
	MaxLength = In_MaxLength;
	sprintf(Text, "%s", In_Text);
	sprintf(PreText, "%s", In_PreText);
	sprintf(Unit, "%s", In_Unit);
	sprintf(DimensionUnit, "");
	RenderText();
}

float FloatStr::Read_Value(void)
{
	return Value;
}

void FloatStr::Write_Value(float In_Value)
{
	Value = In_Value;
}

float FloatStr::Read_Stored_Value(void)
{
	return Stored_Value;
}

void FloatStr::Write_Stored_Value(float In_Stored_Value)
{
	Stored_Value = In_Stored_Value;
}

float FloatStr::Read_Min_Value(void)
{
	return Min_Value;
}

void FloatStr::Write_Min_Value(float In_Min_Value)
{
	Min_Value = In_Min_Value;
}

float FloatStr::Read_Max_Value(void)
{
	return Max_Value;
}

void FloatStr::Write_Max_Value(float In_Max_Value)
{
	Max_Value = In_Max_Value;
}

float FloatStr::Read_StepSize(void)
{
	return StepSize;
}

void FloatStr::Write_StepSize(float In_StepSize)
{
	StepSize = In_StepSize;
}

int FloatStr::Read_AfterDot(void)
{
	return AfterDot;
}

void FloatStr::Write_AfterDot(int In_AfterDot)
{
	AfterDot = In_AfterDot;
}

int FloatStr::Read_MaxLength(void)
{
	return MaxLength;
}

void FloatStr::Write_MaxLength(int In_MaxLength)
{
	MaxLength = In_MaxLength;
}

void FloatStr::RenderText(void)
{
	int cmpvar;
	char Calc_AfterDot = AfterDot;
	volatile float Calc_Value = Value;
	
	float floattempad = 0;
	int inttempbd = 0;
	int inttempad = 0;

	int buf_int = 0;
	
    if (Calc_Value == 0) Calc_Value = 0.0;
//	else if (Calc_Value > 0) Calc_Value = Calc_Value + 0.000000000001;
//	else Calc_Value = Calc_Value - 0.000000000001;	
	
//	if (Calc_Value < 1) buf_int = (int) (Calc_Value * 1000000000);
	
	DimensionUnit[0] = 0;
	
//	printf("CalcV S : %10.10f  = Int : %d\n", Calc_Value, buf_int);

	if (Calc_Value == 0)
    {
        DimensionUnit[0] = 0;
        Calc_Value = 0;
    }        	
	else if (Calc_Value > 0)
	{
/*                    	
		if (Calc_Value < 0.000001)
		{
			Calc_Value = Calc_Value * 1000000000;
			DimensionUnit[0] = 'n';
			printf("CalcV n : %f\n", Calc_Value);
		}
		else if (Calc_Value < 0.001)
		{
			Calc_Value = Calc_Value * 1000000;
			DimensionUnit[0] = '&';
			printf("CalcV  : %f\n", Calc_Value);
		}	
		else if (Calc_Value < 1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = 'm';
			printf("CalcV m : %f\n", Calc_Value);
		}
		else if (Calc_Value >= 1000000000)
		{
			Calc_Value = Calc_Value / 1000000000;
			DimensionUnit[0] = 'T';
			printf("CalcV T : %f\n", Calc_Value);
		}
		else if (Calc_Value >= 1000000)
		{
			Calc_Value = Calc_Value / 1000000;
			DimensionUnit[0] = 'M';
			printf("CalcV M : %f\n", Calc_Value);
		}
		else if (Calc_Value >= 1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'k';
			printf("CalcV k : %f\n", Calc_Value);
		}        		
*/	
		if (Calc_Value < 1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = 'm';
//			printf("CalcV m : %f\n", Calc_Value);
		}
		if (Calc_Value < 1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = '&';	
//			printf("CalcV  : %f\n", Calc_Value);
		}
		if (Calc_Value < 1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = 'n';	
//			printf("CalcV n : %f\n", Calc_Value);
		}				
		if (Calc_Value >= 1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'k';
//			printf("CalcV k : %f\n", Calc_Value);
		}
		if (Calc_Value >= 1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'M';
//			printf("CalcV M : %f\n", Calc_Value);
		}
		if (Calc_Value >= 1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'T';
//			printf("CalcV T : %f\n", Calc_Value);
		}
		
	}
	else if (Calc_Value < 0)
	{
		if (Calc_Value > -1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = 'm';
		}
		if (Calc_Value > -1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = '&';	
		}
		if (Calc_Value > -1)
		{
			Calc_Value = Calc_Value * 1000;
			DimensionUnit[0] = 'n';	
		}			
		if (Calc_Value <= -1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'k';
		}
		if (Calc_Value <= -1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'M';
		}
		if (Calc_Value <= -1000)
		{
			Calc_Value = Calc_Value / 1000;
			DimensionUnit[0] = 'T';
		}
	}
	
	// Copy Float to Integer
	cmpvar = (int) Calc_Value;
	
	// Compare if there is a after Dot integer
	
	if (cmpvar > 0)
	{	
		if (cmpvar < 9)
		{
			if ((AfterDot + 1) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot + 1));
		}
		else if (cmpvar < 99)
		{
			if ((AfterDot + 2) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot));
		}
		else
		{
			if ((AfterDot + 3) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot - 1));
		}
	}
	else
	{	
		if (cmpvar > -9)
		{
			if ((AfterDot + 1) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot + 1));
		}
		else if (cmpvar > -99)
		{
			if ((AfterDot + 2) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot));
		}
		else
		{
			if ((AfterDot + 3) > MaxLength) Calc_AfterDot = AfterDot - (MaxLength - (AfterDot - 1));
		}
	}
	
	cmpvar = (int) Calc_Value;	
	
	inttempbd = (int) Calc_Value;
	
	floattempad = Calc_Value - inttempbd;

	switch(Calc_AfterDot)
	{	
		case 0: inttempad = (int) floattempad * 1; break;
		case 1: inttempad = (int) floattempad * 10; break;
		case 2: inttempad = (int) floattempad * 100; break;
		case 3: inttempad = (int) floattempad * 1000; break;
		case 4: inttempad = (int) floattempad * 10000; break;
	}

	switch(Calc_AfterDot)
	{
		case 0: sprintf(Text, "%s%3.0f %s%s", PreText, Calc_Value, DimensionUnit, Unit); break;
		case 1: sprintf(Text, "%s%3.1f %s%s", PreText, Calc_Value, DimensionUnit, Unit); break;
		case 2: sprintf(Text, "%s%3.2f %s%s", PreText, Calc_Value, DimensionUnit, Unit); break;
		case 3: sprintf(Text, "%s%3.3f %s%s", PreText, Calc_Value, DimensionUnit, Unit); break;
		case 4: sprintf(Text, "%s%3.4f %s%s", PreText, Calc_Value, DimensionUnit, Unit); break;
	}  	
}

char* FloatStr::Read_Text(void)
{
	return(&Text[0]);
}

char* FloatStr::Read_PreText(void)
{
	return(&PreText[0]);
}

void FloatStr::Write_PreText(char In_PreText[10])
{
	sprintf(PreText, "%s", In_PreText);
}

char* FloatStr::Read_Unit(void)
{
	return(&Unit[0]);
}

void FloatStr::Write_Unit(char In_Unit[5])
{
	sprintf(Unit, "%s", In_Unit);
}

void FloatStr::DoStep(char Direction)
{
	float Calc_Value = Value;
/*	
	if (Calc_Value < 0.000001) StepSize = 0.000000005;
	else
	{
		StepSize = 0.01;
		while (Calc_Value < 1)
		{
			Calc_Value = Calc_Value * 10;
			StepSize = StepSize / 10;
		}
	}
*/	
	if (Direction == 1) { if (Value < Max_Value) Value = Value + StepSize; }
	else { if (Value > Min_Value) Value = Value - StepSize; }
}


/***************************
  contents: implementation of flash routines
            for the AMD part.
*/
// Class FloatStr
void AMDFlash::Init(void)
{
//printf("AMDFlash::Init\n");
#if defined(nm_cpu_architecture) && (nm_cpu_architecture == nios2)
#define DO_CACHE_INIT 1
#else
#define DO_CACHE_INIT 0
#endif

}

// ---------------------------------------------
// Private Routines
// Wait for the given address to contain 0xFF.
// Return value: 1 on success, 0 on timeout failure.
int AMDFlash::await_erase_complete(int entire_chip, volatile unsigned char *addr)
{
	int iTimeout = 40;

  	// The "typical" time for an erase command is 0.7 seconds.
  	// Empirically (as expected), it takes longer to erase the entire
	// chip than a single sector. Give a generous timeout for a single
  	// sector, and even more for the entire chip.

  	if (entire_chip) iTimeout = 20000;

	while (iTimeout)
	{
		nr_delay(100);      // Wait 100 ms.	
		if (0xFF == *addr)  // done? note: 8bit data
		{
			return 0;     // leave
		}

		iTimeout--;
	}

  	// Timeout error.
  	return -1;
}

// This routine actually takes about 3 us on a 33.333MHz Nios32.
void AMDFlash::wait_at_least_1_us(void)
{
  	volatile unsigned long iTimeout = nasys_clock_freq_1000 / 825; //8250
  	while (iTimeout--)
  	{
    	;
  	}
}

// Unlock bypass mode, enabling fast writes.
void AMDFlash::unlock_bypass_mode(volatile unsigned char *flash_base)
{	// 065d
	flash_base[0xAAA] = 0xAA; // unlock bypass command - cycle 1
	flash_base[0x555] = 0x55; // unlock bypass command - cycle 2
	flash_base[0xAAA] = 0x20; // unlock bypass command - cycle 3
}

// Turn bypass mode off, disabling fast writes and enabling normal function.
void AMDFlash::reset_bypass_mode(volatile unsigned char *flash_base)
{
  	*flash_base = 0x90; // exit unlock bypass reset command - cycle 1
  	*flash_base = 0x0;  // exit unlock bypass reset command - cycle 2
}

// Read the given address until two successive reads yield the
// same value.
// Return value: 0 on success, -1 on timeout failure.
int AMDFlash::await_write_complete(volatile unsigned char *addr, const unsigned char correct_value)
{
        //
        // TPA 2/14/2003: The *Maximum* programming time is 150us.
        //                Waiting several times the maximum time
        //                seems like a much better idea than giving-up
        //                well before the published spec says we
        //                should.
        //
	unsigned long iTimeout = 1200; //1200
	int return_value = -1; // Pessimistic return value.

	while (iTimeout)
	{
		wait_at_least_1_us();

    	// While the flash is working on program data, read accesses return
    	// "status" instead of data.  Status bit 7 is the complement of the
    	// data being written.  When the program operation is complete and
    	// successful, the written data is returned.  So, read the written
    	// address until it equals the data written.

		if (*addr == correct_value) break;
		iTimeout--;
	}

	if (iTimeout) return_value = 0;

	return return_value;
}
      // (entire chip, base)


// Write val to the given flash address, in bypass mode (assumes
// that bypass mode has been enabled already).
// Return value: 0 on success, -1 on failure.
int AMDFlash::nr_flash_write_bypass(volatile unsigned char *flash_base, volatile unsigned char *addr, unsigned char val)
{
	unsigned char us1, us2;
	int iTimeout;
	int result = 1;
	int errors = 1000;

    nm_dcache_invalidate_line(addr);
    nm_icache_invalidate_line(addr);
	
    while(result)
    {
	   *flash_base = 0xA0;   // unlock bypass program command - 1st cycle
	   *addr = val;          // program address and data    - 2nd cycle

	   result = await_write_complete(addr,val);
	
	   errors--;
	
	   if (errors == 0) result = 0;
    }
    //if(result) return result;

	us1 = *addr;

	if (us1 != val) result = -1;

	return result;
}

// ---------------------------------------------
// Public Routines

// Erase the flash sector at sector_address.
// Return value: 0 on success, -1 on failure.

int AMDFlash::nr_flash_erase_sector(unsigned long *flash_base, unsigned long *sector_address)
{
	volatile unsigned char *fb  = (unsigned char *) flash_base;
	volatile unsigned char *sa  = (unsigned char *) sector_address;
	int result;
//printf("AMDFlash::nr_flash_erase_sector\n");	
#if DO_CACHE_INIT
	nr_dcache_init();
	nr_icache_init();
#endif

#ifdef nasys_main_flash
	if (-1 == (int)fb) fb = (unsigned char *) nasys_main_flash;
#endif // nasys_main_flash
//  AM29LV065d
	fb[0xAAA] = 0xAA; // 1st cycle
	fb[0x555] = 0x55; // 2nd cycle
	fb[0xAAA] = 0x80; // 3rd cycle
	fb[0xAAA] = 0xAA; // 4th cycle
	fb[0x555] = 0x55; // 5th cycle

	*sa = 0x30; // 6th cycle

  	// Loop until the data reads as 0xFF.

  	result = await_erase_complete(0, sa);
  	return result;
}


// Write a buffer of data to the flash, using bypass mode.
// Return value: 1 on success, 0 on failure.
// Note: the integer "size" is given as a number of half-words to
// write.   How convenient.  We write this 8-bit-wide flash one byte
// at a time (of course).
int AMDFlash::nr_flash_write_buffer(unsigned long *flash_base, unsigned long *start_address, unsigned long *buffer, int size)
{
	volatile unsigned char *fb  = (unsigned char *) flash_base;
			 unsigned char *sa  = (unsigned char *) start_address;
			 unsigned char *buf = (unsigned char *) buffer;
	long num_bytes = size * 4;
	long i;
	int result = 0;
//printf("AMDFlash::nr_flash_write_buffer\n");
#ifdef nasys_main_flash
	if (-1 == (int)fb) fb = (unsigned char *) nasys_main_flash;
#endif // nasys_main_flash

	unlock_bypass_mode(fb);
	for (i = 0; i < num_bytes; ++i)
	{
		result = nr_flash_write_bypass(fb, sa + i, buf[i]);
		if(result) break;
	}
	reset_bypass_mode(fb);

	return result;
}

// Write val to the given flash address.
// Return value: 1 on success, 0 on failure.
int AMDFlash::amd29lv065d_flash_write_byte(unsigned char *flash_base, unsigned char *addr, unsigned char val)
{
    volatile unsigned char *fb = (unsigned char *) flash_base;
    volatile unsigned char *a = (unsigned char *) addr;
    unsigned char us1, us2;
    int result = 1;
//printf("AMDFlash::amd29lv065d_flash_write_byte\n");
    nm_dcache_invalidate_line(a);
    nm_icache_invalidate_line(a);

#ifdef nasys_main_flash
    if (-1 == (int)fb) fb = (unsigned char *) nasys_main_flash;
#endif // nasys_main_flash

    while (result)
    {
        fb[0x555] = 0xAA; // 1st cycle  addr = XXX, data = AA
        fb[0x333] = 0x55; // 2nd cycle  addr = XXX, data = 55
        fb[0x555] = 0xA0; // 3rd cycle  addr = XXX, data = A0

        *a = val;     // 4th cycle  addr = PA, data = PD

        result = await_write_complete(a,val);
    }
    //if(result) return result;

    us1 = *a;
    if (us1 != val) result = -1;

    return result;
}

int AMDFlash::nr_flash_write(unsigned long *flash_base, unsigned long *addr, unsigned long val)
{
    unsigned char* fb       = (unsigned char *) flash_base;
    unsigned char* a        = (unsigned char *) addr;
    unsigned char  byte_val = val & 0xff;
    int result;
//printf("AMDFlash::nr_flash_write\n");
    result = amd29lv065d_flash_write_byte (fb, a,   byte_val);
     // Nonzero result means error.
    if (result) return result;

    byte_val = (val >> 8) & 0xff;
    result = amd29lv065d_flash_write_byte (fb, a+1, byte_val);
     // Nonzero result means error.
    if (result) return result;

    byte_val = (val >> 16) & 0xff;
    result = amd29lv065d_flash_write_byte (fb, a+2, byte_val);
     // Nonzero result means error.
    if (result) return result;

    byte_val = (val >> 24) & 0xff;
    result = amd29lv065d_flash_write_byte (fb, a+3, byte_val);

    return result;
}

void AMDFlash::Clear_Data_FLASH(void)
{
	volatile unsigned long fb  = (unsigned long) nasys_main_flash;
	int result = 0;
//printf("AMDFlash::Clear_Data_FLASH\n");		
	unsigned long  Data_Index = 0x0000007F;//0x00000070;
	unsigned long  i;
	
	unsigned long  sectorOffset[] =  // AM29LV065d sector map
	{
		0x000000, 0x010000, 0x020000, 0x030000,
		0x040000, 0x050000, 0x060000, 0x070000,
		0x080000, 0x090000, 0x0A0000, 0x0B0000,
		0x0C0000, 0x0D0000, 0x0E0000, 0x0F0000,
		0x100000, 0x110000, 0x120000, 0x130000,
		0x140000, 0x150000, 0x160000, 0x170000,
		0x180000, 0x190000, 0x1A0000, 0x1B0000,
		0x1C0000, 0x1D0000, 0x1E0000, 0x1F0000,
		0x200000, 0x210000, 0x220000, 0x230000,
		0x240000, 0x250000, 0x260000, 0x270000,
		0x280000, 0x290000, 0x2A0000, 0x2B0000,
		0x2C0000, 0x2D0000, 0x2E0000, 0x2F0000,
		0x300000, 0x310000, 0x320000, 0x330000,
		0x340000, 0x350000, 0x360000, 0x370000,
		0x380000, 0x390000, 0x3A0000, 0x3B0000,
		0x3C0000, 0x3D0000, 0x3E0000, 0x3F0000,
		0x400000, 0x410000, 0x420000, 0x430000,
		0x440000, 0x450000, 0x460000, 0x470000,
		0x480000, 0x490000, 0x4A0000, 0x4B0000,
		0x4C0000, 0x4D0000, 0x4E0000, 0x4F0000,
		0x500000, 0x510000, 0x520000, 0x530000,
		0x540000, 0x550000, 0x560000, 0x570000,
		0x580000, 0x590000, 0x5A0000, 0x5B0000,
		0x5C0000, 0x5D0000, 0x5E0000, 0x5F0000,
		0x600000, 0x610000, 0x620000, 0x630000,
		0x640000, 0x650000, 0x660000, 0x670000,
		0x680000, 0x690000, 0x6A0000, 0x6B0000,
		0x6C0000, 0x6D0000, 0x6E0000, 0x6F0000,
		0x700000, 0x710000, 0x720000, 0x730000,
		0x740000, 0x750000, 0x760000, 0x770000,
		0x780000, 0x790000, 0x7A0000, 0x7B0000,
		0x7C0000, 0x7D0000, 0x7E0000, 0x7F0000,
	};
	
	for (i = Data_Index; i < sizeof(sectorOffset) / sizeof(*sectorOffset); ++i)
	{
#ifdef _Debug_	
		printf("Deleting Sector : %x\n", sectorOffset[i]);
#endif		
		volatile unsigned long *sector = (unsigned long *) sectorOffset[i];

		result = nr_flash_erase_sector((unsigned long *) nasys_main_flash, (unsigned long *) sector);				// Clear Sectors		
		
		if(result) break;
	}
}



int AMDFlash::copy_signal_to_flash(unsigned long *flash_address)
{
	unsigned long cx;
	unsigned long buf[0x1000];
	unsigned long *buffer = (unsigned long *) buf;	
	int result = -1;
	int led_value = 0x0000;	
//printf("AMDFlash::copy_signal_to_flash\n");	
	nr_flash_erase_sector((unsigned long *) nasys_main_flash, flash_address);				// Clear Sectors
	for (cx = 0; cx < 0x1000; cx++)
	{
		buf[cx] = *(SIGNAL1 + (cx * 4) + 0) + (*(SIGNAL1 + (cx * 4) + 1) << 8) + (*(SIGNAL1 + (cx * 4) + 2) << 16) + (*(SIGNAL1 + (cx * 4) + 3) << 24);
	}
	result = nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address, buf, 0x1000);	// Flash Buffer	
#ifdef _Debug_
    printf("Save Signal1 = %d\n", result);
#endif
	for (cx = 0; cx < 0x1000; cx++)
	{
		buf[cx] = *(SIGNAL2 + (cx * 4) + 0) + (*(SIGNAL2 + (cx * 4) + 1) << 8) + (*(SIGNAL2 + (cx * 4) + 2) << 16) + (*(SIGNAL2 + (cx * 4) + 3) << 24);
	}
	result = nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address + 0x1000, buf, 0x1000);	// Flash Buffer	
#ifdef _Debug_
    printf("Save Signal2 = %d\n", result);
#endif
	for (cx = 0; cx < 0x1000; cx++)
	{
		buf[cx] = *(SIGNAL3 + (cx * 4) + 0) + *(SIGNAL3 + (cx * 4) + 1) + *(SIGNAL3 + (cx * 4) + 2) + *(SIGNAL3 + (cx * 4) + 3);
	}
	result = nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address + 0x2000, buf, 0x1000);	// Flash Buffer	
#ifdef _Debug_
    printf("Save Signal3 = %d\n", result);
#endif
	for (cx = 0; cx < 0x1000; cx++)
	{
		buf[cx] = *(SIGNAL4 + (cx * 4) + 0) + *(SIGNAL4 + (cx * 4) + 1) + *(SIGNAL4 + (cx * 4) + 2) + *(SIGNAL4 + (cx * 4) + 3);
	}
	
	if (LED_ON[0] == 1) led_value = led_value | 0x0001;			// Select Channel 1
	if (LED_ON[1] == 1) led_value = led_value | 0x0002;			// Select Channel 2
	if (LED_ON[2] == 1) led_value = led_value | 0x0004;			// Select Channel 3
	if (LED_ON[3] == 1) led_value = led_value | 0x0008;			// Select Channel 4
	if (LED_ON[4] == 1) led_value = led_value | 0x0010;			// Select Channel Math
	if (LED_ON[5] == 1) led_value = led_value | 0x0020;			// General
	if (LED_ON[6] == 1) led_value = led_value | 0x0040;			// Cursor						
	if (LED_ON[7] == 1) led_value = led_value | 0x0080;			// Quick Measure
	if (LED_ON[8] == 1) led_value = led_value | 0x0100;			// Edge
	if (LED_ON[9] == 1) led_value = led_value | 0x0200;			// Pattern - Not Used
	if (LED_ON[10] == 1) led_value = led_value | 0x0400;		// Pulse Width
	if (LED_ON[11] == 1) led_value = led_value | 0x0800;		// More - Not Used
	if (LED_ON[12] == 1) led_value = led_value | 0x1000;		// Run/Stop Green
	if (LED_ON[13] == 1) led_value = led_value | 0x2000;		// Run/Stop Red
	if (LED_ON[14] == 1) led_value = led_value | 0x4000;		// Single Red					
	if (LED_ON[15] == 1) led_value = led_value | 0x8000;		// Single Green	
		
	buf[0x1000 - 0] = (unsigned long) 0x00;
	buf[0x1000 - 1] = (unsigned long) 0xAACC5523;				// Configuration Start Sign
	buf[0x1000 - 2] = (unsigned long) 0x22334455;
	buf[0x1000 - 3] = (unsigned long) 0x00;		
	buf[0x1000 - 4] = (unsigned long) tc_version;		// Quattro Version
	buf[0x1000 - 5] = (unsigned long) tc_subversion;		// SubVerision
	buf[0x1000 - 6] = (unsigned long) tc_revision;		// Revision
	buf[0x1000 - 7] = (unsigned long) tc_compile_status;	// Compile Status
	buf[0x1000 - 8] = (unsigned long) 0x00;   	
	
	// Timebase
	buf[0x1000 - 10] = (unsigned long) MenuStatus[10][0];
	buf[0x1000 - 11] = (unsigned long) MenuStatus[10][1];
	buf[0x1000 - 12] = (unsigned long) MenuStatus[10][2];
	buf[0x1000 - 13] = (unsigned long) MenuStatus[10][3];
	buf[0x1000 - 14] = (unsigned long) MenuStatus[10][4];
	buf[0x1000 - 15] = (unsigned long) MenuStatus[5][2];	
	buf[0x1000 - 16] = (unsigned long) Display_Mode;
	buf[0x1000 - 17] = (unsigned long) Selected_Timebase;	
	buf[0x1000 - 18] = (unsigned long) SIGNALFaktor_idx;
	buf[0x1000 - 19] = (unsigned long) SIGNAL_StartFr_idx;
	buf[0x1000 - 20] = (unsigned long) Selected_Timebase;	
	buf[0x1000 - 21] = (unsigned long) SIGNALFaktor_idx;
	buf[0x1000 - 22] = (unsigned long) dmode_Selected_Timebase;
	buf[0x1000 - 23] = (unsigned long) dmode_SIGNALFaktor_idx;
	buf[0x1000 - 24] = (unsigned long) dmode_Window_Offset_Pos;
	buf[0x1000 - 25] = (unsigned long) dmode_SIGNAL_StartFr_idx;
//	buf[0x1000 - 26] = (unsigned long) Cursor_Delayed_1;
//	buf[0x1000 - 27] = (unsigned long) Cursor_Delayed_2;
//	buf[0x1000 - 28] = (unsigned long) Cursor_Delayed_Size;
	buf[0x1000 - 29] = (unsigned long) ROLLMODE_TB;

	buf[0x1000 - 30] = (unsigned long) ROLLMODE_OFFSET;
//    buf[0x1000 - 31] = (unsigned long) ROLLMODE_STARTED;
//  buf[0x1000 - 32] = (unsigned long) ROLLMODE_Value_rec;	
    buf[0x1000 - 33] = (unsigned long) Timebase_Offset_Pos;
	buf[0x1000 - 34] = (unsigned long) SwitchesTB;	
	
	// Trigger
	//buf[0x1000 - 35] = (unsigned long) MenuStatus[12][0];                                        // Triggering - Auto
	buf[0x1000 - 36] = (unsigned long) MenuStatus[12][1];                                        // Triggering - Coupling DC
	buf[0x1000 - 37] = (unsigned long) MenuStatus[12][2];                                        // Triggering - Reject
	buf[0x1000 - 38] = (unsigned long) MenuStatus[12][4];                                        // Triggering - External Probe = 1 : 1  ( mu noch als funktion integriert werden )
	buf[0x1000 - 39] = (unsigned long) MenuStatus[14][3];                                        // Triggering - TV

	buf[0x1000 - 40] = (unsigned long) MenuStatus[14][0];                                        // Triggering - positive edge
	buf[0x1000 - 41] = (unsigned long) MenuStatus[14][1];                                        // Triggering - Source = channel 1
	buf[0x1000 - 42] = (unsigned long) MenuStatus[14][2];                                        // Triggering - no externel triggering
	buf[0x1000 - 43] = (unsigned long) MenuStatus[15][0];                                        // Triggering - Source Channel 1
	buf[0x1000 - 44] = (unsigned long) MenuStatus[15][1];                                        // Triggering - Negative Pulse
	buf[0x1000 - 45] = (unsigned long) MenuStatus[15][2];                                        // Triggering - bigger - smaller - then
	buf[0x1000 - 46] = (unsigned long) Selected_Trigger_Source;                                  // Selected Trigger Source is Channel 1
	buf[0x1000 - 47] = (unsigned long) SelectedEdgeExtern;                                       // Trigger Edge by extern triggering
	buf[0x1000 - 48] = (unsigned long) PulseToggle;                                              // Pulse width button selection
	buf[0x1000 - 49] = (unsigned long) Memory_Position;                                          // Memory Position

	buf[0x1000 - 50] = (unsigned long) Trigger_Offset_Pos;                                       // Trigger Offset
	buf[0x1000 - 51] = (unsigned long) Trigger_Pos_CH1;                                          // Trigger Level Channel 1
	buf[0x1000 - 52] = (unsigned long) Trigger_Pos_CH2;                                          // Trigger Level Channel 2
	buf[0x1000 - 53] = (unsigned long) Trigger_Pos_CH3;                                          // Trigger Level Channel 3
	buf[0x1000 - 54] = (unsigned long) Trigger_Pos_CH4;                                          // Trigger Level Channel 4
	buf[0x1000 - 55] = (unsigned long) trg_val_reg;                                              // Trigger Value
	buf[0x1000 - 56] = (unsigned long) trg_hyst_reg;                                             // Trigger Hysterese
	buf[0x1000 - 57] = (unsigned long) trig_range_reg;                                           // Trigger Range
	buf[0x1000 - 58] = (unsigned long) trig_holdoff_reg;                                         // Trigger Holdoff
	buf[0x1000 - 59] = (unsigned long) trig_width_reg;                                           // Trigger Width

	buf[0x1000 - 60] = (unsigned long) ctrl_reg;                                                 // Control register
	buf[0x1000 - 61] = (unsigned long) adc_ctrl_reg;                                             // ADC Control register
	buf[0x1000 - 62] = (unsigned long) pre_reg;                                                  // PreTrigger Value
	//buf[0x1000 - 63] = (unsigned long) channel_Adr_add;                                          // Channel Add Value
	//buf[0x1000 - 64] = (unsigned long) channel_Adr_add2;                                           // ADC Change
	buf[0x1000 - 65] = (unsigned long) triggering;                                               // Triggering
	buf[0x1000 - 66] = (unsigned long) TriggerWay;                                               // Triggerway
	buf[0x1000 - 67] = (unsigned long) Trigger_Pos_CHE;                                          // Trigger extern value	
	
	// Channel 1
	buf[0x1000 - 68] = (unsigned long) MenuStatus[1][0];                                         // Channel - Coupling
	buf[0x1000 - 69] = (unsigned long) MenuStatus[1][1];                                         // Channel - BW Linit

	buf[0x1000 - 70] = (unsigned long) MenuStatus[1][2];                                         // Channel - Invert
	buf[0x1000 - 71] = (unsigned long) MenuStatus[1][3];                                         // Channel - Probe
	buf[0x1000 - 72] = (unsigned long) SwitchesCH1;                                              // Switches for Channel 1 and for the other the AC bit
	buf[0x1000 - 73] = (unsigned long) Selected_Voltage_CH1;                                     // Voltage 5V
	buf[0x1000 - 74] = (unsigned long) Channel1_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[0x1000 - 75] = (unsigned long) Channel1_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[0x1000 - 76] = (unsigned long) Channel1_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[0x1000 - 77] = (unsigned long) CH1_DAC_1;                                                // channel dac 1 offset
	buf[0x1000 - 78] = (unsigned long) CH1_DAC_2;                                                // channel dac 2 offset
	buf[0x1000 - 79] = (unsigned long) CH1_DAC_3;                                                // channel dac 3 offset

	buf[0x1000 - 80] = (unsigned long) CH1_DAC_4;                                                // channel dac 4 offset
	buf[0x1000 - 81] = (unsigned long) signal_zoomed1;                                           // signal zoomed
	buf[0x1000 - 82] = (unsigned long) CH1_DAC_Offset;                                           // Channel DAC
	buf[0x1000 - 83] = (unsigned long) ZeroLevelCH1;                                             // ZeroLevel
	buf[0x1000 - 84] = (unsigned long) Virtual_ZeroLevelCH1;                                     // Virtual ZeroLevel
    buf[0x1000 - 85] = (unsigned long) CH1_Zero_Offset;                                          // Shift offset when stopped

    // Channel 2       	
	buf[0x1000 - 86] = (unsigned long) MenuStatus[2][0];                                         // Channel - Coupling
	buf[0x1000 - 87] = (unsigned long) MenuStatus[2][1];                                         // Channel - BW Linit
	buf[0x1000 - 88] = (unsigned long) MenuStatus[2][2];                                         // Channel - Invert
	buf[0x1000 - 89] = (unsigned long) MenuStatus[2][3];                                         // Channel - Probe

	buf[0x1000 - 90] = (unsigned long) SwitchesCH2;                                              // Switches for Channel
	buf[0x1000 - 91] = (unsigned long) Selected_Voltage_CH2;                                     // Voltage 5V
	buf[0x1000 - 92] = (unsigned long) Channel2_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[0x1000 - 93] = (unsigned long) Channel2_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[0x1000 - 94] = (unsigned long) Channel2_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[0x1000 - 95] = (unsigned long) CH2_DAC_1;                                                // channel dac 1 offset
	buf[0x1000 - 96] = (unsigned long) CH2_DAC_2;                                                // channel dac 2 offset
	buf[0x1000 - 97] = (unsigned long) CH2_DAC_3;                                                // channel dac 3 offset
	buf[0x1000 - 98] = (unsigned long) CH2_DAC_4;                                                // channel dac 4 offset
	buf[0x1000 - 99] = (unsigned long) signal_zoomed2;                                           // signal zoomed

	buf[0x1000 - 100] = (unsigned long) CH2_DAC_Offset;                                           // Channel DAC
	buf[0x1000 - 101] = (unsigned long) ZeroLevelCH2;                                             // ZeroLevel
	buf[0x1000 - 102] = (unsigned long) Virtual_ZeroLevelCH2;                                     // Virtual ZeroLevel
    buf[0x1000 - 103] = (unsigned long) CH2_Zero_Offset;                                          // Shift offset when stopped

    // Channel 3
	buf[0x1000 - 104] = (unsigned long) MenuStatus[3][0];                                         // Channel - Coupling
	buf[0x1000 - 105] = (unsigned long) MenuStatus[3][1];                                         // Channel - BW Linit
	buf[0x1000 - 106] = (unsigned long) MenuStatus[3][2];                                         // Channel - Invert
	buf[0x1000 - 107] = (unsigned long) MenuStatus[3][3];                                         // Channel - Probe
	buf[0x1000 - 108] = (unsigned long) SwitchesCH3;                                              // Switches for Channel
	buf[0x1000 - 109] = (unsigned long) Selected_Voltage_CH3;                                     // Voltage 5V

	buf[0x1000 - 110] = (unsigned long) Channel3_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[0x1000 - 111] = (unsigned long) Channel3_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[0x1000 - 112] = (unsigned long) Channel3_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[0x1000 - 113] = (unsigned long) CH3_DAC_1;                                                // channel dac 1 offset
	buf[0x1000 - 114] = (unsigned long) CH3_DAC_2;                                                // channel dac 2 offset
	buf[0x1000 - 115] = (unsigned long) CH3_DAC_3;                                                // channel dac 3 offset
	buf[0x1000 - 116] = (unsigned long) CH3_DAC_4;                                                // channel dac 4 offset
	buf[0x1000 - 117] = (unsigned long) signal_zoomed3;                                           // signal zoomed
	buf[0x1000 - 118] = (unsigned long) CH3_DAC_Offset;                                           // Channel DAC
	buf[0x1000 - 119] = (unsigned long) ZeroLevelCH3;                                             // ZeroLevel

	buf[0x1000 - 120] = (unsigned long) Virtual_ZeroLevelCH3;                                     // Virtual ZeroLevel
    buf[0x1000 - 121] = (unsigned long) CH3_Zero_Offset;                                          // Shift offset when stopped

    // Channel 4
	buf[0x1000 - 122] = (unsigned long) MenuStatus[4][0];                                         // Channel - Coupling
	buf[0x1000 - 123] = (unsigned long) MenuStatus[4][1];                                         // Channel - BW Linit

	buf[0x1000 - 124] = (unsigned long) MenuStatus[4][2];                                         // Channel - Invert
	buf[0x1000 - 125] = (unsigned long) MenuStatus[4][3];                                         // Channel - Probe
	buf[0x1000 - 126] = (unsigned long) SwitchesCH4;                                              // Switches for Channel
	buf[0x1000 - 127] = (unsigned long) Selected_Voltage_CH4;                                     // Voltage 5V
	buf[0x1000 - 128] = (unsigned long) Channel4_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[0x1000 - 129] = (unsigned long) Channel4_Zero_Sign_Offset_2;                              // Search Zeors offset

	buf[0x1000 - 130] = (unsigned long) Channel4_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[0x1000 - 131] = (unsigned long) CH4_DAC_1;                                                // channel dac 1 offset
	buf[0x1000 - 132] = (unsigned long) CH4_DAC_2;                                                // channel dac 2 offset
	buf[0x1000 - 133] = (unsigned long) CH4_DAC_3;                                                // channel dac 3 offset
	buf[0x1000 - 134] = (unsigned long) CH4_DAC_4;                                                // channel dac 4 offset
	buf[0x1000 - 135] = (unsigned long) signal_zoomed4;                                           // signal zoomed
	buf[0x1000 - 136] = (unsigned long) CH4_DAC_Offset;                                           // Channel DAC
	buf[0x1000 - 137] = (unsigned long) ZeroLevelCH4;                                             // ZeroLevel
	buf[0x1000 - 138] = (unsigned long) Virtual_ZeroLevelCH4;                                     // Virtual ZeroLevel
    buf[0x1000 - 139] = (unsigned long) CH4_Zero_Offset;                                          // Shift offset when stopped                   	
     /*
    buf[0x1000 - 140] = (unsigned long) Channel_Math_Active;                                      // Math channel off
    buf[0x1000 - 141] = (unsigned long) MenuStatus[26][1];                                        // standart math fft on
    buf[0x1000 - 142] = (unsigned long) MenuStatus[26][2];                                        // standart math 1*2 of
    buf[0x1000 - 143] = (unsigned long) MenuStatus[26][3];                                        // standart math 1-2 off
    buf[0x1000 - 144] = (unsigned long) MenuStatus[26][4];                                        // standart math 1+2 off
    */
    /* Buffer fr Math Settings
    buf[0x1000 - 145] = (unsigned long) fft source
    buf[0x1000 - 146] = (unsigned long) fft Span
    buf[0x1000 - 147] = (unsigned long) fft Center
    buf[0x1000 - 148] = (unsigned long) fft Preset
    buf[0x1000 - 149] = (unsigned long) fft more Scale

    buf[0x1000 - 150] = (unsigned long) fft more Offset
    buf[0x1000 - 151] = (unsigned long) fft more Window
    buf[0x1000 - 152] = (unsigned long) * - + Scale
    buf[0x1000 - 153] = (unsigned long) * - + Offset  */

    // Cursors    	
    buf[0x1000 - 154] = (unsigned long) MenuStatus[16][0];                                        // Cursor soruce
    buf[0x1000 - 155] = (unsigned long) Cursor_Enabled;
    buf[0x1000 - 156] = (unsigned long) Cursor_Both_Selected;
    buf[0x1000 - 157] = (unsigned long) SelectedCursor;
    buf[0x1000 - 158] = (unsigned long) Cursor_Horizontal_Active;
    buf[0x1000 - 159] = (unsigned long) Cursor_Horizontal_Position_Real1;

    buf[0x1000 - 160] = (unsigned long) Cursor_Horizontal_Position_Real2;
    buf[0x1000 - 161] = (unsigned long) Cursor_Vertical_Active;
    buf[0x1000 - 162] = (unsigned long) Cursor_Vertical_Position_Real1;
    buf[0x1000 - 163] = (unsigned long) Cursor_Vertical_Position_Real2;

    // Quick Measure
    //buf[0x1000 - 164] = (unsigned long) QM_Enabled;
    buf[0x1000 - 165] = (unsigned long) QM_Type[0];
    buf[0x1000 - 166] = (unsigned long) QM_Type[1];
    buf[0x1000 - 167] = (unsigned long) QM_Type[2];
    buf[0x1000 - 168] = (unsigned long) QM_Channel[0];
    buf[0x1000 - 169] = (unsigned long) QM_Channel[1];

    buf[0x1000 - 170] = (unsigned long) QM_Channel[2];
    buf[0x1000 - 171] = (unsigned long) QM_Horizontal_Active;
    buf[0x1000 - 172] = (unsigned long) QM_Vertical_Active;
    buf[0x1000 - 173] = (unsigned long) Quick_Measure_Threshold_btn_select;

    // Display
    buf[0x1000 - 174] = (unsigned long) GridColorArrayPos;                                        // Normal Grid
    buf[0x1000 - 175] = (unsigned long) GridColor_Val;
    buf[0x1000 - 176] = (unsigned long) GridColorArrayPos_Delayed;                                // Delayed Grid
    buf[0x1000 - 177] = (unsigned long) GridColor_Val_Delayed;
    buf[0x1000 - 178] = (unsigned long) MenuStatus[5][0];                                         // Display - Persist
    buf[0x1000 - 179] = (unsigned long) MenuStatus[5][3];                                         // Display - Verctors

//    buf[0x1000 - 180] = (unsigned long) MenuStatus[0][0];                                         // Aquire - Normal
//    buf[0x1000 - 181] = (unsigned long) MenuStatus[0][1];                                         // Aquire - Averaging
//    buf[0x1000 - 183] = (unsigned long) MenuStatus[0][2];                                         // Aquire - Avgs
    buf[0x1000 - 184] = (unsigned long) MenuStatus[5][4];                                         // Display - Browse

    buf[0x1000 - 185] = (unsigned long) MenuStatus[23][1];                                        // Autoscale - Slow TB
//    buf[0x1000 - 186] = (unsigned long) MenuStatus[17][1];

    buf[0x1000 - 187] = (unsigned long) Debug_Mode;
    buf[0x1000 - 188] = (unsigned long) ADC_Debug_Mode;

    /////
	buf[0x1000 - 189] = (unsigned long) ((unsigned long) MenuPopupStatus[8][0] | ((unsigned long) MenuPopupStatus[8][1] << 16));
    	
	buf[0x1000 - 190] = (unsigned long) MenuPopupStatus[8][2] = (short) buf[190];
    buf[0x1000 - 191] = (unsigned long) OneShotRestart;
    buf[0x1000 - 192] = (unsigned long) led_value;
    buf[0x1000 - 193] = (unsigned long) Channel_1_Active;
    buf[0x1000 - 194] = (unsigned long) Channel_2_Active;
    buf[0x1000 - 195] = (unsigned long) Channel_3_Active;
    buf[0x1000 - 196] = (unsigned long) Channel_4_Active;
    buf[0x1000 - 197] = (unsigned long) dmode_SIGNAL_OFFSET;
    buf[0x1000 - 198] = (unsigned long) SIGNAL_OFFSET;

    buf[0x1000 - 199] = (unsigned long) HoldOff_Value;
    buf[0x1000 - 200] = (unsigned long) HoldOff_Expo;
    buf[0x1000 - 201] = (unsigned long) HoldOff_Steps;

    buf[0x1000 - 202] = (unsigned long) Pulse11_Value;
    buf[0x1000 - 203] = (unsigned long) Pulse11_Expo;
    buf[0x1000 - 204] = (unsigned long) Pulse11_Steps;

    buf[0x1000 - 205] = (unsigned long) Pulse12_Value;
    buf[0x1000 - 206] = (unsigned long) Pulse12_Expo;
    buf[0x1000 - 207] = (unsigned long) Pulse12_Steps;

    buf[0x1000 - 208] = (unsigned long) Pulse21_Value;
    buf[0x1000 - 209] = (unsigned long) Pulse21_Expo;
    buf[0x1000 - 210] = (unsigned long) Pulse21_Steps;

    buf[0x1000 - 211] = (unsigned long) Pulse22_Value;
    buf[0x1000 - 212] = (unsigned long) Pulse22_Expo;
    buf[0x1000 - 213] = (unsigned long) Pulse22_Steps;

    Math_Off_Mul_Value_int = (int) Math_Off_Mul_Value;
    Math_Off_Sub_Value_int = (int) Math_Off_Sub_Value;
    Math_Off_Add_Value_int = (int) Math_Off_Add_Value;

   // buf[0x1000 - 214] = (unsigned long) Math_Off_Mul_Value;
    buf[0x1000 - 214] = (unsigned long) Math_Off_Mul_Value_int;
    buf[0x1000 - 215] = (unsigned long) Math_Off_Mul_Expo;
    buf[0x1000 - 216] = (unsigned long) Math_Off_Mul_Steps;

    //buf[0x1000 - 217] = (unsigned long) Math_Off_Sub_Value;
    buf[0x1000 - 217] = (unsigned long) Math_Off_Sub_Value_int;
    buf[0x1000 - 218] = (unsigned long) Math_Off_Sub_Expo;
    buf[0x1000 - 219] = (unsigned long) Math_Off_Sub_Steps;

    //buf[0x1000 - 220] = (unsigned long) Math_Off_Add_Value;
    buf[0x1000 - 220] = (unsigned long) Math_Off_Add_Value_int;
    buf[0x1000 - 221] = (unsigned long) Math_Off_Add_Expo;
    buf[0x1000 - 222] = (unsigned long) Math_Off_Add_Steps;

    buf[0x1000 - 223] = (unsigned long) math_mul_scale;
    buf[0x1000 - 224] = (unsigned long) math_sub_scale;
    buf[0x1000 - 225] = (unsigned long) math_add_scale;

    buf[0x1000 - 226] = (unsigned long) Math_Off_Mul_Value;
    buf[0x1000 - 227] = (unsigned long) Math_Off_Sub_Value;
    buf[0x1000 - 228] = (unsigned long) Math_Off_Add_Value;

    buf[0x1000 - 229] = (unsigned long) Trig_Pos_Mem;
    buf[0x1000 - 230] = (unsigned long) Trig_Pos_Display;
    buf[0x1000 - 231] = (unsigned long) Trig_Pos_Zoom;
    buf[0x1000 - 232] = (unsigned long) Trig_Mem_Pos;

    buf[0x1000 - 233] = (unsigned long) Trig_Pos_Mem_old;
    buf[0x1000 - 234] = (unsigned long) Trig_Pos_Display_old;
    buf[0x1000 - 235] = (unsigned long) Trig_Pos_Zoom_old;
    buf[0x1000 - 236] = (unsigned long) Trig_Mem_Pos_old;

    buf[0x1000 - 237] = (unsigned long) ZFT_float;
    buf[0x1000 - 238] = (unsigned long) ZFT_float_old;
    buf[0x1000 - 239] = (unsigned long) ZFT_float_dmode;
    buf[0x1000 - 240] = (unsigned long) ZFT_float_dmode_old;
    
    buf[0x1000 - 241] = (unsigned long) OFT_float;
    buf[0x1000 - 242] = (unsigned long) OFT_float_old;
    buf[0x1000 - 243] = (unsigned long) ZIT_short;
    buf[0x1000 - 244] = (unsigned long) ZIT_short_old;
    
    buf[0x1000 - 245] = (unsigned long) ZIT_short_dmode;
    buf[0x1000 - 246] = (unsigned long) ZIT_short_dmode_old;
    
    buf[0x1000 - 247] = (unsigned long) test_port_reg;

	buf[0x1000 - 299] = 0x23232323;	
	
	
	
	result = nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address + 0x3000, buf, 0x1000);	// Flash Buffer	
#ifdef _Debug_
    printf("Save Signal4 = %d\n", result);
#endif

	return result;
}

void AMDFlash::load_signal_from_flash(unsigned long *flash_address)
{
	unsigned long lX, bufdata;
	unsigned long buf[300];	
#ifdef _Debug_	
	printf("Restore a Signal  \n");
#endif	
//printf("AMDFlash::load_signal_from_flash\n");
	for (lX = 0; lX < 300; lX++) buf[lX] = flash_address[0x4000 - lX];		
	
	printf("PARAM : ");
	if ((buf[4] == tc_version) && (buf[5] == tc_subversion) && (buf[6] == tc_revision) && (buf[1] == 0xAACC5523) && (buf[2] == 0x22334455) && (buf[299] == 0x23232323))
	{
        Continius = 0;
        UserIface_active = 0;

        SIGNAL_StartFr_idx = SIGNALFaktor_idx;
        Selected_Voltage_CH1_Old = Selected_Voltage_CH1;
        Selected_Voltage_CH2_Old = Selected_Voltage_CH2;
        Selected_Voltage_CH3_Old = Selected_Voltage_CH3;
        Selected_Voltage_CH4_Old = Selected_Voltage_CH4;
                    	
        Hardware::Stop_Record();	
        
        for (lX = 0; lX < 0x1000; lX++)
        {
            bufdata = *(flash_address + lX + 0x0000);
            SIGNAL1[(lX * 4) + 0] = (unsigned char) ((bufdata & 0x000000FF) >> 0);	
            SIGNAL1[(lX * 4) + 1] = (unsigned char) ((bufdata & 0x0000FF00) >> 8);
            SIGNAL1[(lX * 4) + 2] = (unsigned char) ((bufdata & 0x00FF0000) >> 16);
            SIGNAL1[(lX * 4) + 3] = (unsigned char) ((bufdata & 0xFF000000) >> 24);

            bufdata = *(flash_address + lX + 0x1000);
            SIGNAL2[(lX * 4) + 0] = (unsigned char) ((bufdata & 0x000000FF) >> 0);	
            SIGNAL2[(lX * 4) + 1] = (unsigned char) ((bufdata & 0x0000FF00) >> 8);
            SIGNAL2[(lX * 4) + 2] = (unsigned char) ((bufdata & 0x00FF0000) >> 16);
            SIGNAL2[(lX * 4) + 3] = (unsigned char) ((bufdata & 0xFF000000) >> 24);

            bufdata = *(flash_address + lX + 0x2000);
            SIGNAL3[(lX * 4) + 0] = (unsigned char) ((bufdata & 0x000000FF) >> 0);	
            SIGNAL3[(lX * 4) + 1] = (unsigned char) ((bufdata & 0x0000FF00) >> 8);
            SIGNAL3[(lX * 4) + 2] = (unsigned char) ((bufdata & 0x00FF0000) >> 16);
            SIGNAL3[(lX * 4) + 3] = (unsigned char) ((bufdata & 0xFF000000) >> 24);

            bufdata = *(flash_address + lX + 0x2F00);
            SIGNAL4[(lX * 4) + 0] = (unsigned char) ((bufdata & 0x000000FF) >> 0);	
            SIGNAL4[(lX * 4) + 1] = (unsigned char) ((bufdata & 0x0000FF00) >> 8);
            SIGNAL4[(lX * 4) + 2] = (unsigned char) ((bufdata & 0x00FF0000) >> 16);
            SIGNAL4[(lX * 4) + 3] = (unsigned char) ((bufdata & 0xFF000000) >> 24);
        }	
	
        printf("Yes we load parameters\n");
        // Timebase      	
        MenuStatus[10][0] = (short) buf[10];
        MenuStatus[10][1] = (short) buf[11];
        MenuStatus[10][2] = (short) buf[12];
        MenuStatus[10][3] = (short) buf[13];
        MenuStatus[10][4] = (short) buf[14];
        MenuStatus[5][2] = (short) buf[15];
        Display_Mode = (char) buf[16];
        Selected_Timebase = (char) buf[17];
        SIGNALFaktor_idx = (volatile short) buf[18];
        SIGNAL_StartFr_idx = (volatile short) buf[19];

        Selected_Timebase = (unsigned long) buf[20];   //?????
        
        if (Selected_Timebase < 4) Selected_Timebase = 4;

        SIGNALFaktor_idx = (char) buf[21];

        dmode_Selected_Timebase = (char) buf[22];
        dmode_SIGNALFaktor_idx = (volatile short) buf[23];
        dmode_Window_Offset_Pos = (int) buf[24];
        dmode_SIGNAL_StartFr_idx = (volatile short) buf[25];

        // werden frisch berrechnet
        //Cursor_Delayed_1 = (int) buf[26];
        //Cursor_Delayed_2 = (int) buf[27];
        //Cursor_Delayed_Size = (int) buf[28];
        ROLLMODE_TB = (volatile short) buf[29];

        ROLLMODE_OFFSET = (volatile short) buf[30];
//      ROLLMODE_STARTED = (volatile char) buf[31];
//      ROLLMODE_Value_rec = (volatile char) buf[32];
        Timebase_Offset_Pos = (int) buf[33];
        SwitchesTB = (unsigned short) buf[34];
	
        // Trigger	
        //MenuStatus[12][0] = (short) buf[35];                                        // Triggering - Auto
        MenuStatus[12][1] = (short) buf[36];                                        // Triggering - Coupling
        MenuStatus[12][2] = (short) buf[37];                                        // Triggering - Reject
        MenuStatus[12][4] = (short) buf[38];                                        // Triggering - External Probe = 1 : 1  ( mu noch als funktion integriert werden )
        MenuStatus[14][3] = (short) buf[39];                                        // Triggering - TV
        MenuStatus[14][0] = (short) buf[40];                                        // Triggering - positive edge
        MenuStatus[14][1] = (short) buf[41];                                        // Triggering - Source = channel 1
        MenuStatus[14][2] = (short) buf[42];                                        // Triggering - no externel triggering
        MenuStatus[15][0] = (short) buf[43];                                        // Triggering - Source Channel 1
        //MenuStatus[15][1] = (short) buf[44];                                        // Triggering - Negative Pulse
        MenuStatus[15][2] = (short) buf[45];                                        // Triggering - bigger - smaller - then
        Selected_Trigger_Source = (char) buf[46];                                  // Selected Trigger Source is Channel 1
        SelectedEdgeExtern = (char) buf[47];                                       // Trigger Edge by extern triggering
        PulseToggle = (char) buf[48];                                              // Pulse width button selection                                       //
        Memory_Position = (long) buf[49];                                          // Memory Position
	
        Trigger_Offset_Pos = (volatile int) buf[50];                                       // Trigger Offset
        Trigger_Pos_CH1 = (int) buf[51];                                          // Trigger Level Channel 1
        Trigger_Pos_CH2 = (int) buf[52];                                          // Trigger Level Channel 2
        Trigger_Pos_CH3 = (int) buf[53];                                          // Trigger Level Channel 3
        Trigger_Pos_CH4 = (int) buf[54];                                          // Trigger Level Channel 4
        trg_val_reg = (unsigned int) buf[55];                                              // Trigger Value
        trg_hyst_reg = (unsigned int) buf[56];                                             // Trigger Hysterese
        trig_range_reg = (unsigned int) buf[57];                                           // Trigger Range
        trig_holdoff_reg = (unsigned long) buf[58];                                         // Trigger Holdoff
        trig_width_reg = (unsigned int) buf[59];                                           // Trigger Width
	
        ctrl_reg = (unsigned int) buf[60];                                                 // Control register
        adc_ctrl_reg = (unsigned int) buf[61];                                             // ADC Control register
        pre_reg = (unsigned int) buf[62];                                                  // PreTrigger Value
//        channel_Adr_add = (unsigned int) buf[63];                                          // Channel Add Value
//        adc_change_reg = (unsigned long) buf[64];                                           // ADC Change
        triggering = (unsigned int) buf[65];                                               // Triggering
        TriggerWay = (char) buf[66];                                               // Triggerway
	    Trigger_Pos_CHE = (int) buf[67];                                                // Trigger extern value
	
        // Channel 1
        MenuStatus[1][0] = (short) buf[68];                                         // Channel - Coupling
        MenuStatus[1][1] = (short) buf[69];                                         // Channel - BW Linit
	
        MenuStatus[1][2] = (short) buf[70];                                         // Channel - Invert
        MenuStatus[1][3] = (short) buf[71];                                         // Channel - Probe
        SwitchesCH1 = (unsigned short) buf[72];                                              // Switches for Channel 1 and for the other the AC bit
        Selected_Voltage_CH1 = (volatile char) buf[73];                                     // Voltage
        Channel1_Zero_Sign_Offset_1 = (int) buf[74];                              // Search Zeors offset
        Channel1_Zero_Sign_Offset_2 = (int) buf[75];                              // Search Zeors offset
        Channel1_Zero_Sign_Offset_3 = (int) buf[76];                              // Search Zeors offset
        CH1_DAC_1 = (unsigned char) buf[77];                                                // channel dac 1 offset
        CH1_DAC_2 = (unsigned char) buf[78];                                                // channel dac 2 offset
        CH1_DAC_3 = (unsigned char) buf[79];                                                // channel dac 3 offset

        CH1_DAC_4 = (unsigned char) buf[80];                                                // channel dac 4 offset
        signal_zoomed1 = (unsigned char) buf[81];                                           // signal zoomed
        CH1_DAC_Offset = (int) buf[82];                                           // Channel DAC
        ZeroLevelCH1 = (int) buf[83];                                             // ZeroLevel
        Virtual_ZeroLevelCH1 = (int) buf[84];                                     // Virtual ZeroLevel
        CH1_Zero_Offset = (int) buf[85];                                          // Shift offset when stopped
	
        // Channel 2
        MenuStatus[2][0] = (short) buf[86];                                         // Channel - Coupling
        MenuStatus[2][1] = (short) buf[87];                                         // Channel - BW Linit
        MenuStatus[2][2] = (short) buf[88];                                         // Channel - Invert
        MenuStatus[2][3] = (short) buf[89];                                         // Channel - Probe

        SwitchesCH2 = (unsigned short) buf[90];                                              // Switches for Channel 2
        Selected_Voltage_CH2 = (volatile char) buf[91];                                     // Voltage
        Channel2_Zero_Sign_Offset_1 = (int) buf[92];                              // Search Zeors offset
        Channel2_Zero_Sign_Offset_2 = (int) buf[93];                              // Search Zeors offset
        Channel2_Zero_Sign_Offset_3 = (int) buf[94];                              // Search Zeors offset
        CH2_DAC_1 = (unsigned char) buf[95];                                                // channel dac 1 offset
        CH2_DAC_2 = (unsigned char) buf[96];                                                // channel dac 2 offset
        CH2_DAC_3 = (unsigned char) buf[97];                                                // channel dac 3 offset
        CH2_DAC_4 = (unsigned char) buf[98];                                                // channel dac 4 offset
        signal_zoomed2 = (unsigned char) buf[99];                                           // signal zoomed

        CH2_DAC_Offset = (int) buf[100];                                           // Channel DAC
        ZeroLevelCH2 = (int) buf[101];                                             // ZeroLevel
        Virtual_ZeroLevelCH2 = (int) buf[102];                                     // Virtual ZeroLevel
        CH2_Zero_Offset = (int) buf[103];                                          // Shift offset when stopped

        // Channel 3
        MenuStatus[3][0] = (short) buf[104];                                         // Channel - Coupling
        MenuStatus[3][1] = (short) buf[105];                                         // Channel - BW Linit
        MenuStatus[3][2] = (short) buf[106];                                         // Channel - Invert
        MenuStatus[3][3] = (short) buf[107];                                         // Channel - Probe
        SwitchesCH3 = (unsigned short) buf[108];                                              // Switches for Channel 3
        Selected_Voltage_CH3 = (volatile char) buf[109];                                     // Voltage

        Channel3_Zero_Sign_Offset_1 = (int) buf[110];                              // Search Zeors offset
        Channel3_Zero_Sign_Offset_2 = (int) buf[111];                              // Search Zeors offset
        Channel3_Zero_Sign_Offset_3 = (int) buf[112];                              // Search Zeors offset
        CH3_DAC_1 = (unsigned char) buf[113];                                                // channel dac 1 offset
        CH3_DAC_2 = (unsigned char) buf[114];                                                // channel dac 2 offset
        CH3_DAC_3 = (unsigned char) buf[115];                                                // channel dac 3 offset
        CH3_DAC_4 = (unsigned char) buf[116];                                                // channel dac 4 offset
        signal_zoomed3 = (unsigned char) buf[117];                                           // signal zoomed
        CH3_DAC_Offset = (int) buf[118];                                           // Channel DAC
        ZeroLevelCH3 = (int) buf[119];                                             // ZeroLevel

        Virtual_ZeroLevelCH3 = (int) buf[120];                                     // Virtual ZeroLevel
        CH3_Zero_Offset = (int) buf[121];                                          // Shift offset when stopped

        // Channel 4
        MenuStatus[4][0] = (short) buf[122];                                         // Channel - Coupling
        MenuStatus[4][1] = (short) buf[123];                                         // Channel - BW Linit
        MenuStatus[4][2] = (short) buf[124];                                         // Channel - Invert
        MenuStatus[4][3] = (short) buf[125];                                         // Channel - Probe
        SwitchesCH4 = (unsigned short) buf[126];                                              // Switches for Channel 4
        Selected_Voltage_CH4 = (volatile char) buf[127];                                     // Voltage
        Channel4_Zero_Sign_Offset_1 = (int) buf[128];                              // Search Zeors offset
        Channel4_Zero_Sign_Offset_2 = (int) buf[129];                              // Search Zeors offset

        Channel4_Zero_Sign_Offset_3 = (int) buf[130];                              // Search Zeors offset
        CH4_DAC_1 = (unsigned char) buf[131];                                                // channel dac 1 offset
        CH4_DAC_2 = (unsigned char) buf[132];                                                // channel dac 2 offset
        CH4_DAC_3 = (unsigned char) buf[133];                                                // channel dac 3 offset
        CH4_DAC_4 = (unsigned char) buf[134];                                                // channel dac 4 offset
        signal_zoomed4 = (unsigned char) buf[135];                                           // signal zoomed
        CH4_DAC_Offset = (int) buf[136];                                           // Channel DAC
        ZeroLevelCH4 = (int) buf[137];                                             // ZeroLevel
        Virtual_ZeroLevelCH4 = (int) buf[138];                                     // Virtual ZeroLevel
        CH4_Zero_Offset = (int) buf[139];                                          // Shift offset when stopped
         /*
        Channel_Math_Active = (char) buf[140];                                      // Math channel off
        MenuStatus[26][1] = (short) buf[141];                                        // standart math fft on
        MenuStatus[26][2] = (short) buf[142];                                        // standart math 1*2 of
        MenuStatus[26][3] = (short) buf[143];                                        // standart math 1-2 off
        MenuStatus[26][4] = (short) buf[144];                                        // standart math 1+2 off
         */
    /* Buffer fr Math Settings
        buf[145] = (unsigned long) fft source
        buf[146] = (unsigned long) fft Span
        buf[147] = (unsigned long) fft Center
        buf[148] = (unsigned long) fft Preset
        buf[149] = (unsigned long) fft more Scale

        buf[150] = (unsigned long) fft more Offset
        buf[151] = (unsigned long) fft more Window
        buf[152] = (unsigned long) * - + Scale
        buf[153] = (unsigned long) * - + Offset  */

        // Cursors    	
        MenuStatus[16][0] = (short) buf[154];                                        // Cursor soruce
        Cursor_Enabled = (char) buf[155];

        if (Cursor_Enabled) Cursor_Data_First_Draw = 1;

        Cursor_Both_Selected = (char) buf[156];
        SelectedCursor = (char) buf[157];
        Cursor_Horizontal_Active = (char) buf[158];
        Cursor_Horizontal_Position_Real1 = (long) buf[159];

        Cursor_Horizontal_Position_Real2 = (long) buf[160];
        Cursor_Vertical_Active = (char) buf[161];
        Cursor_Vertical_Position_Real1 = (long) buf[162];
        Cursor_Vertical_Position_Real2 = (long) buf[163];

        // Quick Measure
        //QM_Enabled = (char) buf[164];

        if (QM_Enabled) Quick_Measure_First_Draw = 1;

        QM_Type[0] = (char) buf[165];
        QM_Type[1] = (char) buf[166];
        QM_Type[2] = (char) buf[167];
        QM_Channel[0] = (char) buf[168];
        QM_Channel[1] = (char) buf[169];

        QM_Channel[2] = (char) buf[170];
        QM_Horizontal_Active = (char) buf[171];
        QM_Vertical_Active = (char) buf[172];
        Quick_Measure_Threshold_btn_select = (char) buf[173];

        // Display
        GridColorArrayPos = (unsigned char) buf[174];
        GridColor_Val = (unsigned char) buf[175];
        GridColorArrayPos_Delayed = (unsigned char) buf[176];
        GridColor_Val_Delayed = (unsigned char) buf[177];
        MenuStatus[5][0] = (short) buf[178];                                         // Display - Persist
        MenuStatus[5][3] = (short) buf[179];                                         // Display - Verctors

//        MenuStatus[0][0] = (short) buf[180];                                         // Aquire - Normal
//        MenuStatus[0][1] = (short) buf[181];                                         // Aquire - Averaging
//        MenuStatus[0][2] = (short) buf[183];                                         // Aquire - Avgs
        MenuStatus[5][4] = (short) buf[184];                                         // Display - Browse

        MenuStatus[23][1] = (short) buf[185];                                        // Autoscale - Slow TB
//        MenuStatus[17][1] = (short) buf[186];                                        //

        Debug_Mode = (unsigned char) buf[187];
        ADC_Debug_Mode = (unsigned char) buf[188];

        // vergessene
        MenuPopupStatus[8][0] = (short) (buf[189] & 0x0000FFFF);                    // popup for externeal trigger
        MenuPopupStatus[8][1] = (short) ((buf[189] & 0xFFFF0000) >> 16);
        MenuPopupStatus[8][2] = (short) buf[190];
 
        OneShotRestart = (unsigned char) buf[191];
        // 192 s.o. ledval
        Channel_1_Active = (char) buf[193];
        Channel_2_Active = (char) buf[194];
        Channel_3_Active = (char) buf[195];
        Channel_4_Active = (char) buf[196];
        dmode_SIGNAL_OFFSET = (volatile short) buf[197];
        SIGNAL_OFFSET = (volatile short) buf[198];

        HoldOff_Value = (int) buf[199];
        HoldOff_Expo = (int) buf[200];
        HoldOff_Steps = (int) buf[201];

        Pulse11_Value = (int) buf[202];
        Pulse11_Expo = (int) buf[203];
        Pulse11_Steps = (int) buf[204];

        Pulse12_Value = (int) buf[205];
        Pulse12_Expo = (int) buf[206];
        Pulse12_Steps = (int) buf[207];

        Pulse21_Value = (int) buf[208];
        Pulse21_Expo = (int) buf[209];
        Pulse21_Steps = (int) buf[210];

        Pulse22_Value = (int) buf[211];
        Pulse22_Expo = (int) buf[212];
        Pulse22_Steps = (int) buf[213];

        //Math_Off_Mul_Value = (int) buf[214];
        Math_Off_Mul_Value_int = (int) buf[214];
        Math_Off_Mul_Expo = (int) buf[215];
        Math_Off_Mul_Steps = (int) buf[216];

        //Math_Off_Sub_Value = (int) buf[217];
        Math_Off_Sub_Value_int = (int) buf[217];
        Math_Off_Sub_Expo = (int) buf[218];
        Math_Off_Sub_Steps = (int) buf[219];

        //Math_Off_Add_Value = (int) buf[220];
        Math_Off_Add_Value_int = (int) buf[220];
        Math_Off_Add_Expo = (int) buf[221];
        Math_Off_Add_Steps = (int) buf[222];

        math_mul_scale = (int) buf[223];
        math_sub_scale = (int) buf[224];
        math_add_scale = (int) buf[225];
/*
        Math_Off_Mul_Value = (float) buf[226];
        Math_Off_Sub_Value = (float) buf[227];
        Math_Off_Add_Value = (float) buf[228];
*/
        Math_Off_Mul_Value = (float) Math_Off_Mul_Value_int;
        Math_Off_Sub_Value = (float) Math_Off_Sub_Value_int;
        Math_Off_Add_Value = (float) Math_Off_Add_Value_int;

        Trig_Pos_Mem = (int) buf[229];
        Trig_Pos_Display = (int) buf[230];
        Trig_Pos_Zoom = (float) buf[231];
        Trig_Mem_Pos = (int) buf[232];
        
        Trig_Pos_Mem_old = (int) buf[233];
        Trig_Pos_Display_old = (int) buf[234];
        Trig_Pos_Zoom_old = (float) buf[235];
        Trig_Mem_Pos_old = (int) buf[236];
        
        ZFT_float = (float) buf[237];
        ZFT_float_old = (float) buf[238];
        ZFT_float_dmode = (float) buf[239];
        ZFT_float_dmode_old = (float) buf[240];
        
        OFT_float = (float) buf[241];
        OFT_float_old = (float) buf[242];
        
        ZIT_short = (short) buf[243];
        ZIT_short_old = (short) buf[244];
        ZIT_short_dmode = (short) buf[245];
        ZIT_short_dmode_old = (short) buf[246];
        
        test_port_reg = (unsigned int) buf[247];

		timebase_reg = tb_value[Selected_Timebase];
		Display_Timebase = Selected_Timebase + SIGNALFaktor_idx;

        LED_ON[0] = 0;
        LED_ON[1] = 0;
        LED_ON[2] = 0;
        LED_ON[3] = 0;
        LED_ON[4] = 0;
        //LED_ON[5] = 0;
        LED_ON[6] = 0;
        LED_ON[7] = 0;
        LED_ON[8] = 0;
        LED_ON[9] = 0;
        LED_ON[10] = 0;
        LED_ON[11] = 0;
        //LED_ON[12] = 0;
        //LED_ON[13] = 0;
        LED_ON[14] = 0;
        LED_ON[15] = 0;

        if (((int) buf[192] & 0x0001) == 0x0001) LED_ON[0] = 1;
        if (((int) buf[192] & 0x0002) == 0x0002) LED_ON[1] = 1;
        if (((int) buf[192] & 0x0004) == 0x0004) LED_ON[2] = 1;
        if (((int) buf[192] & 0x0008) == 0x0008) LED_ON[3] = 1;
//        if (((int) buf[192] & 0x0010) == 0x0010) LED_ON[4] = 1;  // Math
        //if (((int) buf[192] & 0x0020) == 0x0020) LED_ON[5] = 1; // Generall
        if (((int) buf[192] & 0x0040) == 0x0040) LED_ON[6] = 1;
        //if (((int) buf[192] & 0x0080) == 0x0080) LED_ON[7] = 1; // Quick Measure
        if (((int) buf[192] & 0x0100) == 0x0100) LED_ON[8] = 1;
        if (((int) buf[192] & 0x0200) == 0x0200) LED_ON[9] = 1;
        if (((int) buf[192] & 0x0400) == 0x0400) LED_ON[10] = 1;
        if (((int) buf[192] & 0x0800) == 0x0800) LED_ON[11] = 1;
        //if (((int) buf[192] & 0x1000) == 0x1000) LED_ON[12] = 1; // Run/Stop Green
        //if (((int) buf[192] & 0x2000) == 0x2000) LED_ON[13] = 1; // Run/Stop Red
//        if (((int) buf[192] & 0x4000) == 0x4000) LED_ON[14] = 1;
//        if (((int) buf[192] & 0x8000) == 0x8000) LED_ON[15] = 1;	


        switch(Pulse11_Expo)
        {
            case 1:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse11.Write_Value((float) Pulse11_Value / (float) 1000);
                break;
            }
        }
        Pulse11.Write_StepSize(Pulse11_Steps);
        Pulse11.RenderText();

        switch(Pulse12_Expo)
        {
            case 1:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse12.Write_Value((float) Pulse12_Value / (float) 1000);
                break;
            }
        }
        Pulse12.Write_StepSize(Pulse12_Steps);
        Pulse12.RenderText();

        switch(Pulse21_Expo)
        {
            case 1:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse21.Write_Value((float) Pulse21_Value / (float) 1000);
                break;
            }
        }
        Pulse21.Write_StepSize(Pulse21_Steps);
        Pulse21.RenderText();

        switch(Pulse22_Expo)
        {
            case 1:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000000);
                break;
            }
            case 2:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000000);
                break;
            }
            case 3:
            {
                Pulse22.Write_Value((float) Pulse22_Value / (float) 1000);
                break;
            }
        }
        Pulse22.Write_StepSize(Pulse22_Steps);
        Pulse22.RenderText();

        switch(Math_Off_Mul_Expo)
        {
            case -2:
            {
                Math_Offset_mul.Write_StepSize(1);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1);
                break;
            }
            case -1:
            {
                Math_Offset_mul.Write_StepSize(0.001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                break;
            }
            case 0:
            {
                Math_Offset_mul.Write_StepSize(0.000001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000000);
                break;
            }
            case 1:
            {
                Math_Offset_mul.Write_StepSize(0.001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                break;
            }
            case 2:
            {
                Math_Offset_mul.Write_StepSize(1);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value);
                break;
            }
        }

        Math_Offset_mul.RenderText();

        switch(Math_Off_Sub_Expo)
        {
            case -1:
            {
                Math_Offset_sub.Write_StepSize(1);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                break;
            }
            case 0:
            {
                Math_Offset_sub.Write_StepSize(0.001);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value / (float) 1000);
                break;
            }
            case 1:
            {
                Math_Offset_sub.Write_StepSize(1);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                break;
            }
        }

        Math_Offset_sub.RenderText();

        switch(Math_Off_Add_Expo)
        {
            case -1:
            {
                Math_Offset_add.Write_StepSize(1);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                break;
            }
            case 0:
            {
                Math_Offset_add.Write_StepSize(0.001);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value / (float) 1000);
                break;
            }
            case 1:
            {
                Math_Offset_add.Write_StepSize(1);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                break;
            }
        }

        Math_Offset_add.RenderText();
	
        // einrcken
        Hardware::UpdateChannel(1, Channel_1_Active);
        Hardware::UpdateChannel(2, Channel_2_Active);
				
        VoltageChangedCh1 = 1;
        VoltageChangedCh2 = 1;				
				
        if (Channel_1_Active) LED_ON[0] = 1;
        else LED_ON[0] = 0;
        if (Channel_2_Active) LED_ON[1] = 1;
        else LED_ON[1] = 0;

        LED_ON[5] = 1;
        LED_ON[6] = 0;
        
        // Run/Stop LED Red
        LED_ON[12] = 0;
        LED_ON[13] = 1;

        Rotary_Steps = 0;
        Hardware::ON_Zero_Channel_1();
        Rotary_Steps = 0;
        Hardware::ON_Zero_Channel_2();

        Hardware::SetSwitches(1, Selected_Voltage_CH1);
        Hardware::SetSwitches(2, Selected_Voltage_CH2);

        if (NumberOfChannels > 2)
        {
            Hardware::UpdateChannel(3, Channel_3_Active);
            Hardware::UpdateChannel(4, Channel_4_Active);

            VoltageChangedCh3 = 1;
            VoltageChangedCh4 = 1;
				
            if (Channel_2_Active) LED_ON[2] = 1;
            else LED_ON[2] = 0;
            if (Channel_4_Active) LED_ON[3] = 1;
            else LED_ON[3] = 0;
				
            Rotary_Steps = 0;
            Hardware::ON_Zero_Channel_3();
            Rotary_Steps = 0;
            Hardware::ON_Zero_Channel_4();

            Hardware::SetSwitches(3, Selected_Voltage_CH3);
            Hardware::SetSwitches(4, Selected_Voltage_CH4);

        }
        else
        {
            Hardware::UpdateChannel(3, 0);
            Hardware::UpdateChannel(4, 0);
        }

        TriggerLevelChanged = 1;
        TriggerModeChanged = 1;	
        TriggerWayChanged = 1;
        TimebaseChanged = 1;
        TimeOffsetChanged = 1;
        MenuStatusChanged = 1;
        MenuAktive = 1;

        Cursor_Data_First_Draw = 0;
        Quick_Measure_First_Draw = 0;

        Hardware::Recalc_Vars();
        Hardware::UpdateTrigger(31);
        Display::CALCPRETRIGGER();
        Display::DRAW_ALL_CURSOR();
				
        // remove the cursor data
        for (lX = 408 * lX; lX < 430 * 20; lX++)
        {
            *(UI_Plane1 + lX) = 0;	// delete
            *(Buffer_UI2Plane + lX) = 0;	// delete Text				
            *(UI_Plane4 + lX) = 0;	// delete
            *(UI_Plane5 + lX) = 0;	// delete
        }				

        Display::DRAWSQUAREBUTTON(2, 1, 14, 16, btnPushed, btnDraw);							// Button
        Display::TEXTOUTvbig("1", 6, 4, 1, Channel_Plane1);									// Draw Voltage Text
        Display::TEXTOUTvbig("1", 6, 4, 1, Buffer_Plane1);									// Draw Voltage Text

        Display::DRAWSQUAREBUTTON(78, 1, 14, 16, btnPushed, btnDraw);						// Button
        Display::TEXTOUTvbig("2", 82, 4, 1, Channel_Plane2);									// Draw Voltage Text
        Display::TEXTOUTvbig("2", 82, 4, 1, Buffer_Plane2);									// Draw Voltage Text

        Display::StatusUpdate();

        if (NumberOfChannels > 2)
        {
            Display::DRAWSQUAREBUTTON(154, 1, 14, 16, btnPushed, btnDraw);						// Button
            Display::TEXTOUTvbig("3", 158, 4, 1, Channel_Plane3);								// Draw Voltage Text
            Display::TEXTOUTvbig("3", 158, 4, 1, Buffer_Plane3);								// Draw Voltage Text

            Display::DRAWSQUAREBUTTON(230, 1, 14, 16, btnPushed, btnDraw);						// Button		
            Display::TEXTOUTvbig("4", 234, 4, 1, Channel_Plane4);								// Draw Voltage Text
            Display::TEXTOUTvbig("4", 234, 4, 1, Buffer_Plane4);								// Draw Voltage Text
        }
                    				
        Display::DRAWSTATUS(6, 0);
				
        Hardware::Send_LED();		
            
        DrawSignals_Needed = true;
        UserIface_active = false;
        Continius = false;
        Signal_Loaded = true;
	}
}

void AMDFlash::copy_flash_to_planes(void)
{
	unsigned long lX;
#ifdef _Debug_	
	printf("Restore the planes \n");
#endif

//printf("AMDFlash::copy_flash_to_planes\n");	
	for (lX = 0; lX < 9600; lX++)
	{	
		UI_Plane1[lX] = *(UI_Plane1_Flash + lX);	
		Buffer_UI2Plane[lX] = *(UI_Plane2_Flash + lX);	
		UI_Plane3[lX] = *(UI_Plane3_Flash + lX);	
		UI_Plane4[lX] = *(UI_Plane4_Flash + lX);	
		UI_Plane5[lX] = *(UI_Plane5_Flash + lX);	
		Channel_Plane1[lX] = *(Channel_Plane1_Flash + lX);	
		Channel_Plane2[lX] = *(Channel_Plane2_Flash + lX);	
		Channel_Plane3[lX] = *(Channel_Plane3_Flash + lX);	
		Channel_Plane4[lX] = *(Channel_Plane4_Flash + lX);	
		Channel_Math_Plane[lX] = *(Channel_Math_Plane_Flash + lX);	
		Buffer_Plane1[lX] = *(Channel_Plane1_Flash + lX);	
		Buffer_Plane2[lX] = *(Channel_Plane2_Flash + lX);	
		Buffer_Plane3[lX] = *(Channel_Plane3_Flash + lX);	
		Buffer_Plane4[lX] = *(Channel_Plane4_Flash + lX);	
		Buffer_PlaneM[lX] = *(Channel_Math_Plane_Flash + lX);			
		Memory_Plane1[lX] = *(Memory_Plane1_Flash + lX);	
		Memory_Plane2[lX] = *(Memory_Plane2_Flash + lX);	
		Memory_Plane3[lX] = *(Memory_Plane3_Flash + lX);	
		Marker_Plane1[lX] = *(Marker_Plane1_Flash + lX);	
		Marker_Plane2[lX] = *(Marker_Plane2_Flash + lX);	
		Grid_Plane[lX] = *(Grid_Plane_Flash + lX);	
	}
	UpdateMenuTextPlane = true;
}

void AMDFlash::copy_flash_to_plane(unsigned long *flash_address, unsigned long *plane)
{
	unsigned long lX;
//printf("AMDFlash::copy_flash_to_plane\n");		
	for (lX = 0; lX < 9600; lX++)
	{	
		plane[lX] = flash_address[lX];	
	}
}

void AMDFlash::Write_Config_Flash(void)
{
	unsigned long *flash_address;
	unsigned long buf[300];
	int led_value = 0x0000;

//printf("AMDFlash::Write_Config_Flash\n");	
//	if (AutoTimerOff) return;
				
	if (config_changed == false) return;
	config_changed = false;


	if (LED_ON[0] == 1) led_value = led_value | 0x0001;			// Select Channel 1
	if (LED_ON[1] == 1) led_value = led_value | 0x0002;			// Select Channel 2
	if (LED_ON[2] == 1) led_value = led_value | 0x0004;			// Select Channel 3
	if (LED_ON[3] == 1) led_value = led_value | 0x0008;			// Select Channel 4
	if (LED_ON[4] == 1) led_value = led_value | 0x0010;			// Select Channel Math
	if (LED_ON[5] == 1) led_value = led_value | 0x0020;			// General
	if (LED_ON[6] == 1) led_value = led_value | 0x0040;			// Cursor						
	//if (LED_ON[7] == 1) led_value = led_value | 0x0080;			// Quick Measure
	if (LED_ON[8] == 1) led_value = led_value | 0x0100;			// Edge
	if (LED_ON[9] == 1) led_value = led_value | 0x0200;			// Pattern - Not Used
	if (LED_ON[10] == 1) led_value = led_value | 0x0400;		// Pulse Width
	if (LED_ON[11] == 1) led_value = led_value | 0x0800;		// More - Not Used
	if (LED_ON[12] == 1) led_value = led_value | 0x1000;		// Run/Stop Green
	if (LED_ON[13] == 1) led_value = led_value | 0x2000;		// Run/Stop Red
	if (LED_ON[14] == 1) led_value = led_value | 0x4000;		// Single Red					
	if (LED_ON[15] == 1) led_value = led_value | 0x8000;		// Single Green	

	flash_address = (unsigned long) nasys_main_flash + Config_Flash;
	nr_flash_erase_sector((unsigned long *) nasys_main_flash, flash_address);

	buf[0] = (unsigned long) 0x00;
	buf[1] = (unsigned long) 0xAACC5523;				// Configuration Start Sign
	buf[2] = (unsigned long) 0x22334455;
	buf[3] = (unsigned long) 0x00;		
	buf[4] = (unsigned long) tc_version;		// Quattro Version
	buf[5] = (unsigned long) tc_subversion;		// SubVerision
	buf[6] = (unsigned long) tc_revision;		// Revision
	buf[7] = (unsigned long) tc_compile_status;	// Compile Status
	buf[8] = (unsigned long) 0x00;   	
	
	// Timebase
	buf[10] = (unsigned long) MenuStatus[10][0];
	buf[11] = (unsigned long) MenuStatus[10][1];
	buf[12] = (unsigned long) MenuStatus[10][2];
	buf[13] = (unsigned long) MenuStatus[10][3];
	buf[14] = (unsigned long) MenuStatus[10][4];
	buf[15] = (unsigned long) MenuStatus[5][2];	
	buf[16] = (unsigned long) Display_Mode;
	buf[17] = (unsigned long) Selected_Timebase;	
	buf[18] = (unsigned long) SIGNALFaktor_idx;
	buf[19] = (unsigned long) SIGNAL_StartFr_idx;

	buf[20] = (unsigned long) Selected_Timebase;
	buf[21] = (unsigned long) SIGNALFaktor_idx;
	buf[22] = (unsigned long) dmode_Selected_Timebase;
	buf[23] = (unsigned long) dmode_SIGNALFaktor_idx;
	buf[24] = (unsigned long) dmode_Window_Offset_Pos;
	buf[25] = (unsigned long) dmode_SIGNAL_StartFr_idx;
//	buf[26] = (unsigned long) Cursor_Delayed_1;
//	buf[27] = (unsigned long) Cursor_Delayed_2;
//	buf[28] = (unsigned long) Cursor_Delayed_Size;
	buf[29] = (unsigned long) ROLLMODE_TB;

	buf[30] = (unsigned long) ROLLMODE_OFFSET;
//    buf[31] = (unsigned long) ROLLMODE_STARTED;
//  buf[32] = (unsigned long) ROLLMODE_Value_rec;	
    buf[33] = (unsigned long) Timebase_Offset_Pos;
	buf[34] = (unsigned long) SwitchesTB;	
	
	// Trigger
	//buf[35] = (unsigned long) MenuStatus[12][0];                                        // Triggering - Auto
	buf[36] = (unsigned long) MenuStatus[12][1];                                        // Triggering - Coupling DC
	buf[37] = (unsigned long) MenuStatus[12][2];                                        // Triggering - Reject
	buf[38] = (unsigned long) MenuStatus[12][4];                                        // Triggering - External Probe = 1 : 1  ( mu noch als funktion integriert werden )
	buf[39] = (unsigned long) MenuStatus[14][3];                                        // Triggering - TV

	buf[40] = (unsigned long) MenuStatus[14][0];                                        // Triggering - positive edge
	buf[41] = (unsigned long) MenuStatus[14][1];                                        // Triggering - Source = channel 1
	buf[42] = (unsigned long) MenuStatus[14][2];                                        // Triggering - no externel triggering
	buf[43] = (unsigned long) MenuStatus[15][0];                                        // Triggering - Source Channel 1
	buf[44] = (unsigned long) MenuStatus[15][1];                                        // Triggering - Negative Pulse
	buf[45] = (unsigned long) MenuStatus[15][2];                                        // Triggering - bigger - smaller - then
	buf[46] = (unsigned long) Selected_Trigger_Source;                                  // Selected Trigger Source is Channel 1
	buf[47] = (unsigned long) SelectedEdgeExtern;                                       // Trigger Edge by extern triggering
	buf[48] = (unsigned long) PulseToggle;                                              // Pulse width button selection
	buf[49] = (unsigned long) Memory_Position;                                          // Memory Position

	buf[50] = (unsigned long) Trigger_Offset_Pos;                                       // Trigger Offset
	buf[51] = (unsigned long) Trigger_Pos_CH1;                                          // Trigger Level Channel 1
	buf[52] = (unsigned long) Trigger_Pos_CH2;                                          // Trigger Level Channel 2
	buf[53] = (unsigned long) Trigger_Pos_CH3;                                          // Trigger Level Channel 3
	buf[54] = (unsigned long) Trigger_Pos_CH4;                                          // Trigger Level Channel 4
	buf[55] = (unsigned long) trg_val_reg;                                              // Trigger Value
	buf[56] = (unsigned long) trg_hyst_reg;                                             // Trigger Hysterese
	buf[57] = (unsigned long) trig_range_reg;                                           // Trigger Range
	buf[58] = (unsigned long) trig_holdoff_reg;                                         // Trigger Holdoff
	buf[59] = (unsigned long) trig_width_reg;                                           // Trigger Width

	buf[60] = (unsigned long) ctrl_reg;                                                 // Control register
	buf[61] = (unsigned long) adc_ctrl_reg;                                             // ADC Control register
	buf[62] = (unsigned long) pre_reg;                                                  // PreTrigger Value
//	buf[63] = (unsigned long) channel_Adr_add;                                          // Channel Add Value
	//buf[64] = (unsigned long) adc_change_reg;                                           // ADC Change
	buf[65] = (unsigned long) triggering;                                               // Triggering
	buf[66] = (unsigned long) TriggerWay;                                               // Triggerway
	buf[67] = (unsigned long) Trigger_Pos_CHE;                                          // Trigger extern value
	
	// Channel 1
	buf[68] = (unsigned long) MenuStatus[1][0];                                         // Channel - Coupling
	buf[69] = (unsigned long) MenuStatus[1][1];                                         // Channel - BW Linit
	buf[70] = (unsigned long) MenuStatus[1][2];                                         // Channel - Invert
	buf[71] = (unsigned long) MenuStatus[1][3];                                         // Channel - Probe
	
	buf[72] = (unsigned long) SwitchesCH1;                                              // Switches for Channel 1 and for the other the AC bit
	buf[73] = (unsigned long) Selected_Voltage_CH1;                                     // Voltage 5V
	buf[74] = (unsigned long) Channel1_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[75] = (unsigned long) Channel1_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[76] = (unsigned long) Channel1_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[77] = (unsigned long) CH1_DAC_1;                                                // channel dac 1 offset
	buf[78] = (unsigned long) CH1_DAC_2;                                                // channel dac 2 offset
	buf[79] = (unsigned long) CH1_DAC_3;                                                // channel dac 3 offset
	buf[80] = (unsigned long) CH1_DAC_4;                                                // channel dac 4 offset
	buf[81] = (unsigned long) signal_zoomed1;                                           // signal zoomed
	
	buf[82] = (unsigned long) CH1_DAC_Offset;                                           // Channel DAC
	buf[83] = (unsigned long) ZeroLevelCH1;                                             // ZeroLevel
	buf[84] = (unsigned long) Virtual_ZeroLevelCH1;                                     // Virtual ZeroLevel
    buf[85] = (unsigned long) CH1_Zero_Offset;                                          // Shift offset when stopped

    // Channel 2       	
	buf[86] = (unsigned long) MenuStatus[2][0];                                         // Channel - Coupling
	buf[87] = (unsigned long) MenuStatus[2][1];                                         // Channel - BW Linit
	buf[88] = (unsigned long) MenuStatus[2][2];                                         // Channel - Invert
	buf[89] = (unsigned long) MenuStatus[2][3];                                         // Channel - Probe

	buf[90] = (unsigned long) SwitchesCH2;                                              // Switches for Channel
	buf[91] = (unsigned long) Selected_Voltage_CH2;                                     // Voltage 5V
	buf[92] = (unsigned long) Channel2_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[93] = (unsigned long) Channel2_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[94] = (unsigned long) Channel2_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[95] = (unsigned long) CH2_DAC_1;                                                // channel dac 1 offset
	buf[96] = (unsigned long) CH2_DAC_2;                                                // channel dac 2 offset
	buf[97] = (unsigned long) CH2_DAC_3;                                                // channel dac 3 offset
	buf[98] = (unsigned long) CH2_DAC_4;                                                // channel dac 4 offset
	buf[99] = (unsigned long) signal_zoomed2;                                           // signal zoomed

	buf[100] = (unsigned long) CH2_DAC_Offset;                                           // Channel DAC
	buf[101] = (unsigned long) ZeroLevelCH2;                                             // ZeroLevel
	buf[102] = (unsigned long) Virtual_ZeroLevelCH2;                                     // Virtual ZeroLevel
    buf[103] = (unsigned long) CH2_Zero_Offset;                                          // Shift offset when stopped

    // Channel 3
	buf[104] = (unsigned long) MenuStatus[3][0];                                         // Channel - Coupling
	buf[105] = (unsigned long) MenuStatus[3][1];                                         // Channel - BW Linit
	buf[106] = (unsigned long) MenuStatus[3][2];                                         // Channel - Invert
	buf[107] = (unsigned long) MenuStatus[3][3];                                         // Channel - Probe
	buf[108] = (unsigned long) SwitchesCH3;                                              // Switches for Channel
	buf[109] = (unsigned long) Selected_Voltage_CH3;                                     // Voltage 5V

	buf[110] = (unsigned long) Channel3_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[111] = (unsigned long) Channel3_Zero_Sign_Offset_2;                              // Search Zeors offset
	buf[112] = (unsigned long) Channel3_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[113] = (unsigned long) CH3_DAC_1;                                                // channel dac 1 offset
	buf[114] = (unsigned long) CH3_DAC_2;                                                // channel dac 2 offset
	buf[115] = (unsigned long) CH3_DAC_3;                                                // channel dac 3 offset
	buf[116] = (unsigned long) CH3_DAC_4;                                                // channel dac 4 offset
	buf[117] = (unsigned long) signal_zoomed3;                                           // signal zoomed
	buf[118] = (unsigned long) CH3_DAC_Offset;                                           // Channel DAC
	buf[119] = (unsigned long) ZeroLevelCH3;                                             // ZeroLevel

	buf[120] = (unsigned long) Virtual_ZeroLevelCH3;                                     // Virtual ZeroLevel
    buf[121] = (unsigned long) CH3_Zero_Offset;                                          // Shift offset when stopped

    // Channel 4
	buf[122] = (unsigned long) MenuStatus[4][0];                                         // Channel - Coupling
	buf[123] = (unsigned long) MenuStatus[4][1];                                         // Channel - BW Linit

	buf[124] = (unsigned long) MenuStatus[4][2];                                         // Channel - Invert
	buf[125] = (unsigned long) MenuStatus[4][3];                                         // Channel - Probe
	buf[126] = (unsigned long) SwitchesCH4;                                              // Switches for Channel
	buf[127] = (unsigned long) Selected_Voltage_CH4;                                     // Voltage 5V
	buf[128] = (unsigned long) Channel4_Zero_Sign_Offset_1;                              // Search Zeors offset
	buf[129] = (unsigned long) Channel4_Zero_Sign_Offset_2;                              // Search Zeors offset

	buf[130] = (unsigned long) Channel4_Zero_Sign_Offset_3;                              // Search Zeors offset
	buf[131] = (unsigned long) CH4_DAC_1;                                                // channel dac 1 offset
	buf[132] = (unsigned long) CH4_DAC_2;                                                // channel dac 2 offset
	buf[133] = (unsigned long) CH4_DAC_3;                                                // channel dac 3 offset
	buf[134] = (unsigned long) CH4_DAC_4;                                                // channel dac 4 offset
	buf[135] = (unsigned long) signal_zoomed4;                                           // signal zoomed
	buf[136] = (unsigned long) CH4_DAC_Offset;                                           // Channel DAC
	buf[137] = (unsigned long) ZeroLevelCH4;                                             // ZeroLevel
	buf[138] = (unsigned long) Virtual_ZeroLevelCH4;                                     // Virtual ZeroLevel
    buf[139] = (unsigned long) CH4_Zero_Offset;                                          // Shift offset when stopped                   	
/*
    buf[140] = (unsigned long) Channel_Math_Active;                                      // Math channel off
    buf[141] = (unsigned long) MenuStatus[26][1];                                        // standart math fft on
    buf[142] = (unsigned long) MenuStatus[26][2];                                        // standart math 1*2 of
    buf[143] = (unsigned long) MenuStatus[26][3];                                        // standart math 1-2 off
    buf[144] = (unsigned long) MenuStatus[26][4];                                        // standart math 1+2 off
*/
    /* Buffer fr Math Settings
    buf[145] = (unsigned long) fft source
    buf[146] = (unsigned long) fft Span
    buf[147] = (unsigned long) fft Center
    buf[148] = (unsigned long) fft Preset
    buf[149] = (unsigned long) fft more Scale

    buf[150] = (unsigned long) fft more Offset
    buf[151] = (unsigned long) fft more Window
    buf[152] = (unsigned long) * - + Scale
    buf[153] = (unsigned long) * - + Offset  */

    // Cursors    	
    buf[154] = (unsigned long) MenuStatus[16][0];                                        // Cursor soruce
    buf[155] = (unsigned long) Cursor_Enabled;
    buf[156] = (unsigned long) Cursor_Both_Selected;
    buf[157] = (unsigned long) SelectedCursor;
    buf[158] = (unsigned long) Cursor_Horizontal_Active;
    buf[159] = (unsigned long) Cursor_Horizontal_Position_Real1;

    buf[160] = (unsigned long) Cursor_Horizontal_Position_Real2;
    buf[161] = (unsigned long) Cursor_Vertical_Active;
    buf[162] = (unsigned long) Cursor_Vertical_Position_Real1;
    buf[163] = (unsigned long) Cursor_Vertical_Position_Real2;

    // Quick Measure
    //buf[164] = (unsigned long) QM_Enabled;
    buf[165] = (unsigned long) QM_Type[0];
    buf[166] = (unsigned long) QM_Type[1];
    buf[167] = (unsigned long) QM_Type[2];
    buf[168] = (unsigned long) QM_Channel[0];
    buf[169] = (unsigned long) QM_Channel[1];

    buf[170] = (unsigned long) QM_Channel[2];
    buf[171] = (unsigned long) QM_Horizontal_Active;
    buf[172] = (unsigned long) QM_Vertical_Active;
    buf[173] = (unsigned long) Quick_Measure_Threshold_btn_select;

    // Display
    buf[174] = (unsigned long) GridColorArrayPos;                                        // Normal Grid
    buf[175] = (unsigned long) GridColor_Val;
    buf[176] = (unsigned long) GridColorArrayPos_Delayed;                                // Delayed Grid
    buf[177] = (unsigned long) GridColor_Val_Delayed;
    buf[178] = (unsigned long) MenuStatus[5][0];                                         // Display - Persist
    buf[179] = (unsigned long) MenuStatus[5][3];                                         // Display - Verctors

//    buf[180] = (unsigned long) MenuStatus[0][0];                                         // Aquire - Normal
//    buf[181] = (unsigned long) MenuStatus[0][1];                                         // Aquire - Averaging
//    buf[183] = (unsigned long) MenuStatus[0][2];                                         // Aquire - Avgs
    buf[184] = (unsigned long) MenuStatus[5][4];                                         // Display - Browse

    buf[185] = (unsigned long) MenuStatus[23][1];                                       // Autoscale - Slow TB
//    buf[186] = (unsigned long) MenuStatus[17][1];

    buf[187] = (unsigned long) Debug_Mode;
    buf[188] = (unsigned long) ADC_Debug_Mode;

    /////
    buf[189] = (unsigned long) (MenuPopupStatus[8][0] | (MenuPopupStatus[8][1] << 16));  // popup external trigger

    buf[190] = (unsigned long) MenuPopupStatus[8][2];//MenuStatus[14][3];                                        // Triggering - no externel triggering
    buf[191] = (unsigned long) OneShotRestart;
    buf[192] = (unsigned long) led_value;
    buf[193] = (unsigned long) Channel_1_Active;
    buf[194] = (unsigned long) Channel_2_Active;
    buf[195] = (unsigned long) Channel_3_Active;
    buf[196] = (unsigned long) Channel_4_Active;
    buf[197] = (unsigned long) dmode_SIGNAL_OFFSET;
    buf[198] = (unsigned long) SIGNAL_OFFSET;


    buf[199] = (unsigned long) HoldOff_Value;
    buf[200] = (unsigned long) HoldOff_Expo;
    buf[201] = (unsigned long) HoldOff_Steps;

    buf[202] = (unsigned long) Pulse11_Value;
    buf[203] = (unsigned long) Pulse11_Expo;
    buf[204] = (unsigned long) Pulse11_Steps;

    buf[205] = (unsigned long) Pulse12_Value;
    buf[206] = (unsigned long) Pulse12_Expo;
    buf[207] = (unsigned long) Pulse12_Steps;

    buf[208] = (unsigned long) Pulse21_Value;
    buf[209] = (unsigned long) Pulse21_Expo;
    buf[210] = (unsigned long) Pulse21_Steps;

    buf[211] = (unsigned long) Pulse22_Value;
    buf[212] = (unsigned long) Pulse22_Expo;
    buf[213] = (unsigned long) Pulse22_Steps;

    Math_Off_Mul_Value_int = (int) Math_Off_Mul_Value;
    Math_Off_Sub_Value_int = (int) Math_Off_Sub_Value;
    Math_Off_Add_Value_int = (int) Math_Off_Add_Value;

   // buf[214] = (unsigned long) Math_Off_Mul_Value;
    buf[214] = (unsigned long) Math_Off_Mul_Value_int;
    buf[215] = (unsigned long) Math_Off_Mul_Expo;
    buf[216] = (unsigned long) Math_Off_Mul_Steps;

    //buf[217] = (unsigned long) Math_Off_Sub_Value;
    buf[217] = (unsigned long) Math_Off_Sub_Value_int;
    buf[218] = (unsigned long) Math_Off_Sub_Expo;
    buf[219] = (unsigned long) Math_Off_Sub_Steps;

    //buf[220] = (unsigned long) Math_Off_Add_Value;
    buf[220] = (unsigned long) Math_Off_Add_Value_int;
    buf[221] = (unsigned long) Math_Off_Add_Expo;
    buf[222] = (unsigned long) Math_Off_Add_Steps;

    buf[223] = (unsigned long) math_mul_scale;
    buf[224] = (unsigned long) math_sub_scale;
    buf[225] = (unsigned long) math_add_scale;

    buf[226] = (unsigned long) Math_Off_Mul_Value;
    buf[227] = (unsigned long) Math_Off_Sub_Value;
    buf[228] = (unsigned long) Math_Off_Add_Value;

    buf[229] = (unsigned long) Trig_Pos_Mem;
    buf[230] = (unsigned long) Trig_Pos_Display;
    buf[231] = (unsigned long) Trig_Pos_Zoom;
    buf[232] = (unsigned long) Trig_Mem_Pos;

    buf[233] = (unsigned long) Trig_Pos_Mem_old;
    buf[234] = (unsigned long) Trig_Pos_Display_old;
    buf[235] = (unsigned long) Trig_Pos_Zoom_old;
    buf[236] = (unsigned long) Trig_Mem_Pos_old;

    buf[237] = (unsigned long) ZFT_float;
    buf[238] = (unsigned long) ZFT_float_old;
    buf[239] = (unsigned long) ZFT_float_dmode;
    buf[240] = (unsigned long) ZFT_float_dmode_old;

    buf[241] = (unsigned long) OFT_float;
    buf[242] = (unsigned long) OFT_float_old;
    buf[243] = (unsigned long) ZIT_short;
    buf[244] = (unsigned long) ZIT_short_old;

    buf[245] = (unsigned long) ZIT_short_dmode;
    buf[246] = (unsigned long) ZIT_short_dmode_old;
    buf[247] = (unsigned long) test_port_reg;
	buf[299] = 0x23232323;

	nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address, buf, 300);	// Flash Buffer

#ifdef _Debug_		
	if (Debug_Mode) printf("Flash written\n");
    printf("WF : df : %f c1 : %d c2 : %d cs %d st %d sfi %d dst %d dsfi %d dwop %d\n", dmode_factor, Cursor_Delayed_1, Cursor_Delayed_2, Cursor_Delayed_Size, Selected_Timebase, SIGNALFaktor_idx, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dmode_Window_Offset_Pos);
#endif

    if (Continius) Hardware::Start_Record();
}

void AMDFlash::Read_Config_Flash(void)
{
	int x;
//printf("AMDFlash::Read_Config_Flash\n");	
	unsigned long *flash_address;
	unsigned long buf[300];
	
	flash_address = (unsigned long) nasys_main_flash + Config_Flash;	
	
	for (x = 0; x < 300; x++) buf[x] = flash_address[x];
	
	if ((buf[4] == tc_version) && (buf[5] == tc_subversion) && (buf[6] == tc_revision) && (buf[1] == 0xAACC5523) && (buf[2] == 0x22334455) && (buf[299] == 0x23232323))
	{
        // Timebase      	
//        MenuStatus[10][0] = (short) buf[10];
//        MenuStatus[10][1] = (short) buf[11];
//        MenuStatus[10][2] = (short) buf[12];
//        MenuStatus[10][3] = (short) buf[13];
//        MenuStatus[10][4] = (short) buf[14];
        MenuStatus[5][2] = (short) buf[15];
        Display_Mode = (char) buf[16];
        Selected_Timebase = (char) buf[17];
        SIGNALFaktor_idx = (volatile short) buf[18];
        SIGNAL_StartFr_idx = (volatile short) buf[19];
        Selected_Timebase = (unsigned long) buf[20];        //????
        
        if (Selected_Timebase < 4) Selected_Timebase = 4;
        
        SIGNALFaktor_idx = (char) buf[21];

        dmode_Selected_Timebase = (char) buf[22];
        dmode_SIGNALFaktor_idx = (volatile short) buf[23];
        dmode_Window_Offset_Pos = (int) buf[24];
        dmode_SIGNAL_StartFr_idx = (volatile short) buf[25];

        // werden frisch berrechnet
        //Cursor_Delayed_1 = (int) buf[26];
        //Cursor_Delayed_2 = (int) buf[27];
        //Cursor_Delayed_Size = (int) buf[28];
        ROLLMODE_TB = (volatile short) buf[29];

        ROLLMODE_OFFSET = (volatile short) buf[30];
//      ROLLMODE_STARTED = (volatile char) buf[31];
//      ROLLMODE_Value_rec = (volatile char) buf[32];
        Timebase_Offset_Pos = (int) buf[33];
        SwitchesTB = (unsigned short) buf[34];
	
        // Trigger	
        //MenuStatus[12][0] = (short) buf[35];                                        // Triggering - Auto
        MenuStatus[12][1] = (short) buf[36];                                        // Triggering - Coupling
        MenuStatus[12][2] = (short) buf[37];                                        // Triggering - Reject
        MenuStatus[12][4] = (short) buf[38];                                        // Triggering - External Probe = 1 : 1  ( mu noch als funktion integriert werden )
        MenuStatus[14][3] = (short) buf[39];                                        // Triggering - TV
        MenuStatus[14][0] = (short) buf[40];                                        // Triggering - positive edge
        MenuStatus[14][1] = (short) buf[41];                                        // Triggering - Source = channel 1
        MenuStatus[14][2] = (short) buf[42];                                        // Triggering - no externel triggering
        MenuStatus[15][0] = (short) buf[43];                                        // Triggering - Source Channel 1
//        MenuStatus[15][1] = (short) buf[44];                                        // Triggering - Negative Pulse
        MenuStatus[15][2] = (short) buf[45];                                        // Triggering - bigger - smaller - then
        Selected_Trigger_Source = (char) buf[46];                                  // Selected Trigger Source is Channel 1
        SelectedEdgeExtern = (char) buf[47];                                       // Trigger Edge by extern triggering
        PulseToggle = (char) buf[48];                                              // Pulse width button selection
        Memory_Position = (long) buf[49];                                          // Memory Position
	
        Trigger_Offset_Pos = (volatile int) buf[50];                                       // Trigger Offset
        Trigger_Pos_CH1 = (int) buf[51];                                          // Trigger Level Channel 1
        Trigger_Pos_CH2 = (int) buf[52];                                          // Trigger Level Channel 2
        Trigger_Pos_CH3 = (int) buf[53];                                          // Trigger Level Channel 3
        Trigger_Pos_CH4 = (int) buf[54];                                          // Trigger Level Channel 4
        trg_val_reg = (unsigned int) buf[55];                                              // Trigger Value
        trg_hyst_reg = (unsigned int) buf[56];                                             // Trigger Hysterese
        trig_range_reg = (unsigned int) buf[57];                                           // Trigger Range
        trig_holdoff_reg = (unsigned long) buf[58];                                         // Trigger Holdoff
        trig_width_reg = (unsigned int) buf[59];                                           // Trigger Width
	
        ctrl_reg = (unsigned int) buf[60];                                                 // Control register
        adc_ctrl_reg = (unsigned int) buf[61];                                             // ADC Control register
        pre_reg = (unsigned int) buf[62];                                                  // PreTrigger Value
 //       channel_Adr_add = (unsigned int) buf[63];                                          // Channel Add Value
        //adc_change_reg = (unsigned long) buf[64];                                           // ADC Change
        triggering = (unsigned int) buf[65];                                               // Triggering
        TriggerWay = (char) buf[66];                                               // Triggerway
        Trigger_Pos_CHE = (int) buf[67];                                                // Trigger extern value
	
        // Channel 1
        MenuStatus[1][0] = (short) buf[68];                                         // Channel - Coupling
        MenuStatus[1][1] = (short) buf[69];                                         // Channel - BW Linit
	
        MenuStatus[1][2] = (short) buf[70];                                         // Channel - Invert
        MenuStatus[1][3] = (short) buf[71];                                         // Channel - Probe
        SwitchesCH1 = (unsigned short) buf[72];                                              // Switches for Channel 1 and for the other the AC bit
        Selected_Voltage_CH1 = (volatile char) buf[73];                                     // Voltage
        Channel1_Zero_Sign_Offset_1 = (int) buf[74];                              // Search Zeors offset
        Channel1_Zero_Sign_Offset_2 = (int) buf[75];                              // Search Zeors offset
        Channel1_Zero_Sign_Offset_3 = (int) buf[76];                              // Search Zeors offset
        CH1_DAC_1 = (unsigned char) buf[77];                                                // channel dac 1 offset
        CH1_DAC_2 = (unsigned char) buf[78];                                                // channel dac 2 offset
        CH1_DAC_3 = (unsigned char) buf[79];                                                // channel dac 3 offset

        CH1_DAC_4 = (unsigned char) buf[80];                                                // channel dac 4 offset
        signal_zoomed1 = (unsigned char) buf[81];                                           // signal zoomed
        CH1_DAC_Offset = (int) buf[82];                                           // Channel DAC
        ZeroLevelCH1 = (int) buf[83];                                             // ZeroLevel
        Virtual_ZeroLevelCH1 = (int) buf[84];                                     // Virtual ZeroLevel
        CH1_Zero_Offset = (int) buf[85];                                          // Shift offset when stopped
	
        // Channel 2
        MenuStatus[2][0] = (short) buf[86];                                         // Channel - Coupling
        MenuStatus[2][1] = (short) buf[87];                                         // Channel - BW Linit
        MenuStatus[2][2] = (short) buf[88];                                         // Channel - Invert
        MenuStatus[2][3] = (short) buf[89];                                         // Channel - Probe

        SwitchesCH2 = (unsigned short) buf[90];                                              // Switches for Channel 2
        Selected_Voltage_CH2 = (volatile char) buf[91];                                     // Voltage
        Channel2_Zero_Sign_Offset_1 = (int) buf[92];                              // Search Zeors offset
        Channel2_Zero_Sign_Offset_2 = (int) buf[93];                              // Search Zeors offset
        Channel2_Zero_Sign_Offset_3 = (int) buf[94];                              // Search Zeors offset
        CH2_DAC_1 = (unsigned char) buf[95];                                                // channel dac 1 offset
        CH2_DAC_2 = (unsigned char) buf[96];                                                // channel dac 2 offset
        CH2_DAC_3 = (unsigned char) buf[97];                                                // channel dac 3 offset
        CH2_DAC_4 = (unsigned char) buf[98];                                                // channel dac 4 offset
        signal_zoomed2 = (unsigned char) buf[99];                                           // signal zoomed

        CH2_DAC_Offset = (int) buf[100];                                           // Channel DAC
        ZeroLevelCH2 = (int) buf[101];                                             // ZeroLevel
        Virtual_ZeroLevelCH2 = (int) buf[102];                                     // Virtual ZeroLevel
        CH2_Zero_Offset = (int) buf[103];                                          // Shift offset when stopped

        // Channel 3
        MenuStatus[3][0] = (short) buf[104];                                         // Channel - Coupling
        MenuStatus[3][1] = (short) buf[105];                                         // Channel - BW Linit
        MenuStatus[3][2] = (short) buf[106];                                         // Channel - Invert
        MenuStatus[3][3] = (short) buf[107];                                         // Channel - Probe
        SwitchesCH3 = (unsigned short) buf[108];                                              // Switches for Channel 3
        Selected_Voltage_CH3 = (volatile char) buf[109];                                     // Voltage

        Channel3_Zero_Sign_Offset_1 = (int) buf[110];                              // Search Zeors offset
        Channel3_Zero_Sign_Offset_2 = (int) buf[111];                              // Search Zeors offset
        Channel3_Zero_Sign_Offset_3 = (int) buf[112];                              // Search Zeors offset
        CH3_DAC_1 = (unsigned char) buf[113];                                                // channel dac 1 offset
        CH3_DAC_2 = (unsigned char) buf[114];                                                // channel dac 2 offset
        CH3_DAC_3 = (unsigned char) buf[115];                                                // channel dac 3 offset
        CH3_DAC_4 = (unsigned char) buf[116];                                                // channel dac 4 offset
        signal_zoomed3 = (unsigned char) buf[117];                                           // signal zoomed
        CH3_DAC_Offset = (int) buf[118];                                           // Channel DAC
        ZeroLevelCH3 = (int) buf[119];                                             // ZeroLevel

        Virtual_ZeroLevelCH3 = (int) buf[120];                                     // Virtual ZeroLevel
        CH3_Zero_Offset = (int) buf[121];                                          // Shift offset when stopped

        // Channel 4
        MenuStatus[4][0] = (short) buf[122];                                         // Channel - Coupling
        MenuStatus[4][1] = (short) buf[123];                                         // Channel - BW Linit
        MenuStatus[4][2] = (short) buf[124];                                         // Channel - Invert
        MenuStatus[4][3] = (short) buf[125];                                         // Channel - Probe
        SwitchesCH4 = (unsigned short) buf[126];                                              // Switches for Channel 4
        Selected_Voltage_CH4 = (volatile char) buf[127];                                     // Voltage
        Channel4_Zero_Sign_Offset_1 = (int) buf[128];                              // Search Zeors offset
        Channel4_Zero_Sign_Offset_2 = (int) buf[129];                              // Search Zeors offset

        Channel4_Zero_Sign_Offset_3 = (int) buf[130];                              // Search Zeors offset
        CH4_DAC_1 = (unsigned char) buf[131];                                                // channel dac 1 offset
        CH4_DAC_2 = (unsigned char) buf[132];                                                // channel dac 2 offset
        CH4_DAC_3 = (unsigned char) buf[133];                                                // channel dac 3 offset
        CH4_DAC_4 = (unsigned char) buf[134];                                                // channel dac 4 offset
        signal_zoomed4 = (unsigned char) buf[135];                                           // signal zoomed
        CH4_DAC_Offset = (int) buf[136];                                           // Channel DAC
        ZeroLevelCH4 = (int) buf[137];                                             // ZeroLevel
        Virtual_ZeroLevelCH4 = (int) buf[138];                                     // Virtual ZeroLevel
        CH4_Zero_Offset = (int) buf[139];                                          // Shift offset when stopped

//        Channel_Math_Active = (char) buf[140];                                      // Math channel off
//        MenuStatus[26][1] = (short) buf[141];                                        // standart math fft deactive
//        MenuStatus[26][2] = (short) buf[142];                                        // standart math 1*2 deactive
//        MenuStatus[26][3] = (short) buf[143];                                        // standart math 1-2 off
//        MenuStatus[26][4] = (short) buf[144];                                        // standart math 1+2 off

    /* Buffer fr Math Settings
        buf[145] = (unsigned long) fft source
        buf[146] = (unsigned long) fft Span
        buf[147] = (unsigned long) fft Center
        buf[148] = (unsigned long) fft Preset
        buf[149] = (unsigned long) fft more Scale

        buf[150] = (unsigned long) fft more Offset
        buf[151] = (unsigned long) fft more Window
        buf[152] = (unsigned long) * - + Scale
        buf[153] = (unsigned long) * - + Offset  */

        // Cursors    	
        MenuStatus[16][0] = (short) buf[154];                                        // Cursor soruce
        Cursor_Enabled = (char) buf[155];

        if (Cursor_Enabled) Cursor_Data_First_Draw = 1;

        Cursor_Both_Selected = (char) buf[156];
        SelectedCursor = (char) buf[157];
        Cursor_Horizontal_Active = (char) buf[158];
        Cursor_Horizontal_Position_Real1 = (long) buf[159];

        Cursor_Horizontal_Position_Real2 = (long) buf[160];
        Cursor_Vertical_Active = (char) buf[161];
        Cursor_Vertical_Position_Real1 = (long) buf[162];
        Cursor_Vertical_Position_Real2 = (long) buf[163];

        // Quick Measure
        //QM_Enabled = (char) buf[164];

        if (QM_Enabled) Quick_Measure_First_Draw = 1;

        QM_Type[0] = (char) buf[165];
        QM_Type[1] = (char) buf[166];
        QM_Type[2] = (char) buf[167];
        QM_Channel[0] = (char) buf[168];
        QM_Channel[1] = (char) buf[169];

        QM_Channel[2] = (char) buf[170];
        QM_Horizontal_Active = (char) buf[171];
        QM_Vertical_Active = (char) buf[172];
        Quick_Measure_Threshold_btn_select = (char) buf[173];

        // Display
        GridColorArrayPos = (unsigned char) buf[174];
        GridColor_Val = (unsigned char) buf[175];
        GridColorArrayPos_Delayed = (unsigned char) buf[176];
        GridColor_Val_Delayed = (unsigned char) buf[177];
        MenuStatus[5][0] = (short) buf[178];                                         // Display - Persist
        MenuStatus[5][3] = (short) buf[179];                                         // Display - Verctors

//        MenuStatus[0][0] = (short) buf[180];                                         // Aquire - Normal
//        MenuStatus[0][1] = (short) buf[181];                                         // Aquire - Averaging
        MenuStatus[0][2] = (short) buf[183];                                         // Aquire - Avgs

        MenuStatus[5][4] = (short) buf[184];                                         // Display - Browse

        MenuStatus[23][1] = (short) buf[185];                                        // Autoscale - Slow TB
//        MenuStatus[17][1] = (short) buf[186];                                        //

        Debug_Mode = (unsigned char) buf[187];
        ADC_Debug_Mode = (unsigned char) buf[188];

        // vergessene
        MenuPopupStatus[8][0] = (short) (buf[189] & 0x0000FFFF);                    // popup for externeal trigger
        MenuPopupStatus[8][1] = (short) ((buf[189] & 0xFFFF0000) >> 16);
        MenuPopupStatus[8][2] = (short) buf[190];

        //MenuStatus[14][3] = (short) buf[190];                                        // Triggering - no tv triggering
        OneShotRestart = (unsigned char) buf[191];
        // 192 s.o. ledval
        Channel_1_Active = (char) buf[193];
        Channel_2_Active = (char) buf[194];
        Channel_3_Active = (char) buf[195];
        Channel_4_Active = (char) buf[196];
        dmode_SIGNAL_OFFSET = (volatile short) buf[197];
        SIGNAL_OFFSET = (volatile short) buf[198];

        HoldOff_Value = (int) buf[199];
        HoldOff_Expo = (int) buf[200];
        HoldOff_Steps = (int) buf[201];

        Pulse11_Value = (int) buf[202];
        Pulse11_Expo = (int) buf[203];
        Pulse11_Steps = (int) buf[204];

        Pulse12_Value = (int) buf[205];
        Pulse12_Expo = (int) buf[206];
        Pulse12_Steps = (int) buf[207];

        Pulse21_Value = (int) buf[208];
        Pulse21_Expo = (int) buf[209];
        Pulse21_Steps = (int) buf[210];

        Pulse22_Value = (int) buf[211];
        Pulse22_Expo = (int) buf[212];
        Pulse22_Steps = (int) buf[213];

        //Math_Off_Mul_Value = (int) buf[214];
        Math_Off_Mul_Value_int = (int) buf[214];
        Math_Off_Mul_Expo = (int) buf[215];
        Math_Off_Mul_Steps = (int) buf[216];

        //Math_Off_Sub_Value = (int) buf[217];
        Math_Off_Sub_Value_int = (int) buf[217];
        Math_Off_Sub_Expo = (int) buf[218];
        Math_Off_Sub_Steps = (int) buf[219];

        //Math_Off_Add_Value = (int) buf[220];
        Math_Off_Add_Value_int = (int) buf[220];
        Math_Off_Add_Expo = (int) buf[221];
        Math_Off_Add_Steps = (int) buf[222];

        math_mul_scale = (int) buf[223];
        math_sub_scale = (int) buf[224];
        math_add_scale = (int) buf[225];

      //  Math_Off_Mul_Value = (float) buf[226];
      //  Math_Off_Sub_Value = (float) buf[227];
      //  Math_Off_Add_Value = (float) buf[228];

        Math_Off_Mul_Value = (float) Math_Off_Mul_Value_int;
        Math_Off_Sub_Value = (float) Math_Off_Sub_Value_int;
        Math_Off_Add_Value = (float) Math_Off_Add_Value_int;
        
        Trig_Pos_Mem = (int) buf[229];
        Trig_Pos_Display = (int) buf[230];
        Trig_Pos_Zoom = (float) buf[231];
        Trig_Mem_Pos = (int) buf[232];

        Trig_Pos_Mem_old = (int) buf[233];
        Trig_Pos_Display_old = (int) buf[234];
        Trig_Pos_Zoom_old = (float) buf[235];
        Trig_Mem_Pos_old = (int) buf[236];

        ZFT_float = (float) buf[237];
        ZFT_float_old = (float) buf[238];
        ZFT_float_dmode = (float) buf[239];
        ZFT_float_dmode_old = (float) buf[240];

        OFT_float = (float) buf[241];
        OFT_float_old = (float) buf[242];
        
        ZIT_short = (short) buf[243];
        ZIT_short_old = (short) buf[244];
        ZIT_short_dmode = (short) buf[245];
        ZIT_short_dmode_old = (short) buf[246];
        
        test_port_reg = (unsigned int) buf[247];

		timebase_reg = tb_value[Selected_Timebase];
		Display_Timebase = Selected_Timebase + SIGNALFaktor_idx;

        LED_ON[0] = 0;
        LED_ON[1] = 0;
        LED_ON[2] = 0;
        LED_ON[3] = 0;
        LED_ON[4] = 0;
        //LED_ON[5] = 0;
        LED_ON[6] = 0;
        LED_ON[7] = 0;
        LED_ON[8] = 0;
        LED_ON[9] = 0;
        LED_ON[10] = 0;
        LED_ON[11] = 0;
        //LED_ON[12] = 0;
        //LED_ON[13] = 0;
        LED_ON[14] = 0;
        LED_ON[15] = 0;

        if (((int) buf[192] & 0x0001) == 0x0001) LED_ON[0] = 1;
        if (((int) buf[192] & 0x0002) == 0x0002) LED_ON[1] = 1;
        if (((int) buf[192] & 0x0004) == 0x0004) LED_ON[2] = 1;
        if (((int) buf[192] & 0x0008) == 0x0008) LED_ON[3] = 1;
        //if (((int) buf[192] & 0x0010) == 0x0010) LED_ON[4] = 1;  // Math
        //if (((int) buf[192] & 0x0020) == 0x0020) LED_ON[5] = 1; // Generall
        if (((int) buf[192] & 0x0040) == 0x0040) LED_ON[6] = 1;
        //if (((int) buf[192] & 0x0080) == 0x0080) LED_ON[7] = 1; // Quick Measure
        if (((int) buf[192] & 0x0100) == 0x0100) LED_ON[8] = 1;
        if (((int) buf[192] & 0x0200) == 0x0200) LED_ON[9] = 1;
        if (((int) buf[192] & 0x0400) == 0x0400) LED_ON[10] = 1;
        if (((int) buf[192] & 0x0800) == 0x0800) LED_ON[11] = 1;
        //if (((int) buf[192] & 0x1000) == 0x1000) LED_ON[12] = 1; // Run/Stop Green
        //if (((int) buf[192] & 0x2000) == 0x2000) LED_ON[13] = 1; // Run/Stop Red
//        if (((int) buf[192] & 0x4000) == 0x4000) LED_ON[14] = 1;
//        if (((int) buf[192] & 0x8000) == 0x8000) LED_ON[15] = 1;

        switch(Math_Off_Mul_Expo)
        {
            case -2:
            {
                Math_Offset_mul.Write_StepSize(1);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1);
                break;
            }
            case -1:
            {
                Math_Offset_mul.Write_StepSize(0.001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                break;
            }
            case 0:
            {
                Math_Offset_mul.Write_StepSize(0.000001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000000);
                break;
            }
            case 1:
            {
                Math_Offset_mul.Write_StepSize(0.001);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value / (float) 1000);
                break;
            }
            case 2:
            {
                Math_Offset_mul.Write_StepSize(1);
                Math_Offset_mul.Write_Value((float) Math_Off_Mul_Value);
                break;
            }
        }

        Math_Offset_mul.RenderText();

        switch(Math_Off_Sub_Expo)
        {
            case -1:
            {
                Math_Offset_sub.Write_StepSize(1);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                break;
            }
            case 0:
            {
                Math_Offset_sub.Write_StepSize(0.001);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value / (float) 1000);
                break;
            }
            case 1:
            {
                Math_Offset_sub.Write_StepSize(1);
                Math_Offset_sub.Write_Value((float) Math_Off_Sub_Value);
                break;
            }
        }

        Math_Offset_sub.RenderText();

        switch(Math_Off_Add_Expo)
        {
            case -1:
            {
                Math_Offset_add.Write_StepSize(1);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                break;
            }
            case 0:
            {
                Math_Offset_add.Write_StepSize(0.001);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value / (float) 1000);
                break;
            }
            case 1:
            {
                Math_Offset_add.Write_StepSize(1);
                Math_Offset_add.Write_Value((float) Math_Off_Add_Value);
                break;
            }
        }

        Math_Offset_add.RenderText();
        
        Hardware::Recalc_Vars();

		config_loaded = true;
#ifdef _Debug_		
		if (Debug_Mode) printf("Flash loaded \n");
#endif		
	}
	else
	{
		config_loaded = false;
#ifdef _Debug_		
		if (Debug_Mode) printf("Flash not loaded - setting standards \n");
#endif		
	}
#ifdef _Debug_	
    printf("RF : df : %f c1 : %d c2 : %d cs %d st %d sfi %d dst %d dsfi %d dwop %d\n", dmode_factor, Cursor_Delayed_1, Cursor_Delayed_2, Cursor_Delayed_Size, Selected_Timebase, SIGNALFaktor_idx, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dmode_Window_Offset_Pos);
#endif
}

void AMDFlash::Read_TestData_Flash(void)
{
	int x, cnt;
//printf("AMDFlash::Read_TestData_Flash\n");	
	unsigned long *flash_address;
	unsigned long buf[256];
	unsigned char buf2[1024];
    	
	flash_address = (unsigned long) nasys_main_flash + TestData_Flash;
	
	for (x = 0; x < 256; x++) buf[x] = flash_address[x];
	
	for (x = 0; x < 256; x++)
    {
        buf2[(x * 4) + 0] = (unsigned char) buf[x] & 0x000000FF;
        buf2[(x * 4) + 1] = (unsigned char) ((buf[x] & 0x0000FF00) >> 8);
        buf2[(x * 4) + 2] = (unsigned char) ((buf[x] & 0x00FF0000) >> 16);
        buf2[(x * 4) + 3] = (unsigned char) ((buf[x] & 0xFF000000) >> 24);
    }                                                       	
	
#ifdef _Debug_
    cnt = 0;
    for (x = 0; x < 48; x++)
    {
        printf("%3d %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x \n", cnt, buf2[(cnt * 21) + 0], buf2[(cnt * 21) + 1], buf2[(cnt * 21) + 2], buf2[(cnt * 21) + 3], buf2[(cnt * 21) + 4], buf2[(cnt * 21) + 5], buf2[(cnt * 21) + 6], buf2[(cnt * 21) + 7], buf2[(cnt * 21) + 8], buf2[(cnt * 21) + 9], buf2[(cnt * 21) + 10], buf2[(cnt * 21) + 11], buf2[(cnt * 21) + 12], buf2[(cnt * 21) + 13], buf2[(cnt * 21) + 14], buf2[(cnt * 21) + 15], buf2[(cnt * 21) + 16], buf2[(cnt * 21) + 17], buf2[(cnt * 21) + 18], buf2[(cnt * 21) + 19], buf2[(cnt * 21) + 20]);

        cnt++;
        nr_delay(10);
    }      	
#endif
}

void AMDFlash::Write_TestData_Flash(void)
{
    int x, cnt;
	unsigned long *flash_address;
	unsigned long buf[300];
//printf("AMDFlash::Write_TestData_Flash\n");	
	flash_address = (unsigned long) nasys_main_flash + TestData_Flash;
#ifdef _Debug_	
	printf("Flashadr : %x = %x\n", flash_address, flash_address[0]);
#endif	
	for (x = 0; x < 300; x++) buf[x] = flash_address[x];
	
	nr_flash_erase_sector((unsigned long *) nasys_main_flash, flash_address);

	buf[32] = 0x12345678;
	
	nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address, buf, 34);
#ifdef _Debug_	
	if (Debug_Mode) printf("Flash TestData written\n");
#endif	
}

int AMDFlash::EraseSector_Flash(unsigned long *flash_address)
{
    int result;
//printf("AMDFlash::EraseSector_Flash\n");
    result = nr_flash_erase_sector((unsigned long *) nasys_main_flash, flash_address);
    return result;
}

int AMDFlash::WriteData_Byte_Flash(unsigned long *flash_address, unsigned char add, unsigned char data)
{
    int result = 0;
    int errors = 100;
    unsigned char* fb       = (unsigned char *) nasys_main_flash;
    unsigned char* a        = (unsigned char *) flash_address;
//printf("AMDFlash::WriteData_Byte_Flash\n");

//    result = amd29lv065d_flash_write_byte(fb, a + add, data);

    while (errors)
    {
	   unlock_bypass_mode(fb);
	   result = nr_flash_write_bypass(fb, a + add, data);
	   reset_bypass_mode(fb);
	
	   if (result != -1) errors = 0;
    }
	
    return result;	
}

void AMDFlash::ReadData_Prepare_Flash(unsigned long *flash_address)
{
	int x, cnt;
	
	unsigned long *flash_adr;
	unsigned char result = 0;
//printf("AMDFlash::ReadData_Prepare_Flash\n");    	
	flash_adr = (unsigned long) nasys_main_flash + flash_address;
	
	for (x = 0; x < 256; x++)
    {
        Flash_Read_Buffer[(x * 4) + 0] = (unsigned char) flash_adr[x] & 0x000000FF;
        Flash_Read_Buffer[(x * 4) + 1] = (unsigned char) ((flash_adr[x] & 0x0000FF00) >> 8);
        Flash_Read_Buffer[(x * 4) + 2] = (unsigned char) ((flash_adr[x] & 0x00FF0000) >> 16);
        Flash_Read_Buffer[(x * 4) + 3] = (unsigned char) ((flash_adr[x] & 0xFF000000) >> 24);
//        nr_delay(5);
    }
}


unsigned char AMDFlash::ReadData_Byte_Flash(unsigned int add)
{
	unsigned char result = 0;
//printf("AMDFlash::ReadData_Byte_Flash\n");
    result = Flash_Read_Buffer[add];

    return result;
}

void AMDFlash::Read_Protected_Flash(void)
{
	int x;
	
	unsigned long *flash_address;
 //printf("AMDFlash::Read_Protected_Flash\n");   	
	flash_address = (unsigned long) nasys_main_flash + protected_Config_Flash;
	
	for (x = 0; x < 256; x++)
    {
        Flash_Protect_Buffer[x] = flash_address[x];
    }
	
	if (Flash_Protect_Buffer[0] == 0xFF2332FF)
	{
        tc_model = Flash_Protect_Buffer[1];
        tc_serial = Flash_Protect_Buffer[2];
        tc_production_lot1 = Flash_Protect_Buffer[3];
        tc_production_lot2 = Flash_Protect_Buffer[4];
        tc_shipment_date = Flash_Protect_Buffer[5];

        kill_adc = (unsigned int) Flash_Protect_Buffer[11];
	    m2k_filter_Mode = (unsigned char) Flash_Protect_Buffer[12];
	
	    Voltage_Correction[0][0] = (int) Flash_Protect_Buffer[13];
	    Voltage_Correction[0][1] = (int) Flash_Protect_Buffer[14];
	    Voltage_Correction[0][2] = (int) Flash_Protect_Buffer[15];
	    Voltage_Correction[0][3] = (int) Flash_Protect_Buffer[16];
	    Voltage_Correction[0][4] = (int) Flash_Protect_Buffer[17];
	    Voltage_Correction[0][5] = (int) Flash_Protect_Buffer[18];
	    Voltage_Correction[0][6] = (int) Flash_Protect_Buffer[19];
	    Voltage_Correction[0][7] = (int) Flash_Protect_Buffer[20];
	    Voltage_Correction[0][8] = (int) Flash_Protect_Buffer[21];
	    Voltage_Correction[0][9] = (int) Flash_Protect_Buffer[22];
	    Voltage_Correction[0][10] = (int) Flash_Protect_Buffer[23];
	
	    Voltage_Correction[1][0] = (int) Flash_Protect_Buffer[24];
	    Voltage_Correction[1][1] = (int) Flash_Protect_Buffer[25];
	    Voltage_Correction[1][2] = (int) Flash_Protect_Buffer[26];
	    Voltage_Correction[1][3] = (int) Flash_Protect_Buffer[27];
	    Voltage_Correction[1][4] = (int) Flash_Protect_Buffer[28];
	    Voltage_Correction[1][5] = (int) Flash_Protect_Buffer[29];
	    Voltage_Correction[1][6] = (int) Flash_Protect_Buffer[30];
	    Voltage_Correction[1][7] = (int) Flash_Protect_Buffer[31];
	    Voltage_Correction[1][8] = (int) Flash_Protect_Buffer[32];
	    Voltage_Correction[1][9] = (int) Flash_Protect_Buffer[33];
	    Voltage_Correction[1][10] = (int) Flash_Protect_Buffer[34];

	    Voltage_Correction[2][0] = (int) Flash_Protect_Buffer[35];
	    Voltage_Correction[2][1] = (int) Flash_Protect_Buffer[36];
	    Voltage_Correction[2][2] = (int) Flash_Protect_Buffer[37];
	    Voltage_Correction[2][3] = (int) Flash_Protect_Buffer[38];
	    Voltage_Correction[2][4] = (int) Flash_Protect_Buffer[39];
	    Voltage_Correction[2][5] = (int) Flash_Protect_Buffer[40];
	    Voltage_Correction[2][6] = (int) Flash_Protect_Buffer[41];
	    Voltage_Correction[2][7] = (int) Flash_Protect_Buffer[42];
	    Voltage_Correction[2][8] = (int) Flash_Protect_Buffer[43];
	    Voltage_Correction[2][9] = (int) Flash_Protect_Buffer[44];
	    Voltage_Correction[2][10] = (int) Flash_Protect_Buffer[45];

	    Voltage_Correction[3][0] = (int) Flash_Protect_Buffer[46];
	    Voltage_Correction[3][1] = (int) Flash_Protect_Buffer[47];
	    Voltage_Correction[3][2] = (int) Flash_Protect_Buffer[48];
	    Voltage_Correction[3][3] = (int) Flash_Protect_Buffer[49];
	    Voltage_Correction[3][4] = (int) Flash_Protect_Buffer[50];
	    Voltage_Correction[3][5] = (int) Flash_Protect_Buffer[51];
	    Voltage_Correction[3][6] = (int) Flash_Protect_Buffer[52];
	    Voltage_Correction[3][7] = (int) Flash_Protect_Buffer[53];
	    Voltage_Correction[3][8] = (int) Flash_Protect_Buffer[54];
	    Voltage_Correction[3][9] = (int) Flash_Protect_Buffer[55];
	    Voltage_Correction[3][10] = (int) Flash_Protect_Buffer[56];
	
	    Voltage_Offset[0][0] = (int) Flash_Protect_Buffer[57];
	    Voltage_Offset[0][1] = (int) Flash_Protect_Buffer[58];
	    Voltage_Offset[0][2] = (int) Flash_Protect_Buffer[59];
	    Voltage_Offset[0][3] = (int) Flash_Protect_Buffer[60];	
	
	    Voltage_Offset[1][0] = (int) Flash_Protect_Buffer[61];
	    Voltage_Offset[1][1] = (int) Flash_Protect_Buffer[62];
	    Voltage_Offset[1][2] = (int) Flash_Protect_Buffer[63];
	    Voltage_Offset[1][3] = (int) Flash_Protect_Buffer[64];

	    Voltage_Offset[2][0] = (int) Flash_Protect_Buffer[65];
	    Voltage_Offset[2][1] = (int) Flash_Protect_Buffer[66];
	    Voltage_Offset[2][2] = (int) Flash_Protect_Buffer[67];
	    Voltage_Offset[2][3] = (int) Flash_Protect_Buffer[68];

	    Voltage_Offset[3][0] = (int) Flash_Protect_Buffer[69];
	    Voltage_Offset[3][1] = (int) Flash_Protect_Buffer[70];
	    Voltage_Offset[3][2] = (int) Flash_Protect_Buffer[71];
	    Voltage_Offset[3][3] = (int) Flash_Protect_Buffer[72];
	
	    adc_change12_reg = Flash_Protect_Buffer[73];	
	    adc_ctr12_reg = Flash_Protect_Buffer[74];	
	    adc_change34_reg = Flash_Protect_Buffer[75];		
	    channel_Adr_add = Flash_Protect_Buffer[76];	
		channel_Adr_add2 = Flash_Protect_Buffer[77];	

        Volt_Correct_float[0][0] = (float) ((float) (Voltage_Correction[0][0] + 100) / 100);
        Volt_Correct_float[0][1] = (float) ((float) (Voltage_Correction[0][1] + 100) / 100);
        Volt_Correct_float[0][2] = (float) ((float) (Voltage_Correction[0][2] + 100) / 100);
        Volt_Correct_float[0][3] = (float) ((float) (Voltage_Correction[0][3] + 100) / 100);
        Volt_Correct_float[0][4] = (float) ((float) (Voltage_Correction[0][4] + 100) / 100);
        Volt_Correct_float[0][5] = (float) ((float) (Voltage_Correction[0][5] + 100) / 100);
        Volt_Correct_float[0][6] = (float) ((float) (Voltage_Correction[0][6] + 100) / 100);
        Volt_Correct_float[0][7] = (float) ((float) (Voltage_Correction[0][7] + 100) / 100);
        Volt_Correct_float[0][8] = (float) ((float) (Voltage_Correction[0][8] + 100) / 100);
        Volt_Correct_float[0][9] = (float) ((float) (Voltage_Correction[0][9] + 100) / 100);
        Volt_Correct_float[0][10] = (float) ((float) (Voltage_Correction[0][10] + 100) / 100);
        Volt_Correct_float[0][11] = (float) ((float) (Voltage_Correction[0][11] + 100) / 100);

        Volt_Correct_float[1][0] = (float) ((float) (Voltage_Correction[1][0] + 100) / 100);
        Volt_Correct_float[1][1] = (float) ((float) (Voltage_Correction[1][1] + 100) / 100);
        Volt_Correct_float[1][2] = (float) ((float) (Voltage_Correction[1][2] + 100) / 100);
        Volt_Correct_float[1][3] = (float) ((float) (Voltage_Correction[1][3] + 100) / 100);
        Volt_Correct_float[1][4] = (float) ((float) (Voltage_Correction[1][4] + 100) / 100);
        Volt_Correct_float[1][5] = (float) ((float) (Voltage_Correction[1][5] + 100) / 100);
        Volt_Correct_float[1][6] = (float) ((float) (Voltage_Correction[1][6] + 100) / 100);
        Volt_Correct_float[1][7] = (float) ((float) (Voltage_Correction[1][7] + 100) / 100);
        Volt_Correct_float[1][8] = (float) ((float) (Voltage_Correction[1][8] + 100) / 100);
        Volt_Correct_float[1][9] = (float) ((float) (Voltage_Correction[1][9] + 100) / 100);
        Volt_Correct_float[1][10] = (float) ((float) (Voltage_Correction[1][10] + 100) / 100);
        Volt_Correct_float[1][11] = (float) ((float) (Voltage_Correction[1][11] + 100) / 100);

        Volt_Correct_float[2][0] = (float) ((float) (Voltage_Correction[2][0] + 100) / 100);
        Volt_Correct_float[2][1] = (float) ((float) (Voltage_Correction[2][1] + 100) / 100);
        Volt_Correct_float[2][2] = (float) ((float) (Voltage_Correction[2][2] + 100) / 100);
        Volt_Correct_float[2][3] = (float) ((float) (Voltage_Correction[2][3] + 100) / 100);
        Volt_Correct_float[2][4] = (float) ((float) (Voltage_Correction[2][4] + 100) / 100);
        Volt_Correct_float[2][5] = (float) ((float) (Voltage_Correction[2][5] + 100) / 100);
        Volt_Correct_float[2][6] = (float) ((float) (Voltage_Correction[2][6] + 100) / 100);
        Volt_Correct_float[2][7] = (float) ((float) (Voltage_Correction[2][7] + 100) / 100);
        Volt_Correct_float[2][8] = (float) ((float) (Voltage_Correction[2][8] + 100) / 100);
        Volt_Correct_float[2][9] = (float) ((float) (Voltage_Correction[2][9] + 100) / 100);
        Volt_Correct_float[2][10] = (float) ((float) (Voltage_Correction[2][10] + 100) / 100);
        Volt_Correct_float[2][11] = (float) ((float) (Voltage_Correction[2][11] + 100) / 100);

        Volt_Correct_float[3][0] = (float) ((float) (Voltage_Correction[3][0] + 100) / 100);
        Volt_Correct_float[3][1] = (float) ((float) (Voltage_Correction[3][1] + 100) / 100);
        Volt_Correct_float[3][2] = (float) ((float) (Voltage_Correction[3][2] + 100) / 100);
        Volt_Correct_float[3][3] = (float) ((float) (Voltage_Correction[3][3] + 100) / 100);
        Volt_Correct_float[3][4] = (float) ((float) (Voltage_Correction[3][4] + 100) / 100);
        Volt_Correct_float[3][5] = (float) ((float) (Voltage_Correction[3][5] + 100) / 100);
        Volt_Correct_float[3][6] = (float) ((float) (Voltage_Correction[3][6] + 100) / 100);
        Volt_Correct_float[3][7] = (float) ((float) (Voltage_Correction[3][7] + 100) / 100);
        Volt_Correct_float[3][8] = (float) ((float) (Voltage_Correction[3][8] + 100) / 100);
        Volt_Correct_float[3][9] = (float) ((float) (Voltage_Correction[3][9] + 100) / 100);
        Volt_Correct_float[3][10] = (float) ((float) (Voltage_Correction[3][10] + 100) / 100);
        Volt_Correct_float[3][11] = (float) ((float) (Voltage_Correction[3][11] + 100) / 100);	

        ZeroLevelCH1_cor_offset = 0;
        ZeroLevelCH2_cor_offset = 0;
        ZeroLevelCH3_cor_offset = 0;
        ZeroLevelCH4_cor_offset = 0;

        for (x = 0; x < 4; x++)
        {
            if (Voltage_Offset[0][x] > ZeroLevelCH1_cor_offset) ZeroLevelCH1_cor_offset = Voltage_Offset[0][x];
            if (Voltage_Offset[1][x] > ZeroLevelCH2_cor_offset) ZeroLevelCH2_cor_offset = Voltage_Offset[1][x];
            if (Voltage_Offset[2][x] > ZeroLevelCH3_cor_offset) ZeroLevelCH3_cor_offset = Voltage_Offset[2][x];
            if (Voltage_Offset[3][x] > ZeroLevelCH4_cor_offset) ZeroLevelCH4_cor_offset = Voltage_Offset[3][x];
        }
	}     	
}

void AMDFlash::Write_Protected_Flash(void)
{
    int x, cnt;
	unsigned long *flash_address;
//printf("AMDFlash::Write_Protected_Flash\n");	
	flash_address = (unsigned long) nasys_main_flash + protected_Config_Flash;
#ifdef _Debug_	
	printf("Flashadr : %x = %x\n", flash_address, flash_address[0]);
#endif	
	
	nr_flash_erase_sector((unsigned long *) nasys_main_flash, flash_address);

	Flash_Protect_Buffer[0] = 0xFF2332FF;              // Kennung
	Flash_Protect_Buffer[1] = tc_model;                // model
	Flash_Protect_Buffer[2] = tc_serial;               // serial nr
	Flash_Protect_Buffer[3] = tc_production_lot1;      // production lot	
	Flash_Protect_Buffer[4] = tc_production_lot2;      // production lot	
	Flash_Protect_Buffer[5] = tc_shipment_date;        // shipment date
	Flash_Protect_Buffer[6] = 0x00000000;
	Flash_Protect_Buffer[7] = 0x00000000;
	Flash_Protect_Buffer[8] = 0x00000000;
	Flash_Protect_Buffer[9] = 0x00000000;
	Flash_Protect_Buffer[10] = 0x00000000;
	// spezial config data
	Flash_Protect_Buffer[11] = (unsigned long) kill_adc;	           // kill adc settings for all channels
	Flash_Protect_Buffer[12] = (unsigned long) m2k_filter_Mode;	    // slow tb 2k spike filter settings for all channels	
	
	
	Flash_Protect_Buffer[13] = (unsigned long) Voltage_Correction[0][0];
	Flash_Protect_Buffer[14] = (unsigned long) Voltage_Correction[0][1];
	Flash_Protect_Buffer[15] = (unsigned long) Voltage_Correction[0][2];
	Flash_Protect_Buffer[16] = (unsigned long) Voltage_Correction[0][3];
	Flash_Protect_Buffer[17] = (unsigned long) Voltage_Correction[0][4];
	Flash_Protect_Buffer[18] = (unsigned long) Voltage_Correction[0][5];
	Flash_Protect_Buffer[19] = (unsigned long) Voltage_Correction[0][6];
	Flash_Protect_Buffer[20] = (unsigned long) Voltage_Correction[0][7];
	Flash_Protect_Buffer[21] = (unsigned long) Voltage_Correction[0][8];
	Flash_Protect_Buffer[22] = (unsigned long) Voltage_Correction[0][9];
	Flash_Protect_Buffer[23] = (unsigned long) Voltage_Correction[0][10];

	Flash_Protect_Buffer[24] = (unsigned long) Voltage_Correction[1][0];
	Flash_Protect_Buffer[25] = (unsigned long) Voltage_Correction[1][1];
	Flash_Protect_Buffer[26] = (unsigned long) Voltage_Correction[1][2];
	Flash_Protect_Buffer[27] = (unsigned long) Voltage_Correction[1][3];
	Flash_Protect_Buffer[28] = (unsigned long) Voltage_Correction[1][4];
	Flash_Protect_Buffer[29] = (unsigned long) Voltage_Correction[1][5];
	Flash_Protect_Buffer[30] = (unsigned long) Voltage_Correction[1][6];
	Flash_Protect_Buffer[31] = (unsigned long) Voltage_Correction[1][7];
	Flash_Protect_Buffer[32] = (unsigned long) Voltage_Correction[1][8];
	Flash_Protect_Buffer[33] = (unsigned long) Voltage_Correction[1][9];
	Flash_Protect_Buffer[34] = (unsigned long) Voltage_Correction[1][10];

	Flash_Protect_Buffer[35] = (unsigned long) Voltage_Correction[2][0];
	Flash_Protect_Buffer[36] = (unsigned long) Voltage_Correction[2][1];
	Flash_Protect_Buffer[37] = (unsigned long) Voltage_Correction[2][2];
	Flash_Protect_Buffer[38] = (unsigned long) Voltage_Correction[2][3];
	Flash_Protect_Buffer[39] = (unsigned long) Voltage_Correction[2][4];
	Flash_Protect_Buffer[40] = (unsigned long) Voltage_Correction[2][5];
	Flash_Protect_Buffer[41] = (unsigned long) Voltage_Correction[2][6];
	Flash_Protect_Buffer[42] = (unsigned long) Voltage_Correction[2][7];
	Flash_Protect_Buffer[43] = (unsigned long) Voltage_Correction[2][8];
	Flash_Protect_Buffer[44] = (unsigned long) Voltage_Correction[2][9];
	Flash_Protect_Buffer[45] = (unsigned long) Voltage_Correction[2][10];

	Flash_Protect_Buffer[46] = (unsigned long) Voltage_Correction[3][0];
	Flash_Protect_Buffer[47] = (unsigned long) Voltage_Correction[3][1];
	Flash_Protect_Buffer[48] = (unsigned long) Voltage_Correction[3][2];
	Flash_Protect_Buffer[49] = (unsigned long) Voltage_Correction[3][3];
	Flash_Protect_Buffer[50] = (unsigned long) Voltage_Correction[3][4];
	Flash_Protect_Buffer[51] = (unsigned long) Voltage_Correction[3][5];
	Flash_Protect_Buffer[52] = (unsigned long) Voltage_Correction[3][6];
	Flash_Protect_Buffer[53] = (unsigned long) Voltage_Correction[3][7];
	Flash_Protect_Buffer[54] = (unsigned long) Voltage_Correction[3][8];
	Flash_Protect_Buffer[55] = (unsigned long) Voltage_Correction[3][9];
	Flash_Protect_Buffer[56] = (unsigned long) Voltage_Correction[3][10]; 	
	
	Flash_Protect_Buffer[57] = (unsigned long) Voltage_Offset[0][0];
	Flash_Protect_Buffer[58] = (unsigned long) Voltage_Offset[0][1];
	Flash_Protect_Buffer[59] = (unsigned long) Voltage_Offset[0][2];
	Flash_Protect_Buffer[60] = (unsigned long) Voltage_Offset[0][3];	
	
	Flash_Protect_Buffer[61] = (unsigned long) Voltage_Offset[1][0];
	Flash_Protect_Buffer[62] = (unsigned long) Voltage_Offset[1][1];
	Flash_Protect_Buffer[63] = (unsigned long) Voltage_Offset[1][2];
	Flash_Protect_Buffer[64] = (unsigned long) Voltage_Offset[1][3];	

	Flash_Protect_Buffer[65] = (unsigned long) Voltage_Offset[2][0];
	Flash_Protect_Buffer[66] = (unsigned long) Voltage_Offset[2][1];
	Flash_Protect_Buffer[67] = (unsigned long) Voltage_Offset[2][2];
	Flash_Protect_Buffer[68] = (unsigned long) Voltage_Offset[2][3];	

	Flash_Protect_Buffer[69] = (unsigned long) Voltage_Offset[3][0];
	Flash_Protect_Buffer[70] = (unsigned long) Voltage_Offset[3][1];
	Flash_Protect_Buffer[71] = (unsigned long) Voltage_Offset[3][2];
	Flash_Protect_Buffer[72] = (unsigned long) Voltage_Offset[3][3];	
	
	Flash_Protect_Buffer[73] = (unsigned long) adc_change12_reg;  	
	Flash_Protect_Buffer[74] = (unsigned long) adc_ctr12_reg;
	Flash_Protect_Buffer[75] = (unsigned long) adc_change34_reg;
	Flash_Protect_Buffer[76] = (unsigned long) channel_Adr_add;
	Flash_Protect_Buffer[77] = (unsigned long) channel_Adr_add2;
   	
	nr_flash_write_buffer((unsigned long *) nasys_main_flash, flash_address, Flash_Protect_Buffer, 80);
#ifdef _Debug_	
	if (Debug_Mode) printf("Flash TestData written\n");
#endif	
}










